CREATE DATABASE Item55Example;

USE Item55Example;

CREATE TABLE DimDate (
  DateKey int NOT NULL,
  DateValue date NOT NULL PRIMARY KEY,
  NextDayValue date NOT NULL,
  YearValue smallint NOT NULL,
  YearQuarter int NOT NULL,
  YearMonth int NOT NULL,
  YearDayOfYear int NOT NULL,
  QuarterValue tinyint NOT NULL,
  MonthValue tinyint NOT NULL,
  DayOfYear smallint NOT NULL,
  DayOfMonth smallint NOT NULL,
  DayOfWeek tinyint NOT NULL,
  YearName varchar(4) NOT NULL,
  YearQuarterName varchar(7) NOT NULL,
  QuarterName varchar(8) NOT NULL,
  MonthName varchar(3) NOT NULL,
  MonthNameLong varchar(9) NOT NULL,
  WeekdayName varchar(3) NOT NULL,
  WeekDayNameLong varchar(9) NOT NULL,
  StartOfYearDate date NOT NULL,
  EndOfYearDate date NOT NULL,
  StartOfQuarterDate date NOT NULL,
  EndOfQuarterDate date NOT NULL,
  StartOfMonthDate date NOT NULL,
  EndOfMonthDate date NOT NULL,
  StartOfWeekStartingSunDate date NOT NULL,
  EndOfWeekStartingSunDate date NOT NULL,
  StartOfWeekStartingMonDate date NOT NULL,
  EndOfWeekStartingMonDate date NOT NULL,
  StartOfWeekStartingTueDate date NOT NULL,
  EndOfWeekStartingTueDate date NOT NULL,
  StartOfWeekStartingWedDate date NOT NULL,
  EndOfWeekStartingWedDate date NOT NULL,
  StartOfWeekStartingThuDate date NOT NULL,
  EndOfWeekStartingThuDate date NOT NULL,
  StartOfWeekStartingFriDate date NOT NULL,
  EndOfWeekStartingFriDate date NOT NULL,
  StartOfWeekStartingSatDate date NOT NULL,
  EndOfWeekStartingSatDate date NOT NULL,
  QuarterSeqNo int NOT NULL,
  MonthSeqNo int NOT NULL,
  WeekStartingSunSeq int NOT NULL,
  WeekStartingMonSeq int NOT NULL,
  WeekStartingTueSeq int NOT NULL,
  WeekStartingWedSeq int NOT NULL,
  WeekStartingThuSeq int NOT NULL,
  WeekStartingFriSeq int NOT NULL,
  WeekStartingSatSeq int NOT NULL,
  JulianDate int NOT NULL,
  ModifiedJulianDate int NOT NULL,
  ISODate varchar(10) NOT NULL,
  ISOYearWeekNo int NOT NULL,
  ISOWeekNo smallint NOT NULL,
  ISODayOfWeek tinyint NOT NULL,
  ISOYearWeekName varchar(8) NOT NULL,
  ISOYearWeekDayOfWeekName varchar(10) NOT NULL
);

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93867, CAST(N'2010-01-01' AS date), CAST(N'2010-01-02' AS date), 2010, 20101, 201001, 2010001, 1, 1, 1, 1, 6, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2009-12-27' AS date), CAST(N'2010-01-02' AS date), CAST(N'2009-12-28' AS date), CAST(N'2010-01-03' AS date), CAST(N'2009-12-29' AS date), CAST(N'2010-01-04' AS date), CAST(N'2009-12-30' AS date), CAST(N'2010-01-05' AS date), CAST(N'2009-12-31' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-07' AS date), CAST(N'2009-12-26' AS date), CAST(N'2010-01-01' AS date), 1028, 3084, 13408, 13409, 13409, 13409, 13409, 13409, 13408, 2455198, 55197, N'2010-01-01', 200953, 53, 5, N'2009-W53', N'2009-W53-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93868, CAST(N'2010-01-02' AS date), CAST(N'2010-01-03' AS date), 2010, 20101, 201001, 2010002, 1, 1, 2, 2, 7, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2009-12-27' AS date), CAST(N'2010-01-02' AS date), CAST(N'2009-12-28' AS date), CAST(N'2010-01-03' AS date), CAST(N'2009-12-29' AS date), CAST(N'2010-01-04' AS date), CAST(N'2009-12-30' AS date), CAST(N'2010-01-05' AS date), CAST(N'2009-12-31' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-02' AS date), CAST(N'2010-01-08' AS date), 1028, 3084, 13408, 13409, 13409, 13409, 13409, 13409, 13409, 2455199, 55198, N'2010-01-02', 200953, 53, 6, N'2009-W53', N'2009-W53-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93869, CAST(N'2010-01-03' AS date), CAST(N'2010-01-04' AS date), 2010, 20101, 201001, 2010003, 1, 1, 3, 3, 1, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-03' AS date), CAST(N'2010-01-09' AS date), CAST(N'2009-12-28' AS date), CAST(N'2010-01-03' AS date), CAST(N'2009-12-29' AS date), CAST(N'2010-01-04' AS date), CAST(N'2009-12-30' AS date), CAST(N'2010-01-05' AS date), CAST(N'2009-12-31' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-02' AS date), CAST(N'2010-01-08' AS date), 1028, 3084, 13409, 13409, 13409, 13409, 13409, 13409, 13409, 2455200, 55199, N'2010-01-03', 200953, 53, 7, N'2009-W53', N'2009-W53-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93870, CAST(N'2010-01-04' AS date), CAST(N'2010-01-05' AS date), 2010, 20101, 201001, 2010004, 1, 1, 4, 4, 2, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-03' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-04' AS date), CAST(N'2010-01-10' AS date), CAST(N'2009-12-29' AS date), CAST(N'2010-01-04' AS date), CAST(N'2009-12-30' AS date), CAST(N'2010-01-05' AS date), CAST(N'2009-12-31' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-02' AS date), CAST(N'2010-01-08' AS date), 1028, 3084, 13409, 13410, 13409, 13409, 13409, 13409, 13409, 2455201, 55200, N'2010-01-04', 201001, 1, 1, N'2010-W01', N'2010-W01-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93871, CAST(N'2010-01-05' AS date), CAST(N'2010-01-06' AS date), 2010, 20101, 201001, 2010005, 1, 1, 5, 5, 3, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-03' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-04' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-05' AS date), CAST(N'2010-01-11' AS date), CAST(N'2009-12-30' AS date), CAST(N'2010-01-05' AS date), CAST(N'2009-12-31' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-02' AS date), CAST(N'2010-01-08' AS date), 1028, 3084, 13409, 13410, 13410, 13409, 13409, 13409, 13409, 2455202, 55201, N'2010-01-05', 201001, 1, 2, N'2010-W01', N'2010-W01-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93872, CAST(N'2010-01-06' AS date), CAST(N'2010-01-07' AS date), 2010, 20101, 201001, 2010006, 1, 1, 6, 6, 4, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-03' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-04' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-05' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-12' AS date), CAST(N'2009-12-31' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-02' AS date), CAST(N'2010-01-08' AS date), 1028, 3084, 13409, 13410, 13410, 13410, 13409, 13409, 13409, 2455203, 55202, N'2010-01-06', 201001, 1, 3, N'2010-W01', N'2010-W01-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93873, CAST(N'2010-01-07' AS date), CAST(N'2010-01-08' AS date), 2010, 20101, 201001, 2010007, 1, 1, 7, 7, 5, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-03' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-04' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-05' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-02' AS date), CAST(N'2010-01-08' AS date), 1028, 3084, 13409, 13410, 13410, 13410, 13410, 13409, 13409, 2455204, 55203, N'2010-01-07', 201001, 1, 4, N'2010-W01', N'2010-W01-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93874, CAST(N'2010-01-08' AS date), CAST(N'2010-01-09' AS date), 2010, 20101, 201001, 2010008, 1, 1, 8, 8, 6, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-03' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-04' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-05' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-08' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-02' AS date), CAST(N'2010-01-08' AS date), 1028, 3084, 13409, 13410, 13410, 13410, 13410, 13410, 13409, 2455205, 55204, N'2010-01-08', 201001, 1, 5, N'2010-W01', N'2010-W01-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93875, CAST(N'2010-01-09' AS date), CAST(N'2010-01-10' AS date), 2010, 20101, 201001, 2010009, 1, 1, 9, 9, 7, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-03' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-04' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-05' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-08' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-15' AS date), 1028, 3084, 13409, 13410, 13410, 13410, 13410, 13410, 13410, 2455206, 55205, N'2010-01-09', 201001, 1, 6, N'2010-W01', N'2010-W01-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93876, CAST(N'2010-01-10' AS date), CAST(N'2010-01-11' AS date), 2010, 20101, 201001, 2010010, 1, 1, 10, 10, 1, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-04' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-05' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-08' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-15' AS date), 1028, 3084, 13410, 13410, 13410, 13410, 13410, 13410, 13410, 2455207, 55206, N'2010-01-10', 201001, 1, 7, N'2010-W01', N'2010-W01-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93877, CAST(N'2010-01-11' AS date), CAST(N'2010-01-12' AS date), 2010, 20101, 201001, 2010011, 1, 1, 11, 11, 2, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-05' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-08' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-15' AS date), 1028, 3084, 13410, 13411, 13410, 13410, 13410, 13410, 13410, 2455208, 55207, N'2010-01-11', 201002, 2, 1, N'2010-W02', N'2010-W02-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93878, CAST(N'2010-01-12' AS date), CAST(N'2010-01-13' AS date), 2010, 20101, 201001, 2010012, 1, 1, 12, 12, 3, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-06' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-08' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-15' AS date), 1028, 3084, 13410, 13411, 13411, 13410, 13410, 13410, 13410, 2455209, 55208, N'2010-01-12', 201002, 2, 2, N'2010-W02', N'2010-W02-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93879, CAST(N'2010-01-13' AS date), CAST(N'2010-01-14' AS date), 2010, 20101, 201001, 2010013, 1, 1, 13, 13, 4, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-07' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-08' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-15' AS date), 1028, 3084, 13410, 13411, 13411, 13411, 13410, 13410, 13410, 2455210, 55209, N'2010-01-13', 201002, 2, 3, N'2010-W02', N'2010-W02-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93880, CAST(N'2010-01-14' AS date), CAST(N'2010-01-15' AS date), 2010, 20101, 201001, 2010014, 1, 1, 14, 14, 5, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-08' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-15' AS date), 1028, 3084, 13410, 13411, 13411, 13411, 13411, 13410, 13410, 2455211, 55210, N'2010-01-14', 201002, 2, 4, N'2010-W02', N'2010-W02-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93881, CAST(N'2010-01-15' AS date), CAST(N'2010-01-16' AS date), 2010, 20101, 201001, 2010015, 1, 1, 15, 15, 6, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-15' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-09' AS date), CAST(N'2010-01-15' AS date), 1028, 3084, 13410, 13411, 13411, 13411, 13411, 13411, 13410, 2455212, 55211, N'2010-01-15', 201002, 2, 5, N'2010-W02', N'2010-W02-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93882, CAST(N'2010-01-16' AS date), CAST(N'2010-01-17' AS date), 2010, 20101, 201001, 2010016, 1, 1, 16, 16, 7, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-10' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-15' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-22' AS date), 1028, 3084, 13410, 13411, 13411, 13411, 13411, 13411, 13411, 2455213, 55212, N'2010-01-16', 201002, 2, 6, N'2010-W02', N'2010-W02-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93883, CAST(N'2010-01-17' AS date), CAST(N'2010-01-18' AS date), 2010, 20101, 201001, 2010017, 1, 1, 17, 17, 1, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-11' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-15' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-22' AS date), 1028, 3084, 13411, 13411, 13411, 13411, 13411, 13411, 13411, 2455214, 55213, N'2010-01-17', 201002, 2, 7, N'2010-W02', N'2010-W02-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93884, CAST(N'2010-01-18' AS date), CAST(N'2010-01-19' AS date), 2010, 20101, 201001, 2010018, 1, 1, 18, 18, 2, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-12' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-15' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-22' AS date), 1028, 3084, 13411, 13412, 13411, 13411, 13411, 13411, 13411, 2455215, 55214, N'2010-01-18', 201003, 3, 1, N'2010-W03', N'2010-W03-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93885, CAST(N'2010-01-19' AS date), CAST(N'2010-01-20' AS date), 2010, 20101, 201001, 2010019, 1, 1, 19, 19, 3, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-13' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-15' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-22' AS date), 1028, 3084, 13411, 13412, 13412, 13411, 13411, 13411, 13411, 2455216, 55215, N'2010-01-19', 201003, 3, 2, N'2010-W03', N'2010-W03-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93886, CAST(N'2010-01-20' AS date), CAST(N'2010-01-21' AS date), 2010, 20101, 201001, 2010020, 1, 1, 20, 20, 4, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-01-14' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-15' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-22' AS date), 1028, 3084, 13411, 13412, 13412, 13412, 13411, 13411, 13411, 2455217, 55216, N'2010-01-20', 201003, 3, 3, N'2010-W03', N'2010-W03-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93887, CAST(N'2010-01-21' AS date), CAST(N'2010-01-22' AS date), 2010, 20101, 201001, 2010021, 1, 1, 21, 21, 5, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-01-15' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-22' AS date), 1028, 3084, 13411, 13412, 13412, 13412, 13412, 13411, 13411, 2455218, 55217, N'2010-01-21', 201003, 3, 4, N'2010-W03', N'2010-W03-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93888, CAST(N'2010-01-22' AS date), CAST(N'2010-01-23' AS date), 2010, 20101, 201001, 2010022, 1, 1, 22, 22, 6, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-01-22' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-01-16' AS date), CAST(N'2010-01-22' AS date), 1028, 3084, 13411, 13412, 13412, 13412, 13412, 13412, 13411, 2455219, 55218, N'2010-01-22', 201003, 3, 5, N'2010-W03', N'2010-W03-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93889, CAST(N'2010-01-23' AS date), CAST(N'2010-01-24' AS date), 2010, 20101, 201001, 2010023, 1, 1, 23, 23, 7, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-17' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-01-22' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-29' AS date), 1028, 3084, 13411, 13412, 13412, 13412, 13412, 13412, 13412, 2455220, 55219, N'2010-01-23', 201003, 3, 6, N'2010-W03', N'2010-W03-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93890, CAST(N'2010-01-24' AS date), CAST(N'2010-01-25' AS date), 2010, 20101, 201001, 2010024, 1, 1, 24, 24, 1, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-01-18' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-01-22' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-29' AS date), 1028, 3084, 13412, 13412, 13412, 13412, 13412, 13412, 13412, 2455221, 55220, N'2010-01-24', 201003, 3, 7, N'2010-W03', N'2010-W03-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93891, CAST(N'2010-01-25' AS date), CAST(N'2010-01-26' AS date), 2010, 20101, 201001, 2010025, 1, 1, 25, 25, 2, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-19' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-01-22' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-29' AS date), 1028, 3084, 13412, 13413, 13412, 13412, 13412, 13412, 13412, 2455222, 55221, N'2010-01-25', 201004, 4, 1, N'2010-W04', N'2010-W04-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93892, CAST(N'2010-01-26' AS date), CAST(N'2010-01-27' AS date), 2010, 20101, 201001, 2010026, 1, 1, 26, 26, 3, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-01-20' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-01-22' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-29' AS date), 1028, 3084, 13412, 13413, 13413, 13412, 13412, 13412, 13412, 2455223, 55222, N'2010-01-26', 201004, 4, 2, N'2010-W04', N'2010-W04-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93893, CAST(N'2010-01-27' AS date), CAST(N'2010-01-28' AS date), 2010, 20101, 201001, 2010027, 1, 1, 27, 27, 4, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-01-21' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-01-22' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-29' AS date), 1028, 3084, 13412, 13413, 13413, 13413, 13412, 13412, 13412, 2455224, 55223, N'2010-01-27', 201004, 4, 3, N'2010-W04', N'2010-W04-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93894, CAST(N'2010-01-28' AS date), CAST(N'2010-01-29' AS date), 2010, 20101, 201001, 2010028, 1, 1, 28, 28, 5, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-01-22' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-29' AS date), 1028, 3084, 13412, 13413, 13413, 13413, 13413, 13412, 13412, 2455225, 55224, N'2010-01-28', 201004, 4, 4, N'2010-W04', N'2010-W04-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93895, CAST(N'2010-01-29' AS date), CAST(N'2010-01-30' AS date), 2010, 20101, 201001, 2010029, 1, 1, 29, 29, 6, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-01-29' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-01-23' AS date), CAST(N'2010-01-29' AS date), 1028, 3084, 13412, 13413, 13413, 13413, 13413, 13413, 13412, 2455226, 55225, N'2010-01-29', 201004, 4, 5, N'2010-W04', N'2010-W04-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93896, CAST(N'2010-01-30' AS date), CAST(N'2010-01-31' AS date), 2010, 20101, 201001, 2010030, 1, 1, 30, 30, 7, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-24' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-01-29' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-02-05' AS date), 1028, 3084, 13412, 13413, 13413, 13413, 13413, 13413, 13413, 2455227, 55226, N'2010-01-30', 201004, 4, 6, N'2010-W04', N'2010-W04-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93897, CAST(N'2010-01-31' AS date), CAST(N'2010-02-01' AS date), 2010, 20101, 201001, 2010031, 1, 1, 31, 31, 1, N'2010', N'2010 Q1', N'2010 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-01-25' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-01-29' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-02-05' AS date), 1028, 3084, 13413, 13413, 13413, 13413, 13413, 13413, 13413, 2455228, 55227, N'2010-01-31', 201004, 4, 7, N'2010-W04', N'2010-W04-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93898, CAST(N'2010-02-01' AS date), CAST(N'2010-02-02' AS date), 2010, 20101, 201002, 2010032, 1, 2, 32, 1, 2, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-01-26' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-01-29' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-02-05' AS date), 1028, 3085, 13413, 13414, 13413, 13413, 13413, 13413, 13413, 2455229, 55228, N'2010-02-01', 201005, 5, 1, N'2010-W05', N'2010-W05-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93899, CAST(N'2010-02-02' AS date), CAST(N'2010-02-03' AS date), 2010, 20101, 201002, 2010033, 1, 2, 33, 2, 3, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-01-27' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-01-29' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-02-05' AS date), 1028, 3085, 13413, 13414, 13414, 13413, 13413, 13413, 13413, 2455230, 55229, N'2010-02-02', 201005, 5, 2, N'2010-W05', N'2010-W05-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93900, CAST(N'2010-02-03' AS date), CAST(N'2010-02-04' AS date), 2010, 20101, 201002, 2010034, 1, 2, 34, 3, 4, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-01-28' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-01-29' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-02-05' AS date), 1028, 3085, 13413, 13414, 13414, 13414, 13413, 13413, 13413, 2455231, 55230, N'2010-02-03', 201005, 5, 3, N'2010-W05', N'2010-W05-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93901, CAST(N'2010-02-04' AS date), CAST(N'2010-02-05' AS date), 2010, 20101, 201002, 2010035, 1, 2, 35, 4, 5, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-01-29' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-02-05' AS date), 1028, 3085, 13413, 13414, 13414, 13414, 13414, 13413, 13413, 2455232, 55231, N'2010-02-04', 201005, 5, 4, N'2010-W05', N'2010-W05-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93902, CAST(N'2010-02-05' AS date), CAST(N'2010-02-06' AS date), 2010, 20101, 201002, 2010036, 1, 2, 36, 5, 6, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-05' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-01-30' AS date), CAST(N'2010-02-05' AS date), 1028, 3085, 13413, 13414, 13414, 13414, 13414, 13414, 13413, 2455233, 55232, N'2010-02-05', 201005, 5, 5, N'2010-W05', N'2010-W05-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93903, CAST(N'2010-02-06' AS date), CAST(N'2010-02-07' AS date), 2010, 20101, 201002, 2010037, 1, 2, 37, 6, 7, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-01-31' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-05' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-12' AS date), 1028, 3085, 13413, 13414, 13414, 13414, 13414, 13414, 13414, 2455234, 55233, N'2010-02-06', 201005, 5, 6, N'2010-W05', N'2010-W05-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93904, CAST(N'2010-02-07' AS date), CAST(N'2010-02-08' AS date), 2010, 20101, 201002, 2010038, 1, 2, 38, 7, 1, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-05' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-12' AS date), 1028, 3085, 13414, 13414, 13414, 13414, 13414, 13414, 13414, 2455235, 55234, N'2010-02-07', 201005, 5, 7, N'2010-W05', N'2010-W05-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93905, CAST(N'2010-02-08' AS date), CAST(N'2010-02-09' AS date), 2010, 20101, 201002, 2010039, 1, 2, 39, 8, 2, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-02' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-05' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-12' AS date), 1028, 3085, 13414, 13415, 13414, 13414, 13414, 13414, 13414, 2455236, 55235, N'2010-02-08', 201006, 6, 1, N'2010-W06', N'2010-W06-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93906, CAST(N'2010-02-09' AS date), CAST(N'2010-02-10' AS date), 2010, 20101, 201002, 2010040, 1, 2, 40, 9, 3, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-03' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-05' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-12' AS date), 1028, 3085, 13414, 13415, 13415, 13414, 13414, 13414, 13414, 2455237, 55236, N'2010-02-09', 201006, 6, 2, N'2010-W06', N'2010-W06-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93907, CAST(N'2010-02-10' AS date), CAST(N'2010-02-11' AS date), 2010, 20101, 201002, 2010041, 1, 2, 41, 10, 4, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-04' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-05' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-12' AS date), 1028, 3085, 13414, 13415, 13415, 13415, 13414, 13414, 13414, 2455238, 55237, N'2010-02-10', 201006, 6, 3, N'2010-W06', N'2010-W06-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93908, CAST(N'2010-02-11' AS date), CAST(N'2010-02-12' AS date), 2010, 20101, 201002, 2010042, 1, 2, 42, 11, 5, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-05' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-12' AS date), 1028, 3085, 13414, 13415, 13415, 13415, 13415, 13414, 13414, 2455239, 55238, N'2010-02-11', 201006, 6, 4, N'2010-W06', N'2010-W06-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93909, CAST(N'2010-02-12' AS date), CAST(N'2010-02-13' AS date), 2010, 20101, 201002, 2010043, 1, 2, 43, 12, 6, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-12' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-06' AS date), CAST(N'2010-02-12' AS date), 1028, 3085, 13414, 13415, 13415, 13415, 13415, 13415, 13414, 2455240, 55239, N'2010-02-12', 201006, 6, 5, N'2010-W06', N'2010-W06-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93910, CAST(N'2010-02-13' AS date), CAST(N'2010-02-14' AS date), 2010, 20101, 201002, 2010044, 1, 2, 44, 13, 7, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-07' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-12' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-19' AS date), 1028, 3085, 13414, 13415, 13415, 13415, 13415, 13415, 13415, 2455241, 55240, N'2010-02-13', 201006, 6, 6, N'2010-W06', N'2010-W06-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93911, CAST(N'2010-02-14' AS date), CAST(N'2010-02-15' AS date), 2010, 20101, 201002, 2010045, 1, 2, 45, 14, 1, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-08' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-12' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-19' AS date), 1028, 3085, 13415, 13415, 13415, 13415, 13415, 13415, 13415, 2455242, 55241, N'2010-02-14', 201006, 6, 7, N'2010-W06', N'2010-W06-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93912, CAST(N'2010-02-15' AS date), CAST(N'2010-02-16' AS date), 2010, 20101, 201002, 2010046, 1, 2, 46, 15, 2, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-09' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-12' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-19' AS date), 1028, 3085, 13415, 13416, 13415, 13415, 13415, 13415, 13415, 2455243, 55242, N'2010-02-15', 201007, 7, 1, N'2010-W07', N'2010-W07-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93913, CAST(N'2010-02-16' AS date), CAST(N'2010-02-17' AS date), 2010, 20101, 201002, 2010047, 1, 2, 47, 16, 3, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-10' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-12' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-19' AS date), 1028, 3085, 13415, 13416, 13416, 13415, 13415, 13415, 13415, 2455244, 55243, N'2010-02-16', 201007, 7, 2, N'2010-W07', N'2010-W07-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93914, CAST(N'2010-02-17' AS date), CAST(N'2010-02-18' AS date), 2010, 20101, 201002, 2010048, 1, 2, 48, 17, 4, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-02-11' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-12' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-19' AS date), 1028, 3085, 13415, 13416, 13416, 13416, 13415, 13415, 13415, 2455245, 55244, N'2010-02-17', 201007, 7, 3, N'2010-W07', N'2010-W07-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93915, CAST(N'2010-02-18' AS date), CAST(N'2010-02-19' AS date), 2010, 20101, 201002, 2010049, 1, 2, 49, 18, 5, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-02-12' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-19' AS date), 1028, 3085, 13415, 13416, 13416, 13416, 13416, 13415, 13415, 2455246, 55245, N'2010-02-18', 201007, 7, 4, N'2010-W07', N'2010-W07-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93916, CAST(N'2010-02-19' AS date), CAST(N'2010-02-20' AS date), 2010, 20101, 201002, 2010050, 1, 2, 50, 19, 6, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-02-19' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-02-13' AS date), CAST(N'2010-02-19' AS date), 1028, 3085, 13415, 13416, 13416, 13416, 13416, 13416, 13415, 2455247, 55246, N'2010-02-19', 201007, 7, 5, N'2010-W07', N'2010-W07-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93917, CAST(N'2010-02-20' AS date), CAST(N'2010-02-21' AS date), 2010, 20101, 201002, 2010051, 1, 2, 51, 20, 7, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-14' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-02-19' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-26' AS date), 1028, 3085, 13415, 13416, 13416, 13416, 13416, 13416, 13416, 2455248, 55247, N'2010-02-20', 201007, 7, 6, N'2010-W07', N'2010-W07-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93918, CAST(N'2010-02-21' AS date), CAST(N'2010-02-22' AS date), 2010, 20101, 201002, 2010052, 1, 2, 52, 21, 1, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-02-15' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-02-19' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-26' AS date), 1028, 3085, 13416, 13416, 13416, 13416, 13416, 13416, 13416, 2455249, 55248, N'2010-02-21', 201007, 7, 7, N'2010-W07', N'2010-W07-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93919, CAST(N'2010-02-22' AS date), CAST(N'2010-02-23' AS date), 2010, 20101, 201002, 2010053, 1, 2, 53, 22, 2, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-16' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-02-19' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-26' AS date), 1028, 3085, 13416, 13417, 13416, 13416, 13416, 13416, 13416, 2455250, 55249, N'2010-02-22', 201008, 8, 1, N'2010-W08', N'2010-W08-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93920, CAST(N'2010-02-23' AS date), CAST(N'2010-02-24' AS date), 2010, 20101, 201002, 2010054, 1, 2, 54, 23, 3, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-02-17' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-02-19' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-26' AS date), 1028, 3085, 13416, 13417, 13417, 13416, 13416, 13416, 13416, 2455251, 55250, N'2010-02-23', 201008, 8, 2, N'2010-W08', N'2010-W08-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93921, CAST(N'2010-02-24' AS date), CAST(N'2010-02-25' AS date), 2010, 20101, 201002, 2010055, 1, 2, 55, 24, 4, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-02-18' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-02-19' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-26' AS date), 1028, 3085, 13416, 13417, 13417, 13417, 13416, 13416, 13416, 2455252, 55251, N'2010-02-24', 201008, 8, 3, N'2010-W08', N'2010-W08-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93922, CAST(N'2010-02-25' AS date), CAST(N'2010-02-26' AS date), 2010, 20101, 201002, 2010056, 1, 2, 56, 25, 5, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-02-19' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-26' AS date), 1028, 3085, 13416, 13417, 13417, 13417, 13417, 13416, 13416, 2455253, 55252, N'2010-02-25', 201008, 8, 4, N'2010-W08', N'2010-W08-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93923, CAST(N'2010-02-26' AS date), CAST(N'2010-02-27' AS date), 2010, 20101, 201002, 2010057, 1, 2, 57, 26, 6, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-02-26' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-02-20' AS date), CAST(N'2010-02-26' AS date), 1028, 3085, 13416, 13417, 13417, 13417, 13417, 13417, 13416, 2455254, 55253, N'2010-02-26', 201008, 8, 5, N'2010-W08', N'2010-W08-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93924, CAST(N'2010-02-27' AS date), CAST(N'2010-02-28' AS date), 2010, 20101, 201002, 2010058, 1, 2, 58, 27, 7, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-21' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-02-26' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-03-05' AS date), 1028, 3085, 13416, 13417, 13417, 13417, 13417, 13417, 13417, 2455255, 55254, N'2010-02-27', 201008, 8, 6, N'2010-W08', N'2010-W08-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93925, CAST(N'2010-02-28' AS date), CAST(N'2010-03-01' AS date), 2010, 20101, 201002, 2010059, 1, 2, 59, 28, 1, N'2010', N'2010 Q1', N'2010 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-01' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-02-22' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-02-26' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-03-05' AS date), 1028, 3085, 13417, 13417, 13417, 13417, 13417, 13417, 13417, 2455256, 55255, N'2010-02-28', 201008, 8, 7, N'2010-W08', N'2010-W08-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93926, CAST(N'2010-03-01' AS date), CAST(N'2010-03-02' AS date), 2010, 20101, 201003, 2010060, 1, 3, 60, 1, 2, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-02-23' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-02-26' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-03-05' AS date), 1028, 3086, 13417, 13418, 13417, 13417, 13417, 13417, 13417, 2455257, 55256, N'2010-03-01', 201009, 9, 1, N'2010-W09', N'2010-W09-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93927, CAST(N'2010-03-02' AS date), CAST(N'2010-03-03' AS date), 2010, 20101, 201003, 2010061, 1, 3, 61, 2, 3, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-02-24' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-02-26' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-03-05' AS date), 1028, 3086, 13417, 13418, 13418, 13417, 13417, 13417, 13417, 2455258, 55257, N'2010-03-02', 201009, 9, 2, N'2010-W09', N'2010-W09-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93928, CAST(N'2010-03-03' AS date), CAST(N'2010-03-04' AS date), 2010, 20101, 201003, 2010062, 1, 3, 62, 3, 4, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-02-25' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-02-26' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-03-05' AS date), 1028, 3086, 13417, 13418, 13418, 13418, 13417, 13417, 13417, 2455259, 55258, N'2010-03-03', 201009, 9, 3, N'2010-W09', N'2010-W09-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93929, CAST(N'2010-03-04' AS date), CAST(N'2010-03-05' AS date), 2010, 20101, 201003, 2010063, 1, 3, 63, 4, 5, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-02-26' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-03-05' AS date), 1028, 3086, 13417, 13418, 13418, 13418, 13418, 13417, 13417, 2455260, 55259, N'2010-03-04', 201009, 9, 4, N'2010-W09', N'2010-W09-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93930, CAST(N'2010-03-05' AS date), CAST(N'2010-03-06' AS date), 2010, 20101, 201003, 2010064, 1, 3, 64, 5, 6, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-05' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-02-27' AS date), CAST(N'2010-03-05' AS date), 1028, 3086, 13417, 13418, 13418, 13418, 13418, 13418, 13417, 2455261, 55260, N'2010-03-05', 201009, 9, 5, N'2010-W09', N'2010-W09-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93931, CAST(N'2010-03-06' AS date), CAST(N'2010-03-07' AS date), 2010, 20101, 201003, 2010065, 1, 3, 65, 6, 7, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-02-28' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-05' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-12' AS date), 1028, 3086, 13417, 13418, 13418, 13418, 13418, 13418, 13418, 2455262, 55261, N'2010-03-06', 201009, 9, 6, N'2010-W09', N'2010-W09-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93932, CAST(N'2010-03-07' AS date), CAST(N'2010-03-08' AS date), 2010, 20101, 201003, 2010066, 1, 3, 66, 7, 1, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-05' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-12' AS date), 1028, 3086, 13418, 13418, 13418, 13418, 13418, 13418, 13418, 2455263, 55262, N'2010-03-07', 201009, 9, 7, N'2010-W09', N'2010-W09-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93933, CAST(N'2010-03-08' AS date), CAST(N'2010-03-09' AS date), 2010, 20101, 201003, 2010067, 1, 3, 67, 8, 2, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-02' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-05' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-12' AS date), 1028, 3086, 13418, 13419, 13418, 13418, 13418, 13418, 13418, 2455264, 55263, N'2010-03-08', 201010, 10, 1, N'2010-W10', N'2010-W10-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93934, CAST(N'2010-03-09' AS date), CAST(N'2010-03-10' AS date), 2010, 20101, 201003, 2010068, 1, 3, 68, 9, 3, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-03' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-05' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-12' AS date), 1028, 3086, 13418, 13419, 13419, 13418, 13418, 13418, 13418, 2455265, 55264, N'2010-03-09', 201010, 10, 2, N'2010-W10', N'2010-W10-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93935, CAST(N'2010-03-10' AS date), CAST(N'2010-03-11' AS date), 2010, 20101, 201003, 2010069, 1, 3, 69, 10, 4, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-04' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-05' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-12' AS date), 1028, 3086, 13418, 13419, 13419, 13419, 13418, 13418, 13418, 2455266, 55265, N'2010-03-10', 201010, 10, 3, N'2010-W10', N'2010-W10-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93936, CAST(N'2010-03-11' AS date), CAST(N'2010-03-12' AS date), 2010, 20101, 201003, 2010070, 1, 3, 70, 11, 5, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-05' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-12' AS date), 1028, 3086, 13418, 13419, 13419, 13419, 13419, 13418, 13418, 2455267, 55266, N'2010-03-11', 201010, 10, 4, N'2010-W10', N'2010-W10-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93937, CAST(N'2010-03-12' AS date), CAST(N'2010-03-13' AS date), 2010, 20101, 201003, 2010071, 1, 3, 71, 12, 6, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-12' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-06' AS date), CAST(N'2010-03-12' AS date), 1028, 3086, 13418, 13419, 13419, 13419, 13419, 13419, 13418, 2455268, 55267, N'2010-03-12', 201010, 10, 5, N'2010-W10', N'2010-W10-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93938, CAST(N'2010-03-13' AS date), CAST(N'2010-03-14' AS date), 2010, 20101, 201003, 2010072, 1, 3, 72, 13, 7, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-07' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-12' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-19' AS date), 1028, 3086, 13418, 13419, 13419, 13419, 13419, 13419, 13419, 2455269, 55268, N'2010-03-13', 201010, 10, 6, N'2010-W10', N'2010-W10-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93939, CAST(N'2010-03-14' AS date), CAST(N'2010-03-15' AS date), 2010, 20101, 201003, 2010073, 1, 3, 73, 14, 1, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-08' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-12' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-19' AS date), 1028, 3086, 13419, 13419, 13419, 13419, 13419, 13419, 13419, 2455270, 55269, N'2010-03-14', 201010, 10, 7, N'2010-W10', N'2010-W10-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93940, CAST(N'2010-03-15' AS date), CAST(N'2010-03-16' AS date), 2010, 20101, 201003, 2010074, 1, 3, 74, 15, 2, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-09' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-12' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-19' AS date), 1028, 3086, 13419, 13420, 13419, 13419, 13419, 13419, 13419, 2455271, 55270, N'2010-03-15', 201011, 11, 1, N'2010-W11', N'2010-W11-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93941, CAST(N'2010-03-16' AS date), CAST(N'2010-03-17' AS date), 2010, 20101, 201003, 2010075, 1, 3, 75, 16, 3, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-10' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-12' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-19' AS date), 1028, 3086, 13419, 13420, 13420, 13419, 13419, 13419, 13419, 2455272, 55271, N'2010-03-16', 201011, 11, 2, N'2010-W11', N'2010-W11-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93942, CAST(N'2010-03-17' AS date), CAST(N'2010-03-18' AS date), 2010, 20101, 201003, 2010076, 1, 3, 76, 17, 4, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-11' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-12' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-19' AS date), 1028, 3086, 13419, 13420, 13420, 13420, 13419, 13419, 13419, 2455273, 55272, N'2010-03-17', 201011, 11, 3, N'2010-W11', N'2010-W11-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93943, CAST(N'2010-03-18' AS date), CAST(N'2010-03-19' AS date), 2010, 20101, 201003, 2010077, 1, 3, 77, 18, 5, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-12' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-19' AS date), 1028, 3086, 13419, 13420, 13420, 13420, 13420, 13419, 13419, 2455274, 55273, N'2010-03-18', 201011, 11, 4, N'2010-W11', N'2010-W11-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93944, CAST(N'2010-03-19' AS date), CAST(N'2010-03-20' AS date), 2010, 20101, 201003, 2010078, 1, 3, 78, 19, 6, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-19' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-13' AS date), CAST(N'2010-03-19' AS date), 1028, 3086, 13419, 13420, 13420, 13420, 13420, 13420, 13419, 2455275, 55274, N'2010-03-19', 201011, 11, 5, N'2010-W11', N'2010-W11-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93945, CAST(N'2010-03-20' AS date), CAST(N'2010-03-21' AS date), 2010, 20101, 201003, 2010079, 1, 3, 79, 20, 7, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-14' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-19' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-26' AS date), 1028, 3086, 13419, 13420, 13420, 13420, 13420, 13420, 13420, 2455276, 55275, N'2010-03-20', 201011, 11, 6, N'2010-W11', N'2010-W11-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93946, CAST(N'2010-03-21' AS date), CAST(N'2010-03-22' AS date), 2010, 20101, 201003, 2010080, 1, 3, 80, 21, 1, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-03-15' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-19' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-26' AS date), 1028, 3086, 13420, 13420, 13420, 13420, 13420, 13420, 13420, 2455277, 55276, N'2010-03-21', 201011, 11, 7, N'2010-W11', N'2010-W11-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93947, CAST(N'2010-03-22' AS date), CAST(N'2010-03-23' AS date), 2010, 20101, 201003, 2010081, 1, 3, 81, 22, 2, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-03-16' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-19' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-26' AS date), 1028, 3086, 13420, 13421, 13420, 13420, 13420, 13420, 13420, 2455278, 55277, N'2010-03-22', 201012, 12, 1, N'2010-W12', N'2010-W12-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93948, CAST(N'2010-03-23' AS date), CAST(N'2010-03-24' AS date), 2010, 20101, 201003, 2010082, 1, 3, 82, 23, 3, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-03-17' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-19' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-26' AS date), 1028, 3086, 13420, 13421, 13421, 13420, 13420, 13420, 13420, 2455279, 55278, N'2010-03-23', 201012, 12, 2, N'2010-W12', N'2010-W12-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93949, CAST(N'2010-03-24' AS date), CAST(N'2010-03-25' AS date), 2010, 20101, 201003, 2010083, 1, 3, 83, 24, 4, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-03-18' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-19' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-26' AS date), 1028, 3086, 13420, 13421, 13421, 13421, 13420, 13420, 13420, 2455280, 55279, N'2010-03-24', 201012, 12, 3, N'2010-W12', N'2010-W12-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93950, CAST(N'2010-03-25' AS date), CAST(N'2010-03-26' AS date), 2010, 20101, 201003, 2010084, 1, 3, 84, 25, 5, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-19' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-26' AS date), 1028, 3086, 13420, 13421, 13421, 13421, 13421, 13420, 13420, 2455281, 55280, N'2010-03-25', 201012, 12, 4, N'2010-W12', N'2010-W12-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93951, CAST(N'2010-03-26' AS date), CAST(N'2010-03-27' AS date), 2010, 20101, 201003, 2010085, 1, 3, 85, 26, 6, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-26' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-03-20' AS date), CAST(N'2010-03-26' AS date), 1028, 3086, 13420, 13421, 13421, 13421, 13421, 13421, 13420, 2455282, 55281, N'2010-03-26', 201012, 12, 5, N'2010-W12', N'2010-W12-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93952, CAST(N'2010-03-27' AS date), CAST(N'2010-03-28' AS date), 2010, 20101, 201003, 2010086, 1, 3, 86, 27, 7, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-21' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-26' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-04-02' AS date), 1028, 3086, 13420, 13421, 13421, 13421, 13421, 13421, 13421, 2455283, 55282, N'2010-03-27', 201012, 12, 6, N'2010-W12', N'2010-W12-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93953, CAST(N'2010-03-28' AS date), CAST(N'2010-03-29' AS date), 2010, 20101, 201003, 2010087, 1, 3, 87, 28, 1, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-03-22' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-26' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-04-02' AS date), 1028, 3086, 13421, 13421, 13421, 13421, 13421, 13421, 13421, 2455284, 55283, N'2010-03-28', 201012, 12, 7, N'2010-W12', N'2010-W12-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93954, CAST(N'2010-03-29' AS date), CAST(N'2010-03-30' AS date), 2010, 20101, 201003, 2010088, 1, 3, 88, 29, 2, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-03-23' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-26' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-04-02' AS date), 1028, 3086, 13421, 13422, 13421, 13421, 13421, 13421, 13421, 2455285, 55284, N'2010-03-29', 201013, 13, 1, N'2010-W13', N'2010-W13-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93955, CAST(N'2010-03-30' AS date), CAST(N'2010-03-31' AS date), 2010, 20101, 201003, 2010089, 1, 3, 89, 30, 3, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-03-24' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-26' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-04-02' AS date), 1028, 3086, 13421, 13422, 13422, 13421, 13421, 13421, 13421, 2455286, 55285, N'2010-03-30', 201013, 13, 2, N'2010-W13', N'2010-W13-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93956, CAST(N'2010-03-31' AS date), CAST(N'2010-04-01' AS date), 2010, 20101, 201003, 2010090, 1, 3, 90, 31, 4, N'2010', N'2010 Q1', N'2010 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-01-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-01' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-03-25' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-03-26' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-04-02' AS date), 1028, 3086, 13421, 13422, 13422, 13422, 13421, 13421, 13421, 2455287, 55286, N'2010-03-31', 201013, 13, 3, N'2010-W13', N'2010-W13-3');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93957, CAST(N'2010-04-01' AS date), CAST(N'2010-04-02' AS date), 2010, 20102, 201004, 2010091, 2, 4, 91, 1, 5, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-03-26' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-04-02' AS date), 1029, 3087, 13421, 13422, 13422, 13422, 13422, 13421, 13421, 2455288, 55287, N'2010-04-01', 201013, 13, 4, N'2010-W13', N'2010-W13-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93958, CAST(N'2010-04-02' AS date), CAST(N'2010-04-03' AS date), 2010, 20102, 201004, 2010092, 2, 4, 92, 2, 6, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-02' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-03-27' AS date), CAST(N'2010-04-02' AS date), 1029, 3087, 13421, 13422, 13422, 13422, 13422, 13422, 13421, 2455289, 55288, N'2010-04-02', 201013, 13, 5, N'2010-W13', N'2010-W13-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93959, CAST(N'2010-04-03' AS date), CAST(N'2010-04-04' AS date), 2010, 20102, 201004, 2010093, 2, 4, 93, 3, 7, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-03-28' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-02' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-04-09' AS date), 1029, 3087, 13421, 13422, 13422, 13422, 13422, 13422, 13422, 2455290, 55289, N'2010-04-03', 201013, 13, 6, N'2010-W13', N'2010-W13-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93960, CAST(N'2010-04-04' AS date), CAST(N'2010-04-05' AS date), 2010, 20102, 201004, 2010094, 2, 4, 94, 4, 1, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-03-29' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-02' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-04-09' AS date), 1029, 3087, 13422, 13422, 13422, 13422, 13422, 13422, 13422, 2455291, 55290, N'2010-04-04', 201013, 13, 7, N'2010-W13', N'2010-W13-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93961, CAST(N'2010-04-05' AS date), CAST(N'2010-04-06' AS date), 2010, 20102, 201004, 2010095, 2, 4, 95, 5, 2, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-03-30' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-02' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-04-09' AS date), 1029, 3087, 13422, 13423, 13422, 13422, 13422, 13422, 13422, 2455292, 55291, N'2010-04-05', 201014, 14, 1, N'2010-W14', N'2010-W14-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93962, CAST(N'2010-04-06' AS date), CAST(N'2010-04-07' AS date), 2010, 20102, 201004, 2010096, 2, 4, 96, 6, 3, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-03-31' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-02' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-04-09' AS date), 1029, 3087, 13422, 13423, 13423, 13422, 13422, 13422, 13422, 2455293, 55292, N'2010-04-06', 201014, 14, 2, N'2010-W14', N'2010-W14-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93963, CAST(N'2010-04-07' AS date), CAST(N'2010-04-08' AS date), 2010, 20102, 201004, 2010097, 2, 4, 97, 7, 4, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-02' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-04-09' AS date), 1029, 3087, 13422, 13423, 13423, 13423, 13422, 13422, 13422, 2455294, 55293, N'2010-04-07', 201014, 14, 3, N'2010-W14', N'2010-W14-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93964, CAST(N'2010-04-08' AS date), CAST(N'2010-04-09' AS date), 2010, 20102, 201004, 2010098, 2, 4, 98, 8, 5, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-02' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-04-09' AS date), 1029, 3087, 13422, 13423, 13423, 13423, 13423, 13422, 13422, 2455295, 55294, N'2010-04-08', 201014, 14, 4, N'2010-W14', N'2010-W14-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93965, CAST(N'2010-04-09' AS date), CAST(N'2010-04-10' AS date), 2010, 20102, 201004, 2010099, 2, 4, 99, 9, 6, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-09' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-03' AS date), CAST(N'2010-04-09' AS date), 1029, 3087, 13422, 13423, 13423, 13423, 13423, 13423, 13422, 2455296, 55295, N'2010-04-09', 201014, 14, 5, N'2010-W14', N'2010-W14-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93966, CAST(N'2010-04-10' AS date), CAST(N'2010-04-11' AS date), 2010, 20102, 201004, 2010100, 2, 4, 100, 10, 7, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-04' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-09' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-16' AS date), 1029, 3087, 13422, 13423, 13423, 13423, 13423, 13423, 13423, 2455297, 55296, N'2010-04-10', 201014, 14, 6, N'2010-W14', N'2010-W14-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93967, CAST(N'2010-04-11' AS date), CAST(N'2010-04-12' AS date), 2010, 20102, 201004, 2010101, 2, 4, 101, 11, 1, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-05' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-09' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-16' AS date), 1029, 3087, 13423, 13423, 13423, 13423, 13423, 13423, 13423, 2455298, 55297, N'2010-04-11', 201014, 14, 7, N'2010-W14', N'2010-W14-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93968, CAST(N'2010-04-12' AS date), CAST(N'2010-04-13' AS date), 2010, 20102, 201004, 2010102, 2, 4, 102, 12, 2, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-06' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-09' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-16' AS date), 1029, 3087, 13423, 13424, 13423, 13423, 13423, 13423, 13423, 2455299, 55298, N'2010-04-12', 201015, 15, 1, N'2010-W15', N'2010-W15-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93969, CAST(N'2010-04-13' AS date), CAST(N'2010-04-14' AS date), 2010, 20102, 201004, 2010103, 2, 4, 103, 13, 3, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-07' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-09' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-16' AS date), 1029, 3087, 13423, 13424, 13424, 13423, 13423, 13423, 13423, 2455300, 55299, N'2010-04-13', 201015, 15, 2, N'2010-W15', N'2010-W15-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93970, CAST(N'2010-04-14' AS date), CAST(N'2010-04-15' AS date), 2010, 20102, 201004, 2010104, 2, 4, 104, 14, 4, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-08' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-09' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-16' AS date), 1029, 3087, 13423, 13424, 13424, 13424, 13423, 13423, 13423, 2455301, 55300, N'2010-04-14', 201015, 15, 3, N'2010-W15', N'2010-W15-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93971, CAST(N'2010-04-15' AS date), CAST(N'2010-04-16' AS date), 2010, 20102, 201004, 2010105, 2, 4, 105, 15, 5, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-09' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-16' AS date), 1029, 3087, 13423, 13424, 13424, 13424, 13424, 13423, 13423, 2455302, 55301, N'2010-04-15', 201015, 15, 4, N'2010-W15', N'2010-W15-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93972, CAST(N'2010-04-16' AS date), CAST(N'2010-04-17' AS date), 2010, 20102, 201004, 2010106, 2, 4, 106, 16, 6, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-16' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-10' AS date), CAST(N'2010-04-16' AS date), 1029, 3087, 13423, 13424, 13424, 13424, 13424, 13424, 13423, 2455303, 55302, N'2010-04-16', 201015, 15, 5, N'2010-W15', N'2010-W15-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93973, CAST(N'2010-04-17' AS date), CAST(N'2010-04-18' AS date), 2010, 20102, 201004, 2010107, 2, 4, 107, 17, 7, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-11' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-16' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-23' AS date), 1029, 3087, 13423, 13424, 13424, 13424, 13424, 13424, 13424, 2455304, 55303, N'2010-04-17', 201015, 15, 6, N'2010-W15', N'2010-W15-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93974, CAST(N'2010-04-18' AS date), CAST(N'2010-04-19' AS date), 2010, 20102, 201004, 2010108, 2, 4, 108, 18, 1, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-12' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-16' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-23' AS date), 1029, 3087, 13424, 13424, 13424, 13424, 13424, 13424, 13424, 2455305, 55304, N'2010-04-18', 201015, 15, 7, N'2010-W15', N'2010-W15-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93975, CAST(N'2010-04-19' AS date), CAST(N'2010-04-20' AS date), 2010, 20102, 201004, 2010109, 2, 4, 109, 19, 2, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-04-13' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-16' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-23' AS date), 1029, 3087, 13424, 13425, 13424, 13424, 13424, 13424, 13424, 2455306, 55305, N'2010-04-19', 201016, 16, 1, N'2010-W16', N'2010-W16-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93976, CAST(N'2010-04-20' AS date), CAST(N'2010-04-21' AS date), 2010, 20102, 201004, 2010110, 2, 4, 110, 20, 3, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-04-14' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-16' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-23' AS date), 1029, 3087, 13424, 13425, 13425, 13424, 13424, 13424, 13424, 2455307, 55306, N'2010-04-20', 201016, 16, 2, N'2010-W16', N'2010-W16-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93977, CAST(N'2010-04-21' AS date), CAST(N'2010-04-22' AS date), 2010, 20102, 201004, 2010111, 2, 4, 111, 21, 4, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-04-15' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-16' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-23' AS date), 1029, 3087, 13424, 13425, 13425, 13425, 13424, 13424, 13424, 2455308, 55307, N'2010-04-21', 201016, 16, 3, N'2010-W16', N'2010-W16-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93978, CAST(N'2010-04-22' AS date), CAST(N'2010-04-23' AS date), 2010, 20102, 201004, 2010112, 2, 4, 112, 22, 5, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-04-16' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-23' AS date), 1029, 3087, 13424, 13425, 13425, 13425, 13425, 13424, 13424, 2455309, 55308, N'2010-04-22', 201016, 16, 4, N'2010-W16', N'2010-W16-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93979, CAST(N'2010-04-23' AS date), CAST(N'2010-04-24' AS date), 2010, 20102, 201004, 2010113, 2, 4, 113, 23, 6, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-04-23' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-04-17' AS date), CAST(N'2010-04-23' AS date), 1029, 3087, 13424, 13425, 13425, 13425, 13425, 13425, 13424, 2455310, 55309, N'2010-04-23', 201016, 16, 5, N'2010-W16', N'2010-W16-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93980, CAST(N'2010-04-24' AS date), CAST(N'2010-04-25' AS date), 2010, 20102, 201004, 2010114, 2, 4, 114, 24, 7, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-18' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-04-23' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-30' AS date), 1029, 3087, 13424, 13425, 13425, 13425, 13425, 13425, 13425, 2455311, 55310, N'2010-04-24', 201016, 16, 6, N'2010-W16', N'2010-W16-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93981, CAST(N'2010-04-25' AS date), CAST(N'2010-04-26' AS date), 2010, 20102, 201004, 2010115, 2, 4, 115, 25, 1, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-04-19' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-04-23' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-30' AS date), 1029, 3087, 13425, 13425, 13425, 13425, 13425, 13425, 13425, 2455312, 55311, N'2010-04-25', 201016, 16, 7, N'2010-W16', N'2010-W16-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93982, CAST(N'2010-04-26' AS date), CAST(N'2010-04-27' AS date), 2010, 20102, 201004, 2010116, 2, 4, 116, 26, 2, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-04-20' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-04-23' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-30' AS date), 1029, 3087, 13425, 13426, 13425, 13425, 13425, 13425, 13425, 2455313, 55312, N'2010-04-26', 201017, 17, 1, N'2010-W17', N'2010-W17-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93983, CAST(N'2010-04-27' AS date), CAST(N'2010-04-28' AS date), 2010, 20102, 201004, 2010117, 2, 4, 117, 27, 3, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-04-21' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-04-23' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-30' AS date), 1029, 3087, 13425, 13426, 13426, 13425, 13425, 13425, 13425, 2455314, 55313, N'2010-04-27', 201017, 17, 2, N'2010-W17', N'2010-W17-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93984, CAST(N'2010-04-28' AS date), CAST(N'2010-04-29' AS date), 2010, 20102, 201004, 2010118, 2, 4, 118, 28, 4, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-04-22' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-04-23' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-30' AS date), 1029, 3087, 13425, 13426, 13426, 13426, 13425, 13425, 13425, 2455315, 55314, N'2010-04-28', 201017, 17, 3, N'2010-W17', N'2010-W17-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93985, CAST(N'2010-04-29' AS date), CAST(N'2010-04-30' AS date), 2010, 20102, 201004, 2010119, 2, 4, 119, 29, 5, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-04-23' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-30' AS date), 1029, 3087, 13425, 13426, 13426, 13426, 13426, 13425, 13425, 2455316, 55315, N'2010-04-29', 201017, 17, 4, N'2010-W17', N'2010-W17-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93986, CAST(N'2010-04-30' AS date), CAST(N'2010-05-01' AS date), 2010, 20102, 201004, 2010120, 2, 4, 120, 30, 6, N'2010', N'2010 Q2', N'2010 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-04-24' AS date), CAST(N'2010-04-30' AS date), 1029, 3087, 13425, 13426, 13426, 13426, 13426, 13426, 13425, 2455317, 55316, N'2010-04-30', 201017, 17, 5, N'2010-W17', N'2010-W17-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93987, CAST(N'2010-05-01' AS date), CAST(N'2010-05-02' AS date), 2010, 20102, 201005, 2010121, 2, 5, 121, 1, 7, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-04-25' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-07' AS date), 1029, 3088, 13425, 13426, 13426, 13426, 13426, 13426, 13426, 2455318, 55317, N'2010-05-01', 201017, 17, 6, N'2010-W17', N'2010-W17-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93988, CAST(N'2010-05-02' AS date), CAST(N'2010-05-03' AS date), 2010, 20102, 201005, 2010122, 2, 5, 122, 2, 1, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-04-26' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-07' AS date), 1029, 3088, 13426, 13426, 13426, 13426, 13426, 13426, 13426, 2455319, 55318, N'2010-05-02', 201017, 17, 7, N'2010-W17', N'2010-W17-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93989, CAST(N'2010-05-03' AS date), CAST(N'2010-05-04' AS date), 2010, 20102, 201005, 2010123, 2, 5, 123, 3, 2, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-04-27' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-07' AS date), 1029, 3088, 13426, 13427, 13426, 13426, 13426, 13426, 13426, 2455320, 55319, N'2010-05-03', 201018, 18, 1, N'2010-W18', N'2010-W18-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93990, CAST(N'2010-05-04' AS date), CAST(N'2010-05-05' AS date), 2010, 20102, 201005, 2010124, 2, 5, 124, 4, 3, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-04-28' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-07' AS date), 1029, 3088, 13426, 13427, 13427, 13426, 13426, 13426, 13426, 2455321, 55320, N'2010-05-04', 201018, 18, 2, N'2010-W18', N'2010-W18-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93991, CAST(N'2010-05-05' AS date), CAST(N'2010-05-06' AS date), 2010, 20102, 201005, 2010125, 2, 5, 125, 5, 4, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-04-29' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-07' AS date), 1029, 3088, 13426, 13427, 13427, 13427, 13426, 13426, 13426, 2455322, 55321, N'2010-05-05', 201018, 18, 3, N'2010-W18', N'2010-W18-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93992, CAST(N'2010-05-06' AS date), CAST(N'2010-05-07' AS date), 2010, 20102, 201005, 2010126, 2, 5, 126, 6, 5, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-04-30' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-07' AS date), 1029, 3088, 13426, 13427, 13427, 13427, 13427, 13426, 13426, 2455323, 55322, N'2010-05-06', 201018, 18, 4, N'2010-W18', N'2010-W18-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93993, CAST(N'2010-05-07' AS date), CAST(N'2010-05-08' AS date), 2010, 20102, 201005, 2010127, 2, 5, 127, 7, 6, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-07' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-07' AS date), 1029, 3088, 13426, 13427, 13427, 13427, 13427, 13427, 13426, 2455324, 55323, N'2010-05-07', 201018, 18, 5, N'2010-W18', N'2010-W18-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93994, CAST(N'2010-05-08' AS date), CAST(N'2010-05-09' AS date), 2010, 20102, 201005, 2010128, 2, 5, 128, 8, 7, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-02' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-07' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-14' AS date), 1029, 3088, 13426, 13427, 13427, 13427, 13427, 13427, 13427, 2455325, 55324, N'2010-05-08', 201018, 18, 6, N'2010-W18', N'2010-W18-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93995, CAST(N'2010-05-09' AS date), CAST(N'2010-05-10' AS date), 2010, 20102, 201005, 2010129, 2, 5, 129, 9, 1, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-03' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-07' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-14' AS date), 1029, 3088, 13427, 13427, 13427, 13427, 13427, 13427, 13427, 2455326, 55325, N'2010-05-09', 201018, 18, 7, N'2010-W18', N'2010-W18-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93996, CAST(N'2010-05-10' AS date), CAST(N'2010-05-11' AS date), 2010, 20102, 201005, 2010130, 2, 5, 130, 10, 2, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-04' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-07' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-14' AS date), 1029, 3088, 13427, 13428, 13427, 13427, 13427, 13427, 13427, 2455327, 55326, N'2010-05-10', 201019, 19, 1, N'2010-W19', N'2010-W19-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93997, CAST(N'2010-05-11' AS date), CAST(N'2010-05-12' AS date), 2010, 20102, 201005, 2010131, 2, 5, 131, 11, 3, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-05' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-07' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-14' AS date), 1029, 3088, 13427, 13428, 13428, 13427, 13427, 13427, 13427, 2455328, 55327, N'2010-05-11', 201019, 19, 2, N'2010-W19', N'2010-W19-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93998, CAST(N'2010-05-12' AS date), CAST(N'2010-05-13' AS date), 2010, 20102, 201005, 2010132, 2, 5, 132, 12, 4, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-06' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-07' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-14' AS date), 1029, 3088, 13427, 13428, 13428, 13428, 13427, 13427, 13427, 2455329, 55328, N'2010-05-12', 201019, 19, 3, N'2010-W19', N'2010-W19-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (93999, CAST(N'2010-05-13' AS date), CAST(N'2010-05-14' AS date), 2010, 20102, 201005, 2010133, 2, 5, 133, 13, 5, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-07' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-14' AS date), 1029, 3088, 13427, 13428, 13428, 13428, 13428, 13427, 13427, 2455330, 55329, N'2010-05-13', 201019, 19, 4, N'2010-W19', N'2010-W19-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94000, CAST(N'2010-05-14' AS date), CAST(N'2010-05-15' AS date), 2010, 20102, 201005, 2010134, 2, 5, 134, 14, 6, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-14' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-08' AS date), CAST(N'2010-05-14' AS date), 1029, 3088, 13427, 13428, 13428, 13428, 13428, 13428, 13427, 2455331, 55330, N'2010-05-14', 201019, 19, 5, N'2010-W19', N'2010-W19-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94001, CAST(N'2010-05-15' AS date), CAST(N'2010-05-16' AS date), 2010, 20102, 201005, 2010135, 2, 5, 135, 15, 7, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-09' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-14' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-21' AS date), 1029, 3088, 13427, 13428, 13428, 13428, 13428, 13428, 13428, 2455332, 55331, N'2010-05-15', 201019, 19, 6, N'2010-W19', N'2010-W19-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94002, CAST(N'2010-05-16' AS date), CAST(N'2010-05-17' AS date), 2010, 20102, 201005, 2010136, 2, 5, 136, 16, 1, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-10' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-14' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-21' AS date), 1029, 3088, 13428, 13428, 13428, 13428, 13428, 13428, 13428, 2455333, 55332, N'2010-05-16', 201019, 19, 7, N'2010-W19', N'2010-W19-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94003, CAST(N'2010-05-17' AS date), CAST(N'2010-05-18' AS date), 2010, 20102, 201005, 2010137, 2, 5, 137, 17, 2, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-11' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-14' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-21' AS date), 1029, 3088, 13428, 13429, 13428, 13428, 13428, 13428, 13428, 2455334, 55333, N'2010-05-17', 201020, 20, 1, N'2010-W20', N'2010-W20-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94004, CAST(N'2010-05-18' AS date), CAST(N'2010-05-19' AS date), 2010, 20102, 201005, 2010138, 2, 5, 138, 18, 3, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-12' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-14' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-21' AS date), 1029, 3088, 13428, 13429, 13429, 13428, 13428, 13428, 13428, 2455335, 55334, N'2010-05-18', 201020, 20, 2, N'2010-W20', N'2010-W20-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94005, CAST(N'2010-05-19' AS date), CAST(N'2010-05-20' AS date), 2010, 20102, 201005, 2010139, 2, 5, 139, 19, 4, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-13' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-14' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-21' AS date), 1029, 3088, 13428, 13429, 13429, 13429, 13428, 13428, 13428, 2455336, 55335, N'2010-05-19', 201020, 20, 3, N'2010-W20', N'2010-W20-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94006, CAST(N'2010-05-20' AS date), CAST(N'2010-05-21' AS date), 2010, 20102, 201005, 2010140, 2, 5, 140, 20, 5, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-05-14' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-21' AS date), 1029, 3088, 13428, 13429, 13429, 13429, 13429, 13428, 13428, 2455337, 55336, N'2010-05-20', 201020, 20, 4, N'2010-W20', N'2010-W20-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94007, CAST(N'2010-05-21' AS date), CAST(N'2010-05-22' AS date), 2010, 20102, 201005, 2010141, 2, 5, 141, 21, 6, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-05-21' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-05-15' AS date), CAST(N'2010-05-21' AS date), 1029, 3088, 13428, 13429, 13429, 13429, 13429, 13429, 13428, 2455338, 55337, N'2010-05-21', 201020, 20, 5, N'2010-W20', N'2010-W20-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94008, CAST(N'2010-05-22' AS date), CAST(N'2010-05-23' AS date), 2010, 20102, 201005, 2010142, 2, 5, 142, 22, 7, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-16' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-05-21' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-28' AS date), 1029, 3088, 13428, 13429, 13429, 13429, 13429, 13429, 13429, 2455339, 55338, N'2010-05-22', 201020, 20, 6, N'2010-W20', N'2010-W20-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94009, CAST(N'2010-05-23' AS date), CAST(N'2010-05-24' AS date), 2010, 20102, 201005, 2010143, 2, 5, 143, 23, 1, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-05-17' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-05-21' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-28' AS date), 1029, 3088, 13429, 13429, 13429, 13429, 13429, 13429, 13429, 2455340, 55339, N'2010-05-23', 201020, 20, 7, N'2010-W20', N'2010-W20-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94010, CAST(N'2010-05-24' AS date), CAST(N'2010-05-25' AS date), 2010, 20102, 201005, 2010144, 2, 5, 144, 24, 2, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-05-18' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-05-21' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-28' AS date), 1029, 3088, 13429, 13430, 13429, 13429, 13429, 13429, 13429, 2455341, 55340, N'2010-05-24', 201021, 21, 1, N'2010-W21', N'2010-W21-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94011, CAST(N'2010-05-25' AS date), CAST(N'2010-05-26' AS date), 2010, 20102, 201005, 2010145, 2, 5, 145, 25, 3, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-19' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-05-21' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-28' AS date), 1029, 3088, 13429, 13430, 13430, 13429, 13429, 13429, 13429, 2455342, 55341, N'2010-05-25', 201021, 21, 2, N'2010-W21', N'2010-W21-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94012, CAST(N'2010-05-26' AS date), CAST(N'2010-05-27' AS date), 2010, 20102, 201005, 2010146, 2, 5, 146, 26, 4, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-05-20' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-05-21' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-28' AS date), 1029, 3088, 13429, 13430, 13430, 13430, 13429, 13429, 13429, 2455343, 55342, N'2010-05-26', 201021, 21, 3, N'2010-W21', N'2010-W21-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94013, CAST(N'2010-05-27' AS date), CAST(N'2010-05-28' AS date), 2010, 20102, 201005, 2010147, 2, 5, 147, 27, 5, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-05-21' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-28' AS date), 1029, 3088, 13429, 13430, 13430, 13430, 13430, 13429, 13429, 2455344, 55343, N'2010-05-27', 201021, 21, 4, N'2010-W21', N'2010-W21-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94014, CAST(N'2010-05-28' AS date), CAST(N'2010-05-29' AS date), 2010, 20102, 201005, 2010148, 2, 5, 148, 28, 6, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-05-28' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-05-22' AS date), CAST(N'2010-05-28' AS date), 1029, 3088, 13429, 13430, 13430, 13430, 13430, 13430, 13429, 2455345, 55344, N'2010-05-28', 201021, 21, 5, N'2010-W21', N'2010-W21-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94015, CAST(N'2010-05-29' AS date), CAST(N'2010-05-30' AS date), 2010, 20102, 201005, 2010149, 2, 5, 149, 29, 7, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-23' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-05-28' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-06-04' AS date), 1029, 3088, 13429, 13430, 13430, 13430, 13430, 13430, 13430, 2455346, 55345, N'2010-05-29', 201021, 21, 6, N'2010-W21', N'2010-W21-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94016, CAST(N'2010-05-30' AS date), CAST(N'2010-05-31' AS date), 2010, 20102, 201005, 2010150, 2, 5, 150, 30, 1, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-05-24' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-05-28' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-06-04' AS date), 1029, 3088, 13430, 13430, 13430, 13430, 13430, 13430, 13430, 2455347, 55346, N'2010-05-30', 201021, 21, 7, N'2010-W21', N'2010-W21-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94017, CAST(N'2010-05-31' AS date), CAST(N'2010-06-01' AS date), 2010, 20102, 201005, 2010151, 2, 5, 151, 31, 2, N'2010', N'2010 Q2', N'2010 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-01' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-05-25' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-05-28' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-06-04' AS date), 1029, 3088, 13430, 13431, 13430, 13430, 13430, 13430, 13430, 2455348, 55347, N'2010-05-31', 201022, 22, 1, N'2010-W22', N'2010-W22-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94018, CAST(N'2010-06-01' AS date), CAST(N'2010-06-02' AS date), 2010, 20102, 201006, 2010152, 2, 6, 152, 1, 3, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-05-26' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-05-28' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-06-04' AS date), 1029, 3089, 13430, 13431, 13431, 13430, 13430, 13430, 13430, 2455349, 55348, N'2010-06-01', 201022, 22, 2, N'2010-W22', N'2010-W22-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94019, CAST(N'2010-06-02' AS date), CAST(N'2010-06-03' AS date), 2010, 20102, 201006, 2010153, 2, 6, 153, 2, 4, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-05-27' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-05-28' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-06-04' AS date), 1029, 3089, 13430, 13431, 13431, 13431, 13430, 13430, 13430, 2455350, 55349, N'2010-06-02', 201022, 22, 3, N'2010-W22', N'2010-W22-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94020, CAST(N'2010-06-03' AS date), CAST(N'2010-06-04' AS date), 2010, 20102, 201006, 2010154, 2, 6, 154, 3, 5, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-05-28' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-06-04' AS date), 1029, 3089, 13430, 13431, 13431, 13431, 13431, 13430, 13430, 2455351, 55350, N'2010-06-03', 201022, 22, 4, N'2010-W22', N'2010-W22-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94021, CAST(N'2010-06-04' AS date), CAST(N'2010-06-05' AS date), 2010, 20102, 201006, 2010155, 2, 6, 155, 4, 6, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-04' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-05-29' AS date), CAST(N'2010-06-04' AS date), 1029, 3089, 13430, 13431, 13431, 13431, 13431, 13431, 13430, 2455352, 55351, N'2010-06-04', 201022, 22, 5, N'2010-W22', N'2010-W22-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94022, CAST(N'2010-06-05' AS date), CAST(N'2010-06-06' AS date), 2010, 20102, 201006, 2010156, 2, 6, 156, 5, 7, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-05-30' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-04' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-06-11' AS date), 1029, 3089, 13430, 13431, 13431, 13431, 13431, 13431, 13431, 2455353, 55352, N'2010-06-05', 201022, 22, 6, N'2010-W22', N'2010-W22-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94023, CAST(N'2010-06-06' AS date), CAST(N'2010-06-07' AS date), 2010, 20102, 201006, 2010157, 2, 6, 157, 6, 1, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-05-31' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-04' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-06-11' AS date), 1029, 3089, 13431, 13431, 13431, 13431, 13431, 13431, 13431, 2455354, 55353, N'2010-06-06', 201022, 22, 7, N'2010-W22', N'2010-W22-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94024, CAST(N'2010-06-07' AS date), CAST(N'2010-06-08' AS date), 2010, 20102, 201006, 2010158, 2, 6, 158, 7, 2, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-04' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-06-11' AS date), 1029, 3089, 13431, 13432, 13431, 13431, 13431, 13431, 13431, 2455355, 55354, N'2010-06-07', 201023, 23, 1, N'2010-W23', N'2010-W23-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94025, CAST(N'2010-06-08' AS date), CAST(N'2010-06-09' AS date), 2010, 20102, 201006, 2010159, 2, 6, 159, 8, 3, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-02' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-04' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-06-11' AS date), 1029, 3089, 13431, 13432, 13432, 13431, 13431, 13431, 13431, 2455356, 55355, N'2010-06-08', 201023, 23, 2, N'2010-W23', N'2010-W23-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94026, CAST(N'2010-06-09' AS date), CAST(N'2010-06-10' AS date), 2010, 20102, 201006, 2010160, 2, 6, 160, 9, 4, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-03' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-04' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-06-11' AS date), 1029, 3089, 13431, 13432, 13432, 13432, 13431, 13431, 13431, 2455357, 55356, N'2010-06-09', 201023, 23, 3, N'2010-W23', N'2010-W23-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94027, CAST(N'2010-06-10' AS date), CAST(N'2010-06-11' AS date), 2010, 20102, 201006, 2010161, 2, 6, 161, 10, 5, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-04' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-06-11' AS date), 1029, 3089, 13431, 13432, 13432, 13432, 13432, 13431, 13431, 2455358, 55357, N'2010-06-10', 201023, 23, 4, N'2010-W23', N'2010-W23-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94028, CAST(N'2010-06-11' AS date), CAST(N'2010-06-12' AS date), 2010, 20102, 201006, 2010162, 2, 6, 162, 11, 6, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-11' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-05' AS date), CAST(N'2010-06-11' AS date), 1029, 3089, 13431, 13432, 13432, 13432, 13432, 13432, 13431, 2455359, 55358, N'2010-06-11', 201023, 23, 5, N'2010-W23', N'2010-W23-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94029, CAST(N'2010-06-12' AS date), CAST(N'2010-06-13' AS date), 2010, 20102, 201006, 2010163, 2, 6, 163, 12, 7, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-06' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-11' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-18' AS date), 1029, 3089, 13431, 13432, 13432, 13432, 13432, 13432, 13432, 2455360, 55359, N'2010-06-12', 201023, 23, 6, N'2010-W23', N'2010-W23-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94030, CAST(N'2010-06-13' AS date), CAST(N'2010-06-14' AS date), 2010, 20102, 201006, 2010164, 2, 6, 164, 13, 1, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-07' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-11' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-18' AS date), 1029, 3089, 13432, 13432, 13432, 13432, 13432, 13432, 13432, 2455361, 55360, N'2010-06-13', 201023, 23, 7, N'2010-W23', N'2010-W23-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94031, CAST(N'2010-06-14' AS date), CAST(N'2010-06-15' AS date), 2010, 20102, 201006, 2010165, 2, 6, 165, 14, 2, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-08' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-11' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-18' AS date), 1029, 3089, 13432, 13433, 13432, 13432, 13432, 13432, 13432, 2455362, 55361, N'2010-06-14', 201024, 24, 1, N'2010-W24', N'2010-W24-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94032, CAST(N'2010-06-15' AS date), CAST(N'2010-06-16' AS date), 2010, 20102, 201006, 2010166, 2, 6, 166, 15, 3, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-09' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-11' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-18' AS date), 1029, 3089, 13432, 13433, 13433, 13432, 13432, 13432, 13432, 2455363, 55362, N'2010-06-15', 201024, 24, 2, N'2010-W24', N'2010-W24-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94033, CAST(N'2010-06-16' AS date), CAST(N'2010-06-17' AS date), 2010, 20102, 201006, 2010167, 2, 6, 167, 16, 4, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-10' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-11' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-18' AS date), 1029, 3089, 13432, 13433, 13433, 13433, 13432, 13432, 13432, 2455364, 55363, N'2010-06-16', 201024, 24, 3, N'2010-W24', N'2010-W24-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94034, CAST(N'2010-06-17' AS date), CAST(N'2010-06-18' AS date), 2010, 20102, 201006, 2010168, 2, 6, 168, 17, 5, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-11' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-18' AS date), 1029, 3089, 13432, 13433, 13433, 13433, 13433, 13432, 13432, 2455365, 55364, N'2010-06-17', 201024, 24, 4, N'2010-W24', N'2010-W24-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94035, CAST(N'2010-06-18' AS date), CAST(N'2010-06-19' AS date), 2010, 20102, 201006, 2010169, 2, 6, 169, 18, 6, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-18' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-12' AS date), CAST(N'2010-06-18' AS date), 1029, 3089, 13432, 13433, 13433, 13433, 13433, 13433, 13432, 2455366, 55365, N'2010-06-18', 201024, 24, 5, N'2010-W24', N'2010-W24-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94036, CAST(N'2010-06-19' AS date), CAST(N'2010-06-20' AS date), 2010, 20102, 201006, 2010170, 2, 6, 170, 19, 7, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-13' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-18' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-25' AS date), 1029, 3089, 13432, 13433, 13433, 13433, 13433, 13433, 13433, 2455367, 55366, N'2010-06-19', 201024, 24, 6, N'2010-W24', N'2010-W24-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94037, CAST(N'2010-06-20' AS date), CAST(N'2010-06-21' AS date), 2010, 20102, 201006, 2010171, 2, 6, 171, 20, 1, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-06-14' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-18' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-25' AS date), 1029, 3089, 13433, 13433, 13433, 13433, 13433, 13433, 13433, 2455368, 55367, N'2010-06-20', 201024, 24, 7, N'2010-W24', N'2010-W24-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94038, CAST(N'2010-06-21' AS date), CAST(N'2010-06-22' AS date), 2010, 20102, 201006, 2010172, 2, 6, 172, 21, 2, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-06-15' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-18' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-25' AS date), 1029, 3089, 13433, 13434, 13433, 13433, 13433, 13433, 13433, 2455369, 55368, N'2010-06-21', 201025, 25, 1, N'2010-W25', N'2010-W25-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94039, CAST(N'2010-06-22' AS date), CAST(N'2010-06-23' AS date), 2010, 20102, 201006, 2010173, 2, 6, 173, 22, 3, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-06-16' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-18' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-25' AS date), 1029, 3089, 13433, 13434, 13434, 13433, 13433, 13433, 13433, 2455370, 55369, N'2010-06-22', 201025, 25, 2, N'2010-W25', N'2010-W25-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94040, CAST(N'2010-06-23' AS date), CAST(N'2010-06-24' AS date), 2010, 20102, 201006, 2010174, 2, 6, 174, 23, 4, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-06-17' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-18' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-25' AS date), 1029, 3089, 13433, 13434, 13434, 13434, 13433, 13433, 13433, 2455371, 55370, N'2010-06-23', 201025, 25, 3, N'2010-W25', N'2010-W25-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94041, CAST(N'2010-06-24' AS date), CAST(N'2010-06-25' AS date), 2010, 20102, 201006, 2010175, 2, 6, 175, 24, 5, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-18' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-25' AS date), 1029, 3089, 13433, 13434, 13434, 13434, 13434, 13433, 13433, 2455372, 55371, N'2010-06-24', 201025, 25, 4, N'2010-W25', N'2010-W25-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94042, CAST(N'2010-06-25' AS date), CAST(N'2010-06-26' AS date), 2010, 20102, 201006, 2010176, 2, 6, 176, 25, 6, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-25' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-06-19' AS date), CAST(N'2010-06-25' AS date), 1029, 3089, 13433, 13434, 13434, 13434, 13434, 13434, 13433, 2455373, 55372, N'2010-06-25', 201025, 25, 5, N'2010-W25', N'2010-W25-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94043, CAST(N'2010-06-26' AS date), CAST(N'2010-06-27' AS date), 2010, 20102, 201006, 2010177, 2, 6, 177, 26, 7, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-20' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-25' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-07-02' AS date), 1029, 3089, 13433, 13434, 13434, 13434, 13434, 13434, 13434, 2455374, 55373, N'2010-06-26', 201025, 25, 6, N'2010-W25', N'2010-W25-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94044, CAST(N'2010-06-27' AS date), CAST(N'2010-06-28' AS date), 2010, 20102, 201006, 2010178, 2, 6, 178, 27, 1, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-06-21' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-25' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-07-02' AS date), 1029, 3089, 13434, 13434, 13434, 13434, 13434, 13434, 13434, 2455375, 55374, N'2010-06-27', 201025, 25, 7, N'2010-W25', N'2010-W25-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94045, CAST(N'2010-06-28' AS date), CAST(N'2010-06-29' AS date), 2010, 20102, 201006, 2010179, 2, 6, 179, 28, 2, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-06-22' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-25' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-07-02' AS date), 1029, 3089, 13434, 13435, 13434, 13434, 13434, 13434, 13434, 2455376, 55375, N'2010-06-28', 201026, 26, 1, N'2010-W26', N'2010-W26-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94046, CAST(N'2010-06-29' AS date), CAST(N'2010-06-30' AS date), 2010, 20102, 201006, 2010180, 2, 6, 180, 29, 3, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-06-23' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-25' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-07-02' AS date), 1029, 3089, 13434, 13435, 13435, 13434, 13434, 13434, 13434, 2455377, 55376, N'2010-06-29', 201026, 26, 2, N'2010-W26', N'2010-W26-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94047, CAST(N'2010-06-30' AS date), CAST(N'2010-07-01' AS date), 2010, 20102, 201006, 2010181, 2, 6, 181, 30, 4, N'2010', N'2010 Q2', N'2010 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-04-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-01' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-06-24' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-06-25' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-07-02' AS date), 1029, 3089, 13434, 13435, 13435, 13435, 13434, 13434, 13434, 2455378, 55377, N'2010-06-30', 201026, 26, 3, N'2010-W26', N'2010-W26-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94048, CAST(N'2010-07-01' AS date), CAST(N'2010-07-02' AS date), 2010, 20103, 201007, 2010182, 3, 7, 182, 1, 5, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-06-25' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-07-02' AS date), 1030, 3090, 13434, 13435, 13435, 13435, 13435, 13434, 13434, 2455379, 55378, N'2010-07-01', 201026, 26, 4, N'2010-W26', N'2010-W26-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94049, CAST(N'2010-07-02' AS date), CAST(N'2010-07-03' AS date), 2010, 20103, 201007, 2010183, 3, 7, 183, 2, 6, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-02' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-06-26' AS date), CAST(N'2010-07-02' AS date), 1030, 3090, 13434, 13435, 13435, 13435, 13435, 13435, 13434, 2455380, 55379, N'2010-07-02', 201026, 26, 5, N'2010-W26', N'2010-W26-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94050, CAST(N'2010-07-03' AS date), CAST(N'2010-07-04' AS date), 2010, 20103, 201007, 2010184, 3, 7, 184, 3, 7, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-06-27' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-02' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-07-09' AS date), 1030, 3090, 13434, 13435, 13435, 13435, 13435, 13435, 13435, 2455381, 55380, N'2010-07-03', 201026, 26, 6, N'2010-W26', N'2010-W26-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94051, CAST(N'2010-07-04' AS date), CAST(N'2010-07-05' AS date), 2010, 20103, 201007, 2010185, 3, 7, 185, 4, 1, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-06-28' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-02' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-07-09' AS date), 1030, 3090, 13435, 13435, 13435, 13435, 13435, 13435, 13435, 2455382, 55381, N'2010-07-04', 201026, 26, 7, N'2010-W26', N'2010-W26-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94052, CAST(N'2010-07-05' AS date), CAST(N'2010-07-06' AS date), 2010, 20103, 201007, 2010186, 3, 7, 186, 5, 2, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-06-29' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-02' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-07-09' AS date), 1030, 3090, 13435, 13436, 13435, 13435, 13435, 13435, 13435, 2455383, 55382, N'2010-07-05', 201027, 27, 1, N'2010-W27', N'2010-W27-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94053, CAST(N'2010-07-06' AS date), CAST(N'2010-07-07' AS date), 2010, 20103, 201007, 2010187, 3, 7, 187, 6, 3, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-06-30' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-02' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-07-09' AS date), 1030, 3090, 13435, 13436, 13436, 13435, 13435, 13435, 13435, 2455384, 55383, N'2010-07-06', 201027, 27, 2, N'2010-W27', N'2010-W27-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94054, CAST(N'2010-07-07' AS date), CAST(N'2010-07-08' AS date), 2010, 20103, 201007, 2010188, 3, 7, 188, 7, 4, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-02' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-07-09' AS date), 1030, 3090, 13435, 13436, 13436, 13436, 13435, 13435, 13435, 2455385, 55384, N'2010-07-07', 201027, 27, 3, N'2010-W27', N'2010-W27-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94055, CAST(N'2010-07-08' AS date), CAST(N'2010-07-09' AS date), 2010, 20103, 201007, 2010189, 3, 7, 189, 8, 5, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-02' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-07-09' AS date), 1030, 3090, 13435, 13436, 13436, 13436, 13436, 13435, 13435, 2455386, 55385, N'2010-07-08', 201027, 27, 4, N'2010-W27', N'2010-W27-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94056, CAST(N'2010-07-09' AS date), CAST(N'2010-07-10' AS date), 2010, 20103, 201007, 2010190, 3, 7, 190, 9, 6, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-09' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-03' AS date), CAST(N'2010-07-09' AS date), 1030, 3090, 13435, 13436, 13436, 13436, 13436, 13436, 13435, 2455387, 55386, N'2010-07-09', 201027, 27, 5, N'2010-W27', N'2010-W27-5');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94057, CAST(N'2010-07-10' AS date), CAST(N'2010-07-11' AS date), 2010, 20103, 201007, 2010191, 3, 7, 191, 10, 7, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-04' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-09' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-16' AS date), 1030, 3090, 13435, 13436, 13436, 13436, 13436, 13436, 13436, 2455388, 55387, N'2010-07-10', 201027, 27, 6, N'2010-W27', N'2010-W27-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94058, CAST(N'2010-07-11' AS date), CAST(N'2010-07-12' AS date), 2010, 20103, 201007, 2010192, 3, 7, 192, 11, 1, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-05' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-09' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-16' AS date), 1030, 3090, 13436, 13436, 13436, 13436, 13436, 13436, 13436, 2455389, 55388, N'2010-07-11', 201027, 27, 7, N'2010-W27', N'2010-W27-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94059, CAST(N'2010-07-12' AS date), CAST(N'2010-07-13' AS date), 2010, 20103, 201007, 2010193, 3, 7, 193, 12, 2, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-06' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-09' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-16' AS date), 1030, 3090, 13436, 13437, 13436, 13436, 13436, 13436, 13436, 2455390, 55389, N'2010-07-12', 201028, 28, 1, N'2010-W28', N'2010-W28-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94060, CAST(N'2010-07-13' AS date), CAST(N'2010-07-14' AS date), 2010, 20103, 201007, 2010194, 3, 7, 194, 13, 3, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-07' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-09' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-16' AS date), 1030, 3090, 13436, 13437, 13437, 13436, 13436, 13436, 13436, 2455391, 55390, N'2010-07-13', 201028, 28, 2, N'2010-W28', N'2010-W28-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94061, CAST(N'2010-07-14' AS date), CAST(N'2010-07-15' AS date), 2010, 20103, 201007, 2010195, 3, 7, 195, 14, 4, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-08' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-09' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-16' AS date), 1030, 3090, 13436, 13437, 13437, 13437, 13436, 13436, 13436, 2455392, 55391, N'2010-07-14', 201028, 28, 3, N'2010-W28', N'2010-W28-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94062, CAST(N'2010-07-15' AS date), CAST(N'2010-07-16' AS date), 2010, 20103, 201007, 2010196, 3, 7, 196, 15, 5, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-09' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-16' AS date), 1030, 3090, 13436, 13437, 13437, 13437, 13437, 13436, 13436, 2455393, 55392, N'2010-07-15', 201028, 28, 4, N'2010-W28', N'2010-W28-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94063, CAST(N'2010-07-16' AS date), CAST(N'2010-07-17' AS date), 2010, 20103, 201007, 2010197, 3, 7, 197, 16, 6, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-16' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-10' AS date), CAST(N'2010-07-16' AS date), 1030, 3090, 13436, 13437, 13437, 13437, 13437, 13437, 13436, 2455394, 55393, N'2010-07-16', 201028, 28, 5, N'2010-W28', N'2010-W28-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94064, CAST(N'2010-07-17' AS date), CAST(N'2010-07-18' AS date), 2010, 20103, 201007, 2010198, 3, 7, 198, 17, 7, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-11' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-16' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-23' AS date), 1030, 3090, 13436, 13437, 13437, 13437, 13437, 13437, 13437, 2455395, 55394, N'2010-07-17', 201028, 28, 6, N'2010-W28', N'2010-W28-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94065, CAST(N'2010-07-18' AS date), CAST(N'2010-07-19' AS date), 2010, 20103, 201007, 2010199, 3, 7, 199, 18, 1, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-12' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-16' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-23' AS date), 1030, 3090, 13437, 13437, 13437, 13437, 13437, 13437, 13437, 2455396, 55395, N'2010-07-18', 201028, 28, 7, N'2010-W28', N'2010-W28-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94066, CAST(N'2010-07-19' AS date), CAST(N'2010-07-20' AS date), 2010, 20103, 201007, 2010200, 3, 7, 200, 19, 2, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-13' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-16' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-23' AS date), 1030, 3090, 13437, 13438, 13437, 13437, 13437, 13437, 13437, 2455397, 55396, N'2010-07-19', 201029, 29, 1, N'2010-W29', N'2010-W29-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94067, CAST(N'2010-07-20' AS date), CAST(N'2010-07-21' AS date), 2010, 20103, 201007, 2010201, 3, 7, 201, 20, 3, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-07-14' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-16' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-23' AS date), 1030, 3090, 13437, 13438, 13438, 13437, 13437, 13437, 13437, 2455398, 55397, N'2010-07-20', 201029, 29, 2, N'2010-W29', N'2010-W29-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94068, CAST(N'2010-07-21' AS date), CAST(N'2010-07-22' AS date), 2010, 20103, 201007, 2010202, 3, 7, 202, 21, 4, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-07-15' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-16' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-23' AS date), 1030, 3090, 13437, 13438, 13438, 13438, 13437, 13437, 13437, 2455399, 55398, N'2010-07-21', 201029, 29, 3, N'2010-W29', N'2010-W29-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94069, CAST(N'2010-07-22' AS date), CAST(N'2010-07-23' AS date), 2010, 20103, 201007, 2010203, 3, 7, 203, 22, 5, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-07-16' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-23' AS date), 1030, 3090, 13437, 13438, 13438, 13438, 13438, 13437, 13437, 2455400, 55399, N'2010-07-22', 201029, 29, 4, N'2010-W29', N'2010-W29-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94070, CAST(N'2010-07-23' AS date), CAST(N'2010-07-24' AS date), 2010, 20103, 201007, 2010204, 3, 7, 204, 23, 6, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-07-23' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-07-17' AS date), CAST(N'2010-07-23' AS date), 1030, 3090, 13437, 13438, 13438, 13438, 13438, 13438, 13437, 2455401, 55400, N'2010-07-23', 201029, 29, 5, N'2010-W29', N'2010-W29-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94071, CAST(N'2010-07-24' AS date), CAST(N'2010-07-25' AS date), 2010, 20103, 201007, 2010205, 3, 7, 205, 24, 7, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-18' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-07-23' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-30' AS date), 1030, 3090, 13437, 13438, 13438, 13438, 13438, 13438, 13438, 2455402, 55401, N'2010-07-24', 201029, 29, 6, N'2010-W29', N'2010-W29-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94072, CAST(N'2010-07-25' AS date), CAST(N'2010-07-26' AS date), 2010, 20103, 201007, 2010206, 3, 7, 206, 25, 1, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-19' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-07-23' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-30' AS date), 1030, 3090, 13438, 13438, 13438, 13438, 13438, 13438, 13438, 2455403, 55402, N'2010-07-25', 201029, 29, 7, N'2010-W29', N'2010-W29-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94073, CAST(N'2010-07-26' AS date), CAST(N'2010-07-27' AS date), 2010, 20103, 201007, 2010207, 3, 7, 207, 26, 2, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-07-20' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-07-23' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-30' AS date), 1030, 3090, 13438, 13439, 13438, 13438, 13438, 13438, 13438, 2455404, 55403, N'2010-07-26', 201030, 30, 1, N'2010-W30', N'2010-W30-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94074, CAST(N'2010-07-27' AS date), CAST(N'2010-07-28' AS date), 2010, 20103, 201007, 2010208, 3, 7, 208, 27, 3, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-07-21' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-07-23' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-30' AS date), 1030, 3090, 13438, 13439, 13439, 13438, 13438, 13438, 13438, 2455405, 55404, N'2010-07-27', 201030, 30, 2, N'2010-W30', N'2010-W30-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94075, CAST(N'2010-07-28' AS date), CAST(N'2010-07-29' AS date), 2010, 20103, 201007, 2010209, 3, 7, 209, 28, 4, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-07-22' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-07-23' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-30' AS date), 1030, 3090, 13438, 13439, 13439, 13439, 13438, 13438, 13438, 2455406, 55405, N'2010-07-28', 201030, 30, 3, N'2010-W30', N'2010-W30-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94076, CAST(N'2010-07-29' AS date), CAST(N'2010-07-30' AS date), 2010, 20103, 201007, 2010210, 3, 7, 210, 29, 5, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-07-23' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-30' AS date), 1030, 3090, 13438, 13439, 13439, 13439, 13439, 13438, 13438, 2455407, 55406, N'2010-07-29', 201030, 30, 4, N'2010-W30', N'2010-W30-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94077, CAST(N'2010-07-30' AS date), CAST(N'2010-07-31' AS date), 2010, 20103, 201007, 2010211, 3, 7, 211, 30, 6, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-07-30' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-07-24' AS date), CAST(N'2010-07-30' AS date), 1030, 3090, 13438, 13439, 13439, 13439, 13439, 13439, 13438, 2455408, 55407, N'2010-07-30', 201030, 30, 5, N'2010-W30', N'2010-W30-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94078, CAST(N'2010-07-31' AS date), CAST(N'2010-08-01' AS date), 2010, 20103, 201007, 2010212, 3, 7, 212, 31, 7, N'2010', N'2010 Q3', N'2010 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-25' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-07-30' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-08-06' AS date), 1030, 3090, 13438, 13439, 13439, 13439, 13439, 13439, 13439, 2455409, 55408, N'2010-07-31', 201030, 30, 6, N'2010-W30', N'2010-W30-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94079, CAST(N'2010-08-01' AS date), CAST(N'2010-08-02' AS date), 2010, 20103, 201008, 2010213, 3, 8, 213, 1, 1, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-07-26' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-07-30' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-08-06' AS date), 1030, 3091, 13439, 13439, 13439, 13439, 13439, 13439, 13439, 2455410, 55409, N'2010-08-01', 201030, 30, 7, N'2010-W30', N'2010-W30-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94080, CAST(N'2010-08-02' AS date), CAST(N'2010-08-03' AS date), 2010, 20103, 201008, 2010214, 3, 8, 214, 2, 2, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-07-27' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-07-30' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-08-06' AS date), 1030, 3091, 13439, 13440, 13439, 13439, 13439, 13439, 13439, 2455411, 55410, N'2010-08-02', 201031, 31, 1, N'2010-W31', N'2010-W31-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94081, CAST(N'2010-08-03' AS date), CAST(N'2010-08-04' AS date), 2010, 20103, 201008, 2010215, 3, 8, 215, 3, 3, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-07-28' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-07-30' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-08-06' AS date), 1030, 3091, 13439, 13440, 13440, 13439, 13439, 13439, 13439, 2455412, 55411, N'2010-08-03', 201031, 31, 2, N'2010-W31', N'2010-W31-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94082, CAST(N'2010-08-04' AS date), CAST(N'2010-08-05' AS date), 2010, 20103, 201008, 2010216, 3, 8, 216, 4, 4, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-07-29' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-07-30' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-08-06' AS date), 1030, 3091, 13439, 13440, 13440, 13440, 13439, 13439, 13439, 2455413, 55412, N'2010-08-04', 201031, 31, 3, N'2010-W31', N'2010-W31-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94083, CAST(N'2010-08-05' AS date), CAST(N'2010-08-06' AS date), 2010, 20103, 201008, 2010217, 3, 8, 217, 5, 5, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-07-30' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-08-06' AS date), 1030, 3091, 13439, 13440, 13440, 13440, 13440, 13439, 13439, 2455414, 55413, N'2010-08-05', 201031, 31, 4, N'2010-W31', N'2010-W31-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94084, CAST(N'2010-08-06' AS date), CAST(N'2010-08-07' AS date), 2010, 20103, 201008, 2010218, 3, 8, 218, 6, 6, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-06' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-07-31' AS date), CAST(N'2010-08-06' AS date), 1030, 3091, 13439, 13440, 13440, 13440, 13440, 13440, 13439, 2455415, 55414, N'2010-08-06', 201031, 31, 5, N'2010-W31', N'2010-W31-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94085, CAST(N'2010-08-07' AS date), CAST(N'2010-08-08' AS date), 2010, 20103, 201008, 2010219, 3, 8, 219, 7, 7, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-06' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-13' AS date), 1030, 3091, 13439, 13440, 13440, 13440, 13440, 13440, 13440, 2455416, 55415, N'2010-08-07', 201031, 31, 6, N'2010-W31', N'2010-W31-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94086, CAST(N'2010-08-08' AS date), CAST(N'2010-08-09' AS date), 2010, 20103, 201008, 2010220, 3, 8, 220, 8, 1, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-02' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-06' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-13' AS date), 1030, 3091, 13440, 13440, 13440, 13440, 13440, 13440, 13440, 2455417, 55416, N'2010-08-08', 201031, 31, 7, N'2010-W31', N'2010-W31-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94087, CAST(N'2010-08-09' AS date), CAST(N'2010-08-10' AS date), 2010, 20103, 201008, 2010221, 3, 8, 221, 9, 2, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-03' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-06' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-13' AS date), 1030, 3091, 13440, 13441, 13440, 13440, 13440, 13440, 13440, 2455418, 55417, N'2010-08-09', 201032, 32, 1, N'2010-W32', N'2010-W32-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94088, CAST(N'2010-08-10' AS date), CAST(N'2010-08-11' AS date), 2010, 20103, 201008, 2010222, 3, 8, 222, 10, 3, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-04' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-06' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-13' AS date), 1030, 3091, 13440, 13441, 13441, 13440, 13440, 13440, 13440, 2455419, 55418, N'2010-08-10', 201032, 32, 2, N'2010-W32', N'2010-W32-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94089, CAST(N'2010-08-11' AS date), CAST(N'2010-08-12' AS date), 2010, 20103, 201008, 2010223, 3, 8, 223, 11, 4, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-05' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-06' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-13' AS date), 1030, 3091, 13440, 13441, 13441, 13441, 13440, 13440, 13440, 2455420, 55419, N'2010-08-11', 201032, 32, 3, N'2010-W32', N'2010-W32-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94090, CAST(N'2010-08-12' AS date), CAST(N'2010-08-13' AS date), 2010, 20103, 201008, 2010224, 3, 8, 224, 12, 5, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-06' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-13' AS date), 1030, 3091, 13440, 13441, 13441, 13441, 13441, 13440, 13440, 2455421, 55420, N'2010-08-12', 201032, 32, 4, N'2010-W32', N'2010-W32-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94091, CAST(N'2010-08-13' AS date), CAST(N'2010-08-14' AS date), 2010, 20103, 201008, 2010225, 3, 8, 225, 13, 6, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-13' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-07' AS date), CAST(N'2010-08-13' AS date), 1030, 3091, 13440, 13441, 13441, 13441, 13441, 13441, 13440, 2455422, 55421, N'2010-08-13', 201032, 32, 5, N'2010-W32', N'2010-W32-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94092, CAST(N'2010-08-14' AS date), CAST(N'2010-08-15' AS date), 2010, 20103, 201008, 2010226, 3, 8, 226, 14, 7, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-08' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-13' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-20' AS date), 1030, 3091, 13440, 13441, 13441, 13441, 13441, 13441, 13441, 2455423, 55422, N'2010-08-14', 201032, 32, 6, N'2010-W32', N'2010-W32-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94093, CAST(N'2010-08-15' AS date), CAST(N'2010-08-16' AS date), 2010, 20103, 201008, 2010227, 3, 8, 227, 15, 1, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-09' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-13' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-20' AS date), 1030, 3091, 13441, 13441, 13441, 13441, 13441, 13441, 13441, 2455424, 55423, N'2010-08-15', 201032, 32, 7, N'2010-W32', N'2010-W32-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94094, CAST(N'2010-08-16' AS date), CAST(N'2010-08-17' AS date), 2010, 20103, 201008, 2010228, 3, 8, 228, 16, 2, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-10' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-13' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-20' AS date), 1030, 3091, 13441, 13442, 13441, 13441, 13441, 13441, 13441, 2455425, 55424, N'2010-08-16', 201033, 33, 1, N'2010-W33', N'2010-W33-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94095, CAST(N'2010-08-17' AS date), CAST(N'2010-08-18' AS date), 2010, 20103, 201008, 2010229, 3, 8, 229, 17, 3, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-11' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-13' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-20' AS date), 1030, 3091, 13441, 13442, 13442, 13441, 13441, 13441, 13441, 2455426, 55425, N'2010-08-17', 201033, 33, 2, N'2010-W33', N'2010-W33-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94096, CAST(N'2010-08-18' AS date), CAST(N'2010-08-19' AS date), 2010, 20103, 201008, 2010230, 3, 8, 230, 18, 4, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-12' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-13' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-20' AS date), 1030, 3091, 13441, 13442, 13442, 13442, 13441, 13441, 13441, 2455427, 55426, N'2010-08-18', 201033, 33, 3, N'2010-W33', N'2010-W33-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94097, CAST(N'2010-08-19' AS date), CAST(N'2010-08-20' AS date), 2010, 20103, 201008, 2010231, 3, 8, 231, 19, 5, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-13' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-20' AS date), 1030, 3091, 13441, 13442, 13442, 13442, 13442, 13441, 13441, 2455428, 55427, N'2010-08-19', 201033, 33, 4, N'2010-W33', N'2010-W33-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94098, CAST(N'2010-08-20' AS date), CAST(N'2010-08-21' AS date), 2010, 20103, 201008, 2010232, 3, 8, 232, 20, 6, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-20' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-08-14' AS date), CAST(N'2010-08-20' AS date), 1030, 3091, 13441, 13442, 13442, 13442, 13442, 13442, 13441, 2455429, 55428, N'2010-08-20', 201033, 33, 5, N'2010-W33', N'2010-W33-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94099, CAST(N'2010-08-21' AS date), CAST(N'2010-08-22' AS date), 2010, 20103, 201008, 2010233, 3, 8, 233, 21, 7, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-15' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-20' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-27' AS date), 1030, 3091, 13441, 13442, 13442, 13442, 13442, 13442, 13442, 2455430, 55429, N'2010-08-21', 201033, 33, 6, N'2010-W33', N'2010-W33-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94100, CAST(N'2010-08-22' AS date), CAST(N'2010-08-23' AS date), 2010, 20103, 201008, 2010234, 3, 8, 234, 22, 1, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-08-16' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-20' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-27' AS date), 1030, 3091, 13442, 13442, 13442, 13442, 13442, 13442, 13442, 2455431, 55430, N'2010-08-22', 201033, 33, 7, N'2010-W33', N'2010-W33-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94101, CAST(N'2010-08-23' AS date), CAST(N'2010-08-24' AS date), 2010, 20103, 201008, 2010235, 3, 8, 235, 23, 2, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-08-17' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-20' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-27' AS date), 1030, 3091, 13442, 13443, 13442, 13442, 13442, 13442, 13442, 2455432, 55431, N'2010-08-23', 201034, 34, 1, N'2010-W34', N'2010-W34-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94102, CAST(N'2010-08-24' AS date), CAST(N'2010-08-25' AS date), 2010, 20103, 201008, 2010236, 3, 8, 236, 24, 3, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-08-18' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-20' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-27' AS date), 1030, 3091, 13442, 13443, 13443, 13442, 13442, 13442, 13442, 2455433, 55432, N'2010-08-24', 201034, 34, 2, N'2010-W34', N'2010-W34-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94103, CAST(N'2010-08-25' AS date), CAST(N'2010-08-26' AS date), 2010, 20103, 201008, 2010237, 3, 8, 237, 25, 4, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-19' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-20' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-27' AS date), 1030, 3091, 13442, 13443, 13443, 13443, 13442, 13442, 13442, 2455434, 55433, N'2010-08-25', 201034, 34, 3, N'2010-W34', N'2010-W34-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94104, CAST(N'2010-08-26' AS date), CAST(N'2010-08-27' AS date), 2010, 20103, 201008, 2010238, 3, 8, 238, 26, 5, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-08-20' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-27' AS date), 1030, 3091, 13442, 13443, 13443, 13443, 13443, 13442, 13442, 2455435, 55434, N'2010-08-26', 201034, 34, 4, N'2010-W34', N'2010-W34-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94105, CAST(N'2010-08-27' AS date), CAST(N'2010-08-28' AS date), 2010, 20103, 201008, 2010239, 3, 8, 239, 27, 6, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-08-27' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-08-21' AS date), CAST(N'2010-08-27' AS date), 1030, 3091, 13442, 13443, 13443, 13443, 13443, 13443, 13442, 2455436, 55435, N'2010-08-27', 201034, 34, 5, N'2010-W34', N'2010-W34-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94106, CAST(N'2010-08-28' AS date), CAST(N'2010-08-29' AS date), 2010, 20103, 201008, 2010240, 3, 8, 240, 28, 7, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-22' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-08-27' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-09-03' AS date), 1030, 3091, 13442, 13443, 13443, 13443, 13443, 13443, 13443, 2455437, 55436, N'2010-08-28', 201034, 34, 6, N'2010-W34', N'2010-W34-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94107, CAST(N'2010-08-29' AS date), CAST(N'2010-08-30' AS date), 2010, 20103, 201008, 2010241, 3, 8, 241, 29, 1, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-08-23' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-08-27' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-09-03' AS date), 1030, 3091, 13443, 13443, 13443, 13443, 13443, 13443, 13443, 2455438, 55437, N'2010-08-29', 201034, 34, 7, N'2010-W34', N'2010-W34-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94108, CAST(N'2010-08-30' AS date), CAST(N'2010-08-31' AS date), 2010, 20103, 201008, 2010242, 3, 8, 242, 30, 2, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-08-24' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-08-27' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-09-03' AS date), 1030, 3091, 13443, 13444, 13443, 13443, 13443, 13443, 13443, 2455439, 55438, N'2010-08-30', 201035, 35, 1, N'2010-W35', N'2010-W35-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94109, CAST(N'2010-08-31' AS date), CAST(N'2010-09-01' AS date), 2010, 20103, 201008, 2010243, 3, 8, 243, 31, 3, N'2010', N'2010 Q3', N'2010 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-01' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-08-25' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-08-27' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-09-03' AS date), 1030, 3091, 13443, 13444, 13444, 13443, 13443, 13443, 13443, 2455440, 55439, N'2010-08-31', 201035, 35, 2, N'2010-W35', N'2010-W35-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94110, CAST(N'2010-09-01' AS date), CAST(N'2010-09-02' AS date), 2010, 20103, 201009, 2010244, 3, 9, 244, 1, 4, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-08-26' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-08-27' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-09-03' AS date), 1030, 3092, 13443, 13444, 13444, 13444, 13443, 13443, 13443, 2455441, 55440, N'2010-09-01', 201035, 35, 3, N'2010-W35', N'2010-W35-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94111, CAST(N'2010-09-02' AS date), CAST(N'2010-09-03' AS date), 2010, 20103, 201009, 2010245, 3, 9, 245, 2, 5, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-08-27' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-09-03' AS date), 1030, 3092, 13443, 13444, 13444, 13444, 13444, 13443, 13443, 2455442, 55441, N'2010-09-02', 201035, 35, 4, N'2010-W35', N'2010-W35-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94112, CAST(N'2010-09-03' AS date), CAST(N'2010-09-04' AS date), 2010, 20103, 201009, 2010246, 3, 9, 246, 3, 6, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-03' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-08-28' AS date), CAST(N'2010-09-03' AS date), 1030, 3092, 13443, 13444, 13444, 13444, 13444, 13444, 13443, 2455443, 55442, N'2010-09-03', 201035, 35, 5, N'2010-W35', N'2010-W35-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94113, CAST(N'2010-09-04' AS date), CAST(N'2010-09-05' AS date), 2010, 20103, 201009, 2010247, 3, 9, 247, 4, 7, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-08-29' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-03' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-09-10' AS date), 1030, 3092, 13443, 13444, 13444, 13444, 13444, 13444, 13444, 2455444, 55443, N'2010-09-04', 201035, 35, 6, N'2010-W35', N'2010-W35-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94114, CAST(N'2010-09-05' AS date), CAST(N'2010-09-06' AS date), 2010, 20103, 201009, 2010248, 3, 9, 248, 5, 1, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-08-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-03' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-09-10' AS date), 1030, 3092, 13444, 13444, 13444, 13444, 13444, 13444, 13444, 2455445, 55444, N'2010-09-05', 201035, 35, 7, N'2010-W35', N'2010-W35-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94115, CAST(N'2010-09-06' AS date), CAST(N'2010-09-07' AS date), 2010, 20103, 201009, 2010249, 3, 9, 249, 6, 2, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-08-31' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-03' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-09-10' AS date), 1030, 3092, 13444, 13445, 13444, 13444, 13444, 13444, 13444, 2455446, 55445, N'2010-09-06', 201036, 36, 1, N'2010-W36', N'2010-W36-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94116, CAST(N'2010-09-07' AS date), CAST(N'2010-09-08' AS date), 2010, 20103, 201009, 2010250, 3, 9, 250, 7, 3, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-03' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-09-10' AS date), 1030, 3092, 13444, 13445, 13445, 13444, 13444, 13444, 13444, 2455447, 55446, N'2010-09-07', 201036, 36, 2, N'2010-W36', N'2010-W36-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94117, CAST(N'2010-09-08' AS date), CAST(N'2010-09-09' AS date), 2010, 20103, 201009, 2010251, 3, 9, 251, 8, 4, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-02' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-03' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-09-10' AS date), 1030, 3092, 13444, 13445, 13445, 13445, 13444, 13444, 13444, 2455448, 55447, N'2010-09-08', 201036, 36, 3, N'2010-W36', N'2010-W36-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94118, CAST(N'2010-09-09' AS date), CAST(N'2010-09-10' AS date), 2010, 20103, 201009, 2010252, 3, 9, 252, 9, 5, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-03' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-09-10' AS date), 1030, 3092, 13444, 13445, 13445, 13445, 13445, 13444, 13444, 2455449, 55448, N'2010-09-09', 201036, 36, 4, N'2010-W36', N'2010-W36-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94119, CAST(N'2010-09-10' AS date), CAST(N'2010-09-11' AS date), 2010, 20103, 201009, 2010253, 3, 9, 253, 10, 6, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-10' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-04' AS date), CAST(N'2010-09-10' AS date), 1030, 3092, 13444, 13445, 13445, 13445, 13445, 13445, 13444, 2455450, 55449, N'2010-09-10', 201036, 36, 5, N'2010-W36', N'2010-W36-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94120, CAST(N'2010-09-11' AS date), CAST(N'2010-09-12' AS date), 2010, 20103, 201009, 2010254, 3, 9, 254, 11, 7, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-05' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-10' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-17' AS date), 1030, 3092, 13444, 13445, 13445, 13445, 13445, 13445, 13445, 2455451, 55450, N'2010-09-11', 201036, 36, 6, N'2010-W36', N'2010-W36-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94121, CAST(N'2010-09-12' AS date), CAST(N'2010-09-13' AS date), 2010, 20103, 201009, 2010255, 3, 9, 255, 12, 1, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-06' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-10' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-17' AS date), 1030, 3092, 13445, 13445, 13445, 13445, 13445, 13445, 13445, 2455452, 55451, N'2010-09-12', 201036, 36, 7, N'2010-W36', N'2010-W36-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94122, CAST(N'2010-09-13' AS date), CAST(N'2010-09-14' AS date), 2010, 20103, 201009, 2010256, 3, 9, 256, 13, 2, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-07' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-10' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-17' AS date), 1030, 3092, 13445, 13446, 13445, 13445, 13445, 13445, 13445, 2455453, 55452, N'2010-09-13', 201037, 37, 1, N'2010-W37', N'2010-W37-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94123, CAST(N'2010-09-14' AS date), CAST(N'2010-09-15' AS date), 2010, 20103, 201009, 2010257, 3, 9, 257, 14, 3, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-08' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-10' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-17' AS date), 1030, 3092, 13445, 13446, 13446, 13445, 13445, 13445, 13445, 2455454, 55453, N'2010-09-14', 201037, 37, 2, N'2010-W37', N'2010-W37-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94124, CAST(N'2010-09-15' AS date), CAST(N'2010-09-16' AS date), 2010, 20103, 201009, 2010258, 3, 9, 258, 15, 4, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-09' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-10' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-17' AS date), 1030, 3092, 13445, 13446, 13446, 13446, 13445, 13445, 13445, 2455455, 55454, N'2010-09-15', 201037, 37, 3, N'2010-W37', N'2010-W37-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94125, CAST(N'2010-09-16' AS date), CAST(N'2010-09-17' AS date), 2010, 20103, 201009, 2010259, 3, 9, 259, 16, 5, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-10' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-17' AS date), 1030, 3092, 13445, 13446, 13446, 13446, 13446, 13445, 13445, 2455456, 55455, N'2010-09-16', 201037, 37, 4, N'2010-W37', N'2010-W37-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94126, CAST(N'2010-09-17' AS date), CAST(N'2010-09-18' AS date), 2010, 20103, 201009, 2010260, 3, 9, 260, 17, 6, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-17' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-11' AS date), CAST(N'2010-09-17' AS date), 1030, 3092, 13445, 13446, 13446, 13446, 13446, 13446, 13445, 2455457, 55456, N'2010-09-17', 201037, 37, 5, N'2010-W37', N'2010-W37-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94127, CAST(N'2010-09-18' AS date), CAST(N'2010-09-19' AS date), 2010, 20103, 201009, 2010261, 3, 9, 261, 18, 7, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-12' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-17' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-24' AS date), 1030, 3092, 13445, 13446, 13446, 13446, 13446, 13446, 13446, 2455458, 55457, N'2010-09-18', 201037, 37, 6, N'2010-W37', N'2010-W37-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94128, CAST(N'2010-09-19' AS date), CAST(N'2010-09-20' AS date), 2010, 20103, 201009, 2010262, 3, 9, 262, 19, 1, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-09-13' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-17' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-24' AS date), 1030, 3092, 13446, 13446, 13446, 13446, 13446, 13446, 13446, 2455459, 55458, N'2010-09-19', 201037, 37, 7, N'2010-W37', N'2010-W37-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94129, CAST(N'2010-09-20' AS date), CAST(N'2010-09-21' AS date), 2010, 20103, 201009, 2010263, 3, 9, 263, 20, 2, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-09-14' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-17' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-24' AS date), 1030, 3092, 13446, 13447, 13446, 13446, 13446, 13446, 13446, 2455460, 55459, N'2010-09-20', 201038, 38, 1, N'2010-W38', N'2010-W38-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94130, CAST(N'2010-09-21' AS date), CAST(N'2010-09-22' AS date), 2010, 20103, 201009, 2010264, 3, 9, 264, 21, 3, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-09-15' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-17' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-24' AS date), 1030, 3092, 13446, 13447, 13447, 13446, 13446, 13446, 13446, 2455461, 55460, N'2010-09-21', 201038, 38, 2, N'2010-W38', N'2010-W38-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94131, CAST(N'2010-09-22' AS date), CAST(N'2010-09-23' AS date), 2010, 20103, 201009, 2010265, 3, 9, 265, 22, 4, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-09-16' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-17' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-24' AS date), 1030, 3092, 13446, 13447, 13447, 13447, 13446, 13446, 13446, 2455462, 55461, N'2010-09-22', 201038, 38, 3, N'2010-W38', N'2010-W38-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94132, CAST(N'2010-09-23' AS date), CAST(N'2010-09-24' AS date), 2010, 20103, 201009, 2010266, 3, 9, 266, 23, 5, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-09-17' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-24' AS date), 1030, 3092, 13446, 13447, 13447, 13447, 13447, 13446, 13446, 2455463, 55462, N'2010-09-23', 201038, 38, 4, N'2010-W38', N'2010-W38-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94133, CAST(N'2010-09-24' AS date), CAST(N'2010-09-25' AS date), 2010, 20103, 201009, 2010267, 3, 9, 267, 24, 6, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-09-24' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-18' AS date), CAST(N'2010-09-24' AS date), 1030, 3092, 13446, 13447, 13447, 13447, 13447, 13447, 13446, 2455464, 55463, N'2010-09-24', 201038, 38, 5, N'2010-W38', N'2010-W38-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94134, CAST(N'2010-09-25' AS date), CAST(N'2010-09-26' AS date), 2010, 20103, 201009, 2010268, 3, 9, 268, 25, 7, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-19' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-09-24' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-10-01' AS date), 1030, 3092, 13446, 13447, 13447, 13447, 13447, 13447, 13447, 2455465, 55464, N'2010-09-25', 201038, 38, 6, N'2010-W38', N'2010-W38-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94135, CAST(N'2010-09-26' AS date), CAST(N'2010-09-27' AS date), 2010, 20103, 201009, 2010269, 3, 9, 269, 26, 1, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-09-20' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-09-24' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-10-01' AS date), 1030, 3092, 13447, 13447, 13447, 13447, 13447, 13447, 13447, 2455466, 55465, N'2010-09-26', 201038, 38, 7, N'2010-W38', N'2010-W38-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94136, CAST(N'2010-09-27' AS date), CAST(N'2010-09-28' AS date), 2010, 20103, 201009, 2010270, 3, 9, 270, 27, 2, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-09-21' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-09-24' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-10-01' AS date), 1030, 3092, 13447, 13448, 13447, 13447, 13447, 13447, 13447, 2455467, 55466, N'2010-09-27', 201039, 39, 1, N'2010-W39', N'2010-W39-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94137, CAST(N'2010-09-28' AS date), CAST(N'2010-09-29' AS date), 2010, 20103, 201009, 2010271, 3, 9, 271, 28, 3, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-09-22' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-09-24' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-10-01' AS date), 1030, 3092, 13447, 13448, 13448, 13447, 13447, 13447, 13447, 2455468, 55467, N'2010-09-28', 201039, 39, 2, N'2010-W39', N'2010-W39-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94138, CAST(N'2010-09-29' AS date), CAST(N'2010-09-30' AS date), 2010, 20103, 201009, 2010272, 3, 9, 272, 29, 4, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-09-23' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-09-24' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-10-01' AS date), 1030, 3092, 13447, 13448, 13448, 13448, 13447, 13447, 13447, 2455469, 55468, N'2010-09-29', 201039, 39, 3, N'2010-W39', N'2010-W39-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94139, CAST(N'2010-09-30' AS date), CAST(N'2010-10-01' AS date), 2010, 20103, 201009, 2010273, 3, 9, 273, 30, 5, N'2010', N'2010 Q3', N'2010 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-07-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-01' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-09-24' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-10-01' AS date), 1030, 3092, 13447, 13448, 13448, 13448, 13448, 13447, 13447, 2455470, 55469, N'2010-09-30', 201039, 39, 4, N'2010-W39', N'2010-W39-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94140, CAST(N'2010-10-01' AS date), CAST(N'2010-10-02' AS date), 2010, 20104, 201010, 2010274, 4, 10, 274, 1, 6, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-09-25' AS date), CAST(N'2010-10-01' AS date), 1031, 3093, 13447, 13448, 13448, 13448, 13448, 13448, 13447, 2455471, 55470, N'2010-10-01', 201039, 39, 5, N'2010-W39', N'2010-W39-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94141, CAST(N'2010-10-02' AS date), CAST(N'2010-10-03' AS date), 2010, 20104, 201010, 2010275, 4, 10, 275, 2, 7, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-09-26' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-10-08' AS date), 1031, 3093, 13447, 13448, 13448, 13448, 13448, 13448, 13448, 2455472, 55471, N'2010-10-02', 201039, 39, 6, N'2010-W39', N'2010-W39-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94142, CAST(N'2010-10-03' AS date), CAST(N'2010-10-04' AS date), 2010, 20104, 201010, 2010276, 4, 10, 276, 3, 1, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-09-27' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-10-08' AS date), 1031, 3093, 13448, 13448, 13448, 13448, 13448, 13448, 13448, 2455473, 55472, N'2010-10-03', 201039, 39, 7, N'2010-W39', N'2010-W39-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94143, CAST(N'2010-10-04' AS date), CAST(N'2010-10-05' AS date), 2010, 20104, 201010, 2010277, 4, 10, 277, 4, 2, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-09-28' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-10-08' AS date), 1031, 3093, 13448, 13449, 13448, 13448, 13448, 13448, 13448, 2455474, 55473, N'2010-10-04', 201040, 40, 1, N'2010-W40', N'2010-W40-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94144, CAST(N'2010-10-05' AS date), CAST(N'2010-10-06' AS date), 2010, 20104, 201010, 2010278, 4, 10, 278, 5, 3, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-09-29' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-10-08' AS date), 1031, 3093, 13448, 13449, 13449, 13448, 13448, 13448, 13448, 2455475, 55474, N'2010-10-05', 201040, 40, 2, N'2010-W40', N'2010-W40-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94145, CAST(N'2010-10-06' AS date), CAST(N'2010-10-07' AS date), 2010, 20104, 201010, 2010279, 4, 10, 279, 6, 4, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-09-30' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-10-08' AS date), 1031, 3093, 13448, 13449, 13449, 13449, 13448, 13448, 13448, 2455476, 55475, N'2010-10-06', 201040, 40, 3, N'2010-W40', N'2010-W40-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94146, CAST(N'2010-10-07' AS date), CAST(N'2010-10-08' AS date), 2010, 20104, 201010, 2010280, 4, 10, 280, 7, 5, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-10-08' AS date), 1031, 3093, 13448, 13449, 13449, 13449, 13449, 13448, 13448, 2455477, 55476, N'2010-10-07', 201040, 40, 4, N'2010-W40', N'2010-W40-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94147, CAST(N'2010-10-08' AS date), CAST(N'2010-10-09' AS date), 2010, 20104, 201010, 2010281, 4, 10, 281, 8, 6, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-08' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-02' AS date), CAST(N'2010-10-08' AS date), 1031, 3093, 13448, 13449, 13449, 13449, 13449, 13449, 13448, 2455478, 55477, N'2010-10-08', 201040, 40, 5, N'2010-W40', N'2010-W40-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94148, CAST(N'2010-10-09' AS date), CAST(N'2010-10-10' AS date), 2010, 20104, 201010, 2010282, 4, 10, 282, 9, 7, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-03' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-08' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-15' AS date), 1031, 3093, 13448, 13449, 13449, 13449, 13449, 13449, 13449, 2455479, 55478, N'2010-10-09', 201040, 40, 6, N'2010-W40', N'2010-W40-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94149, CAST(N'2010-10-10' AS date), CAST(N'2010-10-11' AS date), 2010, 20104, 201010, 2010283, 4, 10, 283, 10, 1, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-04' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-08' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-15' AS date), 1031, 3093, 13449, 13449, 13449, 13449, 13449, 13449, 13449, 2455480, 55479, N'2010-10-10', 201040, 40, 7, N'2010-W40', N'2010-W40-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94150, CAST(N'2010-10-11' AS date), CAST(N'2010-10-12' AS date), 2010, 20104, 201010, 2010284, 4, 10, 284, 11, 2, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-05' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-08' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-15' AS date), 1031, 3093, 13449, 13450, 13449, 13449, 13449, 13449, 13449, 2455481, 55480, N'2010-10-11', 201041, 41, 1, N'2010-W41', N'2010-W41-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94151, CAST(N'2010-10-12' AS date), CAST(N'2010-10-13' AS date), 2010, 20104, 201010, 2010285, 4, 10, 285, 12, 3, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-06' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-08' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-15' AS date), 1031, 3093, 13449, 13450, 13450, 13449, 13449, 13449, 13449, 2455482, 55481, N'2010-10-12', 201041, 41, 2, N'2010-W41', N'2010-W41-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94152, CAST(N'2010-10-13' AS date), CAST(N'2010-10-14' AS date), 2010, 20104, 201010, 2010286, 4, 10, 286, 13, 4, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-07' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-08' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-15' AS date), 1031, 3093, 13449, 13450, 13450, 13450, 13449, 13449, 13449, 2455483, 55482, N'2010-10-13', 201041, 41, 3, N'2010-W41', N'2010-W41-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94153, CAST(N'2010-10-14' AS date), CAST(N'2010-10-15' AS date), 2010, 20104, 201010, 2010287, 4, 10, 287, 14, 5, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-08' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-15' AS date), 1031, 3093, 13449, 13450, 13450, 13450, 13450, 13449, 13449, 2455484, 55483, N'2010-10-14', 201041, 41, 4, N'2010-W41', N'2010-W41-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94154, CAST(N'2010-10-15' AS date), CAST(N'2010-10-16' AS date), 2010, 20104, 201010, 2010288, 4, 10, 288, 15, 6, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-15' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-09' AS date), CAST(N'2010-10-15' AS date), 1031, 3093, 13449, 13450, 13450, 13450, 13450, 13450, 13449, 2455485, 55484, N'2010-10-15', 201041, 41, 5, N'2010-W41', N'2010-W41-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94155, CAST(N'2010-10-16' AS date), CAST(N'2010-10-17' AS date), 2010, 20104, 201010, 2010289, 4, 10, 289, 16, 7, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-10' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-15' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-22' AS date), 1031, 3093, 13449, 13450, 13450, 13450, 13450, 13450, 13450, 2455486, 55485, N'2010-10-16', 201041, 41, 6, N'2010-W41', N'2010-W41-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94156, CAST(N'2010-10-17' AS date), CAST(N'2010-10-18' AS date), 2010, 20104, 201010, 2010290, 4, 10, 290, 17, 1, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-11' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-15' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-22' AS date), 1031, 3093, 13450, 13450, 13450, 13450, 13450, 13450, 13450, 2455487, 55486, N'2010-10-17', 201041, 41, 7, N'2010-W41', N'2010-W41-7');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94157, CAST(N'2010-10-18' AS date), CAST(N'2010-10-19' AS date), 2010, 20104, 201010, 2010291, 4, 10, 291, 18, 2, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-12' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-15' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-22' AS date), 1031, 3093, 13450, 13451, 13450, 13450, 13450, 13450, 13450, 2455488, 55487, N'2010-10-18', 201042, 42, 1, N'2010-W42', N'2010-W42-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94158, CAST(N'2010-10-19' AS date), CAST(N'2010-10-20' AS date), 2010, 20104, 201010, 2010292, 4, 10, 292, 19, 3, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-13' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-15' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-22' AS date), 1031, 3093, 13450, 13451, 13451, 13450, 13450, 13450, 13450, 2455489, 55488, N'2010-10-19', 201042, 42, 2, N'2010-W42', N'2010-W42-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94159, CAST(N'2010-10-20' AS date), CAST(N'2010-10-21' AS date), 2010, 20104, 201010, 2010293, 4, 10, 293, 20, 4, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-10-14' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-15' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-22' AS date), 1031, 3093, 13450, 13451, 13451, 13451, 13450, 13450, 13450, 2455490, 55489, N'2010-10-20', 201042, 42, 3, N'2010-W42', N'2010-W42-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94160, CAST(N'2010-10-21' AS date), CAST(N'2010-10-22' AS date), 2010, 20104, 201010, 2010294, 4, 10, 294, 21, 5, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-10-15' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-22' AS date), 1031, 3093, 13450, 13451, 13451, 13451, 13451, 13450, 13450, 2455491, 55490, N'2010-10-21', 201042, 42, 4, N'2010-W42', N'2010-W42-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94161, CAST(N'2010-10-22' AS date), CAST(N'2010-10-23' AS date), 2010, 20104, 201010, 2010295, 4, 10, 295, 22, 6, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-10-22' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-10-16' AS date), CAST(N'2010-10-22' AS date), 1031, 3093, 13450, 13451, 13451, 13451, 13451, 13451, 13450, 2455492, 55491, N'2010-10-22', 201042, 42, 5, N'2010-W42', N'2010-W42-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94162, CAST(N'2010-10-23' AS date), CAST(N'2010-10-24' AS date), 2010, 20104, 201010, 2010296, 4, 10, 296, 23, 7, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-17' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-10-22' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-29' AS date), 1031, 3093, 13450, 13451, 13451, 13451, 13451, 13451, 13451, 2455493, 55492, N'2010-10-23', 201042, 42, 6, N'2010-W42', N'2010-W42-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94163, CAST(N'2010-10-24' AS date), CAST(N'2010-10-25' AS date), 2010, 20104, 201010, 2010297, 4, 10, 297, 24, 1, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-10-18' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-10-22' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-29' AS date), 1031, 3093, 13451, 13451, 13451, 13451, 13451, 13451, 13451, 2455494, 55493, N'2010-10-24', 201042, 42, 7, N'2010-W42', N'2010-W42-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94164, CAST(N'2010-10-25' AS date), CAST(N'2010-10-26' AS date), 2010, 20104, 201010, 2010298, 4, 10, 298, 25, 2, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-19' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-10-22' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-29' AS date), 1031, 3093, 13451, 13452, 13451, 13451, 13451, 13451, 13451, 2455495, 55494, N'2010-10-25', 201043, 43, 1, N'2010-W43', N'2010-W43-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94165, CAST(N'2010-10-26' AS date), CAST(N'2010-10-27' AS date), 2010, 20104, 201010, 2010299, 4, 10, 299, 26, 3, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-10-20' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-10-22' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-29' AS date), 1031, 3093, 13451, 13452, 13452, 13451, 13451, 13451, 13451, 2455496, 55495, N'2010-10-26', 201043, 43, 2, N'2010-W43', N'2010-W43-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94166, CAST(N'2010-10-27' AS date), CAST(N'2010-10-28' AS date), 2010, 20104, 201010, 2010300, 4, 10, 300, 27, 4, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-10-21' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-10-22' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-29' AS date), 1031, 3093, 13451, 13452, 13452, 13452, 13451, 13451, 13451, 2455497, 55496, N'2010-10-27', 201043, 43, 3, N'2010-W43', N'2010-W43-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94167, CAST(N'2010-10-28' AS date), CAST(N'2010-10-29' AS date), 2010, 20104, 201010, 2010301, 4, 10, 301, 28, 5, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-10-22' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-29' AS date), 1031, 3093, 13451, 13452, 13452, 13452, 13452, 13451, 13451, 2455498, 55497, N'2010-10-28', 201043, 43, 4, N'2010-W43', N'2010-W43-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94168, CAST(N'2010-10-29' AS date), CAST(N'2010-10-30' AS date), 2010, 20104, 201010, 2010302, 4, 10, 302, 29, 6, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-10-29' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-10-23' AS date), CAST(N'2010-10-29' AS date), 1031, 3093, 13451, 13452, 13452, 13452, 13452, 13452, 13451, 2455499, 55498, N'2010-10-29', 201043, 43, 5, N'2010-W43', N'2010-W43-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94169, CAST(N'2010-10-30' AS date), CAST(N'2010-10-31' AS date), 2010, 20104, 201010, 2010303, 4, 10, 303, 30, 7, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-24' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-10-29' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-11-05' AS date), 1031, 3093, 13451, 13452, 13452, 13452, 13452, 13452, 13452, 2455500, 55499, N'2010-10-30', 201043, 43, 6, N'2010-W43', N'2010-W43-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94170, CAST(N'2010-10-31' AS date), CAST(N'2010-11-01' AS date), 2010, 20104, 201010, 2010304, 4, 10, 304, 31, 1, N'2010', N'2010 Q4', N'2010 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-10-25' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-10-29' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-11-05' AS date), 1031, 3093, 13452, 13452, 13452, 13452, 13452, 13452, 13452, 2455501, 55500, N'2010-10-31', 201043, 43, 7, N'2010-W43', N'2010-W43-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94171, CAST(N'2010-11-01' AS date), CAST(N'2010-11-02' AS date), 2010, 20104, 201011, 2010305, 4, 11, 305, 1, 2, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-10-26' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-10-29' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-11-05' AS date), 1031, 3094, 13452, 13453, 13452, 13452, 13452, 13452, 13452, 2455502, 55501, N'2010-11-01', 201044, 44, 1, N'2010-W44', N'2010-W44-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94172, CAST(N'2010-11-02' AS date), CAST(N'2010-11-03' AS date), 2010, 20104, 201011, 2010306, 4, 11, 306, 2, 3, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-10-27' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-10-29' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-11-05' AS date), 1031, 3094, 13452, 13453, 13453, 13452, 13452, 13452, 13452, 2455503, 55502, N'2010-11-02', 201044, 44, 2, N'2010-W44', N'2010-W44-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94173, CAST(N'2010-11-03' AS date), CAST(N'2010-11-04' AS date), 2010, 20104, 201011, 2010307, 4, 11, 307, 3, 4, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-10-28' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-10-29' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-11-05' AS date), 1031, 3094, 13452, 13453, 13453, 13453, 13452, 13452, 13452, 2455504, 55503, N'2010-11-03', 201044, 44, 3, N'2010-W44', N'2010-W44-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94174, CAST(N'2010-11-04' AS date), CAST(N'2010-11-05' AS date), 2010, 20104, 201011, 2010308, 4, 11, 308, 4, 5, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-10-29' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-11-05' AS date), 1031, 3094, 13452, 13453, 13453, 13453, 13453, 13452, 13452, 2455505, 55504, N'2010-11-04', 201044, 44, 4, N'2010-W44', N'2010-W44-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94175, CAST(N'2010-11-05' AS date), CAST(N'2010-11-06' AS date), 2010, 20104, 201011, 2010309, 4, 11, 309, 5, 6, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-05' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-10-30' AS date), CAST(N'2010-11-05' AS date), 1031, 3094, 13452, 13453, 13453, 13453, 13453, 13453, 13452, 2455506, 55505, N'2010-11-05', 201044, 44, 5, N'2010-W44', N'2010-W44-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94176, CAST(N'2010-11-06' AS date), CAST(N'2010-11-07' AS date), 2010, 20104, 201011, 2010310, 4, 11, 310, 6, 7, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-10-31' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-05' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-12' AS date), 1031, 3094, 13452, 13453, 13453, 13453, 13453, 13453, 13453, 2455507, 55506, N'2010-11-06', 201044, 44, 6, N'2010-W44', N'2010-W44-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94177, CAST(N'2010-11-07' AS date), CAST(N'2010-11-08' AS date), 2010, 20104, 201011, 2010311, 4, 11, 311, 7, 1, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-05' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-12' AS date), 1031, 3094, 13453, 13453, 13453, 13453, 13453, 13453, 13453, 2455508, 55507, N'2010-11-07', 201044, 44, 7, N'2010-W44', N'2010-W44-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94178, CAST(N'2010-11-08' AS date), CAST(N'2010-11-09' AS date), 2010, 20104, 201011, 2010312, 4, 11, 312, 8, 2, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-02' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-05' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-12' AS date), 1031, 3094, 13453, 13454, 13453, 13453, 13453, 13453, 13453, 2455509, 55508, N'2010-11-08', 201045, 45, 1, N'2010-W45', N'2010-W45-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94179, CAST(N'2010-11-09' AS date), CAST(N'2010-11-10' AS date), 2010, 20104, 201011, 2010313, 4, 11, 313, 9, 3, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-03' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-05' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-12' AS date), 1031, 3094, 13453, 13454, 13454, 13453, 13453, 13453, 13453, 2455510, 55509, N'2010-11-09', 201045, 45, 2, N'2010-W45', N'2010-W45-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94180, CAST(N'2010-11-10' AS date), CAST(N'2010-11-11' AS date), 2010, 20104, 201011, 2010314, 4, 11, 314, 10, 4, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-04' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-05' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-12' AS date), 1031, 3094, 13453, 13454, 13454, 13454, 13453, 13453, 13453, 2455511, 55510, N'2010-11-10', 201045, 45, 3, N'2010-W45', N'2010-W45-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94181, CAST(N'2010-11-11' AS date), CAST(N'2010-11-12' AS date), 2010, 20104, 201011, 2010315, 4, 11, 315, 11, 5, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-05' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-12' AS date), 1031, 3094, 13453, 13454, 13454, 13454, 13454, 13453, 13453, 2455512, 55511, N'2010-11-11', 201045, 45, 4, N'2010-W45', N'2010-W45-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94182, CAST(N'2010-11-12' AS date), CAST(N'2010-11-13' AS date), 2010, 20104, 201011, 2010316, 4, 11, 316, 12, 6, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-12' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-06' AS date), CAST(N'2010-11-12' AS date), 1031, 3094, 13453, 13454, 13454, 13454, 13454, 13454, 13453, 2455513, 55512, N'2010-11-12', 201045, 45, 5, N'2010-W45', N'2010-W45-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94183, CAST(N'2010-11-13' AS date), CAST(N'2010-11-14' AS date), 2010, 20104, 201011, 2010317, 4, 11, 317, 13, 7, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-07' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-12' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-19' AS date), 1031, 3094, 13453, 13454, 13454, 13454, 13454, 13454, 13454, 2455514, 55513, N'2010-11-13', 201045, 45, 6, N'2010-W45', N'2010-W45-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94184, CAST(N'2010-11-14' AS date), CAST(N'2010-11-15' AS date), 2010, 20104, 201011, 2010318, 4, 11, 318, 14, 1, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-08' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-12' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-19' AS date), 1031, 3094, 13454, 13454, 13454, 13454, 13454, 13454, 13454, 2455515, 55514, N'2010-11-14', 201045, 45, 7, N'2010-W45', N'2010-W45-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94185, CAST(N'2010-11-15' AS date), CAST(N'2010-11-16' AS date), 2010, 20104, 201011, 2010319, 4, 11, 319, 15, 2, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-09' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-12' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-19' AS date), 1031, 3094, 13454, 13455, 13454, 13454, 13454, 13454, 13454, 2455516, 55515, N'2010-11-15', 201046, 46, 1, N'2010-W46', N'2010-W46-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94186, CAST(N'2010-11-16' AS date), CAST(N'2010-11-17' AS date), 2010, 20104, 201011, 2010320, 4, 11, 320, 16, 3, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-10' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-12' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-19' AS date), 1031, 3094, 13454, 13455, 13455, 13454, 13454, 13454, 13454, 2455517, 55516, N'2010-11-16', 201046, 46, 2, N'2010-W46', N'2010-W46-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94187, CAST(N'2010-11-17' AS date), CAST(N'2010-11-18' AS date), 2010, 20104, 201011, 2010321, 4, 11, 321, 17, 4, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-11' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-12' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-19' AS date), 1031, 3094, 13454, 13455, 13455, 13455, 13454, 13454, 13454, 2455518, 55517, N'2010-11-17', 201046, 46, 3, N'2010-W46', N'2010-W46-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94188, CAST(N'2010-11-18' AS date), CAST(N'2010-11-19' AS date), 2010, 20104, 201011, 2010322, 4, 11, 322, 18, 5, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-12' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-19' AS date), 1031, 3094, 13454, 13455, 13455, 13455, 13455, 13454, 13454, 2455519, 55518, N'2010-11-18', 201046, 46, 4, N'2010-W46', N'2010-W46-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94189, CAST(N'2010-11-19' AS date), CAST(N'2010-11-20' AS date), 2010, 20104, 201011, 2010323, 4, 11, 323, 19, 6, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-19' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-11-13' AS date), CAST(N'2010-11-19' AS date), 1031, 3094, 13454, 13455, 13455, 13455, 13455, 13455, 13454, 2455520, 55519, N'2010-11-19', 201046, 46, 5, N'2010-W46', N'2010-W46-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94190, CAST(N'2010-11-20' AS date), CAST(N'2010-11-21' AS date), 2010, 20104, 201011, 2010324, 4, 11, 324, 20, 7, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-14' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-19' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-26' AS date), 1031, 3094, 13454, 13455, 13455, 13455, 13455, 13455, 13455, 2455521, 55520, N'2010-11-20', 201046, 46, 6, N'2010-W46', N'2010-W46-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94191, CAST(N'2010-11-21' AS date), CAST(N'2010-11-22' AS date), 2010, 20104, 201011, 2010325, 4, 11, 325, 21, 1, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-11-15' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-19' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-26' AS date), 1031, 3094, 13455, 13455, 13455, 13455, 13455, 13455, 13455, 2455522, 55521, N'2010-11-21', 201046, 46, 7, N'2010-W46', N'2010-W46-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94192, CAST(N'2010-11-22' AS date), CAST(N'2010-11-23' AS date), 2010, 20104, 201011, 2010326, 4, 11, 326, 22, 2, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-11-16' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-19' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-26' AS date), 1031, 3094, 13455, 13456, 13455, 13455, 13455, 13455, 13455, 2455523, 55522, N'2010-11-22', 201047, 47, 1, N'2010-W47', N'2010-W47-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94193, CAST(N'2010-11-23' AS date), CAST(N'2010-11-24' AS date), 2010, 20104, 201011, 2010327, 4, 11, 327, 23, 3, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-11-17' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-19' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-26' AS date), 1031, 3094, 13455, 13456, 13456, 13455, 13455, 13455, 13455, 2455524, 55523, N'2010-11-23', 201047, 47, 2, N'2010-W47', N'2010-W47-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94194, CAST(N'2010-11-24' AS date), CAST(N'2010-11-25' AS date), 2010, 20104, 201011, 2010328, 4, 11, 328, 24, 4, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-18' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-19' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-26' AS date), 1031, 3094, 13455, 13456, 13456, 13456, 13455, 13455, 13455, 2455525, 55524, N'2010-11-24', 201047, 47, 3, N'2010-W47', N'2010-W47-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94195, CAST(N'2010-11-25' AS date), CAST(N'2010-11-26' AS date), 2010, 20104, 201011, 2010329, 4, 11, 329, 25, 5, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-11-19' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-26' AS date), 1031, 3094, 13455, 13456, 13456, 13456, 13456, 13455, 13455, 2455526, 55525, N'2010-11-25', 201047, 47, 4, N'2010-W47', N'2010-W47-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94196, CAST(N'2010-11-26' AS date), CAST(N'2010-11-27' AS date), 2010, 20104, 201011, 2010330, 4, 11, 330, 26, 6, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-11-26' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-11-20' AS date), CAST(N'2010-11-26' AS date), 1031, 3094, 13455, 13456, 13456, 13456, 13456, 13456, 13455, 2455527, 55526, N'2010-11-26', 201047, 47, 5, N'2010-W47', N'2010-W47-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94197, CAST(N'2010-11-27' AS date), CAST(N'2010-11-28' AS date), 2010, 20104, 201011, 2010331, 4, 11, 331, 27, 7, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-21' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-11-26' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-12-03' AS date), 1031, 3094, 13455, 13456, 13456, 13456, 13456, 13456, 13456, 2455528, 55527, N'2010-11-27', 201047, 47, 6, N'2010-W47', N'2010-W47-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94198, CAST(N'2010-11-28' AS date), CAST(N'2010-11-29' AS date), 2010, 20104, 201011, 2010332, 4, 11, 332, 28, 1, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-11-22' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-11-26' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-12-03' AS date), 1031, 3094, 13456, 13456, 13456, 13456, 13456, 13456, 13456, 2455529, 55528, N'2010-11-28', 201047, 47, 7, N'2010-W47', N'2010-W47-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94199, CAST(N'2010-11-29' AS date), CAST(N'2010-11-30' AS date), 2010, 20104, 201011, 2010333, 4, 11, 333, 29, 2, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-11-23' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-11-26' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-12-03' AS date), 1031, 3094, 13456, 13457, 13456, 13456, 13456, 13456, 13456, 2455530, 55529, N'2010-11-29', 201048, 48, 1, N'2010-W48', N'2010-W48-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94200, CAST(N'2010-11-30' AS date), CAST(N'2010-12-01' AS date), 2010, 20104, 201011, 2010334, 4, 11, 334, 30, 3, N'2010', N'2010 Q4', N'2010 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-01' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-11-24' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-11-26' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-12-03' AS date), 1031, 3094, 13456, 13457, 13457, 13456, 13456, 13456, 13456, 2455531, 55530, N'2010-11-30', 201048, 48, 2, N'2010-W48', N'2010-W48-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94201, CAST(N'2010-12-01' AS date), CAST(N'2010-12-02' AS date), 2010, 20104, 201012, 2010335, 4, 12, 335, 1, 4, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-11-25' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-11-26' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-12-03' AS date), 1031, 3095, 13456, 13457, 13457, 13457, 13456, 13456, 13456, 2455532, 55531, N'2010-12-01', 201048, 48, 3, N'2010-W48', N'2010-W48-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94202, CAST(N'2010-12-02' AS date), CAST(N'2010-12-03' AS date), 2010, 20104, 201012, 2010336, 4, 12, 336, 2, 5, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-11-26' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-12-03' AS date), 1031, 3095, 13456, 13457, 13457, 13457, 13457, 13456, 13456, 2455533, 55532, N'2010-12-02', 201048, 48, 4, N'2010-W48', N'2010-W48-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94203, CAST(N'2010-12-03' AS date), CAST(N'2010-12-04' AS date), 2010, 20104, 201012, 2010337, 4, 12, 337, 3, 6, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-03' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-11-27' AS date), CAST(N'2010-12-03' AS date), 1031, 3095, 13456, 13457, 13457, 13457, 13457, 13457, 13456, 2455534, 55533, N'2010-12-03', 201048, 48, 5, N'2010-W48', N'2010-W48-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94204, CAST(N'2010-12-04' AS date), CAST(N'2010-12-05' AS date), 2010, 20104, 201012, 2010338, 4, 12, 338, 4, 7, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-11-28' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-03' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-12-10' AS date), 1031, 3095, 13456, 13457, 13457, 13457, 13457, 13457, 13457, 2455535, 55534, N'2010-12-04', 201048, 48, 6, N'2010-W48', N'2010-W48-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94205, CAST(N'2010-12-05' AS date), CAST(N'2010-12-06' AS date), 2010, 20104, 201012, 2010339, 4, 12, 339, 5, 1, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-11-29' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-03' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-12-10' AS date), 1031, 3095, 13457, 13457, 13457, 13457, 13457, 13457, 13457, 2455536, 55535, N'2010-12-05', 201048, 48, 7, N'2010-W48', N'2010-W48-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94206, CAST(N'2010-12-06' AS date), CAST(N'2010-12-07' AS date), 2010, 20104, 201012, 2010340, 4, 12, 340, 6, 2, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-11-30' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-03' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-12-10' AS date), 1031, 3095, 13457, 13458, 13457, 13457, 13457, 13457, 13457, 2455537, 55536, N'2010-12-06', 201049, 49, 1, N'2010-W49', N'2010-W49-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94207, CAST(N'2010-12-07' AS date), CAST(N'2010-12-08' AS date), 2010, 20104, 201012, 2010341, 4, 12, 341, 7, 3, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-03' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-12-10' AS date), 1031, 3095, 13457, 13458, 13458, 13457, 13457, 13457, 13457, 2455538, 55537, N'2010-12-07', 201049, 49, 2, N'2010-W49', N'2010-W49-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94208, CAST(N'2010-12-08' AS date), CAST(N'2010-12-09' AS date), 2010, 20104, 201012, 2010342, 4, 12, 342, 8, 4, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-02' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-03' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-12-10' AS date), 1031, 3095, 13457, 13458, 13458, 13458, 13457, 13457, 13457, 2455539, 55538, N'2010-12-08', 201049, 49, 3, N'2010-W49', N'2010-W49-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94209, CAST(N'2010-12-09' AS date), CAST(N'2010-12-10' AS date), 2010, 20104, 201012, 2010343, 4, 12, 343, 9, 5, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-03' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-12-10' AS date), 1031, 3095, 13457, 13458, 13458, 13458, 13458, 13457, 13457, 2455540, 55539, N'2010-12-09', 201049, 49, 4, N'2010-W49', N'2010-W49-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94210, CAST(N'2010-12-10' AS date), CAST(N'2010-12-11' AS date), 2010, 20104, 201012, 2010344, 4, 12, 344, 10, 6, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-10' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-04' AS date), CAST(N'2010-12-10' AS date), 1031, 3095, 13457, 13458, 13458, 13458, 13458, 13458, 13457, 2455541, 55540, N'2010-12-10', 201049, 49, 5, N'2010-W49', N'2010-W49-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94211, CAST(N'2010-12-11' AS date), CAST(N'2010-12-12' AS date), 2010, 20104, 201012, 2010345, 4, 12, 345, 11, 7, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-05' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-10' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-17' AS date), 1031, 3095, 13457, 13458, 13458, 13458, 13458, 13458, 13458, 2455542, 55541, N'2010-12-11', 201049, 49, 6, N'2010-W49', N'2010-W49-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94212, CAST(N'2010-12-12' AS date), CAST(N'2010-12-13' AS date), 2010, 20104, 201012, 2010346, 4, 12, 346, 12, 1, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-06' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-10' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-17' AS date), 1031, 3095, 13458, 13458, 13458, 13458, 13458, 13458, 13458, 2455543, 55542, N'2010-12-12', 201049, 49, 7, N'2010-W49', N'2010-W49-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94213, CAST(N'2010-12-13' AS date), CAST(N'2010-12-14' AS date), 2010, 20104, 201012, 2010347, 4, 12, 347, 13, 2, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-07' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-10' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-17' AS date), 1031, 3095, 13458, 13459, 13458, 13458, 13458, 13458, 13458, 2455544, 55543, N'2010-12-13', 201050, 50, 1, N'2010-W50', N'2010-W50-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94214, CAST(N'2010-12-14' AS date), CAST(N'2010-12-15' AS date), 2010, 20104, 201012, 2010348, 4, 12, 348, 14, 3, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-08' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-10' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-17' AS date), 1031, 3095, 13458, 13459, 13459, 13458, 13458, 13458, 13458, 2455545, 55544, N'2010-12-14', 201050, 50, 2, N'2010-W50', N'2010-W50-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94215, CAST(N'2010-12-15' AS date), CAST(N'2010-12-16' AS date), 2010, 20104, 201012, 2010349, 4, 12, 349, 15, 4, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-09' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-10' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-17' AS date), 1031, 3095, 13458, 13459, 13459, 13459, 13458, 13458, 13458, 2455546, 55545, N'2010-12-15', 201050, 50, 3, N'2010-W50', N'2010-W50-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94216, CAST(N'2010-12-16' AS date), CAST(N'2010-12-17' AS date), 2010, 20104, 201012, 2010350, 4, 12, 350, 16, 5, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-10' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-17' AS date), 1031, 3095, 13458, 13459, 13459, 13459, 13459, 13458, 13458, 2455547, 55546, N'2010-12-16', 201050, 50, 4, N'2010-W50', N'2010-W50-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94217, CAST(N'2010-12-17' AS date), CAST(N'2010-12-18' AS date), 2010, 20104, 201012, 2010351, 4, 12, 351, 17, 6, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-17' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-11' AS date), CAST(N'2010-12-17' AS date), 1031, 3095, 13458, 13459, 13459, 13459, 13459, 13459, 13458, 2455548, 55547, N'2010-12-17', 201050, 50, 5, N'2010-W50', N'2010-W50-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94218, CAST(N'2010-12-18' AS date), CAST(N'2010-12-19' AS date), 2010, 20104, 201012, 2010352, 4, 12, 352, 18, 7, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-12' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-17' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-24' AS date), 1031, 3095, 13458, 13459, 13459, 13459, 13459, 13459, 13459, 2455549, 55548, N'2010-12-18', 201050, 50, 6, N'2010-W50', N'2010-W50-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94219, CAST(N'2010-12-19' AS date), CAST(N'2010-12-20' AS date), 2010, 20104, 201012, 2010353, 4, 12, 353, 19, 1, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-13' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-17' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-24' AS date), 1031, 3095, 13459, 13459, 13459, 13459, 13459, 13459, 13459, 2455550, 55549, N'2010-12-19', 201050, 50, 7, N'2010-W50', N'2010-W50-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94220, CAST(N'2010-12-20' AS date), CAST(N'2010-12-21' AS date), 2010, 20104, 201012, 2010354, 4, 12, 354, 20, 2, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-26' AS date), CAST(N'2010-12-14' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-17' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-24' AS date), 1031, 3095, 13459, 13460, 13459, 13459, 13459, 13459, 13459, 2455551, 55550, N'2010-12-20', 201051, 51, 1, N'2010-W51', N'2010-W51-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94221, CAST(N'2010-12-21' AS date), CAST(N'2010-12-22' AS date), 2010, 20104, 201012, 2010355, 4, 12, 355, 21, 3, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-26' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-27' AS date), CAST(N'2010-12-15' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-17' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-24' AS date), 1031, 3095, 13459, 13460, 13460, 13459, 13459, 13459, 13459, 2455552, 55551, N'2010-12-21', 201051, 51, 2, N'2010-W51', N'2010-W51-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94222, CAST(N'2010-12-22' AS date), CAST(N'2010-12-23' AS date), 2010, 20104, 201012, 2010356, 4, 12, 356, 22, 4, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-26' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-27' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-28' AS date), CAST(N'2010-12-16' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-17' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-24' AS date), 1031, 3095, 13459, 13460, 13460, 13460, 13459, 13459, 13459, 2455553, 55552, N'2010-12-22', 201051, 51, 3, N'2010-W51', N'2010-W51-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94223, CAST(N'2010-12-23' AS date), CAST(N'2010-12-24' AS date), 2010, 20104, 201012, 2010357, 4, 12, 357, 23, 5, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-26' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-27' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-28' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-29' AS date), CAST(N'2010-12-17' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-24' AS date), 1031, 3095, 13459, 13460, 13460, 13460, 13460, 13459, 13459, 2455554, 55553, N'2010-12-23', 201051, 51, 4, N'2010-W51', N'2010-W51-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94224, CAST(N'2010-12-24' AS date), CAST(N'2010-12-25' AS date), 2010, 20104, 201012, 2010358, 4, 12, 358, 24, 6, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-26' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-27' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-28' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-29' AS date), CAST(N'2010-12-24' AS date), CAST(N'2010-12-30' AS date), CAST(N'2010-12-18' AS date), CAST(N'2010-12-24' AS date), 1031, 3095, 13459, 13460, 13460, 13460, 13460, 13460, 13459, 2455555, 55554, N'2010-12-24', 201051, 51, 5, N'2010-W51', N'2010-W51-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94225, CAST(N'2010-12-25' AS date), CAST(N'2010-12-26' AS date), 2010, 20104, 201012, 2010359, 4, 12, 359, 25, 7, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-19' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-26' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-27' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-28' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-29' AS date), CAST(N'2010-12-24' AS date), CAST(N'2010-12-30' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-31' AS date), 1031, 3095, 13459, 13460, 13460, 13460, 13460, 13460, 13460, 2455556, 55555, N'2010-12-25', 201051, 51, 6, N'2010-W51', N'2010-W51-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94226, CAST(N'2010-12-26' AS date), CAST(N'2010-12-27' AS date), 2010, 20104, 201012, 2010360, 4, 12, 360, 26, 1, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-26' AS date), CAST(N'2011-01-01' AS date), CAST(N'2010-12-20' AS date), CAST(N'2010-12-26' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-27' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-28' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-29' AS date), CAST(N'2010-12-24' AS date), CAST(N'2010-12-30' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-31' AS date), 1031, 3095, 13460, 13460, 13460, 13460, 13460, 13460, 13460, 2455557, 55556, N'2010-12-26', 201051, 51, 7, N'2010-W51', N'2010-W51-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94227, CAST(N'2010-12-27' AS date), CAST(N'2010-12-28' AS date), 2010, 20104, 201012, 2010361, 4, 12, 361, 27, 2, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-26' AS date), CAST(N'2011-01-01' AS date), CAST(N'2010-12-27' AS date), CAST(N'2011-01-02' AS date), CAST(N'2010-12-21' AS date), CAST(N'2010-12-27' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-28' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-29' AS date), CAST(N'2010-12-24' AS date), CAST(N'2010-12-30' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-31' AS date), 1031, 3095, 13460, 13461, 13460, 13460, 13460, 13460, 13460, 2455558, 55557, N'2010-12-27', 201052, 52, 1, N'2010-W52', N'2010-W52-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94228, CAST(N'2010-12-28' AS date), CAST(N'2010-12-29' AS date), 2010, 20104, 201012, 2010362, 4, 12, 362, 28, 3, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-26' AS date), CAST(N'2011-01-01' AS date), CAST(N'2010-12-27' AS date), CAST(N'2011-01-02' AS date), CAST(N'2010-12-28' AS date), CAST(N'2011-01-03' AS date), CAST(N'2010-12-22' AS date), CAST(N'2010-12-28' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-29' AS date), CAST(N'2010-12-24' AS date), CAST(N'2010-12-30' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-31' AS date), 1031, 3095, 13460, 13461, 13461, 13460, 13460, 13460, 13460, 2455559, 55558, N'2010-12-28', 201052, 52, 2, N'2010-W52', N'2010-W52-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94229, CAST(N'2010-12-29' AS date), CAST(N'2010-12-30' AS date), 2010, 20104, 201012, 2010363, 4, 12, 363, 29, 4, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-26' AS date), CAST(N'2011-01-01' AS date), CAST(N'2010-12-27' AS date), CAST(N'2011-01-02' AS date), CAST(N'2010-12-28' AS date), CAST(N'2011-01-03' AS date), CAST(N'2010-12-29' AS date), CAST(N'2011-01-04' AS date), CAST(N'2010-12-23' AS date), CAST(N'2010-12-29' AS date), CAST(N'2010-12-24' AS date), CAST(N'2010-12-30' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-31' AS date), 1031, 3095, 13460, 13461, 13461, 13461, 13460, 13460, 13460, 2455560, 55559, N'2010-12-29', 201052, 52, 3, N'2010-W52', N'2010-W52-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94230, CAST(N'2010-12-30' AS date), CAST(N'2010-12-31' AS date), 2010, 20104, 201012, 2010364, 4, 12, 364, 30, 5, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-26' AS date), CAST(N'2011-01-01' AS date), CAST(N'2010-12-27' AS date), CAST(N'2011-01-02' AS date), CAST(N'2010-12-28' AS date), CAST(N'2011-01-03' AS date), CAST(N'2010-12-29' AS date), CAST(N'2011-01-04' AS date), CAST(N'2010-12-30' AS date), CAST(N'2011-01-05' AS date), CAST(N'2010-12-24' AS date), CAST(N'2010-12-30' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-31' AS date), 1031, 3095, 13460, 13461, 13461, 13461, 13461, 13460, 13460, 2455561, 55560, N'2010-12-30', 201052, 52, 4, N'2010-W52', N'2010-W52-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94231, CAST(N'2010-12-31' AS date), CAST(N'2011-01-01' AS date), 2010, 20104, 201012, 2010365, 4, 12, 365, 31, 6, N'2010', N'2010 Q4', N'2010 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2010-01-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-10-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-01' AS date), CAST(N'2010-12-31' AS date), CAST(N'2010-12-26' AS date), CAST(N'2011-01-01' AS date), CAST(N'2010-12-27' AS date), CAST(N'2011-01-02' AS date), CAST(N'2010-12-28' AS date), CAST(N'2011-01-03' AS date), CAST(N'2010-12-29' AS date), CAST(N'2011-01-04' AS date), CAST(N'2010-12-30' AS date), CAST(N'2011-01-05' AS date), CAST(N'2010-12-31' AS date), CAST(N'2011-01-06' AS date), CAST(N'2010-12-25' AS date), CAST(N'2010-12-31' AS date), 1031, 3095, 13460, 13461, 13461, 13461, 13461, 13461, 13460, 2455562, 55561, N'2010-12-31', 201052, 52, 5, N'2010-W52', N'2010-W52-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94232, CAST(N'2011-01-01' AS date), CAST(N'2011-01-02' AS date), 2011, 20111, 201101, 2011001, 1, 1, 1, 1, 7, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2010-12-26' AS date), CAST(N'2011-01-01' AS date), CAST(N'2010-12-27' AS date), CAST(N'2011-01-02' AS date), CAST(N'2010-12-28' AS date), CAST(N'2011-01-03' AS date), CAST(N'2010-12-29' AS date), CAST(N'2011-01-04' AS date), CAST(N'2010-12-30' AS date), CAST(N'2011-01-05' AS date), CAST(N'2010-12-31' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-07' AS date), 1032, 3096, 13460, 13461, 13461, 13461, 13461, 13461, 13461, 2455563, 55562, N'2011-01-01', 201052, 52, 6, N'2010-W52', N'2010-W52-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94233, CAST(N'2011-01-02' AS date), CAST(N'2011-01-03' AS date), 2011, 20111, 201101, 2011002, 1, 1, 2, 2, 1, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-02' AS date), CAST(N'2011-01-08' AS date), CAST(N'2010-12-27' AS date), CAST(N'2011-01-02' AS date), CAST(N'2010-12-28' AS date), CAST(N'2011-01-03' AS date), CAST(N'2010-12-29' AS date), CAST(N'2011-01-04' AS date), CAST(N'2010-12-30' AS date), CAST(N'2011-01-05' AS date), CAST(N'2010-12-31' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-07' AS date), 1032, 3096, 13461, 13461, 13461, 13461, 13461, 13461, 13461, 2455564, 55563, N'2011-01-02', 201052, 52, 7, N'2010-W52', N'2010-W52-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94234, CAST(N'2011-01-03' AS date), CAST(N'2011-01-04' AS date), 2011, 20111, 201101, 2011003, 1, 1, 3, 3, 2, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-02' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-03' AS date), CAST(N'2011-01-09' AS date), CAST(N'2010-12-28' AS date), CAST(N'2011-01-03' AS date), CAST(N'2010-12-29' AS date), CAST(N'2011-01-04' AS date), CAST(N'2010-12-30' AS date), CAST(N'2011-01-05' AS date), CAST(N'2010-12-31' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-07' AS date), 1032, 3096, 13461, 13462, 13461, 13461, 13461, 13461, 13461, 2455565, 55564, N'2011-01-03', 201101, 1, 1, N'2011-W01', N'2011-W01-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94235, CAST(N'2011-01-04' AS date), CAST(N'2011-01-05' AS date), 2011, 20111, 201101, 2011004, 1, 1, 4, 4, 3, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-02' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-03' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-04' AS date), CAST(N'2011-01-10' AS date), CAST(N'2010-12-29' AS date), CAST(N'2011-01-04' AS date), CAST(N'2010-12-30' AS date), CAST(N'2011-01-05' AS date), CAST(N'2010-12-31' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-07' AS date), 1032, 3096, 13461, 13462, 13462, 13461, 13461, 13461, 13461, 2455566, 55565, N'2011-01-04', 201101, 1, 2, N'2011-W01', N'2011-W01-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94236, CAST(N'2011-01-05' AS date), CAST(N'2011-01-06' AS date), 2011, 20111, 201101, 2011005, 1, 1, 5, 5, 4, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-02' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-03' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-04' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-05' AS date), CAST(N'2011-01-11' AS date), CAST(N'2010-12-30' AS date), CAST(N'2011-01-05' AS date), CAST(N'2010-12-31' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-07' AS date), 1032, 3096, 13461, 13462, 13462, 13462, 13461, 13461, 13461, 2455567, 55566, N'2011-01-05', 201101, 1, 3, N'2011-W01', N'2011-W01-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94237, CAST(N'2011-01-06' AS date), CAST(N'2011-01-07' AS date), 2011, 20111, 201101, 2011006, 1, 1, 6, 6, 5, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-02' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-03' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-04' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-05' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-12' AS date), CAST(N'2010-12-31' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-07' AS date), 1032, 3096, 13461, 13462, 13462, 13462, 13462, 13461, 13461, 2455568, 55567, N'2011-01-06', 201101, 1, 4, N'2011-W01', N'2011-W01-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94238, CAST(N'2011-01-07' AS date), CAST(N'2011-01-08' AS date), 2011, 20111, 201101, 2011007, 1, 1, 7, 7, 6, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-02' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-03' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-04' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-05' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-07' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-07' AS date), 1032, 3096, 13461, 13462, 13462, 13462, 13462, 13462, 13461, 2455569, 55568, N'2011-01-07', 201101, 1, 5, N'2011-W01', N'2011-W01-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94239, CAST(N'2011-01-08' AS date), CAST(N'2011-01-09' AS date), 2011, 20111, 201101, 2011008, 1, 1, 8, 8, 7, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-02' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-03' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-04' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-05' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-07' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-14' AS date), 1032, 3096, 13461, 13462, 13462, 13462, 13462, 13462, 13462, 2455570, 55569, N'2011-01-08', 201101, 1, 6, N'2011-W01', N'2011-W01-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94240, CAST(N'2011-01-09' AS date), CAST(N'2011-01-10' AS date), 2011, 20111, 201101, 2011009, 1, 1, 9, 9, 1, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-03' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-04' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-05' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-07' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-14' AS date), 1032, 3096, 13462, 13462, 13462, 13462, 13462, 13462, 13462, 2455571, 55570, N'2011-01-09', 201101, 1, 7, N'2011-W01', N'2011-W01-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94241, CAST(N'2011-01-10' AS date), CAST(N'2011-01-11' AS date), 2011, 20111, 201101, 2011010, 1, 1, 10, 10, 2, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-04' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-05' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-07' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-14' AS date), 1032, 3096, 13462, 13463, 13462, 13462, 13462, 13462, 13462, 2455572, 55571, N'2011-01-10', 201102, 2, 1, N'2011-W02', N'2011-W02-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94242, CAST(N'2011-01-11' AS date), CAST(N'2011-01-12' AS date), 2011, 20111, 201101, 2011011, 1, 1, 11, 11, 3, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-05' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-07' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-14' AS date), 1032, 3096, 13462, 13463, 13463, 13462, 13462, 13462, 13462, 2455573, 55572, N'2011-01-11', 201102, 2, 2, N'2011-W02', N'2011-W02-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94243, CAST(N'2011-01-12' AS date), CAST(N'2011-01-13' AS date), 2011, 20111, 201101, 2011012, 1, 1, 12, 12, 4, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-06' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-07' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-14' AS date), 1032, 3096, 13462, 13463, 13463, 13463, 13462, 13462, 13462, 2455574, 55573, N'2011-01-12', 201102, 2, 3, N'2011-W02', N'2011-W02-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94244, CAST(N'2011-01-13' AS date), CAST(N'2011-01-14' AS date), 2011, 20111, 201101, 2011013, 1, 1, 13, 13, 5, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-07' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-14' AS date), 1032, 3096, 13462, 13463, 13463, 13463, 13463, 13462, 13462, 2455575, 55574, N'2011-01-13', 201102, 2, 4, N'2011-W02', N'2011-W02-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94245, CAST(N'2011-01-14' AS date), CAST(N'2011-01-15' AS date), 2011, 20111, 201101, 2011014, 1, 1, 14, 14, 6, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-14' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-08' AS date), CAST(N'2011-01-14' AS date), 1032, 3096, 13462, 13463, 13463, 13463, 13463, 13463, 13462, 2455576, 55575, N'2011-01-14', 201102, 2, 5, N'2011-W02', N'2011-W02-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94246, CAST(N'2011-01-15' AS date), CAST(N'2011-01-16' AS date), 2011, 20111, 201101, 2011015, 1, 1, 15, 15, 7, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-09' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-14' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-21' AS date), 1032, 3096, 13462, 13463, 13463, 13463, 13463, 13463, 13463, 2455577, 55576, N'2011-01-15', 201102, 2, 6, N'2011-W02', N'2011-W02-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94247, CAST(N'2011-01-16' AS date), CAST(N'2011-01-17' AS date), 2011, 20111, 201101, 2011016, 1, 1, 16, 16, 1, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-10' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-14' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-21' AS date), 1032, 3096, 13463, 13463, 13463, 13463, 13463, 13463, 13463, 2455578, 55577, N'2011-01-16', 201102, 2, 7, N'2011-W02', N'2011-W02-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94248, CAST(N'2011-01-17' AS date), CAST(N'2011-01-18' AS date), 2011, 20111, 201101, 2011017, 1, 1, 17, 17, 2, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-11' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-14' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-21' AS date), 1032, 3096, 13463, 13464, 13463, 13463, 13463, 13463, 13463, 2455579, 55578, N'2011-01-17', 201103, 3, 1, N'2011-W03', N'2011-W03-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94249, CAST(N'2011-01-18' AS date), CAST(N'2011-01-19' AS date), 2011, 20111, 201101, 2011018, 1, 1, 18, 18, 3, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-12' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-14' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-21' AS date), 1032, 3096, 13463, 13464, 13464, 13463, 13463, 13463, 13463, 2455580, 55579, N'2011-01-18', 201103, 3, 2, N'2011-W03', N'2011-W03-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94250, CAST(N'2011-01-19' AS date), CAST(N'2011-01-20' AS date), 2011, 20111, 201101, 2011019, 1, 1, 19, 19, 4, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-13' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-14' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-21' AS date), 1032, 3096, 13463, 13464, 13464, 13464, 13463, 13463, 13463, 2455581, 55580, N'2011-01-19', 201103, 3, 3, N'2011-W03', N'2011-W03-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94251, CAST(N'2011-01-20' AS date), CAST(N'2011-01-21' AS date), 2011, 20111, 201101, 2011020, 1, 1, 20, 20, 5, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-01-14' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-21' AS date), 1032, 3096, 13463, 13464, 13464, 13464, 13464, 13463, 13463, 2455582, 55581, N'2011-01-20', 201103, 3, 4, N'2011-W03', N'2011-W03-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94252, CAST(N'2011-01-21' AS date), CAST(N'2011-01-22' AS date), 2011, 20111, 201101, 2011021, 1, 1, 21, 21, 6, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-01-21' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-01-15' AS date), CAST(N'2011-01-21' AS date), 1032, 3096, 13463, 13464, 13464, 13464, 13464, 13464, 13463, 2455583, 55582, N'2011-01-21', 201103, 3, 5, N'2011-W03', N'2011-W03-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94253, CAST(N'2011-01-22' AS date), CAST(N'2011-01-23' AS date), 2011, 20111, 201101, 2011022, 1, 1, 22, 22, 7, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-16' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-01-21' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-28' AS date), 1032, 3096, 13463, 13464, 13464, 13464, 13464, 13464, 13464, 2455584, 55583, N'2011-01-22', 201103, 3, 6, N'2011-W03', N'2011-W03-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94254, CAST(N'2011-01-23' AS date), CAST(N'2011-01-24' AS date), 2011, 20111, 201101, 2011023, 1, 1, 23, 23, 1, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-01-17' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-01-21' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-28' AS date), 1032, 3096, 13464, 13464, 13464, 13464, 13464, 13464, 13464, 2455585, 55584, N'2011-01-23', 201103, 3, 7, N'2011-W03', N'2011-W03-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94255, CAST(N'2011-01-24' AS date), CAST(N'2011-01-25' AS date), 2011, 20111, 201101, 2011024, 1, 1, 24, 24, 2, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-01-18' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-01-21' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-28' AS date), 1032, 3096, 13464, 13465, 13464, 13464, 13464, 13464, 13464, 2455586, 55585, N'2011-01-24', 201104, 4, 1, N'2011-W04', N'2011-W04-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94256, CAST(N'2011-01-25' AS date), CAST(N'2011-01-26' AS date), 2011, 20111, 201101, 2011025, 1, 1, 25, 25, 3, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-19' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-01-21' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-28' AS date), 1032, 3096, 13464, 13465, 13465, 13464, 13464, 13464, 13464, 2455587, 55586, N'2011-01-25', 201104, 4, 2, N'2011-W04', N'2011-W04-2');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94257, CAST(N'2011-01-26' AS date), CAST(N'2011-01-27' AS date), 2011, 20111, 201101, 2011026, 1, 1, 26, 26, 4, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-01-20' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-01-21' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-28' AS date), 1032, 3096, 13464, 13465, 13465, 13465, 13464, 13464, 13464, 2455588, 55587, N'2011-01-26', 201104, 4, 3, N'2011-W04', N'2011-W04-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94258, CAST(N'2011-01-27' AS date), CAST(N'2011-01-28' AS date), 2011, 20111, 201101, 2011027, 1, 1, 27, 27, 5, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-01-21' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-28' AS date), 1032, 3096, 13464, 13465, 13465, 13465, 13465, 13464, 13464, 2455589, 55588, N'2011-01-27', 201104, 4, 4, N'2011-W04', N'2011-W04-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94259, CAST(N'2011-01-28' AS date), CAST(N'2011-01-29' AS date), 2011, 20111, 201101, 2011028, 1, 1, 28, 28, 6, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-01-28' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-01-22' AS date), CAST(N'2011-01-28' AS date), 1032, 3096, 13464, 13465, 13465, 13465, 13465, 13465, 13464, 2455590, 55589, N'2011-01-28', 201104, 4, 5, N'2011-W04', N'2011-W04-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94260, CAST(N'2011-01-29' AS date), CAST(N'2011-01-30' AS date), 2011, 20111, 201101, 2011029, 1, 1, 29, 29, 7, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-23' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-01-28' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-02-04' AS date), 1032, 3096, 13464, 13465, 13465, 13465, 13465, 13465, 13465, 2455591, 55590, N'2011-01-29', 201104, 4, 6, N'2011-W04', N'2011-W04-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94261, CAST(N'2011-01-30' AS date), CAST(N'2011-01-31' AS date), 2011, 20111, 201101, 2011030, 1, 1, 30, 30, 1, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-01-24' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-01-28' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-02-04' AS date), 1032, 3096, 13465, 13465, 13465, 13465, 13465, 13465, 13465, 2455592, 55591, N'2011-01-30', 201104, 4, 7, N'2011-W04', N'2011-W04-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94262, CAST(N'2011-01-31' AS date), CAST(N'2011-02-01' AS date), 2011, 20111, 201101, 2011031, 1, 1, 31, 31, 2, N'2011', N'2011 Q1', N'2011 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-01-25' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-01-28' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-02-04' AS date), 1032, 3096, 13465, 13466, 13465, 13465, 13465, 13465, 13465, 2455593, 55592, N'2011-01-31', 201105, 5, 1, N'2011-W05', N'2011-W05-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94263, CAST(N'2011-02-01' AS date), CAST(N'2011-02-02' AS date), 2011, 20111, 201102, 2011032, 1, 2, 32, 1, 3, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-01-26' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-01-28' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-02-04' AS date), 1032, 3097, 13465, 13466, 13466, 13465, 13465, 13465, 13465, 2455594, 55593, N'2011-02-01', 201105, 5, 2, N'2011-W05', N'2011-W05-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94264, CAST(N'2011-02-02' AS date), CAST(N'2011-02-03' AS date), 2011, 20111, 201102, 2011033, 1, 2, 33, 2, 4, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-01-27' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-01-28' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-02-04' AS date), 1032, 3097, 13465, 13466, 13466, 13466, 13465, 13465, 13465, 2455595, 55594, N'2011-02-02', 201105, 5, 3, N'2011-W05', N'2011-W05-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94265, CAST(N'2011-02-03' AS date), CAST(N'2011-02-04' AS date), 2011, 20111, 201102, 2011034, 1, 2, 34, 3, 5, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-01-28' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-02-04' AS date), 1032, 3097, 13465, 13466, 13466, 13466, 13466, 13465, 13465, 2455596, 55595, N'2011-02-03', 201105, 5, 4, N'2011-W05', N'2011-W05-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94266, CAST(N'2011-02-04' AS date), CAST(N'2011-02-05' AS date), 2011, 20111, 201102, 2011035, 1, 2, 35, 4, 6, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-04' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-01-29' AS date), CAST(N'2011-02-04' AS date), 1032, 3097, 13465, 13466, 13466, 13466, 13466, 13466, 13465, 2455597, 55596, N'2011-02-04', 201105, 5, 5, N'2011-W05', N'2011-W05-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94267, CAST(N'2011-02-05' AS date), CAST(N'2011-02-06' AS date), 2011, 20111, 201102, 2011036, 1, 2, 36, 5, 7, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-01-30' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-04' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-02-11' AS date), 1032, 3097, 13465, 13466, 13466, 13466, 13466, 13466, 13466, 2455598, 55597, N'2011-02-05', 201105, 5, 6, N'2011-W05', N'2011-W05-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94268, CAST(N'2011-02-06' AS date), CAST(N'2011-02-07' AS date), 2011, 20111, 201102, 2011037, 1, 2, 37, 6, 1, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-01-31' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-04' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-02-11' AS date), 1032, 3097, 13466, 13466, 13466, 13466, 13466, 13466, 13466, 2455599, 55598, N'2011-02-06', 201105, 5, 7, N'2011-W05', N'2011-W05-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94269, CAST(N'2011-02-07' AS date), CAST(N'2011-02-08' AS date), 2011, 20111, 201102, 2011038, 1, 2, 38, 7, 2, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-04' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-02-11' AS date), 1032, 3097, 13466, 13467, 13466, 13466, 13466, 13466, 13466, 2455600, 55599, N'2011-02-07', 201106, 6, 1, N'2011-W06', N'2011-W06-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94270, CAST(N'2011-02-08' AS date), CAST(N'2011-02-09' AS date), 2011, 20111, 201102, 2011039, 1, 2, 39, 8, 3, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-02' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-04' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-02-11' AS date), 1032, 3097, 13466, 13467, 13467, 13466, 13466, 13466, 13466, 2455601, 55600, N'2011-02-08', 201106, 6, 2, N'2011-W06', N'2011-W06-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94271, CAST(N'2011-02-09' AS date), CAST(N'2011-02-10' AS date), 2011, 20111, 201102, 2011040, 1, 2, 40, 9, 4, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-03' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-04' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-02-11' AS date), 1032, 3097, 13466, 13467, 13467, 13467, 13466, 13466, 13466, 2455602, 55601, N'2011-02-09', 201106, 6, 3, N'2011-W06', N'2011-W06-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94272, CAST(N'2011-02-10' AS date), CAST(N'2011-02-11' AS date), 2011, 20111, 201102, 2011041, 1, 2, 41, 10, 5, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-04' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-02-11' AS date), 1032, 3097, 13466, 13467, 13467, 13467, 13467, 13466, 13466, 2455603, 55602, N'2011-02-10', 201106, 6, 4, N'2011-W06', N'2011-W06-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94273, CAST(N'2011-02-11' AS date), CAST(N'2011-02-12' AS date), 2011, 20111, 201102, 2011042, 1, 2, 42, 11, 6, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-11' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-05' AS date), CAST(N'2011-02-11' AS date), 1032, 3097, 13466, 13467, 13467, 13467, 13467, 13467, 13466, 2455604, 55603, N'2011-02-11', 201106, 6, 5, N'2011-W06', N'2011-W06-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94274, CAST(N'2011-02-12' AS date), CAST(N'2011-02-13' AS date), 2011, 20111, 201102, 2011043, 1, 2, 43, 12, 7, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-06' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-11' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-18' AS date), 1032, 3097, 13466, 13467, 13467, 13467, 13467, 13467, 13467, 2455605, 55604, N'2011-02-12', 201106, 6, 6, N'2011-W06', N'2011-W06-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94275, CAST(N'2011-02-13' AS date), CAST(N'2011-02-14' AS date), 2011, 20111, 201102, 2011044, 1, 2, 44, 13, 1, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-07' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-11' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-18' AS date), 1032, 3097, 13467, 13467, 13467, 13467, 13467, 13467, 13467, 2455606, 55605, N'2011-02-13', 201106, 6, 7, N'2011-W06', N'2011-W06-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94276, CAST(N'2011-02-14' AS date), CAST(N'2011-02-15' AS date), 2011, 20111, 201102, 2011045, 1, 2, 45, 14, 2, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-08' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-11' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-18' AS date), 1032, 3097, 13467, 13468, 13467, 13467, 13467, 13467, 13467, 2455607, 55606, N'2011-02-14', 201107, 7, 1, N'2011-W07', N'2011-W07-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94277, CAST(N'2011-02-15' AS date), CAST(N'2011-02-16' AS date), 2011, 20111, 201102, 2011046, 1, 2, 46, 15, 3, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-09' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-11' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-18' AS date), 1032, 3097, 13467, 13468, 13468, 13467, 13467, 13467, 13467, 2455608, 55607, N'2011-02-15', 201107, 7, 2, N'2011-W07', N'2011-W07-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94278, CAST(N'2011-02-16' AS date), CAST(N'2011-02-17' AS date), 2011, 20111, 201102, 2011047, 1, 2, 47, 16, 4, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-10' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-11' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-18' AS date), 1032, 3097, 13467, 13468, 13468, 13468, 13467, 13467, 13467, 2455609, 55608, N'2011-02-16', 201107, 7, 3, N'2011-W07', N'2011-W07-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94279, CAST(N'2011-02-17' AS date), CAST(N'2011-02-18' AS date), 2011, 20111, 201102, 2011048, 1, 2, 48, 17, 5, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-02-11' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-18' AS date), 1032, 3097, 13467, 13468, 13468, 13468, 13468, 13467, 13467, 2455610, 55609, N'2011-02-17', 201107, 7, 4, N'2011-W07', N'2011-W07-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94280, CAST(N'2011-02-18' AS date), CAST(N'2011-02-19' AS date), 2011, 20111, 201102, 2011049, 1, 2, 49, 18, 6, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-02-18' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-02-12' AS date), CAST(N'2011-02-18' AS date), 1032, 3097, 13467, 13468, 13468, 13468, 13468, 13468, 13467, 2455611, 55610, N'2011-02-18', 201107, 7, 5, N'2011-W07', N'2011-W07-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94281, CAST(N'2011-02-19' AS date), CAST(N'2011-02-20' AS date), 2011, 20111, 201102, 2011050, 1, 2, 50, 19, 7, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-13' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-02-18' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-25' AS date), 1032, 3097, 13467, 13468, 13468, 13468, 13468, 13468, 13468, 2455612, 55611, N'2011-02-19', 201107, 7, 6, N'2011-W07', N'2011-W07-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94282, CAST(N'2011-02-20' AS date), CAST(N'2011-02-21' AS date), 2011, 20111, 201102, 2011051, 1, 2, 51, 20, 1, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-02-14' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-02-18' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-25' AS date), 1032, 3097, 13468, 13468, 13468, 13468, 13468, 13468, 13468, 2455613, 55612, N'2011-02-20', 201107, 7, 7, N'2011-W07', N'2011-W07-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94283, CAST(N'2011-02-21' AS date), CAST(N'2011-02-22' AS date), 2011, 20111, 201102, 2011052, 1, 2, 52, 21, 2, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-02-15' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-02-18' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-25' AS date), 1032, 3097, 13468, 13469, 13468, 13468, 13468, 13468, 13468, 2455614, 55613, N'2011-02-21', 201108, 8, 1, N'2011-W08', N'2011-W08-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94284, CAST(N'2011-02-22' AS date), CAST(N'2011-02-23' AS date), 2011, 20111, 201102, 2011053, 1, 2, 53, 22, 3, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-16' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-02-18' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-25' AS date), 1032, 3097, 13468, 13469, 13469, 13468, 13468, 13468, 13468, 2455615, 55614, N'2011-02-22', 201108, 8, 2, N'2011-W08', N'2011-W08-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94285, CAST(N'2011-02-23' AS date), CAST(N'2011-02-24' AS date), 2011, 20111, 201102, 2011054, 1, 2, 54, 23, 4, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-02-17' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-02-18' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-25' AS date), 1032, 3097, 13468, 13469, 13469, 13469, 13468, 13468, 13468, 2455616, 55615, N'2011-02-23', 201108, 8, 3, N'2011-W08', N'2011-W08-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94286, CAST(N'2011-02-24' AS date), CAST(N'2011-02-25' AS date), 2011, 20111, 201102, 2011055, 1, 2, 55, 24, 5, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-02-18' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-25' AS date), 1032, 3097, 13468, 13469, 13469, 13469, 13469, 13468, 13468, 2455617, 55616, N'2011-02-24', 201108, 8, 4, N'2011-W08', N'2011-W08-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94287, CAST(N'2011-02-25' AS date), CAST(N'2011-02-26' AS date), 2011, 20111, 201102, 2011056, 1, 2, 56, 25, 6, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-02-25' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-02-19' AS date), CAST(N'2011-02-25' AS date), 1032, 3097, 13468, 13469, 13469, 13469, 13469, 13469, 13468, 2455618, 55617, N'2011-02-25', 201108, 8, 5, N'2011-W08', N'2011-W08-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94288, CAST(N'2011-02-26' AS date), CAST(N'2011-02-27' AS date), 2011, 20111, 201102, 2011057, 1, 2, 57, 26, 7, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-20' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-02-25' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-03-04' AS date), 1032, 3097, 13468, 13469, 13469, 13469, 13469, 13469, 13469, 2455619, 55618, N'2011-02-26', 201108, 8, 6, N'2011-W08', N'2011-W08-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94289, CAST(N'2011-02-27' AS date), CAST(N'2011-02-28' AS date), 2011, 20111, 201102, 2011058, 1, 2, 58, 27, 1, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-02-21' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-02-25' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-03-04' AS date), 1032, 3097, 13469, 13469, 13469, 13469, 13469, 13469, 13469, 2455620, 55619, N'2011-02-27', 201108, 8, 7, N'2011-W08', N'2011-W08-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94290, CAST(N'2011-02-28' AS date), CAST(N'2011-03-01' AS date), 2011, 20111, 201102, 2011059, 1, 2, 59, 28, 2, N'2011', N'2011 Q1', N'2011 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-01' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-02-22' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-02-25' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-03-04' AS date), 1032, 3097, 13469, 13470, 13469, 13469, 13469, 13469, 13469, 2455621, 55620, N'2011-02-28', 201109, 9, 1, N'2011-W09', N'2011-W09-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94291, CAST(N'2011-03-01' AS date), CAST(N'2011-03-02' AS date), 2011, 20111, 201103, 2011060, 1, 3, 60, 1, 3, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-02-23' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-02-25' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-03-04' AS date), 1032, 3098, 13469, 13470, 13470, 13469, 13469, 13469, 13469, 2455622, 55621, N'2011-03-01', 201109, 9, 2, N'2011-W09', N'2011-W09-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94292, CAST(N'2011-03-02' AS date), CAST(N'2011-03-03' AS date), 2011, 20111, 201103, 2011061, 1, 3, 61, 2, 4, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-02-24' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-02-25' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-03-04' AS date), 1032, 3098, 13469, 13470, 13470, 13470, 13469, 13469, 13469, 2455623, 55622, N'2011-03-02', 201109, 9, 3, N'2011-W09', N'2011-W09-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94293, CAST(N'2011-03-03' AS date), CAST(N'2011-03-04' AS date), 2011, 20111, 201103, 2011062, 1, 3, 62, 3, 5, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-02-25' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-03-04' AS date), 1032, 3098, 13469, 13470, 13470, 13470, 13470, 13469, 13469, 2455624, 55623, N'2011-03-03', 201109, 9, 4, N'2011-W09', N'2011-W09-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94294, CAST(N'2011-03-04' AS date), CAST(N'2011-03-05' AS date), 2011, 20111, 201103, 2011063, 1, 3, 63, 4, 6, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-04' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-02-26' AS date), CAST(N'2011-03-04' AS date), 1032, 3098, 13469, 13470, 13470, 13470, 13470, 13470, 13469, 2455625, 55624, N'2011-03-04', 201109, 9, 5, N'2011-W09', N'2011-W09-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94295, CAST(N'2011-03-05' AS date), CAST(N'2011-03-06' AS date), 2011, 20111, 201103, 2011064, 1, 3, 64, 5, 7, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-02-27' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-04' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-03-11' AS date), 1032, 3098, 13469, 13470, 13470, 13470, 13470, 13470, 13470, 2455626, 55625, N'2011-03-05', 201109, 9, 6, N'2011-W09', N'2011-W09-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94296, CAST(N'2011-03-06' AS date), CAST(N'2011-03-07' AS date), 2011, 20111, 201103, 2011065, 1, 3, 65, 6, 1, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-02-28' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-04' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-03-11' AS date), 1032, 3098, 13470, 13470, 13470, 13470, 13470, 13470, 13470, 2455627, 55626, N'2011-03-06', 201109, 9, 7, N'2011-W09', N'2011-W09-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94297, CAST(N'2011-03-07' AS date), CAST(N'2011-03-08' AS date), 2011, 20111, 201103, 2011066, 1, 3, 66, 7, 2, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-04' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-03-11' AS date), 1032, 3098, 13470, 13471, 13470, 13470, 13470, 13470, 13470, 2455628, 55627, N'2011-03-07', 201110, 10, 1, N'2011-W10', N'2011-W10-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94298, CAST(N'2011-03-08' AS date), CAST(N'2011-03-09' AS date), 2011, 20111, 201103, 2011067, 1, 3, 67, 8, 3, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-02' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-04' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-03-11' AS date), 1032, 3098, 13470, 13471, 13471, 13470, 13470, 13470, 13470, 2455629, 55628, N'2011-03-08', 201110, 10, 2, N'2011-W10', N'2011-W10-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94299, CAST(N'2011-03-09' AS date), CAST(N'2011-03-10' AS date), 2011, 20111, 201103, 2011068, 1, 3, 68, 9, 4, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-03' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-04' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-03-11' AS date), 1032, 3098, 13470, 13471, 13471, 13471, 13470, 13470, 13470, 2455630, 55629, N'2011-03-09', 201110, 10, 3, N'2011-W10', N'2011-W10-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94300, CAST(N'2011-03-10' AS date), CAST(N'2011-03-11' AS date), 2011, 20111, 201103, 2011069, 1, 3, 69, 10, 5, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-04' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-03-11' AS date), 1032, 3098, 13470, 13471, 13471, 13471, 13471, 13470, 13470, 2455631, 55630, N'2011-03-10', 201110, 10, 4, N'2011-W10', N'2011-W10-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94301, CAST(N'2011-03-11' AS date), CAST(N'2011-03-12' AS date), 2011, 20111, 201103, 2011070, 1, 3, 70, 11, 6, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-11' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-05' AS date), CAST(N'2011-03-11' AS date), 1032, 3098, 13470, 13471, 13471, 13471, 13471, 13471, 13470, 2455632, 55631, N'2011-03-11', 201110, 10, 5, N'2011-W10', N'2011-W10-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94302, CAST(N'2011-03-12' AS date), CAST(N'2011-03-13' AS date), 2011, 20111, 201103, 2011071, 1, 3, 71, 12, 7, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-06' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-11' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-18' AS date), 1032, 3098, 13470, 13471, 13471, 13471, 13471, 13471, 13471, 2455633, 55632, N'2011-03-12', 201110, 10, 6, N'2011-W10', N'2011-W10-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94303, CAST(N'2011-03-13' AS date), CAST(N'2011-03-14' AS date), 2011, 20111, 201103, 2011072, 1, 3, 72, 13, 1, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-07' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-11' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-18' AS date), 1032, 3098, 13471, 13471, 13471, 13471, 13471, 13471, 13471, 2455634, 55633, N'2011-03-13', 201110, 10, 7, N'2011-W10', N'2011-W10-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94304, CAST(N'2011-03-14' AS date), CAST(N'2011-03-15' AS date), 2011, 20111, 201103, 2011073, 1, 3, 73, 14, 2, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-08' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-11' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-18' AS date), 1032, 3098, 13471, 13472, 13471, 13471, 13471, 13471, 13471, 2455635, 55634, N'2011-03-14', 201111, 11, 1, N'2011-W11', N'2011-W11-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94305, CAST(N'2011-03-15' AS date), CAST(N'2011-03-16' AS date), 2011, 20111, 201103, 2011074, 1, 3, 74, 15, 3, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-09' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-11' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-18' AS date), 1032, 3098, 13471, 13472, 13472, 13471, 13471, 13471, 13471, 2455636, 55635, N'2011-03-15', 201111, 11, 2, N'2011-W11', N'2011-W11-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94306, CAST(N'2011-03-16' AS date), CAST(N'2011-03-17' AS date), 2011, 20111, 201103, 2011075, 1, 3, 75, 16, 4, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-10' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-11' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-18' AS date), 1032, 3098, 13471, 13472, 13472, 13472, 13471, 13471, 13471, 2455637, 55636, N'2011-03-16', 201111, 11, 3, N'2011-W11', N'2011-W11-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94307, CAST(N'2011-03-17' AS date), CAST(N'2011-03-18' AS date), 2011, 20111, 201103, 2011076, 1, 3, 76, 17, 5, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-11' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-18' AS date), 1032, 3098, 13471, 13472, 13472, 13472, 13472, 13471, 13471, 2455638, 55637, N'2011-03-17', 201111, 11, 4, N'2011-W11', N'2011-W11-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94308, CAST(N'2011-03-18' AS date), CAST(N'2011-03-19' AS date), 2011, 20111, 201103, 2011077, 1, 3, 77, 18, 6, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-18' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-12' AS date), CAST(N'2011-03-18' AS date), 1032, 3098, 13471, 13472, 13472, 13472, 13472, 13472, 13471, 2455639, 55638, N'2011-03-18', 201111, 11, 5, N'2011-W11', N'2011-W11-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94309, CAST(N'2011-03-19' AS date), CAST(N'2011-03-20' AS date), 2011, 20111, 201103, 2011078, 1, 3, 78, 19, 7, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-13' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-18' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-25' AS date), 1032, 3098, 13471, 13472, 13472, 13472, 13472, 13472, 13472, 2455640, 55639, N'2011-03-19', 201111, 11, 6, N'2011-W11', N'2011-W11-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94310, CAST(N'2011-03-20' AS date), CAST(N'2011-03-21' AS date), 2011, 20111, 201103, 2011079, 1, 3, 79, 20, 1, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-03-14' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-18' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-25' AS date), 1032, 3098, 13472, 13472, 13472, 13472, 13472, 13472, 13472, 2455641, 55640, N'2011-03-20', 201111, 11, 7, N'2011-W11', N'2011-W11-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94311, CAST(N'2011-03-21' AS date), CAST(N'2011-03-22' AS date), 2011, 20111, 201103, 2011080, 1, 3, 80, 21, 2, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-03-15' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-18' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-25' AS date), 1032, 3098, 13472, 13473, 13472, 13472, 13472, 13472, 13472, 2455642, 55641, N'2011-03-21', 201112, 12, 1, N'2011-W12', N'2011-W12-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94312, CAST(N'2011-03-22' AS date), CAST(N'2011-03-23' AS date), 2011, 20111, 201103, 2011081, 1, 3, 81, 22, 3, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-03-16' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-18' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-25' AS date), 1032, 3098, 13472, 13473, 13473, 13472, 13472, 13472, 13472, 2455643, 55642, N'2011-03-22', 201112, 12, 2, N'2011-W12', N'2011-W12-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94313, CAST(N'2011-03-23' AS date), CAST(N'2011-03-24' AS date), 2011, 20111, 201103, 2011082, 1, 3, 82, 23, 4, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-03-17' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-18' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-25' AS date), 1032, 3098, 13472, 13473, 13473, 13473, 13472, 13472, 13472, 2455644, 55643, N'2011-03-23', 201112, 12, 3, N'2011-W12', N'2011-W12-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94314, CAST(N'2011-03-24' AS date), CAST(N'2011-03-25' AS date), 2011, 20111, 201103, 2011083, 1, 3, 83, 24, 5, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-03-18' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-25' AS date), 1032, 3098, 13472, 13473, 13473, 13473, 13473, 13472, 13472, 2455645, 55644, N'2011-03-24', 201112, 12, 4, N'2011-W12', N'2011-W12-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94315, CAST(N'2011-03-25' AS date), CAST(N'2011-03-26' AS date), 2011, 20111, 201103, 2011084, 1, 3, 84, 25, 6, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-03-25' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-19' AS date), CAST(N'2011-03-25' AS date), 1032, 3098, 13472, 13473, 13473, 13473, 13473, 13473, 13472, 2455646, 55645, N'2011-03-25', 201112, 12, 5, N'2011-W12', N'2011-W12-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94316, CAST(N'2011-03-26' AS date), CAST(N'2011-03-27' AS date), 2011, 20111, 201103, 2011085, 1, 3, 85, 26, 7, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-20' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-03-25' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-04-01' AS date), 1032, 3098, 13472, 13473, 13473, 13473, 13473, 13473, 13473, 2455647, 55646, N'2011-03-26', 201112, 12, 6, N'2011-W12', N'2011-W12-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94317, CAST(N'2011-03-27' AS date), CAST(N'2011-03-28' AS date), 2011, 20111, 201103, 2011086, 1, 3, 86, 27, 1, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-03-21' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-03-25' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-04-01' AS date), 1032, 3098, 13473, 13473, 13473, 13473, 13473, 13473, 13473, 2455648, 55647, N'2011-03-27', 201112, 12, 7, N'2011-W12', N'2011-W12-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94318, CAST(N'2011-03-28' AS date), CAST(N'2011-03-29' AS date), 2011, 20111, 201103, 2011087, 1, 3, 87, 28, 2, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-03-22' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-03-25' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-04-01' AS date), 1032, 3098, 13473, 13474, 13473, 13473, 13473, 13473, 13473, 2455649, 55648, N'2011-03-28', 201113, 13, 1, N'2011-W13', N'2011-W13-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94319, CAST(N'2011-03-29' AS date), CAST(N'2011-03-30' AS date), 2011, 20111, 201103, 2011088, 1, 3, 88, 29, 3, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-03-23' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-03-25' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-04-01' AS date), 1032, 3098, 13473, 13474, 13474, 13473, 13473, 13473, 13473, 2455650, 55649, N'2011-03-29', 201113, 13, 2, N'2011-W13', N'2011-W13-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94320, CAST(N'2011-03-30' AS date), CAST(N'2011-03-31' AS date), 2011, 20111, 201103, 2011089, 1, 3, 89, 30, 4, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-03-24' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-03-25' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-04-01' AS date), 1032, 3098, 13473, 13474, 13474, 13474, 13473, 13473, 13473, 2455651, 55650, N'2011-03-30', 201113, 13, 3, N'2011-W13', N'2011-W13-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94321, CAST(N'2011-03-31' AS date), CAST(N'2011-04-01' AS date), 2011, 20111, 201103, 2011090, 1, 3, 90, 31, 5, N'2011', N'2011 Q1', N'2011 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-01-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-01' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-03-25' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-04-01' AS date), 1032, 3098, 13473, 13474, 13474, 13474, 13474, 13473, 13473, 2455652, 55651, N'2011-03-31', 201113, 13, 4, N'2011-W13', N'2011-W13-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94322, CAST(N'2011-04-01' AS date), CAST(N'2011-04-02' AS date), 2011, 20112, 201104, 2011091, 2, 4, 91, 1, 6, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-03-26' AS date), CAST(N'2011-04-01' AS date), 1033, 3099, 13473, 13474, 13474, 13474, 13474, 13474, 13473, 2455653, 55652, N'2011-04-01', 201113, 13, 5, N'2011-W13', N'2011-W13-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94323, CAST(N'2011-04-02' AS date), CAST(N'2011-04-03' AS date), 2011, 20112, 201104, 2011092, 2, 4, 92, 2, 7, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-03-27' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-04-08' AS date), 1033, 3099, 13473, 13474, 13474, 13474, 13474, 13474, 13474, 2455654, 55653, N'2011-04-02', 201113, 13, 6, N'2011-W13', N'2011-W13-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94324, CAST(N'2011-04-03' AS date), CAST(N'2011-04-04' AS date), 2011, 20112, 201104, 2011093, 2, 4, 93, 3, 1, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-03-28' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-04-08' AS date), 1033, 3099, 13474, 13474, 13474, 13474, 13474, 13474, 13474, 2455655, 55654, N'2011-04-03', 201113, 13, 7, N'2011-W13', N'2011-W13-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94325, CAST(N'2011-04-04' AS date), CAST(N'2011-04-05' AS date), 2011, 20112, 201104, 2011094, 2, 4, 94, 4, 2, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-03-29' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-04-08' AS date), 1033, 3099, 13474, 13475, 13474, 13474, 13474, 13474, 13474, 2455656, 55655, N'2011-04-04', 201114, 14, 1, N'2011-W14', N'2011-W14-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94326, CAST(N'2011-04-05' AS date), CAST(N'2011-04-06' AS date), 2011, 20112, 201104, 2011095, 2, 4, 95, 5, 3, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-03-30' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-04-08' AS date), 1033, 3099, 13474, 13475, 13475, 13474, 13474, 13474, 13474, 2455657, 55656, N'2011-04-05', 201114, 14, 2, N'2011-W14', N'2011-W14-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94327, CAST(N'2011-04-06' AS date), CAST(N'2011-04-07' AS date), 2011, 20112, 201104, 2011096, 2, 4, 96, 6, 4, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-03-31' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-04-08' AS date), 1033, 3099, 13474, 13475, 13475, 13475, 13474, 13474, 13474, 2455658, 55657, N'2011-04-06', 201114, 14, 3, N'2011-W14', N'2011-W14-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94328, CAST(N'2011-04-07' AS date), CAST(N'2011-04-08' AS date), 2011, 20112, 201104, 2011097, 2, 4, 97, 7, 5, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-04-08' AS date), 1033, 3099, 13474, 13475, 13475, 13475, 13475, 13474, 13474, 2455659, 55658, N'2011-04-07', 201114, 14, 4, N'2011-W14', N'2011-W14-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94329, CAST(N'2011-04-08' AS date), CAST(N'2011-04-09' AS date), 2011, 20112, 201104, 2011098, 2, 4, 98, 8, 6, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-08' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-02' AS date), CAST(N'2011-04-08' AS date), 1033, 3099, 13474, 13475, 13475, 13475, 13475, 13475, 13474, 2455660, 55659, N'2011-04-08', 201114, 14, 5, N'2011-W14', N'2011-W14-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94330, CAST(N'2011-04-09' AS date), CAST(N'2011-04-10' AS date), 2011, 20112, 201104, 2011099, 2, 4, 99, 9, 7, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-03' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-08' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-15' AS date), 1033, 3099, 13474, 13475, 13475, 13475, 13475, 13475, 13475, 2455661, 55660, N'2011-04-09', 201114, 14, 6, N'2011-W14', N'2011-W14-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94331, CAST(N'2011-04-10' AS date), CAST(N'2011-04-11' AS date), 2011, 20112, 201104, 2011100, 2, 4, 100, 10, 1, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-04' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-08' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-15' AS date), 1033, 3099, 13475, 13475, 13475, 13475, 13475, 13475, 13475, 2455662, 55661, N'2011-04-10', 201114, 14, 7, N'2011-W14', N'2011-W14-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94332, CAST(N'2011-04-11' AS date), CAST(N'2011-04-12' AS date), 2011, 20112, 201104, 2011101, 2, 4, 101, 11, 2, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-05' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-08' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-15' AS date), 1033, 3099, 13475, 13476, 13475, 13475, 13475, 13475, 13475, 2455663, 55662, N'2011-04-11', 201115, 15, 1, N'2011-W15', N'2011-W15-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94333, CAST(N'2011-04-12' AS date), CAST(N'2011-04-13' AS date), 2011, 20112, 201104, 2011102, 2, 4, 102, 12, 3, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-06' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-08' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-15' AS date), 1033, 3099, 13475, 13476, 13476, 13475, 13475, 13475, 13475, 2455664, 55663, N'2011-04-12', 201115, 15, 2, N'2011-W15', N'2011-W15-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94334, CAST(N'2011-04-13' AS date), CAST(N'2011-04-14' AS date), 2011, 20112, 201104, 2011103, 2, 4, 103, 13, 4, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-07' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-08' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-15' AS date), 1033, 3099, 13475, 13476, 13476, 13476, 13475, 13475, 13475, 2455665, 55664, N'2011-04-13', 201115, 15, 3, N'2011-W15', N'2011-W15-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94335, CAST(N'2011-04-14' AS date), CAST(N'2011-04-15' AS date), 2011, 20112, 201104, 2011104, 2, 4, 104, 14, 5, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-08' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-15' AS date), 1033, 3099, 13475, 13476, 13476, 13476, 13476, 13475, 13475, 2455666, 55665, N'2011-04-14', 201115, 15, 4, N'2011-W15', N'2011-W15-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94336, CAST(N'2011-04-15' AS date), CAST(N'2011-04-16' AS date), 2011, 20112, 201104, 2011105, 2, 4, 105, 15, 6, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-15' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-09' AS date), CAST(N'2011-04-15' AS date), 1033, 3099, 13475, 13476, 13476, 13476, 13476, 13476, 13475, 2455667, 55666, N'2011-04-15', 201115, 15, 5, N'2011-W15', N'2011-W15-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94337, CAST(N'2011-04-16' AS date), CAST(N'2011-04-17' AS date), 2011, 20112, 201104, 2011106, 2, 4, 106, 16, 7, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-10' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-15' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-22' AS date), 1033, 3099, 13475, 13476, 13476, 13476, 13476, 13476, 13476, 2455668, 55667, N'2011-04-16', 201115, 15, 6, N'2011-W15', N'2011-W15-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94338, CAST(N'2011-04-17' AS date), CAST(N'2011-04-18' AS date), 2011, 20112, 201104, 2011107, 2, 4, 107, 17, 1, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-11' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-15' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-22' AS date), 1033, 3099, 13476, 13476, 13476, 13476, 13476, 13476, 13476, 2455669, 55668, N'2011-04-17', 201115, 15, 7, N'2011-W15', N'2011-W15-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94339, CAST(N'2011-04-18' AS date), CAST(N'2011-04-19' AS date), 2011, 20112, 201104, 2011108, 2, 4, 108, 18, 2, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-12' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-15' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-22' AS date), 1033, 3099, 13476, 13477, 13476, 13476, 13476, 13476, 13476, 2455670, 55669, N'2011-04-18', 201116, 16, 1, N'2011-W16', N'2011-W16-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94340, CAST(N'2011-04-19' AS date), CAST(N'2011-04-20' AS date), 2011, 20112, 201104, 2011109, 2, 4, 109, 19, 3, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-04-13' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-15' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-22' AS date), 1033, 3099, 13476, 13477, 13477, 13476, 13476, 13476, 13476, 2455671, 55670, N'2011-04-19', 201116, 16, 2, N'2011-W16', N'2011-W16-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94341, CAST(N'2011-04-20' AS date), CAST(N'2011-04-21' AS date), 2011, 20112, 201104, 2011110, 2, 4, 110, 20, 4, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-04-14' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-15' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-22' AS date), 1033, 3099, 13476, 13477, 13477, 13477, 13476, 13476, 13476, 2455672, 55671, N'2011-04-20', 201116, 16, 3, N'2011-W16', N'2011-W16-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94342, CAST(N'2011-04-21' AS date), CAST(N'2011-04-22' AS date), 2011, 20112, 201104, 2011111, 2, 4, 111, 21, 5, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-04-15' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-22' AS date), 1033, 3099, 13476, 13477, 13477, 13477, 13477, 13476, 13476, 2455673, 55672, N'2011-04-21', 201116, 16, 4, N'2011-W16', N'2011-W16-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94343, CAST(N'2011-04-22' AS date), CAST(N'2011-04-23' AS date), 2011, 20112, 201104, 2011112, 2, 4, 112, 22, 6, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-04-22' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-04-16' AS date), CAST(N'2011-04-22' AS date), 1033, 3099, 13476, 13477, 13477, 13477, 13477, 13477, 13476, 2455674, 55673, N'2011-04-22', 201116, 16, 5, N'2011-W16', N'2011-W16-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94344, CAST(N'2011-04-23' AS date), CAST(N'2011-04-24' AS date), 2011, 20112, 201104, 2011113, 2, 4, 113, 23, 7, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-17' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-04-22' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-29' AS date), 1033, 3099, 13476, 13477, 13477, 13477, 13477, 13477, 13477, 2455675, 55674, N'2011-04-23', 201116, 16, 6, N'2011-W16', N'2011-W16-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94345, CAST(N'2011-04-24' AS date), CAST(N'2011-04-25' AS date), 2011, 20112, 201104, 2011114, 2, 4, 114, 24, 1, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-18' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-04-22' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-29' AS date), 1033, 3099, 13477, 13477, 13477, 13477, 13477, 13477, 13477, 2455676, 55675, N'2011-04-24', 201116, 16, 7, N'2011-W16', N'2011-W16-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94346, CAST(N'2011-04-25' AS date), CAST(N'2011-04-26' AS date), 2011, 20112, 201104, 2011115, 2, 4, 115, 25, 2, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-04-19' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-04-22' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-29' AS date), 1033, 3099, 13477, 13478, 13477, 13477, 13477, 13477, 13477, 2455677, 55676, N'2011-04-25', 201117, 17, 1, N'2011-W17', N'2011-W17-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94347, CAST(N'2011-04-26' AS date), CAST(N'2011-04-27' AS date), 2011, 20112, 201104, 2011116, 2, 4, 116, 26, 3, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-04-20' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-04-22' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-29' AS date), 1033, 3099, 13477, 13478, 13478, 13477, 13477, 13477, 13477, 2455678, 55677, N'2011-04-26', 201117, 17, 2, N'2011-W17', N'2011-W17-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94348, CAST(N'2011-04-27' AS date), CAST(N'2011-04-28' AS date), 2011, 20112, 201104, 2011117, 2, 4, 117, 27, 4, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-04-21' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-04-22' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-29' AS date), 1033, 3099, 13477, 13478, 13478, 13478, 13477, 13477, 13477, 2455679, 55678, N'2011-04-27', 201117, 17, 3, N'2011-W17', N'2011-W17-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94349, CAST(N'2011-04-28' AS date), CAST(N'2011-04-29' AS date), 2011, 20112, 201104, 2011118, 2, 4, 118, 28, 5, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-04-22' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-29' AS date), 1033, 3099, 13477, 13478, 13478, 13478, 13478, 13477, 13477, 2455680, 55679, N'2011-04-28', 201117, 17, 4, N'2011-W17', N'2011-W17-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94350, CAST(N'2011-04-29' AS date), CAST(N'2011-04-30' AS date), 2011, 20112, 201104, 2011119, 2, 4, 119, 29, 6, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-04-29' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-04-23' AS date), CAST(N'2011-04-29' AS date), 1033, 3099, 13477, 13478, 13478, 13478, 13478, 13478, 13477, 2455681, 55680, N'2011-04-29', 201117, 17, 5, N'2011-W17', N'2011-W17-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94351, CAST(N'2011-04-30' AS date), CAST(N'2011-05-01' AS date), 2011, 20112, 201104, 2011120, 2, 4, 120, 30, 7, N'2011', N'2011 Q2', N'2011 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-24' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-04-29' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-05-06' AS date), 1033, 3099, 13477, 13478, 13478, 13478, 13478, 13478, 13478, 2455682, 55681, N'2011-04-30', 201117, 17, 6, N'2011-W17', N'2011-W17-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94352, CAST(N'2011-05-01' AS date), CAST(N'2011-05-02' AS date), 2011, 20112, 201105, 2011121, 2, 5, 121, 1, 1, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-04-25' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-04-29' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-05-06' AS date), 1033, 3100, 13478, 13478, 13478, 13478, 13478, 13478, 13478, 2455683, 55682, N'2011-05-01', 201117, 17, 7, N'2011-W17', N'2011-W17-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94353, CAST(N'2011-05-02' AS date), CAST(N'2011-05-03' AS date), 2011, 20112, 201105, 2011122, 2, 5, 122, 2, 2, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-04-26' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-04-29' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-05-06' AS date), 1033, 3100, 13478, 13479, 13478, 13478, 13478, 13478, 13478, 2455684, 55683, N'2011-05-02', 201118, 18, 1, N'2011-W18', N'2011-W18-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94354, CAST(N'2011-05-03' AS date), CAST(N'2011-05-04' AS date), 2011, 20112, 201105, 2011123, 2, 5, 123, 3, 3, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-04-27' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-04-29' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-05-06' AS date), 1033, 3100, 13478, 13479, 13479, 13478, 13478, 13478, 13478, 2455685, 55684, N'2011-05-03', 201118, 18, 2, N'2011-W18', N'2011-W18-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94355, CAST(N'2011-05-04' AS date), CAST(N'2011-05-05' AS date), 2011, 20112, 201105, 2011124, 2, 5, 124, 4, 4, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-04-28' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-04-29' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-05-06' AS date), 1033, 3100, 13478, 13479, 13479, 13479, 13478, 13478, 13478, 2455686, 55685, N'2011-05-04', 201118, 18, 3, N'2011-W18', N'2011-W18-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94356, CAST(N'2011-05-05' AS date), CAST(N'2011-05-06' AS date), 2011, 20112, 201105, 2011125, 2, 5, 125, 5, 5, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-04-29' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-05-06' AS date), 1033, 3100, 13478, 13479, 13479, 13479, 13479, 13478, 13478, 2455687, 55686, N'2011-05-05', 201118, 18, 4, N'2011-W18', N'2011-W18-4');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94357, CAST(N'2011-05-06' AS date), CAST(N'2011-05-07' AS date), 2011, 20112, 201105, 2011126, 2, 5, 126, 6, 6, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-06' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-04-30' AS date), CAST(N'2011-05-06' AS date), 1033, 3100, 13478, 13479, 13479, 13479, 13479, 13479, 13478, 2455688, 55687, N'2011-05-06', 201118, 18, 5, N'2011-W18', N'2011-W18-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94358, CAST(N'2011-05-07' AS date), CAST(N'2011-05-08' AS date), 2011, 20112, 201105, 2011127, 2, 5, 127, 7, 7, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-06' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-13' AS date), 1033, 3100, 13478, 13479, 13479, 13479, 13479, 13479, 13479, 2455689, 55688, N'2011-05-07', 201118, 18, 6, N'2011-W18', N'2011-W18-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94359, CAST(N'2011-05-08' AS date), CAST(N'2011-05-09' AS date), 2011, 20112, 201105, 2011128, 2, 5, 128, 8, 1, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-02' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-06' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-13' AS date), 1033, 3100, 13479, 13479, 13479, 13479, 13479, 13479, 13479, 2455690, 55689, N'2011-05-08', 201118, 18, 7, N'2011-W18', N'2011-W18-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94360, CAST(N'2011-05-09' AS date), CAST(N'2011-05-10' AS date), 2011, 20112, 201105, 2011129, 2, 5, 129, 9, 2, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-03' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-06' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-13' AS date), 1033, 3100, 13479, 13480, 13479, 13479, 13479, 13479, 13479, 2455691, 55690, N'2011-05-09', 201119, 19, 1, N'2011-W19', N'2011-W19-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94361, CAST(N'2011-05-10' AS date), CAST(N'2011-05-11' AS date), 2011, 20112, 201105, 2011130, 2, 5, 130, 10, 3, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-04' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-06' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-13' AS date), 1033, 3100, 13479, 13480, 13480, 13479, 13479, 13479, 13479, 2455692, 55691, N'2011-05-10', 201119, 19, 2, N'2011-W19', N'2011-W19-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94362, CAST(N'2011-05-11' AS date), CAST(N'2011-05-12' AS date), 2011, 20112, 201105, 2011131, 2, 5, 131, 11, 4, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-05' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-06' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-13' AS date), 1033, 3100, 13479, 13480, 13480, 13480, 13479, 13479, 13479, 2455693, 55692, N'2011-05-11', 201119, 19, 3, N'2011-W19', N'2011-W19-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94363, CAST(N'2011-05-12' AS date), CAST(N'2011-05-13' AS date), 2011, 20112, 201105, 2011132, 2, 5, 132, 12, 5, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-06' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-13' AS date), 1033, 3100, 13479, 13480, 13480, 13480, 13480, 13479, 13479, 2455694, 55693, N'2011-05-12', 201119, 19, 4, N'2011-W19', N'2011-W19-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94364, CAST(N'2011-05-13' AS date), CAST(N'2011-05-14' AS date), 2011, 20112, 201105, 2011133, 2, 5, 133, 13, 6, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-13' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-07' AS date), CAST(N'2011-05-13' AS date), 1033, 3100, 13479, 13480, 13480, 13480, 13480, 13480, 13479, 2455695, 55694, N'2011-05-13', 201119, 19, 5, N'2011-W19', N'2011-W19-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94365, CAST(N'2011-05-14' AS date), CAST(N'2011-05-15' AS date), 2011, 20112, 201105, 2011134, 2, 5, 134, 14, 7, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-08' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-13' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-20' AS date), 1033, 3100, 13479, 13480, 13480, 13480, 13480, 13480, 13480, 2455696, 55695, N'2011-05-14', 201119, 19, 6, N'2011-W19', N'2011-W19-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94366, CAST(N'2011-05-15' AS date), CAST(N'2011-05-16' AS date), 2011, 20112, 201105, 2011135, 2, 5, 135, 15, 1, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-09' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-13' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-20' AS date), 1033, 3100, 13480, 13480, 13480, 13480, 13480, 13480, 13480, 2455697, 55696, N'2011-05-15', 201119, 19, 7, N'2011-W19', N'2011-W19-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94367, CAST(N'2011-05-16' AS date), CAST(N'2011-05-17' AS date), 2011, 20112, 201105, 2011136, 2, 5, 136, 16, 2, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-10' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-13' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-20' AS date), 1033, 3100, 13480, 13481, 13480, 13480, 13480, 13480, 13480, 2455698, 55697, N'2011-05-16', 201120, 20, 1, N'2011-W20', N'2011-W20-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94368, CAST(N'2011-05-17' AS date), CAST(N'2011-05-18' AS date), 2011, 20112, 201105, 2011137, 2, 5, 137, 17, 3, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-11' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-13' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-20' AS date), 1033, 3100, 13480, 13481, 13481, 13480, 13480, 13480, 13480, 2455699, 55698, N'2011-05-17', 201120, 20, 2, N'2011-W20', N'2011-W20-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94369, CAST(N'2011-05-18' AS date), CAST(N'2011-05-19' AS date), 2011, 20112, 201105, 2011138, 2, 5, 138, 18, 4, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-12' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-13' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-20' AS date), 1033, 3100, 13480, 13481, 13481, 13481, 13480, 13480, 13480, 2455700, 55699, N'2011-05-18', 201120, 20, 3, N'2011-W20', N'2011-W20-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94370, CAST(N'2011-05-19' AS date), CAST(N'2011-05-20' AS date), 2011, 20112, 201105, 2011139, 2, 5, 139, 19, 5, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-13' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-20' AS date), 1033, 3100, 13480, 13481, 13481, 13481, 13481, 13480, 13480, 2455701, 55700, N'2011-05-19', 201120, 20, 4, N'2011-W20', N'2011-W20-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94371, CAST(N'2011-05-20' AS date), CAST(N'2011-05-21' AS date), 2011, 20112, 201105, 2011140, 2, 5, 140, 20, 6, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-20' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-05-14' AS date), CAST(N'2011-05-20' AS date), 1033, 3100, 13480, 13481, 13481, 13481, 13481, 13481, 13480, 2455702, 55701, N'2011-05-20', 201120, 20, 5, N'2011-W20', N'2011-W20-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94372, CAST(N'2011-05-21' AS date), CAST(N'2011-05-22' AS date), 2011, 20112, 201105, 2011141, 2, 5, 141, 21, 7, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-15' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-20' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-27' AS date), 1033, 3100, 13480, 13481, 13481, 13481, 13481, 13481, 13481, 2455703, 55702, N'2011-05-21', 201120, 20, 6, N'2011-W20', N'2011-W20-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94373, CAST(N'2011-05-22' AS date), CAST(N'2011-05-23' AS date), 2011, 20112, 201105, 2011142, 2, 5, 142, 22, 1, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-05-16' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-20' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-27' AS date), 1033, 3100, 13481, 13481, 13481, 13481, 13481, 13481, 13481, 2455704, 55703, N'2011-05-22', 201120, 20, 7, N'2011-W20', N'2011-W20-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94374, CAST(N'2011-05-23' AS date), CAST(N'2011-05-24' AS date), 2011, 20112, 201105, 2011143, 2, 5, 143, 23, 2, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-05-17' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-20' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-27' AS date), 1033, 3100, 13481, 13482, 13481, 13481, 13481, 13481, 13481, 2455705, 55704, N'2011-05-23', 201121, 21, 1, N'2011-W21', N'2011-W21-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94375, CAST(N'2011-05-24' AS date), CAST(N'2011-05-25' AS date), 2011, 20112, 201105, 2011144, 2, 5, 144, 24, 3, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-05-18' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-20' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-27' AS date), 1033, 3100, 13481, 13482, 13482, 13481, 13481, 13481, 13481, 2455706, 55705, N'2011-05-24', 201121, 21, 2, N'2011-W21', N'2011-W21-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94376, CAST(N'2011-05-25' AS date), CAST(N'2011-05-26' AS date), 2011, 20112, 201105, 2011145, 2, 5, 145, 25, 4, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-19' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-20' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-27' AS date), 1033, 3100, 13481, 13482, 13482, 13482, 13481, 13481, 13481, 2455707, 55706, N'2011-05-25', 201121, 21, 3, N'2011-W21', N'2011-W21-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94377, CAST(N'2011-05-26' AS date), CAST(N'2011-05-27' AS date), 2011, 20112, 201105, 2011146, 2, 5, 146, 26, 5, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-05-20' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-27' AS date), 1033, 3100, 13481, 13482, 13482, 13482, 13482, 13481, 13481, 2455708, 55707, N'2011-05-26', 201121, 21, 4, N'2011-W21', N'2011-W21-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94378, CAST(N'2011-05-27' AS date), CAST(N'2011-05-28' AS date), 2011, 20112, 201105, 2011147, 2, 5, 147, 27, 6, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-05-27' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-05-21' AS date), CAST(N'2011-05-27' AS date), 1033, 3100, 13481, 13482, 13482, 13482, 13482, 13482, 13481, 2455709, 55708, N'2011-05-27', 201121, 21, 5, N'2011-W21', N'2011-W21-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94379, CAST(N'2011-05-28' AS date), CAST(N'2011-05-29' AS date), 2011, 20112, 201105, 2011148, 2, 5, 148, 28, 7, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-22' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-05-27' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-06-03' AS date), 1033, 3100, 13481, 13482, 13482, 13482, 13482, 13482, 13482, 2455710, 55709, N'2011-05-28', 201121, 21, 6, N'2011-W21', N'2011-W21-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94380, CAST(N'2011-05-29' AS date), CAST(N'2011-05-30' AS date), 2011, 20112, 201105, 2011149, 2, 5, 149, 29, 1, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-05-23' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-05-27' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-06-03' AS date), 1033, 3100, 13482, 13482, 13482, 13482, 13482, 13482, 13482, 2455711, 55710, N'2011-05-29', 201121, 21, 7, N'2011-W21', N'2011-W21-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94381, CAST(N'2011-05-30' AS date), CAST(N'2011-05-31' AS date), 2011, 20112, 201105, 2011150, 2, 5, 150, 30, 2, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-05-24' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-05-27' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-06-03' AS date), 1033, 3100, 13482, 13483, 13482, 13482, 13482, 13482, 13482, 2455712, 55711, N'2011-05-30', 201122, 22, 1, N'2011-W22', N'2011-W22-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94382, CAST(N'2011-05-31' AS date), CAST(N'2011-06-01' AS date), 2011, 20112, 201105, 2011151, 2, 5, 151, 31, 3, N'2011', N'2011 Q2', N'2011 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-01' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-05-25' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-05-27' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-06-03' AS date), 1033, 3100, 13482, 13483, 13483, 13482, 13482, 13482, 13482, 2455713, 55712, N'2011-05-31', 201122, 22, 2, N'2011-W22', N'2011-W22-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94383, CAST(N'2011-06-01' AS date), CAST(N'2011-06-02' AS date), 2011, 20112, 201106, 2011152, 2, 6, 152, 1, 4, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-05-26' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-05-27' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-06-03' AS date), 1033, 3101, 13482, 13483, 13483, 13483, 13482, 13482, 13482, 2455714, 55713, N'2011-06-01', 201122, 22, 3, N'2011-W22', N'2011-W22-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94384, CAST(N'2011-06-02' AS date), CAST(N'2011-06-03' AS date), 2011, 20112, 201106, 2011153, 2, 6, 153, 2, 5, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-05-27' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-06-03' AS date), 1033, 3101, 13482, 13483, 13483, 13483, 13483, 13482, 13482, 2455715, 55714, N'2011-06-02', 201122, 22, 4, N'2011-W22', N'2011-W22-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94385, CAST(N'2011-06-03' AS date), CAST(N'2011-06-04' AS date), 2011, 20112, 201106, 2011154, 2, 6, 154, 3, 6, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-03' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-05-28' AS date), CAST(N'2011-06-03' AS date), 1033, 3101, 13482, 13483, 13483, 13483, 13483, 13483, 13482, 2455716, 55715, N'2011-06-03', 201122, 22, 5, N'2011-W22', N'2011-W22-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94386, CAST(N'2011-06-04' AS date), CAST(N'2011-06-05' AS date), 2011, 20112, 201106, 2011155, 2, 6, 155, 4, 7, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-05-29' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-03' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-06-10' AS date), 1033, 3101, 13482, 13483, 13483, 13483, 13483, 13483, 13483, 2455717, 55716, N'2011-06-04', 201122, 22, 6, N'2011-W22', N'2011-W22-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94387, CAST(N'2011-06-05' AS date), CAST(N'2011-06-06' AS date), 2011, 20112, 201106, 2011156, 2, 6, 156, 5, 1, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-05-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-03' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-06-10' AS date), 1033, 3101, 13483, 13483, 13483, 13483, 13483, 13483, 13483, 2455718, 55717, N'2011-06-05', 201122, 22, 7, N'2011-W22', N'2011-W22-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94388, CAST(N'2011-06-06' AS date), CAST(N'2011-06-07' AS date), 2011, 20112, 201106, 2011157, 2, 6, 157, 6, 2, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-05-31' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-03' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-06-10' AS date), 1033, 3101, 13483, 13484, 13483, 13483, 13483, 13483, 13483, 2455719, 55718, N'2011-06-06', 201123, 23, 1, N'2011-W23', N'2011-W23-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94389, CAST(N'2011-06-07' AS date), CAST(N'2011-06-08' AS date), 2011, 20112, 201106, 2011158, 2, 6, 158, 7, 3, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-03' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-06-10' AS date), 1033, 3101, 13483, 13484, 13484, 13483, 13483, 13483, 13483, 2455720, 55719, N'2011-06-07', 201123, 23, 2, N'2011-W23', N'2011-W23-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94390, CAST(N'2011-06-08' AS date), CAST(N'2011-06-09' AS date), 2011, 20112, 201106, 2011159, 2, 6, 159, 8, 4, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-02' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-03' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-06-10' AS date), 1033, 3101, 13483, 13484, 13484, 13484, 13483, 13483, 13483, 2455721, 55720, N'2011-06-08', 201123, 23, 3, N'2011-W23', N'2011-W23-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94391, CAST(N'2011-06-09' AS date), CAST(N'2011-06-10' AS date), 2011, 20112, 201106, 2011160, 2, 6, 160, 9, 5, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-03' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-06-10' AS date), 1033, 3101, 13483, 13484, 13484, 13484, 13484, 13483, 13483, 2455722, 55721, N'2011-06-09', 201123, 23, 4, N'2011-W23', N'2011-W23-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94392, CAST(N'2011-06-10' AS date), CAST(N'2011-06-11' AS date), 2011, 20112, 201106, 2011161, 2, 6, 161, 10, 6, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-10' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-04' AS date), CAST(N'2011-06-10' AS date), 1033, 3101, 13483, 13484, 13484, 13484, 13484, 13484, 13483, 2455723, 55722, N'2011-06-10', 201123, 23, 5, N'2011-W23', N'2011-W23-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94393, CAST(N'2011-06-11' AS date), CAST(N'2011-06-12' AS date), 2011, 20112, 201106, 2011162, 2, 6, 162, 11, 7, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-05' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-10' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-17' AS date), 1033, 3101, 13483, 13484, 13484, 13484, 13484, 13484, 13484, 2455724, 55723, N'2011-06-11', 201123, 23, 6, N'2011-W23', N'2011-W23-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94394, CAST(N'2011-06-12' AS date), CAST(N'2011-06-13' AS date), 2011, 20112, 201106, 2011163, 2, 6, 163, 12, 1, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-06' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-10' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-17' AS date), 1033, 3101, 13484, 13484, 13484, 13484, 13484, 13484, 13484, 2455725, 55724, N'2011-06-12', 201123, 23, 7, N'2011-W23', N'2011-W23-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94395, CAST(N'2011-06-13' AS date), CAST(N'2011-06-14' AS date), 2011, 20112, 201106, 2011164, 2, 6, 164, 13, 2, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-07' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-10' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-17' AS date), 1033, 3101, 13484, 13485, 13484, 13484, 13484, 13484, 13484, 2455726, 55725, N'2011-06-13', 201124, 24, 1, N'2011-W24', N'2011-W24-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94396, CAST(N'2011-06-14' AS date), CAST(N'2011-06-15' AS date), 2011, 20112, 201106, 2011165, 2, 6, 165, 14, 3, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-08' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-10' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-17' AS date), 1033, 3101, 13484, 13485, 13485, 13484, 13484, 13484, 13484, 2455727, 55726, N'2011-06-14', 201124, 24, 2, N'2011-W24', N'2011-W24-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94397, CAST(N'2011-06-15' AS date), CAST(N'2011-06-16' AS date), 2011, 20112, 201106, 2011166, 2, 6, 166, 15, 4, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-09' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-10' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-17' AS date), 1033, 3101, 13484, 13485, 13485, 13485, 13484, 13484, 13484, 2455728, 55727, N'2011-06-15', 201124, 24, 3, N'2011-W24', N'2011-W24-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94398, CAST(N'2011-06-16' AS date), CAST(N'2011-06-17' AS date), 2011, 20112, 201106, 2011167, 2, 6, 167, 16, 5, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-10' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-17' AS date), 1033, 3101, 13484, 13485, 13485, 13485, 13485, 13484, 13484, 2455729, 55728, N'2011-06-16', 201124, 24, 4, N'2011-W24', N'2011-W24-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94399, CAST(N'2011-06-17' AS date), CAST(N'2011-06-18' AS date), 2011, 20112, 201106, 2011168, 2, 6, 168, 17, 6, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-17' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-11' AS date), CAST(N'2011-06-17' AS date), 1033, 3101, 13484, 13485, 13485, 13485, 13485, 13485, 13484, 2455730, 55729, N'2011-06-17', 201124, 24, 5, N'2011-W24', N'2011-W24-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94400, CAST(N'2011-06-18' AS date), CAST(N'2011-06-19' AS date), 2011, 20112, 201106, 2011169, 2, 6, 169, 18, 7, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-12' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-17' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-24' AS date), 1033, 3101, 13484, 13485, 13485, 13485, 13485, 13485, 13485, 2455731, 55730, N'2011-06-18', 201124, 24, 6, N'2011-W24', N'2011-W24-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94401, CAST(N'2011-06-19' AS date), CAST(N'2011-06-20' AS date), 2011, 20112, 201106, 2011170, 2, 6, 170, 19, 1, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-06-13' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-17' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-24' AS date), 1033, 3101, 13485, 13485, 13485, 13485, 13485, 13485, 13485, 2455732, 55731, N'2011-06-19', 201124, 24, 7, N'2011-W24', N'2011-W24-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94402, CAST(N'2011-06-20' AS date), CAST(N'2011-06-21' AS date), 2011, 20112, 201106, 2011171, 2, 6, 171, 20, 2, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-06-14' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-17' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-24' AS date), 1033, 3101, 13485, 13486, 13485, 13485, 13485, 13485, 13485, 2455733, 55732, N'2011-06-20', 201125, 25, 1, N'2011-W25', N'2011-W25-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94403, CAST(N'2011-06-21' AS date), CAST(N'2011-06-22' AS date), 2011, 20112, 201106, 2011172, 2, 6, 172, 21, 3, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-06-15' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-17' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-24' AS date), 1033, 3101, 13485, 13486, 13486, 13485, 13485, 13485, 13485, 2455734, 55733, N'2011-06-21', 201125, 25, 2, N'2011-W25', N'2011-W25-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94404, CAST(N'2011-06-22' AS date), CAST(N'2011-06-23' AS date), 2011, 20112, 201106, 2011173, 2, 6, 173, 22, 4, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-06-16' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-17' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-24' AS date), 1033, 3101, 13485, 13486, 13486, 13486, 13485, 13485, 13485, 2455735, 55734, N'2011-06-22', 201125, 25, 3, N'2011-W25', N'2011-W25-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94405, CAST(N'2011-06-23' AS date), CAST(N'2011-06-24' AS date), 2011, 20112, 201106, 2011174, 2, 6, 174, 23, 5, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-06-17' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-24' AS date), 1033, 3101, 13485, 13486, 13486, 13486, 13486, 13485, 13485, 2455736, 55735, N'2011-06-23', 201125, 25, 4, N'2011-W25', N'2011-W25-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94406, CAST(N'2011-06-24' AS date), CAST(N'2011-06-25' AS date), 2011, 20112, 201106, 2011175, 2, 6, 175, 24, 6, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-06-24' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-18' AS date), CAST(N'2011-06-24' AS date), 1033, 3101, 13485, 13486, 13486, 13486, 13486, 13486, 13485, 2455737, 55736, N'2011-06-24', 201125, 25, 5, N'2011-W25', N'2011-W25-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94407, CAST(N'2011-06-25' AS date), CAST(N'2011-06-26' AS date), 2011, 20112, 201106, 2011176, 2, 6, 176, 25, 7, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-19' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-06-24' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-07-01' AS date), 1033, 3101, 13485, 13486, 13486, 13486, 13486, 13486, 13486, 2455738, 55737, N'2011-06-25', 201125, 25, 6, N'2011-W25', N'2011-W25-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94408, CAST(N'2011-06-26' AS date), CAST(N'2011-06-27' AS date), 2011, 20112, 201106, 2011177, 2, 6, 177, 26, 1, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-06-20' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-06-24' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-07-01' AS date), 1033, 3101, 13486, 13486, 13486, 13486, 13486, 13486, 13486, 2455739, 55738, N'2011-06-26', 201125, 25, 7, N'2011-W25', N'2011-W25-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94409, CAST(N'2011-06-27' AS date), CAST(N'2011-06-28' AS date), 2011, 20112, 201106, 2011178, 2, 6, 178, 27, 2, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-06-21' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-06-24' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-07-01' AS date), 1033, 3101, 13486, 13487, 13486, 13486, 13486, 13486, 13486, 2455740, 55739, N'2011-06-27', 201126, 26, 1, N'2011-W26', N'2011-W26-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94410, CAST(N'2011-06-28' AS date), CAST(N'2011-06-29' AS date), 2011, 20112, 201106, 2011179, 2, 6, 179, 28, 3, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-06-22' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-06-24' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-07-01' AS date), 1033, 3101, 13486, 13487, 13487, 13486, 13486, 13486, 13486, 2455741, 55740, N'2011-06-28', 201126, 26, 2, N'2011-W26', N'2011-W26-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94411, CAST(N'2011-06-29' AS date), CAST(N'2011-06-30' AS date), 2011, 20112, 201106, 2011180, 2, 6, 180, 29, 4, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-06-23' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-06-24' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-07-01' AS date), 1033, 3101, 13486, 13487, 13487, 13487, 13486, 13486, 13486, 2455742, 55741, N'2011-06-29', 201126, 26, 3, N'2011-W26', N'2011-W26-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94412, CAST(N'2011-06-30' AS date), CAST(N'2011-07-01' AS date), 2011, 20112, 201106, 2011181, 2, 6, 181, 30, 5, N'2011', N'2011 Q2', N'2011 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-04-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-01' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-06-24' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-07-01' AS date), 1033, 3101, 13486, 13487, 13487, 13487, 13487, 13486, 13486, 2455743, 55742, N'2011-06-30', 201126, 26, 4, N'2011-W26', N'2011-W26-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94413, CAST(N'2011-07-01' AS date), CAST(N'2011-07-02' AS date), 2011, 20113, 201107, 2011182, 3, 7, 182, 1, 6, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-06-25' AS date), CAST(N'2011-07-01' AS date), 1034, 3102, 13486, 13487, 13487, 13487, 13487, 13487, 13486, 2455744, 55743, N'2011-07-01', 201126, 26, 5, N'2011-W26', N'2011-W26-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94414, CAST(N'2011-07-02' AS date), CAST(N'2011-07-03' AS date), 2011, 20113, 201107, 2011183, 3, 7, 183, 2, 7, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-06-26' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-07-08' AS date), 1034, 3102, 13486, 13487, 13487, 13487, 13487, 13487, 13487, 2455745, 55744, N'2011-07-02', 201126, 26, 6, N'2011-W26', N'2011-W26-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94415, CAST(N'2011-07-03' AS date), CAST(N'2011-07-04' AS date), 2011, 20113, 201107, 2011184, 3, 7, 184, 3, 1, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-06-27' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-07-08' AS date), 1034, 3102, 13487, 13487, 13487, 13487, 13487, 13487, 13487, 2455746, 55745, N'2011-07-03', 201126, 26, 7, N'2011-W26', N'2011-W26-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94416, CAST(N'2011-07-04' AS date), CAST(N'2011-07-05' AS date), 2011, 20113, 201107, 2011185, 3, 7, 185, 4, 2, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-06-28' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-07-08' AS date), 1034, 3102, 13487, 13488, 13487, 13487, 13487, 13487, 13487, 2455747, 55746, N'2011-07-04', 201127, 27, 1, N'2011-W27', N'2011-W27-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94417, CAST(N'2011-07-05' AS date), CAST(N'2011-07-06' AS date), 2011, 20113, 201107, 2011186, 3, 7, 186, 5, 3, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-06-29' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-07-08' AS date), 1034, 3102, 13487, 13488, 13488, 13487, 13487, 13487, 13487, 2455748, 55747, N'2011-07-05', 201127, 27, 2, N'2011-W27', N'2011-W27-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94418, CAST(N'2011-07-06' AS date), CAST(N'2011-07-07' AS date), 2011, 20113, 201107, 2011187, 3, 7, 187, 6, 4, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-06-30' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-07-08' AS date), 1034, 3102, 13487, 13488, 13488, 13488, 13487, 13487, 13487, 2455749, 55748, N'2011-07-06', 201127, 27, 3, N'2011-W27', N'2011-W27-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94419, CAST(N'2011-07-07' AS date), CAST(N'2011-07-08' AS date), 2011, 20113, 201107, 2011188, 3, 7, 188, 7, 5, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-07-08' AS date), 1034, 3102, 13487, 13488, 13488, 13488, 13488, 13487, 13487, 2455750, 55749, N'2011-07-07', 201127, 27, 4, N'2011-W27', N'2011-W27-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94420, CAST(N'2011-07-08' AS date), CAST(N'2011-07-09' AS date), 2011, 20113, 201107, 2011189, 3, 7, 189, 8, 6, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-08' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-02' AS date), CAST(N'2011-07-08' AS date), 1034, 3102, 13487, 13488, 13488, 13488, 13488, 13488, 13487, 2455751, 55750, N'2011-07-08', 201127, 27, 5, N'2011-W27', N'2011-W27-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94421, CAST(N'2011-07-09' AS date), CAST(N'2011-07-10' AS date), 2011, 20113, 201107, 2011190, 3, 7, 190, 9, 7, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-03' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-08' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-15' AS date), 1034, 3102, 13487, 13488, 13488, 13488, 13488, 13488, 13488, 2455752, 55751, N'2011-07-09', 201127, 27, 6, N'2011-W27', N'2011-W27-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94422, CAST(N'2011-07-10' AS date), CAST(N'2011-07-11' AS date), 2011, 20113, 201107, 2011191, 3, 7, 191, 10, 1, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-04' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-08' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-15' AS date), 1034, 3102, 13488, 13488, 13488, 13488, 13488, 13488, 13488, 2455753, 55752, N'2011-07-10', 201127, 27, 7, N'2011-W27', N'2011-W27-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94423, CAST(N'2011-07-11' AS date), CAST(N'2011-07-12' AS date), 2011, 20113, 201107, 2011192, 3, 7, 192, 11, 2, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-05' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-08' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-15' AS date), 1034, 3102, 13488, 13489, 13488, 13488, 13488, 13488, 13488, 2455754, 55753, N'2011-07-11', 201128, 28, 1, N'2011-W28', N'2011-W28-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94424, CAST(N'2011-07-12' AS date), CAST(N'2011-07-13' AS date), 2011, 20113, 201107, 2011193, 3, 7, 193, 12, 3, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-06' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-08' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-15' AS date), 1034, 3102, 13488, 13489, 13489, 13488, 13488, 13488, 13488, 2455755, 55754, N'2011-07-12', 201128, 28, 2, N'2011-W28', N'2011-W28-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94425, CAST(N'2011-07-13' AS date), CAST(N'2011-07-14' AS date), 2011, 20113, 201107, 2011194, 3, 7, 194, 13, 4, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-07' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-08' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-15' AS date), 1034, 3102, 13488, 13489, 13489, 13489, 13488, 13488, 13488, 2455756, 55755, N'2011-07-13', 201128, 28, 3, N'2011-W28', N'2011-W28-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94426, CAST(N'2011-07-14' AS date), CAST(N'2011-07-15' AS date), 2011, 20113, 201107, 2011195, 3, 7, 195, 14, 5, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-08' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-15' AS date), 1034, 3102, 13488, 13489, 13489, 13489, 13489, 13488, 13488, 2455757, 55756, N'2011-07-14', 201128, 28, 4, N'2011-W28', N'2011-W28-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94427, CAST(N'2011-07-15' AS date), CAST(N'2011-07-16' AS date), 2011, 20113, 201107, 2011196, 3, 7, 196, 15, 6, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-15' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-09' AS date), CAST(N'2011-07-15' AS date), 1034, 3102, 13488, 13489, 13489, 13489, 13489, 13489, 13488, 2455758, 55757, N'2011-07-15', 201128, 28, 5, N'2011-W28', N'2011-W28-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94428, CAST(N'2011-07-16' AS date), CAST(N'2011-07-17' AS date), 2011, 20113, 201107, 2011197, 3, 7, 197, 16, 7, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-10' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-15' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-22' AS date), 1034, 3102, 13488, 13489, 13489, 13489, 13489, 13489, 13489, 2455759, 55758, N'2011-07-16', 201128, 28, 6, N'2011-W28', N'2011-W28-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94429, CAST(N'2011-07-17' AS date), CAST(N'2011-07-18' AS date), 2011, 20113, 201107, 2011198, 3, 7, 198, 17, 1, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-11' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-15' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-22' AS date), 1034, 3102, 13489, 13489, 13489, 13489, 13489, 13489, 13489, 2455760, 55759, N'2011-07-17', 201128, 28, 7, N'2011-W28', N'2011-W28-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94430, CAST(N'2011-07-18' AS date), CAST(N'2011-07-19' AS date), 2011, 20113, 201107, 2011199, 3, 7, 199, 18, 2, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-12' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-15' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-22' AS date), 1034, 3102, 13489, 13490, 13489, 13489, 13489, 13489, 13489, 2455761, 55760, N'2011-07-18', 201129, 29, 1, N'2011-W29', N'2011-W29-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94431, CAST(N'2011-07-19' AS date), CAST(N'2011-07-20' AS date), 2011, 20113, 201107, 2011200, 3, 7, 200, 19, 3, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-13' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-15' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-22' AS date), 1034, 3102, 13489, 13490, 13490, 13489, 13489, 13489, 13489, 2455762, 55761, N'2011-07-19', 201129, 29, 2, N'2011-W29', N'2011-W29-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94432, CAST(N'2011-07-20' AS date), CAST(N'2011-07-21' AS date), 2011, 20113, 201107, 2011201, 3, 7, 201, 20, 4, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-07-14' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-15' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-22' AS date), 1034, 3102, 13489, 13490, 13490, 13490, 13489, 13489, 13489, 2455763, 55762, N'2011-07-20', 201129, 29, 3, N'2011-W29', N'2011-W29-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94433, CAST(N'2011-07-21' AS date), CAST(N'2011-07-22' AS date), 2011, 20113, 201107, 2011202, 3, 7, 202, 21, 5, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-07-15' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-22' AS date), 1034, 3102, 13489, 13490, 13490, 13490, 13490, 13489, 13489, 2455764, 55763, N'2011-07-21', 201129, 29, 4, N'2011-W29', N'2011-W29-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94434, CAST(N'2011-07-22' AS date), CAST(N'2011-07-23' AS date), 2011, 20113, 201107, 2011203, 3, 7, 203, 22, 6, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-07-22' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-07-16' AS date), CAST(N'2011-07-22' AS date), 1034, 3102, 13489, 13490, 13490, 13490, 13490, 13490, 13489, 2455765, 55764, N'2011-07-22', 201129, 29, 5, N'2011-W29', N'2011-W29-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94435, CAST(N'2011-07-23' AS date), CAST(N'2011-07-24' AS date), 2011, 20113, 201107, 2011204, 3, 7, 204, 23, 7, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-17' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-07-22' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-29' AS date), 1034, 3102, 13489, 13490, 13490, 13490, 13490, 13490, 13490, 2455766, 55765, N'2011-07-23', 201129, 29, 6, N'2011-W29', N'2011-W29-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94436, CAST(N'2011-07-24' AS date), CAST(N'2011-07-25' AS date), 2011, 20113, 201107, 2011205, 3, 7, 205, 24, 1, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-07-18' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-07-22' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-29' AS date), 1034, 3102, 13490, 13490, 13490, 13490, 13490, 13490, 13490, 2455767, 55766, N'2011-07-24', 201129, 29, 7, N'2011-W29', N'2011-W29-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94437, CAST(N'2011-07-25' AS date), CAST(N'2011-07-26' AS date), 2011, 20113, 201107, 2011206, 3, 7, 206, 25, 2, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-19' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-07-22' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-29' AS date), 1034, 3102, 13490, 13491, 13490, 13490, 13490, 13490, 13490, 2455768, 55767, N'2011-07-25', 201130, 30, 1, N'2011-W30', N'2011-W30-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94438, CAST(N'2011-07-26' AS date), CAST(N'2011-07-27' AS date), 2011, 20113, 201107, 2011207, 3, 7, 207, 26, 3, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-07-20' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-07-22' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-29' AS date), 1034, 3102, 13490, 13491, 13491, 13490, 13490, 13490, 13490, 2455769, 55768, N'2011-07-26', 201130, 30, 2, N'2011-W30', N'2011-W30-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94439, CAST(N'2011-07-27' AS date), CAST(N'2011-07-28' AS date), 2011, 20113, 201107, 2011208, 3, 7, 208, 27, 4, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-07-21' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-07-22' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-29' AS date), 1034, 3102, 13490, 13491, 13491, 13491, 13490, 13490, 13490, 2455770, 55769, N'2011-07-27', 201130, 30, 3, N'2011-W30', N'2011-W30-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94440, CAST(N'2011-07-28' AS date), CAST(N'2011-07-29' AS date), 2011, 20113, 201107, 2011209, 3, 7, 209, 28, 5, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-07-22' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-29' AS date), 1034, 3102, 13490, 13491, 13491, 13491, 13491, 13490, 13490, 2455771, 55770, N'2011-07-28', 201130, 30, 4, N'2011-W30', N'2011-W30-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94441, CAST(N'2011-07-29' AS date), CAST(N'2011-07-30' AS date), 2011, 20113, 201107, 2011210, 3, 7, 210, 29, 6, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-07-29' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-07-23' AS date), CAST(N'2011-07-29' AS date), 1034, 3102, 13490, 13491, 13491, 13491, 13491, 13491, 13490, 2455772, 55771, N'2011-07-29', 201130, 30, 5, N'2011-W30', N'2011-W30-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94442, CAST(N'2011-07-30' AS date), CAST(N'2011-07-31' AS date), 2011, 20113, 201107, 2011211, 3, 7, 211, 30, 7, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-24' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-07-29' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-08-05' AS date), 1034, 3102, 13490, 13491, 13491, 13491, 13491, 13491, 13491, 2455773, 55772, N'2011-07-30', 201130, 30, 6, N'2011-W30', N'2011-W30-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94443, CAST(N'2011-07-31' AS date), CAST(N'2011-08-01' AS date), 2011, 20113, 201107, 2011212, 3, 7, 212, 31, 1, N'2011', N'2011 Q3', N'2011 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-07-25' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-07-29' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-08-05' AS date), 1034, 3102, 13491, 13491, 13491, 13491, 13491, 13491, 13491, 2455774, 55773, N'2011-07-31', 201130, 30, 7, N'2011-W30', N'2011-W30-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94444, CAST(N'2011-08-01' AS date), CAST(N'2011-08-02' AS date), 2011, 20113, 201108, 2011213, 3, 8, 213, 1, 2, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-07-26' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-07-29' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-08-05' AS date), 1034, 3103, 13491, 13492, 13491, 13491, 13491, 13491, 13491, 2455775, 55774, N'2011-08-01', 201131, 31, 1, N'2011-W31', N'2011-W31-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94445, CAST(N'2011-08-02' AS date), CAST(N'2011-08-03' AS date), 2011, 20113, 201108, 2011214, 3, 8, 214, 2, 3, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-07-27' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-07-29' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-08-05' AS date), 1034, 3103, 13491, 13492, 13492, 13491, 13491, 13491, 13491, 2455776, 55775, N'2011-08-02', 201131, 31, 2, N'2011-W31', N'2011-W31-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94446, CAST(N'2011-08-03' AS date), CAST(N'2011-08-04' AS date), 2011, 20113, 201108, 2011215, 3, 8, 215, 3, 4, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-07-28' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-07-29' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-08-05' AS date), 1034, 3103, 13491, 13492, 13492, 13492, 13491, 13491, 13491, 2455777, 55776, N'2011-08-03', 201131, 31, 3, N'2011-W31', N'2011-W31-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94447, CAST(N'2011-08-04' AS date), CAST(N'2011-08-05' AS date), 2011, 20113, 201108, 2011216, 3, 8, 216, 4, 5, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-07-29' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-08-05' AS date), 1034, 3103, 13491, 13492, 13492, 13492, 13492, 13491, 13491, 2455778, 55777, N'2011-08-04', 201131, 31, 4, N'2011-W31', N'2011-W31-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94448, CAST(N'2011-08-05' AS date), CAST(N'2011-08-06' AS date), 2011, 20113, 201108, 2011217, 3, 8, 217, 5, 6, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-05' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-07-30' AS date), CAST(N'2011-08-05' AS date), 1034, 3103, 13491, 13492, 13492, 13492, 13492, 13492, 13491, 2455779, 55778, N'2011-08-05', 201131, 31, 5, N'2011-W31', N'2011-W31-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94449, CAST(N'2011-08-06' AS date), CAST(N'2011-08-07' AS date), 2011, 20113, 201108, 2011218, 3, 8, 218, 6, 7, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-07-31' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-05' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-12' AS date), 1034, 3103, 13491, 13492, 13492, 13492, 13492, 13492, 13492, 2455780, 55779, N'2011-08-06', 201131, 31, 6, N'2011-W31', N'2011-W31-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94450, CAST(N'2011-08-07' AS date), CAST(N'2011-08-08' AS date), 2011, 20113, 201108, 2011219, 3, 8, 219, 7, 1, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-05' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-12' AS date), 1034, 3103, 13492, 13492, 13492, 13492, 13492, 13492, 13492, 2455781, 55780, N'2011-08-07', 201131, 31, 7, N'2011-W31', N'2011-W31-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94451, CAST(N'2011-08-08' AS date), CAST(N'2011-08-09' AS date), 2011, 20113, 201108, 2011220, 3, 8, 220, 8, 2, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-02' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-05' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-12' AS date), 1034, 3103, 13492, 13493, 13492, 13492, 13492, 13492, 13492, 2455782, 55781, N'2011-08-08', 201132, 32, 1, N'2011-W32', N'2011-W32-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94452, CAST(N'2011-08-09' AS date), CAST(N'2011-08-10' AS date), 2011, 20113, 201108, 2011221, 3, 8, 221, 9, 3, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-03' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-05' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-12' AS date), 1034, 3103, 13492, 13493, 13493, 13492, 13492, 13492, 13492, 2455783, 55782, N'2011-08-09', 201132, 32, 2, N'2011-W32', N'2011-W32-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94453, CAST(N'2011-08-10' AS date), CAST(N'2011-08-11' AS date), 2011, 20113, 201108, 2011222, 3, 8, 222, 10, 4, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-04' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-05' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-12' AS date), 1034, 3103, 13492, 13493, 13493, 13493, 13492, 13492, 13492, 2455784, 55783, N'2011-08-10', 201132, 32, 3, N'2011-W32', N'2011-W32-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94454, CAST(N'2011-08-11' AS date), CAST(N'2011-08-12' AS date), 2011, 20113, 201108, 2011223, 3, 8, 223, 11, 5, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-05' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-12' AS date), 1034, 3103, 13492, 13493, 13493, 13493, 13493, 13492, 13492, 2455785, 55784, N'2011-08-11', 201132, 32, 4, N'2011-W32', N'2011-W32-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94455, CAST(N'2011-08-12' AS date), CAST(N'2011-08-13' AS date), 2011, 20113, 201108, 2011224, 3, 8, 224, 12, 6, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-12' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-06' AS date), CAST(N'2011-08-12' AS date), 1034, 3103, 13492, 13493, 13493, 13493, 13493, 13493, 13492, 2455786, 55785, N'2011-08-12', 201132, 32, 5, N'2011-W32', N'2011-W32-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94456, CAST(N'2011-08-13' AS date), CAST(N'2011-08-14' AS date), 2011, 20113, 201108, 2011225, 3, 8, 225, 13, 7, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-07' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-12' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-19' AS date), 1034, 3103, 13492, 13493, 13493, 13493, 13493, 13493, 13493, 2455787, 55786, N'2011-08-13', 201132, 32, 6, N'2011-W32', N'2011-W32-6');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94457, CAST(N'2011-08-14' AS date), CAST(N'2011-08-15' AS date), 2011, 20113, 201108, 2011226, 3, 8, 226, 14, 1, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-08' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-12' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-19' AS date), 1034, 3103, 13493, 13493, 13493, 13493, 13493, 13493, 13493, 2455788, 55787, N'2011-08-14', 201132, 32, 7, N'2011-W32', N'2011-W32-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94458, CAST(N'2011-08-15' AS date), CAST(N'2011-08-16' AS date), 2011, 20113, 201108, 2011227, 3, 8, 227, 15, 2, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-09' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-12' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-19' AS date), 1034, 3103, 13493, 13494, 13493, 13493, 13493, 13493, 13493, 2455789, 55788, N'2011-08-15', 201133, 33, 1, N'2011-W33', N'2011-W33-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94459, CAST(N'2011-08-16' AS date), CAST(N'2011-08-17' AS date), 2011, 20113, 201108, 2011228, 3, 8, 228, 16, 3, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-10' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-12' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-19' AS date), 1034, 3103, 13493, 13494, 13494, 13493, 13493, 13493, 13493, 2455790, 55789, N'2011-08-16', 201133, 33, 2, N'2011-W33', N'2011-W33-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94460, CAST(N'2011-08-17' AS date), CAST(N'2011-08-18' AS date), 2011, 20113, 201108, 2011229, 3, 8, 229, 17, 4, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-11' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-12' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-19' AS date), 1034, 3103, 13493, 13494, 13494, 13494, 13493, 13493, 13493, 2455791, 55790, N'2011-08-17', 201133, 33, 3, N'2011-W33', N'2011-W33-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94461, CAST(N'2011-08-18' AS date), CAST(N'2011-08-19' AS date), 2011, 20113, 201108, 2011230, 3, 8, 230, 18, 5, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-12' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-19' AS date), 1034, 3103, 13493, 13494, 13494, 13494, 13494, 13493, 13493, 2455792, 55791, N'2011-08-18', 201133, 33, 4, N'2011-W33', N'2011-W33-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94462, CAST(N'2011-08-19' AS date), CAST(N'2011-08-20' AS date), 2011, 20113, 201108, 2011231, 3, 8, 231, 19, 6, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-19' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-13' AS date), CAST(N'2011-08-19' AS date), 1034, 3103, 13493, 13494, 13494, 13494, 13494, 13494, 13493, 2455793, 55792, N'2011-08-19', 201133, 33, 5, N'2011-W33', N'2011-W33-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94463, CAST(N'2011-08-20' AS date), CAST(N'2011-08-21' AS date), 2011, 20113, 201108, 2011232, 3, 8, 232, 20, 7, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-14' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-19' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-26' AS date), 1034, 3103, 13493, 13494, 13494, 13494, 13494, 13494, 13494, 2455794, 55793, N'2011-08-20', 201133, 33, 6, N'2011-W33', N'2011-W33-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94464, CAST(N'2011-08-21' AS date), CAST(N'2011-08-22' AS date), 2011, 20113, 201108, 2011233, 3, 8, 233, 21, 1, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-08-15' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-19' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-26' AS date), 1034, 3103, 13494, 13494, 13494, 13494, 13494, 13494, 13494, 2455795, 55794, N'2011-08-21', 201133, 33, 7, N'2011-W33', N'2011-W33-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94465, CAST(N'2011-08-22' AS date), CAST(N'2011-08-23' AS date), 2011, 20113, 201108, 2011234, 3, 8, 234, 22, 2, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-08-16' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-19' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-26' AS date), 1034, 3103, 13494, 13495, 13494, 13494, 13494, 13494, 13494, 2455796, 55795, N'2011-08-22', 201134, 34, 1, N'2011-W34', N'2011-W34-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94466, CAST(N'2011-08-23' AS date), CAST(N'2011-08-24' AS date), 2011, 20113, 201108, 2011235, 3, 8, 235, 23, 3, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-08-17' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-19' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-26' AS date), 1034, 3103, 13494, 13495, 13495, 13494, 13494, 13494, 13494, 2455797, 55796, N'2011-08-23', 201134, 34, 2, N'2011-W34', N'2011-W34-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94467, CAST(N'2011-08-24' AS date), CAST(N'2011-08-25' AS date), 2011, 20113, 201108, 2011236, 3, 8, 236, 24, 4, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-08-18' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-19' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-26' AS date), 1034, 3103, 13494, 13495, 13495, 13495, 13494, 13494, 13494, 2455798, 55797, N'2011-08-24', 201134, 34, 3, N'2011-W34', N'2011-W34-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94468, CAST(N'2011-08-25' AS date), CAST(N'2011-08-26' AS date), 2011, 20113, 201108, 2011237, 3, 8, 237, 25, 5, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-19' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-26' AS date), 1034, 3103, 13494, 13495, 13495, 13495, 13495, 13494, 13494, 2455799, 55798, N'2011-08-25', 201134, 34, 4, N'2011-W34', N'2011-W34-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94469, CAST(N'2011-08-26' AS date), CAST(N'2011-08-27' AS date), 2011, 20113, 201108, 2011238, 3, 8, 238, 26, 6, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-26' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-08-20' AS date), CAST(N'2011-08-26' AS date), 1034, 3103, 13494, 13495, 13495, 13495, 13495, 13495, 13494, 2455800, 55799, N'2011-08-26', 201134, 34, 5, N'2011-W34', N'2011-W34-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94470, CAST(N'2011-08-27' AS date), CAST(N'2011-08-28' AS date), 2011, 20113, 201108, 2011239, 3, 8, 239, 27, 7, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-21' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-26' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-09-02' AS date), 1034, 3103, 13494, 13495, 13495, 13495, 13495, 13495, 13495, 2455801, 55800, N'2011-08-27', 201134, 34, 6, N'2011-W34', N'2011-W34-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94471, CAST(N'2011-08-28' AS date), CAST(N'2011-08-29' AS date), 2011, 20113, 201108, 2011240, 3, 8, 240, 28, 1, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-08-22' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-26' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-09-02' AS date), 1034, 3103, 13495, 13495, 13495, 13495, 13495, 13495, 13495, 2455802, 55801, N'2011-08-28', 201134, 34, 7, N'2011-W34', N'2011-W34-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94472, CAST(N'2011-08-29' AS date), CAST(N'2011-08-30' AS date), 2011, 20113, 201108, 2011241, 3, 8, 241, 29, 2, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-08-23' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-26' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-09-02' AS date), 1034, 3103, 13495, 13496, 13495, 13495, 13495, 13495, 13495, 2455803, 55802, N'2011-08-29', 201135, 35, 1, N'2011-W35', N'2011-W35-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94473, CAST(N'2011-08-30' AS date), CAST(N'2011-08-31' AS date), 2011, 20113, 201108, 2011242, 3, 8, 242, 30, 3, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-08-24' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-26' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-09-02' AS date), 1034, 3103, 13495, 13496, 13496, 13495, 13495, 13495, 13495, 2455804, 55803, N'2011-08-30', 201135, 35, 2, N'2011-W35', N'2011-W35-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94474, CAST(N'2011-08-31' AS date), CAST(N'2011-09-01' AS date), 2011, 20113, 201108, 2011243, 3, 8, 243, 31, 4, N'2011', N'2011 Q3', N'2011 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-01' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-08-25' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-08-26' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-09-02' AS date), 1034, 3103, 13495, 13496, 13496, 13496, 13495, 13495, 13495, 2455805, 55804, N'2011-08-31', 201135, 35, 3, N'2011-W35', N'2011-W35-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94475, CAST(N'2011-09-01' AS date), CAST(N'2011-09-02' AS date), 2011, 20113, 201109, 2011244, 3, 9, 244, 1, 5, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-08-26' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-09-02' AS date), 1034, 3104, 13495, 13496, 13496, 13496, 13496, 13495, 13495, 2455806, 55805, N'2011-09-01', 201135, 35, 4, N'2011-W35', N'2011-W35-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94476, CAST(N'2011-09-02' AS date), CAST(N'2011-09-03' AS date), 2011, 20113, 201109, 2011245, 3, 9, 245, 2, 6, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-02' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-08-27' AS date), CAST(N'2011-09-02' AS date), 1034, 3104, 13495, 13496, 13496, 13496, 13496, 13496, 13495, 2455807, 55806, N'2011-09-02', 201135, 35, 5, N'2011-W35', N'2011-W35-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94477, CAST(N'2011-09-03' AS date), CAST(N'2011-09-04' AS date), 2011, 20113, 201109, 2011246, 3, 9, 246, 3, 7, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-08-28' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-02' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-09-09' AS date), 1034, 3104, 13495, 13496, 13496, 13496, 13496, 13496, 13496, 2455808, 55807, N'2011-09-03', 201135, 35, 6, N'2011-W35', N'2011-W35-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94478, CAST(N'2011-09-04' AS date), CAST(N'2011-09-05' AS date), 2011, 20113, 201109, 2011247, 3, 9, 247, 4, 1, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-08-29' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-02' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-09-09' AS date), 1034, 3104, 13496, 13496, 13496, 13496, 13496, 13496, 13496, 2455809, 55808, N'2011-09-04', 201135, 35, 7, N'2011-W35', N'2011-W35-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94479, CAST(N'2011-09-05' AS date), CAST(N'2011-09-06' AS date), 2011, 20113, 201109, 2011248, 3, 9, 248, 5, 2, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-08-30' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-02' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-09-09' AS date), 1034, 3104, 13496, 13497, 13496, 13496, 13496, 13496, 13496, 2455810, 55809, N'2011-09-05', 201136, 36, 1, N'2011-W36', N'2011-W36-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94480, CAST(N'2011-09-06' AS date), CAST(N'2011-09-07' AS date), 2011, 20113, 201109, 2011249, 3, 9, 249, 6, 3, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-08-31' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-02' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-09-09' AS date), 1034, 3104, 13496, 13497, 13497, 13496, 13496, 13496, 13496, 2455811, 55810, N'2011-09-06', 201136, 36, 2, N'2011-W36', N'2011-W36-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94481, CAST(N'2011-09-07' AS date), CAST(N'2011-09-08' AS date), 2011, 20113, 201109, 2011250, 3, 9, 250, 7, 4, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-02' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-09-09' AS date), 1034, 3104, 13496, 13497, 13497, 13497, 13496, 13496, 13496, 2455812, 55811, N'2011-09-07', 201136, 36, 3, N'2011-W36', N'2011-W36-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94482, CAST(N'2011-09-08' AS date), CAST(N'2011-09-09' AS date), 2011, 20113, 201109, 2011251, 3, 9, 251, 8, 5, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-02' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-09-09' AS date), 1034, 3104, 13496, 13497, 13497, 13497, 13497, 13496, 13496, 2455813, 55812, N'2011-09-08', 201136, 36, 4, N'2011-W36', N'2011-W36-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94483, CAST(N'2011-09-09' AS date), CAST(N'2011-09-10' AS date), 2011, 20113, 201109, 2011252, 3, 9, 252, 9, 6, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-09' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-03' AS date), CAST(N'2011-09-09' AS date), 1034, 3104, 13496, 13497, 13497, 13497, 13497, 13497, 13496, 2455814, 55813, N'2011-09-09', 201136, 36, 5, N'2011-W36', N'2011-W36-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94484, CAST(N'2011-09-10' AS date), CAST(N'2011-09-11' AS date), 2011, 20113, 201109, 2011253, 3, 9, 253, 10, 7, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-04' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-09' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-16' AS date), 1034, 3104, 13496, 13497, 13497, 13497, 13497, 13497, 13497, 2455815, 55814, N'2011-09-10', 201136, 36, 6, N'2011-W36', N'2011-W36-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94485, CAST(N'2011-09-11' AS date), CAST(N'2011-09-12' AS date), 2011, 20113, 201109, 2011254, 3, 9, 254, 11, 1, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-05' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-09' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-16' AS date), 1034, 3104, 13497, 13497, 13497, 13497, 13497, 13497, 13497, 2455816, 55815, N'2011-09-11', 201136, 36, 7, N'2011-W36', N'2011-W36-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94486, CAST(N'2011-09-12' AS date), CAST(N'2011-09-13' AS date), 2011, 20113, 201109, 2011255, 3, 9, 255, 12, 2, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-06' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-09' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-16' AS date), 1034, 3104, 13497, 13498, 13497, 13497, 13497, 13497, 13497, 2455817, 55816, N'2011-09-12', 201137, 37, 1, N'2011-W37', N'2011-W37-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94487, CAST(N'2011-09-13' AS date), CAST(N'2011-09-14' AS date), 2011, 20113, 201109, 2011256, 3, 9, 256, 13, 3, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-07' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-09' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-16' AS date), 1034, 3104, 13497, 13498, 13498, 13497, 13497, 13497, 13497, 2455818, 55817, N'2011-09-13', 201137, 37, 2, N'2011-W37', N'2011-W37-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94488, CAST(N'2011-09-14' AS date), CAST(N'2011-09-15' AS date), 2011, 20113, 201109, 2011257, 3, 9, 257, 14, 4, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-08' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-09' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-16' AS date), 1034, 3104, 13497, 13498, 13498, 13498, 13497, 13497, 13497, 2455819, 55818, N'2011-09-14', 201137, 37, 3, N'2011-W37', N'2011-W37-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94489, CAST(N'2011-09-15' AS date), CAST(N'2011-09-16' AS date), 2011, 20113, 201109, 2011258, 3, 9, 258, 15, 5, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-09' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-16' AS date), 1034, 3104, 13497, 13498, 13498, 13498, 13498, 13497, 13497, 2455820, 55819, N'2011-09-15', 201137, 37, 4, N'2011-W37', N'2011-W37-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94490, CAST(N'2011-09-16' AS date), CAST(N'2011-09-17' AS date), 2011, 20113, 201109, 2011259, 3, 9, 259, 16, 6, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-16' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-10' AS date), CAST(N'2011-09-16' AS date), 1034, 3104, 13497, 13498, 13498, 13498, 13498, 13498, 13497, 2455821, 55820, N'2011-09-16', 201137, 37, 5, N'2011-W37', N'2011-W37-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94491, CAST(N'2011-09-17' AS date), CAST(N'2011-09-18' AS date), 2011, 20113, 201109, 2011260, 3, 9, 260, 17, 7, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-11' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-16' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-23' AS date), 1034, 3104, 13497, 13498, 13498, 13498, 13498, 13498, 13498, 2455822, 55821, N'2011-09-17', 201137, 37, 6, N'2011-W37', N'2011-W37-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94492, CAST(N'2011-09-18' AS date), CAST(N'2011-09-19' AS date), 2011, 20113, 201109, 2011261, 3, 9, 261, 18, 1, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-12' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-16' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-23' AS date), 1034, 3104, 13498, 13498, 13498, 13498, 13498, 13498, 13498, 2455823, 55822, N'2011-09-18', 201137, 37, 7, N'2011-W37', N'2011-W37-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94493, CAST(N'2011-09-19' AS date), CAST(N'2011-09-20' AS date), 2011, 20113, 201109, 2011262, 3, 9, 262, 19, 2, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-09-13' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-16' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-23' AS date), 1034, 3104, 13498, 13499, 13498, 13498, 13498, 13498, 13498, 2455824, 55823, N'2011-09-19', 201138, 38, 1, N'2011-W38', N'2011-W38-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94494, CAST(N'2011-09-20' AS date), CAST(N'2011-09-21' AS date), 2011, 20113, 201109, 2011263, 3, 9, 263, 20, 3, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-09-14' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-16' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-23' AS date), 1034, 3104, 13498, 13499, 13499, 13498, 13498, 13498, 13498, 2455825, 55824, N'2011-09-20', 201138, 38, 2, N'2011-W38', N'2011-W38-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94495, CAST(N'2011-09-21' AS date), CAST(N'2011-09-22' AS date), 2011, 20113, 201109, 2011264, 3, 9, 264, 21, 4, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-09-15' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-16' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-23' AS date), 1034, 3104, 13498, 13499, 13499, 13499, 13498, 13498, 13498, 2455826, 55825, N'2011-09-21', 201138, 38, 3, N'2011-W38', N'2011-W38-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94496, CAST(N'2011-09-22' AS date), CAST(N'2011-09-23' AS date), 2011, 20113, 201109, 2011265, 3, 9, 265, 22, 5, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-09-16' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-23' AS date), 1034, 3104, 13498, 13499, 13499, 13499, 13499, 13498, 13498, 2455827, 55826, N'2011-09-22', 201138, 38, 4, N'2011-W38', N'2011-W38-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94497, CAST(N'2011-09-23' AS date), CAST(N'2011-09-24' AS date), 2011, 20113, 201109, 2011266, 3, 9, 266, 23, 6, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-09-23' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-09-17' AS date), CAST(N'2011-09-23' AS date), 1034, 3104, 13498, 13499, 13499, 13499, 13499, 13499, 13498, 2455828, 55827, N'2011-09-23', 201138, 38, 5, N'2011-W38', N'2011-W38-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94498, CAST(N'2011-09-24' AS date), CAST(N'2011-09-25' AS date), 2011, 20113, 201109, 2011267, 3, 9, 267, 24, 7, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-18' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-09-23' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-30' AS date), 1034, 3104, 13498, 13499, 13499, 13499, 13499, 13499, 13499, 2455829, 55828, N'2011-09-24', 201138, 38, 6, N'2011-W38', N'2011-W38-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94499, CAST(N'2011-09-25' AS date), CAST(N'2011-09-26' AS date), 2011, 20113, 201109, 2011268, 3, 9, 268, 25, 1, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-09-19' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-09-23' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-30' AS date), 1034, 3104, 13499, 13499, 13499, 13499, 13499, 13499, 13499, 2455830, 55829, N'2011-09-25', 201138, 38, 7, N'2011-W38', N'2011-W38-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94500, CAST(N'2011-09-26' AS date), CAST(N'2011-09-27' AS date), 2011, 20113, 201109, 2011269, 3, 9, 269, 26, 2, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-09-20' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-09-23' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-30' AS date), 1034, 3104, 13499, 13500, 13499, 13499, 13499, 13499, 13499, 2455831, 55830, N'2011-09-26', 201139, 39, 1, N'2011-W39', N'2011-W39-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94501, CAST(N'2011-09-27' AS date), CAST(N'2011-09-28' AS date), 2011, 20113, 201109, 2011270, 3, 9, 270, 27, 3, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-09-21' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-09-23' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-30' AS date), 1034, 3104, 13499, 13500, 13500, 13499, 13499, 13499, 13499, 2455832, 55831, N'2011-09-27', 201139, 39, 2, N'2011-W39', N'2011-W39-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94502, CAST(N'2011-09-28' AS date), CAST(N'2011-09-29' AS date), 2011, 20113, 201109, 2011271, 3, 9, 271, 28, 4, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-09-22' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-09-23' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-30' AS date), 1034, 3104, 13499, 13500, 13500, 13500, 13499, 13499, 13499, 2455833, 55832, N'2011-09-28', 201139, 39, 3, N'2011-W39', N'2011-W39-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94503, CAST(N'2011-09-29' AS date), CAST(N'2011-09-30' AS date), 2011, 20113, 201109, 2011272, 3, 9, 272, 29, 5, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-09-23' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-30' AS date), 1034, 3104, 13499, 13500, 13500, 13500, 13500, 13499, 13499, 2455834, 55833, N'2011-09-29', 201139, 39, 4, N'2011-W39', N'2011-W39-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94504, CAST(N'2011-09-30' AS date), CAST(N'2011-10-01' AS date), 2011, 20113, 201109, 2011273, 3, 9, 273, 30, 6, N'2011', N'2011 Q3', N'2011 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-07-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-01' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-09-24' AS date), CAST(N'2011-09-30' AS date), 1034, 3104, 13499, 13500, 13500, 13500, 13500, 13500, 13499, 2455835, 55834, N'2011-09-30', 201139, 39, 5, N'2011-W39', N'2011-W39-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94505, CAST(N'2011-10-01' AS date), CAST(N'2011-10-02' AS date), 2011, 20114, 201110, 2011274, 4, 10, 274, 1, 7, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-09-25' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-07' AS date), 1035, 3105, 13499, 13500, 13500, 13500, 13500, 13500, 13500, 2455836, 55835, N'2011-10-01', 201139, 39, 6, N'2011-W39', N'2011-W39-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94506, CAST(N'2011-10-02' AS date), CAST(N'2011-10-03' AS date), 2011, 20114, 201110, 2011275, 4, 10, 275, 2, 1, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-09-26' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-07' AS date), 1035, 3105, 13500, 13500, 13500, 13500, 13500, 13500, 13500, 2455837, 55836, N'2011-10-02', 201139, 39, 7, N'2011-W39', N'2011-W39-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94507, CAST(N'2011-10-03' AS date), CAST(N'2011-10-04' AS date), 2011, 20114, 201110, 2011276, 4, 10, 276, 3, 2, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-09-27' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-07' AS date), 1035, 3105, 13500, 13501, 13500, 13500, 13500, 13500, 13500, 2455838, 55837, N'2011-10-03', 201140, 40, 1, N'2011-W40', N'2011-W40-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94508, CAST(N'2011-10-04' AS date), CAST(N'2011-10-05' AS date), 2011, 20114, 201110, 2011277, 4, 10, 277, 4, 3, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-09-28' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-07' AS date), 1035, 3105, 13500, 13501, 13501, 13500, 13500, 13500, 13500, 2455839, 55838, N'2011-10-04', 201140, 40, 2, N'2011-W40', N'2011-W40-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94509, CAST(N'2011-10-05' AS date), CAST(N'2011-10-06' AS date), 2011, 20114, 201110, 2011278, 4, 10, 278, 5, 4, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-09-29' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-07' AS date), 1035, 3105, 13500, 13501, 13501, 13501, 13500, 13500, 13500, 2455840, 55839, N'2011-10-05', 201140, 40, 3, N'2011-W40', N'2011-W40-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94510, CAST(N'2011-10-06' AS date), CAST(N'2011-10-07' AS date), 2011, 20114, 201110, 2011279, 4, 10, 279, 6, 5, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-09-30' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-07' AS date), 1035, 3105, 13500, 13501, 13501, 13501, 13501, 13500, 13500, 2455841, 55840, N'2011-10-06', 201140, 40, 4, N'2011-W40', N'2011-W40-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94511, CAST(N'2011-10-07' AS date), CAST(N'2011-10-08' AS date), 2011, 20114, 201110, 2011280, 4, 10, 280, 7, 6, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-07' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-07' AS date), 1035, 3105, 13500, 13501, 13501, 13501, 13501, 13501, 13500, 2455842, 55841, N'2011-10-07', 201140, 40, 5, N'2011-W40', N'2011-W40-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94512, CAST(N'2011-10-08' AS date), CAST(N'2011-10-09' AS date), 2011, 20114, 201110, 2011281, 4, 10, 281, 8, 7, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-02' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-07' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-14' AS date), 1035, 3105, 13500, 13501, 13501, 13501, 13501, 13501, 13501, 2455843, 55842, N'2011-10-08', 201140, 40, 6, N'2011-W40', N'2011-W40-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94513, CAST(N'2011-10-09' AS date), CAST(N'2011-10-10' AS date), 2011, 20114, 201110, 2011282, 4, 10, 282, 9, 1, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-03' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-07' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-14' AS date), 1035, 3105, 13501, 13501, 13501, 13501, 13501, 13501, 13501, 2455844, 55843, N'2011-10-09', 201140, 40, 7, N'2011-W40', N'2011-W40-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94514, CAST(N'2011-10-10' AS date), CAST(N'2011-10-11' AS date), 2011, 20114, 201110, 2011283, 4, 10, 283, 10, 2, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-04' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-07' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-14' AS date), 1035, 3105, 13501, 13502, 13501, 13501, 13501, 13501, 13501, 2455845, 55844, N'2011-10-10', 201141, 41, 1, N'2011-W41', N'2011-W41-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94515, CAST(N'2011-10-11' AS date), CAST(N'2011-10-12' AS date), 2011, 20114, 201110, 2011284, 4, 10, 284, 11, 3, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-05' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-07' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-14' AS date), 1035, 3105, 13501, 13502, 13502, 13501, 13501, 13501, 13501, 2455846, 55845, N'2011-10-11', 201141, 41, 2, N'2011-W41', N'2011-W41-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94516, CAST(N'2011-10-12' AS date), CAST(N'2011-10-13' AS date), 2011, 20114, 201110, 2011285, 4, 10, 285, 12, 4, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-06' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-07' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-14' AS date), 1035, 3105, 13501, 13502, 13502, 13502, 13501, 13501, 13501, 2455847, 55846, N'2011-10-12', 201141, 41, 3, N'2011-W41', N'2011-W41-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94517, CAST(N'2011-10-13' AS date), CAST(N'2011-10-14' AS date), 2011, 20114, 201110, 2011286, 4, 10, 286, 13, 5, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-07' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-14' AS date), 1035, 3105, 13501, 13502, 13502, 13502, 13502, 13501, 13501, 2455848, 55847, N'2011-10-13', 201141, 41, 4, N'2011-W41', N'2011-W41-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94518, CAST(N'2011-10-14' AS date), CAST(N'2011-10-15' AS date), 2011, 20114, 201110, 2011287, 4, 10, 287, 14, 6, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-14' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-08' AS date), CAST(N'2011-10-14' AS date), 1035, 3105, 13501, 13502, 13502, 13502, 13502, 13502, 13501, 2455849, 55848, N'2011-10-14', 201141, 41, 5, N'2011-W41', N'2011-W41-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94519, CAST(N'2011-10-15' AS date), CAST(N'2011-10-16' AS date), 2011, 20114, 201110, 2011288, 4, 10, 288, 15, 7, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-09' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-14' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-21' AS date), 1035, 3105, 13501, 13502, 13502, 13502, 13502, 13502, 13502, 2455850, 55849, N'2011-10-15', 201141, 41, 6, N'2011-W41', N'2011-W41-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94520, CAST(N'2011-10-16' AS date), CAST(N'2011-10-17' AS date), 2011, 20114, 201110, 2011289, 4, 10, 289, 16, 1, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-10' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-14' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-21' AS date), 1035, 3105, 13502, 13502, 13502, 13502, 13502, 13502, 13502, 2455851, 55850, N'2011-10-16', 201141, 41, 7, N'2011-W41', N'2011-W41-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94521, CAST(N'2011-10-17' AS date), CAST(N'2011-10-18' AS date), 2011, 20114, 201110, 2011290, 4, 10, 290, 17, 2, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-11' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-14' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-21' AS date), 1035, 3105, 13502, 13503, 13502, 13502, 13502, 13502, 13502, 2455852, 55851, N'2011-10-17', 201142, 42, 1, N'2011-W42', N'2011-W42-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94522, CAST(N'2011-10-18' AS date), CAST(N'2011-10-19' AS date), 2011, 20114, 201110, 2011291, 4, 10, 291, 18, 3, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-12' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-14' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-21' AS date), 1035, 3105, 13502, 13503, 13503, 13502, 13502, 13502, 13502, 2455853, 55852, N'2011-10-18', 201142, 42, 2, N'2011-W42', N'2011-W42-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94523, CAST(N'2011-10-19' AS date), CAST(N'2011-10-20' AS date), 2011, 20114, 201110, 2011292, 4, 10, 292, 19, 4, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-13' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-14' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-21' AS date), 1035, 3105, 13502, 13503, 13503, 13503, 13502, 13502, 13502, 2455854, 55853, N'2011-10-19', 201142, 42, 3, N'2011-W42', N'2011-W42-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94524, CAST(N'2011-10-20' AS date), CAST(N'2011-10-21' AS date), 2011, 20114, 201110, 2011293, 4, 10, 293, 20, 5, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-10-14' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-21' AS date), 1035, 3105, 13502, 13503, 13503, 13503, 13503, 13502, 13502, 2455855, 55854, N'2011-10-20', 201142, 42, 4, N'2011-W42', N'2011-W42-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94525, CAST(N'2011-10-21' AS date), CAST(N'2011-10-22' AS date), 2011, 20114, 201110, 2011294, 4, 10, 294, 21, 6, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-10-21' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-10-15' AS date), CAST(N'2011-10-21' AS date), 1035, 3105, 13502, 13503, 13503, 13503, 13503, 13503, 13502, 2455856, 55855, N'2011-10-21', 201142, 42, 5, N'2011-W42', N'2011-W42-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94526, CAST(N'2011-10-22' AS date), CAST(N'2011-10-23' AS date), 2011, 20114, 201110, 2011295, 4, 10, 295, 22, 7, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-16' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-10-21' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-28' AS date), 1035, 3105, 13502, 13503, 13503, 13503, 13503, 13503, 13503, 2455857, 55856, N'2011-10-22', 201142, 42, 6, N'2011-W42', N'2011-W42-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94527, CAST(N'2011-10-23' AS date), CAST(N'2011-10-24' AS date), 2011, 20114, 201110, 2011296, 4, 10, 296, 23, 1, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-10-17' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-10-21' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-28' AS date), 1035, 3105, 13503, 13503, 13503, 13503, 13503, 13503, 13503, 2455858, 55857, N'2011-10-23', 201142, 42, 7, N'2011-W42', N'2011-W42-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94528, CAST(N'2011-10-24' AS date), CAST(N'2011-10-25' AS date), 2011, 20114, 201110, 2011297, 4, 10, 297, 24, 2, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-10-18' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-10-21' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-28' AS date), 1035, 3105, 13503, 13504, 13503, 13503, 13503, 13503, 13503, 2455859, 55858, N'2011-10-24', 201143, 43, 1, N'2011-W43', N'2011-W43-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94529, CAST(N'2011-10-25' AS date), CAST(N'2011-10-26' AS date), 2011, 20114, 201110, 2011298, 4, 10, 298, 25, 3, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-19' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-10-21' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-28' AS date), 1035, 3105, 13503, 13504, 13504, 13503, 13503, 13503, 13503, 2455860, 55859, N'2011-10-25', 201143, 43, 2, N'2011-W43', N'2011-W43-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94530, CAST(N'2011-10-26' AS date), CAST(N'2011-10-27' AS date), 2011, 20114, 201110, 2011299, 4, 10, 299, 26, 4, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-10-20' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-10-21' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-28' AS date), 1035, 3105, 13503, 13504, 13504, 13504, 13503, 13503, 13503, 2455861, 55860, N'2011-10-26', 201143, 43, 3, N'2011-W43', N'2011-W43-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94531, CAST(N'2011-10-27' AS date), CAST(N'2011-10-28' AS date), 2011, 20114, 201110, 2011300, 4, 10, 300, 27, 5, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-10-21' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-28' AS date), 1035, 3105, 13503, 13504, 13504, 13504, 13504, 13503, 13503, 2455862, 55861, N'2011-10-27', 201143, 43, 4, N'2011-W43', N'2011-W43-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94532, CAST(N'2011-10-28' AS date), CAST(N'2011-10-29' AS date), 2011, 20114, 201110, 2011301, 4, 10, 301, 28, 6, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-10-28' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-10-22' AS date), CAST(N'2011-10-28' AS date), 1035, 3105, 13503, 13504, 13504, 13504, 13504, 13504, 13503, 2455863, 55862, N'2011-10-28', 201143, 43, 5, N'2011-W43', N'2011-W43-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94533, CAST(N'2011-10-29' AS date), CAST(N'2011-10-30' AS date), 2011, 20114, 201110, 2011302, 4, 10, 302, 29, 7, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-23' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-10-28' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-11-04' AS date), 1035, 3105, 13503, 13504, 13504, 13504, 13504, 13504, 13504, 2455864, 55863, N'2011-10-29', 201143, 43, 6, N'2011-W43', N'2011-W43-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94534, CAST(N'2011-10-30' AS date), CAST(N'2011-10-31' AS date), 2011, 20114, 201110, 2011303, 4, 10, 303, 30, 1, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-10-24' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-10-28' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-11-04' AS date), 1035, 3105, 13504, 13504, 13504, 13504, 13504, 13504, 13504, 2455865, 55864, N'2011-10-30', 201143, 43, 7, N'2011-W43', N'2011-W43-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94535, CAST(N'2011-10-31' AS date), CAST(N'2011-11-01' AS date), 2011, 20114, 201110, 2011304, 4, 10, 304, 31, 2, N'2011', N'2011 Q4', N'2011 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-10-25' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-10-28' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-11-04' AS date), 1035, 3105, 13504, 13505, 13504, 13504, 13504, 13504, 13504, 2455866, 55865, N'2011-10-31', 201144, 44, 1, N'2011-W44', N'2011-W44-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94536, CAST(N'2011-11-01' AS date), CAST(N'2011-11-02' AS date), 2011, 20114, 201111, 2011305, 4, 11, 305, 1, 3, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-10-26' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-10-28' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-11-04' AS date), 1035, 3106, 13504, 13505, 13505, 13504, 13504, 13504, 13504, 2455867, 55866, N'2011-11-01', 201144, 44, 2, N'2011-W44', N'2011-W44-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94537, CAST(N'2011-11-02' AS date), CAST(N'2011-11-03' AS date), 2011, 20114, 201111, 2011306, 4, 11, 306, 2, 4, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-10-27' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-10-28' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-11-04' AS date), 1035, 3106, 13504, 13505, 13505, 13505, 13504, 13504, 13504, 2455868, 55867, N'2011-11-02', 201144, 44, 3, N'2011-W44', N'2011-W44-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94538, CAST(N'2011-11-03' AS date), CAST(N'2011-11-04' AS date), 2011, 20114, 201111, 2011307, 4, 11, 307, 3, 5, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-10-28' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-11-04' AS date), 1035, 3106, 13504, 13505, 13505, 13505, 13505, 13504, 13504, 2455869, 55868, N'2011-11-03', 201144, 44, 4, N'2011-W44', N'2011-W44-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94539, CAST(N'2011-11-04' AS date), CAST(N'2011-11-05' AS date), 2011, 20114, 201111, 2011308, 4, 11, 308, 4, 6, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-04' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-10-29' AS date), CAST(N'2011-11-04' AS date), 1035, 3106, 13504, 13505, 13505, 13505, 13505, 13505, 13504, 2455870, 55869, N'2011-11-04', 201144, 44, 5, N'2011-W44', N'2011-W44-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94540, CAST(N'2011-11-05' AS date), CAST(N'2011-11-06' AS date), 2011, 20114, 201111, 2011309, 4, 11, 309, 5, 7, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-10-30' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-04' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-11-11' AS date), 1035, 3106, 13504, 13505, 13505, 13505, 13505, 13505, 13505, 2455871, 55870, N'2011-11-05', 201144, 44, 6, N'2011-W44', N'2011-W44-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94541, CAST(N'2011-11-06' AS date), CAST(N'2011-11-07' AS date), 2011, 20114, 201111, 2011310, 4, 11, 310, 6, 1, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-10-31' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-04' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-11-11' AS date), 1035, 3106, 13505, 13505, 13505, 13505, 13505, 13505, 13505, 2455872, 55871, N'2011-11-06', 201144, 44, 7, N'2011-W44', N'2011-W44-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94542, CAST(N'2011-11-07' AS date), CAST(N'2011-11-08' AS date), 2011, 20114, 201111, 2011311, 4, 11, 311, 7, 2, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-04' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-11-11' AS date), 1035, 3106, 13505, 13506, 13505, 13505, 13505, 13505, 13505, 2455873, 55872, N'2011-11-07', 201145, 45, 1, N'2011-W45', N'2011-W45-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94543, CAST(N'2011-11-08' AS date), CAST(N'2011-11-09' AS date), 2011, 20114, 201111, 2011312, 4, 11, 312, 8, 3, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-02' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-04' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-11-11' AS date), 1035, 3106, 13505, 13506, 13506, 13505, 13505, 13505, 13505, 2455874, 55873, N'2011-11-08', 201145, 45, 2, N'2011-W45', N'2011-W45-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94544, CAST(N'2011-11-09' AS date), CAST(N'2011-11-10' AS date), 2011, 20114, 201111, 2011313, 4, 11, 313, 9, 4, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-03' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-04' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-11-11' AS date), 1035, 3106, 13505, 13506, 13506, 13506, 13505, 13505, 13505, 2455875, 55874, N'2011-11-09', 201145, 45, 3, N'2011-W45', N'2011-W45-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94545, CAST(N'2011-11-10' AS date), CAST(N'2011-11-11' AS date), 2011, 20114, 201111, 2011314, 4, 11, 314, 10, 5, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-04' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-11-11' AS date), 1035, 3106, 13505, 13506, 13506, 13506, 13506, 13505, 13505, 2455876, 55875, N'2011-11-10', 201145, 45, 4, N'2011-W45', N'2011-W45-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94546, CAST(N'2011-11-11' AS date), CAST(N'2011-11-12' AS date), 2011, 20114, 201111, 2011315, 4, 11, 315, 11, 6, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-11' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-05' AS date), CAST(N'2011-11-11' AS date), 1035, 3106, 13505, 13506, 13506, 13506, 13506, 13506, 13505, 2455877, 55876, N'2011-11-11', 201145, 45, 5, N'2011-W45', N'2011-W45-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94547, CAST(N'2011-11-12' AS date), CAST(N'2011-11-13' AS date), 2011, 20114, 201111, 2011316, 4, 11, 316, 12, 7, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-06' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-11' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-18' AS date), 1035, 3106, 13505, 13506, 13506, 13506, 13506, 13506, 13506, 2455878, 55877, N'2011-11-12', 201145, 45, 6, N'2011-W45', N'2011-W45-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94548, CAST(N'2011-11-13' AS date), CAST(N'2011-11-14' AS date), 2011, 20114, 201111, 2011317, 4, 11, 317, 13, 1, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-07' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-11' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-18' AS date), 1035, 3106, 13506, 13506, 13506, 13506, 13506, 13506, 13506, 2455879, 55878, N'2011-11-13', 201145, 45, 7, N'2011-W45', N'2011-W45-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94549, CAST(N'2011-11-14' AS date), CAST(N'2011-11-15' AS date), 2011, 20114, 201111, 2011318, 4, 11, 318, 14, 2, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-08' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-11' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-18' AS date), 1035, 3106, 13506, 13507, 13506, 13506, 13506, 13506, 13506, 2455880, 55879, N'2011-11-14', 201146, 46, 1, N'2011-W46', N'2011-W46-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94550, CAST(N'2011-11-15' AS date), CAST(N'2011-11-16' AS date), 2011, 20114, 201111, 2011319, 4, 11, 319, 15, 3, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-09' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-11' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-18' AS date), 1035, 3106, 13506, 13507, 13507, 13506, 13506, 13506, 13506, 2455881, 55880, N'2011-11-15', 201146, 46, 2, N'2011-W46', N'2011-W46-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94551, CAST(N'2011-11-16' AS date), CAST(N'2011-11-17' AS date), 2011, 20114, 201111, 2011320, 4, 11, 320, 16, 4, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-10' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-11' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-18' AS date), 1035, 3106, 13506, 13507, 13507, 13507, 13506, 13506, 13506, 2455882, 55881, N'2011-11-16', 201146, 46, 3, N'2011-W46', N'2011-W46-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94552, CAST(N'2011-11-17' AS date), CAST(N'2011-11-18' AS date), 2011, 20114, 201111, 2011321, 4, 11, 321, 17, 5, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-11' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-18' AS date), 1035, 3106, 13506, 13507, 13507, 13507, 13507, 13506, 13506, 2455883, 55882, N'2011-11-17', 201146, 46, 4, N'2011-W46', N'2011-W46-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94553, CAST(N'2011-11-18' AS date), CAST(N'2011-11-19' AS date), 2011, 20114, 201111, 2011322, 4, 11, 322, 18, 6, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-18' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-12' AS date), CAST(N'2011-11-18' AS date), 1035, 3106, 13506, 13507, 13507, 13507, 13507, 13507, 13506, 2455884, 55883, N'2011-11-18', 201146, 46, 5, N'2011-W46', N'2011-W46-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94554, CAST(N'2011-11-19' AS date), CAST(N'2011-11-20' AS date), 2011, 20114, 201111, 2011323, 4, 11, 323, 19, 7, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-13' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-18' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-25' AS date), 1035, 3106, 13506, 13507, 13507, 13507, 13507, 13507, 13507, 2455885, 55884, N'2011-11-19', 201146, 46, 6, N'2011-W46', N'2011-W46-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94555, CAST(N'2011-11-20' AS date), CAST(N'2011-11-21' AS date), 2011, 20114, 201111, 2011324, 4, 11, 324, 20, 1, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-11-14' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-18' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-25' AS date), 1035, 3106, 13507, 13507, 13507, 13507, 13507, 13507, 13507, 2455886, 55885, N'2011-11-20', 201146, 46, 7, N'2011-W46', N'2011-W46-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94556, CAST(N'2011-11-21' AS date), CAST(N'2011-11-22' AS date), 2011, 20114, 201111, 2011325, 4, 11, 325, 21, 2, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-11-15' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-18' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-25' AS date), 1035, 3106, 13507, 13508, 13507, 13507, 13507, 13507, 13507, 2455887, 55886, N'2011-11-21', 201147, 47, 1, N'2011-W47', N'2011-W47-1');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94557, CAST(N'2011-11-22' AS date), CAST(N'2011-11-23' AS date), 2011, 20114, 201111, 2011326, 4, 11, 326, 22, 3, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-11-16' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-18' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-25' AS date), 1035, 3106, 13507, 13508, 13508, 13507, 13507, 13507, 13507, 2455888, 55887, N'2011-11-22', 201147, 47, 2, N'2011-W47', N'2011-W47-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94558, CAST(N'2011-11-23' AS date), CAST(N'2011-11-24' AS date), 2011, 20114, 201111, 2011327, 4, 11, 327, 23, 4, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-11-17' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-18' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-25' AS date), 1035, 3106, 13507, 13508, 13508, 13508, 13507, 13507, 13507, 2455889, 55888, N'2011-11-23', 201147, 47, 3, N'2011-W47', N'2011-W47-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94559, CAST(N'2011-11-24' AS date), CAST(N'2011-11-25' AS date), 2011, 20114, 201111, 2011328, 4, 11, 328, 24, 5, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-18' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-25' AS date), 1035, 3106, 13507, 13508, 13508, 13508, 13508, 13507, 13507, 2455890, 55889, N'2011-11-24', 201147, 47, 4, N'2011-W47', N'2011-W47-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94560, CAST(N'2011-11-25' AS date), CAST(N'2011-11-26' AS date), 2011, 20114, 201111, 2011329, 4, 11, 329, 25, 6, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-25' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-11-19' AS date), CAST(N'2011-11-25' AS date), 1035, 3106, 13507, 13508, 13508, 13508, 13508, 13508, 13507, 2455891, 55890, N'2011-11-25', 201147, 47, 5, N'2011-W47', N'2011-W47-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94561, CAST(N'2011-11-26' AS date), CAST(N'2011-11-27' AS date), 2011, 20114, 201111, 2011330, 4, 11, 330, 26, 7, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-20' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-25' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-12-02' AS date), 1035, 3106, 13507, 13508, 13508, 13508, 13508, 13508, 13508, 2455892, 55891, N'2011-11-26', 201147, 47, 6, N'2011-W47', N'2011-W47-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94562, CAST(N'2011-11-27' AS date), CAST(N'2011-11-28' AS date), 2011, 20114, 201111, 2011331, 4, 11, 331, 27, 1, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-11-21' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-25' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-12-02' AS date), 1035, 3106, 13508, 13508, 13508, 13508, 13508, 13508, 13508, 2455893, 55892, N'2011-11-27', 201147, 47, 7, N'2011-W47', N'2011-W47-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94563, CAST(N'2011-11-28' AS date), CAST(N'2011-11-29' AS date), 2011, 20114, 201111, 2011332, 4, 11, 332, 28, 2, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-11-22' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-25' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-12-02' AS date), 1035, 3106, 13508, 13509, 13508, 13508, 13508, 13508, 13508, 2455894, 55893, N'2011-11-28', 201148, 48, 1, N'2011-W48', N'2011-W48-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94564, CAST(N'2011-11-29' AS date), CAST(N'2011-11-30' AS date), 2011, 20114, 201111, 2011333, 4, 11, 333, 29, 3, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-11-23' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-25' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-12-02' AS date), 1035, 3106, 13508, 13509, 13509, 13508, 13508, 13508, 13508, 2455895, 55894, N'2011-11-29', 201148, 48, 2, N'2011-W48', N'2011-W48-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94565, CAST(N'2011-11-30' AS date), CAST(N'2011-12-01' AS date), 2011, 20114, 201111, 2011334, 4, 11, 334, 30, 4, N'2011', N'2011 Q4', N'2011 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-01' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-11-24' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-11-25' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-12-02' AS date), 1035, 3106, 13508, 13509, 13509, 13509, 13508, 13508, 13508, 2455896, 55895, N'2011-11-30', 201148, 48, 3, N'2011-W48', N'2011-W48-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94566, CAST(N'2011-12-01' AS date), CAST(N'2011-12-02' AS date), 2011, 20114, 201112, 2011335, 4, 12, 335, 1, 5, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-11-25' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-12-02' AS date), 1035, 3107, 13508, 13509, 13509, 13509, 13509, 13508, 13508, 2455897, 55896, N'2011-12-01', 201148, 48, 4, N'2011-W48', N'2011-W48-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94567, CAST(N'2011-12-02' AS date), CAST(N'2011-12-03' AS date), 2011, 20114, 201112, 2011336, 4, 12, 336, 2, 6, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-02' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-11-26' AS date), CAST(N'2011-12-02' AS date), 1035, 3107, 13508, 13509, 13509, 13509, 13509, 13509, 13508, 2455898, 55897, N'2011-12-02', 201148, 48, 5, N'2011-W48', N'2011-W48-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94568, CAST(N'2011-12-03' AS date), CAST(N'2011-12-04' AS date), 2011, 20114, 201112, 2011337, 4, 12, 337, 3, 7, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-11-27' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-02' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-12-09' AS date), 1035, 3107, 13508, 13509, 13509, 13509, 13509, 13509, 13509, 2455899, 55898, N'2011-12-03', 201148, 48, 6, N'2011-W48', N'2011-W48-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94569, CAST(N'2011-12-04' AS date), CAST(N'2011-12-05' AS date), 2011, 20114, 201112, 2011338, 4, 12, 338, 4, 1, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-11-28' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-02' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-12-09' AS date), 1035, 3107, 13509, 13509, 13509, 13509, 13509, 13509, 13509, 2455900, 55899, N'2011-12-04', 201148, 48, 7, N'2011-W48', N'2011-W48-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94570, CAST(N'2011-12-05' AS date), CAST(N'2011-12-06' AS date), 2011, 20114, 201112, 2011339, 4, 12, 339, 5, 2, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-11-29' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-02' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-12-09' AS date), 1035, 3107, 13509, 13510, 13509, 13509, 13509, 13509, 13509, 2455901, 55900, N'2011-12-05', 201149, 49, 1, N'2011-W49', N'2011-W49-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94571, CAST(N'2011-12-06' AS date), CAST(N'2011-12-07' AS date), 2011, 20114, 201112, 2011340, 4, 12, 340, 6, 3, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-11-30' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-02' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-12-09' AS date), 1035, 3107, 13509, 13510, 13510, 13509, 13509, 13509, 13509, 2455902, 55901, N'2011-12-06', 201149, 49, 2, N'2011-W49', N'2011-W49-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94572, CAST(N'2011-12-07' AS date), CAST(N'2011-12-08' AS date), 2011, 20114, 201112, 2011341, 4, 12, 341, 7, 4, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-02' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-12-09' AS date), 1035, 3107, 13509, 13510, 13510, 13510, 13509, 13509, 13509, 2455903, 55902, N'2011-12-07', 201149, 49, 3, N'2011-W49', N'2011-W49-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94573, CAST(N'2011-12-08' AS date), CAST(N'2011-12-09' AS date), 2011, 20114, 201112, 2011342, 4, 12, 342, 8, 5, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-02' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-12-09' AS date), 1035, 3107, 13509, 13510, 13510, 13510, 13510, 13509, 13509, 2455904, 55903, N'2011-12-08', 201149, 49, 4, N'2011-W49', N'2011-W49-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94574, CAST(N'2011-12-09' AS date), CAST(N'2011-12-10' AS date), 2011, 20114, 201112, 2011343, 4, 12, 343, 9, 6, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-09' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-03' AS date), CAST(N'2011-12-09' AS date), 1035, 3107, 13509, 13510, 13510, 13510, 13510, 13510, 13509, 2455905, 55904, N'2011-12-09', 201149, 49, 5, N'2011-W49', N'2011-W49-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94575, CAST(N'2011-12-10' AS date), CAST(N'2011-12-11' AS date), 2011, 20114, 201112, 2011344, 4, 12, 344, 10, 7, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-04' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-09' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-16' AS date), 1035, 3107, 13509, 13510, 13510, 13510, 13510, 13510, 13510, 2455906, 55905, N'2011-12-10', 201149, 49, 6, N'2011-W49', N'2011-W49-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94576, CAST(N'2011-12-11' AS date), CAST(N'2011-12-12' AS date), 2011, 20114, 201112, 2011345, 4, 12, 345, 11, 1, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-05' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-09' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-16' AS date), 1035, 3107, 13510, 13510, 13510, 13510, 13510, 13510, 13510, 2455907, 55906, N'2011-12-11', 201149, 49, 7, N'2011-W49', N'2011-W49-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94577, CAST(N'2011-12-12' AS date), CAST(N'2011-12-13' AS date), 2011, 20114, 201112, 2011346, 4, 12, 346, 12, 2, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-06' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-09' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-16' AS date), 1035, 3107, 13510, 13511, 13510, 13510, 13510, 13510, 13510, 2455908, 55907, N'2011-12-12', 201150, 50, 1, N'2011-W50', N'2011-W50-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94578, CAST(N'2011-12-13' AS date), CAST(N'2011-12-14' AS date), 2011, 20114, 201112, 2011347, 4, 12, 347, 13, 3, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-07' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-09' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-16' AS date), 1035, 3107, 13510, 13511, 13511, 13510, 13510, 13510, 13510, 2455909, 55908, N'2011-12-13', 201150, 50, 2, N'2011-W50', N'2011-W50-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94579, CAST(N'2011-12-14' AS date), CAST(N'2011-12-15' AS date), 2011, 20114, 201112, 2011348, 4, 12, 348, 14, 4, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-08' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-09' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-16' AS date), 1035, 3107, 13510, 13511, 13511, 13511, 13510, 13510, 13510, 2455910, 55909, N'2011-12-14', 201150, 50, 3, N'2011-W50', N'2011-W50-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94580, CAST(N'2011-12-15' AS date), CAST(N'2011-12-16' AS date), 2011, 20114, 201112, 2011349, 4, 12, 349, 15, 5, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-09' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-16' AS date), 1035, 3107, 13510, 13511, 13511, 13511, 13511, 13510, 13510, 2455911, 55910, N'2011-12-15', 201150, 50, 4, N'2011-W50', N'2011-W50-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94581, CAST(N'2011-12-16' AS date), CAST(N'2011-12-17' AS date), 2011, 20114, 201112, 2011350, 4, 12, 350, 16, 6, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-16' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-10' AS date), CAST(N'2011-12-16' AS date), 1035, 3107, 13510, 13511, 13511, 13511, 13511, 13511, 13510, 2455912, 55911, N'2011-12-16', 201150, 50, 5, N'2011-W50', N'2011-W50-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94582, CAST(N'2011-12-17' AS date), CAST(N'2011-12-18' AS date), 2011, 20114, 201112, 2011351, 4, 12, 351, 17, 7, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-11' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-16' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-23' AS date), 1035, 3107, 13510, 13511, 13511, 13511, 13511, 13511, 13511, 2455913, 55912, N'2011-12-17', 201150, 50, 6, N'2011-W50', N'2011-W50-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94583, CAST(N'2011-12-18' AS date), CAST(N'2011-12-19' AS date), 2011, 20114, 201112, 2011352, 4, 12, 352, 18, 1, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-12' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-16' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-23' AS date), 1035, 3107, 13511, 13511, 13511, 13511, 13511, 13511, 13511, 2455914, 55913, N'2011-12-18', 201150, 50, 7, N'2011-W50', N'2011-W50-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94584, CAST(N'2011-12-19' AS date), CAST(N'2011-12-20' AS date), 2011, 20114, 201112, 2011353, 4, 12, 353, 19, 2, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-13' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-16' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-23' AS date), 1035, 3107, 13511, 13512, 13511, 13511, 13511, 13511, 13511, 2455915, 55914, N'2011-12-19', 201151, 51, 1, N'2011-W51', N'2011-W51-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94585, CAST(N'2011-12-20' AS date), CAST(N'2011-12-21' AS date), 2011, 20114, 201112, 2011354, 4, 12, 354, 20, 3, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-26' AS date), CAST(N'2011-12-14' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-16' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-23' AS date), 1035, 3107, 13511, 13512, 13512, 13511, 13511, 13511, 13511, 2455916, 55915, N'2011-12-20', 201151, 51, 2, N'2011-W51', N'2011-W51-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94586, CAST(N'2011-12-21' AS date), CAST(N'2011-12-22' AS date), 2011, 20114, 201112, 2011355, 4, 12, 355, 21, 4, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-26' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-27' AS date), CAST(N'2011-12-15' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-16' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-23' AS date), 1035, 3107, 13511, 13512, 13512, 13512, 13511, 13511, 13511, 2455917, 55916, N'2011-12-21', 201151, 51, 3, N'2011-W51', N'2011-W51-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94587, CAST(N'2011-12-22' AS date), CAST(N'2011-12-23' AS date), 2011, 20114, 201112, 2011356, 4, 12, 356, 22, 5, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-26' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-27' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-28' AS date), CAST(N'2011-12-16' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-23' AS date), 1035, 3107, 13511, 13512, 13512, 13512, 13512, 13511, 13511, 2455918, 55917, N'2011-12-22', 201151, 51, 4, N'2011-W51', N'2011-W51-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94588, CAST(N'2011-12-23' AS date), CAST(N'2011-12-24' AS date), 2011, 20114, 201112, 2011357, 4, 12, 357, 23, 6, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-26' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-27' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-28' AS date), CAST(N'2011-12-23' AS date), CAST(N'2011-12-29' AS date), CAST(N'2011-12-17' AS date), CAST(N'2011-12-23' AS date), 1035, 3107, 13511, 13512, 13512, 13512, 13512, 13512, 13511, 2455919, 55918, N'2011-12-23', 201151, 51, 5, N'2011-W51', N'2011-W51-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94589, CAST(N'2011-12-24' AS date), CAST(N'2011-12-25' AS date), 2011, 20114, 201112, 2011358, 4, 12, 358, 24, 7, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-18' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-26' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-27' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-28' AS date), CAST(N'2011-12-23' AS date), CAST(N'2011-12-29' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-30' AS date), 1035, 3107, 13511, 13512, 13512, 13512, 13512, 13512, 13512, 2455920, 55919, N'2011-12-24', 201151, 51, 6, N'2011-W51', N'2011-W51-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94590, CAST(N'2011-12-25' AS date), CAST(N'2011-12-26' AS date), 2011, 20114, 201112, 2011359, 4, 12, 359, 25, 1, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-19' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-26' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-27' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-28' AS date), CAST(N'2011-12-23' AS date), CAST(N'2011-12-29' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-30' AS date), 1035, 3107, 13512, 13512, 13512, 13512, 13512, 13512, 13512, 2455921, 55920, N'2011-12-25', 201151, 51, 7, N'2011-W51', N'2011-W51-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94591, CAST(N'2011-12-26' AS date), CAST(N'2011-12-27' AS date), 2011, 20114, 201112, 2011360, 4, 12, 360, 26, 2, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-26' AS date), CAST(N'2012-01-01' AS date), CAST(N'2011-12-20' AS date), CAST(N'2011-12-26' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-27' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-28' AS date), CAST(N'2011-12-23' AS date), CAST(N'2011-12-29' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-30' AS date), 1035, 3107, 13512, 13513, 13512, 13512, 13512, 13512, 13512, 2455922, 55921, N'2011-12-26', 201152, 52, 1, N'2011-W52', N'2011-W52-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94592, CAST(N'2011-12-27' AS date), CAST(N'2011-12-28' AS date), 2011, 20114, 201112, 2011361, 4, 12, 361, 27, 3, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-26' AS date), CAST(N'2012-01-01' AS date), CAST(N'2011-12-27' AS date), CAST(N'2012-01-02' AS date), CAST(N'2011-12-21' AS date), CAST(N'2011-12-27' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-28' AS date), CAST(N'2011-12-23' AS date), CAST(N'2011-12-29' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-30' AS date), 1035, 3107, 13512, 13513, 13513, 13512, 13512, 13512, 13512, 2455923, 55922, N'2011-12-27', 201152, 52, 2, N'2011-W52', N'2011-W52-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94593, CAST(N'2011-12-28' AS date), CAST(N'2011-12-29' AS date), 2011, 20114, 201112, 2011362, 4, 12, 362, 28, 4, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-26' AS date), CAST(N'2012-01-01' AS date), CAST(N'2011-12-27' AS date), CAST(N'2012-01-02' AS date), CAST(N'2011-12-28' AS date), CAST(N'2012-01-03' AS date), CAST(N'2011-12-22' AS date), CAST(N'2011-12-28' AS date), CAST(N'2011-12-23' AS date), CAST(N'2011-12-29' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-30' AS date), 1035, 3107, 13512, 13513, 13513, 13513, 13512, 13512, 13512, 2455924, 55923, N'2011-12-28', 201152, 52, 3, N'2011-W52', N'2011-W52-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94594, CAST(N'2011-12-29' AS date), CAST(N'2011-12-30' AS date), 2011, 20114, 201112, 2011363, 4, 12, 363, 29, 5, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-26' AS date), CAST(N'2012-01-01' AS date), CAST(N'2011-12-27' AS date), CAST(N'2012-01-02' AS date), CAST(N'2011-12-28' AS date), CAST(N'2012-01-03' AS date), CAST(N'2011-12-29' AS date), CAST(N'2012-01-04' AS date), CAST(N'2011-12-23' AS date), CAST(N'2011-12-29' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-30' AS date), 1035, 3107, 13512, 13513, 13513, 13513, 13513, 13512, 13512, 2455925, 55924, N'2011-12-29', 201152, 52, 4, N'2011-W52', N'2011-W52-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94595, CAST(N'2011-12-30' AS date), CAST(N'2011-12-31' AS date), 2011, 20114, 201112, 2011364, 4, 12, 364, 30, 6, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-26' AS date), CAST(N'2012-01-01' AS date), CAST(N'2011-12-27' AS date), CAST(N'2012-01-02' AS date), CAST(N'2011-12-28' AS date), CAST(N'2012-01-03' AS date), CAST(N'2011-12-29' AS date), CAST(N'2012-01-04' AS date), CAST(N'2011-12-30' AS date), CAST(N'2012-01-05' AS date), CAST(N'2011-12-24' AS date), CAST(N'2011-12-30' AS date), 1035, 3107, 13512, 13513, 13513, 13513, 13513, 13513, 13512, 2455926, 55925, N'2011-12-30', 201152, 52, 5, N'2011-W52', N'2011-W52-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94596, CAST(N'2011-12-31' AS date), CAST(N'2012-01-01' AS date), 2011, 20114, 201112, 2011365, 4, 12, 365, 31, 7, N'2011', N'2011 Q4', N'2011 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2011-01-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-10-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-01' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-25' AS date), CAST(N'2011-12-31' AS date), CAST(N'2011-12-26' AS date), CAST(N'2012-01-01' AS date), CAST(N'2011-12-27' AS date), CAST(N'2012-01-02' AS date), CAST(N'2011-12-28' AS date), CAST(N'2012-01-03' AS date), CAST(N'2011-12-29' AS date), CAST(N'2012-01-04' AS date), CAST(N'2011-12-30' AS date), CAST(N'2012-01-05' AS date), CAST(N'2011-12-31' AS date), CAST(N'2012-01-06' AS date), 1035, 3107, 13512, 13513, 13513, 13513, 13513, 13513, 13513, 2455927, 55926, N'2011-12-31', 201152, 52, 6, N'2011-W52', N'2011-W52-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94597, CAST(N'2012-01-01' AS date), CAST(N'2012-01-02' AS date), 2012, 20121, 201201, 2012001, 1, 1, 1, 1, 1, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-07' AS date), CAST(N'2011-12-26' AS date), CAST(N'2012-01-01' AS date), CAST(N'2011-12-27' AS date), CAST(N'2012-01-02' AS date), CAST(N'2011-12-28' AS date), CAST(N'2012-01-03' AS date), CAST(N'2011-12-29' AS date), CAST(N'2012-01-04' AS date), CAST(N'2011-12-30' AS date), CAST(N'2012-01-05' AS date), CAST(N'2011-12-31' AS date), CAST(N'2012-01-06' AS date), 1036, 3108, 13513, 13513, 13513, 13513, 13513, 13513, 13513, 2455928, 55927, N'2012-01-01', 201152, 52, 7, N'2011-W52', N'2011-W52-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94598, CAST(N'2012-01-02' AS date), CAST(N'2012-01-03' AS date), 2012, 20121, 201201, 2012002, 1, 1, 2, 2, 2, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-02' AS date), CAST(N'2012-01-08' AS date), CAST(N'2011-12-27' AS date), CAST(N'2012-01-02' AS date), CAST(N'2011-12-28' AS date), CAST(N'2012-01-03' AS date), CAST(N'2011-12-29' AS date), CAST(N'2012-01-04' AS date), CAST(N'2011-12-30' AS date), CAST(N'2012-01-05' AS date), CAST(N'2011-12-31' AS date), CAST(N'2012-01-06' AS date), 1036, 3108, 13513, 13514, 13513, 13513, 13513, 13513, 13513, 2455929, 55928, N'2012-01-02', 201201, 1, 1, N'2012-W01', N'2012-W01-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94599, CAST(N'2012-01-03' AS date), CAST(N'2012-01-04' AS date), 2012, 20121, 201201, 2012003, 1, 1, 3, 3, 3, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-02' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-03' AS date), CAST(N'2012-01-09' AS date), CAST(N'2011-12-28' AS date), CAST(N'2012-01-03' AS date), CAST(N'2011-12-29' AS date), CAST(N'2012-01-04' AS date), CAST(N'2011-12-30' AS date), CAST(N'2012-01-05' AS date), CAST(N'2011-12-31' AS date), CAST(N'2012-01-06' AS date), 1036, 3108, 13513, 13514, 13514, 13513, 13513, 13513, 13513, 2455930, 55929, N'2012-01-03', 201201, 1, 2, N'2012-W01', N'2012-W01-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94600, CAST(N'2012-01-04' AS date), CAST(N'2012-01-05' AS date), 2012, 20121, 201201, 2012004, 1, 1, 4, 4, 4, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-02' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-03' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-04' AS date), CAST(N'2012-01-10' AS date), CAST(N'2011-12-29' AS date), CAST(N'2012-01-04' AS date), CAST(N'2011-12-30' AS date), CAST(N'2012-01-05' AS date), CAST(N'2011-12-31' AS date), CAST(N'2012-01-06' AS date), 1036, 3108, 13513, 13514, 13514, 13514, 13513, 13513, 13513, 2455931, 55930, N'2012-01-04', 201201, 1, 3, N'2012-W01', N'2012-W01-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94601, CAST(N'2012-01-05' AS date), CAST(N'2012-01-06' AS date), 2012, 20121, 201201, 2012005, 1, 1, 5, 5, 5, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-02' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-03' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-04' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-05' AS date), CAST(N'2012-01-11' AS date), CAST(N'2011-12-30' AS date), CAST(N'2012-01-05' AS date), CAST(N'2011-12-31' AS date), CAST(N'2012-01-06' AS date), 1036, 3108, 13513, 13514, 13514, 13514, 13514, 13513, 13513, 2455932, 55931, N'2012-01-05', 201201, 1, 4, N'2012-W01', N'2012-W01-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94602, CAST(N'2012-01-06' AS date), CAST(N'2012-01-07' AS date), 2012, 20121, 201201, 2012006, 1, 1, 6, 6, 6, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-02' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-03' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-04' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-05' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-06' AS date), CAST(N'2012-01-12' AS date), CAST(N'2011-12-31' AS date), CAST(N'2012-01-06' AS date), 1036, 3108, 13513, 13514, 13514, 13514, 13514, 13514, 13513, 2455933, 55932, N'2012-01-06', 201201, 1, 5, N'2012-W01', N'2012-W01-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94603, CAST(N'2012-01-07' AS date), CAST(N'2012-01-08' AS date), 2012, 20121, 201201, 2012007, 1, 1, 7, 7, 7, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-02' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-03' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-04' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-05' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-06' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-13' AS date), 1036, 3108, 13513, 13514, 13514, 13514, 13514, 13514, 13514, 2455934, 55933, N'2012-01-07', 201201, 1, 6, N'2012-W01', N'2012-W01-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94604, CAST(N'2012-01-08' AS date), CAST(N'2012-01-09' AS date), 2012, 20121, 201201, 2012008, 1, 1, 8, 8, 1, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-02' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-03' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-04' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-05' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-06' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-13' AS date), 1036, 3108, 13514, 13514, 13514, 13514, 13514, 13514, 13514, 2455935, 55934, N'2012-01-08', 201201, 1, 7, N'2012-W01', N'2012-W01-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94605, CAST(N'2012-01-09' AS date), CAST(N'2012-01-10' AS date), 2012, 20121, 201201, 2012009, 1, 1, 9, 9, 2, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-03' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-04' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-05' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-06' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-13' AS date), 1036, 3108, 13514, 13515, 13514, 13514, 13514, 13514, 13514, 2455936, 55935, N'2012-01-09', 201202, 2, 1, N'2012-W02', N'2012-W02-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94606, CAST(N'2012-01-10' AS date), CAST(N'2012-01-11' AS date), 2012, 20121, 201201, 2012010, 1, 1, 10, 10, 3, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-04' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-05' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-06' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-13' AS date), 1036, 3108, 13514, 13515, 13515, 13514, 13514, 13514, 13514, 2455937, 55936, N'2012-01-10', 201202, 2, 2, N'2012-W02', N'2012-W02-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94607, CAST(N'2012-01-11' AS date), CAST(N'2012-01-12' AS date), 2012, 20121, 201201, 2012011, 1, 1, 11, 11, 4, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-05' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-06' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-13' AS date), 1036, 3108, 13514, 13515, 13515, 13515, 13514, 13514, 13514, 2455938, 55937, N'2012-01-11', 201202, 2, 3, N'2012-W02', N'2012-W02-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94608, CAST(N'2012-01-12' AS date), CAST(N'2012-01-13' AS date), 2012, 20121, 201201, 2012012, 1, 1, 12, 12, 5, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-06' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-13' AS date), 1036, 3108, 13514, 13515, 13515, 13515, 13515, 13514, 13514, 2455939, 55938, N'2012-01-12', 201202, 2, 4, N'2012-W02', N'2012-W02-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94609, CAST(N'2012-01-13' AS date), CAST(N'2012-01-14' AS date), 2012, 20121, 201201, 2012013, 1, 1, 13, 13, 6, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-13' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-07' AS date), CAST(N'2012-01-13' AS date), 1036, 3108, 13514, 13515, 13515, 13515, 13515, 13515, 13514, 2455940, 55939, N'2012-01-13', 201202, 2, 5, N'2012-W02', N'2012-W02-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94610, CAST(N'2012-01-14' AS date), CAST(N'2012-01-15' AS date), 2012, 20121, 201201, 2012014, 1, 1, 14, 14, 7, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-08' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-13' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-20' AS date), 1036, 3108, 13514, 13515, 13515, 13515, 13515, 13515, 13515, 2455941, 55940, N'2012-01-14', 201202, 2, 6, N'2012-W02', N'2012-W02-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94611, CAST(N'2012-01-15' AS date), CAST(N'2012-01-16' AS date), 2012, 20121, 201201, 2012015, 1, 1, 15, 15, 1, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-09' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-13' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-20' AS date), 1036, 3108, 13515, 13515, 13515, 13515, 13515, 13515, 13515, 2455942, 55941, N'2012-01-15', 201202, 2, 7, N'2012-W02', N'2012-W02-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94612, CAST(N'2012-01-16' AS date), CAST(N'2012-01-17' AS date), 2012, 20121, 201201, 2012016, 1, 1, 16, 16, 2, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-10' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-13' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-20' AS date), 1036, 3108, 13515, 13516, 13515, 13515, 13515, 13515, 13515, 2455943, 55942, N'2012-01-16', 201203, 3, 1, N'2012-W03', N'2012-W03-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94613, CAST(N'2012-01-17' AS date), CAST(N'2012-01-18' AS date), 2012, 20121, 201201, 2012017, 1, 1, 17, 17, 3, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-11' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-13' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-20' AS date), 1036, 3108, 13515, 13516, 13516, 13515, 13515, 13515, 13515, 2455944, 55943, N'2012-01-17', 201203, 3, 2, N'2012-W03', N'2012-W03-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94614, CAST(N'2012-01-18' AS date), CAST(N'2012-01-19' AS date), 2012, 20121, 201201, 2012018, 1, 1, 18, 18, 4, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-12' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-13' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-20' AS date), 1036, 3108, 13515, 13516, 13516, 13516, 13515, 13515, 13515, 2455945, 55944, N'2012-01-18', 201203, 3, 3, N'2012-W03', N'2012-W03-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94615, CAST(N'2012-01-19' AS date), CAST(N'2012-01-20' AS date), 2012, 20121, 201201, 2012019, 1, 1, 19, 19, 5, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-13' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-20' AS date), 1036, 3108, 13515, 13516, 13516, 13516, 13516, 13515, 13515, 2455946, 55945, N'2012-01-19', 201203, 3, 4, N'2012-W03', N'2012-W03-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94616, CAST(N'2012-01-20' AS date), CAST(N'2012-01-21' AS date), 2012, 20121, 201201, 2012020, 1, 1, 20, 20, 6, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-20' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-01-14' AS date), CAST(N'2012-01-20' AS date), 1036, 3108, 13515, 13516, 13516, 13516, 13516, 13516, 13515, 2455947, 55946, N'2012-01-20', 201203, 3, 5, N'2012-W03', N'2012-W03-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94617, CAST(N'2012-01-21' AS date), CAST(N'2012-01-22' AS date), 2012, 20121, 201201, 2012021, 1, 1, 21, 21, 7, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-15' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-20' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-27' AS date), 1036, 3108, 13515, 13516, 13516, 13516, 13516, 13516, 13516, 2455948, 55947, N'2012-01-21', 201203, 3, 6, N'2012-W03', N'2012-W03-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94618, CAST(N'2012-01-22' AS date), CAST(N'2012-01-23' AS date), 2012, 20121, 201201, 2012022, 1, 1, 22, 22, 1, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-01-16' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-20' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-27' AS date), 1036, 3108, 13516, 13516, 13516, 13516, 13516, 13516, 13516, 2455949, 55948, N'2012-01-22', 201203, 3, 7, N'2012-W03', N'2012-W03-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94619, CAST(N'2012-01-23' AS date), CAST(N'2012-01-24' AS date), 2012, 20121, 201201, 2012023, 1, 1, 23, 23, 2, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-01-17' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-20' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-27' AS date), 1036, 3108, 13516, 13517, 13516, 13516, 13516, 13516, 13516, 2455950, 55949, N'2012-01-23', 201204, 4, 1, N'2012-W04', N'2012-W04-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94620, CAST(N'2012-01-24' AS date), CAST(N'2012-01-25' AS date), 2012, 20121, 201201, 2012024, 1, 1, 24, 24, 3, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-01-18' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-20' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-27' AS date), 1036, 3108, 13516, 13517, 13517, 13516, 13516, 13516, 13516, 2455951, 55950, N'2012-01-24', 201204, 4, 2, N'2012-W04', N'2012-W04-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94621, CAST(N'2012-01-25' AS date), CAST(N'2012-01-26' AS date), 2012, 20121, 201201, 2012025, 1, 1, 25, 25, 4, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-19' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-20' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-27' AS date), 1036, 3108, 13516, 13517, 13517, 13517, 13516, 13516, 13516, 2455952, 55951, N'2012-01-25', 201204, 4, 3, N'2012-W04', N'2012-W04-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94622, CAST(N'2012-01-26' AS date), CAST(N'2012-01-27' AS date), 2012, 20121, 201201, 2012026, 1, 1, 26, 26, 5, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-01-20' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-27' AS date), 1036, 3108, 13516, 13517, 13517, 13517, 13517, 13516, 13516, 2455953, 55952, N'2012-01-26', 201204, 4, 4, N'2012-W04', N'2012-W04-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94623, CAST(N'2012-01-27' AS date), CAST(N'2012-01-28' AS date), 2012, 20121, 201201, 2012027, 1, 1, 27, 27, 6, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-01-27' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-01-21' AS date), CAST(N'2012-01-27' AS date), 1036, 3108, 13516, 13517, 13517, 13517, 13517, 13517, 13516, 2455954, 55953, N'2012-01-27', 201204, 4, 5, N'2012-W04', N'2012-W04-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94624, CAST(N'2012-01-28' AS date), CAST(N'2012-01-29' AS date), 2012, 20121, 201201, 2012028, 1, 1, 28, 28, 7, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-22' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-01-27' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-02-03' AS date), 1036, 3108, 13516, 13517, 13517, 13517, 13517, 13517, 13517, 2455955, 55954, N'2012-01-28', 201204, 4, 6, N'2012-W04', N'2012-W04-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94625, CAST(N'2012-01-29' AS date), CAST(N'2012-01-30' AS date), 2012, 20121, 201201, 2012029, 1, 1, 29, 29, 1, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-01-23' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-01-27' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-02-03' AS date), 1036, 3108, 13517, 13517, 13517, 13517, 13517, 13517, 13517, 2455956, 55955, N'2012-01-29', 201204, 4, 7, N'2012-W04', N'2012-W04-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94626, CAST(N'2012-01-30' AS date), CAST(N'2012-01-31' AS date), 2012, 20121, 201201, 2012030, 1, 1, 30, 30, 2, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-01-24' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-01-27' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-02-03' AS date), 1036, 3108, 13517, 13518, 13517, 13517, 13517, 13517, 13517, 2455957, 55956, N'2012-01-30', 201205, 5, 1, N'2012-W05', N'2012-W05-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94627, CAST(N'2012-01-31' AS date), CAST(N'2012-02-01' AS date), 2012, 20121, 201201, 2012031, 1, 1, 31, 31, 3, N'2012', N'2012 Q1', N'2012 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-01-25' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-01-27' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-02-03' AS date), 1036, 3108, 13517, 13518, 13518, 13517, 13517, 13517, 13517, 2455958, 55957, N'2012-01-31', 201205, 5, 2, N'2012-W05', N'2012-W05-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94628, CAST(N'2012-02-01' AS date), CAST(N'2012-02-02' AS date), 2012, 20121, 201202, 2012032, 1, 2, 32, 1, 4, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-01-26' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-01-27' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-02-03' AS date), 1036, 3109, 13517, 13518, 13518, 13518, 13517, 13517, 13517, 2455959, 55958, N'2012-02-01', 201205, 5, 3, N'2012-W05', N'2012-W05-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94629, CAST(N'2012-02-02' AS date), CAST(N'2012-02-03' AS date), 2012, 20121, 201202, 2012033, 1, 2, 33, 2, 5, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-01-27' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-02-03' AS date), 1036, 3109, 13517, 13518, 13518, 13518, 13518, 13517, 13517, 2455960, 55959, N'2012-02-02', 201205, 5, 4, N'2012-W05', N'2012-W05-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94630, CAST(N'2012-02-03' AS date), CAST(N'2012-02-04' AS date), 2012, 20121, 201202, 2012034, 1, 2, 34, 3, 6, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-03' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-01-28' AS date), CAST(N'2012-02-03' AS date), 1036, 3109, 13517, 13518, 13518, 13518, 13518, 13518, 13517, 2455961, 55960, N'2012-02-03', 201205, 5, 5, N'2012-W05', N'2012-W05-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94631, CAST(N'2012-02-04' AS date), CAST(N'2012-02-05' AS date), 2012, 20121, 201202, 2012035, 1, 2, 35, 4, 7, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-01-29' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-03' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-02-10' AS date), 1036, 3109, 13517, 13518, 13518, 13518, 13518, 13518, 13518, 2455962, 55961, N'2012-02-04', 201205, 5, 6, N'2012-W05', N'2012-W05-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94632, CAST(N'2012-02-05' AS date), CAST(N'2012-02-06' AS date), 2012, 20121, 201202, 2012036, 1, 2, 36, 5, 1, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-01-30' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-03' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-02-10' AS date), 1036, 3109, 13518, 13518, 13518, 13518, 13518, 13518, 13518, 2455963, 55962, N'2012-02-05', 201205, 5, 7, N'2012-W05', N'2012-W05-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94633, CAST(N'2012-02-06' AS date), CAST(N'2012-02-07' AS date), 2012, 20121, 201202, 2012037, 1, 2, 37, 6, 2, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-01-31' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-03' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-02-10' AS date), 1036, 3109, 13518, 13519, 13518, 13518, 13518, 13518, 13518, 2455964, 55963, N'2012-02-06', 201206, 6, 1, N'2012-W06', N'2012-W06-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94634, CAST(N'2012-02-07' AS date), CAST(N'2012-02-08' AS date), 2012, 20121, 201202, 2012038, 1, 2, 38, 7, 3, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-03' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-02-10' AS date), 1036, 3109, 13518, 13519, 13519, 13518, 13518, 13518, 13518, 2455965, 55964, N'2012-02-07', 201206, 6, 2, N'2012-W06', N'2012-W06-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94635, CAST(N'2012-02-08' AS date), CAST(N'2012-02-09' AS date), 2012, 20121, 201202, 2012039, 1, 2, 39, 8, 4, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-02' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-03' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-02-10' AS date), 1036, 3109, 13518, 13519, 13519, 13519, 13518, 13518, 13518, 2455966, 55965, N'2012-02-08', 201206, 6, 3, N'2012-W06', N'2012-W06-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94636, CAST(N'2012-02-09' AS date), CAST(N'2012-02-10' AS date), 2012, 20121, 201202, 2012040, 1, 2, 40, 9, 5, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-03' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-02-10' AS date), 1036, 3109, 13518, 13519, 13519, 13519, 13519, 13518, 13518, 2455967, 55966, N'2012-02-09', 201206, 6, 4, N'2012-W06', N'2012-W06-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94637, CAST(N'2012-02-10' AS date), CAST(N'2012-02-11' AS date), 2012, 20121, 201202, 2012041, 1, 2, 41, 10, 6, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-10' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-04' AS date), CAST(N'2012-02-10' AS date), 1036, 3109, 13518, 13519, 13519, 13519, 13519, 13519, 13518, 2455968, 55967, N'2012-02-10', 201206, 6, 5, N'2012-W06', N'2012-W06-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94638, CAST(N'2012-02-11' AS date), CAST(N'2012-02-12' AS date), 2012, 20121, 201202, 2012042, 1, 2, 42, 11, 7, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-05' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-10' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-17' AS date), 1036, 3109, 13518, 13519, 13519, 13519, 13519, 13519, 13519, 2455969, 55968, N'2012-02-11', 201206, 6, 6, N'2012-W06', N'2012-W06-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94639, CAST(N'2012-02-12' AS date), CAST(N'2012-02-13' AS date), 2012, 20121, 201202, 2012043, 1, 2, 43, 12, 1, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-06' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-10' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-17' AS date), 1036, 3109, 13519, 13519, 13519, 13519, 13519, 13519, 13519, 2455970, 55969, N'2012-02-12', 201206, 6, 7, N'2012-W06', N'2012-W06-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94640, CAST(N'2012-02-13' AS date), CAST(N'2012-02-14' AS date), 2012, 20121, 201202, 2012044, 1, 2, 44, 13, 2, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-07' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-10' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-17' AS date), 1036, 3109, 13519, 13520, 13519, 13519, 13519, 13519, 13519, 2455971, 55970, N'2012-02-13', 201207, 7, 1, N'2012-W07', N'2012-W07-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94641, CAST(N'2012-02-14' AS date), CAST(N'2012-02-15' AS date), 2012, 20121, 201202, 2012045, 1, 2, 45, 14, 3, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-08' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-10' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-17' AS date), 1036, 3109, 13519, 13520, 13520, 13519, 13519, 13519, 13519, 2455972, 55971, N'2012-02-14', 201207, 7, 2, N'2012-W07', N'2012-W07-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94642, CAST(N'2012-02-15' AS date), CAST(N'2012-02-16' AS date), 2012, 20121, 201202, 2012046, 1, 2, 46, 15, 4, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-09' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-10' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-17' AS date), 1036, 3109, 13519, 13520, 13520, 13520, 13519, 13519, 13519, 2455973, 55972, N'2012-02-15', 201207, 7, 3, N'2012-W07', N'2012-W07-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94643, CAST(N'2012-02-16' AS date), CAST(N'2012-02-17' AS date), 2012, 20121, 201202, 2012047, 1, 2, 47, 16, 5, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-10' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-17' AS date), 1036, 3109, 13519, 13520, 13520, 13520, 13520, 13519, 13519, 2455974, 55973, N'2012-02-16', 201207, 7, 4, N'2012-W07', N'2012-W07-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94644, CAST(N'2012-02-17' AS date), CAST(N'2012-02-18' AS date), 2012, 20121, 201202, 2012048, 1, 2, 48, 17, 6, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-17' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-11' AS date), CAST(N'2012-02-17' AS date), 1036, 3109, 13519, 13520, 13520, 13520, 13520, 13520, 13519, 2455975, 55974, N'2012-02-17', 201207, 7, 5, N'2012-W07', N'2012-W07-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94645, CAST(N'2012-02-18' AS date), CAST(N'2012-02-19' AS date), 2012, 20121, 201202, 2012049, 1, 2, 49, 18, 7, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-12' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-17' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-24' AS date), 1036, 3109, 13519, 13520, 13520, 13520, 13520, 13520, 13520, 2455976, 55975, N'2012-02-18', 201207, 7, 6, N'2012-W07', N'2012-W07-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94646, CAST(N'2012-02-19' AS date), CAST(N'2012-02-20' AS date), 2012, 20121, 201202, 2012050, 1, 2, 50, 19, 1, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-02-13' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-17' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-24' AS date), 1036, 3109, 13520, 13520, 13520, 13520, 13520, 13520, 13520, 2455977, 55976, N'2012-02-19', 201207, 7, 7, N'2012-W07', N'2012-W07-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94647, CAST(N'2012-02-20' AS date), CAST(N'2012-02-21' AS date), 2012, 20121, 201202, 2012051, 1, 2, 51, 20, 2, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-02-14' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-17' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-24' AS date), 1036, 3109, 13520, 13521, 13520, 13520, 13520, 13520, 13520, 2455978, 55977, N'2012-02-20', 201208, 8, 1, N'2012-W08', N'2012-W08-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94648, CAST(N'2012-02-21' AS date), CAST(N'2012-02-22' AS date), 2012, 20121, 201202, 2012052, 1, 2, 52, 21, 3, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-02-15' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-17' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-24' AS date), 1036, 3109, 13520, 13521, 13521, 13520, 13520, 13520, 13520, 2455979, 55978, N'2012-02-21', 201208, 8, 2, N'2012-W08', N'2012-W08-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94649, CAST(N'2012-02-22' AS date), CAST(N'2012-02-23' AS date), 2012, 20121, 201202, 2012053, 1, 2, 53, 22, 4, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-02-16' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-17' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-24' AS date), 1036, 3109, 13520, 13521, 13521, 13521, 13520, 13520, 13520, 2455980, 55979, N'2012-02-22', 201208, 8, 3, N'2012-W08', N'2012-W08-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94650, CAST(N'2012-02-23' AS date), CAST(N'2012-02-24' AS date), 2012, 20121, 201202, 2012054, 1, 2, 54, 23, 5, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-17' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-24' AS date), 1036, 3109, 13520, 13521, 13521, 13521, 13521, 13520, 13520, 2455981, 55980, N'2012-02-23', 201208, 8, 4, N'2012-W08', N'2012-W08-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94651, CAST(N'2012-02-24' AS date), CAST(N'2012-02-25' AS date), 2012, 20121, 201202, 2012055, 1, 2, 55, 24, 6, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-24' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-02-18' AS date), CAST(N'2012-02-24' AS date), 1036, 3109, 13520, 13521, 13521, 13521, 13521, 13521, 13520, 2455982, 55981, N'2012-02-24', 201208, 8, 5, N'2012-W08', N'2012-W08-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94652, CAST(N'2012-02-25' AS date), CAST(N'2012-02-26' AS date), 2012, 20121, 201202, 2012056, 1, 2, 56, 25, 7, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-19' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-24' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-03-02' AS date), 1036, 3109, 13520, 13521, 13521, 13521, 13521, 13521, 13521, 2455983, 55982, N'2012-02-25', 201208, 8, 6, N'2012-W08', N'2012-W08-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94653, CAST(N'2012-02-26' AS date), CAST(N'2012-02-27' AS date), 2012, 20121, 201202, 2012057, 1, 2, 57, 26, 1, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-02-20' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-24' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-03-02' AS date), 1036, 3109, 13521, 13521, 13521, 13521, 13521, 13521, 13521, 2455984, 55983, N'2012-02-26', 201208, 8, 7, N'2012-W08', N'2012-W08-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94654, CAST(N'2012-02-27' AS date), CAST(N'2012-02-28' AS date), 2012, 20121, 201202, 2012058, 1, 2, 58, 27, 2, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-02-21' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-24' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-03-02' AS date), 1036, 3109, 13521, 13522, 13521, 13521, 13521, 13521, 13521, 2455985, 55984, N'2012-02-27', 201209, 9, 1, N'2012-W09', N'2012-W09-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94655, CAST(N'2012-02-28' AS date), CAST(N'2012-02-29' AS date), 2012, 20121, 201202, 2012059, 1, 2, 59, 28, 3, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-02-22' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-24' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-03-02' AS date), 1036, 3109, 13521, 13522, 13522, 13521, 13521, 13521, 13521, 2455986, 55985, N'2012-02-28', 201209, 9, 2, N'2012-W09', N'2012-W09-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94656, CAST(N'2012-02-29' AS date), CAST(N'2012-03-01' AS date), 2012, 20121, 201202, 2012060, 1, 2, 60, 29, 4, N'2012', N'2012 Q1', N'2012 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-01' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-02-23' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-02-24' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-03-02' AS date), 1036, 3109, 13521, 13522, 13522, 13522, 13521, 13521, 13521, 2455987, 55986, N'2012-02-29', 201209, 9, 3, N'2012-W09', N'2012-W09-3');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94657, CAST(N'2012-03-01' AS date), CAST(N'2012-03-02' AS date), 2012, 20121, 201203, 2012061, 1, 3, 61, 1, 5, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-02-24' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-03-02' AS date), 1036, 3110, 13521, 13522, 13522, 13522, 13522, 13521, 13521, 2455988, 55987, N'2012-03-01', 201209, 9, 4, N'2012-W09', N'2012-W09-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94658, CAST(N'2012-03-02' AS date), CAST(N'2012-03-03' AS date), 2012, 20121, 201203, 2012062, 1, 3, 62, 2, 6, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-02' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-02-25' AS date), CAST(N'2012-03-02' AS date), 1036, 3110, 13521, 13522, 13522, 13522, 13522, 13522, 13521, 2455989, 55988, N'2012-03-02', 201209, 9, 5, N'2012-W09', N'2012-W09-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94659, CAST(N'2012-03-03' AS date), CAST(N'2012-03-04' AS date), 2012, 20121, 201203, 2012063, 1, 3, 63, 3, 7, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-02-26' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-02' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-03-09' AS date), 1036, 3110, 13521, 13522, 13522, 13522, 13522, 13522, 13522, 2455990, 55989, N'2012-03-03', 201209, 9, 6, N'2012-W09', N'2012-W09-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94660, CAST(N'2012-03-04' AS date), CAST(N'2012-03-05' AS date), 2012, 20121, 201203, 2012064, 1, 3, 64, 4, 1, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-02-27' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-02' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-03-09' AS date), 1036, 3110, 13522, 13522, 13522, 13522, 13522, 13522, 13522, 2455991, 55990, N'2012-03-04', 201209, 9, 7, N'2012-W09', N'2012-W09-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94661, CAST(N'2012-03-05' AS date), CAST(N'2012-03-06' AS date), 2012, 20121, 201203, 2012065, 1, 3, 65, 5, 2, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-02-28' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-02' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-03-09' AS date), 1036, 3110, 13522, 13523, 13522, 13522, 13522, 13522, 13522, 2455992, 55991, N'2012-03-05', 201210, 10, 1, N'2012-W10', N'2012-W10-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94662, CAST(N'2012-03-06' AS date), CAST(N'2012-03-07' AS date), 2012, 20121, 201203, 2012066, 1, 3, 66, 6, 3, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-02-29' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-02' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-03-09' AS date), 1036, 3110, 13522, 13523, 13523, 13522, 13522, 13522, 13522, 2455993, 55992, N'2012-03-06', 201210, 10, 2, N'2012-W10', N'2012-W10-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94663, CAST(N'2012-03-07' AS date), CAST(N'2012-03-08' AS date), 2012, 20121, 201203, 2012067, 1, 3, 67, 7, 4, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-02' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-03-09' AS date), 1036, 3110, 13522, 13523, 13523, 13523, 13522, 13522, 13522, 2455994, 55993, N'2012-03-07', 201210, 10, 3, N'2012-W10', N'2012-W10-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94664, CAST(N'2012-03-08' AS date), CAST(N'2012-03-09' AS date), 2012, 20121, 201203, 2012068, 1, 3, 68, 8, 5, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-02' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-03-09' AS date), 1036, 3110, 13522, 13523, 13523, 13523, 13523, 13522, 13522, 2455995, 55994, N'2012-03-08', 201210, 10, 4, N'2012-W10', N'2012-W10-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94665, CAST(N'2012-03-09' AS date), CAST(N'2012-03-10' AS date), 2012, 20121, 201203, 2012069, 1, 3, 69, 9, 6, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-09' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-03' AS date), CAST(N'2012-03-09' AS date), 1036, 3110, 13522, 13523, 13523, 13523, 13523, 13523, 13522, 2455996, 55995, N'2012-03-09', 201210, 10, 5, N'2012-W10', N'2012-W10-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94666, CAST(N'2012-03-10' AS date), CAST(N'2012-03-11' AS date), 2012, 20121, 201203, 2012070, 1, 3, 70, 10, 7, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-04' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-09' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-16' AS date), 1036, 3110, 13522, 13523, 13523, 13523, 13523, 13523, 13523, 2455997, 55996, N'2012-03-10', 201210, 10, 6, N'2012-W10', N'2012-W10-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94667, CAST(N'2012-03-11' AS date), CAST(N'2012-03-12' AS date), 2012, 20121, 201203, 2012071, 1, 3, 71, 11, 1, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-05' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-09' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-16' AS date), 1036, 3110, 13523, 13523, 13523, 13523, 13523, 13523, 13523, 2455998, 55997, N'2012-03-11', 201210, 10, 7, N'2012-W10', N'2012-W10-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94668, CAST(N'2012-03-12' AS date), CAST(N'2012-03-13' AS date), 2012, 20121, 201203, 2012072, 1, 3, 72, 12, 2, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-06' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-09' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-16' AS date), 1036, 3110, 13523, 13524, 13523, 13523, 13523, 13523, 13523, 2455999, 55998, N'2012-03-12', 201211, 11, 1, N'2012-W11', N'2012-W11-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94669, CAST(N'2012-03-13' AS date), CAST(N'2012-03-14' AS date), 2012, 20121, 201203, 2012073, 1, 3, 73, 13, 3, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-07' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-09' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-16' AS date), 1036, 3110, 13523, 13524, 13524, 13523, 13523, 13523, 13523, 2456000, 55999, N'2012-03-13', 201211, 11, 2, N'2012-W11', N'2012-W11-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94670, CAST(N'2012-03-14' AS date), CAST(N'2012-03-15' AS date), 2012, 20121, 201203, 2012074, 1, 3, 74, 14, 4, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-08' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-09' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-16' AS date), 1036, 3110, 13523, 13524, 13524, 13524, 13523, 13523, 13523, 2456001, 56000, N'2012-03-14', 201211, 11, 3, N'2012-W11', N'2012-W11-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94671, CAST(N'2012-03-15' AS date), CAST(N'2012-03-16' AS date), 2012, 20121, 201203, 2012075, 1, 3, 75, 15, 5, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-09' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-16' AS date), 1036, 3110, 13523, 13524, 13524, 13524, 13524, 13523, 13523, 2456002, 56001, N'2012-03-15', 201211, 11, 4, N'2012-W11', N'2012-W11-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94672, CAST(N'2012-03-16' AS date), CAST(N'2012-03-17' AS date), 2012, 20121, 201203, 2012076, 1, 3, 76, 16, 6, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-16' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-10' AS date), CAST(N'2012-03-16' AS date), 1036, 3110, 13523, 13524, 13524, 13524, 13524, 13524, 13523, 2456003, 56002, N'2012-03-16', 201211, 11, 5, N'2012-W11', N'2012-W11-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94673, CAST(N'2012-03-17' AS date), CAST(N'2012-03-18' AS date), 2012, 20121, 201203, 2012077, 1, 3, 77, 17, 7, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-11' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-16' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-23' AS date), 1036, 3110, 13523, 13524, 13524, 13524, 13524, 13524, 13524, 2456004, 56003, N'2012-03-17', 201211, 11, 6, N'2012-W11', N'2012-W11-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94674, CAST(N'2012-03-18' AS date), CAST(N'2012-03-19' AS date), 2012, 20121, 201203, 2012078, 1, 3, 78, 18, 1, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-12' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-16' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-23' AS date), 1036, 3110, 13524, 13524, 13524, 13524, 13524, 13524, 13524, 2456005, 56004, N'2012-03-18', 201211, 11, 7, N'2012-W11', N'2012-W11-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94675, CAST(N'2012-03-19' AS date), CAST(N'2012-03-20' AS date), 2012, 20121, 201203, 2012079, 1, 3, 79, 19, 2, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-13' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-16' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-23' AS date), 1036, 3110, 13524, 13525, 13524, 13524, 13524, 13524, 13524, 2456006, 56005, N'2012-03-19', 201212, 12, 1, N'2012-W12', N'2012-W12-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94676, CAST(N'2012-03-20' AS date), CAST(N'2012-03-21' AS date), 2012, 20121, 201203, 2012080, 1, 3, 80, 20, 3, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-03-14' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-16' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-23' AS date), 1036, 3110, 13524, 13525, 13525, 13524, 13524, 13524, 13524, 2456007, 56006, N'2012-03-20', 201212, 12, 2, N'2012-W12', N'2012-W12-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94677, CAST(N'2012-03-21' AS date), CAST(N'2012-03-22' AS date), 2012, 20121, 201203, 2012081, 1, 3, 81, 21, 4, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-03-15' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-16' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-23' AS date), 1036, 3110, 13524, 13525, 13525, 13525, 13524, 13524, 13524, 2456008, 56007, N'2012-03-21', 201212, 12, 3, N'2012-W12', N'2012-W12-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94678, CAST(N'2012-03-22' AS date), CAST(N'2012-03-23' AS date), 2012, 20121, 201203, 2012082, 1, 3, 82, 22, 5, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-03-16' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-23' AS date), 1036, 3110, 13524, 13525, 13525, 13525, 13525, 13524, 13524, 2456009, 56008, N'2012-03-22', 201212, 12, 4, N'2012-W12', N'2012-W12-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94679, CAST(N'2012-03-23' AS date), CAST(N'2012-03-24' AS date), 2012, 20121, 201203, 2012083, 1, 3, 83, 23, 6, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-03-23' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-03-17' AS date), CAST(N'2012-03-23' AS date), 1036, 3110, 13524, 13525, 13525, 13525, 13525, 13525, 13524, 2456010, 56009, N'2012-03-23', 201212, 12, 5, N'2012-W12', N'2012-W12-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94680, CAST(N'2012-03-24' AS date), CAST(N'2012-03-25' AS date), 2012, 20121, 201203, 2012084, 1, 3, 84, 24, 7, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-18' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-03-23' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-30' AS date), 1036, 3110, 13524, 13525, 13525, 13525, 13525, 13525, 13525, 2456011, 56010, N'2012-03-24', 201212, 12, 6, N'2012-W12', N'2012-W12-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94681, CAST(N'2012-03-25' AS date), CAST(N'2012-03-26' AS date), 2012, 20121, 201203, 2012085, 1, 3, 85, 25, 1, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-19' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-03-23' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-30' AS date), 1036, 3110, 13525, 13525, 13525, 13525, 13525, 13525, 13525, 2456012, 56011, N'2012-03-25', 201212, 12, 7, N'2012-W12', N'2012-W12-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94682, CAST(N'2012-03-26' AS date), CAST(N'2012-03-27' AS date), 2012, 20121, 201203, 2012086, 1, 3, 86, 26, 2, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-03-20' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-03-23' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-30' AS date), 1036, 3110, 13525, 13526, 13525, 13525, 13525, 13525, 13525, 2456013, 56012, N'2012-03-26', 201213, 13, 1, N'2012-W13', N'2012-W13-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94683, CAST(N'2012-03-27' AS date), CAST(N'2012-03-28' AS date), 2012, 20121, 201203, 2012087, 1, 3, 87, 27, 3, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-03-21' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-03-23' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-30' AS date), 1036, 3110, 13525, 13526, 13526, 13525, 13525, 13525, 13525, 2456014, 56013, N'2012-03-27', 201213, 13, 2, N'2012-W13', N'2012-W13-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94684, CAST(N'2012-03-28' AS date), CAST(N'2012-03-29' AS date), 2012, 20121, 201203, 2012088, 1, 3, 88, 28, 4, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-03-22' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-03-23' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-30' AS date), 1036, 3110, 13525, 13526, 13526, 13526, 13525, 13525, 13525, 2456015, 56014, N'2012-03-28', 201213, 13, 3, N'2012-W13', N'2012-W13-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94685, CAST(N'2012-03-29' AS date), CAST(N'2012-03-30' AS date), 2012, 20121, 201203, 2012089, 1, 3, 89, 29, 5, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-03-23' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-30' AS date), 1036, 3110, 13525, 13526, 13526, 13526, 13526, 13525, 13525, 2456016, 56015, N'2012-03-29', 201213, 13, 4, N'2012-W13', N'2012-W13-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94686, CAST(N'2012-03-30' AS date), CAST(N'2012-03-31' AS date), 2012, 20121, 201203, 2012090, 1, 3, 90, 30, 6, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-03-30' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-03-24' AS date), CAST(N'2012-03-30' AS date), 1036, 3110, 13525, 13526, 13526, 13526, 13526, 13526, 13525, 2456017, 56016, N'2012-03-30', 201213, 13, 5, N'2012-W13', N'2012-W13-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94687, CAST(N'2012-03-31' AS date), CAST(N'2012-04-01' AS date), 2012, 20121, 201203, 2012091, 1, 3, 91, 31, 7, N'2012', N'2012 Q1', N'2012 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-01-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-01' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-25' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-03-30' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-04-06' AS date), 1036, 3110, 13525, 13526, 13526, 13526, 13526, 13526, 13526, 2456018, 56017, N'2012-03-31', 201213, 13, 6, N'2012-W13', N'2012-W13-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94688, CAST(N'2012-04-01' AS date), CAST(N'2012-04-02' AS date), 2012, 20122, 201204, 2012092, 2, 4, 92, 1, 1, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-03-26' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-03-30' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-04-06' AS date), 1037, 3111, 13526, 13526, 13526, 13526, 13526, 13526, 13526, 2456019, 56018, N'2012-04-01', 201213, 13, 7, N'2012-W13', N'2012-W13-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94689, CAST(N'2012-04-02' AS date), CAST(N'2012-04-03' AS date), 2012, 20122, 201204, 2012093, 2, 4, 93, 2, 2, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-03-27' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-03-30' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-04-06' AS date), 1037, 3111, 13526, 13527, 13526, 13526, 13526, 13526, 13526, 2456020, 56019, N'2012-04-02', 201214, 14, 1, N'2012-W14', N'2012-W14-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94690, CAST(N'2012-04-03' AS date), CAST(N'2012-04-04' AS date), 2012, 20122, 201204, 2012094, 2, 4, 94, 3, 3, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-03-28' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-03-30' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-04-06' AS date), 1037, 3111, 13526, 13527, 13527, 13526, 13526, 13526, 13526, 2456021, 56020, N'2012-04-03', 201214, 14, 2, N'2012-W14', N'2012-W14-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94691, CAST(N'2012-04-04' AS date), CAST(N'2012-04-05' AS date), 2012, 20122, 201204, 2012095, 2, 4, 95, 4, 4, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-03-29' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-03-30' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-04-06' AS date), 1037, 3111, 13526, 13527, 13527, 13527, 13526, 13526, 13526, 2456022, 56021, N'2012-04-04', 201214, 14, 3, N'2012-W14', N'2012-W14-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94692, CAST(N'2012-04-05' AS date), CAST(N'2012-04-06' AS date), 2012, 20122, 201204, 2012096, 2, 4, 96, 5, 5, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-03-30' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-04-06' AS date), 1037, 3111, 13526, 13527, 13527, 13527, 13527, 13526, 13526, 2456023, 56022, N'2012-04-05', 201214, 14, 4, N'2012-W14', N'2012-W14-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94693, CAST(N'2012-04-06' AS date), CAST(N'2012-04-07' AS date), 2012, 20122, 201204, 2012097, 2, 4, 97, 6, 6, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-06' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-03-31' AS date), CAST(N'2012-04-06' AS date), 1037, 3111, 13526, 13527, 13527, 13527, 13527, 13527, 13526, 2456024, 56023, N'2012-04-06', 201214, 14, 5, N'2012-W14', N'2012-W14-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94694, CAST(N'2012-04-07' AS date), CAST(N'2012-04-08' AS date), 2012, 20122, 201204, 2012098, 2, 4, 98, 7, 7, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-06' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-13' AS date), 1037, 3111, 13526, 13527, 13527, 13527, 13527, 13527, 13527, 2456025, 56024, N'2012-04-07', 201214, 14, 6, N'2012-W14', N'2012-W14-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94695, CAST(N'2012-04-08' AS date), CAST(N'2012-04-09' AS date), 2012, 20122, 201204, 2012099, 2, 4, 99, 8, 1, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-02' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-06' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-13' AS date), 1037, 3111, 13527, 13527, 13527, 13527, 13527, 13527, 13527, 2456026, 56025, N'2012-04-08', 201214, 14, 7, N'2012-W14', N'2012-W14-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94696, CAST(N'2012-04-09' AS date), CAST(N'2012-04-10' AS date), 2012, 20122, 201204, 2012100, 2, 4, 100, 9, 2, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-03' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-06' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-13' AS date), 1037, 3111, 13527, 13528, 13527, 13527, 13527, 13527, 13527, 2456027, 56026, N'2012-04-09', 201215, 15, 1, N'2012-W15', N'2012-W15-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94697, CAST(N'2012-04-10' AS date), CAST(N'2012-04-11' AS date), 2012, 20122, 201204, 2012101, 2, 4, 101, 10, 3, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-04' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-06' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-13' AS date), 1037, 3111, 13527, 13528, 13528, 13527, 13527, 13527, 13527, 2456028, 56027, N'2012-04-10', 201215, 15, 2, N'2012-W15', N'2012-W15-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94698, CAST(N'2012-04-11' AS date), CAST(N'2012-04-12' AS date), 2012, 20122, 201204, 2012102, 2, 4, 102, 11, 4, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-05' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-06' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-13' AS date), 1037, 3111, 13527, 13528, 13528, 13528, 13527, 13527, 13527, 2456029, 56028, N'2012-04-11', 201215, 15, 3, N'2012-W15', N'2012-W15-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94699, CAST(N'2012-04-12' AS date), CAST(N'2012-04-13' AS date), 2012, 20122, 201204, 2012103, 2, 4, 103, 12, 5, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-06' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-13' AS date), 1037, 3111, 13527, 13528, 13528, 13528, 13528, 13527, 13527, 2456030, 56029, N'2012-04-12', 201215, 15, 4, N'2012-W15', N'2012-W15-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94700, CAST(N'2012-04-13' AS date), CAST(N'2012-04-14' AS date), 2012, 20122, 201204, 2012104, 2, 4, 104, 13, 6, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-13' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-07' AS date), CAST(N'2012-04-13' AS date), 1037, 3111, 13527, 13528, 13528, 13528, 13528, 13528, 13527, 2456031, 56030, N'2012-04-13', 201215, 15, 5, N'2012-W15', N'2012-W15-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94701, CAST(N'2012-04-14' AS date), CAST(N'2012-04-15' AS date), 2012, 20122, 201204, 2012105, 2, 4, 105, 14, 7, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-08' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-13' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-20' AS date), 1037, 3111, 13527, 13528, 13528, 13528, 13528, 13528, 13528, 2456032, 56031, N'2012-04-14', 201215, 15, 6, N'2012-W15', N'2012-W15-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94702, CAST(N'2012-04-15' AS date), CAST(N'2012-04-16' AS date), 2012, 20122, 201204, 2012106, 2, 4, 106, 15, 1, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-09' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-13' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-20' AS date), 1037, 3111, 13528, 13528, 13528, 13528, 13528, 13528, 13528, 2456033, 56032, N'2012-04-15', 201215, 15, 7, N'2012-W15', N'2012-W15-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94703, CAST(N'2012-04-16' AS date), CAST(N'2012-04-17' AS date), 2012, 20122, 201204, 2012107, 2, 4, 107, 16, 2, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-10' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-13' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-20' AS date), 1037, 3111, 13528, 13529, 13528, 13528, 13528, 13528, 13528, 2456034, 56033, N'2012-04-16', 201216, 16, 1, N'2012-W16', N'2012-W16-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94704, CAST(N'2012-04-17' AS date), CAST(N'2012-04-18' AS date), 2012, 20122, 201204, 2012108, 2, 4, 108, 17, 3, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-11' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-13' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-20' AS date), 1037, 3111, 13528, 13529, 13529, 13528, 13528, 13528, 13528, 2456035, 56034, N'2012-04-17', 201216, 16, 2, N'2012-W16', N'2012-W16-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94705, CAST(N'2012-04-18' AS date), CAST(N'2012-04-19' AS date), 2012, 20122, 201204, 2012109, 2, 4, 109, 18, 4, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-12' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-13' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-20' AS date), 1037, 3111, 13528, 13529, 13529, 13529, 13528, 13528, 13528, 2456036, 56035, N'2012-04-18', 201216, 16, 3, N'2012-W16', N'2012-W16-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94706, CAST(N'2012-04-19' AS date), CAST(N'2012-04-20' AS date), 2012, 20122, 201204, 2012110, 2, 4, 110, 19, 5, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-04-13' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-20' AS date), 1037, 3111, 13528, 13529, 13529, 13529, 13529, 13528, 13528, 2456037, 56036, N'2012-04-19', 201216, 16, 4, N'2012-W16', N'2012-W16-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94707, CAST(N'2012-04-20' AS date), CAST(N'2012-04-21' AS date), 2012, 20122, 201204, 2012111, 2, 4, 111, 20, 6, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-04-20' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-04-14' AS date), CAST(N'2012-04-20' AS date), 1037, 3111, 13528, 13529, 13529, 13529, 13529, 13529, 13528, 2456038, 56037, N'2012-04-20', 201216, 16, 5, N'2012-W16', N'2012-W16-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94708, CAST(N'2012-04-21' AS date), CAST(N'2012-04-22' AS date), 2012, 20122, 201204, 2012112, 2, 4, 112, 21, 7, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-15' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-04-20' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-27' AS date), 1037, 3111, 13528, 13529, 13529, 13529, 13529, 13529, 13529, 2456039, 56038, N'2012-04-21', 201216, 16, 6, N'2012-W16', N'2012-W16-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94709, CAST(N'2012-04-22' AS date), CAST(N'2012-04-23' AS date), 2012, 20122, 201204, 2012113, 2, 4, 113, 22, 1, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-04-16' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-04-20' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-27' AS date), 1037, 3111, 13529, 13529, 13529, 13529, 13529, 13529, 13529, 2456040, 56039, N'2012-04-22', 201216, 16, 7, N'2012-W16', N'2012-W16-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94710, CAST(N'2012-04-23' AS date), CAST(N'2012-04-24' AS date), 2012, 20122, 201204, 2012114, 2, 4, 114, 23, 2, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-04-17' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-04-20' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-27' AS date), 1037, 3111, 13529, 13530, 13529, 13529, 13529, 13529, 13529, 2456041, 56040, N'2012-04-23', 201217, 17, 1, N'2012-W17', N'2012-W17-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94711, CAST(N'2012-04-24' AS date), CAST(N'2012-04-25' AS date), 2012, 20122, 201204, 2012115, 2, 4, 115, 24, 3, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-18' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-04-20' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-27' AS date), 1037, 3111, 13529, 13530, 13530, 13529, 13529, 13529, 13529, 2456042, 56041, N'2012-04-24', 201217, 17, 2, N'2012-W17', N'2012-W17-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94712, CAST(N'2012-04-25' AS date), CAST(N'2012-04-26' AS date), 2012, 20122, 201204, 2012116, 2, 4, 116, 25, 4, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-04-19' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-04-20' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-27' AS date), 1037, 3111, 13529, 13530, 13530, 13530, 13529, 13529, 13529, 2456043, 56042, N'2012-04-25', 201217, 17, 3, N'2012-W17', N'2012-W17-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94713, CAST(N'2012-04-26' AS date), CAST(N'2012-04-27' AS date), 2012, 20122, 201204, 2012117, 2, 4, 117, 26, 5, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-04-20' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-27' AS date), 1037, 3111, 13529, 13530, 13530, 13530, 13530, 13529, 13529, 2456044, 56043, N'2012-04-26', 201217, 17, 4, N'2012-W17', N'2012-W17-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94714, CAST(N'2012-04-27' AS date), CAST(N'2012-04-28' AS date), 2012, 20122, 201204, 2012118, 2, 4, 118, 27, 6, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-04-27' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-04-21' AS date), CAST(N'2012-04-27' AS date), 1037, 3111, 13529, 13530, 13530, 13530, 13530, 13530, 13529, 2456045, 56044, N'2012-04-27', 201217, 17, 5, N'2012-W17', N'2012-W17-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94715, CAST(N'2012-04-28' AS date), CAST(N'2012-04-29' AS date), 2012, 20122, 201204, 2012119, 2, 4, 119, 28, 7, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-22' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-04-27' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-05-04' AS date), 1037, 3111, 13529, 13530, 13530, 13530, 13530, 13530, 13530, 2456046, 56045, N'2012-04-28', 201217, 17, 6, N'2012-W17', N'2012-W17-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94716, CAST(N'2012-04-29' AS date), CAST(N'2012-04-30' AS date), 2012, 20122, 201204, 2012120, 2, 4, 120, 29, 1, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-04-23' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-04-27' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-05-04' AS date), 1037, 3111, 13530, 13530, 13530, 13530, 13530, 13530, 13530, 2456047, 56046, N'2012-04-29', 201217, 17, 7, N'2012-W17', N'2012-W17-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94717, CAST(N'2012-04-30' AS date), CAST(N'2012-05-01' AS date), 2012, 20122, 201204, 2012121, 2, 4, 121, 30, 2, N'2012', N'2012 Q2', N'2012 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-04-24' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-04-27' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-05-04' AS date), 1037, 3111, 13530, 13531, 13530, 13530, 13530, 13530, 13530, 2456048, 56047, N'2012-04-30', 201218, 18, 1, N'2012-W18', N'2012-W18-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94718, CAST(N'2012-05-01' AS date), CAST(N'2012-05-02' AS date), 2012, 20122, 201205, 2012122, 2, 5, 122, 1, 3, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-04-25' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-04-27' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-05-04' AS date), 1037, 3112, 13530, 13531, 13531, 13530, 13530, 13530, 13530, 2456049, 56048, N'2012-05-01', 201218, 18, 2, N'2012-W18', N'2012-W18-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94719, CAST(N'2012-05-02' AS date), CAST(N'2012-05-03' AS date), 2012, 20122, 201205, 2012123, 2, 5, 123, 2, 4, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-04-26' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-04-27' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-05-04' AS date), 1037, 3112, 13530, 13531, 13531, 13531, 13530, 13530, 13530, 2456050, 56049, N'2012-05-02', 201218, 18, 3, N'2012-W18', N'2012-W18-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94720, CAST(N'2012-05-03' AS date), CAST(N'2012-05-04' AS date), 2012, 20122, 201205, 2012124, 2, 5, 124, 3, 5, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-04-27' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-05-04' AS date), 1037, 3112, 13530, 13531, 13531, 13531, 13531, 13530, 13530, 2456051, 56050, N'2012-05-03', 201218, 18, 4, N'2012-W18', N'2012-W18-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94721, CAST(N'2012-05-04' AS date), CAST(N'2012-05-05' AS date), 2012, 20122, 201205, 2012125, 2, 5, 125, 4, 6, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-04' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-04-28' AS date), CAST(N'2012-05-04' AS date), 1037, 3112, 13530, 13531, 13531, 13531, 13531, 13531, 13530, 2456052, 56051, N'2012-05-04', 201218, 18, 5, N'2012-W18', N'2012-W18-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94722, CAST(N'2012-05-05' AS date), CAST(N'2012-05-06' AS date), 2012, 20122, 201205, 2012126, 2, 5, 126, 5, 7, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-04-29' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-04' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-05-11' AS date), 1037, 3112, 13530, 13531, 13531, 13531, 13531, 13531, 13531, 2456053, 56052, N'2012-05-05', 201218, 18, 6, N'2012-W18', N'2012-W18-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94723, CAST(N'2012-05-06' AS date), CAST(N'2012-05-07' AS date), 2012, 20122, 201205, 2012127, 2, 5, 127, 6, 1, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-04-30' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-04' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-05-11' AS date), 1037, 3112, 13531, 13531, 13531, 13531, 13531, 13531, 13531, 2456054, 56053, N'2012-05-06', 201218, 18, 7, N'2012-W18', N'2012-W18-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94724, CAST(N'2012-05-07' AS date), CAST(N'2012-05-08' AS date), 2012, 20122, 201205, 2012128, 2, 5, 128, 7, 2, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-04' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-05-11' AS date), 1037, 3112, 13531, 13532, 13531, 13531, 13531, 13531, 13531, 2456055, 56054, N'2012-05-07', 201219, 19, 1, N'2012-W19', N'2012-W19-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94725, CAST(N'2012-05-08' AS date), CAST(N'2012-05-09' AS date), 2012, 20122, 201205, 2012129, 2, 5, 129, 8, 3, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-02' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-04' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-05-11' AS date), 1037, 3112, 13531, 13532, 13532, 13531, 13531, 13531, 13531, 2456056, 56055, N'2012-05-08', 201219, 19, 2, N'2012-W19', N'2012-W19-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94726, CAST(N'2012-05-09' AS date), CAST(N'2012-05-10' AS date), 2012, 20122, 201205, 2012130, 2, 5, 130, 9, 4, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-03' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-04' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-05-11' AS date), 1037, 3112, 13531, 13532, 13532, 13532, 13531, 13531, 13531, 2456057, 56056, N'2012-05-09', 201219, 19, 3, N'2012-W19', N'2012-W19-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94727, CAST(N'2012-05-10' AS date), CAST(N'2012-05-11' AS date), 2012, 20122, 201205, 2012131, 2, 5, 131, 10, 5, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-04' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-05-11' AS date), 1037, 3112, 13531, 13532, 13532, 13532, 13532, 13531, 13531, 2456058, 56057, N'2012-05-10', 201219, 19, 4, N'2012-W19', N'2012-W19-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94728, CAST(N'2012-05-11' AS date), CAST(N'2012-05-12' AS date), 2012, 20122, 201205, 2012132, 2, 5, 132, 11, 6, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-11' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-05' AS date), CAST(N'2012-05-11' AS date), 1037, 3112, 13531, 13532, 13532, 13532, 13532, 13532, 13531, 2456059, 56058, N'2012-05-11', 201219, 19, 5, N'2012-W19', N'2012-W19-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94729, CAST(N'2012-05-12' AS date), CAST(N'2012-05-13' AS date), 2012, 20122, 201205, 2012133, 2, 5, 133, 12, 7, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-06' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-11' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-18' AS date), 1037, 3112, 13531, 13532, 13532, 13532, 13532, 13532, 13532, 2456060, 56059, N'2012-05-12', 201219, 19, 6, N'2012-W19', N'2012-W19-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94730, CAST(N'2012-05-13' AS date), CAST(N'2012-05-14' AS date), 2012, 20122, 201205, 2012134, 2, 5, 134, 13, 1, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-07' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-11' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-18' AS date), 1037, 3112, 13532, 13532, 13532, 13532, 13532, 13532, 13532, 2456061, 56060, N'2012-05-13', 201219, 19, 7, N'2012-W19', N'2012-W19-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94731, CAST(N'2012-05-14' AS date), CAST(N'2012-05-15' AS date), 2012, 20122, 201205, 2012135, 2, 5, 135, 14, 2, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-08' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-11' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-18' AS date), 1037, 3112, 13532, 13533, 13532, 13532, 13532, 13532, 13532, 2456062, 56061, N'2012-05-14', 201220, 20, 1, N'2012-W20', N'2012-W20-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94732, CAST(N'2012-05-15' AS date), CAST(N'2012-05-16' AS date), 2012, 20122, 201205, 2012136, 2, 5, 136, 15, 3, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-09' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-11' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-18' AS date), 1037, 3112, 13532, 13533, 13533, 13532, 13532, 13532, 13532, 2456063, 56062, N'2012-05-15', 201220, 20, 2, N'2012-W20', N'2012-W20-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94733, CAST(N'2012-05-16' AS date), CAST(N'2012-05-17' AS date), 2012, 20122, 201205, 2012137, 2, 5, 137, 16, 4, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-10' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-11' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-18' AS date), 1037, 3112, 13532, 13533, 13533, 13533, 13532, 13532, 13532, 2456064, 56063, N'2012-05-16', 201220, 20, 3, N'2012-W20', N'2012-W20-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94734, CAST(N'2012-05-17' AS date), CAST(N'2012-05-18' AS date), 2012, 20122, 201205, 2012138, 2, 5, 138, 17, 5, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-11' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-18' AS date), 1037, 3112, 13532, 13533, 13533, 13533, 13533, 13532, 13532, 2456065, 56064, N'2012-05-17', 201220, 20, 4, N'2012-W20', N'2012-W20-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94735, CAST(N'2012-05-18' AS date), CAST(N'2012-05-19' AS date), 2012, 20122, 201205, 2012139, 2, 5, 139, 18, 6, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-18' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-12' AS date), CAST(N'2012-05-18' AS date), 1037, 3112, 13532, 13533, 13533, 13533, 13533, 13533, 13532, 2456066, 56065, N'2012-05-18', 201220, 20, 5, N'2012-W20', N'2012-W20-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94736, CAST(N'2012-05-19' AS date), CAST(N'2012-05-20' AS date), 2012, 20122, 201205, 2012140, 2, 5, 140, 19, 7, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-13' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-18' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-25' AS date), 1037, 3112, 13532, 13533, 13533, 13533, 13533, 13533, 13533, 2456067, 56066, N'2012-05-19', 201220, 20, 6, N'2012-W20', N'2012-W20-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94737, CAST(N'2012-05-20' AS date), CAST(N'2012-05-21' AS date), 2012, 20122, 201205, 2012141, 2, 5, 141, 20, 1, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-05-14' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-18' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-25' AS date), 1037, 3112, 13533, 13533, 13533, 13533, 13533, 13533, 13533, 2456068, 56067, N'2012-05-20', 201220, 20, 7, N'2012-W20', N'2012-W20-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94738, CAST(N'2012-05-21' AS date), CAST(N'2012-05-22' AS date), 2012, 20122, 201205, 2012142, 2, 5, 142, 21, 2, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-05-15' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-18' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-25' AS date), 1037, 3112, 13533, 13534, 13533, 13533, 13533, 13533, 13533, 2456069, 56068, N'2012-05-21', 201221, 21, 1, N'2012-W21', N'2012-W21-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94739, CAST(N'2012-05-22' AS date), CAST(N'2012-05-23' AS date), 2012, 20122, 201205, 2012143, 2, 5, 143, 22, 3, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-05-16' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-18' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-25' AS date), 1037, 3112, 13533, 13534, 13534, 13533, 13533, 13533, 13533, 2456070, 56069, N'2012-05-22', 201221, 21, 2, N'2012-W21', N'2012-W21-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94740, CAST(N'2012-05-23' AS date), CAST(N'2012-05-24' AS date), 2012, 20122, 201205, 2012144, 2, 5, 144, 23, 4, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-05-17' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-18' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-25' AS date), 1037, 3112, 13533, 13534, 13534, 13534, 13533, 13533, 13533, 2456071, 56070, N'2012-05-23', 201221, 21, 3, N'2012-W21', N'2012-W21-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94741, CAST(N'2012-05-24' AS date), CAST(N'2012-05-25' AS date), 2012, 20122, 201205, 2012145, 2, 5, 145, 24, 5, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-05-18' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-25' AS date), 1037, 3112, 13533, 13534, 13534, 13534, 13534, 13533, 13533, 2456072, 56071, N'2012-05-24', 201221, 21, 4, N'2012-W21', N'2012-W21-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94742, CAST(N'2012-05-25' AS date), CAST(N'2012-05-26' AS date), 2012, 20122, 201205, 2012146, 2, 5, 146, 25, 6, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-05-25' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-19' AS date), CAST(N'2012-05-25' AS date), 1037, 3112, 13533, 13534, 13534, 13534, 13534, 13534, 13533, 2456073, 56072, N'2012-05-25', 201221, 21, 5, N'2012-W21', N'2012-W21-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94743, CAST(N'2012-05-26' AS date), CAST(N'2012-05-27' AS date), 2012, 20122, 201205, 2012147, 2, 5, 147, 26, 7, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-20' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-05-25' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-06-01' AS date), 1037, 3112, 13533, 13534, 13534, 13534, 13534, 13534, 13534, 2456074, 56073, N'2012-05-26', 201221, 21, 6, N'2012-W21', N'2012-W21-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94744, CAST(N'2012-05-27' AS date), CAST(N'2012-05-28' AS date), 2012, 20122, 201205, 2012148, 2, 5, 148, 27, 1, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-05-21' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-05-25' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-06-01' AS date), 1037, 3112, 13534, 13534, 13534, 13534, 13534, 13534, 13534, 2456075, 56074, N'2012-05-27', 201221, 21, 7, N'2012-W21', N'2012-W21-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94745, CAST(N'2012-05-28' AS date), CAST(N'2012-05-29' AS date), 2012, 20122, 201205, 2012149, 2, 5, 149, 28, 2, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-05-22' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-05-25' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-06-01' AS date), 1037, 3112, 13534, 13535, 13534, 13534, 13534, 13534, 13534, 2456076, 56075, N'2012-05-28', 201222, 22, 1, N'2012-W22', N'2012-W22-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94746, CAST(N'2012-05-29' AS date), CAST(N'2012-05-30' AS date), 2012, 20122, 201205, 2012150, 2, 5, 150, 29, 3, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-05-23' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-05-25' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-06-01' AS date), 1037, 3112, 13534, 13535, 13535, 13534, 13534, 13534, 13534, 2456077, 56076, N'2012-05-29', 201222, 22, 2, N'2012-W22', N'2012-W22-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94747, CAST(N'2012-05-30' AS date), CAST(N'2012-05-31' AS date), 2012, 20122, 201205, 2012151, 2, 5, 151, 30, 4, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-05-24' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-05-25' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-06-01' AS date), 1037, 3112, 13534, 13535, 13535, 13535, 13534, 13534, 13534, 2456078, 56077, N'2012-05-30', 201222, 22, 3, N'2012-W22', N'2012-W22-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94748, CAST(N'2012-05-31' AS date), CAST(N'2012-06-01' AS date), 2012, 20122, 201205, 2012152, 2, 5, 152, 31, 5, N'2012', N'2012 Q2', N'2012 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-01' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-05-25' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-06-01' AS date), 1037, 3112, 13534, 13535, 13535, 13535, 13535, 13534, 13534, 2456079, 56078, N'2012-05-31', 201222, 22, 4, N'2012-W22', N'2012-W22-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94749, CAST(N'2012-06-01' AS date), CAST(N'2012-06-02' AS date), 2012, 20122, 201206, 2012153, 2, 6, 153, 1, 6, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-05-26' AS date), CAST(N'2012-06-01' AS date), 1037, 3113, 13534, 13535, 13535, 13535, 13535, 13535, 13534, 2456080, 56079, N'2012-06-01', 201222, 22, 5, N'2012-W22', N'2012-W22-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94750, CAST(N'2012-06-02' AS date), CAST(N'2012-06-03' AS date), 2012, 20122, 201206, 2012154, 2, 6, 154, 2, 7, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-05-27' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-06-08' AS date), 1037, 3113, 13534, 13535, 13535, 13535, 13535, 13535, 13535, 2456081, 56080, N'2012-06-02', 201222, 22, 6, N'2012-W22', N'2012-W22-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94751, CAST(N'2012-06-03' AS date), CAST(N'2012-06-04' AS date), 2012, 20122, 201206, 2012155, 2, 6, 155, 3, 1, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-05-28' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-06-08' AS date), 1037, 3113, 13535, 13535, 13535, 13535, 13535, 13535, 13535, 2456082, 56081, N'2012-06-03', 201222, 22, 7, N'2012-W22', N'2012-W22-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94752, CAST(N'2012-06-04' AS date), CAST(N'2012-06-05' AS date), 2012, 20122, 201206, 2012156, 2, 6, 156, 4, 2, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-05-29' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-06-08' AS date), 1037, 3113, 13535, 13536, 13535, 13535, 13535, 13535, 13535, 2456083, 56082, N'2012-06-04', 201223, 23, 1, N'2012-W23', N'2012-W23-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94753, CAST(N'2012-06-05' AS date), CAST(N'2012-06-06' AS date), 2012, 20122, 201206, 2012157, 2, 6, 157, 5, 3, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-05-30' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-06-08' AS date), 1037, 3113, 13535, 13536, 13536, 13535, 13535, 13535, 13535, 2456084, 56083, N'2012-06-05', 201223, 23, 2, N'2012-W23', N'2012-W23-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94754, CAST(N'2012-06-06' AS date), CAST(N'2012-06-07' AS date), 2012, 20122, 201206, 2012158, 2, 6, 158, 6, 4, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-05-31' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-06-08' AS date), 1037, 3113, 13535, 13536, 13536, 13536, 13535, 13535, 13535, 2456085, 56084, N'2012-06-06', 201223, 23, 3, N'2012-W23', N'2012-W23-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94755, CAST(N'2012-06-07' AS date), CAST(N'2012-06-08' AS date), 2012, 20122, 201206, 2012159, 2, 6, 159, 7, 5, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-06-08' AS date), 1037, 3113, 13535, 13536, 13536, 13536, 13536, 13535, 13535, 2456086, 56085, N'2012-06-07', 201223, 23, 4, N'2012-W23', N'2012-W23-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94756, CAST(N'2012-06-08' AS date), CAST(N'2012-06-09' AS date), 2012, 20122, 201206, 2012160, 2, 6, 160, 8, 6, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-08' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-02' AS date), CAST(N'2012-06-08' AS date), 1037, 3113, 13535, 13536, 13536, 13536, 13536, 13536, 13535, 2456087, 56086, N'2012-06-08', 201223, 23, 5, N'2012-W23', N'2012-W23-5');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94757, CAST(N'2012-06-09' AS date), CAST(N'2012-06-10' AS date), 2012, 20122, 201206, 2012161, 2, 6, 161, 9, 7, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-03' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-08' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-15' AS date), 1037, 3113, 13535, 13536, 13536, 13536, 13536, 13536, 13536, 2456088, 56087, N'2012-06-09', 201223, 23, 6, N'2012-W23', N'2012-W23-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94758, CAST(N'2012-06-10' AS date), CAST(N'2012-06-11' AS date), 2012, 20122, 201206, 2012162, 2, 6, 162, 10, 1, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-04' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-08' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-15' AS date), 1037, 3113, 13536, 13536, 13536, 13536, 13536, 13536, 13536, 2456089, 56088, N'2012-06-10', 201223, 23, 7, N'2012-W23', N'2012-W23-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94759, CAST(N'2012-06-11' AS date), CAST(N'2012-06-12' AS date), 2012, 20122, 201206, 2012163, 2, 6, 163, 11, 2, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-05' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-08' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-15' AS date), 1037, 3113, 13536, 13537, 13536, 13536, 13536, 13536, 13536, 2456090, 56089, N'2012-06-11', 201224, 24, 1, N'2012-W24', N'2012-W24-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94760, CAST(N'2012-06-12' AS date), CAST(N'2012-06-13' AS date), 2012, 20122, 201206, 2012164, 2, 6, 164, 12, 3, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-06' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-08' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-15' AS date), 1037, 3113, 13536, 13537, 13537, 13536, 13536, 13536, 13536, 2456091, 56090, N'2012-06-12', 201224, 24, 2, N'2012-W24', N'2012-W24-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94761, CAST(N'2012-06-13' AS date), CAST(N'2012-06-14' AS date), 2012, 20122, 201206, 2012165, 2, 6, 165, 13, 4, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-07' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-08' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-15' AS date), 1037, 3113, 13536, 13537, 13537, 13537, 13536, 13536, 13536, 2456092, 56091, N'2012-06-13', 201224, 24, 3, N'2012-W24', N'2012-W24-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94762, CAST(N'2012-06-14' AS date), CAST(N'2012-06-15' AS date), 2012, 20122, 201206, 2012166, 2, 6, 166, 14, 5, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-08' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-15' AS date), 1037, 3113, 13536, 13537, 13537, 13537, 13537, 13536, 13536, 2456093, 56092, N'2012-06-14', 201224, 24, 4, N'2012-W24', N'2012-W24-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94763, CAST(N'2012-06-15' AS date), CAST(N'2012-06-16' AS date), 2012, 20122, 201206, 2012167, 2, 6, 167, 15, 6, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-15' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-09' AS date), CAST(N'2012-06-15' AS date), 1037, 3113, 13536, 13537, 13537, 13537, 13537, 13537, 13536, 2456094, 56093, N'2012-06-15', 201224, 24, 5, N'2012-W24', N'2012-W24-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94764, CAST(N'2012-06-16' AS date), CAST(N'2012-06-17' AS date), 2012, 20122, 201206, 2012168, 2, 6, 168, 16, 7, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-10' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-15' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-22' AS date), 1037, 3113, 13536, 13537, 13537, 13537, 13537, 13537, 13537, 2456095, 56094, N'2012-06-16', 201224, 24, 6, N'2012-W24', N'2012-W24-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94765, CAST(N'2012-06-17' AS date), CAST(N'2012-06-18' AS date), 2012, 20122, 201206, 2012169, 2, 6, 169, 17, 1, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-11' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-15' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-22' AS date), 1037, 3113, 13537, 13537, 13537, 13537, 13537, 13537, 13537, 2456096, 56095, N'2012-06-17', 201224, 24, 7, N'2012-W24', N'2012-W24-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94766, CAST(N'2012-06-18' AS date), CAST(N'2012-06-19' AS date), 2012, 20122, 201206, 2012170, 2, 6, 170, 18, 2, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-12' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-15' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-22' AS date), 1037, 3113, 13537, 13538, 13537, 13537, 13537, 13537, 13537, 2456097, 56096, N'2012-06-18', 201225, 25, 1, N'2012-W25', N'2012-W25-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94767, CAST(N'2012-06-19' AS date), CAST(N'2012-06-20' AS date), 2012, 20122, 201206, 2012171, 2, 6, 171, 19, 3, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-06-13' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-15' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-22' AS date), 1037, 3113, 13537, 13538, 13538, 13537, 13537, 13537, 13537, 2456098, 56097, N'2012-06-19', 201225, 25, 2, N'2012-W25', N'2012-W25-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94768, CAST(N'2012-06-20' AS date), CAST(N'2012-06-21' AS date), 2012, 20122, 201206, 2012172, 2, 6, 172, 20, 4, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-06-14' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-15' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-22' AS date), 1037, 3113, 13537, 13538, 13538, 13538, 13537, 13537, 13537, 2456099, 56098, N'2012-06-20', 201225, 25, 3, N'2012-W25', N'2012-W25-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94769, CAST(N'2012-06-21' AS date), CAST(N'2012-06-22' AS date), 2012, 20122, 201206, 2012173, 2, 6, 173, 21, 5, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-06-15' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-22' AS date), 1037, 3113, 13537, 13538, 13538, 13538, 13538, 13537, 13537, 2456100, 56099, N'2012-06-21', 201225, 25, 4, N'2012-W25', N'2012-W25-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94770, CAST(N'2012-06-22' AS date), CAST(N'2012-06-23' AS date), 2012, 20122, 201206, 2012174, 2, 6, 174, 22, 6, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-06-22' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-06-16' AS date), CAST(N'2012-06-22' AS date), 1037, 3113, 13537, 13538, 13538, 13538, 13538, 13538, 13537, 2456101, 56100, N'2012-06-22', 201225, 25, 5, N'2012-W25', N'2012-W25-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94771, CAST(N'2012-06-23' AS date), CAST(N'2012-06-24' AS date), 2012, 20122, 201206, 2012175, 2, 6, 175, 23, 7, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-17' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-06-22' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-29' AS date), 1037, 3113, 13537, 13538, 13538, 13538, 13538, 13538, 13538, 2456102, 56101, N'2012-06-23', 201225, 25, 6, N'2012-W25', N'2012-W25-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94772, CAST(N'2012-06-24' AS date), CAST(N'2012-06-25' AS date), 2012, 20122, 201206, 2012176, 2, 6, 176, 24, 1, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-18' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-06-22' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-29' AS date), 1037, 3113, 13538, 13538, 13538, 13538, 13538, 13538, 13538, 2456103, 56102, N'2012-06-24', 201225, 25, 7, N'2012-W25', N'2012-W25-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94773, CAST(N'2012-06-25' AS date), CAST(N'2012-06-26' AS date), 2012, 20122, 201206, 2012177, 2, 6, 177, 25, 2, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-06-19' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-06-22' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-29' AS date), 1037, 3113, 13538, 13539, 13538, 13538, 13538, 13538, 13538, 2456104, 56103, N'2012-06-25', 201226, 26, 1, N'2012-W26', N'2012-W26-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94774, CAST(N'2012-06-26' AS date), CAST(N'2012-06-27' AS date), 2012, 20122, 201206, 2012178, 2, 6, 178, 26, 3, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-06-20' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-06-22' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-29' AS date), 1037, 3113, 13538, 13539, 13539, 13538, 13538, 13538, 13538, 2456105, 56104, N'2012-06-26', 201226, 26, 2, N'2012-W26', N'2012-W26-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94775, CAST(N'2012-06-27' AS date), CAST(N'2012-06-28' AS date), 2012, 20122, 201206, 2012179, 2, 6, 179, 27, 4, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-06-21' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-06-22' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-29' AS date), 1037, 3113, 13538, 13539, 13539, 13539, 13538, 13538, 13538, 2456106, 56105, N'2012-06-27', 201226, 26, 3, N'2012-W26', N'2012-W26-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94776, CAST(N'2012-06-28' AS date), CAST(N'2012-06-29' AS date), 2012, 20122, 201206, 2012180, 2, 6, 180, 28, 5, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-06-22' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-29' AS date), 1037, 3113, 13538, 13539, 13539, 13539, 13539, 13538, 13538, 2456107, 56106, N'2012-06-28', 201226, 26, 4, N'2012-W26', N'2012-W26-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94777, CAST(N'2012-06-29' AS date), CAST(N'2012-06-30' AS date), 2012, 20122, 201206, 2012181, 2, 6, 181, 29, 6, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-06-29' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-06-23' AS date), CAST(N'2012-06-29' AS date), 1037, 3113, 13538, 13539, 13539, 13539, 13539, 13539, 13538, 2456108, 56107, N'2012-06-29', 201226, 26, 5, N'2012-W26', N'2012-W26-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94778, CAST(N'2012-06-30' AS date), CAST(N'2012-07-01' AS date), 2012, 20122, 201206, 2012182, 2, 6, 182, 30, 7, N'2012', N'2012 Q2', N'2012 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-04-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-01' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-24' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-06-29' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-07-06' AS date), 1037, 3113, 13538, 13539, 13539, 13539, 13539, 13539, 13539, 2456109, 56108, N'2012-06-30', 201226, 26, 6, N'2012-W26', N'2012-W26-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94779, CAST(N'2012-07-01' AS date), CAST(N'2012-07-02' AS date), 2012, 20123, 201207, 2012183, 3, 7, 183, 1, 1, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-06-25' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-06-29' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-07-06' AS date), 1038, 3114, 13539, 13539, 13539, 13539, 13539, 13539, 13539, 2456110, 56109, N'2012-07-01', 201226, 26, 7, N'2012-W26', N'2012-W26-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94780, CAST(N'2012-07-02' AS date), CAST(N'2012-07-03' AS date), 2012, 20123, 201207, 2012184, 3, 7, 184, 2, 2, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-06-26' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-06-29' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-07-06' AS date), 1038, 3114, 13539, 13540, 13539, 13539, 13539, 13539, 13539, 2456111, 56110, N'2012-07-02', 201227, 27, 1, N'2012-W27', N'2012-W27-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94781, CAST(N'2012-07-03' AS date), CAST(N'2012-07-04' AS date), 2012, 20123, 201207, 2012185, 3, 7, 185, 3, 3, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-06-27' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-06-29' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-07-06' AS date), 1038, 3114, 13539, 13540, 13540, 13539, 13539, 13539, 13539, 2456112, 56111, N'2012-07-03', 201227, 27, 2, N'2012-W27', N'2012-W27-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94782, CAST(N'2012-07-04' AS date), CAST(N'2012-07-05' AS date), 2012, 20123, 201207, 2012186, 3, 7, 186, 4, 4, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-06-28' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-06-29' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-07-06' AS date), 1038, 3114, 13539, 13540, 13540, 13540, 13539, 13539, 13539, 2456113, 56112, N'2012-07-04', 201227, 27, 3, N'2012-W27', N'2012-W27-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94783, CAST(N'2012-07-05' AS date), CAST(N'2012-07-06' AS date), 2012, 20123, 201207, 2012187, 3, 7, 187, 5, 5, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-06-29' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-07-06' AS date), 1038, 3114, 13539, 13540, 13540, 13540, 13540, 13539, 13539, 2456114, 56113, N'2012-07-05', 201227, 27, 4, N'2012-W27', N'2012-W27-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94784, CAST(N'2012-07-06' AS date), CAST(N'2012-07-07' AS date), 2012, 20123, 201207, 2012188, 3, 7, 188, 6, 6, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-06' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-06-30' AS date), CAST(N'2012-07-06' AS date), 1038, 3114, 13539, 13540, 13540, 13540, 13540, 13540, 13539, 2456115, 56114, N'2012-07-06', 201227, 27, 5, N'2012-W27', N'2012-W27-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94785, CAST(N'2012-07-07' AS date), CAST(N'2012-07-08' AS date), 2012, 20123, 201207, 2012189, 3, 7, 189, 7, 7, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-06' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-13' AS date), 1038, 3114, 13539, 13540, 13540, 13540, 13540, 13540, 13540, 2456116, 56115, N'2012-07-07', 201227, 27, 6, N'2012-W27', N'2012-W27-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94786, CAST(N'2012-07-08' AS date), CAST(N'2012-07-09' AS date), 2012, 20123, 201207, 2012190, 3, 7, 190, 8, 1, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-02' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-06' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-13' AS date), 1038, 3114, 13540, 13540, 13540, 13540, 13540, 13540, 13540, 2456117, 56116, N'2012-07-08', 201227, 27, 7, N'2012-W27', N'2012-W27-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94787, CAST(N'2012-07-09' AS date), CAST(N'2012-07-10' AS date), 2012, 20123, 201207, 2012191, 3, 7, 191, 9, 2, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-03' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-06' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-13' AS date), 1038, 3114, 13540, 13541, 13540, 13540, 13540, 13540, 13540, 2456118, 56117, N'2012-07-09', 201228, 28, 1, N'2012-W28', N'2012-W28-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94788, CAST(N'2012-07-10' AS date), CAST(N'2012-07-11' AS date), 2012, 20123, 201207, 2012192, 3, 7, 192, 10, 3, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-04' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-06' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-13' AS date), 1038, 3114, 13540, 13541, 13541, 13540, 13540, 13540, 13540, 2456119, 56118, N'2012-07-10', 201228, 28, 2, N'2012-W28', N'2012-W28-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94789, CAST(N'2012-07-11' AS date), CAST(N'2012-07-12' AS date), 2012, 20123, 201207, 2012193, 3, 7, 193, 11, 4, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-05' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-06' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-13' AS date), 1038, 3114, 13540, 13541, 13541, 13541, 13540, 13540, 13540, 2456120, 56119, N'2012-07-11', 201228, 28, 3, N'2012-W28', N'2012-W28-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94790, CAST(N'2012-07-12' AS date), CAST(N'2012-07-13' AS date), 2012, 20123, 201207, 2012194, 3, 7, 194, 12, 5, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-06' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-13' AS date), 1038, 3114, 13540, 13541, 13541, 13541, 13541, 13540, 13540, 2456121, 56120, N'2012-07-12', 201228, 28, 4, N'2012-W28', N'2012-W28-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94791, CAST(N'2012-07-13' AS date), CAST(N'2012-07-14' AS date), 2012, 20123, 201207, 2012195, 3, 7, 195, 13, 6, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-13' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-07' AS date), CAST(N'2012-07-13' AS date), 1038, 3114, 13540, 13541, 13541, 13541, 13541, 13541, 13540, 2456122, 56121, N'2012-07-13', 201228, 28, 5, N'2012-W28', N'2012-W28-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94792, CAST(N'2012-07-14' AS date), CAST(N'2012-07-15' AS date), 2012, 20123, 201207, 2012196, 3, 7, 196, 14, 7, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-08' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-13' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-20' AS date), 1038, 3114, 13540, 13541, 13541, 13541, 13541, 13541, 13541, 2456123, 56122, N'2012-07-14', 201228, 28, 6, N'2012-W28', N'2012-W28-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94793, CAST(N'2012-07-15' AS date), CAST(N'2012-07-16' AS date), 2012, 20123, 201207, 2012197, 3, 7, 197, 15, 1, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-09' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-13' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-20' AS date), 1038, 3114, 13541, 13541, 13541, 13541, 13541, 13541, 13541, 2456124, 56123, N'2012-07-15', 201228, 28, 7, N'2012-W28', N'2012-W28-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94794, CAST(N'2012-07-16' AS date), CAST(N'2012-07-17' AS date), 2012, 20123, 201207, 2012198, 3, 7, 198, 16, 2, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-10' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-13' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-20' AS date), 1038, 3114, 13541, 13542, 13541, 13541, 13541, 13541, 13541, 2456125, 56124, N'2012-07-16', 201229, 29, 1, N'2012-W29', N'2012-W29-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94795, CAST(N'2012-07-17' AS date), CAST(N'2012-07-18' AS date), 2012, 20123, 201207, 2012199, 3, 7, 199, 17, 3, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-11' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-13' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-20' AS date), 1038, 3114, 13541, 13542, 13542, 13541, 13541, 13541, 13541, 2456126, 56125, N'2012-07-17', 201229, 29, 2, N'2012-W29', N'2012-W29-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94796, CAST(N'2012-07-18' AS date), CAST(N'2012-07-19' AS date), 2012, 20123, 201207, 2012200, 3, 7, 200, 18, 4, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-12' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-13' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-20' AS date), 1038, 3114, 13541, 13542, 13542, 13542, 13541, 13541, 13541, 2456127, 56126, N'2012-07-18', 201229, 29, 3, N'2012-W29', N'2012-W29-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94797, CAST(N'2012-07-19' AS date), CAST(N'2012-07-20' AS date), 2012, 20123, 201207, 2012201, 3, 7, 201, 19, 5, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-13' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-20' AS date), 1038, 3114, 13541, 13542, 13542, 13542, 13542, 13541, 13541, 2456128, 56127, N'2012-07-19', 201229, 29, 4, N'2012-W29', N'2012-W29-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94798, CAST(N'2012-07-20' AS date), CAST(N'2012-07-21' AS date), 2012, 20123, 201207, 2012202, 3, 7, 202, 20, 6, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-20' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-07-14' AS date), CAST(N'2012-07-20' AS date), 1038, 3114, 13541, 13542, 13542, 13542, 13542, 13542, 13541, 2456129, 56128, N'2012-07-20', 201229, 29, 5, N'2012-W29', N'2012-W29-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94799, CAST(N'2012-07-21' AS date), CAST(N'2012-07-22' AS date), 2012, 20123, 201207, 2012203, 3, 7, 203, 21, 7, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-15' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-20' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-27' AS date), 1038, 3114, 13541, 13542, 13542, 13542, 13542, 13542, 13542, 2456130, 56129, N'2012-07-21', 201229, 29, 6, N'2012-W29', N'2012-W29-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94800, CAST(N'2012-07-22' AS date), CAST(N'2012-07-23' AS date), 2012, 20123, 201207, 2012204, 3, 7, 204, 22, 1, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-07-16' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-20' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-27' AS date), 1038, 3114, 13542, 13542, 13542, 13542, 13542, 13542, 13542, 2456131, 56130, N'2012-07-22', 201229, 29, 7, N'2012-W29', N'2012-W29-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94801, CAST(N'2012-07-23' AS date), CAST(N'2012-07-24' AS date), 2012, 20123, 201207, 2012205, 3, 7, 205, 23, 2, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-07-17' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-20' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-27' AS date), 1038, 3114, 13542, 13543, 13542, 13542, 13542, 13542, 13542, 2456132, 56131, N'2012-07-23', 201230, 30, 1, N'2012-W30', N'2012-W30-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94802, CAST(N'2012-07-24' AS date), CAST(N'2012-07-25' AS date), 2012, 20123, 201207, 2012206, 3, 7, 206, 24, 3, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-07-18' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-20' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-27' AS date), 1038, 3114, 13542, 13543, 13543, 13542, 13542, 13542, 13542, 2456133, 56132, N'2012-07-24', 201230, 30, 2, N'2012-W30', N'2012-W30-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94803, CAST(N'2012-07-25' AS date), CAST(N'2012-07-26' AS date), 2012, 20123, 201207, 2012207, 3, 7, 207, 25, 4, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-19' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-20' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-27' AS date), 1038, 3114, 13542, 13543, 13543, 13543, 13542, 13542, 13542, 2456134, 56133, N'2012-07-25', 201230, 30, 3, N'2012-W30', N'2012-W30-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94804, CAST(N'2012-07-26' AS date), CAST(N'2012-07-27' AS date), 2012, 20123, 201207, 2012208, 3, 7, 208, 26, 5, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-07-20' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-27' AS date), 1038, 3114, 13542, 13543, 13543, 13543, 13543, 13542, 13542, 2456135, 56134, N'2012-07-26', 201230, 30, 4, N'2012-W30', N'2012-W30-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94805, CAST(N'2012-07-27' AS date), CAST(N'2012-07-28' AS date), 2012, 20123, 201207, 2012209, 3, 7, 209, 27, 6, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-07-27' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-07-21' AS date), CAST(N'2012-07-27' AS date), 1038, 3114, 13542, 13543, 13543, 13543, 13543, 13543, 13542, 2456136, 56135, N'2012-07-27', 201230, 30, 5, N'2012-W30', N'2012-W30-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94806, CAST(N'2012-07-28' AS date), CAST(N'2012-07-29' AS date), 2012, 20123, 201207, 2012210, 3, 7, 210, 28, 7, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-22' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-07-27' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-08-03' AS date), 1038, 3114, 13542, 13543, 13543, 13543, 13543, 13543, 13543, 2456137, 56136, N'2012-07-28', 201230, 30, 6, N'2012-W30', N'2012-W30-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94807, CAST(N'2012-07-29' AS date), CAST(N'2012-07-30' AS date), 2012, 20123, 201207, 2012211, 3, 7, 211, 29, 1, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-07-23' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-07-27' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-08-03' AS date), 1038, 3114, 13543, 13543, 13543, 13543, 13543, 13543, 13543, 2456138, 56137, N'2012-07-29', 201230, 30, 7, N'2012-W30', N'2012-W30-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94808, CAST(N'2012-07-30' AS date), CAST(N'2012-07-31' AS date), 2012, 20123, 201207, 2012212, 3, 7, 212, 30, 2, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-07-24' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-07-27' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-08-03' AS date), 1038, 3114, 13543, 13544, 13543, 13543, 13543, 13543, 13543, 2456139, 56138, N'2012-07-30', 201231, 31, 1, N'2012-W31', N'2012-W31-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94809, CAST(N'2012-07-31' AS date), CAST(N'2012-08-01' AS date), 2012, 20123, 201207, 2012213, 3, 7, 213, 31, 3, N'2012', N'2012 Q3', N'2012 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-07-25' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-07-27' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-08-03' AS date), 1038, 3114, 13543, 13544, 13544, 13543, 13543, 13543, 13543, 2456140, 56139, N'2012-07-31', 201231, 31, 2, N'2012-W31', N'2012-W31-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94810, CAST(N'2012-08-01' AS date), CAST(N'2012-08-02' AS date), 2012, 20123, 201208, 2012214, 3, 8, 214, 1, 4, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-07-26' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-07-27' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-08-03' AS date), 1038, 3115, 13543, 13544, 13544, 13544, 13543, 13543, 13543, 2456141, 56140, N'2012-08-01', 201231, 31, 3, N'2012-W31', N'2012-W31-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94811, CAST(N'2012-08-02' AS date), CAST(N'2012-08-03' AS date), 2012, 20123, 201208, 2012215, 3, 8, 215, 2, 5, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-07-27' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-08-03' AS date), 1038, 3115, 13543, 13544, 13544, 13544, 13544, 13543, 13543, 2456142, 56141, N'2012-08-02', 201231, 31, 4, N'2012-W31', N'2012-W31-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94812, CAST(N'2012-08-03' AS date), CAST(N'2012-08-04' AS date), 2012, 20123, 201208, 2012216, 3, 8, 216, 3, 6, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-03' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-07-28' AS date), CAST(N'2012-08-03' AS date), 1038, 3115, 13543, 13544, 13544, 13544, 13544, 13544, 13543, 2456143, 56142, N'2012-08-03', 201231, 31, 5, N'2012-W31', N'2012-W31-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94813, CAST(N'2012-08-04' AS date), CAST(N'2012-08-05' AS date), 2012, 20123, 201208, 2012217, 3, 8, 217, 4, 7, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-07-29' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-03' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-08-10' AS date), 1038, 3115, 13543, 13544, 13544, 13544, 13544, 13544, 13544, 2456144, 56143, N'2012-08-04', 201231, 31, 6, N'2012-W31', N'2012-W31-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94814, CAST(N'2012-08-05' AS date), CAST(N'2012-08-06' AS date), 2012, 20123, 201208, 2012218, 3, 8, 218, 5, 1, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-07-30' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-03' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-08-10' AS date), 1038, 3115, 13544, 13544, 13544, 13544, 13544, 13544, 13544, 2456145, 56144, N'2012-08-05', 201231, 31, 7, N'2012-W31', N'2012-W31-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94815, CAST(N'2012-08-06' AS date), CAST(N'2012-08-07' AS date), 2012, 20123, 201208, 2012219, 3, 8, 219, 6, 2, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-07-31' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-03' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-08-10' AS date), 1038, 3115, 13544, 13545, 13544, 13544, 13544, 13544, 13544, 2456146, 56145, N'2012-08-06', 201232, 32, 1, N'2012-W32', N'2012-W32-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94816, CAST(N'2012-08-07' AS date), CAST(N'2012-08-08' AS date), 2012, 20123, 201208, 2012220, 3, 8, 220, 7, 3, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-03' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-08-10' AS date), 1038, 3115, 13544, 13545, 13545, 13544, 13544, 13544, 13544, 2456147, 56146, N'2012-08-07', 201232, 32, 2, N'2012-W32', N'2012-W32-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94817, CAST(N'2012-08-08' AS date), CAST(N'2012-08-09' AS date), 2012, 20123, 201208, 2012221, 3, 8, 221, 8, 4, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-02' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-03' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-08-10' AS date), 1038, 3115, 13544, 13545, 13545, 13545, 13544, 13544, 13544, 2456148, 56147, N'2012-08-08', 201232, 32, 3, N'2012-W32', N'2012-W32-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94818, CAST(N'2012-08-09' AS date), CAST(N'2012-08-10' AS date), 2012, 20123, 201208, 2012222, 3, 8, 222, 9, 5, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-03' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-08-10' AS date), 1038, 3115, 13544, 13545, 13545, 13545, 13545, 13544, 13544, 2456149, 56148, N'2012-08-09', 201232, 32, 4, N'2012-W32', N'2012-W32-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94819, CAST(N'2012-08-10' AS date), CAST(N'2012-08-11' AS date), 2012, 20123, 201208, 2012223, 3, 8, 223, 10, 6, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-10' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-04' AS date), CAST(N'2012-08-10' AS date), 1038, 3115, 13544, 13545, 13545, 13545, 13545, 13545, 13544, 2456150, 56149, N'2012-08-10', 201232, 32, 5, N'2012-W32', N'2012-W32-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94820, CAST(N'2012-08-11' AS date), CAST(N'2012-08-12' AS date), 2012, 20123, 201208, 2012224, 3, 8, 224, 11, 7, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-05' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-10' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-17' AS date), 1038, 3115, 13544, 13545, 13545, 13545, 13545, 13545, 13545, 2456151, 56150, N'2012-08-11', 201232, 32, 6, N'2012-W32', N'2012-W32-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94821, CAST(N'2012-08-12' AS date), CAST(N'2012-08-13' AS date), 2012, 20123, 201208, 2012225, 3, 8, 225, 12, 1, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-06' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-10' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-17' AS date), 1038, 3115, 13545, 13545, 13545, 13545, 13545, 13545, 13545, 2456152, 56151, N'2012-08-12', 201232, 32, 7, N'2012-W32', N'2012-W32-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94822, CAST(N'2012-08-13' AS date), CAST(N'2012-08-14' AS date), 2012, 20123, 201208, 2012226, 3, 8, 226, 13, 2, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-07' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-10' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-17' AS date), 1038, 3115, 13545, 13546, 13545, 13545, 13545, 13545, 13545, 2456153, 56152, N'2012-08-13', 201233, 33, 1, N'2012-W33', N'2012-W33-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94823, CAST(N'2012-08-14' AS date), CAST(N'2012-08-15' AS date), 2012, 20123, 201208, 2012227, 3, 8, 227, 14, 3, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-08' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-10' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-17' AS date), 1038, 3115, 13545, 13546, 13546, 13545, 13545, 13545, 13545, 2456154, 56153, N'2012-08-14', 201233, 33, 2, N'2012-W33', N'2012-W33-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94824, CAST(N'2012-08-15' AS date), CAST(N'2012-08-16' AS date), 2012, 20123, 201208, 2012228, 3, 8, 228, 15, 4, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-09' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-10' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-17' AS date), 1038, 3115, 13545, 13546, 13546, 13546, 13545, 13545, 13545, 2456155, 56154, N'2012-08-15', 201233, 33, 3, N'2012-W33', N'2012-W33-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94825, CAST(N'2012-08-16' AS date), CAST(N'2012-08-17' AS date), 2012, 20123, 201208, 2012229, 3, 8, 229, 16, 5, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-10' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-17' AS date), 1038, 3115, 13545, 13546, 13546, 13546, 13546, 13545, 13545, 2456156, 56155, N'2012-08-16', 201233, 33, 4, N'2012-W33', N'2012-W33-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94826, CAST(N'2012-08-17' AS date), CAST(N'2012-08-18' AS date), 2012, 20123, 201208, 2012230, 3, 8, 230, 17, 6, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-17' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-11' AS date), CAST(N'2012-08-17' AS date), 1038, 3115, 13545, 13546, 13546, 13546, 13546, 13546, 13545, 2456157, 56156, N'2012-08-17', 201233, 33, 5, N'2012-W33', N'2012-W33-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94827, CAST(N'2012-08-18' AS date), CAST(N'2012-08-19' AS date), 2012, 20123, 201208, 2012231, 3, 8, 231, 18, 7, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-12' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-17' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-24' AS date), 1038, 3115, 13545, 13546, 13546, 13546, 13546, 13546, 13546, 2456158, 56157, N'2012-08-18', 201233, 33, 6, N'2012-W33', N'2012-W33-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94828, CAST(N'2012-08-19' AS date), CAST(N'2012-08-20' AS date), 2012, 20123, 201208, 2012232, 3, 8, 232, 19, 1, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-13' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-17' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-24' AS date), 1038, 3115, 13546, 13546, 13546, 13546, 13546, 13546, 13546, 2456159, 56158, N'2012-08-19', 201233, 33, 7, N'2012-W33', N'2012-W33-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94829, CAST(N'2012-08-20' AS date), CAST(N'2012-08-21' AS date), 2012, 20123, 201208, 2012233, 3, 8, 233, 20, 2, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-08-14' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-17' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-24' AS date), 1038, 3115, 13546, 13547, 13546, 13546, 13546, 13546, 13546, 2456160, 56159, N'2012-08-20', 201234, 34, 1, N'2012-W34', N'2012-W34-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94830, CAST(N'2012-08-21' AS date), CAST(N'2012-08-22' AS date), 2012, 20123, 201208, 2012234, 3, 8, 234, 21, 3, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-08-15' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-17' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-24' AS date), 1038, 3115, 13546, 13547, 13547, 13546, 13546, 13546, 13546, 2456161, 56160, N'2012-08-21', 201234, 34, 2, N'2012-W34', N'2012-W34-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94831, CAST(N'2012-08-22' AS date), CAST(N'2012-08-23' AS date), 2012, 20123, 201208, 2012235, 3, 8, 235, 22, 4, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-08-16' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-17' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-24' AS date), 1038, 3115, 13546, 13547, 13547, 13547, 13546, 13546, 13546, 2456162, 56161, N'2012-08-22', 201234, 34, 3, N'2012-W34', N'2012-W34-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94832, CAST(N'2012-08-23' AS date), CAST(N'2012-08-24' AS date), 2012, 20123, 201208, 2012236, 3, 8, 236, 23, 5, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-08-17' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-24' AS date), 1038, 3115, 13546, 13547, 13547, 13547, 13547, 13546, 13546, 2456163, 56162, N'2012-08-23', 201234, 34, 4, N'2012-W34', N'2012-W34-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94833, CAST(N'2012-08-24' AS date), CAST(N'2012-08-25' AS date), 2012, 20123, 201208, 2012237, 3, 8, 237, 24, 6, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-08-24' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-08-18' AS date), CAST(N'2012-08-24' AS date), 1038, 3115, 13546, 13547, 13547, 13547, 13547, 13547, 13546, 2456164, 56163, N'2012-08-24', 201234, 34, 5, N'2012-W34', N'2012-W34-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94834, CAST(N'2012-08-25' AS date), CAST(N'2012-08-26' AS date), 2012, 20123, 201208, 2012238, 3, 8, 238, 25, 7, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-19' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-08-24' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-31' AS date), 1038, 3115, 13546, 13547, 13547, 13547, 13547, 13547, 13547, 2456165, 56164, N'2012-08-25', 201234, 34, 6, N'2012-W34', N'2012-W34-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94835, CAST(N'2012-08-26' AS date), CAST(N'2012-08-27' AS date), 2012, 20123, 201208, 2012239, 3, 8, 239, 26, 1, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-08-20' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-08-24' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-31' AS date), 1038, 3115, 13547, 13547, 13547, 13547, 13547, 13547, 13547, 2456166, 56165, N'2012-08-26', 201234, 34, 7, N'2012-W34', N'2012-W34-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94836, CAST(N'2012-08-27' AS date), CAST(N'2012-08-28' AS date), 2012, 20123, 201208, 2012240, 3, 8, 240, 27, 2, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-08-21' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-08-24' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-31' AS date), 1038, 3115, 13547, 13548, 13547, 13547, 13547, 13547, 13547, 2456167, 56166, N'2012-08-27', 201235, 35, 1, N'2012-W35', N'2012-W35-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94837, CAST(N'2012-08-28' AS date), CAST(N'2012-08-29' AS date), 2012, 20123, 201208, 2012241, 3, 8, 241, 28, 3, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-08-22' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-08-24' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-31' AS date), 1038, 3115, 13547, 13548, 13548, 13547, 13547, 13547, 13547, 2456168, 56167, N'2012-08-28', 201235, 35, 2, N'2012-W35', N'2012-W35-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94838, CAST(N'2012-08-29' AS date), CAST(N'2012-08-30' AS date), 2012, 20123, 201208, 2012242, 3, 8, 242, 29, 4, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-08-23' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-08-24' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-31' AS date), 1038, 3115, 13547, 13548, 13548, 13548, 13547, 13547, 13547, 2456169, 56168, N'2012-08-29', 201235, 35, 3, N'2012-W35', N'2012-W35-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94839, CAST(N'2012-08-30' AS date), CAST(N'2012-08-31' AS date), 2012, 20123, 201208, 2012243, 3, 8, 243, 30, 5, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-08-24' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-31' AS date), 1038, 3115, 13547, 13548, 13548, 13548, 13548, 13547, 13547, 2456170, 56169, N'2012-08-30', 201235, 35, 4, N'2012-W35', N'2012-W35-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94840, CAST(N'2012-08-31' AS date), CAST(N'2012-09-01' AS date), 2012, 20123, 201208, 2012244, 3, 8, 244, 31, 6, N'2012', N'2012 Q3', N'2012 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-01' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-08-25' AS date), CAST(N'2012-08-31' AS date), 1038, 3115, 13547, 13548, 13548, 13548, 13548, 13548, 13547, 2456171, 56170, N'2012-08-31', 201235, 35, 5, N'2012-W35', N'2012-W35-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94841, CAST(N'2012-09-01' AS date), CAST(N'2012-09-02' AS date), 2012, 20123, 201209, 2012245, 3, 9, 245, 1, 7, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-08-26' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-07' AS date), 1038, 3116, 13547, 13548, 13548, 13548, 13548, 13548, 13548, 2456172, 56171, N'2012-09-01', 201235, 35, 6, N'2012-W35', N'2012-W35-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94842, CAST(N'2012-09-02' AS date), CAST(N'2012-09-03' AS date), 2012, 20123, 201209, 2012246, 3, 9, 246, 2, 1, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-08-27' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-07' AS date), 1038, 3116, 13548, 13548, 13548, 13548, 13548, 13548, 13548, 2456173, 56172, N'2012-09-02', 201235, 35, 7, N'2012-W35', N'2012-W35-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94843, CAST(N'2012-09-03' AS date), CAST(N'2012-09-04' AS date), 2012, 20123, 201209, 2012247, 3, 9, 247, 3, 2, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-08-28' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-07' AS date), 1038, 3116, 13548, 13549, 13548, 13548, 13548, 13548, 13548, 2456174, 56173, N'2012-09-03', 201236, 36, 1, N'2012-W36', N'2012-W36-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94844, CAST(N'2012-09-04' AS date), CAST(N'2012-09-05' AS date), 2012, 20123, 201209, 2012248, 3, 9, 248, 4, 3, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-08-29' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-07' AS date), 1038, 3116, 13548, 13549, 13549, 13548, 13548, 13548, 13548, 2456175, 56174, N'2012-09-04', 201236, 36, 2, N'2012-W36', N'2012-W36-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94845, CAST(N'2012-09-05' AS date), CAST(N'2012-09-06' AS date), 2012, 20123, 201209, 2012249, 3, 9, 249, 5, 4, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-08-30' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-07' AS date), 1038, 3116, 13548, 13549, 13549, 13549, 13548, 13548, 13548, 2456176, 56175, N'2012-09-05', 201236, 36, 3, N'2012-W36', N'2012-W36-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94846, CAST(N'2012-09-06' AS date), CAST(N'2012-09-07' AS date), 2012, 20123, 201209, 2012250, 3, 9, 250, 6, 5, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-08-31' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-07' AS date), 1038, 3116, 13548, 13549, 13549, 13549, 13549, 13548, 13548, 2456177, 56176, N'2012-09-06', 201236, 36, 4, N'2012-W36', N'2012-W36-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94847, CAST(N'2012-09-07' AS date), CAST(N'2012-09-08' AS date), 2012, 20123, 201209, 2012251, 3, 9, 251, 7, 6, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-07' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-07' AS date), 1038, 3116, 13548, 13549, 13549, 13549, 13549, 13549, 13548, 2456178, 56177, N'2012-09-07', 201236, 36, 5, N'2012-W36', N'2012-W36-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94848, CAST(N'2012-09-08' AS date), CAST(N'2012-09-09' AS date), 2012, 20123, 201209, 2012252, 3, 9, 252, 8, 7, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-02' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-07' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-14' AS date), 1038, 3116, 13548, 13549, 13549, 13549, 13549, 13549, 13549, 2456179, 56178, N'2012-09-08', 201236, 36, 6, N'2012-W36', N'2012-W36-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94849, CAST(N'2012-09-09' AS date), CAST(N'2012-09-10' AS date), 2012, 20123, 201209, 2012253, 3, 9, 253, 9, 1, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-03' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-07' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-14' AS date), 1038, 3116, 13549, 13549, 13549, 13549, 13549, 13549, 13549, 2456180, 56179, N'2012-09-09', 201236, 36, 7, N'2012-W36', N'2012-W36-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94850, CAST(N'2012-09-10' AS date), CAST(N'2012-09-11' AS date), 2012, 20123, 201209, 2012254, 3, 9, 254, 10, 2, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-04' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-07' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-14' AS date), 1038, 3116, 13549, 13550, 13549, 13549, 13549, 13549, 13549, 2456181, 56180, N'2012-09-10', 201237, 37, 1, N'2012-W37', N'2012-W37-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94851, CAST(N'2012-09-11' AS date), CAST(N'2012-09-12' AS date), 2012, 20123, 201209, 2012255, 3, 9, 255, 11, 3, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-05' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-07' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-14' AS date), 1038, 3116, 13549, 13550, 13550, 13549, 13549, 13549, 13549, 2456182, 56181, N'2012-09-11', 201237, 37, 2, N'2012-W37', N'2012-W37-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94852, CAST(N'2012-09-12' AS date), CAST(N'2012-09-13' AS date), 2012, 20123, 201209, 2012256, 3, 9, 256, 12, 4, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-06' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-07' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-14' AS date), 1038, 3116, 13549, 13550, 13550, 13550, 13549, 13549, 13549, 2456183, 56182, N'2012-09-12', 201237, 37, 3, N'2012-W37', N'2012-W37-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94853, CAST(N'2012-09-13' AS date), CAST(N'2012-09-14' AS date), 2012, 20123, 201209, 2012257, 3, 9, 257, 13, 5, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-07' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-14' AS date), 1038, 3116, 13549, 13550, 13550, 13550, 13550, 13549, 13549, 2456184, 56183, N'2012-09-13', 201237, 37, 4, N'2012-W37', N'2012-W37-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94854, CAST(N'2012-09-14' AS date), CAST(N'2012-09-15' AS date), 2012, 20123, 201209, 2012258, 3, 9, 258, 14, 6, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-14' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-08' AS date), CAST(N'2012-09-14' AS date), 1038, 3116, 13549, 13550, 13550, 13550, 13550, 13550, 13549, 2456185, 56184, N'2012-09-14', 201237, 37, 5, N'2012-W37', N'2012-W37-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94855, CAST(N'2012-09-15' AS date), CAST(N'2012-09-16' AS date), 2012, 20123, 201209, 2012259, 3, 9, 259, 15, 7, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-09' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-14' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-21' AS date), 1038, 3116, 13549, 13550, 13550, 13550, 13550, 13550, 13550, 2456186, 56185, N'2012-09-15', 201237, 37, 6, N'2012-W37', N'2012-W37-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94856, CAST(N'2012-09-16' AS date), CAST(N'2012-09-17' AS date), 2012, 20123, 201209, 2012260, 3, 9, 260, 16, 1, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-10' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-14' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-21' AS date), 1038, 3116, 13550, 13550, 13550, 13550, 13550, 13550, 13550, 2456187, 56186, N'2012-09-16', 201237, 37, 7, N'2012-W37', N'2012-W37-7');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94857, CAST(N'2012-09-17' AS date), CAST(N'2012-09-18' AS date), 2012, 20123, 201209, 2012261, 3, 9, 261, 17, 2, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-11' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-14' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-21' AS date), 1038, 3116, 13550, 13551, 13550, 13550, 13550, 13550, 13550, 2456188, 56187, N'2012-09-17', 201238, 38, 1, N'2012-W38', N'2012-W38-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94858, CAST(N'2012-09-18' AS date), CAST(N'2012-09-19' AS date), 2012, 20123, 201209, 2012262, 3, 9, 262, 18, 3, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-12' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-14' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-21' AS date), 1038, 3116, 13550, 13551, 13551, 13550, 13550, 13550, 13550, 2456189, 56188, N'2012-09-18', 201238, 38, 2, N'2012-W38', N'2012-W38-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94859, CAST(N'2012-09-19' AS date), CAST(N'2012-09-20' AS date), 2012, 20123, 201209, 2012263, 3, 9, 263, 19, 4, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-09-13' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-14' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-21' AS date), 1038, 3116, 13550, 13551, 13551, 13551, 13550, 13550, 13550, 2456190, 56189, N'2012-09-19', 201238, 38, 3, N'2012-W38', N'2012-W38-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94860, CAST(N'2012-09-20' AS date), CAST(N'2012-09-21' AS date), 2012, 20123, 201209, 2012264, 3, 9, 264, 20, 5, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-09-14' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-21' AS date), 1038, 3116, 13550, 13551, 13551, 13551, 13551, 13550, 13550, 2456191, 56190, N'2012-09-20', 201238, 38, 4, N'2012-W38', N'2012-W38-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94861, CAST(N'2012-09-21' AS date), CAST(N'2012-09-22' AS date), 2012, 20123, 201209, 2012265, 3, 9, 265, 21, 6, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-09-21' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-09-15' AS date), CAST(N'2012-09-21' AS date), 1038, 3116, 13550, 13551, 13551, 13551, 13551, 13551, 13550, 2456192, 56191, N'2012-09-21', 201238, 38, 5, N'2012-W38', N'2012-W38-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94862, CAST(N'2012-09-22' AS date), CAST(N'2012-09-23' AS date), 2012, 20123, 201209, 2012266, 3, 9, 266, 22, 7, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-16' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-09-21' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-28' AS date), 1038, 3116, 13550, 13551, 13551, 13551, 13551, 13551, 13551, 2456193, 56192, N'2012-09-22', 201238, 38, 6, N'2012-W38', N'2012-W38-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94863, CAST(N'2012-09-23' AS date), CAST(N'2012-09-24' AS date), 2012, 20123, 201209, 2012267, 3, 9, 267, 23, 1, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-09-17' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-09-21' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-28' AS date), 1038, 3116, 13551, 13551, 13551, 13551, 13551, 13551, 13551, 2456194, 56193, N'2012-09-23', 201238, 38, 7, N'2012-W38', N'2012-W38-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94864, CAST(N'2012-09-24' AS date), CAST(N'2012-09-25' AS date), 2012, 20123, 201209, 2012268, 3, 9, 268, 24, 2, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-18' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-09-21' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-28' AS date), 1038, 3116, 13551, 13552, 13551, 13551, 13551, 13551, 13551, 2456195, 56194, N'2012-09-24', 201239, 39, 1, N'2012-W39', N'2012-W39-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94865, CAST(N'2012-09-25' AS date), CAST(N'2012-09-26' AS date), 2012, 20123, 201209, 2012269, 3, 9, 269, 25, 3, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-09-19' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-09-21' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-28' AS date), 1038, 3116, 13551, 13552, 13552, 13551, 13551, 13551, 13551, 2456196, 56195, N'2012-09-25', 201239, 39, 2, N'2012-W39', N'2012-W39-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94866, CAST(N'2012-09-26' AS date), CAST(N'2012-09-27' AS date), 2012, 20123, 201209, 2012270, 3, 9, 270, 26, 4, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-09-20' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-09-21' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-28' AS date), 1038, 3116, 13551, 13552, 13552, 13552, 13551, 13551, 13551, 2456197, 56196, N'2012-09-26', 201239, 39, 3, N'2012-W39', N'2012-W39-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94867, CAST(N'2012-09-27' AS date), CAST(N'2012-09-28' AS date), 2012, 20123, 201209, 2012271, 3, 9, 271, 27, 5, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-09-21' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-28' AS date), 1038, 3116, 13551, 13552, 13552, 13552, 13552, 13551, 13551, 2456198, 56197, N'2012-09-27', 201239, 39, 4, N'2012-W39', N'2012-W39-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94868, CAST(N'2012-09-28' AS date), CAST(N'2012-09-29' AS date), 2012, 20123, 201209, 2012272, 3, 9, 272, 28, 6, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-09-28' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-09-22' AS date), CAST(N'2012-09-28' AS date), 1038, 3116, 13551, 13552, 13552, 13552, 13552, 13552, 13551, 2456199, 56198, N'2012-09-28', 201239, 39, 5, N'2012-W39', N'2012-W39-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94869, CAST(N'2012-09-29' AS date), CAST(N'2012-09-30' AS date), 2012, 20123, 201209, 2012273, 3, 9, 273, 29, 7, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-23' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-09-28' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-10-05' AS date), 1038, 3116, 13551, 13552, 13552, 13552, 13552, 13552, 13552, 2456200, 56199, N'2012-09-29', 201239, 39, 6, N'2012-W39', N'2012-W39-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94870, CAST(N'2012-09-30' AS date), CAST(N'2012-10-01' AS date), 2012, 20123, 201209, 2012274, 3, 9, 274, 30, 1, N'2012', N'2012 Q3', N'2012 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-07-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-01' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-09-24' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-09-28' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-10-05' AS date), 1038, 3116, 13552, 13552, 13552, 13552, 13552, 13552, 13552, 2456201, 56200, N'2012-09-30', 201239, 39, 7, N'2012-W39', N'2012-W39-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94871, CAST(N'2012-10-01' AS date), CAST(N'2012-10-02' AS date), 2012, 20124, 201210, 2012275, 4, 10, 275, 1, 2, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-09-25' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-09-28' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-10-05' AS date), 1039, 3117, 13552, 13553, 13552, 13552, 13552, 13552, 13552, 2456202, 56201, N'2012-10-01', 201240, 40, 1, N'2012-W40', N'2012-W40-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94872, CAST(N'2012-10-02' AS date), CAST(N'2012-10-03' AS date), 2012, 20124, 201210, 2012276, 4, 10, 276, 2, 3, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-09-26' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-09-28' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-10-05' AS date), 1039, 3117, 13552, 13553, 13553, 13552, 13552, 13552, 13552, 2456203, 56202, N'2012-10-02', 201240, 40, 2, N'2012-W40', N'2012-W40-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94873, CAST(N'2012-10-03' AS date), CAST(N'2012-10-04' AS date), 2012, 20124, 201210, 2012277, 4, 10, 277, 3, 4, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-09-27' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-09-28' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-10-05' AS date), 1039, 3117, 13552, 13553, 13553, 13553, 13552, 13552, 13552, 2456204, 56203, N'2012-10-03', 201240, 40, 3, N'2012-W40', N'2012-W40-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94874, CAST(N'2012-10-04' AS date), CAST(N'2012-10-05' AS date), 2012, 20124, 201210, 2012278, 4, 10, 278, 4, 5, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-09-28' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-10-05' AS date), 1039, 3117, 13552, 13553, 13553, 13553, 13553, 13552, 13552, 2456205, 56204, N'2012-10-04', 201240, 40, 4, N'2012-W40', N'2012-W40-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94875, CAST(N'2012-10-05' AS date), CAST(N'2012-10-06' AS date), 2012, 20124, 201210, 2012279, 4, 10, 279, 5, 6, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-05' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-09-29' AS date), CAST(N'2012-10-05' AS date), 1039, 3117, 13552, 13553, 13553, 13553, 13553, 13553, 13552, 2456206, 56205, N'2012-10-05', 201240, 40, 5, N'2012-W40', N'2012-W40-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94876, CAST(N'2012-10-06' AS date), CAST(N'2012-10-07' AS date), 2012, 20124, 201210, 2012280, 4, 10, 280, 6, 7, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-09-30' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-05' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-12' AS date), 1039, 3117, 13552, 13553, 13553, 13553, 13553, 13553, 13553, 2456207, 56206, N'2012-10-06', 201240, 40, 6, N'2012-W40', N'2012-W40-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94877, CAST(N'2012-10-07' AS date), CAST(N'2012-10-08' AS date), 2012, 20124, 201210, 2012281, 4, 10, 281, 7, 1, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-05' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-12' AS date), 1039, 3117, 13553, 13553, 13553, 13553, 13553, 13553, 13553, 2456208, 56207, N'2012-10-07', 201240, 40, 7, N'2012-W40', N'2012-W40-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94878, CAST(N'2012-10-08' AS date), CAST(N'2012-10-09' AS date), 2012, 20124, 201210, 2012282, 4, 10, 282, 8, 2, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-02' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-05' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-12' AS date), 1039, 3117, 13553, 13554, 13553, 13553, 13553, 13553, 13553, 2456209, 56208, N'2012-10-08', 201241, 41, 1, N'2012-W41', N'2012-W41-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94879, CAST(N'2012-10-09' AS date), CAST(N'2012-10-10' AS date), 2012, 20124, 201210, 2012283, 4, 10, 283, 9, 3, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-03' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-05' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-12' AS date), 1039, 3117, 13553, 13554, 13554, 13553, 13553, 13553, 13553, 2456210, 56209, N'2012-10-09', 201241, 41, 2, N'2012-W41', N'2012-W41-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94880, CAST(N'2012-10-10' AS date), CAST(N'2012-10-11' AS date), 2012, 20124, 201210, 2012284, 4, 10, 284, 10, 4, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-04' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-05' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-12' AS date), 1039, 3117, 13553, 13554, 13554, 13554, 13553, 13553, 13553, 2456211, 56210, N'2012-10-10', 201241, 41, 3, N'2012-W41', N'2012-W41-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94881, CAST(N'2012-10-11' AS date), CAST(N'2012-10-12' AS date), 2012, 20124, 201210, 2012285, 4, 10, 285, 11, 5, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-05' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-12' AS date), 1039, 3117, 13553, 13554, 13554, 13554, 13554, 13553, 13553, 2456212, 56211, N'2012-10-11', 201241, 41, 4, N'2012-W41', N'2012-W41-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94882, CAST(N'2012-10-12' AS date), CAST(N'2012-10-13' AS date), 2012, 20124, 201210, 2012286, 4, 10, 286, 12, 6, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-12' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-06' AS date), CAST(N'2012-10-12' AS date), 1039, 3117, 13553, 13554, 13554, 13554, 13554, 13554, 13553, 2456213, 56212, N'2012-10-12', 201241, 41, 5, N'2012-W41', N'2012-W41-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94883, CAST(N'2012-10-13' AS date), CAST(N'2012-10-14' AS date), 2012, 20124, 201210, 2012287, 4, 10, 287, 13, 7, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-07' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-12' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-19' AS date), 1039, 3117, 13553, 13554, 13554, 13554, 13554, 13554, 13554, 2456214, 56213, N'2012-10-13', 201241, 41, 6, N'2012-W41', N'2012-W41-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94884, CAST(N'2012-10-14' AS date), CAST(N'2012-10-15' AS date), 2012, 20124, 201210, 2012288, 4, 10, 288, 14, 1, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-08' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-12' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-19' AS date), 1039, 3117, 13554, 13554, 13554, 13554, 13554, 13554, 13554, 2456215, 56214, N'2012-10-14', 201241, 41, 7, N'2012-W41', N'2012-W41-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94885, CAST(N'2012-10-15' AS date), CAST(N'2012-10-16' AS date), 2012, 20124, 201210, 2012289, 4, 10, 289, 15, 2, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-09' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-12' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-19' AS date), 1039, 3117, 13554, 13555, 13554, 13554, 13554, 13554, 13554, 2456216, 56215, N'2012-10-15', 201242, 42, 1, N'2012-W42', N'2012-W42-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94886, CAST(N'2012-10-16' AS date), CAST(N'2012-10-17' AS date), 2012, 20124, 201210, 2012290, 4, 10, 290, 16, 3, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-10' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-12' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-19' AS date), 1039, 3117, 13554, 13555, 13555, 13554, 13554, 13554, 13554, 2456217, 56216, N'2012-10-16', 201242, 42, 2, N'2012-W42', N'2012-W42-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94887, CAST(N'2012-10-17' AS date), CAST(N'2012-10-18' AS date), 2012, 20124, 201210, 2012291, 4, 10, 291, 17, 4, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-11' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-12' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-19' AS date), 1039, 3117, 13554, 13555, 13555, 13555, 13554, 13554, 13554, 2456218, 56217, N'2012-10-17', 201242, 42, 3, N'2012-W42', N'2012-W42-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94888, CAST(N'2012-10-18' AS date), CAST(N'2012-10-19' AS date), 2012, 20124, 201210, 2012292, 4, 10, 292, 18, 5, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-12' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-19' AS date), 1039, 3117, 13554, 13555, 13555, 13555, 13555, 13554, 13554, 2456219, 56218, N'2012-10-18', 201242, 42, 4, N'2012-W42', N'2012-W42-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94889, CAST(N'2012-10-19' AS date), CAST(N'2012-10-20' AS date), 2012, 20124, 201210, 2012293, 4, 10, 293, 19, 6, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-19' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-13' AS date), CAST(N'2012-10-19' AS date), 1039, 3117, 13554, 13555, 13555, 13555, 13555, 13555, 13554, 2456220, 56219, N'2012-10-19', 201242, 42, 5, N'2012-W42', N'2012-W42-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94890, CAST(N'2012-10-20' AS date), CAST(N'2012-10-21' AS date), 2012, 20124, 201210, 2012294, 4, 10, 294, 20, 7, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-14' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-19' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-26' AS date), 1039, 3117, 13554, 13555, 13555, 13555, 13555, 13555, 13555, 2456221, 56220, N'2012-10-20', 201242, 42, 6, N'2012-W42', N'2012-W42-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94891, CAST(N'2012-10-21' AS date), CAST(N'2012-10-22' AS date), 2012, 20124, 201210, 2012295, 4, 10, 295, 21, 1, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-10-15' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-19' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-26' AS date), 1039, 3117, 13555, 13555, 13555, 13555, 13555, 13555, 13555, 2456222, 56221, N'2012-10-21', 201242, 42, 7, N'2012-W42', N'2012-W42-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94892, CAST(N'2012-10-22' AS date), CAST(N'2012-10-23' AS date), 2012, 20124, 201210, 2012296, 4, 10, 296, 22, 2, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-10-16' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-19' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-26' AS date), 1039, 3117, 13555, 13556, 13555, 13555, 13555, 13555, 13555, 2456223, 56222, N'2012-10-22', 201243, 43, 1, N'2012-W43', N'2012-W43-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94893, CAST(N'2012-10-23' AS date), CAST(N'2012-10-24' AS date), 2012, 20124, 201210, 2012297, 4, 10, 297, 23, 3, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-10-17' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-19' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-26' AS date), 1039, 3117, 13555, 13556, 13556, 13555, 13555, 13555, 13555, 2456224, 56223, N'2012-10-23', 201243, 43, 2, N'2012-W43', N'2012-W43-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94894, CAST(N'2012-10-24' AS date), CAST(N'2012-10-25' AS date), 2012, 20124, 201210, 2012298, 4, 10, 298, 24, 4, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-10-18' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-19' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-26' AS date), 1039, 3117, 13555, 13556, 13556, 13556, 13555, 13555, 13555, 2456225, 56224, N'2012-10-24', 201243, 43, 3, N'2012-W43', N'2012-W43-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94895, CAST(N'2012-10-25' AS date), CAST(N'2012-10-26' AS date), 2012, 20124, 201210, 2012299, 4, 10, 299, 25, 5, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-19' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-26' AS date), 1039, 3117, 13555, 13556, 13556, 13556, 13556, 13555, 13555, 2456226, 56225, N'2012-10-25', 201243, 43, 4, N'2012-W43', N'2012-W43-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94896, CAST(N'2012-10-26' AS date), CAST(N'2012-10-27' AS date), 2012, 20124, 201210, 2012300, 4, 10, 300, 26, 6, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-26' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-10-20' AS date), CAST(N'2012-10-26' AS date), 1039, 3117, 13555, 13556, 13556, 13556, 13556, 13556, 13555, 2456227, 56226, N'2012-10-26', 201243, 43, 5, N'2012-W43', N'2012-W43-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94897, CAST(N'2012-10-27' AS date), CAST(N'2012-10-28' AS date), 2012, 20124, 201210, 2012301, 4, 10, 301, 27, 7, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-21' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-26' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-11-02' AS date), 1039, 3117, 13555, 13556, 13556, 13556, 13556, 13556, 13556, 2456228, 56227, N'2012-10-27', 201243, 43, 6, N'2012-W43', N'2012-W43-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94898, CAST(N'2012-10-28' AS date), CAST(N'2012-10-29' AS date), 2012, 20124, 201210, 2012302, 4, 10, 302, 28, 1, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-10-22' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-26' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-11-02' AS date), 1039, 3117, 13556, 13556, 13556, 13556, 13556, 13556, 13556, 2456229, 56228, N'2012-10-28', 201243, 43, 7, N'2012-W43', N'2012-W43-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94899, CAST(N'2012-10-29' AS date), CAST(N'2012-10-30' AS date), 2012, 20124, 201210, 2012303, 4, 10, 303, 29, 2, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-10-23' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-26' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-11-02' AS date), 1039, 3117, 13556, 13557, 13556, 13556, 13556, 13556, 13556, 2456230, 56229, N'2012-10-29', 201244, 44, 1, N'2012-W44', N'2012-W44-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94900, CAST(N'2012-10-30' AS date), CAST(N'2012-10-31' AS date), 2012, 20124, 201210, 2012304, 4, 10, 304, 30, 3, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-10-24' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-26' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-11-02' AS date), 1039, 3117, 13556, 13557, 13557, 13556, 13556, 13556, 13556, 2456231, 56230, N'2012-10-30', 201244, 44, 2, N'2012-W44', N'2012-W44-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94901, CAST(N'2012-10-31' AS date), CAST(N'2012-11-01' AS date), 2012, 20124, 201210, 2012305, 4, 10, 305, 31, 4, N'2012', N'2012 Q4', N'2012 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-10-25' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-10-26' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-11-02' AS date), 1039, 3117, 13556, 13557, 13557, 13557, 13556, 13556, 13556, 2456232, 56231, N'2012-10-31', 201244, 44, 3, N'2012-W44', N'2012-W44-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94902, CAST(N'2012-11-01' AS date), CAST(N'2012-11-02' AS date), 2012, 20124, 201211, 2012306, 4, 11, 306, 1, 5, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-10-26' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-11-02' AS date), 1039, 3118, 13556, 13557, 13557, 13557, 13557, 13556, 13556, 2456233, 56232, N'2012-11-01', 201244, 44, 4, N'2012-W44', N'2012-W44-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94903, CAST(N'2012-11-02' AS date), CAST(N'2012-11-03' AS date), 2012, 20124, 201211, 2012307, 4, 11, 307, 2, 6, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-02' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-10-27' AS date), CAST(N'2012-11-02' AS date), 1039, 3118, 13556, 13557, 13557, 13557, 13557, 13557, 13556, 2456234, 56233, N'2012-11-02', 201244, 44, 5, N'2012-W44', N'2012-W44-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94904, CAST(N'2012-11-03' AS date), CAST(N'2012-11-04' AS date), 2012, 20124, 201211, 2012308, 4, 11, 308, 3, 7, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-10-28' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-02' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-11-09' AS date), 1039, 3118, 13556, 13557, 13557, 13557, 13557, 13557, 13557, 2456235, 56234, N'2012-11-03', 201244, 44, 6, N'2012-W44', N'2012-W44-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94905, CAST(N'2012-11-04' AS date), CAST(N'2012-11-05' AS date), 2012, 20124, 201211, 2012309, 4, 11, 309, 4, 1, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-10-29' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-02' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-11-09' AS date), 1039, 3118, 13557, 13557, 13557, 13557, 13557, 13557, 13557, 2456236, 56235, N'2012-11-04', 201244, 44, 7, N'2012-W44', N'2012-W44-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94906, CAST(N'2012-11-05' AS date), CAST(N'2012-11-06' AS date), 2012, 20124, 201211, 2012310, 4, 11, 310, 5, 2, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-10-30' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-02' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-11-09' AS date), 1039, 3118, 13557, 13558, 13557, 13557, 13557, 13557, 13557, 2456237, 56236, N'2012-11-05', 201245, 45, 1, N'2012-W45', N'2012-W45-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94907, CAST(N'2012-11-06' AS date), CAST(N'2012-11-07' AS date), 2012, 20124, 201211, 2012311, 4, 11, 311, 6, 3, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-10-31' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-02' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-11-09' AS date), 1039, 3118, 13557, 13558, 13558, 13557, 13557, 13557, 13557, 2456238, 56237, N'2012-11-06', 201245, 45, 2, N'2012-W45', N'2012-W45-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94908, CAST(N'2012-11-07' AS date), CAST(N'2012-11-08' AS date), 2012, 20124, 201211, 2012312, 4, 11, 312, 7, 4, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-02' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-11-09' AS date), 1039, 3118, 13557, 13558, 13558, 13558, 13557, 13557, 13557, 2456239, 56238, N'2012-11-07', 201245, 45, 3, N'2012-W45', N'2012-W45-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94909, CAST(N'2012-11-08' AS date), CAST(N'2012-11-09' AS date), 2012, 20124, 201211, 2012313, 4, 11, 313, 8, 5, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-02' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-11-09' AS date), 1039, 3118, 13557, 13558, 13558, 13558, 13558, 13557, 13557, 2456240, 56239, N'2012-11-08', 201245, 45, 4, N'2012-W45', N'2012-W45-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94910, CAST(N'2012-11-09' AS date), CAST(N'2012-11-10' AS date), 2012, 20124, 201211, 2012314, 4, 11, 314, 9, 6, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-09' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-03' AS date), CAST(N'2012-11-09' AS date), 1039, 3118, 13557, 13558, 13558, 13558, 13558, 13558, 13557, 2456241, 56240, N'2012-11-09', 201245, 45, 5, N'2012-W45', N'2012-W45-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94911, CAST(N'2012-11-10' AS date), CAST(N'2012-11-11' AS date), 2012, 20124, 201211, 2012315, 4, 11, 315, 10, 7, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-04' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-09' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-16' AS date), 1039, 3118, 13557, 13558, 13558, 13558, 13558, 13558, 13558, 2456242, 56241, N'2012-11-10', 201245, 45, 6, N'2012-W45', N'2012-W45-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94912, CAST(N'2012-11-11' AS date), CAST(N'2012-11-12' AS date), 2012, 20124, 201211, 2012316, 4, 11, 316, 11, 1, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-05' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-09' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-16' AS date), 1039, 3118, 13558, 13558, 13558, 13558, 13558, 13558, 13558, 2456243, 56242, N'2012-11-11', 201245, 45, 7, N'2012-W45', N'2012-W45-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94913, CAST(N'2012-11-12' AS date), CAST(N'2012-11-13' AS date), 2012, 20124, 201211, 2012317, 4, 11, 317, 12, 2, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-06' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-09' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-16' AS date), 1039, 3118, 13558, 13559, 13558, 13558, 13558, 13558, 13558, 2456244, 56243, N'2012-11-12', 201246, 46, 1, N'2012-W46', N'2012-W46-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94914, CAST(N'2012-11-13' AS date), CAST(N'2012-11-14' AS date), 2012, 20124, 201211, 2012318, 4, 11, 318, 13, 3, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-07' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-09' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-16' AS date), 1039, 3118, 13558, 13559, 13559, 13558, 13558, 13558, 13558, 2456245, 56244, N'2012-11-13', 201246, 46, 2, N'2012-W46', N'2012-W46-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94915, CAST(N'2012-11-14' AS date), CAST(N'2012-11-15' AS date), 2012, 20124, 201211, 2012319, 4, 11, 319, 14, 4, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-08' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-09' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-16' AS date), 1039, 3118, 13558, 13559, 13559, 13559, 13558, 13558, 13558, 2456246, 56245, N'2012-11-14', 201246, 46, 3, N'2012-W46', N'2012-W46-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94916, CAST(N'2012-11-15' AS date), CAST(N'2012-11-16' AS date), 2012, 20124, 201211, 2012320, 4, 11, 320, 15, 5, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-09' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-16' AS date), 1039, 3118, 13558, 13559, 13559, 13559, 13559, 13558, 13558, 2456247, 56246, N'2012-11-15', 201246, 46, 4, N'2012-W46', N'2012-W46-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94917, CAST(N'2012-11-16' AS date), CAST(N'2012-11-17' AS date), 2012, 20124, 201211, 2012321, 4, 11, 321, 16, 6, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-16' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-10' AS date), CAST(N'2012-11-16' AS date), 1039, 3118, 13558, 13559, 13559, 13559, 13559, 13559, 13558, 2456248, 56247, N'2012-11-16', 201246, 46, 5, N'2012-W46', N'2012-W46-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94918, CAST(N'2012-11-17' AS date), CAST(N'2012-11-18' AS date), 2012, 20124, 201211, 2012322, 4, 11, 322, 17, 7, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-11' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-16' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-23' AS date), 1039, 3118, 13558, 13559, 13559, 13559, 13559, 13559, 13559, 2456249, 56248, N'2012-11-17', 201246, 46, 6, N'2012-W46', N'2012-W46-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94919, CAST(N'2012-11-18' AS date), CAST(N'2012-11-19' AS date), 2012, 20124, 201211, 2012323, 4, 11, 323, 18, 1, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-12' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-16' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-23' AS date), 1039, 3118, 13559, 13559, 13559, 13559, 13559, 13559, 13559, 2456250, 56249, N'2012-11-18', 201246, 46, 7, N'2012-W46', N'2012-W46-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94920, CAST(N'2012-11-19' AS date), CAST(N'2012-11-20' AS date), 2012, 20124, 201211, 2012324, 4, 11, 324, 19, 2, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-11-13' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-16' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-23' AS date), 1039, 3118, 13559, 13560, 13559, 13559, 13559, 13559, 13559, 2456251, 56250, N'2012-11-19', 201247, 47, 1, N'2012-W47', N'2012-W47-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94921, CAST(N'2012-11-20' AS date), CAST(N'2012-11-21' AS date), 2012, 20124, 201211, 2012325, 4, 11, 325, 20, 3, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-11-14' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-16' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-23' AS date), 1039, 3118, 13559, 13560, 13560, 13559, 13559, 13559, 13559, 2456252, 56251, N'2012-11-20', 201247, 47, 2, N'2012-W47', N'2012-W47-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94922, CAST(N'2012-11-21' AS date), CAST(N'2012-11-22' AS date), 2012, 20124, 201211, 2012326, 4, 11, 326, 21, 4, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-11-15' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-16' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-23' AS date), 1039, 3118, 13559, 13560, 13560, 13560, 13559, 13559, 13559, 2456253, 56252, N'2012-11-21', 201247, 47, 3, N'2012-W47', N'2012-W47-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94923, CAST(N'2012-11-22' AS date), CAST(N'2012-11-23' AS date), 2012, 20124, 201211, 2012327, 4, 11, 327, 22, 5, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-11-16' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-23' AS date), 1039, 3118, 13559, 13560, 13560, 13560, 13560, 13559, 13559, 2456254, 56253, N'2012-11-22', 201247, 47, 4, N'2012-W47', N'2012-W47-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94924, CAST(N'2012-11-23' AS date), CAST(N'2012-11-24' AS date), 2012, 20124, 201211, 2012328, 4, 11, 328, 23, 6, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-11-23' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-11-17' AS date), CAST(N'2012-11-23' AS date), 1039, 3118, 13559, 13560, 13560, 13560, 13560, 13560, 13559, 2456255, 56254, N'2012-11-23', 201247, 47, 5, N'2012-W47', N'2012-W47-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94925, CAST(N'2012-11-24' AS date), CAST(N'2012-11-25' AS date), 2012, 20124, 201211, 2012329, 4, 11, 329, 24, 7, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-18' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-11-23' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-30' AS date), 1039, 3118, 13559, 13560, 13560, 13560, 13560, 13560, 13560, 2456256, 56255, N'2012-11-24', 201247, 47, 6, N'2012-W47', N'2012-W47-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94926, CAST(N'2012-11-25' AS date), CAST(N'2012-11-26' AS date), 2012, 20124, 201211, 2012330, 4, 11, 330, 25, 1, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-11-19' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-11-23' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-30' AS date), 1039, 3118, 13560, 13560, 13560, 13560, 13560, 13560, 13560, 2456257, 56256, N'2012-11-25', 201247, 47, 7, N'2012-W47', N'2012-W47-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94927, CAST(N'2012-11-26' AS date), CAST(N'2012-11-27' AS date), 2012, 20124, 201211, 2012331, 4, 11, 331, 26, 2, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-11-20' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-11-23' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-30' AS date), 1039, 3118, 13560, 13561, 13560, 13560, 13560, 13560, 13560, 2456258, 56257, N'2012-11-26', 201248, 48, 1, N'2012-W48', N'2012-W48-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94928, CAST(N'2012-11-27' AS date), CAST(N'2012-11-28' AS date), 2012, 20124, 201211, 2012332, 4, 11, 332, 27, 3, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-11-21' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-11-23' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-30' AS date), 1039, 3118, 13560, 13561, 13561, 13560, 13560, 13560, 13560, 2456259, 56258, N'2012-11-27', 201248, 48, 2, N'2012-W48', N'2012-W48-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94929, CAST(N'2012-11-28' AS date), CAST(N'2012-11-29' AS date), 2012, 20124, 201211, 2012333, 4, 11, 333, 28, 4, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-11-22' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-11-23' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-30' AS date), 1039, 3118, 13560, 13561, 13561, 13561, 13560, 13560, 13560, 2456260, 56259, N'2012-11-28', 201248, 48, 3, N'2012-W48', N'2012-W48-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94930, CAST(N'2012-11-29' AS date), CAST(N'2012-11-30' AS date), 2012, 20124, 201211, 2012334, 4, 11, 334, 29, 5, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-11-23' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-30' AS date), 1039, 3118, 13560, 13561, 13561, 13561, 13561, 13560, 13560, 2456261, 56260, N'2012-11-29', 201248, 48, 4, N'2012-W48', N'2012-W48-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94931, CAST(N'2012-11-30' AS date), CAST(N'2012-12-01' AS date), 2012, 20124, 201211, 2012335, 4, 11, 335, 30, 6, N'2012', N'2012 Q4', N'2012 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-01' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-11-24' AS date), CAST(N'2012-11-30' AS date), 1039, 3118, 13560, 13561, 13561, 13561, 13561, 13561, 13560, 2456262, 56261, N'2012-11-30', 201248, 48, 5, N'2012-W48', N'2012-W48-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94932, CAST(N'2012-12-01' AS date), CAST(N'2012-12-02' AS date), 2012, 20124, 201212, 2012336, 4, 12, 336, 1, 7, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-11-25' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-07' AS date), 1039, 3119, 13560, 13561, 13561, 13561, 13561, 13561, 13561, 2456263, 56262, N'2012-12-01', 201248, 48, 6, N'2012-W48', N'2012-W48-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94933, CAST(N'2012-12-02' AS date), CAST(N'2012-12-03' AS date), 2012, 20124, 201212, 2012337, 4, 12, 337, 2, 1, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-11-26' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-07' AS date), 1039, 3119, 13561, 13561, 13561, 13561, 13561, 13561, 13561, 2456264, 56263, N'2012-12-02', 201248, 48, 7, N'2012-W48', N'2012-W48-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94934, CAST(N'2012-12-03' AS date), CAST(N'2012-12-04' AS date), 2012, 20124, 201212, 2012338, 4, 12, 338, 3, 2, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-11-27' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-07' AS date), 1039, 3119, 13561, 13562, 13561, 13561, 13561, 13561, 13561, 2456265, 56264, N'2012-12-03', 201249, 49, 1, N'2012-W49', N'2012-W49-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94935, CAST(N'2012-12-04' AS date), CAST(N'2012-12-05' AS date), 2012, 20124, 201212, 2012339, 4, 12, 339, 4, 3, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-11-28' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-07' AS date), 1039, 3119, 13561, 13562, 13562, 13561, 13561, 13561, 13561, 2456266, 56265, N'2012-12-04', 201249, 49, 2, N'2012-W49', N'2012-W49-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94936, CAST(N'2012-12-05' AS date), CAST(N'2012-12-06' AS date), 2012, 20124, 201212, 2012340, 4, 12, 340, 5, 4, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-11-29' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-07' AS date), 1039, 3119, 13561, 13562, 13562, 13562, 13561, 13561, 13561, 2456267, 56266, N'2012-12-05', 201249, 49, 3, N'2012-W49', N'2012-W49-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94937, CAST(N'2012-12-06' AS date), CAST(N'2012-12-07' AS date), 2012, 20124, 201212, 2012341, 4, 12, 341, 6, 5, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-11-30' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-07' AS date), 1039, 3119, 13561, 13562, 13562, 13562, 13562, 13561, 13561, 2456268, 56267, N'2012-12-06', 201249, 49, 4, N'2012-W49', N'2012-W49-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94938, CAST(N'2012-12-07' AS date), CAST(N'2012-12-08' AS date), 2012, 20124, 201212, 2012342, 4, 12, 342, 7, 6, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-07' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-07' AS date), 1039, 3119, 13561, 13562, 13562, 13562, 13562, 13562, 13561, 2456269, 56268, N'2012-12-07', 201249, 49, 5, N'2012-W49', N'2012-W49-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94939, CAST(N'2012-12-08' AS date), CAST(N'2012-12-09' AS date), 2012, 20124, 201212, 2012343, 4, 12, 343, 8, 7, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-02' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-07' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-14' AS date), 1039, 3119, 13561, 13562, 13562, 13562, 13562, 13562, 13562, 2456270, 56269, N'2012-12-08', 201249, 49, 6, N'2012-W49', N'2012-W49-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94940, CAST(N'2012-12-09' AS date), CAST(N'2012-12-10' AS date), 2012, 20124, 201212, 2012344, 4, 12, 344, 9, 1, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-03' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-07' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-14' AS date), 1039, 3119, 13562, 13562, 13562, 13562, 13562, 13562, 13562, 2456271, 56270, N'2012-12-09', 201249, 49, 7, N'2012-W49', N'2012-W49-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94941, CAST(N'2012-12-10' AS date), CAST(N'2012-12-11' AS date), 2012, 20124, 201212, 2012345, 4, 12, 345, 10, 2, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-04' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-07' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-14' AS date), 1039, 3119, 13562, 13563, 13562, 13562, 13562, 13562, 13562, 2456272, 56271, N'2012-12-10', 201250, 50, 1, N'2012-W50', N'2012-W50-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94942, CAST(N'2012-12-11' AS date), CAST(N'2012-12-12' AS date), 2012, 20124, 201212, 2012346, 4, 12, 346, 11, 3, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-05' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-07' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-14' AS date), 1039, 3119, 13562, 13563, 13563, 13562, 13562, 13562, 13562, 2456273, 56272, N'2012-12-11', 201250, 50, 2, N'2012-W50', N'2012-W50-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94943, CAST(N'2012-12-12' AS date), CAST(N'2012-12-13' AS date), 2012, 20124, 201212, 2012347, 4, 12, 347, 12, 4, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-06' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-07' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-14' AS date), 1039, 3119, 13562, 13563, 13563, 13563, 13562, 13562, 13562, 2456274, 56273, N'2012-12-12', 201250, 50, 3, N'2012-W50', N'2012-W50-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94944, CAST(N'2012-12-13' AS date), CAST(N'2012-12-14' AS date), 2012, 20124, 201212, 2012348, 4, 12, 348, 13, 5, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-07' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-14' AS date), 1039, 3119, 13562, 13563, 13563, 13563, 13563, 13562, 13562, 2456275, 56274, N'2012-12-13', 201250, 50, 4, N'2012-W50', N'2012-W50-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94945, CAST(N'2012-12-14' AS date), CAST(N'2012-12-15' AS date), 2012, 20124, 201212, 2012349, 4, 12, 349, 14, 6, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-14' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-08' AS date), CAST(N'2012-12-14' AS date), 1039, 3119, 13562, 13563, 13563, 13563, 13563, 13563, 13562, 2456276, 56275, N'2012-12-14', 201250, 50, 5, N'2012-W50', N'2012-W50-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94946, CAST(N'2012-12-15' AS date), CAST(N'2012-12-16' AS date), 2012, 20124, 201212, 2012350, 4, 12, 350, 15, 7, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-09' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-14' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-21' AS date), 1039, 3119, 13562, 13563, 13563, 13563, 13563, 13563, 13563, 2456277, 56276, N'2012-12-15', 201250, 50, 6, N'2012-W50', N'2012-W50-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94947, CAST(N'2012-12-16' AS date), CAST(N'2012-12-17' AS date), 2012, 20124, 201212, 2012351, 4, 12, 351, 16, 1, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-10' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-14' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-21' AS date), 1039, 3119, 13563, 13563, 13563, 13563, 13563, 13563, 13563, 2456278, 56277, N'2012-12-16', 201250, 50, 7, N'2012-W50', N'2012-W50-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94948, CAST(N'2012-12-17' AS date), CAST(N'2012-12-18' AS date), 2012, 20124, 201212, 2012352, 4, 12, 352, 17, 2, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-11' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-14' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-21' AS date), 1039, 3119, 13563, 13564, 13563, 13563, 13563, 13563, 13563, 2456279, 56278, N'2012-12-17', 201251, 51, 1, N'2012-W51', N'2012-W51-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94949, CAST(N'2012-12-18' AS date), CAST(N'2012-12-19' AS date), 2012, 20124, 201212, 2012353, 4, 12, 353, 18, 3, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-12' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-14' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-21' AS date), 1039, 3119, 13563, 13564, 13564, 13563, 13563, 13563, 13563, 2456280, 56279, N'2012-12-18', 201251, 51, 2, N'2012-W51', N'2012-W51-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94950, CAST(N'2012-12-19' AS date), CAST(N'2012-12-20' AS date), 2012, 20124, 201212, 2012354, 4, 12, 354, 19, 4, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-13' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-14' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-21' AS date), 1039, 3119, 13563, 13564, 13564, 13564, 13563, 13563, 13563, 2456281, 56280, N'2012-12-19', 201251, 51, 3, N'2012-W51', N'2012-W51-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94951, CAST(N'2012-12-20' AS date), CAST(N'2012-12-21' AS date), 2012, 20124, 201212, 2012355, 4, 12, 355, 20, 5, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-26' AS date), CAST(N'2012-12-14' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-21' AS date), 1039, 3119, 13563, 13564, 13564, 13564, 13564, 13563, 13563, 2456282, 56281, N'2012-12-20', 201251, 51, 4, N'2012-W51', N'2012-W51-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94952, CAST(N'2012-12-21' AS date), CAST(N'2012-12-22' AS date), 2012, 20124, 201212, 2012356, 4, 12, 356, 21, 6, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-26' AS date), CAST(N'2012-12-21' AS date), CAST(N'2012-12-27' AS date), CAST(N'2012-12-15' AS date), CAST(N'2012-12-21' AS date), 1039, 3119, 13563, 13564, 13564, 13564, 13564, 13564, 13563, 2456283, 56282, N'2012-12-21', 201251, 51, 5, N'2012-W51', N'2012-W51-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94953, CAST(N'2012-12-22' AS date), CAST(N'2012-12-23' AS date), 2012, 20124, 201212, 2012357, 4, 12, 357, 22, 7, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-16' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-26' AS date), CAST(N'2012-12-21' AS date), CAST(N'2012-12-27' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-28' AS date), 1039, 3119, 13563, 13564, 13564, 13564, 13564, 13564, 13564, 2456284, 56283, N'2012-12-22', 201251, 51, 6, N'2012-W51', N'2012-W51-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94954, CAST(N'2012-12-23' AS date), CAST(N'2012-12-24' AS date), 2012, 20124, 201212, 2012358, 4, 12, 358, 23, 1, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-29' AS date), CAST(N'2012-12-17' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-26' AS date), CAST(N'2012-12-21' AS date), CAST(N'2012-12-27' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-28' AS date), 1039, 3119, 13564, 13564, 13564, 13564, 13564, 13564, 13564, 2456285, 56284, N'2012-12-23', 201251, 51, 7, N'2012-W51', N'2012-W51-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94955, CAST(N'2012-12-24' AS date), CAST(N'2012-12-25' AS date), 2012, 20124, 201212, 2012359, 4, 12, 359, 24, 2, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-29' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-30' AS date), CAST(N'2012-12-18' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-26' AS date), CAST(N'2012-12-21' AS date), CAST(N'2012-12-27' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-28' AS date), 1039, 3119, 13564, 13565, 13564, 13564, 13564, 13564, 13564, 2456286, 56285, N'2012-12-24', 201252, 52, 1, N'2012-W52', N'2012-W52-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94956, CAST(N'2012-12-25' AS date), CAST(N'2012-12-26' AS date), 2012, 20124, 201212, 2012360, 4, 12, 360, 25, 3, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-29' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-30' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-19' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-26' AS date), CAST(N'2012-12-21' AS date), CAST(N'2012-12-27' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-28' AS date), 1039, 3119, 13564, 13565, 13565, 13564, 13564, 13564, 13564, 2456287, 56286, N'2012-12-25', 201252, 52, 2, N'2012-W52', N'2012-W52-2');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94957, CAST(N'2012-12-26' AS date), CAST(N'2012-12-27' AS date), 2012, 20124, 201212, 2012361, 4, 12, 361, 26, 4, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-29' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-30' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-26' AS date), CAST(N'2013-01-01' AS date), CAST(N'2012-12-20' AS date), CAST(N'2012-12-26' AS date), CAST(N'2012-12-21' AS date), CAST(N'2012-12-27' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-28' AS date), 1039, 3119, 13564, 13565, 13565, 13565, 13564, 13564, 13564, 2456288, 56287, N'2012-12-26', 201252, 52, 3, N'2012-W52', N'2012-W52-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94958, CAST(N'2012-12-27' AS date), CAST(N'2012-12-28' AS date), 2012, 20124, 201212, 2012362, 4, 12, 362, 27, 5, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-29' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-30' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-26' AS date), CAST(N'2013-01-01' AS date), CAST(N'2012-12-27' AS date), CAST(N'2013-01-02' AS date), CAST(N'2012-12-21' AS date), CAST(N'2012-12-27' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-28' AS date), 1039, 3119, 13564, 13565, 13565, 13565, 13565, 13564, 13564, 2456289, 56288, N'2012-12-27', 201252, 52, 4, N'2012-W52', N'2012-W52-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94959, CAST(N'2012-12-28' AS date), CAST(N'2012-12-29' AS date), 2012, 20124, 201212, 2012363, 4, 12, 363, 28, 6, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-29' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-30' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-26' AS date), CAST(N'2013-01-01' AS date), CAST(N'2012-12-27' AS date), CAST(N'2013-01-02' AS date), CAST(N'2012-12-28' AS date), CAST(N'2013-01-03' AS date), CAST(N'2012-12-22' AS date), CAST(N'2012-12-28' AS date), 1039, 3119, 13564, 13565, 13565, 13565, 13565, 13565, 13564, 2456290, 56289, N'2012-12-28', 201252, 52, 5, N'2012-W52', N'2012-W52-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94960, CAST(N'2012-12-29' AS date), CAST(N'2012-12-30' AS date), 2012, 20124, 201212, 2012364, 4, 12, 364, 29, 7, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-23' AS date), CAST(N'2012-12-29' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-30' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-26' AS date), CAST(N'2013-01-01' AS date), CAST(N'2012-12-27' AS date), CAST(N'2013-01-02' AS date), CAST(N'2012-12-28' AS date), CAST(N'2013-01-03' AS date), CAST(N'2012-12-29' AS date), CAST(N'2013-01-04' AS date), 1039, 3119, 13564, 13565, 13565, 13565, 13565, 13565, 13565, 2456291, 56290, N'2012-12-29', 201252, 52, 6, N'2012-W52', N'2012-W52-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94961, CAST(N'2012-12-30' AS date), CAST(N'2012-12-31' AS date), 2012, 20124, 201212, 2012365, 4, 12, 365, 30, 1, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-30' AS date), CAST(N'2013-01-05' AS date), CAST(N'2012-12-24' AS date), CAST(N'2012-12-30' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-26' AS date), CAST(N'2013-01-01' AS date), CAST(N'2012-12-27' AS date), CAST(N'2013-01-02' AS date), CAST(N'2012-12-28' AS date), CAST(N'2013-01-03' AS date), CAST(N'2012-12-29' AS date), CAST(N'2013-01-04' AS date), 1039, 3119, 13565, 13565, 13565, 13565, 13565, 13565, 13565, 2456292, 56291, N'2012-12-30', 201252, 52, 7, N'2012-W52', N'2012-W52-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94962, CAST(N'2012-12-31' AS date), CAST(N'2013-01-01' AS date), 2012, 20124, 201212, 2012366, 4, 12, 366, 31, 2, N'2012', N'2012 Q4', N'2012 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2012-01-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-10-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-01' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-30' AS date), CAST(N'2013-01-05' AS date), CAST(N'2012-12-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2012-12-25' AS date), CAST(N'2012-12-31' AS date), CAST(N'2012-12-26' AS date), CAST(N'2013-01-01' AS date), CAST(N'2012-12-27' AS date), CAST(N'2013-01-02' AS date), CAST(N'2012-12-28' AS date), CAST(N'2013-01-03' AS date), CAST(N'2012-12-29' AS date), CAST(N'2013-01-04' AS date), 1039, 3119, 13565, 13566, 13565, 13565, 13565, 13565, 13565, 2456293, 56292, N'2012-12-31', 201301, 1, 1, N'2013-W01', N'2013-W01-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94963, CAST(N'2013-01-01' AS date), CAST(N'2013-01-02' AS date), 2013, 20131, 201301, 2013001, 1, 1, 1, 1, 3, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2012-12-30' AS date), CAST(N'2013-01-05' AS date), CAST(N'2012-12-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-07' AS date), CAST(N'2012-12-26' AS date), CAST(N'2013-01-01' AS date), CAST(N'2012-12-27' AS date), CAST(N'2013-01-02' AS date), CAST(N'2012-12-28' AS date), CAST(N'2013-01-03' AS date), CAST(N'2012-12-29' AS date), CAST(N'2013-01-04' AS date), 1040, 3120, 13565, 13566, 13566, 13565, 13565, 13565, 13565, 2456294, 56293, N'2013-01-01', 201301, 1, 2, N'2013-W01', N'2013-W01-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94964, CAST(N'2013-01-02' AS date), CAST(N'2013-01-03' AS date), 2013, 20131, 201301, 2013002, 1, 1, 2, 2, 4, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2012-12-30' AS date), CAST(N'2013-01-05' AS date), CAST(N'2012-12-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-02' AS date), CAST(N'2013-01-08' AS date), CAST(N'2012-12-27' AS date), CAST(N'2013-01-02' AS date), CAST(N'2012-12-28' AS date), CAST(N'2013-01-03' AS date), CAST(N'2012-12-29' AS date), CAST(N'2013-01-04' AS date), 1040, 3120, 13565, 13566, 13566, 13566, 13565, 13565, 13565, 2456295, 56294, N'2013-01-02', 201301, 1, 3, N'2013-W01', N'2013-W01-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94965, CAST(N'2013-01-03' AS date), CAST(N'2013-01-04' AS date), 2013, 20131, 201301, 2013003, 1, 1, 3, 3, 5, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2012-12-30' AS date), CAST(N'2013-01-05' AS date), CAST(N'2012-12-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-02' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-03' AS date), CAST(N'2013-01-09' AS date), CAST(N'2012-12-28' AS date), CAST(N'2013-01-03' AS date), CAST(N'2012-12-29' AS date), CAST(N'2013-01-04' AS date), 1040, 3120, 13565, 13566, 13566, 13566, 13566, 13565, 13565, 2456296, 56295, N'2013-01-03', 201301, 1, 4, N'2013-W01', N'2013-W01-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94966, CAST(N'2013-01-04' AS date), CAST(N'2013-01-05' AS date), 2013, 20131, 201301, 2013004, 1, 1, 4, 4, 6, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2012-12-30' AS date), CAST(N'2013-01-05' AS date), CAST(N'2012-12-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-02' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-03' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-04' AS date), CAST(N'2013-01-10' AS date), CAST(N'2012-12-29' AS date), CAST(N'2013-01-04' AS date), 1040, 3120, 13565, 13566, 13566, 13566, 13566, 13566, 13565, 2456297, 56296, N'2013-01-04', 201301, 1, 5, N'2013-W01', N'2013-W01-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94967, CAST(N'2013-01-05' AS date), CAST(N'2013-01-06' AS date), 2013, 20131, 201301, 2013005, 1, 1, 5, 5, 7, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2012-12-30' AS date), CAST(N'2013-01-05' AS date), CAST(N'2012-12-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-02' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-03' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-04' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-05' AS date), CAST(N'2013-01-11' AS date), 1040, 3120, 13565, 13566, 13566, 13566, 13566, 13566, 13566, 2456298, 56297, N'2013-01-05', 201301, 1, 6, N'2013-W01', N'2013-W01-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94968, CAST(N'2013-01-06' AS date), CAST(N'2013-01-07' AS date), 2013, 20131, 201301, 2013006, 1, 1, 6, 6, 1, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-12' AS date), CAST(N'2012-12-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-02' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-03' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-04' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-05' AS date), CAST(N'2013-01-11' AS date), 1040, 3120, 13566, 13566, 13566, 13566, 13566, 13566, 13566, 2456299, 56298, N'2013-01-06', 201301, 1, 7, N'2013-W01', N'2013-W01-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94969, CAST(N'2013-01-07' AS date), CAST(N'2013-01-08' AS date), 2013, 20131, 201301, 2013007, 1, 1, 7, 7, 2, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-02' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-03' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-04' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-05' AS date), CAST(N'2013-01-11' AS date), 1040, 3120, 13566, 13567, 13566, 13566, 13566, 13566, 13566, 2456300, 56299, N'2013-01-07', 201302, 2, 1, N'2013-W02', N'2013-W02-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94970, CAST(N'2013-01-08' AS date), CAST(N'2013-01-09' AS date), 2013, 20131, 201301, 2013008, 1, 1, 8, 8, 3, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-02' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-03' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-04' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-05' AS date), CAST(N'2013-01-11' AS date), 1040, 3120, 13566, 13567, 13567, 13566, 13566, 13566, 13566, 2456301, 56300, N'2013-01-08', 201302, 2, 2, N'2013-W02', N'2013-W02-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94971, CAST(N'2013-01-09' AS date), CAST(N'2013-01-10' AS date), 2013, 20131, 201301, 2013009, 1, 1, 9, 9, 4, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-03' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-04' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-05' AS date), CAST(N'2013-01-11' AS date), 1040, 3120, 13566, 13567, 13567, 13567, 13566, 13566, 13566, 2456302, 56301, N'2013-01-09', 201302, 2, 3, N'2013-W02', N'2013-W02-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94972, CAST(N'2013-01-10' AS date), CAST(N'2013-01-11' AS date), 2013, 20131, 201301, 2013010, 1, 1, 10, 10, 5, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-04' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-05' AS date), CAST(N'2013-01-11' AS date), 1040, 3120, 13566, 13567, 13567, 13567, 13567, 13566, 13566, 2456303, 56302, N'2013-01-10', 201302, 2, 4, N'2013-W02', N'2013-W02-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94973, CAST(N'2013-01-11' AS date), CAST(N'2013-01-12' AS date), 2013, 20131, 201301, 2013011, 1, 1, 11, 11, 6, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-11' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-05' AS date), CAST(N'2013-01-11' AS date), 1040, 3120, 13566, 13567, 13567, 13567, 13567, 13567, 13566, 2456304, 56303, N'2013-01-11', 201302, 2, 5, N'2013-W02', N'2013-W02-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94974, CAST(N'2013-01-12' AS date), CAST(N'2013-01-13' AS date), 2013, 20131, 201301, 2013012, 1, 1, 12, 12, 7, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-06' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-11' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-18' AS date), 1040, 3120, 13566, 13567, 13567, 13567, 13567, 13567, 13567, 2456305, 56304, N'2013-01-12', 201302, 2, 6, N'2013-W02', N'2013-W02-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94975, CAST(N'2013-01-13' AS date), CAST(N'2013-01-14' AS date), 2013, 20131, 201301, 2013013, 1, 1, 13, 13, 1, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-07' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-11' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-18' AS date), 1040, 3120, 13567, 13567, 13567, 13567, 13567, 13567, 13567, 2456306, 56305, N'2013-01-13', 201302, 2, 7, N'2013-W02', N'2013-W02-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94976, CAST(N'2013-01-14' AS date), CAST(N'2013-01-15' AS date), 2013, 20131, 201301, 2013014, 1, 1, 14, 14, 2, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-08' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-11' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-18' AS date), 1040, 3120, 13567, 13568, 13567, 13567, 13567, 13567, 13567, 2456307, 56306, N'2013-01-14', 201303, 3, 1, N'2013-W03', N'2013-W03-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94977, CAST(N'2013-01-15' AS date), CAST(N'2013-01-16' AS date), 2013, 20131, 201301, 2013015, 1, 1, 15, 15, 3, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-09' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-11' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-18' AS date), 1040, 3120, 13567, 13568, 13568, 13567, 13567, 13567, 13567, 2456308, 56307, N'2013-01-15', 201303, 3, 2, N'2013-W03', N'2013-W03-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94978, CAST(N'2013-01-16' AS date), CAST(N'2013-01-17' AS date), 2013, 20131, 201301, 2013016, 1, 1, 16, 16, 4, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-10' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-11' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-18' AS date), 1040, 3120, 13567, 13568, 13568, 13568, 13567, 13567, 13567, 2456309, 56308, N'2013-01-16', 201303, 3, 3, N'2013-W03', N'2013-W03-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94979, CAST(N'2013-01-17' AS date), CAST(N'2013-01-18' AS date), 2013, 20131, 201301, 2013017, 1, 1, 17, 17, 5, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-11' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-18' AS date), 1040, 3120, 13567, 13568, 13568, 13568, 13568, 13567, 13567, 2456310, 56309, N'2013-01-17', 201303, 3, 4, N'2013-W03', N'2013-W03-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94980, CAST(N'2013-01-18' AS date), CAST(N'2013-01-19' AS date), 2013, 20131, 201301, 2013018, 1, 1, 18, 18, 6, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-18' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-12' AS date), CAST(N'2013-01-18' AS date), 1040, 3120, 13567, 13568, 13568, 13568, 13568, 13568, 13567, 2456311, 56310, N'2013-01-18', 201303, 3, 5, N'2013-W03', N'2013-W03-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94981, CAST(N'2013-01-19' AS date), CAST(N'2013-01-20' AS date), 2013, 20131, 201301, 2013019, 1, 1, 19, 19, 7, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-13' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-18' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-25' AS date), 1040, 3120, 13567, 13568, 13568, 13568, 13568, 13568, 13568, 2456312, 56311, N'2013-01-19', 201303, 3, 6, N'2013-W03', N'2013-W03-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94982, CAST(N'2013-01-20' AS date), CAST(N'2013-01-21' AS date), 2013, 20131, 201301, 2013020, 1, 1, 20, 20, 1, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-01-14' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-18' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-25' AS date), 1040, 3120, 13568, 13568, 13568, 13568, 13568, 13568, 13568, 2456313, 56312, N'2013-01-20', 201303, 3, 7, N'2013-W03', N'2013-W03-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94983, CAST(N'2013-01-21' AS date), CAST(N'2013-01-22' AS date), 2013, 20131, 201301, 2013021, 1, 1, 21, 21, 2, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-01-15' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-18' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-25' AS date), 1040, 3120, 13568, 13569, 13568, 13568, 13568, 13568, 13568, 2456314, 56313, N'2013-01-21', 201304, 4, 1, N'2013-W04', N'2013-W04-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94984, CAST(N'2013-01-22' AS date), CAST(N'2013-01-23' AS date), 2013, 20131, 201301, 2013022, 1, 1, 22, 22, 3, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-01-16' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-18' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-25' AS date), 1040, 3120, 13568, 13569, 13569, 13568, 13568, 13568, 13568, 2456315, 56314, N'2013-01-22', 201304, 4, 2, N'2013-W04', N'2013-W04-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94985, CAST(N'2013-01-23' AS date), CAST(N'2013-01-24' AS date), 2013, 20131, 201301, 2013023, 1, 1, 23, 23, 4, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-01-17' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-18' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-25' AS date), 1040, 3120, 13568, 13569, 13569, 13569, 13568, 13568, 13568, 2456316, 56315, N'2013-01-23', 201304, 4, 3, N'2013-W04', N'2013-W04-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94986, CAST(N'2013-01-24' AS date), CAST(N'2013-01-25' AS date), 2013, 20131, 201301, 2013024, 1, 1, 24, 24, 5, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-01-18' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-25' AS date), 1040, 3120, 13568, 13569, 13569, 13569, 13569, 13568, 13568, 2456317, 56316, N'2013-01-24', 201304, 4, 4, N'2013-W04', N'2013-W04-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94987, CAST(N'2013-01-25' AS date), CAST(N'2013-01-26' AS date), 2013, 20131, 201301, 2013025, 1, 1, 25, 25, 6, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-01-25' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-19' AS date), CAST(N'2013-01-25' AS date), 1040, 3120, 13568, 13569, 13569, 13569, 13569, 13569, 13568, 2456318, 56317, N'2013-01-25', 201304, 4, 5, N'2013-W04', N'2013-W04-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94988, CAST(N'2013-01-26' AS date), CAST(N'2013-01-27' AS date), 2013, 20131, 201301, 2013026, 1, 1, 26, 26, 7, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-20' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-01-25' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-02-01' AS date), 1040, 3120, 13568, 13569, 13569, 13569, 13569, 13569, 13569, 2456319, 56318, N'2013-01-26', 201304, 4, 6, N'2013-W04', N'2013-W04-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94989, CAST(N'2013-01-27' AS date), CAST(N'2013-01-28' AS date), 2013, 20131, 201301, 2013027, 1, 1, 27, 27, 1, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-01-21' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-01-25' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-02-01' AS date), 1040, 3120, 13569, 13569, 13569, 13569, 13569, 13569, 13569, 2456320, 56319, N'2013-01-27', 201304, 4, 7, N'2013-W04', N'2013-W04-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94990, CAST(N'2013-01-28' AS date), CAST(N'2013-01-29' AS date), 2013, 20131, 201301, 2013028, 1, 1, 28, 28, 2, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-01-22' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-01-25' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-02-01' AS date), 1040, 3120, 13569, 13570, 13569, 13569, 13569, 13569, 13569, 2456321, 56320, N'2013-01-28', 201305, 5, 1, N'2013-W05', N'2013-W05-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94991, CAST(N'2013-01-29' AS date), CAST(N'2013-01-30' AS date), 2013, 20131, 201301, 2013029, 1, 1, 29, 29, 3, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-01-23' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-01-25' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-02-01' AS date), 1040, 3120, 13569, 13570, 13570, 13569, 13569, 13569, 13569, 2456322, 56321, N'2013-01-29', 201305, 5, 2, N'2013-W05', N'2013-W05-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94992, CAST(N'2013-01-30' AS date), CAST(N'2013-01-31' AS date), 2013, 20131, 201301, 2013030, 1, 1, 30, 30, 4, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-01-24' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-01-25' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-02-01' AS date), 1040, 3120, 13569, 13570, 13570, 13570, 13569, 13569, 13569, 2456323, 56322, N'2013-01-30', 201305, 5, 3, N'2013-W05', N'2013-W05-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94993, CAST(N'2013-01-31' AS date), CAST(N'2013-02-01' AS date), 2013, 20131, 201301, 2013031, 1, 1, 31, 31, 5, N'2013', N'2013 Q1', N'2013 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-01-25' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-02-01' AS date), 1040, 3120, 13569, 13570, 13570, 13570, 13570, 13569, 13569, 2456324, 56323, N'2013-01-31', 201305, 5, 4, N'2013-W05', N'2013-W05-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94994, CAST(N'2013-02-01' AS date), CAST(N'2013-02-02' AS date), 2013, 20131, 201302, 2013032, 1, 2, 32, 1, 6, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-01-26' AS date), CAST(N'2013-02-01' AS date), 1040, 3121, 13569, 13570, 13570, 13570, 13570, 13570, 13569, 2456325, 56324, N'2013-02-01', 201305, 5, 5, N'2013-W05', N'2013-W05-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94995, CAST(N'2013-02-02' AS date), CAST(N'2013-02-03' AS date), 2013, 20131, 201302, 2013033, 1, 2, 33, 2, 7, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-01-27' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-02-08' AS date), 1040, 3121, 13569, 13570, 13570, 13570, 13570, 13570, 13570, 2456326, 56325, N'2013-02-02', 201305, 5, 6, N'2013-W05', N'2013-W05-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94996, CAST(N'2013-02-03' AS date), CAST(N'2013-02-04' AS date), 2013, 20131, 201302, 2013034, 1, 2, 34, 3, 1, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-01-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-02-08' AS date), 1040, 3121, 13570, 13570, 13570, 13570, 13570, 13570, 13570, 2456327, 56326, N'2013-02-03', 201305, 5, 7, N'2013-W05', N'2013-W05-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94997, CAST(N'2013-02-04' AS date), CAST(N'2013-02-05' AS date), 2013, 20131, 201302, 2013035, 1, 2, 35, 4, 2, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-01-29' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-02-08' AS date), 1040, 3121, 13570, 13571, 13570, 13570, 13570, 13570, 13570, 2456328, 56327, N'2013-02-04', 201306, 6, 1, N'2013-W06', N'2013-W06-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94998, CAST(N'2013-02-05' AS date), CAST(N'2013-02-06' AS date), 2013, 20131, 201302, 2013036, 1, 2, 36, 5, 3, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-01-30' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-02-08' AS date), 1040, 3121, 13570, 13571, 13571, 13570, 13570, 13570, 13570, 2456329, 56328, N'2013-02-05', 201306, 6, 2, N'2013-W06', N'2013-W06-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (94999, CAST(N'2013-02-06' AS date), CAST(N'2013-02-07' AS date), 2013, 20131, 201302, 2013037, 1, 2, 37, 6, 4, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-01-31' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-02-08' AS date), 1040, 3121, 13570, 13571, 13571, 13571, 13570, 13570, 13570, 2456330, 56329, N'2013-02-06', 201306, 6, 3, N'2013-W06', N'2013-W06-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95000, CAST(N'2013-02-07' AS date), CAST(N'2013-02-08' AS date), 2013, 20131, 201302, 2013038, 1, 2, 38, 7, 5, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-02-08' AS date), 1040, 3121, 13570, 13571, 13571, 13571, 13571, 13570, 13570, 2456331, 56330, N'2013-02-07', 201306, 6, 4, N'2013-W06', N'2013-W06-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95001, CAST(N'2013-02-08' AS date), CAST(N'2013-02-09' AS date), 2013, 20131, 201302, 2013039, 1, 2, 39, 8, 6, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-08' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-02' AS date), CAST(N'2013-02-08' AS date), 1040, 3121, 13570, 13571, 13571, 13571, 13571, 13571, 13570, 2456332, 56331, N'2013-02-08', 201306, 6, 5, N'2013-W06', N'2013-W06-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95002, CAST(N'2013-02-09' AS date), CAST(N'2013-02-10' AS date), 2013, 20131, 201302, 2013040, 1, 2, 40, 9, 7, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-03' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-08' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-15' AS date), 1040, 3121, 13570, 13571, 13571, 13571, 13571, 13571, 13571, 2456333, 56332, N'2013-02-09', 201306, 6, 6, N'2013-W06', N'2013-W06-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95003, CAST(N'2013-02-10' AS date), CAST(N'2013-02-11' AS date), 2013, 20131, 201302, 2013041, 1, 2, 41, 10, 1, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-04' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-08' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-15' AS date), 1040, 3121, 13571, 13571, 13571, 13571, 13571, 13571, 13571, 2456334, 56333, N'2013-02-10', 201306, 6, 7, N'2013-W06', N'2013-W06-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95004, CAST(N'2013-02-11' AS date), CAST(N'2013-02-12' AS date), 2013, 20131, 201302, 2013042, 1, 2, 42, 11, 2, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-05' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-08' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-15' AS date), 1040, 3121, 13571, 13572, 13571, 13571, 13571, 13571, 13571, 2456335, 56334, N'2013-02-11', 201307, 7, 1, N'2013-W07', N'2013-W07-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95005, CAST(N'2013-02-12' AS date), CAST(N'2013-02-13' AS date), 2013, 20131, 201302, 2013043, 1, 2, 43, 12, 3, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-06' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-08' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-15' AS date), 1040, 3121, 13571, 13572, 13572, 13571, 13571, 13571, 13571, 2456336, 56335, N'2013-02-12', 201307, 7, 2, N'2013-W07', N'2013-W07-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95006, CAST(N'2013-02-13' AS date), CAST(N'2013-02-14' AS date), 2013, 20131, 201302, 2013044, 1, 2, 44, 13, 4, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-07' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-08' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-15' AS date), 1040, 3121, 13571, 13572, 13572, 13572, 13571, 13571, 13571, 2456337, 56336, N'2013-02-13', 201307, 7, 3, N'2013-W07', N'2013-W07-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95007, CAST(N'2013-02-14' AS date), CAST(N'2013-02-15' AS date), 2013, 20131, 201302, 2013045, 1, 2, 45, 14, 5, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-08' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-15' AS date), 1040, 3121, 13571, 13572, 13572, 13572, 13572, 13571, 13571, 2456338, 56337, N'2013-02-14', 201307, 7, 4, N'2013-W07', N'2013-W07-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95008, CAST(N'2013-02-15' AS date), CAST(N'2013-02-16' AS date), 2013, 20131, 201302, 2013046, 1, 2, 46, 15, 6, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-15' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-09' AS date), CAST(N'2013-02-15' AS date), 1040, 3121, 13571, 13572, 13572, 13572, 13572, 13572, 13571, 2456339, 56338, N'2013-02-15', 201307, 7, 5, N'2013-W07', N'2013-W07-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95009, CAST(N'2013-02-16' AS date), CAST(N'2013-02-17' AS date), 2013, 20131, 201302, 2013047, 1, 2, 47, 16, 7, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-10' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-15' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-22' AS date), 1040, 3121, 13571, 13572, 13572, 13572, 13572, 13572, 13572, 2456340, 56339, N'2013-02-16', 201307, 7, 6, N'2013-W07', N'2013-W07-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95010, CAST(N'2013-02-17' AS date), CAST(N'2013-02-18' AS date), 2013, 20131, 201302, 2013048, 1, 2, 48, 17, 1, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-02-11' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-15' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-22' AS date), 1040, 3121, 13572, 13572, 13572, 13572, 13572, 13572, 13572, 2456341, 56340, N'2013-02-17', 201307, 7, 7, N'2013-W07', N'2013-W07-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95011, CAST(N'2013-02-18' AS date), CAST(N'2013-02-19' AS date), 2013, 20131, 201302, 2013049, 1, 2, 49, 18, 2, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-02-12' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-15' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-22' AS date), 1040, 3121, 13572, 13573, 13572, 13572, 13572, 13572, 13572, 2456342, 56341, N'2013-02-18', 201308, 8, 1, N'2013-W08', N'2013-W08-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95012, CAST(N'2013-02-19' AS date), CAST(N'2013-02-20' AS date), 2013, 20131, 201302, 2013050, 1, 2, 50, 19, 3, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-02-13' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-15' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-22' AS date), 1040, 3121, 13572, 13573, 13573, 13572, 13572, 13572, 13572, 2456343, 56342, N'2013-02-19', 201308, 8, 2, N'2013-W08', N'2013-W08-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95013, CAST(N'2013-02-20' AS date), CAST(N'2013-02-21' AS date), 2013, 20131, 201302, 2013051, 1, 2, 51, 20, 4, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-02-14' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-15' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-22' AS date), 1040, 3121, 13572, 13573, 13573, 13573, 13572, 13572, 13572, 2456344, 56343, N'2013-02-20', 201308, 8, 3, N'2013-W08', N'2013-W08-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95014, CAST(N'2013-02-21' AS date), CAST(N'2013-02-22' AS date), 2013, 20131, 201302, 2013052, 1, 2, 52, 21, 5, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-02-15' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-22' AS date), 1040, 3121, 13572, 13573, 13573, 13573, 13573, 13572, 13572, 2456345, 56344, N'2013-02-21', 201308, 8, 4, N'2013-W08', N'2013-W08-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95015, CAST(N'2013-02-22' AS date), CAST(N'2013-02-23' AS date), 2013, 20131, 201302, 2013053, 1, 2, 53, 22, 6, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-02-22' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-16' AS date), CAST(N'2013-02-22' AS date), 1040, 3121, 13572, 13573, 13573, 13573, 13573, 13573, 13572, 2456346, 56345, N'2013-02-22', 201308, 8, 5, N'2013-W08', N'2013-W08-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95016, CAST(N'2013-02-23' AS date), CAST(N'2013-02-24' AS date), 2013, 20131, 201302, 2013054, 1, 2, 54, 23, 7, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-17' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-02-22' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-03-01' AS date), 1040, 3121, 13572, 13573, 13573, 13573, 13573, 13573, 13573, 2456347, 56346, N'2013-02-23', 201308, 8, 6, N'2013-W08', N'2013-W08-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95017, CAST(N'2013-02-24' AS date), CAST(N'2013-02-25' AS date), 2013, 20131, 201302, 2013055, 1, 2, 55, 24, 1, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-02-18' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-02-22' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-03-01' AS date), 1040, 3121, 13573, 13573, 13573, 13573, 13573, 13573, 13573, 2456348, 56347, N'2013-02-24', 201308, 8, 7, N'2013-W08', N'2013-W08-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95018, CAST(N'2013-02-25' AS date), CAST(N'2013-02-26' AS date), 2013, 20131, 201302, 2013056, 1, 2, 56, 25, 2, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-02-19' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-02-22' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-03-01' AS date), 1040, 3121, 13573, 13574, 13573, 13573, 13573, 13573, 13573, 2456349, 56348, N'2013-02-25', 201309, 9, 1, N'2013-W09', N'2013-W09-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95019, CAST(N'2013-02-26' AS date), CAST(N'2013-02-27' AS date), 2013, 20131, 201302, 2013057, 1, 2, 57, 26, 3, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-02-20' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-02-22' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-03-01' AS date), 1040, 3121, 13573, 13574, 13574, 13573, 13573, 13573, 13573, 2456350, 56349, N'2013-02-26', 201309, 9, 2, N'2013-W09', N'2013-W09-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95020, CAST(N'2013-02-27' AS date), CAST(N'2013-02-28' AS date), 2013, 20131, 201302, 2013058, 1, 2, 58, 27, 4, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-02-21' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-02-22' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-03-01' AS date), 1040, 3121, 13573, 13574, 13574, 13574, 13573, 13573, 13573, 2456351, 56350, N'2013-02-27', 201309, 9, 3, N'2013-W09', N'2013-W09-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95021, CAST(N'2013-02-28' AS date), CAST(N'2013-03-01' AS date), 2013, 20131, 201302, 2013059, 1, 2, 59, 28, 5, N'2013', N'2013 Q1', N'2013 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-01' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-02-22' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-03-01' AS date), 1040, 3121, 13573, 13574, 13574, 13574, 13574, 13573, 13573, 2456352, 56351, N'2013-02-28', 201309, 9, 4, N'2013-W09', N'2013-W09-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95022, CAST(N'2013-03-01' AS date), CAST(N'2013-03-02' AS date), 2013, 20131, 201303, 2013060, 1, 3, 60, 1, 6, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-02-23' AS date), CAST(N'2013-03-01' AS date), 1040, 3122, 13573, 13574, 13574, 13574, 13574, 13574, 13573, 2456353, 56352, N'2013-03-01', 201309, 9, 5, N'2013-W09', N'2013-W09-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95023, CAST(N'2013-03-02' AS date), CAST(N'2013-03-03' AS date), 2013, 20131, 201303, 2013061, 1, 3, 61, 2, 7, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-02-24' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-03-08' AS date), 1040, 3122, 13573, 13574, 13574, 13574, 13574, 13574, 13574, 2456354, 56353, N'2013-03-02', 201309, 9, 6, N'2013-W09', N'2013-W09-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95024, CAST(N'2013-03-03' AS date), CAST(N'2013-03-04' AS date), 2013, 20131, 201303, 2013062, 1, 3, 62, 3, 1, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-02-25' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-03-08' AS date), 1040, 3122, 13574, 13574, 13574, 13574, 13574, 13574, 13574, 2456355, 56354, N'2013-03-03', 201309, 9, 7, N'2013-W09', N'2013-W09-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95025, CAST(N'2013-03-04' AS date), CAST(N'2013-03-05' AS date), 2013, 20131, 201303, 2013063, 1, 3, 63, 4, 2, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-02-26' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-03-08' AS date), 1040, 3122, 13574, 13575, 13574, 13574, 13574, 13574, 13574, 2456356, 56355, N'2013-03-04', 201310, 10, 1, N'2013-W10', N'2013-W10-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95026, CAST(N'2013-03-05' AS date), CAST(N'2013-03-06' AS date), 2013, 20131, 201303, 2013064, 1, 3, 64, 5, 3, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-02-27' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-03-08' AS date), 1040, 3122, 13574, 13575, 13575, 13574, 13574, 13574, 13574, 2456357, 56356, N'2013-03-05', 201310, 10, 2, N'2013-W10', N'2013-W10-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95027, CAST(N'2013-03-06' AS date), CAST(N'2013-03-07' AS date), 2013, 20131, 201303, 2013065, 1, 3, 65, 6, 4, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-02-28' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-03-08' AS date), 1040, 3122, 13574, 13575, 13575, 13575, 13574, 13574, 13574, 2456358, 56357, N'2013-03-06', 201310, 10, 3, N'2013-W10', N'2013-W10-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95028, CAST(N'2013-03-07' AS date), CAST(N'2013-03-08' AS date), 2013, 20131, 201303, 2013066, 1, 3, 66, 7, 5, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-03-08' AS date), 1040, 3122, 13574, 13575, 13575, 13575, 13575, 13574, 13574, 2456359, 56358, N'2013-03-07', 201310, 10, 4, N'2013-W10', N'2013-W10-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95029, CAST(N'2013-03-08' AS date), CAST(N'2013-03-09' AS date), 2013, 20131, 201303, 2013067, 1, 3, 67, 8, 6, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-08' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-02' AS date), CAST(N'2013-03-08' AS date), 1040, 3122, 13574, 13575, 13575, 13575, 13575, 13575, 13574, 2456360, 56359, N'2013-03-08', 201310, 10, 5, N'2013-W10', N'2013-W10-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95030, CAST(N'2013-03-09' AS date), CAST(N'2013-03-10' AS date), 2013, 20131, 201303, 2013068, 1, 3, 68, 9, 7, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-03' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-08' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-15' AS date), 1040, 3122, 13574, 13575, 13575, 13575, 13575, 13575, 13575, 2456361, 56360, N'2013-03-09', 201310, 10, 6, N'2013-W10', N'2013-W10-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95031, CAST(N'2013-03-10' AS date), CAST(N'2013-03-11' AS date), 2013, 20131, 201303, 2013069, 1, 3, 69, 10, 1, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-04' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-08' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-15' AS date), 1040, 3122, 13575, 13575, 13575, 13575, 13575, 13575, 13575, 2456362, 56361, N'2013-03-10', 201310, 10, 7, N'2013-W10', N'2013-W10-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95032, CAST(N'2013-03-11' AS date), CAST(N'2013-03-12' AS date), 2013, 20131, 201303, 2013070, 1, 3, 70, 11, 2, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-05' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-08' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-15' AS date), 1040, 3122, 13575, 13576, 13575, 13575, 13575, 13575, 13575, 2456363, 56362, N'2013-03-11', 201311, 11, 1, N'2013-W11', N'2013-W11-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95033, CAST(N'2013-03-12' AS date), CAST(N'2013-03-13' AS date), 2013, 20131, 201303, 2013071, 1, 3, 71, 12, 3, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-06' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-08' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-15' AS date), 1040, 3122, 13575, 13576, 13576, 13575, 13575, 13575, 13575, 2456364, 56363, N'2013-03-12', 201311, 11, 2, N'2013-W11', N'2013-W11-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95034, CAST(N'2013-03-13' AS date), CAST(N'2013-03-14' AS date), 2013, 20131, 201303, 2013072, 1, 3, 72, 13, 4, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-07' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-08' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-15' AS date), 1040, 3122, 13575, 13576, 13576, 13576, 13575, 13575, 13575, 2456365, 56364, N'2013-03-13', 201311, 11, 3, N'2013-W11', N'2013-W11-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95035, CAST(N'2013-03-14' AS date), CAST(N'2013-03-15' AS date), 2013, 20131, 201303, 2013073, 1, 3, 73, 14, 5, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-08' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-15' AS date), 1040, 3122, 13575, 13576, 13576, 13576, 13576, 13575, 13575, 2456366, 56365, N'2013-03-14', 201311, 11, 4, N'2013-W11', N'2013-W11-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95036, CAST(N'2013-03-15' AS date), CAST(N'2013-03-16' AS date), 2013, 20131, 201303, 2013074, 1, 3, 74, 15, 6, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-15' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-09' AS date), CAST(N'2013-03-15' AS date), 1040, 3122, 13575, 13576, 13576, 13576, 13576, 13576, 13575, 2456367, 56366, N'2013-03-15', 201311, 11, 5, N'2013-W11', N'2013-W11-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95037, CAST(N'2013-03-16' AS date), CAST(N'2013-03-17' AS date), 2013, 20131, 201303, 2013075, 1, 3, 75, 16, 7, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-10' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-15' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-22' AS date), 1040, 3122, 13575, 13576, 13576, 13576, 13576, 13576, 13576, 2456368, 56367, N'2013-03-16', 201311, 11, 6, N'2013-W11', N'2013-W11-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95038, CAST(N'2013-03-17' AS date), CAST(N'2013-03-18' AS date), 2013, 20131, 201303, 2013076, 1, 3, 76, 17, 1, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-11' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-15' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-22' AS date), 1040, 3122, 13576, 13576, 13576, 13576, 13576, 13576, 13576, 2456369, 56368, N'2013-03-17', 201311, 11, 7, N'2013-W11', N'2013-W11-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95039, CAST(N'2013-03-18' AS date), CAST(N'2013-03-19' AS date), 2013, 20131, 201303, 2013077, 1, 3, 77, 18, 2, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-12' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-15' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-22' AS date), 1040, 3122, 13576, 13577, 13576, 13576, 13576, 13576, 13576, 2456370, 56369, N'2013-03-18', 201312, 12, 1, N'2013-W12', N'2013-W12-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95040, CAST(N'2013-03-19' AS date), CAST(N'2013-03-20' AS date), 2013, 20131, 201303, 2013078, 1, 3, 78, 19, 3, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-13' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-15' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-22' AS date), 1040, 3122, 13576, 13577, 13577, 13576, 13576, 13576, 13576, 2456371, 56370, N'2013-03-19', 201312, 12, 2, N'2013-W12', N'2013-W12-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95041, CAST(N'2013-03-20' AS date), CAST(N'2013-03-21' AS date), 2013, 20131, 201303, 2013079, 1, 3, 79, 20, 4, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-03-14' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-15' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-22' AS date), 1040, 3122, 13576, 13577, 13577, 13577, 13576, 13576, 13576, 2456372, 56371, N'2013-03-20', 201312, 12, 3, N'2013-W12', N'2013-W12-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95042, CAST(N'2013-03-21' AS date), CAST(N'2013-03-22' AS date), 2013, 20131, 201303, 2013080, 1, 3, 80, 21, 5, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-03-15' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-22' AS date), 1040, 3122, 13576, 13577, 13577, 13577, 13577, 13576, 13576, 2456373, 56372, N'2013-03-21', 201312, 12, 4, N'2013-W12', N'2013-W12-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95043, CAST(N'2013-03-22' AS date), CAST(N'2013-03-23' AS date), 2013, 20131, 201303, 2013081, 1, 3, 81, 22, 6, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-03-22' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-03-16' AS date), CAST(N'2013-03-22' AS date), 1040, 3122, 13576, 13577, 13577, 13577, 13577, 13577, 13576, 2456374, 56373, N'2013-03-22', 201312, 12, 5, N'2013-W12', N'2013-W12-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95044, CAST(N'2013-03-23' AS date), CAST(N'2013-03-24' AS date), 2013, 20131, 201303, 2013082, 1, 3, 82, 23, 7, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-17' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-03-22' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-29' AS date), 1040, 3122, 13576, 13577, 13577, 13577, 13577, 13577, 13577, 2456375, 56374, N'2013-03-23', 201312, 12, 6, N'2013-W12', N'2013-W12-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95045, CAST(N'2013-03-24' AS date), CAST(N'2013-03-25' AS date), 2013, 20131, 201303, 2013083, 1, 3, 83, 24, 1, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-03-18' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-03-22' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-29' AS date), 1040, 3122, 13577, 13577, 13577, 13577, 13577, 13577, 13577, 2456376, 56375, N'2013-03-24', 201312, 12, 7, N'2013-W12', N'2013-W12-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95046, CAST(N'2013-03-25' AS date), CAST(N'2013-03-26' AS date), 2013, 20131, 201303, 2013084, 1, 3, 84, 25, 2, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-19' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-03-22' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-29' AS date), 1040, 3122, 13577, 13578, 13577, 13577, 13577, 13577, 13577, 2456377, 56376, N'2013-03-25', 201313, 13, 1, N'2013-W13', N'2013-W13-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95047, CAST(N'2013-03-26' AS date), CAST(N'2013-03-27' AS date), 2013, 20131, 201303, 2013085, 1, 3, 85, 26, 3, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-03-20' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-03-22' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-29' AS date), 1040, 3122, 13577, 13578, 13578, 13577, 13577, 13577, 13577, 2456378, 56377, N'2013-03-26', 201313, 13, 2, N'2013-W13', N'2013-W13-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95048, CAST(N'2013-03-27' AS date), CAST(N'2013-03-28' AS date), 2013, 20131, 201303, 2013086, 1, 3, 86, 27, 4, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-03-21' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-03-22' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-29' AS date), 1040, 3122, 13577, 13578, 13578, 13578, 13577, 13577, 13577, 2456379, 56378, N'2013-03-27', 201313, 13, 3, N'2013-W13', N'2013-W13-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95049, CAST(N'2013-03-28' AS date), CAST(N'2013-03-29' AS date), 2013, 20131, 201303, 2013087, 1, 3, 87, 28, 5, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-03-22' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-29' AS date), 1040, 3122, 13577, 13578, 13578, 13578, 13578, 13577, 13577, 2456380, 56379, N'2013-03-28', 201313, 13, 4, N'2013-W13', N'2013-W13-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95050, CAST(N'2013-03-29' AS date), CAST(N'2013-03-30' AS date), 2013, 20131, 201303, 2013088, 1, 3, 88, 29, 6, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-03-29' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-03-23' AS date), CAST(N'2013-03-29' AS date), 1040, 3122, 13577, 13578, 13578, 13578, 13578, 13578, 13577, 2456381, 56380, N'2013-03-29', 201313, 13, 5, N'2013-W13', N'2013-W13-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95051, CAST(N'2013-03-30' AS date), CAST(N'2013-03-31' AS date), 2013, 20131, 201303, 2013089, 1, 3, 89, 30, 7, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-24' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-03-29' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-04-05' AS date), 1040, 3122, 13577, 13578, 13578, 13578, 13578, 13578, 13578, 2456382, 56381, N'2013-03-30', 201313, 13, 6, N'2013-W13', N'2013-W13-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95052, CAST(N'2013-03-31' AS date), CAST(N'2013-04-01' AS date), 2013, 20131, 201303, 2013090, 1, 3, 90, 31, 1, N'2013', N'2013 Q1', N'2013 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-01-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-01' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-03-25' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-03-29' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-04-05' AS date), 1040, 3122, 13578, 13578, 13578, 13578, 13578, 13578, 13578, 2456383, 56382, N'2013-03-31', 201313, 13, 7, N'2013-W13', N'2013-W13-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95053, CAST(N'2013-04-01' AS date), CAST(N'2013-04-02' AS date), 2013, 20132, 201304, 2013091, 2, 4, 91, 1, 2, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-03-26' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-03-29' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-04-05' AS date), 1041, 3123, 13578, 13579, 13578, 13578, 13578, 13578, 13578, 2456384, 56383, N'2013-04-01', 201314, 14, 1, N'2013-W14', N'2013-W14-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95054, CAST(N'2013-04-02' AS date), CAST(N'2013-04-03' AS date), 2013, 20132, 201304, 2013092, 2, 4, 92, 2, 3, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-03-27' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-03-29' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-04-05' AS date), 1041, 3123, 13578, 13579, 13579, 13578, 13578, 13578, 13578, 2456385, 56384, N'2013-04-02', 201314, 14, 2, N'2013-W14', N'2013-W14-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95055, CAST(N'2013-04-03' AS date), CAST(N'2013-04-04' AS date), 2013, 20132, 201304, 2013093, 2, 4, 93, 3, 4, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-03-28' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-03-29' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-04-05' AS date), 1041, 3123, 13578, 13579, 13579, 13579, 13578, 13578, 13578, 2456386, 56385, N'2013-04-03', 201314, 14, 3, N'2013-W14', N'2013-W14-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95056, CAST(N'2013-04-04' AS date), CAST(N'2013-04-05' AS date), 2013, 20132, 201304, 2013094, 2, 4, 94, 4, 5, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-03-29' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-04-05' AS date), 1041, 3123, 13578, 13579, 13579, 13579, 13579, 13578, 13578, 2456387, 56386, N'2013-04-04', 201314, 14, 4, N'2013-W14', N'2013-W14-4');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95057, CAST(N'2013-04-05' AS date), CAST(N'2013-04-06' AS date), 2013, 20132, 201304, 2013095, 2, 4, 95, 5, 6, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-05' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-03-30' AS date), CAST(N'2013-04-05' AS date), 1041, 3123, 13578, 13579, 13579, 13579, 13579, 13579, 13578, 2456388, 56387, N'2013-04-05', 201314, 14, 5, N'2013-W14', N'2013-W14-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95058, CAST(N'2013-04-06' AS date), CAST(N'2013-04-07' AS date), 2013, 20132, 201304, 2013096, 2, 4, 96, 6, 7, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-03-31' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-05' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-12' AS date), 1041, 3123, 13578, 13579, 13579, 13579, 13579, 13579, 13579, 2456389, 56388, N'2013-04-06', 201314, 14, 6, N'2013-W14', N'2013-W14-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95059, CAST(N'2013-04-07' AS date), CAST(N'2013-04-08' AS date), 2013, 20132, 201304, 2013097, 2, 4, 97, 7, 1, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-05' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-12' AS date), 1041, 3123, 13579, 13579, 13579, 13579, 13579, 13579, 13579, 2456390, 56389, N'2013-04-07', 201314, 14, 7, N'2013-W14', N'2013-W14-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95060, CAST(N'2013-04-08' AS date), CAST(N'2013-04-09' AS date), 2013, 20132, 201304, 2013098, 2, 4, 98, 8, 2, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-02' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-05' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-12' AS date), 1041, 3123, 13579, 13580, 13579, 13579, 13579, 13579, 13579, 2456391, 56390, N'2013-04-08', 201315, 15, 1, N'2013-W15', N'2013-W15-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95061, CAST(N'2013-04-09' AS date), CAST(N'2013-04-10' AS date), 2013, 20132, 201304, 2013099, 2, 4, 99, 9, 3, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-03' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-05' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-12' AS date), 1041, 3123, 13579, 13580, 13580, 13579, 13579, 13579, 13579, 2456392, 56391, N'2013-04-09', 201315, 15, 2, N'2013-W15', N'2013-W15-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95062, CAST(N'2013-04-10' AS date), CAST(N'2013-04-11' AS date), 2013, 20132, 201304, 2013100, 2, 4, 100, 10, 4, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-04' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-05' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-12' AS date), 1041, 3123, 13579, 13580, 13580, 13580, 13579, 13579, 13579, 2456393, 56392, N'2013-04-10', 201315, 15, 3, N'2013-W15', N'2013-W15-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95063, CAST(N'2013-04-11' AS date), CAST(N'2013-04-12' AS date), 2013, 20132, 201304, 2013101, 2, 4, 101, 11, 5, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-05' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-12' AS date), 1041, 3123, 13579, 13580, 13580, 13580, 13580, 13579, 13579, 2456394, 56393, N'2013-04-11', 201315, 15, 4, N'2013-W15', N'2013-W15-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95064, CAST(N'2013-04-12' AS date), CAST(N'2013-04-13' AS date), 2013, 20132, 201304, 2013102, 2, 4, 102, 12, 6, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-12' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-06' AS date), CAST(N'2013-04-12' AS date), 1041, 3123, 13579, 13580, 13580, 13580, 13580, 13580, 13579, 2456395, 56394, N'2013-04-12', 201315, 15, 5, N'2013-W15', N'2013-W15-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95065, CAST(N'2013-04-13' AS date), CAST(N'2013-04-14' AS date), 2013, 20132, 201304, 2013103, 2, 4, 103, 13, 7, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-07' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-12' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-19' AS date), 1041, 3123, 13579, 13580, 13580, 13580, 13580, 13580, 13580, 2456396, 56395, N'2013-04-13', 201315, 15, 6, N'2013-W15', N'2013-W15-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95066, CAST(N'2013-04-14' AS date), CAST(N'2013-04-15' AS date), 2013, 20132, 201304, 2013104, 2, 4, 104, 14, 1, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-08' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-12' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-19' AS date), 1041, 3123, 13580, 13580, 13580, 13580, 13580, 13580, 13580, 2456397, 56396, N'2013-04-14', 201315, 15, 7, N'2013-W15', N'2013-W15-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95067, CAST(N'2013-04-15' AS date), CAST(N'2013-04-16' AS date), 2013, 20132, 201304, 2013105, 2, 4, 105, 15, 2, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-09' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-12' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-19' AS date), 1041, 3123, 13580, 13581, 13580, 13580, 13580, 13580, 13580, 2456398, 56397, N'2013-04-15', 201316, 16, 1, N'2013-W16', N'2013-W16-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95068, CAST(N'2013-04-16' AS date), CAST(N'2013-04-17' AS date), 2013, 20132, 201304, 2013106, 2, 4, 106, 16, 3, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-10' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-12' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-19' AS date), 1041, 3123, 13580, 13581, 13581, 13580, 13580, 13580, 13580, 2456399, 56398, N'2013-04-16', 201316, 16, 2, N'2013-W16', N'2013-W16-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95069, CAST(N'2013-04-17' AS date), CAST(N'2013-04-18' AS date), 2013, 20132, 201304, 2013107, 2, 4, 107, 17, 4, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-11' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-12' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-19' AS date), 1041, 3123, 13580, 13581, 13581, 13581, 13580, 13580, 13580, 2456400, 56399, N'2013-04-17', 201316, 16, 3, N'2013-W16', N'2013-W16-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95070, CAST(N'2013-04-18' AS date), CAST(N'2013-04-19' AS date), 2013, 20132, 201304, 2013108, 2, 4, 108, 18, 5, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-12' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-19' AS date), 1041, 3123, 13580, 13581, 13581, 13581, 13581, 13580, 13580, 2456401, 56400, N'2013-04-18', 201316, 16, 4, N'2013-W16', N'2013-W16-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95071, CAST(N'2013-04-19' AS date), CAST(N'2013-04-20' AS date), 2013, 20132, 201304, 2013109, 2, 4, 109, 19, 6, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-19' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-04-13' AS date), CAST(N'2013-04-19' AS date), 1041, 3123, 13580, 13581, 13581, 13581, 13581, 13581, 13580, 2456402, 56401, N'2013-04-19', 201316, 16, 5, N'2013-W16', N'2013-W16-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95072, CAST(N'2013-04-20' AS date), CAST(N'2013-04-21' AS date), 2013, 20132, 201304, 2013110, 2, 4, 110, 20, 7, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-14' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-19' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-26' AS date), 1041, 3123, 13580, 13581, 13581, 13581, 13581, 13581, 13581, 2456403, 56402, N'2013-04-20', 201316, 16, 6, N'2013-W16', N'2013-W16-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95073, CAST(N'2013-04-21' AS date), CAST(N'2013-04-22' AS date), 2013, 20132, 201304, 2013111, 2, 4, 111, 21, 1, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-04-15' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-19' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-26' AS date), 1041, 3123, 13581, 13581, 13581, 13581, 13581, 13581, 13581, 2456404, 56403, N'2013-04-21', 201316, 16, 7, N'2013-W16', N'2013-W16-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95074, CAST(N'2013-04-22' AS date), CAST(N'2013-04-23' AS date), 2013, 20132, 201304, 2013112, 2, 4, 112, 22, 2, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-04-16' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-19' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-26' AS date), 1041, 3123, 13581, 13582, 13581, 13581, 13581, 13581, 13581, 2456405, 56404, N'2013-04-22', 201317, 17, 1, N'2013-W17', N'2013-W17-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95075, CAST(N'2013-04-23' AS date), CAST(N'2013-04-24' AS date), 2013, 20132, 201304, 2013113, 2, 4, 113, 23, 3, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-04-17' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-19' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-26' AS date), 1041, 3123, 13581, 13582, 13582, 13581, 13581, 13581, 13581, 2456406, 56405, N'2013-04-23', 201317, 17, 2, N'2013-W17', N'2013-W17-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95076, CAST(N'2013-04-24' AS date), CAST(N'2013-04-25' AS date), 2013, 20132, 201304, 2013114, 2, 4, 114, 24, 4, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-18' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-19' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-26' AS date), 1041, 3123, 13581, 13582, 13582, 13582, 13581, 13581, 13581, 2456407, 56406, N'2013-04-24', 201317, 17, 3, N'2013-W17', N'2013-W17-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95077, CAST(N'2013-04-25' AS date), CAST(N'2013-04-26' AS date), 2013, 20132, 201304, 2013115, 2, 4, 115, 25, 5, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-04-19' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-26' AS date), 1041, 3123, 13581, 13582, 13582, 13582, 13582, 13581, 13581, 2456408, 56407, N'2013-04-25', 201317, 17, 4, N'2013-W17', N'2013-W17-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95078, CAST(N'2013-04-26' AS date), CAST(N'2013-04-27' AS date), 2013, 20132, 201304, 2013116, 2, 4, 116, 26, 6, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-04-26' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-04-20' AS date), CAST(N'2013-04-26' AS date), 1041, 3123, 13581, 13582, 13582, 13582, 13582, 13582, 13581, 2456409, 56408, N'2013-04-26', 201317, 17, 5, N'2013-W17', N'2013-W17-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95079, CAST(N'2013-04-27' AS date), CAST(N'2013-04-28' AS date), 2013, 20132, 201304, 2013117, 2, 4, 117, 27, 7, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-21' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-04-26' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-05-03' AS date), 1041, 3123, 13581, 13582, 13582, 13582, 13582, 13582, 13582, 2456410, 56409, N'2013-04-27', 201317, 17, 6, N'2013-W17', N'2013-W17-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95080, CAST(N'2013-04-28' AS date), CAST(N'2013-04-29' AS date), 2013, 20132, 201304, 2013118, 2, 4, 118, 28, 1, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-04-22' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-04-26' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-05-03' AS date), 1041, 3123, 13582, 13582, 13582, 13582, 13582, 13582, 13582, 2456411, 56410, N'2013-04-28', 201317, 17, 7, N'2013-W17', N'2013-W17-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95081, CAST(N'2013-04-29' AS date), CAST(N'2013-04-30' AS date), 2013, 20132, 201304, 2013119, 2, 4, 119, 29, 2, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-04-23' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-04-26' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-05-03' AS date), 1041, 3123, 13582, 13583, 13582, 13582, 13582, 13582, 13582, 2456412, 56411, N'2013-04-29', 201318, 18, 1, N'2013-W18', N'2013-W18-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95082, CAST(N'2013-04-30' AS date), CAST(N'2013-05-01' AS date), 2013, 20132, 201304, 2013120, 2, 4, 120, 30, 3, N'2013', N'2013 Q2', N'2013 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-04-24' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-04-26' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-05-03' AS date), 1041, 3123, 13582, 13583, 13583, 13582, 13582, 13582, 13582, 2456413, 56412, N'2013-04-30', 201318, 18, 2, N'2013-W18', N'2013-W18-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95083, CAST(N'2013-05-01' AS date), CAST(N'2013-05-02' AS date), 2013, 20132, 201305, 2013121, 2, 5, 121, 1, 4, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-04-25' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-04-26' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-05-03' AS date), 1041, 3124, 13582, 13583, 13583, 13583, 13582, 13582, 13582, 2456414, 56413, N'2013-05-01', 201318, 18, 3, N'2013-W18', N'2013-W18-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95084, CAST(N'2013-05-02' AS date), CAST(N'2013-05-03' AS date), 2013, 20132, 201305, 2013122, 2, 5, 122, 2, 5, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-04-26' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-05-03' AS date), 1041, 3124, 13582, 13583, 13583, 13583, 13583, 13582, 13582, 2456415, 56414, N'2013-05-02', 201318, 18, 4, N'2013-W18', N'2013-W18-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95085, CAST(N'2013-05-03' AS date), CAST(N'2013-05-04' AS date), 2013, 20132, 201305, 2013123, 2, 5, 123, 3, 6, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-03' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-04-27' AS date), CAST(N'2013-05-03' AS date), 1041, 3124, 13582, 13583, 13583, 13583, 13583, 13583, 13582, 2456416, 56415, N'2013-05-03', 201318, 18, 5, N'2013-W18', N'2013-W18-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95086, CAST(N'2013-05-04' AS date), CAST(N'2013-05-05' AS date), 2013, 20132, 201305, 2013124, 2, 5, 124, 4, 7, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-04-28' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-03' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-05-10' AS date), 1041, 3124, 13582, 13583, 13583, 13583, 13583, 13583, 13583, 2456417, 56416, N'2013-05-04', 201318, 18, 6, N'2013-W18', N'2013-W18-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95087, CAST(N'2013-05-05' AS date), CAST(N'2013-05-06' AS date), 2013, 20132, 201305, 2013125, 2, 5, 125, 5, 1, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-04-29' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-03' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-05-10' AS date), 1041, 3124, 13583, 13583, 13583, 13583, 13583, 13583, 13583, 2456418, 56417, N'2013-05-05', 201318, 18, 7, N'2013-W18', N'2013-W18-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95088, CAST(N'2013-05-06' AS date), CAST(N'2013-05-07' AS date), 2013, 20132, 201305, 2013126, 2, 5, 126, 6, 2, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-04-30' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-03' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-05-10' AS date), 1041, 3124, 13583, 13584, 13583, 13583, 13583, 13583, 13583, 2456419, 56418, N'2013-05-06', 201319, 19, 1, N'2013-W19', N'2013-W19-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95089, CAST(N'2013-05-07' AS date), CAST(N'2013-05-08' AS date), 2013, 20132, 201305, 2013127, 2, 5, 127, 7, 3, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-03' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-05-10' AS date), 1041, 3124, 13583, 13584, 13584, 13583, 13583, 13583, 13583, 2456420, 56419, N'2013-05-07', 201319, 19, 2, N'2013-W19', N'2013-W19-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95090, CAST(N'2013-05-08' AS date), CAST(N'2013-05-09' AS date), 2013, 20132, 201305, 2013128, 2, 5, 128, 8, 4, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-02' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-03' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-05-10' AS date), 1041, 3124, 13583, 13584, 13584, 13584, 13583, 13583, 13583, 2456421, 56420, N'2013-05-08', 201319, 19, 3, N'2013-W19', N'2013-W19-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95091, CAST(N'2013-05-09' AS date), CAST(N'2013-05-10' AS date), 2013, 20132, 201305, 2013129, 2, 5, 129, 9, 5, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-03' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-05-10' AS date), 1041, 3124, 13583, 13584, 13584, 13584, 13584, 13583, 13583, 2456422, 56421, N'2013-05-09', 201319, 19, 4, N'2013-W19', N'2013-W19-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95092, CAST(N'2013-05-10' AS date), CAST(N'2013-05-11' AS date), 2013, 20132, 201305, 2013130, 2, 5, 130, 10, 6, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-10' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-04' AS date), CAST(N'2013-05-10' AS date), 1041, 3124, 13583, 13584, 13584, 13584, 13584, 13584, 13583, 2456423, 56422, N'2013-05-10', 201319, 19, 5, N'2013-W19', N'2013-W19-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95093, CAST(N'2013-05-11' AS date), CAST(N'2013-05-12' AS date), 2013, 20132, 201305, 2013131, 2, 5, 131, 11, 7, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-05' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-10' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-17' AS date), 1041, 3124, 13583, 13584, 13584, 13584, 13584, 13584, 13584, 2456424, 56423, N'2013-05-11', 201319, 19, 6, N'2013-W19', N'2013-W19-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95094, CAST(N'2013-05-12' AS date), CAST(N'2013-05-13' AS date), 2013, 20132, 201305, 2013132, 2, 5, 132, 12, 1, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-06' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-10' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-17' AS date), 1041, 3124, 13584, 13584, 13584, 13584, 13584, 13584, 13584, 2456425, 56424, N'2013-05-12', 201319, 19, 7, N'2013-W19', N'2013-W19-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95095, CAST(N'2013-05-13' AS date), CAST(N'2013-05-14' AS date), 2013, 20132, 201305, 2013133, 2, 5, 133, 13, 2, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-07' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-10' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-17' AS date), 1041, 3124, 13584, 13585, 13584, 13584, 13584, 13584, 13584, 2456426, 56425, N'2013-05-13', 201320, 20, 1, N'2013-W20', N'2013-W20-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95096, CAST(N'2013-05-14' AS date), CAST(N'2013-05-15' AS date), 2013, 20132, 201305, 2013134, 2, 5, 134, 14, 3, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-08' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-10' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-17' AS date), 1041, 3124, 13584, 13585, 13585, 13584, 13584, 13584, 13584, 2456427, 56426, N'2013-05-14', 201320, 20, 2, N'2013-W20', N'2013-W20-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95097, CAST(N'2013-05-15' AS date), CAST(N'2013-05-16' AS date), 2013, 20132, 201305, 2013135, 2, 5, 135, 15, 4, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-09' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-10' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-17' AS date), 1041, 3124, 13584, 13585, 13585, 13585, 13584, 13584, 13584, 2456428, 56427, N'2013-05-15', 201320, 20, 3, N'2013-W20', N'2013-W20-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95098, CAST(N'2013-05-16' AS date), CAST(N'2013-05-17' AS date), 2013, 20132, 201305, 2013136, 2, 5, 136, 16, 5, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-10' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-17' AS date), 1041, 3124, 13584, 13585, 13585, 13585, 13585, 13584, 13584, 2456429, 56428, N'2013-05-16', 201320, 20, 4, N'2013-W20', N'2013-W20-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95099, CAST(N'2013-05-17' AS date), CAST(N'2013-05-18' AS date), 2013, 20132, 201305, 2013137, 2, 5, 137, 17, 6, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-17' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-11' AS date), CAST(N'2013-05-17' AS date), 1041, 3124, 13584, 13585, 13585, 13585, 13585, 13585, 13584, 2456430, 56429, N'2013-05-17', 201320, 20, 5, N'2013-W20', N'2013-W20-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95100, CAST(N'2013-05-18' AS date), CAST(N'2013-05-19' AS date), 2013, 20132, 201305, 2013138, 2, 5, 138, 18, 7, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-12' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-17' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-24' AS date), 1041, 3124, 13584, 13585, 13585, 13585, 13585, 13585, 13585, 2456431, 56430, N'2013-05-18', 201320, 20, 6, N'2013-W20', N'2013-W20-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95101, CAST(N'2013-05-19' AS date), CAST(N'2013-05-20' AS date), 2013, 20132, 201305, 2013139, 2, 5, 139, 19, 1, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-13' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-17' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-24' AS date), 1041, 3124, 13585, 13585, 13585, 13585, 13585, 13585, 13585, 2456432, 56431, N'2013-05-19', 201320, 20, 7, N'2013-W20', N'2013-W20-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95102, CAST(N'2013-05-20' AS date), CAST(N'2013-05-21' AS date), 2013, 20132, 201305, 2013140, 2, 5, 140, 20, 2, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-05-14' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-17' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-24' AS date), 1041, 3124, 13585, 13586, 13585, 13585, 13585, 13585, 13585, 2456433, 56432, N'2013-05-20', 201321, 21, 1, N'2013-W21', N'2013-W21-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95103, CAST(N'2013-05-21' AS date), CAST(N'2013-05-22' AS date), 2013, 20132, 201305, 2013141, 2, 5, 141, 21, 3, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-05-15' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-17' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-24' AS date), 1041, 3124, 13585, 13586, 13586, 13585, 13585, 13585, 13585, 2456434, 56433, N'2013-05-21', 201321, 21, 2, N'2013-W21', N'2013-W21-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95104, CAST(N'2013-05-22' AS date), CAST(N'2013-05-23' AS date), 2013, 20132, 201305, 2013142, 2, 5, 142, 22, 4, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-05-16' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-17' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-24' AS date), 1041, 3124, 13585, 13586, 13586, 13586, 13585, 13585, 13585, 2456435, 56434, N'2013-05-22', 201321, 21, 3, N'2013-W21', N'2013-W21-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95105, CAST(N'2013-05-23' AS date), CAST(N'2013-05-24' AS date), 2013, 20132, 201305, 2013143, 2, 5, 143, 23, 5, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-05-17' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-24' AS date), 1041, 3124, 13585, 13586, 13586, 13586, 13586, 13585, 13585, 2456436, 56435, N'2013-05-23', 201321, 21, 4, N'2013-W21', N'2013-W21-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95106, CAST(N'2013-05-24' AS date), CAST(N'2013-05-25' AS date), 2013, 20132, 201305, 2013144, 2, 5, 144, 24, 6, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-05-24' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-05-18' AS date), CAST(N'2013-05-24' AS date), 1041, 3124, 13585, 13586, 13586, 13586, 13586, 13586, 13585, 2456437, 56436, N'2013-05-24', 201321, 21, 5, N'2013-W21', N'2013-W21-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95107, CAST(N'2013-05-25' AS date), CAST(N'2013-05-26' AS date), 2013, 20132, 201305, 2013145, 2, 5, 145, 25, 7, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-19' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-05-24' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-31' AS date), 1041, 3124, 13585, 13586, 13586, 13586, 13586, 13586, 13586, 2456438, 56437, N'2013-05-25', 201321, 21, 6, N'2013-W21', N'2013-W21-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95108, CAST(N'2013-05-26' AS date), CAST(N'2013-05-27' AS date), 2013, 20132, 201305, 2013146, 2, 5, 146, 26, 1, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-05-20' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-05-24' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-31' AS date), 1041, 3124, 13586, 13586, 13586, 13586, 13586, 13586, 13586, 2456439, 56438, N'2013-05-26', 201321, 21, 7, N'2013-W21', N'2013-W21-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95109, CAST(N'2013-05-27' AS date), CAST(N'2013-05-28' AS date), 2013, 20132, 201305, 2013147, 2, 5, 147, 27, 2, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-05-21' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-05-24' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-31' AS date), 1041, 3124, 13586, 13587, 13586, 13586, 13586, 13586, 13586, 2456440, 56439, N'2013-05-27', 201322, 22, 1, N'2013-W22', N'2013-W22-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95110, CAST(N'2013-05-28' AS date), CAST(N'2013-05-29' AS date), 2013, 20132, 201305, 2013148, 2, 5, 148, 28, 3, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-05-22' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-05-24' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-31' AS date), 1041, 3124, 13586, 13587, 13587, 13586, 13586, 13586, 13586, 2456441, 56440, N'2013-05-28', 201322, 22, 2, N'2013-W22', N'2013-W22-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95111, CAST(N'2013-05-29' AS date), CAST(N'2013-05-30' AS date), 2013, 20132, 201305, 2013149, 2, 5, 149, 29, 4, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-05-23' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-05-24' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-31' AS date), 1041, 3124, 13586, 13587, 13587, 13587, 13586, 13586, 13586, 2456442, 56441, N'2013-05-29', 201322, 22, 3, N'2013-W22', N'2013-W22-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95112, CAST(N'2013-05-30' AS date), CAST(N'2013-05-31' AS date), 2013, 20132, 201305, 2013150, 2, 5, 150, 30, 5, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-05-24' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-31' AS date), 1041, 3124, 13586, 13587, 13587, 13587, 13587, 13586, 13586, 2456443, 56442, N'2013-05-30', 201322, 22, 4, N'2013-W22', N'2013-W22-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95113, CAST(N'2013-05-31' AS date), CAST(N'2013-06-01' AS date), 2013, 20132, 201305, 2013151, 2, 5, 151, 31, 6, N'2013', N'2013 Q2', N'2013 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-01' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-05-25' AS date), CAST(N'2013-05-31' AS date), 1041, 3124, 13586, 13587, 13587, 13587, 13587, 13587, 13586, 2456444, 56443, N'2013-05-31', 201322, 22, 5, N'2013-W22', N'2013-W22-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95114, CAST(N'2013-06-01' AS date), CAST(N'2013-06-02' AS date), 2013, 20132, 201306, 2013152, 2, 6, 152, 1, 7, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-05-26' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-07' AS date), 1041, 3125, 13586, 13587, 13587, 13587, 13587, 13587, 13587, 2456445, 56444, N'2013-06-01', 201322, 22, 6, N'2013-W22', N'2013-W22-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95115, CAST(N'2013-06-02' AS date), CAST(N'2013-06-03' AS date), 2013, 20132, 201306, 2013153, 2, 6, 153, 2, 1, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-05-27' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-07' AS date), 1041, 3125, 13587, 13587, 13587, 13587, 13587, 13587, 13587, 2456446, 56445, N'2013-06-02', 201322, 22, 7, N'2013-W22', N'2013-W22-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95116, CAST(N'2013-06-03' AS date), CAST(N'2013-06-04' AS date), 2013, 20132, 201306, 2013154, 2, 6, 154, 3, 2, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-05-28' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-07' AS date), 1041, 3125, 13587, 13588, 13587, 13587, 13587, 13587, 13587, 2456447, 56446, N'2013-06-03', 201323, 23, 1, N'2013-W23', N'2013-W23-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95117, CAST(N'2013-06-04' AS date), CAST(N'2013-06-05' AS date), 2013, 20132, 201306, 2013155, 2, 6, 155, 4, 3, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-05-29' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-07' AS date), 1041, 3125, 13587, 13588, 13588, 13587, 13587, 13587, 13587, 2456448, 56447, N'2013-06-04', 201323, 23, 2, N'2013-W23', N'2013-W23-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95118, CAST(N'2013-06-05' AS date), CAST(N'2013-06-06' AS date), 2013, 20132, 201306, 2013156, 2, 6, 156, 5, 4, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-05-30' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-07' AS date), 1041, 3125, 13587, 13588, 13588, 13588, 13587, 13587, 13587, 2456449, 56448, N'2013-06-05', 201323, 23, 3, N'2013-W23', N'2013-W23-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95119, CAST(N'2013-06-06' AS date), CAST(N'2013-06-07' AS date), 2013, 20132, 201306, 2013157, 2, 6, 157, 6, 5, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-05-31' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-07' AS date), 1041, 3125, 13587, 13588, 13588, 13588, 13588, 13587, 13587, 2456450, 56449, N'2013-06-06', 201323, 23, 4, N'2013-W23', N'2013-W23-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95120, CAST(N'2013-06-07' AS date), CAST(N'2013-06-08' AS date), 2013, 20132, 201306, 2013158, 2, 6, 158, 7, 6, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-07' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-07' AS date), 1041, 3125, 13587, 13588, 13588, 13588, 13588, 13588, 13587, 2456451, 56450, N'2013-06-07', 201323, 23, 5, N'2013-W23', N'2013-W23-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95121, CAST(N'2013-06-08' AS date), CAST(N'2013-06-09' AS date), 2013, 20132, 201306, 2013159, 2, 6, 159, 8, 7, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-02' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-07' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-14' AS date), 1041, 3125, 13587, 13588, 13588, 13588, 13588, 13588, 13588, 2456452, 56451, N'2013-06-08', 201323, 23, 6, N'2013-W23', N'2013-W23-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95122, CAST(N'2013-06-09' AS date), CAST(N'2013-06-10' AS date), 2013, 20132, 201306, 2013160, 2, 6, 160, 9, 1, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-03' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-07' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-14' AS date), 1041, 3125, 13588, 13588, 13588, 13588, 13588, 13588, 13588, 2456453, 56452, N'2013-06-09', 201323, 23, 7, N'2013-W23', N'2013-W23-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95123, CAST(N'2013-06-10' AS date), CAST(N'2013-06-11' AS date), 2013, 20132, 201306, 2013161, 2, 6, 161, 10, 2, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-04' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-07' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-14' AS date), 1041, 3125, 13588, 13589, 13588, 13588, 13588, 13588, 13588, 2456454, 56453, N'2013-06-10', 201324, 24, 1, N'2013-W24', N'2013-W24-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95124, CAST(N'2013-06-11' AS date), CAST(N'2013-06-12' AS date), 2013, 20132, 201306, 2013162, 2, 6, 162, 11, 3, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-05' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-07' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-14' AS date), 1041, 3125, 13588, 13589, 13589, 13588, 13588, 13588, 13588, 2456455, 56454, N'2013-06-11', 201324, 24, 2, N'2013-W24', N'2013-W24-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95125, CAST(N'2013-06-12' AS date), CAST(N'2013-06-13' AS date), 2013, 20132, 201306, 2013163, 2, 6, 163, 12, 4, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-06' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-07' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-14' AS date), 1041, 3125, 13588, 13589, 13589, 13589, 13588, 13588, 13588, 2456456, 56455, N'2013-06-12', 201324, 24, 3, N'2013-W24', N'2013-W24-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95126, CAST(N'2013-06-13' AS date), CAST(N'2013-06-14' AS date), 2013, 20132, 201306, 2013164, 2, 6, 164, 13, 5, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-07' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-14' AS date), 1041, 3125, 13588, 13589, 13589, 13589, 13589, 13588, 13588, 2456457, 56456, N'2013-06-13', 201324, 24, 4, N'2013-W24', N'2013-W24-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95127, CAST(N'2013-06-14' AS date), CAST(N'2013-06-15' AS date), 2013, 20132, 201306, 2013165, 2, 6, 165, 14, 6, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-14' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-08' AS date), CAST(N'2013-06-14' AS date), 1041, 3125, 13588, 13589, 13589, 13589, 13589, 13589, 13588, 2456458, 56457, N'2013-06-14', 201324, 24, 5, N'2013-W24', N'2013-W24-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95128, CAST(N'2013-06-15' AS date), CAST(N'2013-06-16' AS date), 2013, 20132, 201306, 2013166, 2, 6, 166, 15, 7, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-09' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-14' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-21' AS date), 1041, 3125, 13588, 13589, 13589, 13589, 13589, 13589, 13589, 2456459, 56458, N'2013-06-15', 201324, 24, 6, N'2013-W24', N'2013-W24-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95129, CAST(N'2013-06-16' AS date), CAST(N'2013-06-17' AS date), 2013, 20132, 201306, 2013167, 2, 6, 167, 16, 1, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-10' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-14' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-21' AS date), 1041, 3125, 13589, 13589, 13589, 13589, 13589, 13589, 13589, 2456460, 56459, N'2013-06-16', 201324, 24, 7, N'2013-W24', N'2013-W24-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95130, CAST(N'2013-06-17' AS date), CAST(N'2013-06-18' AS date), 2013, 20132, 201306, 2013168, 2, 6, 168, 17, 2, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-11' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-14' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-21' AS date), 1041, 3125, 13589, 13590, 13589, 13589, 13589, 13589, 13589, 2456461, 56460, N'2013-06-17', 201325, 25, 1, N'2013-W25', N'2013-W25-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95131, CAST(N'2013-06-18' AS date), CAST(N'2013-06-19' AS date), 2013, 20132, 201306, 2013169, 2, 6, 169, 18, 3, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-12' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-14' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-21' AS date), 1041, 3125, 13589, 13590, 13590, 13589, 13589, 13589, 13589, 2456462, 56461, N'2013-06-18', 201325, 25, 2, N'2013-W25', N'2013-W25-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95132, CAST(N'2013-06-19' AS date), CAST(N'2013-06-20' AS date), 2013, 20132, 201306, 2013170, 2, 6, 170, 19, 4, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-06-13' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-14' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-21' AS date), 1041, 3125, 13589, 13590, 13590, 13590, 13589, 13589, 13589, 2456463, 56462, N'2013-06-19', 201325, 25, 3, N'2013-W25', N'2013-W25-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95133, CAST(N'2013-06-20' AS date), CAST(N'2013-06-21' AS date), 2013, 20132, 201306, 2013171, 2, 6, 171, 20, 5, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-06-14' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-21' AS date), 1041, 3125, 13589, 13590, 13590, 13590, 13590, 13589, 13589, 2456464, 56463, N'2013-06-20', 201325, 25, 4, N'2013-W25', N'2013-W25-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95134, CAST(N'2013-06-21' AS date), CAST(N'2013-06-22' AS date), 2013, 20132, 201306, 2013172, 2, 6, 172, 21, 6, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-06-21' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-06-15' AS date), CAST(N'2013-06-21' AS date), 1041, 3125, 13589, 13590, 13590, 13590, 13590, 13590, 13589, 2456465, 56464, N'2013-06-21', 201325, 25, 5, N'2013-W25', N'2013-W25-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95135, CAST(N'2013-06-22' AS date), CAST(N'2013-06-23' AS date), 2013, 20132, 201306, 2013173, 2, 6, 173, 22, 7, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-16' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-06-21' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-28' AS date), 1041, 3125, 13589, 13590, 13590, 13590, 13590, 13590, 13590, 2456466, 56465, N'2013-06-22', 201325, 25, 6, N'2013-W25', N'2013-W25-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95136, CAST(N'2013-06-23' AS date), CAST(N'2013-06-24' AS date), 2013, 20132, 201306, 2013174, 2, 6, 174, 23, 1, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-06-17' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-06-21' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-28' AS date), 1041, 3125, 13590, 13590, 13590, 13590, 13590, 13590, 13590, 2456467, 56466, N'2013-06-23', 201325, 25, 7, N'2013-W25', N'2013-W25-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95137, CAST(N'2013-06-24' AS date), CAST(N'2013-06-25' AS date), 2013, 20132, 201306, 2013175, 2, 6, 175, 24, 2, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-18' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-06-21' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-28' AS date), 1041, 3125, 13590, 13591, 13590, 13590, 13590, 13590, 13590, 2456468, 56467, N'2013-06-24', 201326, 26, 1, N'2013-W26', N'2013-W26-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95138, CAST(N'2013-06-25' AS date), CAST(N'2013-06-26' AS date), 2013, 20132, 201306, 2013176, 2, 6, 176, 25, 3, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-06-19' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-06-21' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-28' AS date), 1041, 3125, 13590, 13591, 13591, 13590, 13590, 13590, 13590, 2456469, 56468, N'2013-06-25', 201326, 26, 2, N'2013-W26', N'2013-W26-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95139, CAST(N'2013-06-26' AS date), CAST(N'2013-06-27' AS date), 2013, 20132, 201306, 2013177, 2, 6, 177, 26, 4, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-06-20' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-06-21' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-28' AS date), 1041, 3125, 13590, 13591, 13591, 13591, 13590, 13590, 13590, 2456470, 56469, N'2013-06-26', 201326, 26, 3, N'2013-W26', N'2013-W26-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95140, CAST(N'2013-06-27' AS date), CAST(N'2013-06-28' AS date), 2013, 20132, 201306, 2013178, 2, 6, 178, 27, 5, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-06-21' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-28' AS date), 1041, 3125, 13590, 13591, 13591, 13591, 13591, 13590, 13590, 2456471, 56470, N'2013-06-27', 201326, 26, 4, N'2013-W26', N'2013-W26-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95141, CAST(N'2013-06-28' AS date), CAST(N'2013-06-29' AS date), 2013, 20132, 201306, 2013179, 2, 6, 179, 28, 6, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-06-28' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-06-22' AS date), CAST(N'2013-06-28' AS date), 1041, 3125, 13590, 13591, 13591, 13591, 13591, 13591, 13590, 2456472, 56471, N'2013-06-28', 201326, 26, 5, N'2013-W26', N'2013-W26-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95142, CAST(N'2013-06-29' AS date), CAST(N'2013-06-30' AS date), 2013, 20132, 201306, 2013180, 2, 6, 180, 29, 7, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-23' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-06-28' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-07-05' AS date), 1041, 3125, 13590, 13591, 13591, 13591, 13591, 13591, 13591, 2456473, 56472, N'2013-06-29', 201326, 26, 6, N'2013-W26', N'2013-W26-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95143, CAST(N'2013-06-30' AS date), CAST(N'2013-07-01' AS date), 2013, 20132, 201306, 2013181, 2, 6, 181, 30, 1, N'2013', N'2013 Q2', N'2013 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-04-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-01' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-06-24' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-06-28' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-07-05' AS date), 1041, 3125, 13591, 13591, 13591, 13591, 13591, 13591, 13591, 2456474, 56473, N'2013-06-30', 201326, 26, 7, N'2013-W26', N'2013-W26-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95144, CAST(N'2013-07-01' AS date), CAST(N'2013-07-02' AS date), 2013, 20133, 201307, 2013182, 3, 7, 182, 1, 2, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-06-25' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-06-28' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-07-05' AS date), 1042, 3126, 13591, 13592, 13591, 13591, 13591, 13591, 13591, 2456475, 56474, N'2013-07-01', 201327, 27, 1, N'2013-W27', N'2013-W27-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95145, CAST(N'2013-07-02' AS date), CAST(N'2013-07-03' AS date), 2013, 20133, 201307, 2013183, 3, 7, 183, 2, 3, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-06-26' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-06-28' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-07-05' AS date), 1042, 3126, 13591, 13592, 13592, 13591, 13591, 13591, 13591, 2456476, 56475, N'2013-07-02', 201327, 27, 2, N'2013-W27', N'2013-W27-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95146, CAST(N'2013-07-03' AS date), CAST(N'2013-07-04' AS date), 2013, 20133, 201307, 2013184, 3, 7, 184, 3, 4, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-06-27' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-06-28' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-07-05' AS date), 1042, 3126, 13591, 13592, 13592, 13592, 13591, 13591, 13591, 2456477, 56476, N'2013-07-03', 201327, 27, 3, N'2013-W27', N'2013-W27-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95147, CAST(N'2013-07-04' AS date), CAST(N'2013-07-05' AS date), 2013, 20133, 201307, 2013185, 3, 7, 185, 4, 5, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-06-28' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-07-05' AS date), 1042, 3126, 13591, 13592, 13592, 13592, 13592, 13591, 13591, 2456478, 56477, N'2013-07-04', 201327, 27, 4, N'2013-W27', N'2013-W27-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95148, CAST(N'2013-07-05' AS date), CAST(N'2013-07-06' AS date), 2013, 20133, 201307, 2013186, 3, 7, 186, 5, 6, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-05' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-06-29' AS date), CAST(N'2013-07-05' AS date), 1042, 3126, 13591, 13592, 13592, 13592, 13592, 13592, 13591, 2456479, 56478, N'2013-07-05', 201327, 27, 5, N'2013-W27', N'2013-W27-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95149, CAST(N'2013-07-06' AS date), CAST(N'2013-07-07' AS date), 2013, 20133, 201307, 2013187, 3, 7, 187, 6, 7, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-06-30' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-05' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-12' AS date), 1042, 3126, 13591, 13592, 13592, 13592, 13592, 13592, 13592, 2456480, 56479, N'2013-07-06', 201327, 27, 6, N'2013-W27', N'2013-W27-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95150, CAST(N'2013-07-07' AS date), CAST(N'2013-07-08' AS date), 2013, 20133, 201307, 2013188, 3, 7, 188, 7, 1, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-05' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-12' AS date), 1042, 3126, 13592, 13592, 13592, 13592, 13592, 13592, 13592, 2456481, 56480, N'2013-07-07', 201327, 27, 7, N'2013-W27', N'2013-W27-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95151, CAST(N'2013-07-08' AS date), CAST(N'2013-07-09' AS date), 2013, 20133, 201307, 2013189, 3, 7, 189, 8, 2, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-02' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-05' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-12' AS date), 1042, 3126, 13592, 13593, 13592, 13592, 13592, 13592, 13592, 2456482, 56481, N'2013-07-08', 201328, 28, 1, N'2013-W28', N'2013-W28-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95152, CAST(N'2013-07-09' AS date), CAST(N'2013-07-10' AS date), 2013, 20133, 201307, 2013190, 3, 7, 190, 9, 3, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-03' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-05' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-12' AS date), 1042, 3126, 13592, 13593, 13593, 13592, 13592, 13592, 13592, 2456483, 56482, N'2013-07-09', 201328, 28, 2, N'2013-W28', N'2013-W28-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95153, CAST(N'2013-07-10' AS date), CAST(N'2013-07-11' AS date), 2013, 20133, 201307, 2013191, 3, 7, 191, 10, 4, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-04' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-05' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-12' AS date), 1042, 3126, 13592, 13593, 13593, 13593, 13592, 13592, 13592, 2456484, 56483, N'2013-07-10', 201328, 28, 3, N'2013-W28', N'2013-W28-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95154, CAST(N'2013-07-11' AS date), CAST(N'2013-07-12' AS date), 2013, 20133, 201307, 2013192, 3, 7, 192, 11, 5, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-05' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-12' AS date), 1042, 3126, 13592, 13593, 13593, 13593, 13593, 13592, 13592, 2456485, 56484, N'2013-07-11', 201328, 28, 4, N'2013-W28', N'2013-W28-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95155, CAST(N'2013-07-12' AS date), CAST(N'2013-07-13' AS date), 2013, 20133, 201307, 2013193, 3, 7, 193, 12, 6, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-12' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-06' AS date), CAST(N'2013-07-12' AS date), 1042, 3126, 13592, 13593, 13593, 13593, 13593, 13593, 13592, 2456486, 56485, N'2013-07-12', 201328, 28, 5, N'2013-W28', N'2013-W28-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95156, CAST(N'2013-07-13' AS date), CAST(N'2013-07-14' AS date), 2013, 20133, 201307, 2013194, 3, 7, 194, 13, 7, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-07' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-12' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-19' AS date), 1042, 3126, 13592, 13593, 13593, 13593, 13593, 13593, 13593, 2456487, 56486, N'2013-07-13', 201328, 28, 6, N'2013-W28', N'2013-W28-6');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95157, CAST(N'2013-07-14' AS date), CAST(N'2013-07-15' AS date), 2013, 20133, 201307, 2013195, 3, 7, 195, 14, 1, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-08' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-12' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-19' AS date), 1042, 3126, 13593, 13593, 13593, 13593, 13593, 13593, 13593, 2456488, 56487, N'2013-07-14', 201328, 28, 7, N'2013-W28', N'2013-W28-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95158, CAST(N'2013-07-15' AS date), CAST(N'2013-07-16' AS date), 2013, 20133, 201307, 2013196, 3, 7, 196, 15, 2, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-09' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-12' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-19' AS date), 1042, 3126, 13593, 13594, 13593, 13593, 13593, 13593, 13593, 2456489, 56488, N'2013-07-15', 201329, 29, 1, N'2013-W29', N'2013-W29-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95159, CAST(N'2013-07-16' AS date), CAST(N'2013-07-17' AS date), 2013, 20133, 201307, 2013197, 3, 7, 197, 16, 3, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-10' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-12' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-19' AS date), 1042, 3126, 13593, 13594, 13594, 13593, 13593, 13593, 13593, 2456490, 56489, N'2013-07-16', 201329, 29, 2, N'2013-W29', N'2013-W29-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95160, CAST(N'2013-07-17' AS date), CAST(N'2013-07-18' AS date), 2013, 20133, 201307, 2013198, 3, 7, 198, 17, 4, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-11' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-12' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-19' AS date), 1042, 3126, 13593, 13594, 13594, 13594, 13593, 13593, 13593, 2456491, 56490, N'2013-07-17', 201329, 29, 3, N'2013-W29', N'2013-W29-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95161, CAST(N'2013-07-18' AS date), CAST(N'2013-07-19' AS date), 2013, 20133, 201307, 2013199, 3, 7, 199, 18, 5, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-12' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-19' AS date), 1042, 3126, 13593, 13594, 13594, 13594, 13594, 13593, 13593, 2456492, 56491, N'2013-07-18', 201329, 29, 4, N'2013-W29', N'2013-W29-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95162, CAST(N'2013-07-19' AS date), CAST(N'2013-07-20' AS date), 2013, 20133, 201307, 2013200, 3, 7, 200, 19, 6, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-19' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-13' AS date), CAST(N'2013-07-19' AS date), 1042, 3126, 13593, 13594, 13594, 13594, 13594, 13594, 13593, 2456493, 56492, N'2013-07-19', 201329, 29, 5, N'2013-W29', N'2013-W29-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95163, CAST(N'2013-07-20' AS date), CAST(N'2013-07-21' AS date), 2013, 20133, 201307, 2013201, 3, 7, 201, 20, 7, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-14' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-19' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-26' AS date), 1042, 3126, 13593, 13594, 13594, 13594, 13594, 13594, 13594, 2456494, 56493, N'2013-07-20', 201329, 29, 6, N'2013-W29', N'2013-W29-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95164, CAST(N'2013-07-21' AS date), CAST(N'2013-07-22' AS date), 2013, 20133, 201307, 2013202, 3, 7, 202, 21, 1, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-07-15' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-19' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-26' AS date), 1042, 3126, 13594, 13594, 13594, 13594, 13594, 13594, 13594, 2456495, 56494, N'2013-07-21', 201329, 29, 7, N'2013-W29', N'2013-W29-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95165, CAST(N'2013-07-22' AS date), CAST(N'2013-07-23' AS date), 2013, 20133, 201307, 2013203, 3, 7, 203, 22, 2, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-07-16' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-19' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-26' AS date), 1042, 3126, 13594, 13595, 13594, 13594, 13594, 13594, 13594, 2456496, 56495, N'2013-07-22', 201330, 30, 1, N'2013-W30', N'2013-W30-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95166, CAST(N'2013-07-23' AS date), CAST(N'2013-07-24' AS date), 2013, 20133, 201307, 2013204, 3, 7, 204, 23, 3, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-07-17' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-19' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-26' AS date), 1042, 3126, 13594, 13595, 13595, 13594, 13594, 13594, 13594, 2456497, 56496, N'2013-07-23', 201330, 30, 2, N'2013-W30', N'2013-W30-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95167, CAST(N'2013-07-24' AS date), CAST(N'2013-07-25' AS date), 2013, 20133, 201307, 2013205, 3, 7, 205, 24, 4, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-07-18' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-19' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-26' AS date), 1042, 3126, 13594, 13595, 13595, 13595, 13594, 13594, 13594, 2456498, 56497, N'2013-07-24', 201330, 30, 3, N'2013-W30', N'2013-W30-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95168, CAST(N'2013-07-25' AS date), CAST(N'2013-07-26' AS date), 2013, 20133, 201307, 2013206, 3, 7, 206, 25, 5, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-19' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-26' AS date), 1042, 3126, 13594, 13595, 13595, 13595, 13595, 13594, 13594, 2456499, 56498, N'2013-07-25', 201330, 30, 4, N'2013-W30', N'2013-W30-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95169, CAST(N'2013-07-26' AS date), CAST(N'2013-07-27' AS date), 2013, 20133, 201307, 2013207, 3, 7, 207, 26, 6, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-26' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-07-20' AS date), CAST(N'2013-07-26' AS date), 1042, 3126, 13594, 13595, 13595, 13595, 13595, 13595, 13594, 2456500, 56499, N'2013-07-26', 201330, 30, 5, N'2013-W30', N'2013-W30-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95170, CAST(N'2013-07-27' AS date), CAST(N'2013-07-28' AS date), 2013, 20133, 201307, 2013208, 3, 7, 208, 27, 7, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-21' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-26' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-08-02' AS date), 1042, 3126, 13594, 13595, 13595, 13595, 13595, 13595, 13595, 2456501, 56500, N'2013-07-27', 201330, 30, 6, N'2013-W30', N'2013-W30-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95171, CAST(N'2013-07-28' AS date), CAST(N'2013-07-29' AS date), 2013, 20133, 201307, 2013209, 3, 7, 209, 28, 1, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-07-22' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-26' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-08-02' AS date), 1042, 3126, 13595, 13595, 13595, 13595, 13595, 13595, 13595, 2456502, 56501, N'2013-07-28', 201330, 30, 7, N'2013-W30', N'2013-W30-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95172, CAST(N'2013-07-29' AS date), CAST(N'2013-07-30' AS date), 2013, 20133, 201307, 2013210, 3, 7, 210, 29, 2, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-07-23' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-26' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-08-02' AS date), 1042, 3126, 13595, 13596, 13595, 13595, 13595, 13595, 13595, 2456503, 56502, N'2013-07-29', 201331, 31, 1, N'2013-W31', N'2013-W31-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95173, CAST(N'2013-07-30' AS date), CAST(N'2013-07-31' AS date), 2013, 20133, 201307, 2013211, 3, 7, 211, 30, 3, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-07-24' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-26' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-08-02' AS date), 1042, 3126, 13595, 13596, 13596, 13595, 13595, 13595, 13595, 2456504, 56503, N'2013-07-30', 201331, 31, 2, N'2013-W31', N'2013-W31-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95174, CAST(N'2013-07-31' AS date), CAST(N'2013-08-01' AS date), 2013, 20133, 201307, 2013212, 3, 7, 212, 31, 4, N'2013', N'2013 Q3', N'2013 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-07-25' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-07-26' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-08-02' AS date), 1042, 3126, 13595, 13596, 13596, 13596, 13595, 13595, 13595, 2456505, 56504, N'2013-07-31', 201331, 31, 3, N'2013-W31', N'2013-W31-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95175, CAST(N'2013-08-01' AS date), CAST(N'2013-08-02' AS date), 2013, 20133, 201308, 2013213, 3, 8, 213, 1, 5, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-07-26' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-08-02' AS date), 1042, 3127, 13595, 13596, 13596, 13596, 13596, 13595, 13595, 2456506, 56505, N'2013-08-01', 201331, 31, 4, N'2013-W31', N'2013-W31-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95176, CAST(N'2013-08-02' AS date), CAST(N'2013-08-03' AS date), 2013, 20133, 201308, 2013214, 3, 8, 214, 2, 6, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-02' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-07-27' AS date), CAST(N'2013-08-02' AS date), 1042, 3127, 13595, 13596, 13596, 13596, 13596, 13596, 13595, 2456507, 56506, N'2013-08-02', 201331, 31, 5, N'2013-W31', N'2013-W31-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95177, CAST(N'2013-08-03' AS date), CAST(N'2013-08-04' AS date), 2013, 20133, 201308, 2013215, 3, 8, 215, 3, 7, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-07-28' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-02' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-08-09' AS date), 1042, 3127, 13595, 13596, 13596, 13596, 13596, 13596, 13596, 2456508, 56507, N'2013-08-03', 201331, 31, 6, N'2013-W31', N'2013-W31-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95178, CAST(N'2013-08-04' AS date), CAST(N'2013-08-05' AS date), 2013, 20133, 201308, 2013216, 3, 8, 216, 4, 1, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-07-29' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-02' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-08-09' AS date), 1042, 3127, 13596, 13596, 13596, 13596, 13596, 13596, 13596, 2456509, 56508, N'2013-08-04', 201331, 31, 7, N'2013-W31', N'2013-W31-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95179, CAST(N'2013-08-05' AS date), CAST(N'2013-08-06' AS date), 2013, 20133, 201308, 2013217, 3, 8, 217, 5, 2, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-07-30' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-02' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-08-09' AS date), 1042, 3127, 13596, 13597, 13596, 13596, 13596, 13596, 13596, 2456510, 56509, N'2013-08-05', 201332, 32, 1, N'2013-W32', N'2013-W32-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95180, CAST(N'2013-08-06' AS date), CAST(N'2013-08-07' AS date), 2013, 20133, 201308, 2013218, 3, 8, 218, 6, 3, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-07-31' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-02' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-08-09' AS date), 1042, 3127, 13596, 13597, 13597, 13596, 13596, 13596, 13596, 2456511, 56510, N'2013-08-06', 201332, 32, 2, N'2013-W32', N'2013-W32-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95181, CAST(N'2013-08-07' AS date), CAST(N'2013-08-08' AS date), 2013, 20133, 201308, 2013219, 3, 8, 219, 7, 4, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-02' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-08-09' AS date), 1042, 3127, 13596, 13597, 13597, 13597, 13596, 13596, 13596, 2456512, 56511, N'2013-08-07', 201332, 32, 3, N'2013-W32', N'2013-W32-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95182, CAST(N'2013-08-08' AS date), CAST(N'2013-08-09' AS date), 2013, 20133, 201308, 2013220, 3, 8, 220, 8, 5, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-02' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-08-09' AS date), 1042, 3127, 13596, 13597, 13597, 13597, 13597, 13596, 13596, 2456513, 56512, N'2013-08-08', 201332, 32, 4, N'2013-W32', N'2013-W32-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95183, CAST(N'2013-08-09' AS date), CAST(N'2013-08-10' AS date), 2013, 20133, 201308, 2013221, 3, 8, 221, 9, 6, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-09' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-03' AS date), CAST(N'2013-08-09' AS date), 1042, 3127, 13596, 13597, 13597, 13597, 13597, 13597, 13596, 2456514, 56513, N'2013-08-09', 201332, 32, 5, N'2013-W32', N'2013-W32-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95184, CAST(N'2013-08-10' AS date), CAST(N'2013-08-11' AS date), 2013, 20133, 201308, 2013222, 3, 8, 222, 10, 7, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-04' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-09' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-16' AS date), 1042, 3127, 13596, 13597, 13597, 13597, 13597, 13597, 13597, 2456515, 56514, N'2013-08-10', 201332, 32, 6, N'2013-W32', N'2013-W32-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95185, CAST(N'2013-08-11' AS date), CAST(N'2013-08-12' AS date), 2013, 20133, 201308, 2013223, 3, 8, 223, 11, 1, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-05' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-09' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-16' AS date), 1042, 3127, 13597, 13597, 13597, 13597, 13597, 13597, 13597, 2456516, 56515, N'2013-08-11', 201332, 32, 7, N'2013-W32', N'2013-W32-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95186, CAST(N'2013-08-12' AS date), CAST(N'2013-08-13' AS date), 2013, 20133, 201308, 2013224, 3, 8, 224, 12, 2, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-06' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-09' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-16' AS date), 1042, 3127, 13597, 13598, 13597, 13597, 13597, 13597, 13597, 2456517, 56516, N'2013-08-12', 201333, 33, 1, N'2013-W33', N'2013-W33-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95187, CAST(N'2013-08-13' AS date), CAST(N'2013-08-14' AS date), 2013, 20133, 201308, 2013225, 3, 8, 225, 13, 3, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-07' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-09' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-16' AS date), 1042, 3127, 13597, 13598, 13598, 13597, 13597, 13597, 13597, 2456518, 56517, N'2013-08-13', 201333, 33, 2, N'2013-W33', N'2013-W33-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95188, CAST(N'2013-08-14' AS date), CAST(N'2013-08-15' AS date), 2013, 20133, 201308, 2013226, 3, 8, 226, 14, 4, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-08' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-09' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-16' AS date), 1042, 3127, 13597, 13598, 13598, 13598, 13597, 13597, 13597, 2456519, 56518, N'2013-08-14', 201333, 33, 3, N'2013-W33', N'2013-W33-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95189, CAST(N'2013-08-15' AS date), CAST(N'2013-08-16' AS date), 2013, 20133, 201308, 2013227, 3, 8, 227, 15, 5, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-09' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-16' AS date), 1042, 3127, 13597, 13598, 13598, 13598, 13598, 13597, 13597, 2456520, 56519, N'2013-08-15', 201333, 33, 4, N'2013-W33', N'2013-W33-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95190, CAST(N'2013-08-16' AS date), CAST(N'2013-08-17' AS date), 2013, 20133, 201308, 2013228, 3, 8, 228, 16, 6, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-16' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-10' AS date), CAST(N'2013-08-16' AS date), 1042, 3127, 13597, 13598, 13598, 13598, 13598, 13598, 13597, 2456521, 56520, N'2013-08-16', 201333, 33, 5, N'2013-W33', N'2013-W33-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95191, CAST(N'2013-08-17' AS date), CAST(N'2013-08-18' AS date), 2013, 20133, 201308, 2013229, 3, 8, 229, 17, 7, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-11' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-16' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-23' AS date), 1042, 3127, 13597, 13598, 13598, 13598, 13598, 13598, 13598, 2456522, 56521, N'2013-08-17', 201333, 33, 6, N'2013-W33', N'2013-W33-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95192, CAST(N'2013-08-18' AS date), CAST(N'2013-08-19' AS date), 2013, 20133, 201308, 2013230, 3, 8, 230, 18, 1, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-12' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-16' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-23' AS date), 1042, 3127, 13598, 13598, 13598, 13598, 13598, 13598, 13598, 2456523, 56522, N'2013-08-18', 201333, 33, 7, N'2013-W33', N'2013-W33-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95193, CAST(N'2013-08-19' AS date), CAST(N'2013-08-20' AS date), 2013, 20133, 201308, 2013231, 3, 8, 231, 19, 2, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-13' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-16' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-23' AS date), 1042, 3127, 13598, 13599, 13598, 13598, 13598, 13598, 13598, 2456524, 56523, N'2013-08-19', 201334, 34, 1, N'2013-W34', N'2013-W34-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95194, CAST(N'2013-08-20' AS date), CAST(N'2013-08-21' AS date), 2013, 20133, 201308, 2013232, 3, 8, 232, 20, 3, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-08-14' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-16' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-23' AS date), 1042, 3127, 13598, 13599, 13599, 13598, 13598, 13598, 13598, 2456525, 56524, N'2013-08-20', 201334, 34, 2, N'2013-W34', N'2013-W34-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95195, CAST(N'2013-08-21' AS date), CAST(N'2013-08-22' AS date), 2013, 20133, 201308, 2013233, 3, 8, 233, 21, 4, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-08-15' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-16' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-23' AS date), 1042, 3127, 13598, 13599, 13599, 13599, 13598, 13598, 13598, 2456526, 56525, N'2013-08-21', 201334, 34, 3, N'2013-W34', N'2013-W34-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95196, CAST(N'2013-08-22' AS date), CAST(N'2013-08-23' AS date), 2013, 20133, 201308, 2013234, 3, 8, 234, 22, 5, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-08-16' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-23' AS date), 1042, 3127, 13598, 13599, 13599, 13599, 13599, 13598, 13598, 2456527, 56526, N'2013-08-22', 201334, 34, 4, N'2013-W34', N'2013-W34-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95197, CAST(N'2013-08-23' AS date), CAST(N'2013-08-24' AS date), 2013, 20133, 201308, 2013235, 3, 8, 235, 23, 6, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-08-23' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-08-17' AS date), CAST(N'2013-08-23' AS date), 1042, 3127, 13598, 13599, 13599, 13599, 13599, 13599, 13598, 2456528, 56527, N'2013-08-23', 201334, 34, 5, N'2013-W34', N'2013-W34-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95198, CAST(N'2013-08-24' AS date), CAST(N'2013-08-25' AS date), 2013, 20133, 201308, 2013236, 3, 8, 236, 24, 7, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-18' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-08-23' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-30' AS date), 1042, 3127, 13598, 13599, 13599, 13599, 13599, 13599, 13599, 2456529, 56528, N'2013-08-24', 201334, 34, 6, N'2013-W34', N'2013-W34-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95199, CAST(N'2013-08-25' AS date), CAST(N'2013-08-26' AS date), 2013, 20133, 201308, 2013237, 3, 8, 237, 25, 1, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-19' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-08-23' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-30' AS date), 1042, 3127, 13599, 13599, 13599, 13599, 13599, 13599, 13599, 2456530, 56529, N'2013-08-25', 201334, 34, 7, N'2013-W34', N'2013-W34-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95200, CAST(N'2013-08-26' AS date), CAST(N'2013-08-27' AS date), 2013, 20133, 201308, 2013238, 3, 8, 238, 26, 2, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-08-20' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-08-23' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-30' AS date), 1042, 3127, 13599, 13600, 13599, 13599, 13599, 13599, 13599, 2456531, 56530, N'2013-08-26', 201335, 35, 1, N'2013-W35', N'2013-W35-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95201, CAST(N'2013-08-27' AS date), CAST(N'2013-08-28' AS date), 2013, 20133, 201308, 2013239, 3, 8, 239, 27, 3, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-08-21' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-08-23' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-30' AS date), 1042, 3127, 13599, 13600, 13600, 13599, 13599, 13599, 13599, 2456532, 56531, N'2013-08-27', 201335, 35, 2, N'2013-W35', N'2013-W35-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95202, CAST(N'2013-08-28' AS date), CAST(N'2013-08-29' AS date), 2013, 20133, 201308, 2013240, 3, 8, 240, 28, 4, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-08-22' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-08-23' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-30' AS date), 1042, 3127, 13599, 13600, 13600, 13600, 13599, 13599, 13599, 2456533, 56532, N'2013-08-28', 201335, 35, 3, N'2013-W35', N'2013-W35-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95203, CAST(N'2013-08-29' AS date), CAST(N'2013-08-30' AS date), 2013, 20133, 201308, 2013241, 3, 8, 241, 29, 5, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-08-23' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-30' AS date), 1042, 3127, 13599, 13600, 13600, 13600, 13600, 13599, 13599, 2456534, 56533, N'2013-08-29', 201335, 35, 4, N'2013-W35', N'2013-W35-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95204, CAST(N'2013-08-30' AS date), CAST(N'2013-08-31' AS date), 2013, 20133, 201308, 2013242, 3, 8, 242, 30, 6, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-08-30' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-08-24' AS date), CAST(N'2013-08-30' AS date), 1042, 3127, 13599, 13600, 13600, 13600, 13600, 13600, 13599, 2456535, 56534, N'2013-08-30', 201335, 35, 5, N'2013-W35', N'2013-W35-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95205, CAST(N'2013-08-31' AS date), CAST(N'2013-09-01' AS date), 2013, 20133, 201308, 2013243, 3, 8, 243, 31, 7, N'2013', N'2013 Q3', N'2013 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-08-01' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-25' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-08-30' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-09-06' AS date), 1042, 3127, 13599, 13600, 13600, 13600, 13600, 13600, 13600, 2456536, 56535, N'2013-08-31', 201335, 35, 6, N'2013-W35', N'2013-W35-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95206, CAST(N'2013-09-01' AS date), CAST(N'2013-09-02' AS date), 2013, 20133, 201309, 2013244, 3, 9, 244, 1, 1, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-08-26' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-08-30' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-09-06' AS date), 1042, 3128, 13600, 13600, 13600, 13600, 13600, 13600, 13600, 2456537, 56536, N'2013-09-01', 201335, 35, 7, N'2013-W35', N'2013-W35-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95207, CAST(N'2013-09-02' AS date), CAST(N'2013-09-03' AS date), 2013, 20133, 201309, 2013245, 3, 9, 245, 2, 2, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-08-27' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-08-30' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-09-06' AS date), 1042, 3128, 13600, 13601, 13600, 13600, 13600, 13600, 13600, 2456538, 56537, N'2013-09-02', 201336, 36, 1, N'2013-W36', N'2013-W36-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95208, CAST(N'2013-09-03' AS date), CAST(N'2013-09-04' AS date), 2013, 20133, 201309, 2013246, 3, 9, 246, 3, 3, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-08-28' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-08-30' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-09-06' AS date), 1042, 3128, 13600, 13601, 13601, 13600, 13600, 13600, 13600, 2456539, 56538, N'2013-09-03', 201336, 36, 2, N'2013-W36', N'2013-W36-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95209, CAST(N'2013-09-04' AS date), CAST(N'2013-09-05' AS date), 2013, 20133, 201309, 2013247, 3, 9, 247, 4, 4, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-08-29' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-08-30' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-09-06' AS date), 1042, 3128, 13600, 13601, 13601, 13601, 13600, 13600, 13600, 2456540, 56539, N'2013-09-04', 201336, 36, 3, N'2013-W36', N'2013-W36-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95210, CAST(N'2013-09-05' AS date), CAST(N'2013-09-06' AS date), 2013, 20133, 201309, 2013248, 3, 9, 248, 5, 5, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-08-30' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-09-06' AS date), 1042, 3128, 13600, 13601, 13601, 13601, 13601, 13600, 13600, 2456541, 56540, N'2013-09-05', 201336, 36, 4, N'2013-W36', N'2013-W36-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95211, CAST(N'2013-09-06' AS date), CAST(N'2013-09-07' AS date), 2013, 20133, 201309, 2013249, 3, 9, 249, 6, 6, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-06' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-08-31' AS date), CAST(N'2013-09-06' AS date), 1042, 3128, 13600, 13601, 13601, 13601, 13601, 13601, 13600, 2456542, 56541, N'2013-09-06', 201336, 36, 5, N'2013-W36', N'2013-W36-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95212, CAST(N'2013-09-07' AS date), CAST(N'2013-09-08' AS date), 2013, 20133, 201309, 2013250, 3, 9, 250, 7, 7, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-06' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-13' AS date), 1042, 3128, 13600, 13601, 13601, 13601, 13601, 13601, 13601, 2456543, 56542, N'2013-09-07', 201336, 36, 6, N'2013-W36', N'2013-W36-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95213, CAST(N'2013-09-08' AS date), CAST(N'2013-09-09' AS date), 2013, 20133, 201309, 2013251, 3, 9, 251, 8, 1, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-02' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-06' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-13' AS date), 1042, 3128, 13601, 13601, 13601, 13601, 13601, 13601, 13601, 2456544, 56543, N'2013-09-08', 201336, 36, 7, N'2013-W36', N'2013-W36-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95214, CAST(N'2013-09-09' AS date), CAST(N'2013-09-10' AS date), 2013, 20133, 201309, 2013252, 3, 9, 252, 9, 2, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-03' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-06' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-13' AS date), 1042, 3128, 13601, 13602, 13601, 13601, 13601, 13601, 13601, 2456545, 56544, N'2013-09-09', 201337, 37, 1, N'2013-W37', N'2013-W37-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95215, CAST(N'2013-09-10' AS date), CAST(N'2013-09-11' AS date), 2013, 20133, 201309, 2013253, 3, 9, 253, 10, 3, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-04' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-06' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-13' AS date), 1042, 3128, 13601, 13602, 13602, 13601, 13601, 13601, 13601, 2456546, 56545, N'2013-09-10', 201337, 37, 2, N'2013-W37', N'2013-W37-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95216, CAST(N'2013-09-11' AS date), CAST(N'2013-09-12' AS date), 2013, 20133, 201309, 2013254, 3, 9, 254, 11, 4, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-05' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-06' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-13' AS date), 1042, 3128, 13601, 13602, 13602, 13602, 13601, 13601, 13601, 2456547, 56546, N'2013-09-11', 201337, 37, 3, N'2013-W37', N'2013-W37-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95217, CAST(N'2013-09-12' AS date), CAST(N'2013-09-13' AS date), 2013, 20133, 201309, 2013255, 3, 9, 255, 12, 5, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-06' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-13' AS date), 1042, 3128, 13601, 13602, 13602, 13602, 13602, 13601, 13601, 2456548, 56547, N'2013-09-12', 201337, 37, 4, N'2013-W37', N'2013-W37-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95218, CAST(N'2013-09-13' AS date), CAST(N'2013-09-14' AS date), 2013, 20133, 201309, 2013256, 3, 9, 256, 13, 6, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-13' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-07' AS date), CAST(N'2013-09-13' AS date), 1042, 3128, 13601, 13602, 13602, 13602, 13602, 13602, 13601, 2456549, 56548, N'2013-09-13', 201337, 37, 5, N'2013-W37', N'2013-W37-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95219, CAST(N'2013-09-14' AS date), CAST(N'2013-09-15' AS date), 2013, 20133, 201309, 2013257, 3, 9, 257, 14, 7, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-08' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-13' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-20' AS date), 1042, 3128, 13601, 13602, 13602, 13602, 13602, 13602, 13602, 2456550, 56549, N'2013-09-14', 201337, 37, 6, N'2013-W37', N'2013-W37-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95220, CAST(N'2013-09-15' AS date), CAST(N'2013-09-16' AS date), 2013, 20133, 201309, 2013258, 3, 9, 258, 15, 1, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-09' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-13' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-20' AS date), 1042, 3128, 13602, 13602, 13602, 13602, 13602, 13602, 13602, 2456551, 56550, N'2013-09-15', 201337, 37, 7, N'2013-W37', N'2013-W37-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95221, CAST(N'2013-09-16' AS date), CAST(N'2013-09-17' AS date), 2013, 20133, 201309, 2013259, 3, 9, 259, 16, 2, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-10' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-13' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-20' AS date), 1042, 3128, 13602, 13603, 13602, 13602, 13602, 13602, 13602, 2456552, 56551, N'2013-09-16', 201338, 38, 1, N'2013-W38', N'2013-W38-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95222, CAST(N'2013-09-17' AS date), CAST(N'2013-09-18' AS date), 2013, 20133, 201309, 2013260, 3, 9, 260, 17, 3, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-11' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-13' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-20' AS date), 1042, 3128, 13602, 13603, 13603, 13602, 13602, 13602, 13602, 2456553, 56552, N'2013-09-17', 201338, 38, 2, N'2013-W38', N'2013-W38-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95223, CAST(N'2013-09-18' AS date), CAST(N'2013-09-19' AS date), 2013, 20133, 201309, 2013261, 3, 9, 261, 18, 4, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-12' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-13' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-20' AS date), 1042, 3128, 13602, 13603, 13603, 13603, 13602, 13602, 13602, 2456554, 56553, N'2013-09-18', 201338, 38, 3, N'2013-W38', N'2013-W38-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95224, CAST(N'2013-09-19' AS date), CAST(N'2013-09-20' AS date), 2013, 20133, 201309, 2013262, 3, 9, 262, 19, 5, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-09-13' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-20' AS date), 1042, 3128, 13602, 13603, 13603, 13603, 13603, 13602, 13602, 2456555, 56554, N'2013-09-19', 201338, 38, 4, N'2013-W38', N'2013-W38-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95225, CAST(N'2013-09-20' AS date), CAST(N'2013-09-21' AS date), 2013, 20133, 201309, 2013263, 3, 9, 263, 20, 6, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-09-20' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-09-14' AS date), CAST(N'2013-09-20' AS date), 1042, 3128, 13602, 13603, 13603, 13603, 13603, 13603, 13602, 2456556, 56555, N'2013-09-20', 201338, 38, 5, N'2013-W38', N'2013-W38-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95226, CAST(N'2013-09-21' AS date), CAST(N'2013-09-22' AS date), 2013, 20133, 201309, 2013264, 3, 9, 264, 21, 7, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-15' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-09-20' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-27' AS date), 1042, 3128, 13602, 13603, 13603, 13603, 13603, 13603, 13603, 2456557, 56556, N'2013-09-21', 201338, 38, 6, N'2013-W38', N'2013-W38-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95227, CAST(N'2013-09-22' AS date), CAST(N'2013-09-23' AS date), 2013, 20133, 201309, 2013265, 3, 9, 265, 22, 1, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-09-16' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-09-20' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-27' AS date), 1042, 3128, 13603, 13603, 13603, 13603, 13603, 13603, 13603, 2456558, 56557, N'2013-09-22', 201338, 38, 7, N'2013-W38', N'2013-W38-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95228, CAST(N'2013-09-23' AS date), CAST(N'2013-09-24' AS date), 2013, 20133, 201309, 2013266, 3, 9, 266, 23, 2, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-09-17' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-09-20' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-27' AS date), 1042, 3128, 13603, 13604, 13603, 13603, 13603, 13603, 13603, 2456559, 56558, N'2013-09-23', 201339, 39, 1, N'2013-W39', N'2013-W39-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95229, CAST(N'2013-09-24' AS date), CAST(N'2013-09-25' AS date), 2013, 20133, 201309, 2013267, 3, 9, 267, 24, 3, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-18' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-09-20' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-27' AS date), 1042, 3128, 13603, 13604, 13604, 13603, 13603, 13603, 13603, 2456560, 56559, N'2013-09-24', 201339, 39, 2, N'2013-W39', N'2013-W39-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95230, CAST(N'2013-09-25' AS date), CAST(N'2013-09-26' AS date), 2013, 20133, 201309, 2013268, 3, 9, 268, 25, 4, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-09-19' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-09-20' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-27' AS date), 1042, 3128, 13603, 13604, 13604, 13604, 13603, 13603, 13603, 2456561, 56560, N'2013-09-25', 201339, 39, 3, N'2013-W39', N'2013-W39-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95231, CAST(N'2013-09-26' AS date), CAST(N'2013-09-27' AS date), 2013, 20133, 201309, 2013269, 3, 9, 269, 26, 5, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-09-20' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-27' AS date), 1042, 3128, 13603, 13604, 13604, 13604, 13604, 13603, 13603, 2456562, 56561, N'2013-09-26', 201339, 39, 4, N'2013-W39', N'2013-W39-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95232, CAST(N'2013-09-27' AS date), CAST(N'2013-09-28' AS date), 2013, 20133, 201309, 2013270, 3, 9, 270, 27, 6, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-09-27' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-09-21' AS date), CAST(N'2013-09-27' AS date), 1042, 3128, 13603, 13604, 13604, 13604, 13604, 13604, 13603, 2456563, 56562, N'2013-09-27', 201339, 39, 5, N'2013-W39', N'2013-W39-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95233, CAST(N'2013-09-28' AS date), CAST(N'2013-09-29' AS date), 2013, 20133, 201309, 2013271, 3, 9, 271, 28, 7, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-22' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-09-27' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-10-04' AS date), 1042, 3128, 13603, 13604, 13604, 13604, 13604, 13604, 13604, 2456564, 56563, N'2013-09-28', 201339, 39, 6, N'2013-W39', N'2013-W39-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95234, CAST(N'2013-09-29' AS date), CAST(N'2013-09-30' AS date), 2013, 20133, 201309, 2013272, 3, 9, 272, 29, 1, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-09-23' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-09-27' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-10-04' AS date), 1042, 3128, 13604, 13604, 13604, 13604, 13604, 13604, 13604, 2456565, 56564, N'2013-09-29', 201339, 39, 7, N'2013-W39', N'2013-W39-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95235, CAST(N'2013-09-30' AS date), CAST(N'2013-10-01' AS date), 2013, 20133, 201309, 2013273, 3, 9, 273, 30, 2, N'2013', N'2013 Q3', N'2013 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-07-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-01' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-09-24' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-09-27' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-10-04' AS date), 1042, 3128, 13604, 13605, 13604, 13604, 13604, 13604, 13604, 2456566, 56565, N'2013-09-30', 201340, 40, 1, N'2013-W40', N'2013-W40-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95236, CAST(N'2013-10-01' AS date), CAST(N'2013-10-02' AS date), 2013, 20134, 201310, 2013274, 4, 10, 274, 1, 3, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-09-25' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-09-27' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-10-04' AS date), 1043, 3129, 13604, 13605, 13605, 13604, 13604, 13604, 13604, 2456567, 56566, N'2013-10-01', 201340, 40, 2, N'2013-W40', N'2013-W40-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95237, CAST(N'2013-10-02' AS date), CAST(N'2013-10-03' AS date), 2013, 20134, 201310, 2013275, 4, 10, 275, 2, 4, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-09-26' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-09-27' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-10-04' AS date), 1043, 3129, 13604, 13605, 13605, 13605, 13604, 13604, 13604, 2456568, 56567, N'2013-10-02', 201340, 40, 3, N'2013-W40', N'2013-W40-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95238, CAST(N'2013-10-03' AS date), CAST(N'2013-10-04' AS date), 2013, 20134, 201310, 2013276, 4, 10, 276, 3, 5, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-09-27' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-10-04' AS date), 1043, 3129, 13604, 13605, 13605, 13605, 13605, 13604, 13604, 2456569, 56568, N'2013-10-03', 201340, 40, 4, N'2013-W40', N'2013-W40-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95239, CAST(N'2013-10-04' AS date), CAST(N'2013-10-05' AS date), 2013, 20134, 201310, 2013277, 4, 10, 277, 4, 6, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-04' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-09-28' AS date), CAST(N'2013-10-04' AS date), 1043, 3129, 13604, 13605, 13605, 13605, 13605, 13605, 13604, 2456570, 56569, N'2013-10-04', 201340, 40, 5, N'2013-W40', N'2013-W40-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95240, CAST(N'2013-10-05' AS date), CAST(N'2013-10-06' AS date), 2013, 20134, 201310, 2013278, 4, 10, 278, 5, 7, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-09-29' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-04' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-10-11' AS date), 1043, 3129, 13604, 13605, 13605, 13605, 13605, 13605, 13605, 2456571, 56570, N'2013-10-05', 201340, 40, 6, N'2013-W40', N'2013-W40-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95241, CAST(N'2013-10-06' AS date), CAST(N'2013-10-07' AS date), 2013, 20134, 201310, 2013279, 4, 10, 279, 6, 1, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-09-30' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-04' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-10-11' AS date), 1043, 3129, 13605, 13605, 13605, 13605, 13605, 13605, 13605, 2456572, 56571, N'2013-10-06', 201340, 40, 7, N'2013-W40', N'2013-W40-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95242, CAST(N'2013-10-07' AS date), CAST(N'2013-10-08' AS date), 2013, 20134, 201310, 2013280, 4, 10, 280, 7, 2, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-04' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-10-11' AS date), 1043, 3129, 13605, 13606, 13605, 13605, 13605, 13605, 13605, 2456573, 56572, N'2013-10-07', 201341, 41, 1, N'2013-W41', N'2013-W41-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95243, CAST(N'2013-10-08' AS date), CAST(N'2013-10-09' AS date), 2013, 20134, 201310, 2013281, 4, 10, 281, 8, 3, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-02' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-04' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-10-11' AS date), 1043, 3129, 13605, 13606, 13606, 13605, 13605, 13605, 13605, 2456574, 56573, N'2013-10-08', 201341, 41, 2, N'2013-W41', N'2013-W41-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95244, CAST(N'2013-10-09' AS date), CAST(N'2013-10-10' AS date), 2013, 20134, 201310, 2013282, 4, 10, 282, 9, 4, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-03' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-04' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-10-11' AS date), 1043, 3129, 13605, 13606, 13606, 13606, 13605, 13605, 13605, 2456575, 56574, N'2013-10-09', 201341, 41, 3, N'2013-W41', N'2013-W41-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95245, CAST(N'2013-10-10' AS date), CAST(N'2013-10-11' AS date), 2013, 20134, 201310, 2013283, 4, 10, 283, 10, 5, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-04' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-10-11' AS date), 1043, 3129, 13605, 13606, 13606, 13606, 13606, 13605, 13605, 2456576, 56575, N'2013-10-10', 201341, 41, 4, N'2013-W41', N'2013-W41-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95246, CAST(N'2013-10-11' AS date), CAST(N'2013-10-12' AS date), 2013, 20134, 201310, 2013284, 4, 10, 284, 11, 6, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-11' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-05' AS date), CAST(N'2013-10-11' AS date), 1043, 3129, 13605, 13606, 13606, 13606, 13606, 13606, 13605, 2456577, 56576, N'2013-10-11', 201341, 41, 5, N'2013-W41', N'2013-W41-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95247, CAST(N'2013-10-12' AS date), CAST(N'2013-10-13' AS date), 2013, 20134, 201310, 2013285, 4, 10, 285, 12, 7, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-06' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-11' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-18' AS date), 1043, 3129, 13605, 13606, 13606, 13606, 13606, 13606, 13606, 2456578, 56577, N'2013-10-12', 201341, 41, 6, N'2013-W41', N'2013-W41-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95248, CAST(N'2013-10-13' AS date), CAST(N'2013-10-14' AS date), 2013, 20134, 201310, 2013286, 4, 10, 286, 13, 1, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-07' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-11' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-18' AS date), 1043, 3129, 13606, 13606, 13606, 13606, 13606, 13606, 13606, 2456579, 56578, N'2013-10-13', 201341, 41, 7, N'2013-W41', N'2013-W41-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95249, CAST(N'2013-10-14' AS date), CAST(N'2013-10-15' AS date), 2013, 20134, 201310, 2013287, 4, 10, 287, 14, 2, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-08' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-11' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-18' AS date), 1043, 3129, 13606, 13607, 13606, 13606, 13606, 13606, 13606, 2456580, 56579, N'2013-10-14', 201342, 42, 1, N'2013-W42', N'2013-W42-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95250, CAST(N'2013-10-15' AS date), CAST(N'2013-10-16' AS date), 2013, 20134, 201310, 2013288, 4, 10, 288, 15, 3, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-09' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-11' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-18' AS date), 1043, 3129, 13606, 13607, 13607, 13606, 13606, 13606, 13606, 2456581, 56580, N'2013-10-15', 201342, 42, 2, N'2013-W42', N'2013-W42-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95251, CAST(N'2013-10-16' AS date), CAST(N'2013-10-17' AS date), 2013, 20134, 201310, 2013289, 4, 10, 289, 16, 4, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-10' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-11' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-18' AS date), 1043, 3129, 13606, 13607, 13607, 13607, 13606, 13606, 13606, 2456582, 56581, N'2013-10-16', 201342, 42, 3, N'2013-W42', N'2013-W42-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95252, CAST(N'2013-10-17' AS date), CAST(N'2013-10-18' AS date), 2013, 20134, 201310, 2013290, 4, 10, 290, 17, 5, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-11' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-18' AS date), 1043, 3129, 13606, 13607, 13607, 13607, 13607, 13606, 13606, 2456583, 56582, N'2013-10-17', 201342, 42, 4, N'2013-W42', N'2013-W42-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95253, CAST(N'2013-10-18' AS date), CAST(N'2013-10-19' AS date), 2013, 20134, 201310, 2013291, 4, 10, 291, 18, 6, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-18' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-12' AS date), CAST(N'2013-10-18' AS date), 1043, 3129, 13606, 13607, 13607, 13607, 13607, 13607, 13606, 2456584, 56583, N'2013-10-18', 201342, 42, 5, N'2013-W42', N'2013-W42-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95254, CAST(N'2013-10-19' AS date), CAST(N'2013-10-20' AS date), 2013, 20134, 201310, 2013292, 4, 10, 292, 19, 7, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-13' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-18' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-25' AS date), 1043, 3129, 13606, 13607, 13607, 13607, 13607, 13607, 13607, 2456585, 56584, N'2013-10-19', 201342, 42, 6, N'2013-W42', N'2013-W42-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95255, CAST(N'2013-10-20' AS date), CAST(N'2013-10-21' AS date), 2013, 20134, 201310, 2013293, 4, 10, 293, 20, 1, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-10-14' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-18' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-25' AS date), 1043, 3129, 13607, 13607, 13607, 13607, 13607, 13607, 13607, 2456586, 56585, N'2013-10-20', 201342, 42, 7, N'2013-W42', N'2013-W42-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95256, CAST(N'2013-10-21' AS date), CAST(N'2013-10-22' AS date), 2013, 20134, 201310, 2013294, 4, 10, 294, 21, 2, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-10-15' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-18' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-25' AS date), 1043, 3129, 13607, 13608, 13607, 13607, 13607, 13607, 13607, 2456587, 56586, N'2013-10-21', 201343, 43, 1, N'2013-W43', N'2013-W43-1');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95257, CAST(N'2013-10-22' AS date), CAST(N'2013-10-23' AS date), 2013, 20134, 201310, 2013295, 4, 10, 295, 22, 3, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-10-16' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-18' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-25' AS date), 1043, 3129, 13607, 13608, 13608, 13607, 13607, 13607, 13607, 2456588, 56587, N'2013-10-22', 201343, 43, 2, N'2013-W43', N'2013-W43-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95258, CAST(N'2013-10-23' AS date), CAST(N'2013-10-24' AS date), 2013, 20134, 201310, 2013296, 4, 10, 296, 23, 4, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-10-17' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-18' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-25' AS date), 1043, 3129, 13607, 13608, 13608, 13608, 13607, 13607, 13607, 2456589, 56588, N'2013-10-23', 201343, 43, 3, N'2013-W43', N'2013-W43-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95259, CAST(N'2013-10-24' AS date), CAST(N'2013-10-25' AS date), 2013, 20134, 201310, 2013297, 4, 10, 297, 24, 5, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-10-18' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-25' AS date), 1043, 3129, 13607, 13608, 13608, 13608, 13608, 13607, 13607, 2456590, 56589, N'2013-10-24', 201343, 43, 4, N'2013-W43', N'2013-W43-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95260, CAST(N'2013-10-25' AS date), CAST(N'2013-10-26' AS date), 2013, 20134, 201310, 2013298, 4, 10, 298, 25, 6, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-10-25' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-19' AS date), CAST(N'2013-10-25' AS date), 1043, 3129, 13607, 13608, 13608, 13608, 13608, 13608, 13607, 2456591, 56590, N'2013-10-25', 201343, 43, 5, N'2013-W43', N'2013-W43-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95261, CAST(N'2013-10-26' AS date), CAST(N'2013-10-27' AS date), 2013, 20134, 201310, 2013299, 4, 10, 299, 26, 7, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-20' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-10-25' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-11-01' AS date), 1043, 3129, 13607, 13608, 13608, 13608, 13608, 13608, 13608, 2456592, 56591, N'2013-10-26', 201343, 43, 6, N'2013-W43', N'2013-W43-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95262, CAST(N'2013-10-27' AS date), CAST(N'2013-10-28' AS date), 2013, 20134, 201310, 2013300, 4, 10, 300, 27, 1, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-10-21' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-10-25' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-11-01' AS date), 1043, 3129, 13608, 13608, 13608, 13608, 13608, 13608, 13608, 2456593, 56592, N'2013-10-27', 201343, 43, 7, N'2013-W43', N'2013-W43-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95263, CAST(N'2013-10-28' AS date), CAST(N'2013-10-29' AS date), 2013, 20134, 201310, 2013301, 4, 10, 301, 28, 2, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-10-22' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-10-25' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-11-01' AS date), 1043, 3129, 13608, 13609, 13608, 13608, 13608, 13608, 13608, 2456594, 56593, N'2013-10-28', 201344, 44, 1, N'2013-W44', N'2013-W44-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95264, CAST(N'2013-10-29' AS date), CAST(N'2013-10-30' AS date), 2013, 20134, 201310, 2013302, 4, 10, 302, 29, 3, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-10-23' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-10-25' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-11-01' AS date), 1043, 3129, 13608, 13609, 13609, 13608, 13608, 13608, 13608, 2456595, 56594, N'2013-10-29', 201344, 44, 2, N'2013-W44', N'2013-W44-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95265, CAST(N'2013-10-30' AS date), CAST(N'2013-10-31' AS date), 2013, 20134, 201310, 2013303, 4, 10, 303, 30, 4, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-10-24' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-10-25' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-11-01' AS date), 1043, 3129, 13608, 13609, 13609, 13609, 13608, 13608, 13608, 2456596, 56595, N'2013-10-30', 201344, 44, 3, N'2013-W44', N'2013-W44-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95266, CAST(N'2013-10-31' AS date), CAST(N'2013-11-01' AS date), 2013, 20134, 201310, 2013304, 4, 10, 304, 31, 5, N'2013', N'2013 Q4', N'2013 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-10-25' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-11-01' AS date), 1043, 3129, 13608, 13609, 13609, 13609, 13609, 13608, 13608, 2456597, 56596, N'2013-10-31', 201344, 44, 4, N'2013-W44', N'2013-W44-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95267, CAST(N'2013-11-01' AS date), CAST(N'2013-11-02' AS date), 2013, 20134, 201311, 2013305, 4, 11, 305, 1, 6, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-10-26' AS date), CAST(N'2013-11-01' AS date), 1043, 3130, 13608, 13609, 13609, 13609, 13609, 13609, 13608, 2456598, 56597, N'2013-11-01', 201344, 44, 5, N'2013-W44', N'2013-W44-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95268, CAST(N'2013-11-02' AS date), CAST(N'2013-11-03' AS date), 2013, 20134, 201311, 2013306, 4, 11, 306, 2, 7, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-10-27' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-11-08' AS date), 1043, 3130, 13608, 13609, 13609, 13609, 13609, 13609, 13609, 2456599, 56598, N'2013-11-02', 201344, 44, 6, N'2013-W44', N'2013-W44-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95269, CAST(N'2013-11-03' AS date), CAST(N'2013-11-04' AS date), 2013, 20134, 201311, 2013307, 4, 11, 307, 3, 1, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-10-28' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-11-08' AS date), 1043, 3130, 13609, 13609, 13609, 13609, 13609, 13609, 13609, 2456600, 56599, N'2013-11-03', 201344, 44, 7, N'2013-W44', N'2013-W44-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95270, CAST(N'2013-11-04' AS date), CAST(N'2013-11-05' AS date), 2013, 20134, 201311, 2013308, 4, 11, 308, 4, 2, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-10-29' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-11-08' AS date), 1043, 3130, 13609, 13610, 13609, 13609, 13609, 13609, 13609, 2456601, 56600, N'2013-11-04', 201345, 45, 1, N'2013-W45', N'2013-W45-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95271, CAST(N'2013-11-05' AS date), CAST(N'2013-11-06' AS date), 2013, 20134, 201311, 2013309, 4, 11, 309, 5, 3, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-10-30' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-11-08' AS date), 1043, 3130, 13609, 13610, 13610, 13609, 13609, 13609, 13609, 2456602, 56601, N'2013-11-05', 201345, 45, 2, N'2013-W45', N'2013-W45-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95272, CAST(N'2013-11-06' AS date), CAST(N'2013-11-07' AS date), 2013, 20134, 201311, 2013310, 4, 11, 310, 6, 4, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-10-31' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-11-08' AS date), 1043, 3130, 13609, 13610, 13610, 13610, 13609, 13609, 13609, 2456603, 56602, N'2013-11-06', 201345, 45, 3, N'2013-W45', N'2013-W45-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95273, CAST(N'2013-11-07' AS date), CAST(N'2013-11-08' AS date), 2013, 20134, 201311, 2013311, 4, 11, 311, 7, 5, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-11-08' AS date), 1043, 3130, 13609, 13610, 13610, 13610, 13610, 13609, 13609, 2456604, 56603, N'2013-11-07', 201345, 45, 4, N'2013-W45', N'2013-W45-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95274, CAST(N'2013-11-08' AS date), CAST(N'2013-11-09' AS date), 2013, 20134, 201311, 2013312, 4, 11, 312, 8, 6, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-08' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-02' AS date), CAST(N'2013-11-08' AS date), 1043, 3130, 13609, 13610, 13610, 13610, 13610, 13610, 13609, 2456605, 56604, N'2013-11-08', 201345, 45, 5, N'2013-W45', N'2013-W45-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95275, CAST(N'2013-11-09' AS date), CAST(N'2013-11-10' AS date), 2013, 20134, 201311, 2013313, 4, 11, 313, 9, 7, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-03' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-08' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-15' AS date), 1043, 3130, 13609, 13610, 13610, 13610, 13610, 13610, 13610, 2456606, 56605, N'2013-11-09', 201345, 45, 6, N'2013-W45', N'2013-W45-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95276, CAST(N'2013-11-10' AS date), CAST(N'2013-11-11' AS date), 2013, 20134, 201311, 2013314, 4, 11, 314, 10, 1, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-04' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-08' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-15' AS date), 1043, 3130, 13610, 13610, 13610, 13610, 13610, 13610, 13610, 2456607, 56606, N'2013-11-10', 201345, 45, 7, N'2013-W45', N'2013-W45-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95277, CAST(N'2013-11-11' AS date), CAST(N'2013-11-12' AS date), 2013, 20134, 201311, 2013315, 4, 11, 315, 11, 2, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-05' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-08' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-15' AS date), 1043, 3130, 13610, 13611, 13610, 13610, 13610, 13610, 13610, 2456608, 56607, N'2013-11-11', 201346, 46, 1, N'2013-W46', N'2013-W46-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95278, CAST(N'2013-11-12' AS date), CAST(N'2013-11-13' AS date), 2013, 20134, 201311, 2013316, 4, 11, 316, 12, 3, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-06' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-08' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-15' AS date), 1043, 3130, 13610, 13611, 13611, 13610, 13610, 13610, 13610, 2456609, 56608, N'2013-11-12', 201346, 46, 2, N'2013-W46', N'2013-W46-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95279, CAST(N'2013-11-13' AS date), CAST(N'2013-11-14' AS date), 2013, 20134, 201311, 2013317, 4, 11, 317, 13, 4, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-07' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-08' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-15' AS date), 1043, 3130, 13610, 13611, 13611, 13611, 13610, 13610, 13610, 2456610, 56609, N'2013-11-13', 201346, 46, 3, N'2013-W46', N'2013-W46-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95280, CAST(N'2013-11-14' AS date), CAST(N'2013-11-15' AS date), 2013, 20134, 201311, 2013318, 4, 11, 318, 14, 5, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-08' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-15' AS date), 1043, 3130, 13610, 13611, 13611, 13611, 13611, 13610, 13610, 2456611, 56610, N'2013-11-14', 201346, 46, 4, N'2013-W46', N'2013-W46-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95281, CAST(N'2013-11-15' AS date), CAST(N'2013-11-16' AS date), 2013, 20134, 201311, 2013319, 4, 11, 319, 15, 6, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-15' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-09' AS date), CAST(N'2013-11-15' AS date), 1043, 3130, 13610, 13611, 13611, 13611, 13611, 13611, 13610, 2456612, 56611, N'2013-11-15', 201346, 46, 5, N'2013-W46', N'2013-W46-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95282, CAST(N'2013-11-16' AS date), CAST(N'2013-11-17' AS date), 2013, 20134, 201311, 2013320, 4, 11, 320, 16, 7, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-10' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-15' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-22' AS date), 1043, 3130, 13610, 13611, 13611, 13611, 13611, 13611, 13611, 2456613, 56612, N'2013-11-16', 201346, 46, 6, N'2013-W46', N'2013-W46-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95283, CAST(N'2013-11-17' AS date), CAST(N'2013-11-18' AS date), 2013, 20134, 201311, 2013321, 4, 11, 321, 17, 1, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-11' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-15' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-22' AS date), 1043, 3130, 13611, 13611, 13611, 13611, 13611, 13611, 13611, 2456614, 56613, N'2013-11-17', 201346, 46, 7, N'2013-W46', N'2013-W46-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95284, CAST(N'2013-11-18' AS date), CAST(N'2013-11-19' AS date), 2013, 20134, 201311, 2013322, 4, 11, 322, 18, 2, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-12' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-15' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-22' AS date), 1043, 3130, 13611, 13612, 13611, 13611, 13611, 13611, 13611, 2456615, 56614, N'2013-11-18', 201347, 47, 1, N'2013-W47', N'2013-W47-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95285, CAST(N'2013-11-19' AS date), CAST(N'2013-11-20' AS date), 2013, 20134, 201311, 2013323, 4, 11, 323, 19, 3, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-11-13' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-15' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-22' AS date), 1043, 3130, 13611, 13612, 13612, 13611, 13611, 13611, 13611, 2456616, 56615, N'2013-11-19', 201347, 47, 2, N'2013-W47', N'2013-W47-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95286, CAST(N'2013-11-20' AS date), CAST(N'2013-11-21' AS date), 2013, 20134, 201311, 2013324, 4, 11, 324, 20, 4, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-11-14' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-15' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-22' AS date), 1043, 3130, 13611, 13612, 13612, 13612, 13611, 13611, 13611, 2456617, 56616, N'2013-11-20', 201347, 47, 3, N'2013-W47', N'2013-W47-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95287, CAST(N'2013-11-21' AS date), CAST(N'2013-11-22' AS date), 2013, 20134, 201311, 2013325, 4, 11, 325, 21, 5, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-11-15' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-22' AS date), 1043, 3130, 13611, 13612, 13612, 13612, 13612, 13611, 13611, 2456618, 56617, N'2013-11-21', 201347, 47, 4, N'2013-W47', N'2013-W47-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95288, CAST(N'2013-11-22' AS date), CAST(N'2013-11-23' AS date), 2013, 20134, 201311, 2013326, 4, 11, 326, 22, 6, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-11-22' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-11-16' AS date), CAST(N'2013-11-22' AS date), 1043, 3130, 13611, 13612, 13612, 13612, 13612, 13612, 13611, 2456619, 56618, N'2013-11-22', 201347, 47, 5, N'2013-W47', N'2013-W47-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95289, CAST(N'2013-11-23' AS date), CAST(N'2013-11-24' AS date), 2013, 20134, 201311, 2013327, 4, 11, 327, 23, 7, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-17' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-11-22' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-29' AS date), 1043, 3130, 13611, 13612, 13612, 13612, 13612, 13612, 13612, 2456620, 56619, N'2013-11-23', 201347, 47, 6, N'2013-W47', N'2013-W47-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95290, CAST(N'2013-11-24' AS date), CAST(N'2013-11-25' AS date), 2013, 20134, 201311, 2013328, 4, 11, 328, 24, 1, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-18' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-11-22' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-29' AS date), 1043, 3130, 13612, 13612, 13612, 13612, 13612, 13612, 13612, 2456621, 56620, N'2013-11-24', 201347, 47, 7, N'2013-W47', N'2013-W47-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95291, CAST(N'2013-11-25' AS date), CAST(N'2013-11-26' AS date), 2013, 20134, 201311, 2013329, 4, 11, 329, 25, 2, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-11-19' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-11-22' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-29' AS date), 1043, 3130, 13612, 13613, 13612, 13612, 13612, 13612, 13612, 2456622, 56621, N'2013-11-25', 201348, 48, 1, N'2013-W48', N'2013-W48-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95292, CAST(N'2013-11-26' AS date), CAST(N'2013-11-27' AS date), 2013, 20134, 201311, 2013330, 4, 11, 330, 26, 3, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-11-20' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-11-22' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-29' AS date), 1043, 3130, 13612, 13613, 13613, 13612, 13612, 13612, 13612, 2456623, 56622, N'2013-11-26', 201348, 48, 2, N'2013-W48', N'2013-W48-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95293, CAST(N'2013-11-27' AS date), CAST(N'2013-11-28' AS date), 2013, 20134, 201311, 2013331, 4, 11, 331, 27, 4, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-11-21' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-11-22' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-29' AS date), 1043, 3130, 13612, 13613, 13613, 13613, 13612, 13612, 13612, 2456624, 56623, N'2013-11-27', 201348, 48, 3, N'2013-W48', N'2013-W48-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95294, CAST(N'2013-11-28' AS date), CAST(N'2013-11-29' AS date), 2013, 20134, 201311, 2013332, 4, 11, 332, 28, 5, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-11-22' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-29' AS date), 1043, 3130, 13612, 13613, 13613, 13613, 13613, 13612, 13612, 2456625, 56624, N'2013-11-28', 201348, 48, 4, N'2013-W48', N'2013-W48-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95295, CAST(N'2013-11-29' AS date), CAST(N'2013-11-30' AS date), 2013, 20134, 201311, 2013333, 4, 11, 333, 29, 6, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-11-29' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-11-23' AS date), CAST(N'2013-11-29' AS date), 1043, 3130, 13612, 13613, 13613, 13613, 13613, 13613, 13612, 2456626, 56625, N'2013-11-29', 201348, 48, 5, N'2013-W48', N'2013-W48-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95296, CAST(N'2013-11-30' AS date), CAST(N'2013-12-01' AS date), 2013, 20134, 201311, 2013334, 4, 11, 334, 30, 7, N'2013', N'2013 Q4', N'2013 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-11-01' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-24' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-11-29' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-12-06' AS date), 1043, 3130, 13612, 13613, 13613, 13613, 13613, 13613, 13613, 2456627, 56626, N'2013-11-30', 201348, 48, 6, N'2013-W48', N'2013-W48-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95297, CAST(N'2013-12-01' AS date), CAST(N'2013-12-02' AS date), 2013, 20134, 201312, 2013335, 4, 12, 335, 1, 1, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-11-25' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-11-29' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-12-06' AS date), 1043, 3131, 13613, 13613, 13613, 13613, 13613, 13613, 13613, 2456628, 56627, N'2013-12-01', 201348, 48, 7, N'2013-W48', N'2013-W48-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95298, CAST(N'2013-12-02' AS date), CAST(N'2013-12-03' AS date), 2013, 20134, 201312, 2013336, 4, 12, 336, 2, 2, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-11-26' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-11-29' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-12-06' AS date), 1043, 3131, 13613, 13614, 13613, 13613, 13613, 13613, 13613, 2456629, 56628, N'2013-12-02', 201349, 49, 1, N'2013-W49', N'2013-W49-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95299, CAST(N'2013-12-03' AS date), CAST(N'2013-12-04' AS date), 2013, 20134, 201312, 2013337, 4, 12, 337, 3, 3, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-11-27' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-11-29' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-12-06' AS date), 1043, 3131, 13613, 13614, 13614, 13613, 13613, 13613, 13613, 2456630, 56629, N'2013-12-03', 201349, 49, 2, N'2013-W49', N'2013-W49-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95300, CAST(N'2013-12-04' AS date), CAST(N'2013-12-05' AS date), 2013, 20134, 201312, 2013338, 4, 12, 338, 4, 4, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-11-28' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-11-29' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-12-06' AS date), 1043, 3131, 13613, 13614, 13614, 13614, 13613, 13613, 13613, 2456631, 56630, N'2013-12-04', 201349, 49, 3, N'2013-W49', N'2013-W49-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95301, CAST(N'2013-12-05' AS date), CAST(N'2013-12-06' AS date), 2013, 20134, 201312, 2013339, 4, 12, 339, 5, 5, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-11-29' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-12-06' AS date), 1043, 3131, 13613, 13614, 13614, 13614, 13614, 13613, 13613, 2456632, 56631, N'2013-12-05', 201349, 49, 4, N'2013-W49', N'2013-W49-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95302, CAST(N'2013-12-06' AS date), CAST(N'2013-12-07' AS date), 2013, 20134, 201312, 2013340, 4, 12, 340, 6, 6, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-06' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-11-30' AS date), CAST(N'2013-12-06' AS date), 1043, 3131, 13613, 13614, 13614, 13614, 13614, 13614, 13613, 2456633, 56632, N'2013-12-06', 201349, 49, 5, N'2013-W49', N'2013-W49-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95303, CAST(N'2013-12-07' AS date), CAST(N'2013-12-08' AS date), 2013, 20134, 201312, 2013341, 4, 12, 341, 7, 7, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-06' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-13' AS date), 1043, 3131, 13613, 13614, 13614, 13614, 13614, 13614, 13614, 2456634, 56633, N'2013-12-07', 201349, 49, 6, N'2013-W49', N'2013-W49-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95304, CAST(N'2013-12-08' AS date), CAST(N'2013-12-09' AS date), 2013, 20134, 201312, 2013342, 4, 12, 342, 8, 1, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-02' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-06' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-13' AS date), 1043, 3131, 13614, 13614, 13614, 13614, 13614, 13614, 13614, 2456635, 56634, N'2013-12-08', 201349, 49, 7, N'2013-W49', N'2013-W49-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95305, CAST(N'2013-12-09' AS date), CAST(N'2013-12-10' AS date), 2013, 20134, 201312, 2013343, 4, 12, 343, 9, 2, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-03' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-06' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-13' AS date), 1043, 3131, 13614, 13615, 13614, 13614, 13614, 13614, 13614, 2456636, 56635, N'2013-12-09', 201350, 50, 1, N'2013-W50', N'2013-W50-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95306, CAST(N'2013-12-10' AS date), CAST(N'2013-12-11' AS date), 2013, 20134, 201312, 2013344, 4, 12, 344, 10, 3, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-04' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-06' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-13' AS date), 1043, 3131, 13614, 13615, 13615, 13614, 13614, 13614, 13614, 2456637, 56636, N'2013-12-10', 201350, 50, 2, N'2013-W50', N'2013-W50-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95307, CAST(N'2013-12-11' AS date), CAST(N'2013-12-12' AS date), 2013, 20134, 201312, 2013345, 4, 12, 345, 11, 4, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-05' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-06' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-13' AS date), 1043, 3131, 13614, 13615, 13615, 13615, 13614, 13614, 13614, 2456638, 56637, N'2013-12-11', 201350, 50, 3, N'2013-W50', N'2013-W50-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95308, CAST(N'2013-12-12' AS date), CAST(N'2013-12-13' AS date), 2013, 20134, 201312, 2013346, 4, 12, 346, 12, 5, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-06' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-13' AS date), 1043, 3131, 13614, 13615, 13615, 13615, 13615, 13614, 13614, 2456639, 56638, N'2013-12-12', 201350, 50, 4, N'2013-W50', N'2013-W50-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95309, CAST(N'2013-12-13' AS date), CAST(N'2013-12-14' AS date), 2013, 20134, 201312, 2013347, 4, 12, 347, 13, 6, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-13' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-07' AS date), CAST(N'2013-12-13' AS date), 1043, 3131, 13614, 13615, 13615, 13615, 13615, 13615, 13614, 2456640, 56639, N'2013-12-13', 201350, 50, 5, N'2013-W50', N'2013-W50-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95310, CAST(N'2013-12-14' AS date), CAST(N'2013-12-15' AS date), 2013, 20134, 201312, 2013348, 4, 12, 348, 14, 7, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-08' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-13' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-20' AS date), 1043, 3131, 13614, 13615, 13615, 13615, 13615, 13615, 13615, 2456641, 56640, N'2013-12-14', 201350, 50, 6, N'2013-W50', N'2013-W50-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95311, CAST(N'2013-12-15' AS date), CAST(N'2013-12-16' AS date), 2013, 20134, 201312, 2013349, 4, 12, 349, 15, 1, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-09' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-13' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-20' AS date), 1043, 3131, 13615, 13615, 13615, 13615, 13615, 13615, 13615, 2456642, 56641, N'2013-12-15', 201350, 50, 7, N'2013-W50', N'2013-W50-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95312, CAST(N'2013-12-16' AS date), CAST(N'2013-12-17' AS date), 2013, 20134, 201312, 2013350, 4, 12, 350, 16, 2, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-10' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-13' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-20' AS date), 1043, 3131, 13615, 13616, 13615, 13615, 13615, 13615, 13615, 2456643, 56642, N'2013-12-16', 201351, 51, 1, N'2013-W51', N'2013-W51-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95313, CAST(N'2013-12-17' AS date), CAST(N'2013-12-18' AS date), 2013, 20134, 201312, 2013351, 4, 12, 351, 17, 3, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-11' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-13' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-20' AS date), 1043, 3131, 13615, 13616, 13616, 13615, 13615, 13615, 13615, 2456644, 56643, N'2013-12-17', 201351, 51, 2, N'2013-W51', N'2013-W51-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95314, CAST(N'2013-12-18' AS date), CAST(N'2013-12-19' AS date), 2013, 20134, 201312, 2013352, 4, 12, 352, 18, 4, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-12' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-13' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-20' AS date), 1043, 3131, 13615, 13616, 13616, 13616, 13615, 13615, 13615, 2456645, 56644, N'2013-12-18', 201351, 51, 3, N'2013-W51', N'2013-W51-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95315, CAST(N'2013-12-19' AS date), CAST(N'2013-12-20' AS date), 2013, 20134, 201312, 2013353, 4, 12, 353, 19, 5, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-13' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-20' AS date), 1043, 3131, 13615, 13616, 13616, 13616, 13616, 13615, 13615, 2456646, 56645, N'2013-12-19', 201351, 51, 4, N'2013-W51', N'2013-W51-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95316, CAST(N'2013-12-20' AS date), CAST(N'2013-12-21' AS date), 2013, 20134, 201312, 2013354, 4, 12, 354, 20, 6, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-20' AS date), CAST(N'2013-12-26' AS date), CAST(N'2013-12-14' AS date), CAST(N'2013-12-20' AS date), 1043, 3131, 13615, 13616, 13616, 13616, 13616, 13616, 13615, 2456647, 56646, N'2013-12-20', 201351, 51, 5, N'2013-W51', N'2013-W51-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95317, CAST(N'2013-12-21' AS date), CAST(N'2013-12-22' AS date), 2013, 20134, 201312, 2013355, 4, 12, 355, 21, 7, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-15' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-20' AS date), CAST(N'2013-12-26' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-27' AS date), 1043, 3131, 13615, 13616, 13616, 13616, 13616, 13616, 13616, 2456648, 56647, N'2013-12-21', 201351, 51, 6, N'2013-W51', N'2013-W51-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95318, CAST(N'2013-12-22' AS date), CAST(N'2013-12-23' AS date), 2013, 20134, 201312, 2013356, 4, 12, 356, 22, 1, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-28' AS date), CAST(N'2013-12-16' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-20' AS date), CAST(N'2013-12-26' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-27' AS date), 1043, 3131, 13616, 13616, 13616, 13616, 13616, 13616, 13616, 2456649, 56648, N'2013-12-22', 201351, 51, 7, N'2013-W51', N'2013-W51-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95319, CAST(N'2013-12-23' AS date), CAST(N'2013-12-24' AS date), 2013, 20134, 201312, 2013357, 4, 12, 357, 23, 2, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-28' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-29' AS date), CAST(N'2013-12-17' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-20' AS date), CAST(N'2013-12-26' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-27' AS date), 1043, 3131, 13616, 13617, 13616, 13616, 13616, 13616, 13616, 2456650, 56649, N'2013-12-23', 201352, 52, 1, N'2013-W52', N'2013-W52-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95320, CAST(N'2013-12-24' AS date), CAST(N'2013-12-25' AS date), 2013, 20134, 201312, 2013358, 4, 12, 358, 24, 3, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-28' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-29' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-30' AS date), CAST(N'2013-12-18' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-20' AS date), CAST(N'2013-12-26' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-27' AS date), 1043, 3131, 13616, 13617, 13617, 13616, 13616, 13616, 13616, 2456651, 56650, N'2013-12-24', 201352, 52, 2, N'2013-W52', N'2013-W52-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95321, CAST(N'2013-12-25' AS date), CAST(N'2013-12-26' AS date), 2013, 20134, 201312, 2013359, 4, 12, 359, 25, 4, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-28' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-29' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-30' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-19' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-20' AS date), CAST(N'2013-12-26' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-27' AS date), 1043, 3131, 13616, 13617, 13617, 13617, 13616, 13616, 13616, 2456652, 56651, N'2013-12-25', 201352, 52, 3, N'2013-W52', N'2013-W52-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95322, CAST(N'2013-12-26' AS date), CAST(N'2013-12-27' AS date), 2013, 20134, 201312, 2013360, 4, 12, 360, 26, 5, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-28' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-29' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-30' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-26' AS date), CAST(N'2014-01-01' AS date), CAST(N'2013-12-20' AS date), CAST(N'2013-12-26' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-27' AS date), 1043, 3131, 13616, 13617, 13617, 13617, 13617, 13616, 13616, 2456653, 56652, N'2013-12-26', 201352, 52, 4, N'2013-W52', N'2013-W52-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95323, CAST(N'2013-12-27' AS date), CAST(N'2013-12-28' AS date), 2013, 20134, 201312, 2013361, 4, 12, 361, 27, 6, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-28' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-29' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-30' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-26' AS date), CAST(N'2014-01-01' AS date), CAST(N'2013-12-27' AS date), CAST(N'2014-01-02' AS date), CAST(N'2013-12-21' AS date), CAST(N'2013-12-27' AS date), 1043, 3131, 13616, 13617, 13617, 13617, 13617, 13617, 13616, 2456654, 56653, N'2013-12-27', 201352, 52, 5, N'2013-W52', N'2013-W52-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95324, CAST(N'2013-12-28' AS date), CAST(N'2013-12-29' AS date), 2013, 20134, 201312, 2013362, 4, 12, 362, 28, 7, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-22' AS date), CAST(N'2013-12-28' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-29' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-30' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-26' AS date), CAST(N'2014-01-01' AS date), CAST(N'2013-12-27' AS date), CAST(N'2014-01-02' AS date), CAST(N'2013-12-28' AS date), CAST(N'2014-01-03' AS date), 1043, 3131, 13616, 13617, 13617, 13617, 13617, 13617, 13617, 2456655, 56654, N'2013-12-28', 201352, 52, 6, N'2013-W52', N'2013-W52-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95325, CAST(N'2013-12-29' AS date), CAST(N'2013-12-30' AS date), 2013, 20134, 201312, 2013363, 4, 12, 363, 29, 1, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-29' AS date), CAST(N'2014-01-04' AS date), CAST(N'2013-12-23' AS date), CAST(N'2013-12-29' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-30' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-26' AS date), CAST(N'2014-01-01' AS date), CAST(N'2013-12-27' AS date), CAST(N'2014-01-02' AS date), CAST(N'2013-12-28' AS date), CAST(N'2014-01-03' AS date), 1043, 3131, 13617, 13617, 13617, 13617, 13617, 13617, 13617, 2456656, 56655, N'2013-12-29', 201352, 52, 7, N'2013-W52', N'2013-W52-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95326, CAST(N'2013-12-30' AS date), CAST(N'2013-12-31' AS date), 2013, 20134, 201312, 2013364, 4, 12, 364, 30, 2, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-29' AS date), CAST(N'2014-01-04' AS date), CAST(N'2013-12-30' AS date), CAST(N'2014-01-05' AS date), CAST(N'2013-12-24' AS date), CAST(N'2013-12-30' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-26' AS date), CAST(N'2014-01-01' AS date), CAST(N'2013-12-27' AS date), CAST(N'2014-01-02' AS date), CAST(N'2013-12-28' AS date), CAST(N'2014-01-03' AS date), 1043, 3131, 13617, 13618, 13617, 13617, 13617, 13617, 13617, 2456657, 56656, N'2013-12-30', 201401, 1, 1, N'2014-W01', N'2014-W01-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95327, CAST(N'2013-12-31' AS date), CAST(N'2014-01-01' AS date), 2013, 20134, 201312, 2013365, 4, 12, 365, 31, 3, N'2013', N'2013 Q4', N'2013 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2013-01-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-10-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-01' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-29' AS date), CAST(N'2014-01-04' AS date), CAST(N'2013-12-30' AS date), CAST(N'2014-01-05' AS date), CAST(N'2013-12-31' AS date), CAST(N'2014-01-06' AS date), CAST(N'2013-12-25' AS date), CAST(N'2013-12-31' AS date), CAST(N'2013-12-26' AS date), CAST(N'2014-01-01' AS date), CAST(N'2013-12-27' AS date), CAST(N'2014-01-02' AS date), CAST(N'2013-12-28' AS date), CAST(N'2014-01-03' AS date), 1043, 3131, 13617, 13618, 13618, 13617, 13617, 13617, 13617, 2456658, 56657, N'2013-12-31', 201401, 1, 2, N'2014-W01', N'2014-W01-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95328, CAST(N'2014-01-01' AS date), CAST(N'2014-01-02' AS date), 2014, 20141, 201401, 2014001, 1, 1, 1, 1, 4, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2013-12-29' AS date), CAST(N'2014-01-04' AS date), CAST(N'2013-12-30' AS date), CAST(N'2014-01-05' AS date), CAST(N'2013-12-31' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-07' AS date), CAST(N'2013-12-26' AS date), CAST(N'2014-01-01' AS date), CAST(N'2013-12-27' AS date), CAST(N'2014-01-02' AS date), CAST(N'2013-12-28' AS date), CAST(N'2014-01-03' AS date), 1044, 3132, 13617, 13618, 13618, 13618, 13617, 13617, 13617, 2456659, 56658, N'2014-01-01', 201401, 1, 3, N'2014-W01', N'2014-W01-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95329, CAST(N'2014-01-02' AS date), CAST(N'2014-01-03' AS date), 2014, 20141, 201401, 2014002, 1, 1, 2, 2, 5, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2013-12-29' AS date), CAST(N'2014-01-04' AS date), CAST(N'2013-12-30' AS date), CAST(N'2014-01-05' AS date), CAST(N'2013-12-31' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-02' AS date), CAST(N'2014-01-08' AS date), CAST(N'2013-12-27' AS date), CAST(N'2014-01-02' AS date), CAST(N'2013-12-28' AS date), CAST(N'2014-01-03' AS date), 1044, 3132, 13617, 13618, 13618, 13618, 13618, 13617, 13617, 2456660, 56659, N'2014-01-02', 201401, 1, 4, N'2014-W01', N'2014-W01-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95330, CAST(N'2014-01-03' AS date), CAST(N'2014-01-04' AS date), 2014, 20141, 201401, 2014003, 1, 1, 3, 3, 6, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2013-12-29' AS date), CAST(N'2014-01-04' AS date), CAST(N'2013-12-30' AS date), CAST(N'2014-01-05' AS date), CAST(N'2013-12-31' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-02' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-03' AS date), CAST(N'2014-01-09' AS date), CAST(N'2013-12-28' AS date), CAST(N'2014-01-03' AS date), 1044, 3132, 13617, 13618, 13618, 13618, 13618, 13618, 13617, 2456661, 56660, N'2014-01-03', 201401, 1, 5, N'2014-W01', N'2014-W01-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95331, CAST(N'2014-01-04' AS date), CAST(N'2014-01-05' AS date), 2014, 20141, 201401, 2014004, 1, 1, 4, 4, 7, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2013-12-29' AS date), CAST(N'2014-01-04' AS date), CAST(N'2013-12-30' AS date), CAST(N'2014-01-05' AS date), CAST(N'2013-12-31' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-02' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-03' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-04' AS date), CAST(N'2014-01-10' AS date), 1044, 3132, 13617, 13618, 13618, 13618, 13618, 13618, 13618, 2456662, 56661, N'2014-01-04', 201401, 1, 6, N'2014-W01', N'2014-W01-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95332, CAST(N'2014-01-05' AS date), CAST(N'2014-01-06' AS date), 2014, 20141, 201401, 2014005, 1, 1, 5, 5, 1, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-05' AS date), CAST(N'2014-01-11' AS date), CAST(N'2013-12-30' AS date), CAST(N'2014-01-05' AS date), CAST(N'2013-12-31' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-02' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-03' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-04' AS date), CAST(N'2014-01-10' AS date), 1044, 3132, 13618, 13618, 13618, 13618, 13618, 13618, 13618, 2456663, 56662, N'2014-01-05', 201401, 1, 7, N'2014-W01', N'2014-W01-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95333, CAST(N'2014-01-06' AS date), CAST(N'2014-01-07' AS date), 2014, 20141, 201401, 2014006, 1, 1, 6, 6, 2, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-05' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-12' AS date), CAST(N'2013-12-31' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-02' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-03' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-04' AS date), CAST(N'2014-01-10' AS date), 1044, 3132, 13618, 13619, 13618, 13618, 13618, 13618, 13618, 2456664, 56663, N'2014-01-06', 201402, 2, 1, N'2014-W02', N'2014-W02-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95334, CAST(N'2014-01-07' AS date), CAST(N'2014-01-08' AS date), 2014, 20141, 201401, 2014007, 1, 1, 7, 7, 3, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-05' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-02' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-03' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-04' AS date), CAST(N'2014-01-10' AS date), 1044, 3132, 13618, 13619, 13619, 13618, 13618, 13618, 13618, 2456665, 56664, N'2014-01-07', 201402, 2, 2, N'2014-W02', N'2014-W02-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95335, CAST(N'2014-01-08' AS date), CAST(N'2014-01-09' AS date), 2014, 20141, 201401, 2014008, 1, 1, 8, 8, 4, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-05' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-02' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-03' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-04' AS date), CAST(N'2014-01-10' AS date), 1044, 3132, 13618, 13619, 13619, 13619, 13618, 13618, 13618, 2456666, 56665, N'2014-01-08', 201402, 2, 3, N'2014-W02', N'2014-W02-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95336, CAST(N'2014-01-09' AS date), CAST(N'2014-01-10' AS date), 2014, 20141, 201401, 2014009, 1, 1, 9, 9, 5, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-05' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-03' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-04' AS date), CAST(N'2014-01-10' AS date), 1044, 3132, 13618, 13619, 13619, 13619, 13619, 13618, 13618, 2456667, 56666, N'2014-01-09', 201402, 2, 4, N'2014-W02', N'2014-W02-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95337, CAST(N'2014-01-10' AS date), CAST(N'2014-01-11' AS date), 2014, 20141, 201401, 2014010, 1, 1, 10, 10, 6, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-05' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-10' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-04' AS date), CAST(N'2014-01-10' AS date), 1044, 3132, 13618, 13619, 13619, 13619, 13619, 13619, 13618, 2456668, 56667, N'2014-01-10', 201402, 2, 5, N'2014-W02', N'2014-W02-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95338, CAST(N'2014-01-11' AS date), CAST(N'2014-01-12' AS date), 2014, 20141, 201401, 2014011, 1, 1, 11, 11, 7, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-05' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-10' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-17' AS date), 1044, 3132, 13618, 13619, 13619, 13619, 13619, 13619, 13619, 2456669, 56668, N'2014-01-11', 201402, 2, 6, N'2014-W02', N'2014-W02-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95339, CAST(N'2014-01-12' AS date), CAST(N'2014-01-13' AS date), 2014, 20141, 201401, 2014012, 1, 1, 12, 12, 1, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-06' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-10' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-17' AS date), 1044, 3132, 13619, 13619, 13619, 13619, 13619, 13619, 13619, 2456670, 56669, N'2014-01-12', 201402, 2, 7, N'2014-W02', N'2014-W02-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95340, CAST(N'2014-01-13' AS date), CAST(N'2014-01-14' AS date), 2014, 20141, 201401, 2014013, 1, 1, 13, 13, 2, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-07' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-10' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-17' AS date), 1044, 3132, 13619, 13620, 13619, 13619, 13619, 13619, 13619, 2456671, 56670, N'2014-01-13', 201403, 3, 1, N'2014-W03', N'2014-W03-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95341, CAST(N'2014-01-14' AS date), CAST(N'2014-01-15' AS date), 2014, 20141, 201401, 2014014, 1, 1, 14, 14, 3, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-08' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-10' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-17' AS date), 1044, 3132, 13619, 13620, 13620, 13619, 13619, 13619, 13619, 2456672, 56671, N'2014-01-14', 201403, 3, 2, N'2014-W03', N'2014-W03-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95342, CAST(N'2014-01-15' AS date), CAST(N'2014-01-16' AS date), 2014, 20141, 201401, 2014015, 1, 1, 15, 15, 4, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-09' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-10' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-17' AS date), 1044, 3132, 13619, 13620, 13620, 13620, 13619, 13619, 13619, 2456673, 56672, N'2014-01-15', 201403, 3, 3, N'2014-W03', N'2014-W03-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95343, CAST(N'2014-01-16' AS date), CAST(N'2014-01-17' AS date), 2014, 20141, 201401, 2014016, 1, 1, 16, 16, 5, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-10' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-17' AS date), 1044, 3132, 13619, 13620, 13620, 13620, 13620, 13619, 13619, 2456674, 56673, N'2014-01-16', 201403, 3, 4, N'2014-W03', N'2014-W03-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95344, CAST(N'2014-01-17' AS date), CAST(N'2014-01-18' AS date), 2014, 20141, 201401, 2014017, 1, 1, 17, 17, 6, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-17' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-11' AS date), CAST(N'2014-01-17' AS date), 1044, 3132, 13619, 13620, 13620, 13620, 13620, 13620, 13619, 2456675, 56674, N'2014-01-17', 201403, 3, 5, N'2014-W03', N'2014-W03-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95345, CAST(N'2014-01-18' AS date), CAST(N'2014-01-19' AS date), 2014, 20141, 201401, 2014018, 1, 1, 18, 18, 7, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-12' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-17' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-24' AS date), 1044, 3132, 13619, 13620, 13620, 13620, 13620, 13620, 13620, 2456676, 56675, N'2014-01-18', 201403, 3, 6, N'2014-W03', N'2014-W03-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95346, CAST(N'2014-01-19' AS date), CAST(N'2014-01-20' AS date), 2014, 20141, 201401, 2014019, 1, 1, 19, 19, 1, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-13' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-17' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-24' AS date), 1044, 3132, 13620, 13620, 13620, 13620, 13620, 13620, 13620, 2456677, 56676, N'2014-01-19', 201403, 3, 7, N'2014-W03', N'2014-W03-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95347, CAST(N'2014-01-20' AS date), CAST(N'2014-01-21' AS date), 2014, 20141, 201401, 2014020, 1, 1, 20, 20, 2, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-01-14' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-17' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-24' AS date), 1044, 3132, 13620, 13621, 13620, 13620, 13620, 13620, 13620, 2456678, 56677, N'2014-01-20', 201404, 4, 1, N'2014-W04', N'2014-W04-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95348, CAST(N'2014-01-21' AS date), CAST(N'2014-01-22' AS date), 2014, 20141, 201401, 2014021, 1, 1, 21, 21, 3, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-01-15' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-17' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-24' AS date), 1044, 3132, 13620, 13621, 13621, 13620, 13620, 13620, 13620, 2456679, 56678, N'2014-01-21', 201404, 4, 2, N'2014-W04', N'2014-W04-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95349, CAST(N'2014-01-22' AS date), CAST(N'2014-01-23' AS date), 2014, 20141, 201401, 2014022, 1, 1, 22, 22, 4, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-01-16' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-17' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-24' AS date), 1044, 3132, 13620, 13621, 13621, 13621, 13620, 13620, 13620, 2456680, 56679, N'2014-01-22', 201404, 4, 3, N'2014-W04', N'2014-W04-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95350, CAST(N'2014-01-23' AS date), CAST(N'2014-01-24' AS date), 2014, 20141, 201401, 2014023, 1, 1, 23, 23, 5, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-01-17' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-24' AS date), 1044, 3132, 13620, 13621, 13621, 13621, 13621, 13620, 13620, 2456681, 56680, N'2014-01-23', 201404, 4, 4, N'2014-W04', N'2014-W04-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95351, CAST(N'2014-01-24' AS date), CAST(N'2014-01-25' AS date), 2014, 20141, 201401, 2014024, 1, 1, 24, 24, 6, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-01-24' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-01-18' AS date), CAST(N'2014-01-24' AS date), 1044, 3132, 13620, 13621, 13621, 13621, 13621, 13621, 13620, 2456682, 56681, N'2014-01-24', 201404, 4, 5, N'2014-W04', N'2014-W04-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95352, CAST(N'2014-01-25' AS date), CAST(N'2014-01-26' AS date), 2014, 20141, 201401, 2014025, 1, 1, 25, 25, 7, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-19' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-01-24' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-31' AS date), 1044, 3132, 13620, 13621, 13621, 13621, 13621, 13621, 13621, 2456683, 56682, N'2014-01-25', 201404, 4, 6, N'2014-W04', N'2014-W04-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95353, CAST(N'2014-01-26' AS date), CAST(N'2014-01-27' AS date), 2014, 20141, 201401, 2014026, 1, 1, 26, 26, 1, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-01-20' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-01-24' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-31' AS date), 1044, 3132, 13621, 13621, 13621, 13621, 13621, 13621, 13621, 2456684, 56683, N'2014-01-26', 201404, 4, 7, N'2014-W04', N'2014-W04-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95354, CAST(N'2014-01-27' AS date), CAST(N'2014-01-28' AS date), 2014, 20141, 201401, 2014027, 1, 1, 27, 27, 2, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-01-21' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-01-24' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-31' AS date), 1044, 3132, 13621, 13622, 13621, 13621, 13621, 13621, 13621, 2456685, 56684, N'2014-01-27', 201405, 5, 1, N'2014-W05', N'2014-W05-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95355, CAST(N'2014-01-28' AS date), CAST(N'2014-01-29' AS date), 2014, 20141, 201401, 2014028, 1, 1, 28, 28, 3, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-01-22' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-01-24' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-31' AS date), 1044, 3132, 13621, 13622, 13622, 13621, 13621, 13621, 13621, 2456686, 56685, N'2014-01-28', 201405, 5, 2, N'2014-W05', N'2014-W05-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95356, CAST(N'2014-01-29' AS date), CAST(N'2014-01-30' AS date), 2014, 20141, 201401, 2014029, 1, 1, 29, 29, 4, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-01-23' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-01-24' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-31' AS date), 1044, 3132, 13621, 13622, 13622, 13622, 13621, 13621, 13621, 2456687, 56686, N'2014-01-29', 201405, 5, 3, N'2014-W05', N'2014-W05-3');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95357, CAST(N'2014-01-30' AS date), CAST(N'2014-01-31' AS date), 2014, 20141, 201401, 2014030, 1, 1, 30, 30, 5, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-01-24' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-31' AS date), 1044, 3132, 13621, 13622, 13622, 13622, 13622, 13621, 13621, 2456688, 56687, N'2014-01-30', 201405, 5, 4, N'2014-W05', N'2014-W05-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95358, CAST(N'2014-01-31' AS date), CAST(N'2014-02-01' AS date), 2014, 20141, 201401, 2014031, 1, 1, 31, 31, 6, N'2014', N'2014 Q1', N'2014 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-01-25' AS date), CAST(N'2014-01-31' AS date), 1044, 3132, 13621, 13622, 13622, 13622, 13622, 13622, 13621, 2456689, 56688, N'2014-01-31', 201405, 5, 5, N'2014-W05', N'2014-W05-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95359, CAST(N'2014-02-01' AS date), CAST(N'2014-02-02' AS date), 2014, 20141, 201402, 2014032, 1, 2, 32, 1, 7, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-01-26' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-07' AS date), 1044, 3133, 13621, 13622, 13622, 13622, 13622, 13622, 13622, 2456690, 56689, N'2014-02-01', 201405, 5, 6, N'2014-W05', N'2014-W05-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95360, CAST(N'2014-02-02' AS date), CAST(N'2014-02-03' AS date), 2014, 20141, 201402, 2014033, 1, 2, 33, 2, 1, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-01-27' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-07' AS date), 1044, 3133, 13622, 13622, 13622, 13622, 13622, 13622, 13622, 2456691, 56690, N'2014-02-02', 201405, 5, 7, N'2014-W05', N'2014-W05-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95361, CAST(N'2014-02-03' AS date), CAST(N'2014-02-04' AS date), 2014, 20141, 201402, 2014034, 1, 2, 34, 3, 2, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-01-28' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-07' AS date), 1044, 3133, 13622, 13623, 13622, 13622, 13622, 13622, 13622, 2456692, 56691, N'2014-02-03', 201406, 6, 1, N'2014-W06', N'2014-W06-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95362, CAST(N'2014-02-04' AS date), CAST(N'2014-02-05' AS date), 2014, 20141, 201402, 2014035, 1, 2, 35, 4, 3, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-01-29' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-07' AS date), 1044, 3133, 13622, 13623, 13623, 13622, 13622, 13622, 13622, 2456693, 56692, N'2014-02-04', 201406, 6, 2, N'2014-W06', N'2014-W06-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95363, CAST(N'2014-02-05' AS date), CAST(N'2014-02-06' AS date), 2014, 20141, 201402, 2014036, 1, 2, 36, 5, 4, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-01-30' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-07' AS date), 1044, 3133, 13622, 13623, 13623, 13623, 13622, 13622, 13622, 2456694, 56693, N'2014-02-05', 201406, 6, 3, N'2014-W06', N'2014-W06-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95364, CAST(N'2014-02-06' AS date), CAST(N'2014-02-07' AS date), 2014, 20141, 201402, 2014037, 1, 2, 37, 6, 5, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-01-31' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-07' AS date), 1044, 3133, 13622, 13623, 13623, 13623, 13623, 13622, 13622, 2456695, 56694, N'2014-02-06', 201406, 6, 4, N'2014-W06', N'2014-W06-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95365, CAST(N'2014-02-07' AS date), CAST(N'2014-02-08' AS date), 2014, 20141, 201402, 2014038, 1, 2, 38, 7, 6, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-07' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-07' AS date), 1044, 3133, 13622, 13623, 13623, 13623, 13623, 13623, 13622, 2456696, 56695, N'2014-02-07', 201406, 6, 5, N'2014-W06', N'2014-W06-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95366, CAST(N'2014-02-08' AS date), CAST(N'2014-02-09' AS date), 2014, 20141, 201402, 2014039, 1, 2, 39, 8, 7, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-02' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-07' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-14' AS date), 1044, 3133, 13622, 13623, 13623, 13623, 13623, 13623, 13623, 2456697, 56696, N'2014-02-08', 201406, 6, 6, N'2014-W06', N'2014-W06-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95367, CAST(N'2014-02-09' AS date), CAST(N'2014-02-10' AS date), 2014, 20141, 201402, 2014040, 1, 2, 40, 9, 1, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-03' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-07' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-14' AS date), 1044, 3133, 13623, 13623, 13623, 13623, 13623, 13623, 13623, 2456698, 56697, N'2014-02-09', 201406, 6, 7, N'2014-W06', N'2014-W06-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95368, CAST(N'2014-02-10' AS date), CAST(N'2014-02-11' AS date), 2014, 20141, 201402, 2014041, 1, 2, 41, 10, 2, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-04' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-07' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-14' AS date), 1044, 3133, 13623, 13624, 13623, 13623, 13623, 13623, 13623, 2456699, 56698, N'2014-02-10', 201407, 7, 1, N'2014-W07', N'2014-W07-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95369, CAST(N'2014-02-11' AS date), CAST(N'2014-02-12' AS date), 2014, 20141, 201402, 2014042, 1, 2, 42, 11, 3, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-05' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-07' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-14' AS date), 1044, 3133, 13623, 13624, 13624, 13623, 13623, 13623, 13623, 2456700, 56699, N'2014-02-11', 201407, 7, 2, N'2014-W07', N'2014-W07-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95370, CAST(N'2014-02-12' AS date), CAST(N'2014-02-13' AS date), 2014, 20141, 201402, 2014043, 1, 2, 43, 12, 4, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-06' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-07' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-14' AS date), 1044, 3133, 13623, 13624, 13624, 13624, 13623, 13623, 13623, 2456701, 56700, N'2014-02-12', 201407, 7, 3, N'2014-W07', N'2014-W07-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95371, CAST(N'2014-02-13' AS date), CAST(N'2014-02-14' AS date), 2014, 20141, 201402, 2014044, 1, 2, 44, 13, 5, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-07' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-14' AS date), 1044, 3133, 13623, 13624, 13624, 13624, 13624, 13623, 13623, 2456702, 56701, N'2014-02-13', 201407, 7, 4, N'2014-W07', N'2014-W07-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95372, CAST(N'2014-02-14' AS date), CAST(N'2014-02-15' AS date), 2014, 20141, 201402, 2014045, 1, 2, 45, 14, 6, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-14' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-08' AS date), CAST(N'2014-02-14' AS date), 1044, 3133, 13623, 13624, 13624, 13624, 13624, 13624, 13623, 2456703, 56702, N'2014-02-14', 201407, 7, 5, N'2014-W07', N'2014-W07-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95373, CAST(N'2014-02-15' AS date), CAST(N'2014-02-16' AS date), 2014, 20141, 201402, 2014046, 1, 2, 46, 15, 7, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-09' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-14' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-21' AS date), 1044, 3133, 13623, 13624, 13624, 13624, 13624, 13624, 13624, 2456704, 56703, N'2014-02-15', 201407, 7, 6, N'2014-W07', N'2014-W07-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95374, CAST(N'2014-02-16' AS date), CAST(N'2014-02-17' AS date), 2014, 20141, 201402, 2014047, 1, 2, 47, 16, 1, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-10' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-14' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-21' AS date), 1044, 3133, 13624, 13624, 13624, 13624, 13624, 13624, 13624, 2456705, 56704, N'2014-02-16', 201407, 7, 7, N'2014-W07', N'2014-W07-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95375, CAST(N'2014-02-17' AS date), CAST(N'2014-02-18' AS date), 2014, 20141, 201402, 2014048, 1, 2, 48, 17, 2, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-02-11' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-14' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-21' AS date), 1044, 3133, 13624, 13625, 13624, 13624, 13624, 13624, 13624, 2456706, 56705, N'2014-02-17', 201408, 8, 1, N'2014-W08', N'2014-W08-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95376, CAST(N'2014-02-18' AS date), CAST(N'2014-02-19' AS date), 2014, 20141, 201402, 2014049, 1, 2, 49, 18, 3, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-02-12' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-14' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-21' AS date), 1044, 3133, 13624, 13625, 13625, 13624, 13624, 13624, 13624, 2456707, 56706, N'2014-02-18', 201408, 8, 2, N'2014-W08', N'2014-W08-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95377, CAST(N'2014-02-19' AS date), CAST(N'2014-02-20' AS date), 2014, 20141, 201402, 2014050, 1, 2, 50, 19, 4, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-02-13' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-14' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-21' AS date), 1044, 3133, 13624, 13625, 13625, 13625, 13624, 13624, 13624, 2456708, 56707, N'2014-02-19', 201408, 8, 3, N'2014-W08', N'2014-W08-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95378, CAST(N'2014-02-20' AS date), CAST(N'2014-02-21' AS date), 2014, 20141, 201402, 2014051, 1, 2, 51, 20, 5, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-02-14' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-21' AS date), 1044, 3133, 13624, 13625, 13625, 13625, 13625, 13624, 13624, 2456709, 56708, N'2014-02-20', 201408, 8, 4, N'2014-W08', N'2014-W08-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95379, CAST(N'2014-02-21' AS date), CAST(N'2014-02-22' AS date), 2014, 20141, 201402, 2014052, 1, 2, 52, 21, 6, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-02-21' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-02-15' AS date), CAST(N'2014-02-21' AS date), 1044, 3133, 13624, 13625, 13625, 13625, 13625, 13625, 13624, 2456710, 56709, N'2014-02-21', 201408, 8, 5, N'2014-W08', N'2014-W08-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95380, CAST(N'2014-02-22' AS date), CAST(N'2014-02-23' AS date), 2014, 20141, 201402, 2014053, 1, 2, 53, 22, 7, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-16' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-02-21' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-28' AS date), 1044, 3133, 13624, 13625, 13625, 13625, 13625, 13625, 13625, 2456711, 56710, N'2014-02-22', 201408, 8, 6, N'2014-W08', N'2014-W08-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95381, CAST(N'2014-02-23' AS date), CAST(N'2014-02-24' AS date), 2014, 20141, 201402, 2014054, 1, 2, 54, 23, 1, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-02-17' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-02-21' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-28' AS date), 1044, 3133, 13625, 13625, 13625, 13625, 13625, 13625, 13625, 2456712, 56711, N'2014-02-23', 201408, 8, 7, N'2014-W08', N'2014-W08-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95382, CAST(N'2014-02-24' AS date), CAST(N'2014-02-25' AS date), 2014, 20141, 201402, 2014055, 1, 2, 55, 24, 2, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-02-18' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-02-21' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-28' AS date), 1044, 3133, 13625, 13626, 13625, 13625, 13625, 13625, 13625, 2456713, 56712, N'2014-02-24', 201409, 9, 1, N'2014-W09', N'2014-W09-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95383, CAST(N'2014-02-25' AS date), CAST(N'2014-02-26' AS date), 2014, 20141, 201402, 2014056, 1, 2, 56, 25, 3, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-02-19' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-02-21' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-28' AS date), 1044, 3133, 13625, 13626, 13626, 13625, 13625, 13625, 13625, 2456714, 56713, N'2014-02-25', 201409, 9, 2, N'2014-W09', N'2014-W09-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95384, CAST(N'2014-02-26' AS date), CAST(N'2014-02-27' AS date), 2014, 20141, 201402, 2014057, 1, 2, 57, 26, 4, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-02-20' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-02-21' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-28' AS date), 1044, 3133, 13625, 13626, 13626, 13626, 13625, 13625, 13625, 2456715, 56714, N'2014-02-26', 201409, 9, 3, N'2014-W09', N'2014-W09-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95385, CAST(N'2014-02-27' AS date), CAST(N'2014-02-28' AS date), 2014, 20141, 201402, 2014058, 1, 2, 58, 27, 5, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-02-21' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-28' AS date), 1044, 3133, 13625, 13626, 13626, 13626, 13626, 13625, 13625, 2456716, 56715, N'2014-02-27', 201409, 9, 4, N'2014-W09', N'2014-W09-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95386, CAST(N'2014-02-28' AS date), CAST(N'2014-03-01' AS date), 2014, 20141, 201402, 2014059, 1, 2, 59, 28, 6, N'2014', N'2014 Q1', N'2014 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-01' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-02-22' AS date), CAST(N'2014-02-28' AS date), 1044, 3133, 13625, 13626, 13626, 13626, 13626, 13626, 13625, 2456717, 56716, N'2014-02-28', 201409, 9, 5, N'2014-W09', N'2014-W09-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95387, CAST(N'2014-03-01' AS date), CAST(N'2014-03-02' AS date), 2014, 20141, 201403, 2014060, 1, 3, 60, 1, 7, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-02-23' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-07' AS date), 1044, 3134, 13625, 13626, 13626, 13626, 13626, 13626, 13626, 2456718, 56717, N'2014-03-01', 201409, 9, 6, N'2014-W09', N'2014-W09-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95388, CAST(N'2014-03-02' AS date), CAST(N'2014-03-03' AS date), 2014, 20141, 201403, 2014061, 1, 3, 61, 2, 1, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-02-24' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-07' AS date), 1044, 3134, 13626, 13626, 13626, 13626, 13626, 13626, 13626, 2456719, 56718, N'2014-03-02', 201409, 9, 7, N'2014-W09', N'2014-W09-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95389, CAST(N'2014-03-03' AS date), CAST(N'2014-03-04' AS date), 2014, 20141, 201403, 2014062, 1, 3, 62, 3, 2, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-02-25' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-07' AS date), 1044, 3134, 13626, 13627, 13626, 13626, 13626, 13626, 13626, 2456720, 56719, N'2014-03-03', 201410, 10, 1, N'2014-W10', N'2014-W10-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95390, CAST(N'2014-03-04' AS date), CAST(N'2014-03-05' AS date), 2014, 20141, 201403, 2014063, 1, 3, 63, 4, 3, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-02-26' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-07' AS date), 1044, 3134, 13626, 13627, 13627, 13626, 13626, 13626, 13626, 2456721, 56720, N'2014-03-04', 201410, 10, 2, N'2014-W10', N'2014-W10-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95391, CAST(N'2014-03-05' AS date), CAST(N'2014-03-06' AS date), 2014, 20141, 201403, 2014064, 1, 3, 64, 5, 4, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-02-27' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-07' AS date), 1044, 3134, 13626, 13627, 13627, 13627, 13626, 13626, 13626, 2456722, 56721, N'2014-03-05', 201410, 10, 3, N'2014-W10', N'2014-W10-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95392, CAST(N'2014-03-06' AS date), CAST(N'2014-03-07' AS date), 2014, 20141, 201403, 2014065, 1, 3, 65, 6, 5, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-02-28' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-07' AS date), 1044, 3134, 13626, 13627, 13627, 13627, 13627, 13626, 13626, 2456723, 56722, N'2014-03-06', 201410, 10, 4, N'2014-W10', N'2014-W10-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95393, CAST(N'2014-03-07' AS date), CAST(N'2014-03-08' AS date), 2014, 20141, 201403, 2014066, 1, 3, 66, 7, 6, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-07' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-07' AS date), 1044, 3134, 13626, 13627, 13627, 13627, 13627, 13627, 13626, 2456724, 56723, N'2014-03-07', 201410, 10, 5, N'2014-W10', N'2014-W10-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95394, CAST(N'2014-03-08' AS date), CAST(N'2014-03-09' AS date), 2014, 20141, 201403, 2014067, 1, 3, 67, 8, 7, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-02' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-07' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-14' AS date), 1044, 3134, 13626, 13627, 13627, 13627, 13627, 13627, 13627, 2456725, 56724, N'2014-03-08', 201410, 10, 6, N'2014-W10', N'2014-W10-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95395, CAST(N'2014-03-09' AS date), CAST(N'2014-03-10' AS date), 2014, 20141, 201403, 2014068, 1, 3, 68, 9, 1, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-03' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-07' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-14' AS date), 1044, 3134, 13627, 13627, 13627, 13627, 13627, 13627, 13627, 2456726, 56725, N'2014-03-09', 201410, 10, 7, N'2014-W10', N'2014-W10-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95396, CAST(N'2014-03-10' AS date), CAST(N'2014-03-11' AS date), 2014, 20141, 201403, 2014069, 1, 3, 69, 10, 2, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-04' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-07' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-14' AS date), 1044, 3134, 13627, 13628, 13627, 13627, 13627, 13627, 13627, 2456727, 56726, N'2014-03-10', 201411, 11, 1, N'2014-W11', N'2014-W11-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95397, CAST(N'2014-03-11' AS date), CAST(N'2014-03-12' AS date), 2014, 20141, 201403, 2014070, 1, 3, 70, 11, 3, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-05' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-07' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-14' AS date), 1044, 3134, 13627, 13628, 13628, 13627, 13627, 13627, 13627, 2456728, 56727, N'2014-03-11', 201411, 11, 2, N'2014-W11', N'2014-W11-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95398, CAST(N'2014-03-12' AS date), CAST(N'2014-03-13' AS date), 2014, 20141, 201403, 2014071, 1, 3, 71, 12, 4, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-06' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-07' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-14' AS date), 1044, 3134, 13627, 13628, 13628, 13628, 13627, 13627, 13627, 2456729, 56728, N'2014-03-12', 201411, 11, 3, N'2014-W11', N'2014-W11-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95399, CAST(N'2014-03-13' AS date), CAST(N'2014-03-14' AS date), 2014, 20141, 201403, 2014072, 1, 3, 72, 13, 5, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-07' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-14' AS date), 1044, 3134, 13627, 13628, 13628, 13628, 13628, 13627, 13627, 2456730, 56729, N'2014-03-13', 201411, 11, 4, N'2014-W11', N'2014-W11-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95400, CAST(N'2014-03-14' AS date), CAST(N'2014-03-15' AS date), 2014, 20141, 201403, 2014073, 1, 3, 73, 14, 6, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-14' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-08' AS date), CAST(N'2014-03-14' AS date), 1044, 3134, 13627, 13628, 13628, 13628, 13628, 13628, 13627, 2456731, 56730, N'2014-03-14', 201411, 11, 5, N'2014-W11', N'2014-W11-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95401, CAST(N'2014-03-15' AS date), CAST(N'2014-03-16' AS date), 2014, 20141, 201403, 2014074, 1, 3, 74, 15, 7, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-09' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-14' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-21' AS date), 1044, 3134, 13627, 13628, 13628, 13628, 13628, 13628, 13628, 2456732, 56731, N'2014-03-15', 201411, 11, 6, N'2014-W11', N'2014-W11-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95402, CAST(N'2014-03-16' AS date), CAST(N'2014-03-17' AS date), 2014, 20141, 201403, 2014075, 1, 3, 75, 16, 1, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-10' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-14' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-21' AS date), 1044, 3134, 13628, 13628, 13628, 13628, 13628, 13628, 13628, 2456733, 56732, N'2014-03-16', 201411, 11, 7, N'2014-W11', N'2014-W11-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95403, CAST(N'2014-03-17' AS date), CAST(N'2014-03-18' AS date), 2014, 20141, 201403, 2014076, 1, 3, 76, 17, 2, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-11' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-14' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-21' AS date), 1044, 3134, 13628, 13629, 13628, 13628, 13628, 13628, 13628, 2456734, 56733, N'2014-03-17', 201412, 12, 1, N'2014-W12', N'2014-W12-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95404, CAST(N'2014-03-18' AS date), CAST(N'2014-03-19' AS date), 2014, 20141, 201403, 2014077, 1, 3, 77, 18, 3, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-12' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-14' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-21' AS date), 1044, 3134, 13628, 13629, 13629, 13628, 13628, 13628, 13628, 2456735, 56734, N'2014-03-18', 201412, 12, 2, N'2014-W12', N'2014-W12-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95405, CAST(N'2014-03-19' AS date), CAST(N'2014-03-20' AS date), 2014, 20141, 201403, 2014078, 1, 3, 78, 19, 4, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-13' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-14' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-21' AS date), 1044, 3134, 13628, 13629, 13629, 13629, 13628, 13628, 13628, 2456736, 56735, N'2014-03-19', 201412, 12, 3, N'2014-W12', N'2014-W12-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95406, CAST(N'2014-03-20' AS date), CAST(N'2014-03-21' AS date), 2014, 20141, 201403, 2014079, 1, 3, 79, 20, 5, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-03-14' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-21' AS date), 1044, 3134, 13628, 13629, 13629, 13629, 13629, 13628, 13628, 2456737, 56736, N'2014-03-20', 201412, 12, 4, N'2014-W12', N'2014-W12-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95407, CAST(N'2014-03-21' AS date), CAST(N'2014-03-22' AS date), 2014, 20141, 201403, 2014080, 1, 3, 80, 21, 6, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-03-21' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-03-15' AS date), CAST(N'2014-03-21' AS date), 1044, 3134, 13628, 13629, 13629, 13629, 13629, 13629, 13628, 2456738, 56737, N'2014-03-21', 201412, 12, 5, N'2014-W12', N'2014-W12-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95408, CAST(N'2014-03-22' AS date), CAST(N'2014-03-23' AS date), 2014, 20141, 201403, 2014081, 1, 3, 81, 22, 7, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-16' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-03-21' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-28' AS date), 1044, 3134, 13628, 13629, 13629, 13629, 13629, 13629, 13629, 2456739, 56738, N'2014-03-22', 201412, 12, 6, N'2014-W12', N'2014-W12-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95409, CAST(N'2014-03-23' AS date), CAST(N'2014-03-24' AS date), 2014, 20141, 201403, 2014082, 1, 3, 82, 23, 1, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-03-17' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-03-21' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-28' AS date), 1044, 3134, 13629, 13629, 13629, 13629, 13629, 13629, 13629, 2456740, 56739, N'2014-03-23', 201412, 12, 7, N'2014-W12', N'2014-W12-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95410, CAST(N'2014-03-24' AS date), CAST(N'2014-03-25' AS date), 2014, 20141, 201403, 2014083, 1, 3, 83, 24, 2, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-03-18' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-03-21' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-28' AS date), 1044, 3134, 13629, 13630, 13629, 13629, 13629, 13629, 13629, 2456741, 56740, N'2014-03-24', 201413, 13, 1, N'2014-W13', N'2014-W13-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95411, CAST(N'2014-03-25' AS date), CAST(N'2014-03-26' AS date), 2014, 20141, 201403, 2014084, 1, 3, 84, 25, 3, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-19' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-03-21' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-28' AS date), 1044, 3134, 13629, 13630, 13630, 13629, 13629, 13629, 13629, 2456742, 56741, N'2014-03-25', 201413, 13, 2, N'2014-W13', N'2014-W13-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95412, CAST(N'2014-03-26' AS date), CAST(N'2014-03-27' AS date), 2014, 20141, 201403, 2014085, 1, 3, 85, 26, 4, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-03-20' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-03-21' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-28' AS date), 1044, 3134, 13629, 13630, 13630, 13630, 13629, 13629, 13629, 2456743, 56742, N'2014-03-26', 201413, 13, 3, N'2014-W13', N'2014-W13-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95413, CAST(N'2014-03-27' AS date), CAST(N'2014-03-28' AS date), 2014, 20141, 201403, 2014086, 1, 3, 86, 27, 5, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-03-21' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-28' AS date), 1044, 3134, 13629, 13630, 13630, 13630, 13630, 13629, 13629, 2456744, 56743, N'2014-03-27', 201413, 13, 4, N'2014-W13', N'2014-W13-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95414, CAST(N'2014-03-28' AS date), CAST(N'2014-03-29' AS date), 2014, 20141, 201403, 2014087, 1, 3, 87, 28, 6, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-03-28' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-03-22' AS date), CAST(N'2014-03-28' AS date), 1044, 3134, 13629, 13630, 13630, 13630, 13630, 13630, 13629, 2456745, 56744, N'2014-03-28', 201413, 13, 5, N'2014-W13', N'2014-W13-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95415, CAST(N'2014-03-29' AS date), CAST(N'2014-03-30' AS date), 2014, 20141, 201403, 2014088, 1, 3, 88, 29, 7, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-23' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-03-28' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-04-04' AS date), 1044, 3134, 13629, 13630, 13630, 13630, 13630, 13630, 13630, 2456746, 56745, N'2014-03-29', 201413, 13, 6, N'2014-W13', N'2014-W13-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95416, CAST(N'2014-03-30' AS date), CAST(N'2014-03-31' AS date), 2014, 20141, 201403, 2014089, 1, 3, 89, 30, 1, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-03-24' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-03-28' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-04-04' AS date), 1044, 3134, 13630, 13630, 13630, 13630, 13630, 13630, 13630, 2456747, 56746, N'2014-03-30', 201413, 13, 7, N'2014-W13', N'2014-W13-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95417, CAST(N'2014-03-31' AS date), CAST(N'2014-04-01' AS date), 2014, 20141, 201403, 2014090, 1, 3, 90, 31, 2, N'2014', N'2014 Q1', N'2014 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-01-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-01' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-03-25' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-03-28' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-04-04' AS date), 1044, 3134, 13630, 13631, 13630, 13630, 13630, 13630, 13630, 2456748, 56747, N'2014-03-31', 201414, 14, 1, N'2014-W14', N'2014-W14-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95418, CAST(N'2014-04-01' AS date), CAST(N'2014-04-02' AS date), 2014, 20142, 201404, 2014091, 2, 4, 91, 1, 3, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-03-26' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-03-28' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-04-04' AS date), 1045, 3135, 13630, 13631, 13631, 13630, 13630, 13630, 13630, 2456749, 56748, N'2014-04-01', 201414, 14, 2, N'2014-W14', N'2014-W14-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95419, CAST(N'2014-04-02' AS date), CAST(N'2014-04-03' AS date), 2014, 20142, 201404, 2014092, 2, 4, 92, 2, 4, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-03-27' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-03-28' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-04-04' AS date), 1045, 3135, 13630, 13631, 13631, 13631, 13630, 13630, 13630, 2456750, 56749, N'2014-04-02', 201414, 14, 3, N'2014-W14', N'2014-W14-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95420, CAST(N'2014-04-03' AS date), CAST(N'2014-04-04' AS date), 2014, 20142, 201404, 2014093, 2, 4, 93, 3, 5, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-03-28' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-04-04' AS date), 1045, 3135, 13630, 13631, 13631, 13631, 13631, 13630, 13630, 2456751, 56750, N'2014-04-03', 201414, 14, 4, N'2014-W14', N'2014-W14-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95421, CAST(N'2014-04-04' AS date), CAST(N'2014-04-05' AS date), 2014, 20142, 201404, 2014094, 2, 4, 94, 4, 6, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-04' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-03-29' AS date), CAST(N'2014-04-04' AS date), 1045, 3135, 13630, 13631, 13631, 13631, 13631, 13631, 13630, 2456752, 56751, N'2014-04-04', 201414, 14, 5, N'2014-W14', N'2014-W14-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95422, CAST(N'2014-04-05' AS date), CAST(N'2014-04-06' AS date), 2014, 20142, 201404, 2014095, 2, 4, 95, 5, 7, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-03-30' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-04' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-04-11' AS date), 1045, 3135, 13630, 13631, 13631, 13631, 13631, 13631, 13631, 2456753, 56752, N'2014-04-05', 201414, 14, 6, N'2014-W14', N'2014-W14-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95423, CAST(N'2014-04-06' AS date), CAST(N'2014-04-07' AS date), 2014, 20142, 201404, 2014096, 2, 4, 96, 6, 1, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-03-31' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-04' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-04-11' AS date), 1045, 3135, 13631, 13631, 13631, 13631, 13631, 13631, 13631, 2456754, 56753, N'2014-04-06', 201414, 14, 7, N'2014-W14', N'2014-W14-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95424, CAST(N'2014-04-07' AS date), CAST(N'2014-04-08' AS date), 2014, 20142, 201404, 2014097, 2, 4, 97, 7, 2, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-04' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-04-11' AS date), 1045, 3135, 13631, 13632, 13631, 13631, 13631, 13631, 13631, 2456755, 56754, N'2014-04-07', 201415, 15, 1, N'2014-W15', N'2014-W15-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95425, CAST(N'2014-04-08' AS date), CAST(N'2014-04-09' AS date), 2014, 20142, 201404, 2014098, 2, 4, 98, 8, 3, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-02' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-04' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-04-11' AS date), 1045, 3135, 13631, 13632, 13632, 13631, 13631, 13631, 13631, 2456756, 56755, N'2014-04-08', 201415, 15, 2, N'2014-W15', N'2014-W15-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95426, CAST(N'2014-04-09' AS date), CAST(N'2014-04-10' AS date), 2014, 20142, 201404, 2014099, 2, 4, 99, 9, 4, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-03' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-04' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-04-11' AS date), 1045, 3135, 13631, 13632, 13632, 13632, 13631, 13631, 13631, 2456757, 56756, N'2014-04-09', 201415, 15, 3, N'2014-W15', N'2014-W15-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95427, CAST(N'2014-04-10' AS date), CAST(N'2014-04-11' AS date), 2014, 20142, 201404, 2014100, 2, 4, 100, 10, 5, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-04' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-04-11' AS date), 1045, 3135, 13631, 13632, 13632, 13632, 13632, 13631, 13631, 2456758, 56757, N'2014-04-10', 201415, 15, 4, N'2014-W15', N'2014-W15-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95428, CAST(N'2014-04-11' AS date), CAST(N'2014-04-12' AS date), 2014, 20142, 201404, 2014101, 2, 4, 101, 11, 6, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-11' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-05' AS date), CAST(N'2014-04-11' AS date), 1045, 3135, 13631, 13632, 13632, 13632, 13632, 13632, 13631, 2456759, 56758, N'2014-04-11', 201415, 15, 5, N'2014-W15', N'2014-W15-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95429, CAST(N'2014-04-12' AS date), CAST(N'2014-04-13' AS date), 2014, 20142, 201404, 2014102, 2, 4, 102, 12, 7, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-06' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-11' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-18' AS date), 1045, 3135, 13631, 13632, 13632, 13632, 13632, 13632, 13632, 2456760, 56759, N'2014-04-12', 201415, 15, 6, N'2014-W15', N'2014-W15-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95430, CAST(N'2014-04-13' AS date), CAST(N'2014-04-14' AS date), 2014, 20142, 201404, 2014103, 2, 4, 103, 13, 1, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-07' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-11' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-18' AS date), 1045, 3135, 13632, 13632, 13632, 13632, 13632, 13632, 13632, 2456761, 56760, N'2014-04-13', 201415, 15, 7, N'2014-W15', N'2014-W15-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95431, CAST(N'2014-04-14' AS date), CAST(N'2014-04-15' AS date), 2014, 20142, 201404, 2014104, 2, 4, 104, 14, 2, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-08' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-11' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-18' AS date), 1045, 3135, 13632, 13633, 13632, 13632, 13632, 13632, 13632, 2456762, 56761, N'2014-04-14', 201416, 16, 1, N'2014-W16', N'2014-W16-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95432, CAST(N'2014-04-15' AS date), CAST(N'2014-04-16' AS date), 2014, 20142, 201404, 2014105, 2, 4, 105, 15, 3, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-09' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-11' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-18' AS date), 1045, 3135, 13632, 13633, 13633, 13632, 13632, 13632, 13632, 2456763, 56762, N'2014-04-15', 201416, 16, 2, N'2014-W16', N'2014-W16-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95433, CAST(N'2014-04-16' AS date), CAST(N'2014-04-17' AS date), 2014, 20142, 201404, 2014106, 2, 4, 106, 16, 4, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-10' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-11' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-18' AS date), 1045, 3135, 13632, 13633, 13633, 13633, 13632, 13632, 13632, 2456764, 56763, N'2014-04-16', 201416, 16, 3, N'2014-W16', N'2014-W16-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95434, CAST(N'2014-04-17' AS date), CAST(N'2014-04-18' AS date), 2014, 20142, 201404, 2014107, 2, 4, 107, 17, 5, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-11' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-18' AS date), 1045, 3135, 13632, 13633, 13633, 13633, 13633, 13632, 13632, 2456765, 56764, N'2014-04-17', 201416, 16, 4, N'2014-W16', N'2014-W16-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95435, CAST(N'2014-04-18' AS date), CAST(N'2014-04-19' AS date), 2014, 20142, 201404, 2014108, 2, 4, 108, 18, 6, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-18' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-12' AS date), CAST(N'2014-04-18' AS date), 1045, 3135, 13632, 13633, 13633, 13633, 13633, 13633, 13632, 2456766, 56765, N'2014-04-18', 201416, 16, 5, N'2014-W16', N'2014-W16-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95436, CAST(N'2014-04-19' AS date), CAST(N'2014-04-20' AS date), 2014, 20142, 201404, 2014109, 2, 4, 109, 19, 7, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-13' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-18' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-25' AS date), 1045, 3135, 13632, 13633, 13633, 13633, 13633, 13633, 13633, 2456767, 56766, N'2014-04-19', 201416, 16, 6, N'2014-W16', N'2014-W16-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95437, CAST(N'2014-04-20' AS date), CAST(N'2014-04-21' AS date), 2014, 20142, 201404, 2014110, 2, 4, 110, 20, 1, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-04-14' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-18' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-25' AS date), 1045, 3135, 13633, 13633, 13633, 13633, 13633, 13633, 13633, 2456768, 56767, N'2014-04-20', 201416, 16, 7, N'2014-W16', N'2014-W16-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95438, CAST(N'2014-04-21' AS date), CAST(N'2014-04-22' AS date), 2014, 20142, 201404, 2014111, 2, 4, 111, 21, 2, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-04-15' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-18' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-25' AS date), 1045, 3135, 13633, 13634, 13633, 13633, 13633, 13633, 13633, 2456769, 56768, N'2014-04-21', 201417, 17, 1, N'2014-W17', N'2014-W17-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95439, CAST(N'2014-04-22' AS date), CAST(N'2014-04-23' AS date), 2014, 20142, 201404, 2014112, 2, 4, 112, 22, 3, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-04-16' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-18' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-25' AS date), 1045, 3135, 13633, 13634, 13634, 13633, 13633, 13633, 13633, 2456770, 56769, N'2014-04-22', 201417, 17, 2, N'2014-W17', N'2014-W17-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95440, CAST(N'2014-04-23' AS date), CAST(N'2014-04-24' AS date), 2014, 20142, 201404, 2014113, 2, 4, 113, 23, 4, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-04-17' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-18' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-25' AS date), 1045, 3135, 13633, 13634, 13634, 13634, 13633, 13633, 13633, 2456771, 56770, N'2014-04-23', 201417, 17, 3, N'2014-W17', N'2014-W17-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95441, CAST(N'2014-04-24' AS date), CAST(N'2014-04-25' AS date), 2014, 20142, 201404, 2014114, 2, 4, 114, 24, 5, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-18' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-25' AS date), 1045, 3135, 13633, 13634, 13634, 13634, 13634, 13633, 13633, 2456772, 56771, N'2014-04-24', 201417, 17, 4, N'2014-W17', N'2014-W17-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95442, CAST(N'2014-04-25' AS date), CAST(N'2014-04-26' AS date), 2014, 20142, 201404, 2014115, 2, 4, 115, 25, 6, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-25' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-04-19' AS date), CAST(N'2014-04-25' AS date), 1045, 3135, 13633, 13634, 13634, 13634, 13634, 13634, 13633, 2456773, 56772, N'2014-04-25', 201417, 17, 5, N'2014-W17', N'2014-W17-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95443, CAST(N'2014-04-26' AS date), CAST(N'2014-04-27' AS date), 2014, 20142, 201404, 2014116, 2, 4, 116, 26, 7, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-20' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-25' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-05-02' AS date), 1045, 3135, 13633, 13634, 13634, 13634, 13634, 13634, 13634, 2456774, 56773, N'2014-04-26', 201417, 17, 6, N'2014-W17', N'2014-W17-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95444, CAST(N'2014-04-27' AS date), CAST(N'2014-04-28' AS date), 2014, 20142, 201404, 2014117, 2, 4, 117, 27, 1, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-04-21' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-25' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-05-02' AS date), 1045, 3135, 13634, 13634, 13634, 13634, 13634, 13634, 13634, 2456775, 56774, N'2014-04-27', 201417, 17, 7, N'2014-W17', N'2014-W17-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95445, CAST(N'2014-04-28' AS date), CAST(N'2014-04-29' AS date), 2014, 20142, 201404, 2014118, 2, 4, 118, 28, 2, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-04-22' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-25' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-05-02' AS date), 1045, 3135, 13634, 13635, 13634, 13634, 13634, 13634, 13634, 2456776, 56775, N'2014-04-28', 201418, 18, 1, N'2014-W18', N'2014-W18-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95446, CAST(N'2014-04-29' AS date), CAST(N'2014-04-30' AS date), 2014, 20142, 201404, 2014119, 2, 4, 119, 29, 3, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-04-23' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-25' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-05-02' AS date), 1045, 3135, 13634, 13635, 13635, 13634, 13634, 13634, 13634, 2456777, 56776, N'2014-04-29', 201418, 18, 2, N'2014-W18', N'2014-W18-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95447, CAST(N'2014-04-30' AS date), CAST(N'2014-05-01' AS date), 2014, 20142, 201404, 2014120, 2, 4, 120, 30, 4, N'2014', N'2014 Q2', N'2014 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-04-24' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-04-25' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-05-02' AS date), 1045, 3135, 13634, 13635, 13635, 13635, 13634, 13634, 13634, 2456778, 56777, N'2014-04-30', 201418, 18, 3, N'2014-W18', N'2014-W18-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95448, CAST(N'2014-05-01' AS date), CAST(N'2014-05-02' AS date), 2014, 20142, 201405, 2014121, 2, 5, 121, 1, 5, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-04-25' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-05-02' AS date), 1045, 3136, 13634, 13635, 13635, 13635, 13635, 13634, 13634, 2456779, 56778, N'2014-05-01', 201418, 18, 4, N'2014-W18', N'2014-W18-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95449, CAST(N'2014-05-02' AS date), CAST(N'2014-05-03' AS date), 2014, 20142, 201405, 2014122, 2, 5, 122, 2, 6, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-02' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-04-26' AS date), CAST(N'2014-05-02' AS date), 1045, 3136, 13634, 13635, 13635, 13635, 13635, 13635, 13634, 2456780, 56779, N'2014-05-02', 201418, 18, 5, N'2014-W18', N'2014-W18-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95450, CAST(N'2014-05-03' AS date), CAST(N'2014-05-04' AS date), 2014, 20142, 201405, 2014123, 2, 5, 123, 3, 7, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-04-27' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-02' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-05-09' AS date), 1045, 3136, 13634, 13635, 13635, 13635, 13635, 13635, 13635, 2456781, 56780, N'2014-05-03', 201418, 18, 6, N'2014-W18', N'2014-W18-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95451, CAST(N'2014-05-04' AS date), CAST(N'2014-05-05' AS date), 2014, 20142, 201405, 2014124, 2, 5, 124, 4, 1, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-04-28' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-02' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-05-09' AS date), 1045, 3136, 13635, 13635, 13635, 13635, 13635, 13635, 13635, 2456782, 56781, N'2014-05-04', 201418, 18, 7, N'2014-W18', N'2014-W18-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95452, CAST(N'2014-05-05' AS date), CAST(N'2014-05-06' AS date), 2014, 20142, 201405, 2014125, 2, 5, 125, 5, 2, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-04-29' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-02' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-05-09' AS date), 1045, 3136, 13635, 13636, 13635, 13635, 13635, 13635, 13635, 2456783, 56782, N'2014-05-05', 201419, 19, 1, N'2014-W19', N'2014-W19-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95453, CAST(N'2014-05-06' AS date), CAST(N'2014-05-07' AS date), 2014, 20142, 201405, 2014126, 2, 5, 126, 6, 3, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-04-30' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-02' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-05-09' AS date), 1045, 3136, 13635, 13636, 13636, 13635, 13635, 13635, 13635, 2456784, 56783, N'2014-05-06', 201419, 19, 2, N'2014-W19', N'2014-W19-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95454, CAST(N'2014-05-07' AS date), CAST(N'2014-05-08' AS date), 2014, 20142, 201405, 2014127, 2, 5, 127, 7, 4, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-02' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-05-09' AS date), 1045, 3136, 13635, 13636, 13636, 13636, 13635, 13635, 13635, 2456785, 56784, N'2014-05-07', 201419, 19, 3, N'2014-W19', N'2014-W19-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95455, CAST(N'2014-05-08' AS date), CAST(N'2014-05-09' AS date), 2014, 20142, 201405, 2014128, 2, 5, 128, 8, 5, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-02' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-05-09' AS date), 1045, 3136, 13635, 13636, 13636, 13636, 13636, 13635, 13635, 2456786, 56785, N'2014-05-08', 201419, 19, 4, N'2014-W19', N'2014-W19-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95456, CAST(N'2014-05-09' AS date), CAST(N'2014-05-10' AS date), 2014, 20142, 201405, 2014129, 2, 5, 129, 9, 6, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-09' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-03' AS date), CAST(N'2014-05-09' AS date), 1045, 3136, 13635, 13636, 13636, 13636, 13636, 13636, 13635, 2456787, 56786, N'2014-05-09', 201419, 19, 5, N'2014-W19', N'2014-W19-5');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95457, CAST(N'2014-05-10' AS date), CAST(N'2014-05-11' AS date), 2014, 20142, 201405, 2014130, 2, 5, 130, 10, 7, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-04' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-09' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-16' AS date), 1045, 3136, 13635, 13636, 13636, 13636, 13636, 13636, 13636, 2456788, 56787, N'2014-05-10', 201419, 19, 6, N'2014-W19', N'2014-W19-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95458, CAST(N'2014-05-11' AS date), CAST(N'2014-05-12' AS date), 2014, 20142, 201405, 2014131, 2, 5, 131, 11, 1, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-05' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-09' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-16' AS date), 1045, 3136, 13636, 13636, 13636, 13636, 13636, 13636, 13636, 2456789, 56788, N'2014-05-11', 201419, 19, 7, N'2014-W19', N'2014-W19-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95459, CAST(N'2014-05-12' AS date), CAST(N'2014-05-13' AS date), 2014, 20142, 201405, 2014132, 2, 5, 132, 12, 2, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-06' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-09' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-16' AS date), 1045, 3136, 13636, 13637, 13636, 13636, 13636, 13636, 13636, 2456790, 56789, N'2014-05-12', 201420, 20, 1, N'2014-W20', N'2014-W20-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95460, CAST(N'2014-05-13' AS date), CAST(N'2014-05-14' AS date), 2014, 20142, 201405, 2014133, 2, 5, 133, 13, 3, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-07' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-09' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-16' AS date), 1045, 3136, 13636, 13637, 13637, 13636, 13636, 13636, 13636, 2456791, 56790, N'2014-05-13', 201420, 20, 2, N'2014-W20', N'2014-W20-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95461, CAST(N'2014-05-14' AS date), CAST(N'2014-05-15' AS date), 2014, 20142, 201405, 2014134, 2, 5, 134, 14, 4, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-08' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-09' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-16' AS date), 1045, 3136, 13636, 13637, 13637, 13637, 13636, 13636, 13636, 2456792, 56791, N'2014-05-14', 201420, 20, 3, N'2014-W20', N'2014-W20-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95462, CAST(N'2014-05-15' AS date), CAST(N'2014-05-16' AS date), 2014, 20142, 201405, 2014135, 2, 5, 135, 15, 5, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-09' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-16' AS date), 1045, 3136, 13636, 13637, 13637, 13637, 13637, 13636, 13636, 2456793, 56792, N'2014-05-15', 201420, 20, 4, N'2014-W20', N'2014-W20-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95463, CAST(N'2014-05-16' AS date), CAST(N'2014-05-17' AS date), 2014, 20142, 201405, 2014136, 2, 5, 136, 16, 6, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-16' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-10' AS date), CAST(N'2014-05-16' AS date), 1045, 3136, 13636, 13637, 13637, 13637, 13637, 13637, 13636, 2456794, 56793, N'2014-05-16', 201420, 20, 5, N'2014-W20', N'2014-W20-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95464, CAST(N'2014-05-17' AS date), CAST(N'2014-05-18' AS date), 2014, 20142, 201405, 2014137, 2, 5, 137, 17, 7, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-11' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-16' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-23' AS date), 1045, 3136, 13636, 13637, 13637, 13637, 13637, 13637, 13637, 2456795, 56794, N'2014-05-17', 201420, 20, 6, N'2014-W20', N'2014-W20-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95465, CAST(N'2014-05-18' AS date), CAST(N'2014-05-19' AS date), 2014, 20142, 201405, 2014138, 2, 5, 138, 18, 1, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-12' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-16' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-23' AS date), 1045, 3136, 13637, 13637, 13637, 13637, 13637, 13637, 13637, 2456796, 56795, N'2014-05-18', 201420, 20, 7, N'2014-W20', N'2014-W20-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95466, CAST(N'2014-05-19' AS date), CAST(N'2014-05-20' AS date), 2014, 20142, 201405, 2014139, 2, 5, 139, 19, 2, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-13' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-16' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-23' AS date), 1045, 3136, 13637, 13638, 13637, 13637, 13637, 13637, 13637, 2456797, 56796, N'2014-05-19', 201421, 21, 1, N'2014-W21', N'2014-W21-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95467, CAST(N'2014-05-20' AS date), CAST(N'2014-05-21' AS date), 2014, 20142, 201405, 2014140, 2, 5, 140, 20, 3, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-05-14' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-16' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-23' AS date), 1045, 3136, 13637, 13638, 13638, 13637, 13637, 13637, 13637, 2456798, 56797, N'2014-05-20', 201421, 21, 2, N'2014-W21', N'2014-W21-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95468, CAST(N'2014-05-21' AS date), CAST(N'2014-05-22' AS date), 2014, 20142, 201405, 2014141, 2, 5, 141, 21, 4, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-05-15' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-16' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-23' AS date), 1045, 3136, 13637, 13638, 13638, 13638, 13637, 13637, 13637, 2456799, 56798, N'2014-05-21', 201421, 21, 3, N'2014-W21', N'2014-W21-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95469, CAST(N'2014-05-22' AS date), CAST(N'2014-05-23' AS date), 2014, 20142, 201405, 2014142, 2, 5, 142, 22, 5, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-05-16' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-23' AS date), 1045, 3136, 13637, 13638, 13638, 13638, 13638, 13637, 13637, 2456800, 56799, N'2014-05-22', 201421, 21, 4, N'2014-W21', N'2014-W21-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95470, CAST(N'2014-05-23' AS date), CAST(N'2014-05-24' AS date), 2014, 20142, 201405, 2014143, 2, 5, 143, 23, 6, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-05-23' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-05-17' AS date), CAST(N'2014-05-23' AS date), 1045, 3136, 13637, 13638, 13638, 13638, 13638, 13638, 13637, 2456801, 56800, N'2014-05-23', 201421, 21, 5, N'2014-W21', N'2014-W21-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95471, CAST(N'2014-05-24' AS date), CAST(N'2014-05-25' AS date), 2014, 20142, 201405, 2014144, 2, 5, 144, 24, 7, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-18' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-05-23' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-30' AS date), 1045, 3136, 13637, 13638, 13638, 13638, 13638, 13638, 13638, 2456802, 56801, N'2014-05-24', 201421, 21, 6, N'2014-W21', N'2014-W21-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95472, CAST(N'2014-05-25' AS date), CAST(N'2014-05-26' AS date), 2014, 20142, 201405, 2014145, 2, 5, 145, 25, 1, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-19' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-05-23' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-30' AS date), 1045, 3136, 13638, 13638, 13638, 13638, 13638, 13638, 13638, 2456803, 56802, N'2014-05-25', 201421, 21, 7, N'2014-W21', N'2014-W21-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95473, CAST(N'2014-05-26' AS date), CAST(N'2014-05-27' AS date), 2014, 20142, 201405, 2014146, 2, 5, 146, 26, 2, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-05-20' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-05-23' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-30' AS date), 1045, 3136, 13638, 13639, 13638, 13638, 13638, 13638, 13638, 2456804, 56803, N'2014-05-26', 201422, 22, 1, N'2014-W22', N'2014-W22-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95474, CAST(N'2014-05-27' AS date), CAST(N'2014-05-28' AS date), 2014, 20142, 201405, 2014147, 2, 5, 147, 27, 3, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-05-21' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-05-23' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-30' AS date), 1045, 3136, 13638, 13639, 13639, 13638, 13638, 13638, 13638, 2456805, 56804, N'2014-05-27', 201422, 22, 2, N'2014-W22', N'2014-W22-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95475, CAST(N'2014-05-28' AS date), CAST(N'2014-05-29' AS date), 2014, 20142, 201405, 2014148, 2, 5, 148, 28, 4, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-05-22' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-05-23' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-30' AS date), 1045, 3136, 13638, 13639, 13639, 13639, 13638, 13638, 13638, 2456806, 56805, N'2014-05-28', 201422, 22, 3, N'2014-W22', N'2014-W22-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95476, CAST(N'2014-05-29' AS date), CAST(N'2014-05-30' AS date), 2014, 20142, 201405, 2014149, 2, 5, 149, 29, 5, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-05-23' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-30' AS date), 1045, 3136, 13638, 13639, 13639, 13639, 13639, 13638, 13638, 2456807, 56806, N'2014-05-29', 201422, 22, 4, N'2014-W22', N'2014-W22-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95477, CAST(N'2014-05-30' AS date), CAST(N'2014-05-31' AS date), 2014, 20142, 201405, 2014150, 2, 5, 150, 30, 6, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-05-30' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-05-24' AS date), CAST(N'2014-05-30' AS date), 1045, 3136, 13638, 13639, 13639, 13639, 13639, 13639, 13638, 2456808, 56807, N'2014-05-30', 201422, 22, 5, N'2014-W22', N'2014-W22-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95478, CAST(N'2014-05-31' AS date), CAST(N'2014-06-01' AS date), 2014, 20142, 201405, 2014151, 2, 5, 151, 31, 7, N'2014', N'2014 Q2', N'2014 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-05-01' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-25' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-05-30' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-06-06' AS date), 1045, 3136, 13638, 13639, 13639, 13639, 13639, 13639, 13639, 2456809, 56808, N'2014-05-31', 201422, 22, 6, N'2014-W22', N'2014-W22-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95479, CAST(N'2014-06-01' AS date), CAST(N'2014-06-02' AS date), 2014, 20142, 201406, 2014152, 2, 6, 152, 1, 1, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-05-26' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-05-30' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-06-06' AS date), 1045, 3137, 13639, 13639, 13639, 13639, 13639, 13639, 13639, 2456810, 56809, N'2014-06-01', 201422, 22, 7, N'2014-W22', N'2014-W22-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95480, CAST(N'2014-06-02' AS date), CAST(N'2014-06-03' AS date), 2014, 20142, 201406, 2014153, 2, 6, 153, 2, 2, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-05-27' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-05-30' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-06-06' AS date), 1045, 3137, 13639, 13640, 13639, 13639, 13639, 13639, 13639, 2456811, 56810, N'2014-06-02', 201423, 23, 1, N'2014-W23', N'2014-W23-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95481, CAST(N'2014-06-03' AS date), CAST(N'2014-06-04' AS date), 2014, 20142, 201406, 2014154, 2, 6, 154, 3, 3, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-05-28' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-05-30' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-06-06' AS date), 1045, 3137, 13639, 13640, 13640, 13639, 13639, 13639, 13639, 2456812, 56811, N'2014-06-03', 201423, 23, 2, N'2014-W23', N'2014-W23-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95482, CAST(N'2014-06-04' AS date), CAST(N'2014-06-05' AS date), 2014, 20142, 201406, 2014155, 2, 6, 155, 4, 4, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-05-29' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-05-30' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-06-06' AS date), 1045, 3137, 13639, 13640, 13640, 13640, 13639, 13639, 13639, 2456813, 56812, N'2014-06-04', 201423, 23, 3, N'2014-W23', N'2014-W23-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95483, CAST(N'2014-06-05' AS date), CAST(N'2014-06-06' AS date), 2014, 20142, 201406, 2014156, 2, 6, 156, 5, 5, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-05-30' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-06-06' AS date), 1045, 3137, 13639, 13640, 13640, 13640, 13640, 13639, 13639, 2456814, 56813, N'2014-06-05', 201423, 23, 4, N'2014-W23', N'2014-W23-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95484, CAST(N'2014-06-06' AS date), CAST(N'2014-06-07' AS date), 2014, 20142, 201406, 2014157, 2, 6, 157, 6, 6, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-06' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-05-31' AS date), CAST(N'2014-06-06' AS date), 1045, 3137, 13639, 13640, 13640, 13640, 13640, 13640, 13639, 2456815, 56814, N'2014-06-06', 201423, 23, 5, N'2014-W23', N'2014-W23-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95485, CAST(N'2014-06-07' AS date), CAST(N'2014-06-08' AS date), 2014, 20142, 201406, 2014158, 2, 6, 158, 7, 7, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-06' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-13' AS date), 1045, 3137, 13639, 13640, 13640, 13640, 13640, 13640, 13640, 2456816, 56815, N'2014-06-07', 201423, 23, 6, N'2014-W23', N'2014-W23-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95486, CAST(N'2014-06-08' AS date), CAST(N'2014-06-09' AS date), 2014, 20142, 201406, 2014159, 2, 6, 159, 8, 1, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-02' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-06' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-13' AS date), 1045, 3137, 13640, 13640, 13640, 13640, 13640, 13640, 13640, 2456817, 56816, N'2014-06-08', 201423, 23, 7, N'2014-W23', N'2014-W23-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95487, CAST(N'2014-06-09' AS date), CAST(N'2014-06-10' AS date), 2014, 20142, 201406, 2014160, 2, 6, 160, 9, 2, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-03' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-06' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-13' AS date), 1045, 3137, 13640, 13641, 13640, 13640, 13640, 13640, 13640, 2456818, 56817, N'2014-06-09', 201424, 24, 1, N'2014-W24', N'2014-W24-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95488, CAST(N'2014-06-10' AS date), CAST(N'2014-06-11' AS date), 2014, 20142, 201406, 2014161, 2, 6, 161, 10, 3, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-04' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-06' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-13' AS date), 1045, 3137, 13640, 13641, 13641, 13640, 13640, 13640, 13640, 2456819, 56818, N'2014-06-10', 201424, 24, 2, N'2014-W24', N'2014-W24-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95489, CAST(N'2014-06-11' AS date), CAST(N'2014-06-12' AS date), 2014, 20142, 201406, 2014162, 2, 6, 162, 11, 4, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-05' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-06' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-13' AS date), 1045, 3137, 13640, 13641, 13641, 13641, 13640, 13640, 13640, 2456820, 56819, N'2014-06-11', 201424, 24, 3, N'2014-W24', N'2014-W24-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95490, CAST(N'2014-06-12' AS date), CAST(N'2014-06-13' AS date), 2014, 20142, 201406, 2014163, 2, 6, 163, 12, 5, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-06' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-13' AS date), 1045, 3137, 13640, 13641, 13641, 13641, 13641, 13640, 13640, 2456821, 56820, N'2014-06-12', 201424, 24, 4, N'2014-W24', N'2014-W24-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95491, CAST(N'2014-06-13' AS date), CAST(N'2014-06-14' AS date), 2014, 20142, 201406, 2014164, 2, 6, 164, 13, 6, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-13' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-07' AS date), CAST(N'2014-06-13' AS date), 1045, 3137, 13640, 13641, 13641, 13641, 13641, 13641, 13640, 2456822, 56821, N'2014-06-13', 201424, 24, 5, N'2014-W24', N'2014-W24-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95492, CAST(N'2014-06-14' AS date), CAST(N'2014-06-15' AS date), 2014, 20142, 201406, 2014165, 2, 6, 165, 14, 7, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-08' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-13' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-20' AS date), 1045, 3137, 13640, 13641, 13641, 13641, 13641, 13641, 13641, 2456823, 56822, N'2014-06-14', 201424, 24, 6, N'2014-W24', N'2014-W24-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95493, CAST(N'2014-06-15' AS date), CAST(N'2014-06-16' AS date), 2014, 20142, 201406, 2014166, 2, 6, 166, 15, 1, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-09' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-13' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-20' AS date), 1045, 3137, 13641, 13641, 13641, 13641, 13641, 13641, 13641, 2456824, 56823, N'2014-06-15', 201424, 24, 7, N'2014-W24', N'2014-W24-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95494, CAST(N'2014-06-16' AS date), CAST(N'2014-06-17' AS date), 2014, 20142, 201406, 2014167, 2, 6, 167, 16, 2, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-10' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-13' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-20' AS date), 1045, 3137, 13641, 13642, 13641, 13641, 13641, 13641, 13641, 2456825, 56824, N'2014-06-16', 201425, 25, 1, N'2014-W25', N'2014-W25-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95495, CAST(N'2014-06-17' AS date), CAST(N'2014-06-18' AS date), 2014, 20142, 201406, 2014168, 2, 6, 168, 17, 3, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-11' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-13' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-20' AS date), 1045, 3137, 13641, 13642, 13642, 13641, 13641, 13641, 13641, 2456826, 56825, N'2014-06-17', 201425, 25, 2, N'2014-W25', N'2014-W25-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95496, CAST(N'2014-06-18' AS date), CAST(N'2014-06-19' AS date), 2014, 20142, 201406, 2014169, 2, 6, 169, 18, 4, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-12' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-13' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-20' AS date), 1045, 3137, 13641, 13642, 13642, 13642, 13641, 13641, 13641, 2456827, 56826, N'2014-06-18', 201425, 25, 3, N'2014-W25', N'2014-W25-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95497, CAST(N'2014-06-19' AS date), CAST(N'2014-06-20' AS date), 2014, 20142, 201406, 2014170, 2, 6, 170, 19, 5, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-06-13' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-20' AS date), 1045, 3137, 13641, 13642, 13642, 13642, 13642, 13641, 13641, 2456828, 56827, N'2014-06-19', 201425, 25, 4, N'2014-W25', N'2014-W25-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95498, CAST(N'2014-06-20' AS date), CAST(N'2014-06-21' AS date), 2014, 20142, 201406, 2014171, 2, 6, 171, 20, 6, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-06-20' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-06-14' AS date), CAST(N'2014-06-20' AS date), 1045, 3137, 13641, 13642, 13642, 13642, 13642, 13642, 13641, 2456829, 56828, N'2014-06-20', 201425, 25, 5, N'2014-W25', N'2014-W25-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95499, CAST(N'2014-06-21' AS date), CAST(N'2014-06-22' AS date), 2014, 20142, 201406, 2014172, 2, 6, 172, 21, 7, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-15' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-06-20' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-27' AS date), 1045, 3137, 13641, 13642, 13642, 13642, 13642, 13642, 13642, 2456830, 56829, N'2014-06-21', 201425, 25, 6, N'2014-W25', N'2014-W25-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95500, CAST(N'2014-06-22' AS date), CAST(N'2014-06-23' AS date), 2014, 20142, 201406, 2014173, 2, 6, 173, 22, 1, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-06-16' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-06-20' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-27' AS date), 1045, 3137, 13642, 13642, 13642, 13642, 13642, 13642, 13642, 2456831, 56830, N'2014-06-22', 201425, 25, 7, N'2014-W25', N'2014-W25-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95501, CAST(N'2014-06-23' AS date), CAST(N'2014-06-24' AS date), 2014, 20142, 201406, 2014174, 2, 6, 174, 23, 2, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-06-17' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-06-20' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-27' AS date), 1045, 3137, 13642, 13643, 13642, 13642, 13642, 13642, 13642, 2456832, 56831, N'2014-06-23', 201426, 26, 1, N'2014-W26', N'2014-W26-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95502, CAST(N'2014-06-24' AS date), CAST(N'2014-06-25' AS date), 2014, 20142, 201406, 2014175, 2, 6, 175, 24, 3, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-18' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-06-20' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-27' AS date), 1045, 3137, 13642, 13643, 13643, 13642, 13642, 13642, 13642, 2456833, 56832, N'2014-06-24', 201426, 26, 2, N'2014-W26', N'2014-W26-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95503, CAST(N'2014-06-25' AS date), CAST(N'2014-06-26' AS date), 2014, 20142, 201406, 2014176, 2, 6, 176, 25, 4, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-06-19' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-06-20' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-27' AS date), 1045, 3137, 13642, 13643, 13643, 13643, 13642, 13642, 13642, 2456834, 56833, N'2014-06-25', 201426, 26, 3, N'2014-W26', N'2014-W26-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95504, CAST(N'2014-06-26' AS date), CAST(N'2014-06-27' AS date), 2014, 20142, 201406, 2014177, 2, 6, 177, 26, 5, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-06-20' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-27' AS date), 1045, 3137, 13642, 13643, 13643, 13643, 13643, 13642, 13642, 2456835, 56834, N'2014-06-26', 201426, 26, 4, N'2014-W26', N'2014-W26-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95505, CAST(N'2014-06-27' AS date), CAST(N'2014-06-28' AS date), 2014, 20142, 201406, 2014178, 2, 6, 178, 27, 6, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-06-27' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-06-21' AS date), CAST(N'2014-06-27' AS date), 1045, 3137, 13642, 13643, 13643, 13643, 13643, 13643, 13642, 2456836, 56835, N'2014-06-27', 201426, 26, 5, N'2014-W26', N'2014-W26-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95506, CAST(N'2014-06-28' AS date), CAST(N'2014-06-29' AS date), 2014, 20142, 201406, 2014179, 2, 6, 179, 28, 7, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-22' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-06-27' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-07-04' AS date), 1045, 3137, 13642, 13643, 13643, 13643, 13643, 13643, 13643, 2456837, 56836, N'2014-06-28', 201426, 26, 6, N'2014-W26', N'2014-W26-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95507, CAST(N'2014-06-29' AS date), CAST(N'2014-06-30' AS date), 2014, 20142, 201406, 2014180, 2, 6, 180, 29, 1, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-06-23' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-06-27' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-07-04' AS date), 1045, 3137, 13643, 13643, 13643, 13643, 13643, 13643, 13643, 2456838, 56837, N'2014-06-29', 201426, 26, 7, N'2014-W26', N'2014-W26-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95508, CAST(N'2014-06-30' AS date), CAST(N'2014-07-01' AS date), 2014, 20142, 201406, 2014181, 2, 6, 181, 30, 2, N'2014', N'2014 Q2', N'2014 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-04-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-01' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-06-24' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-06-27' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-07-04' AS date), 1045, 3137, 13643, 13644, 13643, 13643, 13643, 13643, 13643, 2456839, 56838, N'2014-06-30', 201427, 27, 1, N'2014-W27', N'2014-W27-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95509, CAST(N'2014-07-01' AS date), CAST(N'2014-07-02' AS date), 2014, 20143, 201407, 2014182, 3, 7, 182, 1, 3, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-06-25' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-06-27' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-07-04' AS date), 1046, 3138, 13643, 13644, 13644, 13643, 13643, 13643, 13643, 2456840, 56839, N'2014-07-01', 201427, 27, 2, N'2014-W27', N'2014-W27-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95510, CAST(N'2014-07-02' AS date), CAST(N'2014-07-03' AS date), 2014, 20143, 201407, 2014183, 3, 7, 183, 2, 4, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-06-26' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-06-27' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-07-04' AS date), 1046, 3138, 13643, 13644, 13644, 13644, 13643, 13643, 13643, 2456841, 56840, N'2014-07-02', 201427, 27, 3, N'2014-W27', N'2014-W27-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95511, CAST(N'2014-07-03' AS date), CAST(N'2014-07-04' AS date), 2014, 20143, 201407, 2014184, 3, 7, 184, 3, 5, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-06-27' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-07-04' AS date), 1046, 3138, 13643, 13644, 13644, 13644, 13644, 13643, 13643, 2456842, 56841, N'2014-07-03', 201427, 27, 4, N'2014-W27', N'2014-W27-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95512, CAST(N'2014-07-04' AS date), CAST(N'2014-07-05' AS date), 2014, 20143, 201407, 2014185, 3, 7, 185, 4, 6, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-04' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-06-28' AS date), CAST(N'2014-07-04' AS date), 1046, 3138, 13643, 13644, 13644, 13644, 13644, 13644, 13643, 2456843, 56842, N'2014-07-04', 201427, 27, 5, N'2014-W27', N'2014-W27-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95513, CAST(N'2014-07-05' AS date), CAST(N'2014-07-06' AS date), 2014, 20143, 201407, 2014186, 3, 7, 186, 5, 7, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-06-29' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-04' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-07-11' AS date), 1046, 3138, 13643, 13644, 13644, 13644, 13644, 13644, 13644, 2456844, 56843, N'2014-07-05', 201427, 27, 6, N'2014-W27', N'2014-W27-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95514, CAST(N'2014-07-06' AS date), CAST(N'2014-07-07' AS date), 2014, 20143, 201407, 2014187, 3, 7, 187, 6, 1, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-06-30' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-04' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-07-11' AS date), 1046, 3138, 13644, 13644, 13644, 13644, 13644, 13644, 13644, 2456845, 56844, N'2014-07-06', 201427, 27, 7, N'2014-W27', N'2014-W27-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95515, CAST(N'2014-07-07' AS date), CAST(N'2014-07-08' AS date), 2014, 20143, 201407, 2014188, 3, 7, 188, 7, 2, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-04' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-07-11' AS date), 1046, 3138, 13644, 13645, 13644, 13644, 13644, 13644, 13644, 2456846, 56845, N'2014-07-07', 201428, 28, 1, N'2014-W28', N'2014-W28-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95516, CAST(N'2014-07-08' AS date), CAST(N'2014-07-09' AS date), 2014, 20143, 201407, 2014189, 3, 7, 189, 8, 3, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-02' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-04' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-07-11' AS date), 1046, 3138, 13644, 13645, 13645, 13644, 13644, 13644, 13644, 2456847, 56846, N'2014-07-08', 201428, 28, 2, N'2014-W28', N'2014-W28-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95517, CAST(N'2014-07-09' AS date), CAST(N'2014-07-10' AS date), 2014, 20143, 201407, 2014190, 3, 7, 190, 9, 4, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-03' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-04' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-07-11' AS date), 1046, 3138, 13644, 13645, 13645, 13645, 13644, 13644, 13644, 2456848, 56847, N'2014-07-09', 201428, 28, 3, N'2014-W28', N'2014-W28-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95518, CAST(N'2014-07-10' AS date), CAST(N'2014-07-11' AS date), 2014, 20143, 201407, 2014191, 3, 7, 191, 10, 5, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-04' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-07-11' AS date), 1046, 3138, 13644, 13645, 13645, 13645, 13645, 13644, 13644, 2456849, 56848, N'2014-07-10', 201428, 28, 4, N'2014-W28', N'2014-W28-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95519, CAST(N'2014-07-11' AS date), CAST(N'2014-07-12' AS date), 2014, 20143, 201407, 2014192, 3, 7, 192, 11, 6, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-11' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-05' AS date), CAST(N'2014-07-11' AS date), 1046, 3138, 13644, 13645, 13645, 13645, 13645, 13645, 13644, 2456850, 56849, N'2014-07-11', 201428, 28, 5, N'2014-W28', N'2014-W28-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95520, CAST(N'2014-07-12' AS date), CAST(N'2014-07-13' AS date), 2014, 20143, 201407, 2014193, 3, 7, 193, 12, 7, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-06' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-11' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-18' AS date), 1046, 3138, 13644, 13645, 13645, 13645, 13645, 13645, 13645, 2456851, 56850, N'2014-07-12', 201428, 28, 6, N'2014-W28', N'2014-W28-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95521, CAST(N'2014-07-13' AS date), CAST(N'2014-07-14' AS date), 2014, 20143, 201407, 2014194, 3, 7, 194, 13, 1, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-07' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-11' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-18' AS date), 1046, 3138, 13645, 13645, 13645, 13645, 13645, 13645, 13645, 2456852, 56851, N'2014-07-13', 201428, 28, 7, N'2014-W28', N'2014-W28-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95522, CAST(N'2014-07-14' AS date), CAST(N'2014-07-15' AS date), 2014, 20143, 201407, 2014195, 3, 7, 195, 14, 2, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-08' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-11' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-18' AS date), 1046, 3138, 13645, 13646, 13645, 13645, 13645, 13645, 13645, 2456853, 56852, N'2014-07-14', 201429, 29, 1, N'2014-W29', N'2014-W29-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95523, CAST(N'2014-07-15' AS date), CAST(N'2014-07-16' AS date), 2014, 20143, 201407, 2014196, 3, 7, 196, 15, 3, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-09' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-11' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-18' AS date), 1046, 3138, 13645, 13646, 13646, 13645, 13645, 13645, 13645, 2456854, 56853, N'2014-07-15', 201429, 29, 2, N'2014-W29', N'2014-W29-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95524, CAST(N'2014-07-16' AS date), CAST(N'2014-07-17' AS date), 2014, 20143, 201407, 2014197, 3, 7, 197, 16, 4, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-10' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-11' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-18' AS date), 1046, 3138, 13645, 13646, 13646, 13646, 13645, 13645, 13645, 2456855, 56854, N'2014-07-16', 201429, 29, 3, N'2014-W29', N'2014-W29-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95525, CAST(N'2014-07-17' AS date), CAST(N'2014-07-18' AS date), 2014, 20143, 201407, 2014198, 3, 7, 198, 17, 5, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-11' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-18' AS date), 1046, 3138, 13645, 13646, 13646, 13646, 13646, 13645, 13645, 2456856, 56855, N'2014-07-17', 201429, 29, 4, N'2014-W29', N'2014-W29-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95526, CAST(N'2014-07-18' AS date), CAST(N'2014-07-19' AS date), 2014, 20143, 201407, 2014199, 3, 7, 199, 18, 6, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-18' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-12' AS date), CAST(N'2014-07-18' AS date), 1046, 3138, 13645, 13646, 13646, 13646, 13646, 13646, 13645, 2456857, 56856, N'2014-07-18', 201429, 29, 5, N'2014-W29', N'2014-W29-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95527, CAST(N'2014-07-19' AS date), CAST(N'2014-07-20' AS date), 2014, 20143, 201407, 2014200, 3, 7, 200, 19, 7, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-13' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-18' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-25' AS date), 1046, 3138, 13645, 13646, 13646, 13646, 13646, 13646, 13646, 2456858, 56857, N'2014-07-19', 201429, 29, 6, N'2014-W29', N'2014-W29-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95528, CAST(N'2014-07-20' AS date), CAST(N'2014-07-21' AS date), 2014, 20143, 201407, 2014201, 3, 7, 201, 20, 1, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-07-14' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-18' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-25' AS date), 1046, 3138, 13646, 13646, 13646, 13646, 13646, 13646, 13646, 2456859, 56858, N'2014-07-20', 201429, 29, 7, N'2014-W29', N'2014-W29-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95529, CAST(N'2014-07-21' AS date), CAST(N'2014-07-22' AS date), 2014, 20143, 201407, 2014202, 3, 7, 202, 21, 2, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-07-15' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-18' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-25' AS date), 1046, 3138, 13646, 13647, 13646, 13646, 13646, 13646, 13646, 2456860, 56859, N'2014-07-21', 201430, 30, 1, N'2014-W30', N'2014-W30-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95530, CAST(N'2014-07-22' AS date), CAST(N'2014-07-23' AS date), 2014, 20143, 201407, 2014203, 3, 7, 203, 22, 3, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-07-16' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-18' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-25' AS date), 1046, 3138, 13646, 13647, 13647, 13646, 13646, 13646, 13646, 2456861, 56860, N'2014-07-22', 201430, 30, 2, N'2014-W30', N'2014-W30-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95531, CAST(N'2014-07-23' AS date), CAST(N'2014-07-24' AS date), 2014, 20143, 201407, 2014204, 3, 7, 204, 23, 4, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-07-17' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-18' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-25' AS date), 1046, 3138, 13646, 13647, 13647, 13647, 13646, 13646, 13646, 2456862, 56861, N'2014-07-23', 201430, 30, 3, N'2014-W30', N'2014-W30-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95532, CAST(N'2014-07-24' AS date), CAST(N'2014-07-25' AS date), 2014, 20143, 201407, 2014205, 3, 7, 205, 24, 5, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-07-18' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-25' AS date), 1046, 3138, 13646, 13647, 13647, 13647, 13647, 13646, 13646, 2456863, 56862, N'2014-07-24', 201430, 30, 4, N'2014-W30', N'2014-W30-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95533, CAST(N'2014-07-25' AS date), CAST(N'2014-07-26' AS date), 2014, 20143, 201407, 2014206, 3, 7, 206, 25, 6, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-07-25' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-19' AS date), CAST(N'2014-07-25' AS date), 1046, 3138, 13646, 13647, 13647, 13647, 13647, 13647, 13646, 2456864, 56863, N'2014-07-25', 201430, 30, 5, N'2014-W30', N'2014-W30-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95534, CAST(N'2014-07-26' AS date), CAST(N'2014-07-27' AS date), 2014, 20143, 201407, 2014207, 3, 7, 207, 26, 7, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-20' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-07-25' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-08-01' AS date), 1046, 3138, 13646, 13647, 13647, 13647, 13647, 13647, 13647, 2456865, 56864, N'2014-07-26', 201430, 30, 6, N'2014-W30', N'2014-W30-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95535, CAST(N'2014-07-27' AS date), CAST(N'2014-07-28' AS date), 2014, 20143, 201407, 2014208, 3, 7, 208, 27, 1, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-07-21' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-07-25' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-08-01' AS date), 1046, 3138, 13647, 13647, 13647, 13647, 13647, 13647, 13647, 2456866, 56865, N'2014-07-27', 201430, 30, 7, N'2014-W30', N'2014-W30-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95536, CAST(N'2014-07-28' AS date), CAST(N'2014-07-29' AS date), 2014, 20143, 201407, 2014209, 3, 7, 209, 28, 2, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-07-22' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-07-25' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-08-01' AS date), 1046, 3138, 13647, 13648, 13647, 13647, 13647, 13647, 13647, 2456867, 56866, N'2014-07-28', 201431, 31, 1, N'2014-W31', N'2014-W31-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95537, CAST(N'2014-07-29' AS date), CAST(N'2014-07-30' AS date), 2014, 20143, 201407, 2014210, 3, 7, 210, 29, 3, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-07-23' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-07-25' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-08-01' AS date), 1046, 3138, 13647, 13648, 13648, 13647, 13647, 13647, 13647, 2456868, 56867, N'2014-07-29', 201431, 31, 2, N'2014-W31', N'2014-W31-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95538, CAST(N'2014-07-30' AS date), CAST(N'2014-07-31' AS date), 2014, 20143, 201407, 2014211, 3, 7, 211, 30, 4, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-07-24' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-07-25' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-08-01' AS date), 1046, 3138, 13647, 13648, 13648, 13648, 13647, 13647, 13647, 2456869, 56868, N'2014-07-30', 201431, 31, 3, N'2014-W31', N'2014-W31-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95539, CAST(N'2014-07-31' AS date), CAST(N'2014-08-01' AS date), 2014, 20143, 201407, 2014212, 3, 7, 212, 31, 5, N'2014', N'2014 Q3', N'2014 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-07-25' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-08-01' AS date), 1046, 3138, 13647, 13648, 13648, 13648, 13648, 13647, 13647, 2456870, 56869, N'2014-07-31', 201431, 31, 4, N'2014-W31', N'2014-W31-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95540, CAST(N'2014-08-01' AS date), CAST(N'2014-08-02' AS date), 2014, 20143, 201408, 2014213, 3, 8, 213, 1, 6, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-07-26' AS date), CAST(N'2014-08-01' AS date), 1046, 3139, 13647, 13648, 13648, 13648, 13648, 13648, 13647, 2456871, 56870, N'2014-08-01', 201431, 31, 5, N'2014-W31', N'2014-W31-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95541, CAST(N'2014-08-02' AS date), CAST(N'2014-08-03' AS date), 2014, 20143, 201408, 2014214, 3, 8, 214, 2, 7, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-07-27' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-08-08' AS date), 1046, 3139, 13647, 13648, 13648, 13648, 13648, 13648, 13648, 2456872, 56871, N'2014-08-02', 201431, 31, 6, N'2014-W31', N'2014-W31-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95542, CAST(N'2014-08-03' AS date), CAST(N'2014-08-04' AS date), 2014, 20143, 201408, 2014215, 3, 8, 215, 3, 1, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-07-28' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-08-08' AS date), 1046, 3139, 13648, 13648, 13648, 13648, 13648, 13648, 13648, 2456873, 56872, N'2014-08-03', 201431, 31, 7, N'2014-W31', N'2014-W31-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95543, CAST(N'2014-08-04' AS date), CAST(N'2014-08-05' AS date), 2014, 20143, 201408, 2014216, 3, 8, 216, 4, 2, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-07-29' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-08-08' AS date), 1046, 3139, 13648, 13649, 13648, 13648, 13648, 13648, 13648, 2456874, 56873, N'2014-08-04', 201432, 32, 1, N'2014-W32', N'2014-W32-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95544, CAST(N'2014-08-05' AS date), CAST(N'2014-08-06' AS date), 2014, 20143, 201408, 2014217, 3, 8, 217, 5, 3, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-07-30' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-08-08' AS date), 1046, 3139, 13648, 13649, 13649, 13648, 13648, 13648, 13648, 2456875, 56874, N'2014-08-05', 201432, 32, 2, N'2014-W32', N'2014-W32-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95545, CAST(N'2014-08-06' AS date), CAST(N'2014-08-07' AS date), 2014, 20143, 201408, 2014218, 3, 8, 218, 6, 4, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-07-31' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-08-08' AS date), 1046, 3139, 13648, 13649, 13649, 13649, 13648, 13648, 13648, 2456876, 56875, N'2014-08-06', 201432, 32, 3, N'2014-W32', N'2014-W32-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95546, CAST(N'2014-08-07' AS date), CAST(N'2014-08-08' AS date), 2014, 20143, 201408, 2014219, 3, 8, 219, 7, 5, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-08-08' AS date), 1046, 3139, 13648, 13649, 13649, 13649, 13649, 13648, 13648, 2456877, 56876, N'2014-08-07', 201432, 32, 4, N'2014-W32', N'2014-W32-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95547, CAST(N'2014-08-08' AS date), CAST(N'2014-08-09' AS date), 2014, 20143, 201408, 2014220, 3, 8, 220, 8, 6, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-08' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-02' AS date), CAST(N'2014-08-08' AS date), 1046, 3139, 13648, 13649, 13649, 13649, 13649, 13649, 13648, 2456878, 56877, N'2014-08-08', 201432, 32, 5, N'2014-W32', N'2014-W32-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95548, CAST(N'2014-08-09' AS date), CAST(N'2014-08-10' AS date), 2014, 20143, 201408, 2014221, 3, 8, 221, 9, 7, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-03' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-08' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-15' AS date), 1046, 3139, 13648, 13649, 13649, 13649, 13649, 13649, 13649, 2456879, 56878, N'2014-08-09', 201432, 32, 6, N'2014-W32', N'2014-W32-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95549, CAST(N'2014-08-10' AS date), CAST(N'2014-08-11' AS date), 2014, 20143, 201408, 2014222, 3, 8, 222, 10, 1, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-04' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-08' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-15' AS date), 1046, 3139, 13649, 13649, 13649, 13649, 13649, 13649, 13649, 2456880, 56879, N'2014-08-10', 201432, 32, 7, N'2014-W32', N'2014-W32-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95550, CAST(N'2014-08-11' AS date), CAST(N'2014-08-12' AS date), 2014, 20143, 201408, 2014223, 3, 8, 223, 11, 2, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-05' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-08' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-15' AS date), 1046, 3139, 13649, 13650, 13649, 13649, 13649, 13649, 13649, 2456881, 56880, N'2014-08-11', 201433, 33, 1, N'2014-W33', N'2014-W33-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95551, CAST(N'2014-08-12' AS date), CAST(N'2014-08-13' AS date), 2014, 20143, 201408, 2014224, 3, 8, 224, 12, 3, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-06' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-08' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-15' AS date), 1046, 3139, 13649, 13650, 13650, 13649, 13649, 13649, 13649, 2456882, 56881, N'2014-08-12', 201433, 33, 2, N'2014-W33', N'2014-W33-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95552, CAST(N'2014-08-13' AS date), CAST(N'2014-08-14' AS date), 2014, 20143, 201408, 2014225, 3, 8, 225, 13, 4, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-07' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-08' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-15' AS date), 1046, 3139, 13649, 13650, 13650, 13650, 13649, 13649, 13649, 2456883, 56882, N'2014-08-13', 201433, 33, 3, N'2014-W33', N'2014-W33-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95553, CAST(N'2014-08-14' AS date), CAST(N'2014-08-15' AS date), 2014, 20143, 201408, 2014226, 3, 8, 226, 14, 5, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-08' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-15' AS date), 1046, 3139, 13649, 13650, 13650, 13650, 13650, 13649, 13649, 2456884, 56883, N'2014-08-14', 201433, 33, 4, N'2014-W33', N'2014-W33-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95554, CAST(N'2014-08-15' AS date), CAST(N'2014-08-16' AS date), 2014, 20143, 201408, 2014227, 3, 8, 227, 15, 6, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-15' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-09' AS date), CAST(N'2014-08-15' AS date), 1046, 3139, 13649, 13650, 13650, 13650, 13650, 13650, 13649, 2456885, 56884, N'2014-08-15', 201433, 33, 5, N'2014-W33', N'2014-W33-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95555, CAST(N'2014-08-16' AS date), CAST(N'2014-08-17' AS date), 2014, 20143, 201408, 2014228, 3, 8, 228, 16, 7, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-10' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-15' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-22' AS date), 1046, 3139, 13649, 13650, 13650, 13650, 13650, 13650, 13650, 2456886, 56885, N'2014-08-16', 201433, 33, 6, N'2014-W33', N'2014-W33-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95556, CAST(N'2014-08-17' AS date), CAST(N'2014-08-18' AS date), 2014, 20143, 201408, 2014229, 3, 8, 229, 17, 1, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-11' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-15' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-22' AS date), 1046, 3139, 13650, 13650, 13650, 13650, 13650, 13650, 13650, 2456887, 56886, N'2014-08-17', 201433, 33, 7, N'2014-W33', N'2014-W33-7');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95557, CAST(N'2014-08-18' AS date), CAST(N'2014-08-19' AS date), 2014, 20143, 201408, 2014230, 3, 8, 230, 18, 2, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-12' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-15' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-22' AS date), 1046, 3139, 13650, 13651, 13650, 13650, 13650, 13650, 13650, 2456888, 56887, N'2014-08-18', 201434, 34, 1, N'2014-W34', N'2014-W34-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95558, CAST(N'2014-08-19' AS date), CAST(N'2014-08-20' AS date), 2014, 20143, 201408, 2014231, 3, 8, 231, 19, 3, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-13' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-15' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-22' AS date), 1046, 3139, 13650, 13651, 13651, 13650, 13650, 13650, 13650, 2456889, 56888, N'2014-08-19', 201434, 34, 2, N'2014-W34', N'2014-W34-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95559, CAST(N'2014-08-20' AS date), CAST(N'2014-08-21' AS date), 2014, 20143, 201408, 2014232, 3, 8, 232, 20, 4, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-08-14' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-15' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-22' AS date), 1046, 3139, 13650, 13651, 13651, 13651, 13650, 13650, 13650, 2456890, 56889, N'2014-08-20', 201434, 34, 3, N'2014-W34', N'2014-W34-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95560, CAST(N'2014-08-21' AS date), CAST(N'2014-08-22' AS date), 2014, 20143, 201408, 2014233, 3, 8, 233, 21, 5, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-08-15' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-22' AS date), 1046, 3139, 13650, 13651, 13651, 13651, 13651, 13650, 13650, 2456891, 56890, N'2014-08-21', 201434, 34, 4, N'2014-W34', N'2014-W34-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95561, CAST(N'2014-08-22' AS date), CAST(N'2014-08-23' AS date), 2014, 20143, 201408, 2014234, 3, 8, 234, 22, 6, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-08-22' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-08-16' AS date), CAST(N'2014-08-22' AS date), 1046, 3139, 13650, 13651, 13651, 13651, 13651, 13651, 13650, 2456892, 56891, N'2014-08-22', 201434, 34, 5, N'2014-W34', N'2014-W34-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95562, CAST(N'2014-08-23' AS date), CAST(N'2014-08-24' AS date), 2014, 20143, 201408, 2014235, 3, 8, 235, 23, 7, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-17' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-08-22' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-29' AS date), 1046, 3139, 13650, 13651, 13651, 13651, 13651, 13651, 13651, 2456893, 56892, N'2014-08-23', 201434, 34, 6, N'2014-W34', N'2014-W34-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95563, CAST(N'2014-08-24' AS date), CAST(N'2014-08-25' AS date), 2014, 20143, 201408, 2014236, 3, 8, 236, 24, 1, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-08-18' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-08-22' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-29' AS date), 1046, 3139, 13651, 13651, 13651, 13651, 13651, 13651, 13651, 2456894, 56893, N'2014-08-24', 201434, 34, 7, N'2014-W34', N'2014-W34-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95564, CAST(N'2014-08-25' AS date), CAST(N'2014-08-26' AS date), 2014, 20143, 201408, 2014237, 3, 8, 237, 25, 2, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-19' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-08-22' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-29' AS date), 1046, 3139, 13651, 13652, 13651, 13651, 13651, 13651, 13651, 2456895, 56894, N'2014-08-25', 201435, 35, 1, N'2014-W35', N'2014-W35-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95565, CAST(N'2014-08-26' AS date), CAST(N'2014-08-27' AS date), 2014, 20143, 201408, 2014238, 3, 8, 238, 26, 3, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-08-20' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-08-22' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-29' AS date), 1046, 3139, 13651, 13652, 13652, 13651, 13651, 13651, 13651, 2456896, 56895, N'2014-08-26', 201435, 35, 2, N'2014-W35', N'2014-W35-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95566, CAST(N'2014-08-27' AS date), CAST(N'2014-08-28' AS date), 2014, 20143, 201408, 2014239, 3, 8, 239, 27, 4, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-08-21' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-08-22' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-29' AS date), 1046, 3139, 13651, 13652, 13652, 13652, 13651, 13651, 13651, 2456897, 56896, N'2014-08-27', 201435, 35, 3, N'2014-W35', N'2014-W35-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95567, CAST(N'2014-08-28' AS date), CAST(N'2014-08-29' AS date), 2014, 20143, 201408, 2014240, 3, 8, 240, 28, 5, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-08-22' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-29' AS date), 1046, 3139, 13651, 13652, 13652, 13652, 13652, 13651, 13651, 2456898, 56897, N'2014-08-28', 201435, 35, 4, N'2014-W35', N'2014-W35-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95568, CAST(N'2014-08-29' AS date), CAST(N'2014-08-30' AS date), 2014, 20143, 201408, 2014241, 3, 8, 241, 29, 6, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-08-29' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-08-23' AS date), CAST(N'2014-08-29' AS date), 1046, 3139, 13651, 13652, 13652, 13652, 13652, 13652, 13651, 2456899, 56898, N'2014-08-29', 201435, 35, 5, N'2014-W35', N'2014-W35-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95569, CAST(N'2014-08-30' AS date), CAST(N'2014-08-31' AS date), 2014, 20143, 201408, 2014242, 3, 8, 242, 30, 7, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-24' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-08-29' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-09-05' AS date), 1046, 3139, 13651, 13652, 13652, 13652, 13652, 13652, 13652, 2456900, 56899, N'2014-08-30', 201435, 35, 6, N'2014-W35', N'2014-W35-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95570, CAST(N'2014-08-31' AS date), CAST(N'2014-09-01' AS date), 2014, 20143, 201408, 2014243, 3, 8, 243, 31, 1, N'2014', N'2014 Q3', N'2014 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-01' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-08-25' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-08-29' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-09-05' AS date), 1046, 3139, 13652, 13652, 13652, 13652, 13652, 13652, 13652, 2456901, 56900, N'2014-08-31', 201435, 35, 7, N'2014-W35', N'2014-W35-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95571, CAST(N'2014-09-01' AS date), CAST(N'2014-09-02' AS date), 2014, 20143, 201409, 2014244, 3, 9, 244, 1, 2, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-08-26' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-08-29' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-09-05' AS date), 1046, 3140, 13652, 13653, 13652, 13652, 13652, 13652, 13652, 2456902, 56901, N'2014-09-01', 201436, 36, 1, N'2014-W36', N'2014-W36-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95572, CAST(N'2014-09-02' AS date), CAST(N'2014-09-03' AS date), 2014, 20143, 201409, 2014245, 3, 9, 245, 2, 3, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-08-27' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-08-29' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-09-05' AS date), 1046, 3140, 13652, 13653, 13653, 13652, 13652, 13652, 13652, 2456903, 56902, N'2014-09-02', 201436, 36, 2, N'2014-W36', N'2014-W36-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95573, CAST(N'2014-09-03' AS date), CAST(N'2014-09-04' AS date), 2014, 20143, 201409, 2014246, 3, 9, 246, 3, 4, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-08-28' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-08-29' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-09-05' AS date), 1046, 3140, 13652, 13653, 13653, 13653, 13652, 13652, 13652, 2456904, 56903, N'2014-09-03', 201436, 36, 3, N'2014-W36', N'2014-W36-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95574, CAST(N'2014-09-04' AS date), CAST(N'2014-09-05' AS date), 2014, 20143, 201409, 2014247, 3, 9, 247, 4, 5, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-08-29' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-09-05' AS date), 1046, 3140, 13652, 13653, 13653, 13653, 13653, 13652, 13652, 2456905, 56904, N'2014-09-04', 201436, 36, 4, N'2014-W36', N'2014-W36-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95575, CAST(N'2014-09-05' AS date), CAST(N'2014-09-06' AS date), 2014, 20143, 201409, 2014248, 3, 9, 248, 5, 6, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-05' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-08-30' AS date), CAST(N'2014-09-05' AS date), 1046, 3140, 13652, 13653, 13653, 13653, 13653, 13653, 13652, 2456906, 56905, N'2014-09-05', 201436, 36, 5, N'2014-W36', N'2014-W36-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95576, CAST(N'2014-09-06' AS date), CAST(N'2014-09-07' AS date), 2014, 20143, 201409, 2014249, 3, 9, 249, 6, 7, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-08-31' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-05' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-12' AS date), 1046, 3140, 13652, 13653, 13653, 13653, 13653, 13653, 13653, 2456907, 56906, N'2014-09-06', 201436, 36, 6, N'2014-W36', N'2014-W36-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95577, CAST(N'2014-09-07' AS date), CAST(N'2014-09-08' AS date), 2014, 20143, 201409, 2014250, 3, 9, 250, 7, 1, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-05' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-12' AS date), 1046, 3140, 13653, 13653, 13653, 13653, 13653, 13653, 13653, 2456908, 56907, N'2014-09-07', 201436, 36, 7, N'2014-W36', N'2014-W36-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95578, CAST(N'2014-09-08' AS date), CAST(N'2014-09-09' AS date), 2014, 20143, 201409, 2014251, 3, 9, 251, 8, 2, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-02' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-05' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-12' AS date), 1046, 3140, 13653, 13654, 13653, 13653, 13653, 13653, 13653, 2456909, 56908, N'2014-09-08', 201437, 37, 1, N'2014-W37', N'2014-W37-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95579, CAST(N'2014-09-09' AS date), CAST(N'2014-09-10' AS date), 2014, 20143, 201409, 2014252, 3, 9, 252, 9, 3, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-03' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-05' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-12' AS date), 1046, 3140, 13653, 13654, 13654, 13653, 13653, 13653, 13653, 2456910, 56909, N'2014-09-09', 201437, 37, 2, N'2014-W37', N'2014-W37-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95580, CAST(N'2014-09-10' AS date), CAST(N'2014-09-11' AS date), 2014, 20143, 201409, 2014253, 3, 9, 253, 10, 4, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-04' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-05' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-12' AS date), 1046, 3140, 13653, 13654, 13654, 13654, 13653, 13653, 13653, 2456911, 56910, N'2014-09-10', 201437, 37, 3, N'2014-W37', N'2014-W37-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95581, CAST(N'2014-09-11' AS date), CAST(N'2014-09-12' AS date), 2014, 20143, 201409, 2014254, 3, 9, 254, 11, 5, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-05' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-12' AS date), 1046, 3140, 13653, 13654, 13654, 13654, 13654, 13653, 13653, 2456912, 56911, N'2014-09-11', 201437, 37, 4, N'2014-W37', N'2014-W37-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95582, CAST(N'2014-09-12' AS date), CAST(N'2014-09-13' AS date), 2014, 20143, 201409, 2014255, 3, 9, 255, 12, 6, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-12' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-06' AS date), CAST(N'2014-09-12' AS date), 1046, 3140, 13653, 13654, 13654, 13654, 13654, 13654, 13653, 2456913, 56912, N'2014-09-12', 201437, 37, 5, N'2014-W37', N'2014-W37-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95583, CAST(N'2014-09-13' AS date), CAST(N'2014-09-14' AS date), 2014, 20143, 201409, 2014256, 3, 9, 256, 13, 7, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-07' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-12' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-19' AS date), 1046, 3140, 13653, 13654, 13654, 13654, 13654, 13654, 13654, 2456914, 56913, N'2014-09-13', 201437, 37, 6, N'2014-W37', N'2014-W37-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95584, CAST(N'2014-09-14' AS date), CAST(N'2014-09-15' AS date), 2014, 20143, 201409, 2014257, 3, 9, 257, 14, 1, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-08' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-12' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-19' AS date), 1046, 3140, 13654, 13654, 13654, 13654, 13654, 13654, 13654, 2456915, 56914, N'2014-09-14', 201437, 37, 7, N'2014-W37', N'2014-W37-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95585, CAST(N'2014-09-15' AS date), CAST(N'2014-09-16' AS date), 2014, 20143, 201409, 2014258, 3, 9, 258, 15, 2, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-09' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-12' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-19' AS date), 1046, 3140, 13654, 13655, 13654, 13654, 13654, 13654, 13654, 2456916, 56915, N'2014-09-15', 201438, 38, 1, N'2014-W38', N'2014-W38-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95586, CAST(N'2014-09-16' AS date), CAST(N'2014-09-17' AS date), 2014, 20143, 201409, 2014259, 3, 9, 259, 16, 3, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-10' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-12' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-19' AS date), 1046, 3140, 13654, 13655, 13655, 13654, 13654, 13654, 13654, 2456917, 56916, N'2014-09-16', 201438, 38, 2, N'2014-W38', N'2014-W38-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95587, CAST(N'2014-09-17' AS date), CAST(N'2014-09-18' AS date), 2014, 20143, 201409, 2014260, 3, 9, 260, 17, 4, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-11' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-12' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-19' AS date), 1046, 3140, 13654, 13655, 13655, 13655, 13654, 13654, 13654, 2456918, 56917, N'2014-09-17', 201438, 38, 3, N'2014-W38', N'2014-W38-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95588, CAST(N'2014-09-18' AS date), CAST(N'2014-09-19' AS date), 2014, 20143, 201409, 2014261, 3, 9, 261, 18, 5, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-12' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-19' AS date), 1046, 3140, 13654, 13655, 13655, 13655, 13655, 13654, 13654, 2456919, 56918, N'2014-09-18', 201438, 38, 4, N'2014-W38', N'2014-W38-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95589, CAST(N'2014-09-19' AS date), CAST(N'2014-09-20' AS date), 2014, 20143, 201409, 2014262, 3, 9, 262, 19, 6, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-19' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-09-13' AS date), CAST(N'2014-09-19' AS date), 1046, 3140, 13654, 13655, 13655, 13655, 13655, 13655, 13654, 2456920, 56919, N'2014-09-19', 201438, 38, 5, N'2014-W38', N'2014-W38-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95590, CAST(N'2014-09-20' AS date), CAST(N'2014-09-21' AS date), 2014, 20143, 201409, 2014263, 3, 9, 263, 20, 7, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-14' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-19' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-26' AS date), 1046, 3140, 13654, 13655, 13655, 13655, 13655, 13655, 13655, 2456921, 56920, N'2014-09-20', 201438, 38, 6, N'2014-W38', N'2014-W38-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95591, CAST(N'2014-09-21' AS date), CAST(N'2014-09-22' AS date), 2014, 20143, 201409, 2014264, 3, 9, 264, 21, 1, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-09-15' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-19' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-26' AS date), 1046, 3140, 13655, 13655, 13655, 13655, 13655, 13655, 13655, 2456922, 56921, N'2014-09-21', 201438, 38, 7, N'2014-W38', N'2014-W38-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95592, CAST(N'2014-09-22' AS date), CAST(N'2014-09-23' AS date), 2014, 20143, 201409, 2014265, 3, 9, 265, 22, 2, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-09-16' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-19' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-26' AS date), 1046, 3140, 13655, 13656, 13655, 13655, 13655, 13655, 13655, 2456923, 56922, N'2014-09-22', 201439, 39, 1, N'2014-W39', N'2014-W39-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95593, CAST(N'2014-09-23' AS date), CAST(N'2014-09-24' AS date), 2014, 20143, 201409, 2014266, 3, 9, 266, 23, 3, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-09-17' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-19' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-26' AS date), 1046, 3140, 13655, 13656, 13656, 13655, 13655, 13655, 13655, 2456924, 56923, N'2014-09-23', 201439, 39, 2, N'2014-W39', N'2014-W39-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95594, CAST(N'2014-09-24' AS date), CAST(N'2014-09-25' AS date), 2014, 20143, 201409, 2014267, 3, 9, 267, 24, 4, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-18' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-19' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-26' AS date), 1046, 3140, 13655, 13656, 13656, 13656, 13655, 13655, 13655, 2456925, 56924, N'2014-09-24', 201439, 39, 3, N'2014-W39', N'2014-W39-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95595, CAST(N'2014-09-25' AS date), CAST(N'2014-09-26' AS date), 2014, 20143, 201409, 2014268, 3, 9, 268, 25, 5, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-09-19' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-26' AS date), 1046, 3140, 13655, 13656, 13656, 13656, 13656, 13655, 13655, 2456926, 56925, N'2014-09-25', 201439, 39, 4, N'2014-W39', N'2014-W39-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95596, CAST(N'2014-09-26' AS date), CAST(N'2014-09-27' AS date), 2014, 20143, 201409, 2014269, 3, 9, 269, 26, 6, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-09-26' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-09-20' AS date), CAST(N'2014-09-26' AS date), 1046, 3140, 13655, 13656, 13656, 13656, 13656, 13656, 13655, 2456927, 56926, N'2014-09-26', 201439, 39, 5, N'2014-W39', N'2014-W39-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95597, CAST(N'2014-09-27' AS date), CAST(N'2014-09-28' AS date), 2014, 20143, 201409, 2014270, 3, 9, 270, 27, 7, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-21' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-09-26' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-10-03' AS date), 1046, 3140, 13655, 13656, 13656, 13656, 13656, 13656, 13656, 2456928, 56927, N'2014-09-27', 201439, 39, 6, N'2014-W39', N'2014-W39-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95598, CAST(N'2014-09-28' AS date), CAST(N'2014-09-29' AS date), 2014, 20143, 201409, 2014271, 3, 9, 271, 28, 1, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-09-22' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-09-26' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-10-03' AS date), 1046, 3140, 13656, 13656, 13656, 13656, 13656, 13656, 13656, 2456929, 56928, N'2014-09-28', 201439, 39, 7, N'2014-W39', N'2014-W39-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95599, CAST(N'2014-09-29' AS date), CAST(N'2014-09-30' AS date), 2014, 20143, 201409, 2014272, 3, 9, 272, 29, 2, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-09-23' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-09-26' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-10-03' AS date), 1046, 3140, 13656, 13657, 13656, 13656, 13656, 13656, 13656, 2456930, 56929, N'2014-09-29', 201440, 40, 1, N'2014-W40', N'2014-W40-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95600, CAST(N'2014-09-30' AS date), CAST(N'2014-10-01' AS date), 2014, 20143, 201409, 2014273, 3, 9, 273, 30, 3, N'2014', N'2014 Q3', N'2014 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-07-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-01' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-09-24' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-09-26' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-10-03' AS date), 1046, 3140, 13656, 13657, 13657, 13656, 13656, 13656, 13656, 2456931, 56930, N'2014-09-30', 201440, 40, 2, N'2014-W40', N'2014-W40-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95601, CAST(N'2014-10-01' AS date), CAST(N'2014-10-02' AS date), 2014, 20144, 201410, 2014274, 4, 10, 274, 1, 4, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-09-25' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-09-26' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-10-03' AS date), 1047, 3141, 13656, 13657, 13657, 13657, 13656, 13656, 13656, 2456932, 56931, N'2014-10-01', 201440, 40, 3, N'2014-W40', N'2014-W40-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95602, CAST(N'2014-10-02' AS date), CAST(N'2014-10-03' AS date), 2014, 20144, 201410, 2014275, 4, 10, 275, 2, 5, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-09-26' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-10-03' AS date), 1047, 3141, 13656, 13657, 13657, 13657, 13657, 13656, 13656, 2456933, 56932, N'2014-10-02', 201440, 40, 4, N'2014-W40', N'2014-W40-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95603, CAST(N'2014-10-03' AS date), CAST(N'2014-10-04' AS date), 2014, 20144, 201410, 2014276, 4, 10, 276, 3, 6, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-03' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-09-27' AS date), CAST(N'2014-10-03' AS date), 1047, 3141, 13656, 13657, 13657, 13657, 13657, 13657, 13656, 2456934, 56933, N'2014-10-03', 201440, 40, 5, N'2014-W40', N'2014-W40-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95604, CAST(N'2014-10-04' AS date), CAST(N'2014-10-05' AS date), 2014, 20144, 201410, 2014277, 4, 10, 277, 4, 7, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-09-28' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-03' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-10-10' AS date), 1047, 3141, 13656, 13657, 13657, 13657, 13657, 13657, 13657, 2456935, 56934, N'2014-10-04', 201440, 40, 6, N'2014-W40', N'2014-W40-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95605, CAST(N'2014-10-05' AS date), CAST(N'2014-10-06' AS date), 2014, 20144, 201410, 2014278, 4, 10, 278, 5, 1, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-09-29' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-03' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-10-10' AS date), 1047, 3141, 13657, 13657, 13657, 13657, 13657, 13657, 13657, 2456936, 56935, N'2014-10-05', 201440, 40, 7, N'2014-W40', N'2014-W40-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95606, CAST(N'2014-10-06' AS date), CAST(N'2014-10-07' AS date), 2014, 20144, 201410, 2014279, 4, 10, 279, 6, 2, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-09-30' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-03' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-10-10' AS date), 1047, 3141, 13657, 13658, 13657, 13657, 13657, 13657, 13657, 2456937, 56936, N'2014-10-06', 201441, 41, 1, N'2014-W41', N'2014-W41-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95607, CAST(N'2014-10-07' AS date), CAST(N'2014-10-08' AS date), 2014, 20144, 201410, 2014280, 4, 10, 280, 7, 3, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-03' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-10-10' AS date), 1047, 3141, 13657, 13658, 13658, 13657, 13657, 13657, 13657, 2456938, 56937, N'2014-10-07', 201441, 41, 2, N'2014-W41', N'2014-W41-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95608, CAST(N'2014-10-08' AS date), CAST(N'2014-10-09' AS date), 2014, 20144, 201410, 2014281, 4, 10, 281, 8, 4, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-02' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-03' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-10-10' AS date), 1047, 3141, 13657, 13658, 13658, 13658, 13657, 13657, 13657, 2456939, 56938, N'2014-10-08', 201441, 41, 3, N'2014-W41', N'2014-W41-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95609, CAST(N'2014-10-09' AS date), CAST(N'2014-10-10' AS date), 2014, 20144, 201410, 2014282, 4, 10, 282, 9, 5, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-03' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-10-10' AS date), 1047, 3141, 13657, 13658, 13658, 13658, 13658, 13657, 13657, 2456940, 56939, N'2014-10-09', 201441, 41, 4, N'2014-W41', N'2014-W41-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95610, CAST(N'2014-10-10' AS date), CAST(N'2014-10-11' AS date), 2014, 20144, 201410, 2014283, 4, 10, 283, 10, 6, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-10' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-04' AS date), CAST(N'2014-10-10' AS date), 1047, 3141, 13657, 13658, 13658, 13658, 13658, 13658, 13657, 2456941, 56940, N'2014-10-10', 201441, 41, 5, N'2014-W41', N'2014-W41-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95611, CAST(N'2014-10-11' AS date), CAST(N'2014-10-12' AS date), 2014, 20144, 201410, 2014284, 4, 10, 284, 11, 7, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-05' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-10' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-17' AS date), 1047, 3141, 13657, 13658, 13658, 13658, 13658, 13658, 13658, 2456942, 56941, N'2014-10-11', 201441, 41, 6, N'2014-W41', N'2014-W41-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95612, CAST(N'2014-10-12' AS date), CAST(N'2014-10-13' AS date), 2014, 20144, 201410, 2014285, 4, 10, 285, 12, 1, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-06' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-10' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-17' AS date), 1047, 3141, 13658, 13658, 13658, 13658, 13658, 13658, 13658, 2456943, 56942, N'2014-10-12', 201441, 41, 7, N'2014-W41', N'2014-W41-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95613, CAST(N'2014-10-13' AS date), CAST(N'2014-10-14' AS date), 2014, 20144, 201410, 2014286, 4, 10, 286, 13, 2, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-07' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-10' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-17' AS date), 1047, 3141, 13658, 13659, 13658, 13658, 13658, 13658, 13658, 2456944, 56943, N'2014-10-13', 201442, 42, 1, N'2014-W42', N'2014-W42-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95614, CAST(N'2014-10-14' AS date), CAST(N'2014-10-15' AS date), 2014, 20144, 201410, 2014287, 4, 10, 287, 14, 3, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-08' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-10' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-17' AS date), 1047, 3141, 13658, 13659, 13659, 13658, 13658, 13658, 13658, 2456945, 56944, N'2014-10-14', 201442, 42, 2, N'2014-W42', N'2014-W42-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95615, CAST(N'2014-10-15' AS date), CAST(N'2014-10-16' AS date), 2014, 20144, 201410, 2014288, 4, 10, 288, 15, 4, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-09' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-10' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-17' AS date), 1047, 3141, 13658, 13659, 13659, 13659, 13658, 13658, 13658, 2456946, 56945, N'2014-10-15', 201442, 42, 3, N'2014-W42', N'2014-W42-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95616, CAST(N'2014-10-16' AS date), CAST(N'2014-10-17' AS date), 2014, 20144, 201410, 2014289, 4, 10, 289, 16, 5, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-10' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-17' AS date), 1047, 3141, 13658, 13659, 13659, 13659, 13659, 13658, 13658, 2456947, 56946, N'2014-10-16', 201442, 42, 4, N'2014-W42', N'2014-W42-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95617, CAST(N'2014-10-17' AS date), CAST(N'2014-10-18' AS date), 2014, 20144, 201410, 2014290, 4, 10, 290, 17, 6, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-17' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-11' AS date), CAST(N'2014-10-17' AS date), 1047, 3141, 13658, 13659, 13659, 13659, 13659, 13659, 13658, 2456948, 56947, N'2014-10-17', 201442, 42, 5, N'2014-W42', N'2014-W42-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95618, CAST(N'2014-10-18' AS date), CAST(N'2014-10-19' AS date), 2014, 20144, 201410, 2014291, 4, 10, 291, 18, 7, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-12' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-17' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-24' AS date), 1047, 3141, 13658, 13659, 13659, 13659, 13659, 13659, 13659, 2456949, 56948, N'2014-10-18', 201442, 42, 6, N'2014-W42', N'2014-W42-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95619, CAST(N'2014-10-19' AS date), CAST(N'2014-10-20' AS date), 2014, 20144, 201410, 2014292, 4, 10, 292, 19, 1, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-13' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-17' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-24' AS date), 1047, 3141, 13659, 13659, 13659, 13659, 13659, 13659, 13659, 2456950, 56949, N'2014-10-19', 201442, 42, 7, N'2014-W42', N'2014-W42-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95620, CAST(N'2014-10-20' AS date), CAST(N'2014-10-21' AS date), 2014, 20144, 201410, 2014293, 4, 10, 293, 20, 2, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-10-14' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-17' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-24' AS date), 1047, 3141, 13659, 13660, 13659, 13659, 13659, 13659, 13659, 2456951, 56950, N'2014-10-20', 201443, 43, 1, N'2014-W43', N'2014-W43-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95621, CAST(N'2014-10-21' AS date), CAST(N'2014-10-22' AS date), 2014, 20144, 201410, 2014294, 4, 10, 294, 21, 3, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-10-15' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-17' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-24' AS date), 1047, 3141, 13659, 13660, 13660, 13659, 13659, 13659, 13659, 2456952, 56951, N'2014-10-21', 201443, 43, 2, N'2014-W43', N'2014-W43-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95622, CAST(N'2014-10-22' AS date), CAST(N'2014-10-23' AS date), 2014, 20144, 201410, 2014295, 4, 10, 295, 22, 4, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-10-16' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-17' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-24' AS date), 1047, 3141, 13659, 13660, 13660, 13660, 13659, 13659, 13659, 2456953, 56952, N'2014-10-22', 201443, 43, 3, N'2014-W43', N'2014-W43-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95623, CAST(N'2014-10-23' AS date), CAST(N'2014-10-24' AS date), 2014, 20144, 201410, 2014296, 4, 10, 296, 23, 5, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-10-17' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-24' AS date), 1047, 3141, 13659, 13660, 13660, 13660, 13660, 13659, 13659, 2456954, 56953, N'2014-10-23', 201443, 43, 4, N'2014-W43', N'2014-W43-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95624, CAST(N'2014-10-24' AS date), CAST(N'2014-10-25' AS date), 2014, 20144, 201410, 2014297, 4, 10, 297, 24, 6, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-10-24' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-10-18' AS date), CAST(N'2014-10-24' AS date), 1047, 3141, 13659, 13660, 13660, 13660, 13660, 13660, 13659, 2456955, 56954, N'2014-10-24', 201443, 43, 5, N'2014-W43', N'2014-W43-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95625, CAST(N'2014-10-25' AS date), CAST(N'2014-10-26' AS date), 2014, 20144, 201410, 2014298, 4, 10, 298, 25, 7, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-19' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-10-24' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-31' AS date), 1047, 3141, 13659, 13660, 13660, 13660, 13660, 13660, 13660, 2456956, 56955, N'2014-10-25', 201443, 43, 6, N'2014-W43', N'2014-W43-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95626, CAST(N'2014-10-26' AS date), CAST(N'2014-10-27' AS date), 2014, 20144, 201410, 2014299, 4, 10, 299, 26, 1, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-10-20' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-10-24' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-31' AS date), 1047, 3141, 13660, 13660, 13660, 13660, 13660, 13660, 13660, 2456957, 56956, N'2014-10-26', 201443, 43, 7, N'2014-W43', N'2014-W43-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95627, CAST(N'2014-10-27' AS date), CAST(N'2014-10-28' AS date), 2014, 20144, 201410, 2014300, 4, 10, 300, 27, 2, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-10-21' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-10-24' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-31' AS date), 1047, 3141, 13660, 13661, 13660, 13660, 13660, 13660, 13660, 2456958, 56957, N'2014-10-27', 201444, 44, 1, N'2014-W44', N'2014-W44-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95628, CAST(N'2014-10-28' AS date), CAST(N'2014-10-29' AS date), 2014, 20144, 201410, 2014301, 4, 10, 301, 28, 3, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-10-22' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-10-24' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-31' AS date), 1047, 3141, 13660, 13661, 13661, 13660, 13660, 13660, 13660, 2456959, 56958, N'2014-10-28', 201444, 44, 2, N'2014-W44', N'2014-W44-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95629, CAST(N'2014-10-29' AS date), CAST(N'2014-10-30' AS date), 2014, 20144, 201410, 2014302, 4, 10, 302, 29, 4, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-10-23' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-10-24' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-31' AS date), 1047, 3141, 13660, 13661, 13661, 13661, 13660, 13660, 13660, 2456960, 56959, N'2014-10-29', 201444, 44, 3, N'2014-W44', N'2014-W44-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95630, CAST(N'2014-10-30' AS date), CAST(N'2014-10-31' AS date), 2014, 20144, 201410, 2014303, 4, 10, 303, 30, 5, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-10-24' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-31' AS date), 1047, 3141, 13660, 13661, 13661, 13661, 13661, 13660, 13660, 2456961, 56960, N'2014-10-30', 201444, 44, 4, N'2014-W44', N'2014-W44-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95631, CAST(N'2014-10-31' AS date), CAST(N'2014-11-01' AS date), 2014, 20144, 201410, 2014304, 4, 10, 304, 31, 6, N'2014', N'2014 Q4', N'2014 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-10-25' AS date), CAST(N'2014-10-31' AS date), 1047, 3141, 13660, 13661, 13661, 13661, 13661, 13661, 13660, 2456962, 56961, N'2014-10-31', 201444, 44, 5, N'2014-W44', N'2014-W44-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95632, CAST(N'2014-11-01' AS date), CAST(N'2014-11-02' AS date), 2014, 20144, 201411, 2014305, 4, 11, 305, 1, 7, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-10-26' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-07' AS date), 1047, 3142, 13660, 13661, 13661, 13661, 13661, 13661, 13661, 2456963, 56962, N'2014-11-01', 201444, 44, 6, N'2014-W44', N'2014-W44-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95633, CAST(N'2014-11-02' AS date), CAST(N'2014-11-03' AS date), 2014, 20144, 201411, 2014306, 4, 11, 306, 2, 1, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-10-27' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-07' AS date), 1047, 3142, 13661, 13661, 13661, 13661, 13661, 13661, 13661, 2456964, 56963, N'2014-11-02', 201444, 44, 7, N'2014-W44', N'2014-W44-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95634, CAST(N'2014-11-03' AS date), CAST(N'2014-11-04' AS date), 2014, 20144, 201411, 2014307, 4, 11, 307, 3, 2, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-10-28' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-07' AS date), 1047, 3142, 13661, 13662, 13661, 13661, 13661, 13661, 13661, 2456965, 56964, N'2014-11-03', 201445, 45, 1, N'2014-W45', N'2014-W45-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95635, CAST(N'2014-11-04' AS date), CAST(N'2014-11-05' AS date), 2014, 20144, 201411, 2014308, 4, 11, 308, 4, 3, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-10-29' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-07' AS date), 1047, 3142, 13661, 13662, 13662, 13661, 13661, 13661, 13661, 2456966, 56965, N'2014-11-04', 201445, 45, 2, N'2014-W45', N'2014-W45-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95636, CAST(N'2014-11-05' AS date), CAST(N'2014-11-06' AS date), 2014, 20144, 201411, 2014309, 4, 11, 309, 5, 4, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-10-30' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-07' AS date), 1047, 3142, 13661, 13662, 13662, 13662, 13661, 13661, 13661, 2456967, 56966, N'2014-11-05', 201445, 45, 3, N'2014-W45', N'2014-W45-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95637, CAST(N'2014-11-06' AS date), CAST(N'2014-11-07' AS date), 2014, 20144, 201411, 2014310, 4, 11, 310, 6, 5, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-10-31' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-07' AS date), 1047, 3142, 13661, 13662, 13662, 13662, 13662, 13661, 13661, 2456968, 56967, N'2014-11-06', 201445, 45, 4, N'2014-W45', N'2014-W45-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95638, CAST(N'2014-11-07' AS date), CAST(N'2014-11-08' AS date), 2014, 20144, 201411, 2014311, 4, 11, 311, 7, 6, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-07' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-07' AS date), 1047, 3142, 13661, 13662, 13662, 13662, 13662, 13662, 13661, 2456969, 56968, N'2014-11-07', 201445, 45, 5, N'2014-W45', N'2014-W45-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95639, CAST(N'2014-11-08' AS date), CAST(N'2014-11-09' AS date), 2014, 20144, 201411, 2014312, 4, 11, 312, 8, 7, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-02' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-07' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-14' AS date), 1047, 3142, 13661, 13662, 13662, 13662, 13662, 13662, 13662, 2456970, 56969, N'2014-11-08', 201445, 45, 6, N'2014-W45', N'2014-W45-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95640, CAST(N'2014-11-09' AS date), CAST(N'2014-11-10' AS date), 2014, 20144, 201411, 2014313, 4, 11, 313, 9, 1, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-03' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-07' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-14' AS date), 1047, 3142, 13662, 13662, 13662, 13662, 13662, 13662, 13662, 2456971, 56970, N'2014-11-09', 201445, 45, 7, N'2014-W45', N'2014-W45-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95641, CAST(N'2014-11-10' AS date), CAST(N'2014-11-11' AS date), 2014, 20144, 201411, 2014314, 4, 11, 314, 10, 2, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-04' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-07' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-14' AS date), 1047, 3142, 13662, 13663, 13662, 13662, 13662, 13662, 13662, 2456972, 56971, N'2014-11-10', 201446, 46, 1, N'2014-W46', N'2014-W46-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95642, CAST(N'2014-11-11' AS date), CAST(N'2014-11-12' AS date), 2014, 20144, 201411, 2014315, 4, 11, 315, 11, 3, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-05' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-07' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-14' AS date), 1047, 3142, 13662, 13663, 13663, 13662, 13662, 13662, 13662, 2456973, 56972, N'2014-11-11', 201446, 46, 2, N'2014-W46', N'2014-W46-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95643, CAST(N'2014-11-12' AS date), CAST(N'2014-11-13' AS date), 2014, 20144, 201411, 2014316, 4, 11, 316, 12, 4, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-06' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-07' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-14' AS date), 1047, 3142, 13662, 13663, 13663, 13663, 13662, 13662, 13662, 2456974, 56973, N'2014-11-12', 201446, 46, 3, N'2014-W46', N'2014-W46-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95644, CAST(N'2014-11-13' AS date), CAST(N'2014-11-14' AS date), 2014, 20144, 201411, 2014317, 4, 11, 317, 13, 5, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-07' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-14' AS date), 1047, 3142, 13662, 13663, 13663, 13663, 13663, 13662, 13662, 2456975, 56974, N'2014-11-13', 201446, 46, 4, N'2014-W46', N'2014-W46-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95645, CAST(N'2014-11-14' AS date), CAST(N'2014-11-15' AS date), 2014, 20144, 201411, 2014318, 4, 11, 318, 14, 6, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-14' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-08' AS date), CAST(N'2014-11-14' AS date), 1047, 3142, 13662, 13663, 13663, 13663, 13663, 13663, 13662, 2456976, 56975, N'2014-11-14', 201446, 46, 5, N'2014-W46', N'2014-W46-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95646, CAST(N'2014-11-15' AS date), CAST(N'2014-11-16' AS date), 2014, 20144, 201411, 2014319, 4, 11, 319, 15, 7, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-09' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-14' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-21' AS date), 1047, 3142, 13662, 13663, 13663, 13663, 13663, 13663, 13663, 2456977, 56976, N'2014-11-15', 201446, 46, 6, N'2014-W46', N'2014-W46-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95647, CAST(N'2014-11-16' AS date), CAST(N'2014-11-17' AS date), 2014, 20144, 201411, 2014320, 4, 11, 320, 16, 1, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-10' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-14' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-21' AS date), 1047, 3142, 13663, 13663, 13663, 13663, 13663, 13663, 13663, 2456978, 56977, N'2014-11-16', 201446, 46, 7, N'2014-W46', N'2014-W46-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95648, CAST(N'2014-11-17' AS date), CAST(N'2014-11-18' AS date), 2014, 20144, 201411, 2014321, 4, 11, 321, 17, 2, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-11' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-14' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-21' AS date), 1047, 3142, 13663, 13664, 13663, 13663, 13663, 13663, 13663, 2456979, 56978, N'2014-11-17', 201447, 47, 1, N'2014-W47', N'2014-W47-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95649, CAST(N'2014-11-18' AS date), CAST(N'2014-11-19' AS date), 2014, 20144, 201411, 2014322, 4, 11, 322, 18, 3, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-12' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-14' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-21' AS date), 1047, 3142, 13663, 13664, 13664, 13663, 13663, 13663, 13663, 2456980, 56979, N'2014-11-18', 201447, 47, 2, N'2014-W47', N'2014-W47-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95650, CAST(N'2014-11-19' AS date), CAST(N'2014-11-20' AS date), 2014, 20144, 201411, 2014323, 4, 11, 323, 19, 4, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-11-13' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-14' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-21' AS date), 1047, 3142, 13663, 13664, 13664, 13664, 13663, 13663, 13663, 2456981, 56980, N'2014-11-19', 201447, 47, 3, N'2014-W47', N'2014-W47-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95651, CAST(N'2014-11-20' AS date), CAST(N'2014-11-21' AS date), 2014, 20144, 201411, 2014324, 4, 11, 324, 20, 5, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-11-14' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-21' AS date), 1047, 3142, 13663, 13664, 13664, 13664, 13664, 13663, 13663, 2456982, 56981, N'2014-11-20', 201447, 47, 4, N'2014-W47', N'2014-W47-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95652, CAST(N'2014-11-21' AS date), CAST(N'2014-11-22' AS date), 2014, 20144, 201411, 2014325, 4, 11, 325, 21, 6, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-11-21' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-11-15' AS date), CAST(N'2014-11-21' AS date), 1047, 3142, 13663, 13664, 13664, 13664, 13664, 13664, 13663, 2456983, 56982, N'2014-11-21', 201447, 47, 5, N'2014-W47', N'2014-W47-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95653, CAST(N'2014-11-22' AS date), CAST(N'2014-11-23' AS date), 2014, 20144, 201411, 2014326, 4, 11, 326, 22, 7, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-16' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-11-21' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-28' AS date), 1047, 3142, 13663, 13664, 13664, 13664, 13664, 13664, 13664, 2456984, 56983, N'2014-11-22', 201447, 47, 6, N'2014-W47', N'2014-W47-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95654, CAST(N'2014-11-23' AS date), CAST(N'2014-11-24' AS date), 2014, 20144, 201411, 2014327, 4, 11, 327, 23, 1, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-11-17' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-11-21' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-28' AS date), 1047, 3142, 13664, 13664, 13664, 13664, 13664, 13664, 13664, 2456985, 56984, N'2014-11-23', 201447, 47, 7, N'2014-W47', N'2014-W47-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95655, CAST(N'2014-11-24' AS date), CAST(N'2014-11-25' AS date), 2014, 20144, 201411, 2014328, 4, 11, 328, 24, 2, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-18' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-11-21' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-28' AS date), 1047, 3142, 13664, 13665, 13664, 13664, 13664, 13664, 13664, 2456986, 56985, N'2014-11-24', 201448, 48, 1, N'2014-W48', N'2014-W48-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95656, CAST(N'2014-11-25' AS date), CAST(N'2014-11-26' AS date), 2014, 20144, 201411, 2014329, 4, 11, 329, 25, 3, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-11-19' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-11-21' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-28' AS date), 1047, 3142, 13664, 13665, 13665, 13664, 13664, 13664, 13664, 2456987, 56986, N'2014-11-25', 201448, 48, 2, N'2014-W48', N'2014-W48-2');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95657, CAST(N'2014-11-26' AS date), CAST(N'2014-11-27' AS date), 2014, 20144, 201411, 2014330, 4, 11, 330, 26, 4, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-11-20' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-11-21' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-28' AS date), 1047, 3142, 13664, 13665, 13665, 13665, 13664, 13664, 13664, 2456988, 56987, N'2014-11-26', 201448, 48, 3, N'2014-W48', N'2014-W48-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95658, CAST(N'2014-11-27' AS date), CAST(N'2014-11-28' AS date), 2014, 20144, 201411, 2014331, 4, 11, 331, 27, 5, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-11-21' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-28' AS date), 1047, 3142, 13664, 13665, 13665, 13665, 13665, 13664, 13664, 2456989, 56988, N'2014-11-27', 201448, 48, 4, N'2014-W48', N'2014-W48-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95659, CAST(N'2014-11-28' AS date), CAST(N'2014-11-29' AS date), 2014, 20144, 201411, 2014332, 4, 11, 332, 28, 6, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-11-28' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-11-22' AS date), CAST(N'2014-11-28' AS date), 1047, 3142, 13664, 13665, 13665, 13665, 13665, 13665, 13664, 2456990, 56989, N'2014-11-28', 201448, 48, 5, N'2014-W48', N'2014-W48-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95660, CAST(N'2014-11-29' AS date), CAST(N'2014-11-30' AS date), 2014, 20144, 201411, 2014333, 4, 11, 333, 29, 7, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-23' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-11-28' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-12-05' AS date), 1047, 3142, 13664, 13665, 13665, 13665, 13665, 13665, 13665, 2456991, 56990, N'2014-11-29', 201448, 48, 6, N'2014-W48', N'2014-W48-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95661, CAST(N'2014-11-30' AS date), CAST(N'2014-12-01' AS date), 2014, 20144, 201411, 2014334, 4, 11, 334, 30, 1, N'2014', N'2014 Q4', N'2014 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-01' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-11-24' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-11-28' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-12-05' AS date), 1047, 3142, 13665, 13665, 13665, 13665, 13665, 13665, 13665, 2456992, 56991, N'2014-11-30', 201448, 48, 7, N'2014-W48', N'2014-W48-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95662, CAST(N'2014-12-01' AS date), CAST(N'2014-12-02' AS date), 2014, 20144, 201412, 2014335, 4, 12, 335, 1, 2, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-11-25' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-11-28' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-12-05' AS date), 1047, 3143, 13665, 13666, 13665, 13665, 13665, 13665, 13665, 2456993, 56992, N'2014-12-01', 201449, 49, 1, N'2014-W49', N'2014-W49-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95663, CAST(N'2014-12-02' AS date), CAST(N'2014-12-03' AS date), 2014, 20144, 201412, 2014336, 4, 12, 336, 2, 3, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-11-26' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-11-28' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-12-05' AS date), 1047, 3143, 13665, 13666, 13666, 13665, 13665, 13665, 13665, 2456994, 56993, N'2014-12-02', 201449, 49, 2, N'2014-W49', N'2014-W49-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95664, CAST(N'2014-12-03' AS date), CAST(N'2014-12-04' AS date), 2014, 20144, 201412, 2014337, 4, 12, 337, 3, 4, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-11-27' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-11-28' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-12-05' AS date), 1047, 3143, 13665, 13666, 13666, 13666, 13665, 13665, 13665, 2456995, 56994, N'2014-12-03', 201449, 49, 3, N'2014-W49', N'2014-W49-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95665, CAST(N'2014-12-04' AS date), CAST(N'2014-12-05' AS date), 2014, 20144, 201412, 2014338, 4, 12, 338, 4, 5, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-11-28' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-12-05' AS date), 1047, 3143, 13665, 13666, 13666, 13666, 13666, 13665, 13665, 2456996, 56995, N'2014-12-04', 201449, 49, 4, N'2014-W49', N'2014-W49-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95666, CAST(N'2014-12-05' AS date), CAST(N'2014-12-06' AS date), 2014, 20144, 201412, 2014339, 4, 12, 339, 5, 6, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-05' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-11-29' AS date), CAST(N'2014-12-05' AS date), 1047, 3143, 13665, 13666, 13666, 13666, 13666, 13666, 13665, 2456997, 56996, N'2014-12-05', 201449, 49, 5, N'2014-W49', N'2014-W49-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95667, CAST(N'2014-12-06' AS date), CAST(N'2014-12-07' AS date), 2014, 20144, 201412, 2014340, 4, 12, 340, 6, 7, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-11-30' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-05' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-12' AS date), 1047, 3143, 13665, 13666, 13666, 13666, 13666, 13666, 13666, 2456998, 56997, N'2014-12-06', 201449, 49, 6, N'2014-W49', N'2014-W49-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95668, CAST(N'2014-12-07' AS date), CAST(N'2014-12-08' AS date), 2014, 20144, 201412, 2014341, 4, 12, 341, 7, 1, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-05' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-12' AS date), 1047, 3143, 13666, 13666, 13666, 13666, 13666, 13666, 13666, 2456999, 56998, N'2014-12-07', 201449, 49, 7, N'2014-W49', N'2014-W49-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95669, CAST(N'2014-12-08' AS date), CAST(N'2014-12-09' AS date), 2014, 20144, 201412, 2014342, 4, 12, 342, 8, 2, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-02' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-05' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-12' AS date), 1047, 3143, 13666, 13667, 13666, 13666, 13666, 13666, 13666, 2457000, 56999, N'2014-12-08', 201450, 50, 1, N'2014-W50', N'2014-W50-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95670, CAST(N'2014-12-09' AS date), CAST(N'2014-12-10' AS date), 2014, 20144, 201412, 2014343, 4, 12, 343, 9, 3, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-03' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-05' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-12' AS date), 1047, 3143, 13666, 13667, 13667, 13666, 13666, 13666, 13666, 2457001, 57000, N'2014-12-09', 201450, 50, 2, N'2014-W50', N'2014-W50-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95671, CAST(N'2014-12-10' AS date), CAST(N'2014-12-11' AS date), 2014, 20144, 201412, 2014344, 4, 12, 344, 10, 4, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-04' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-05' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-12' AS date), 1047, 3143, 13666, 13667, 13667, 13667, 13666, 13666, 13666, 2457002, 57001, N'2014-12-10', 201450, 50, 3, N'2014-W50', N'2014-W50-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95672, CAST(N'2014-12-11' AS date), CAST(N'2014-12-12' AS date), 2014, 20144, 201412, 2014345, 4, 12, 345, 11, 5, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-05' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-12' AS date), 1047, 3143, 13666, 13667, 13667, 13667, 13667, 13666, 13666, 2457003, 57002, N'2014-12-11', 201450, 50, 4, N'2014-W50', N'2014-W50-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95673, CAST(N'2014-12-12' AS date), CAST(N'2014-12-13' AS date), 2014, 20144, 201412, 2014346, 4, 12, 346, 12, 6, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-12' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-06' AS date), CAST(N'2014-12-12' AS date), 1047, 3143, 13666, 13667, 13667, 13667, 13667, 13667, 13666, 2457004, 57003, N'2014-12-12', 201450, 50, 5, N'2014-W50', N'2014-W50-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95674, CAST(N'2014-12-13' AS date), CAST(N'2014-12-14' AS date), 2014, 20144, 201412, 2014347, 4, 12, 347, 13, 7, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-07' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-12' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-19' AS date), 1047, 3143, 13666, 13667, 13667, 13667, 13667, 13667, 13667, 2457005, 57004, N'2014-12-13', 201450, 50, 6, N'2014-W50', N'2014-W50-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95675, CAST(N'2014-12-14' AS date), CAST(N'2014-12-15' AS date), 2014, 20144, 201412, 2014348, 4, 12, 348, 14, 1, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-08' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-12' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-19' AS date), 1047, 3143, 13667, 13667, 13667, 13667, 13667, 13667, 13667, 2457006, 57005, N'2014-12-14', 201450, 50, 7, N'2014-W50', N'2014-W50-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95676, CAST(N'2014-12-15' AS date), CAST(N'2014-12-16' AS date), 2014, 20144, 201412, 2014349, 4, 12, 349, 15, 2, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-09' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-12' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-19' AS date), 1047, 3143, 13667, 13668, 13667, 13667, 13667, 13667, 13667, 2457007, 57006, N'2014-12-15', 201451, 51, 1, N'2014-W51', N'2014-W51-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95677, CAST(N'2014-12-16' AS date), CAST(N'2014-12-17' AS date), 2014, 20144, 201412, 2014350, 4, 12, 350, 16, 3, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-10' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-12' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-19' AS date), 1047, 3143, 13667, 13668, 13668, 13667, 13667, 13667, 13667, 2457008, 57007, N'2014-12-16', 201451, 51, 2, N'2014-W51', N'2014-W51-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95678, CAST(N'2014-12-17' AS date), CAST(N'2014-12-18' AS date), 2014, 20144, 201412, 2014351, 4, 12, 351, 17, 4, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-11' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-12' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-19' AS date), 1047, 3143, 13667, 13668, 13668, 13668, 13667, 13667, 13667, 2457009, 57008, N'2014-12-17', 201451, 51, 3, N'2014-W51', N'2014-W51-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95679, CAST(N'2014-12-18' AS date), CAST(N'2014-12-19' AS date), 2014, 20144, 201412, 2014352, 4, 12, 352, 18, 5, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-12' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-19' AS date), 1047, 3143, 13667, 13668, 13668, 13668, 13668, 13667, 13667, 2457010, 57009, N'2014-12-18', 201451, 51, 4, N'2014-W51', N'2014-W51-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95680, CAST(N'2014-12-19' AS date), CAST(N'2014-12-20' AS date), 2014, 20144, 201412, 2014353, 4, 12, 353, 19, 6, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-19' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-13' AS date), CAST(N'2014-12-19' AS date), 1047, 3143, 13667, 13668, 13668, 13668, 13668, 13668, 13667, 2457011, 57010, N'2014-12-19', 201451, 51, 5, N'2014-W51', N'2014-W51-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95681, CAST(N'2014-12-20' AS date), CAST(N'2014-12-21' AS date), 2014, 20144, 201412, 2014354, 4, 12, 354, 20, 7, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-14' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-19' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-26' AS date), 1047, 3143, 13667, 13668, 13668, 13668, 13668, 13668, 13668, 2457012, 57011, N'2014-12-20', 201451, 51, 6, N'2014-W51', N'2014-W51-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95682, CAST(N'2014-12-21' AS date), CAST(N'2014-12-22' AS date), 2014, 20144, 201412, 2014355, 4, 12, 355, 21, 1, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-27' AS date), CAST(N'2014-12-15' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-19' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-26' AS date), 1047, 3143, 13668, 13668, 13668, 13668, 13668, 13668, 13668, 2457013, 57012, N'2014-12-21', 201451, 51, 7, N'2014-W51', N'2014-W51-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95683, CAST(N'2014-12-22' AS date), CAST(N'2014-12-23' AS date), 2014, 20144, 201412, 2014356, 4, 12, 356, 22, 2, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-27' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-28' AS date), CAST(N'2014-12-16' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-19' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-26' AS date), 1047, 3143, 13668, 13669, 13668, 13668, 13668, 13668, 13668, 2457014, 57013, N'2014-12-22', 201452, 52, 1, N'2014-W52', N'2014-W52-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95684, CAST(N'2014-12-23' AS date), CAST(N'2014-12-24' AS date), 2014, 20144, 201412, 2014357, 4, 12, 357, 23, 3, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-27' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-28' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-29' AS date), CAST(N'2014-12-17' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-19' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-26' AS date), 1047, 3143, 13668, 13669, 13669, 13668, 13668, 13668, 13668, 2457015, 57014, N'2014-12-23', 201452, 52, 2, N'2014-W52', N'2014-W52-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95685, CAST(N'2014-12-24' AS date), CAST(N'2014-12-25' AS date), 2014, 20144, 201412, 2014358, 4, 12, 358, 24, 4, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-27' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-28' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-29' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-30' AS date), CAST(N'2014-12-18' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-19' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-26' AS date), 1047, 3143, 13668, 13669, 13669, 13669, 13668, 13668, 13668, 2457016, 57015, N'2014-12-24', 201452, 52, 3, N'2014-W52', N'2014-W52-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95686, CAST(N'2014-12-25' AS date), CAST(N'2014-12-26' AS date), 2014, 20144, 201412, 2014359, 4, 12, 359, 25, 5, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-27' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-28' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-29' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-30' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-19' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-26' AS date), 1047, 3143, 13668, 13669, 13669, 13669, 13669, 13668, 13668, 2457017, 57016, N'2014-12-25', 201452, 52, 4, N'2014-W52', N'2014-W52-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95687, CAST(N'2014-12-26' AS date), CAST(N'2014-12-27' AS date), 2014, 20144, 201412, 2014360, 4, 12, 360, 26, 6, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-27' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-28' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-29' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-30' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-26' AS date), CAST(N'2015-01-01' AS date), CAST(N'2014-12-20' AS date), CAST(N'2014-12-26' AS date), 1047, 3143, 13668, 13669, 13669, 13669, 13669, 13669, 13668, 2457018, 57017, N'2014-12-26', 201452, 52, 5, N'2014-W52', N'2014-W52-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95688, CAST(N'2014-12-27' AS date), CAST(N'2014-12-28' AS date), 2014, 20144, 201412, 2014361, 4, 12, 361, 27, 7, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-21' AS date), CAST(N'2014-12-27' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-28' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-29' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-30' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-26' AS date), CAST(N'2015-01-01' AS date), CAST(N'2014-12-27' AS date), CAST(N'2015-01-02' AS date), 1047, 3143, 13668, 13669, 13669, 13669, 13669, 13669, 13669, 2457019, 57018, N'2014-12-27', 201452, 52, 6, N'2014-W52', N'2014-W52-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95689, CAST(N'2014-12-28' AS date), CAST(N'2014-12-29' AS date), 2014, 20144, 201412, 2014362, 4, 12, 362, 28, 1, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-28' AS date), CAST(N'2015-01-03' AS date), CAST(N'2014-12-22' AS date), CAST(N'2014-12-28' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-29' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-30' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-26' AS date), CAST(N'2015-01-01' AS date), CAST(N'2014-12-27' AS date), CAST(N'2015-01-02' AS date), 1047, 3143, 13669, 13669, 13669, 13669, 13669, 13669, 13669, 2457020, 57019, N'2014-12-28', 201452, 52, 7, N'2014-W52', N'2014-W52-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95690, CAST(N'2014-12-29' AS date), CAST(N'2014-12-30' AS date), 2014, 20144, 201412, 2014363, 4, 12, 363, 29, 2, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-28' AS date), CAST(N'2015-01-03' AS date), CAST(N'2014-12-29' AS date), CAST(N'2015-01-04' AS date), CAST(N'2014-12-23' AS date), CAST(N'2014-12-29' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-30' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-26' AS date), CAST(N'2015-01-01' AS date), CAST(N'2014-12-27' AS date), CAST(N'2015-01-02' AS date), 1047, 3143, 13669, 13670, 13669, 13669, 13669, 13669, 13669, 2457021, 57020, N'2014-12-29', 201501, 1, 1, N'2015-W01', N'2015-W01-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95691, CAST(N'2014-12-30' AS date), CAST(N'2014-12-31' AS date), 2014, 20144, 201412, 2014364, 4, 12, 364, 30, 3, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-28' AS date), CAST(N'2015-01-03' AS date), CAST(N'2014-12-29' AS date), CAST(N'2015-01-04' AS date), CAST(N'2014-12-30' AS date), CAST(N'2015-01-05' AS date), CAST(N'2014-12-24' AS date), CAST(N'2014-12-30' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-26' AS date), CAST(N'2015-01-01' AS date), CAST(N'2014-12-27' AS date), CAST(N'2015-01-02' AS date), 1047, 3143, 13669, 13670, 13670, 13669, 13669, 13669, 13669, 2457022, 57021, N'2014-12-30', 201501, 1, 2, N'2015-W01', N'2015-W01-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95692, CAST(N'2014-12-31' AS date), CAST(N'2015-01-01' AS date), 2014, 20144, 201412, 2014365, 4, 12, 365, 31, 4, N'2014', N'2014 Q4', N'2014 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2014-01-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-10-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-01' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-28' AS date), CAST(N'2015-01-03' AS date), CAST(N'2014-12-29' AS date), CAST(N'2015-01-04' AS date), CAST(N'2014-12-30' AS date), CAST(N'2015-01-05' AS date), CAST(N'2014-12-31' AS date), CAST(N'2015-01-06' AS date), CAST(N'2014-12-25' AS date), CAST(N'2014-12-31' AS date), CAST(N'2014-12-26' AS date), CAST(N'2015-01-01' AS date), CAST(N'2014-12-27' AS date), CAST(N'2015-01-02' AS date), 1047, 3143, 13669, 13670, 13670, 13670, 13669, 13669, 13669, 2457023, 57022, N'2014-12-31', 201501, 1, 3, N'2015-W01', N'2015-W01-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95693, CAST(N'2015-01-01' AS date), CAST(N'2015-01-02' AS date), 2015, 20151, 201501, 2015001, 1, 1, 1, 1, 5, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2014-12-28' AS date), CAST(N'2015-01-03' AS date), CAST(N'2014-12-29' AS date), CAST(N'2015-01-04' AS date), CAST(N'2014-12-30' AS date), CAST(N'2015-01-05' AS date), CAST(N'2014-12-31' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-07' AS date), CAST(N'2014-12-26' AS date), CAST(N'2015-01-01' AS date), CAST(N'2014-12-27' AS date), CAST(N'2015-01-02' AS date), 1048, 3144, 13669, 13670, 13670, 13670, 13670, 13669, 13669, 2457024, 57023, N'2015-01-01', 201501, 1, 4, N'2015-W01', N'2015-W01-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95694, CAST(N'2015-01-02' AS date), CAST(N'2015-01-03' AS date), 2015, 20151, 201501, 2015002, 1, 1, 2, 2, 6, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2014-12-28' AS date), CAST(N'2015-01-03' AS date), CAST(N'2014-12-29' AS date), CAST(N'2015-01-04' AS date), CAST(N'2014-12-30' AS date), CAST(N'2015-01-05' AS date), CAST(N'2014-12-31' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-02' AS date), CAST(N'2015-01-08' AS date), CAST(N'2014-12-27' AS date), CAST(N'2015-01-02' AS date), 1048, 3144, 13669, 13670, 13670, 13670, 13670, 13670, 13669, 2457025, 57024, N'2015-01-02', 201501, 1, 5, N'2015-W01', N'2015-W01-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95695, CAST(N'2015-01-03' AS date), CAST(N'2015-01-04' AS date), 2015, 20151, 201501, 2015003, 1, 1, 3, 3, 7, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2014-12-28' AS date), CAST(N'2015-01-03' AS date), CAST(N'2014-12-29' AS date), CAST(N'2015-01-04' AS date), CAST(N'2014-12-30' AS date), CAST(N'2015-01-05' AS date), CAST(N'2014-12-31' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-02' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-03' AS date), CAST(N'2015-01-09' AS date), 1048, 3144, 13669, 13670, 13670, 13670, 13670, 13670, 13670, 2457026, 57025, N'2015-01-03', 201501, 1, 6, N'2015-W01', N'2015-W01-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95696, CAST(N'2015-01-04' AS date), CAST(N'2015-01-05' AS date), 2015, 20151, 201501, 2015004, 1, 1, 4, 4, 1, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-04' AS date), CAST(N'2015-01-10' AS date), CAST(N'2014-12-29' AS date), CAST(N'2015-01-04' AS date), CAST(N'2014-12-30' AS date), CAST(N'2015-01-05' AS date), CAST(N'2014-12-31' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-02' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-03' AS date), CAST(N'2015-01-09' AS date), 1048, 3144, 13670, 13670, 13670, 13670, 13670, 13670, 13670, 2457027, 57026, N'2015-01-04', 201501, 1, 7, N'2015-W01', N'2015-W01-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95697, CAST(N'2015-01-05' AS date), CAST(N'2015-01-06' AS date), 2015, 20151, 201501, 2015005, 1, 1, 5, 5, 2, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-04' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-05' AS date), CAST(N'2015-01-11' AS date), CAST(N'2014-12-30' AS date), CAST(N'2015-01-05' AS date), CAST(N'2014-12-31' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-02' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-03' AS date), CAST(N'2015-01-09' AS date), 1048, 3144, 13670, 13671, 13670, 13670, 13670, 13670, 13670, 2457028, 57027, N'2015-01-05', 201502, 2, 1, N'2015-W02', N'2015-W02-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95698, CAST(N'2015-01-06' AS date), CAST(N'2015-01-07' AS date), 2015, 20151, 201501, 2015006, 1, 1, 6, 6, 3, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-04' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-05' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-12' AS date), CAST(N'2014-12-31' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-02' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-03' AS date), CAST(N'2015-01-09' AS date), 1048, 3144, 13670, 13671, 13671, 13670, 13670, 13670, 13670, 2457029, 57028, N'2015-01-06', 201502, 2, 2, N'2015-W02', N'2015-W02-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95699, CAST(N'2015-01-07' AS date), CAST(N'2015-01-08' AS date), 2015, 20151, 201501, 2015007, 1, 1, 7, 7, 4, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-04' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-05' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-02' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-03' AS date), CAST(N'2015-01-09' AS date), 1048, 3144, 13670, 13671, 13671, 13671, 13670, 13670, 13670, 2457030, 57029, N'2015-01-07', 201502, 2, 3, N'2015-W02', N'2015-W02-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95700, CAST(N'2015-01-08' AS date), CAST(N'2015-01-09' AS date), 2015, 20151, 201501, 2015008, 1, 1, 8, 8, 5, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-04' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-05' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-02' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-03' AS date), CAST(N'2015-01-09' AS date), 1048, 3144, 13670, 13671, 13671, 13671, 13671, 13670, 13670, 2457031, 57030, N'2015-01-08', 201502, 2, 4, N'2015-W02', N'2015-W02-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95701, CAST(N'2015-01-09' AS date), CAST(N'2015-01-10' AS date), 2015, 20151, 201501, 2015009, 1, 1, 9, 9, 6, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-04' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-05' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-09' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-03' AS date), CAST(N'2015-01-09' AS date), 1048, 3144, 13670, 13671, 13671, 13671, 13671, 13671, 13670, 2457032, 57031, N'2015-01-09', 201502, 2, 5, N'2015-W02', N'2015-W02-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95702, CAST(N'2015-01-10' AS date), CAST(N'2015-01-11' AS date), 2015, 20151, 201501, 2015010, 1, 1, 10, 10, 7, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-04' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-05' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-09' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-16' AS date), 1048, 3144, 13670, 13671, 13671, 13671, 13671, 13671, 13671, 2457033, 57032, N'2015-01-10', 201502, 2, 6, N'2015-W02', N'2015-W02-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95703, CAST(N'2015-01-11' AS date), CAST(N'2015-01-12' AS date), 2015, 20151, 201501, 2015011, 1, 1, 11, 11, 1, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-05' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-09' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-16' AS date), 1048, 3144, 13671, 13671, 13671, 13671, 13671, 13671, 13671, 2457034, 57033, N'2015-01-11', 201502, 2, 7, N'2015-W02', N'2015-W02-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95704, CAST(N'2015-01-12' AS date), CAST(N'2015-01-13' AS date), 2015, 20151, 201501, 2015012, 1, 1, 12, 12, 2, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-06' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-09' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-16' AS date), 1048, 3144, 13671, 13672, 13671, 13671, 13671, 13671, 13671, 2457035, 57034, N'2015-01-12', 201503, 3, 1, N'2015-W03', N'2015-W03-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95705, CAST(N'2015-01-13' AS date), CAST(N'2015-01-14' AS date), 2015, 20151, 201501, 2015013, 1, 1, 13, 13, 3, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-07' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-09' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-16' AS date), 1048, 3144, 13671, 13672, 13672, 13671, 13671, 13671, 13671, 2457036, 57035, N'2015-01-13', 201503, 3, 2, N'2015-W03', N'2015-W03-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95706, CAST(N'2015-01-14' AS date), CAST(N'2015-01-15' AS date), 2015, 20151, 201501, 2015014, 1, 1, 14, 14, 4, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-08' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-09' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-16' AS date), 1048, 3144, 13671, 13672, 13672, 13672, 13671, 13671, 13671, 2457037, 57036, N'2015-01-14', 201503, 3, 3, N'2015-W03', N'2015-W03-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95707, CAST(N'2015-01-15' AS date), CAST(N'2015-01-16' AS date), 2015, 20151, 201501, 2015015, 1, 1, 15, 15, 5, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-09' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-16' AS date), 1048, 3144, 13671, 13672, 13672, 13672, 13672, 13671, 13671, 2457038, 57037, N'2015-01-15', 201503, 3, 4, N'2015-W03', N'2015-W03-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95708, CAST(N'2015-01-16' AS date), CAST(N'2015-01-17' AS date), 2015, 20151, 201501, 2015016, 1, 1, 16, 16, 6, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-16' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-10' AS date), CAST(N'2015-01-16' AS date), 1048, 3144, 13671, 13672, 13672, 13672, 13672, 13672, 13671, 2457039, 57038, N'2015-01-16', 201503, 3, 5, N'2015-W03', N'2015-W03-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95709, CAST(N'2015-01-17' AS date), CAST(N'2015-01-18' AS date), 2015, 20151, 201501, 2015017, 1, 1, 17, 17, 7, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-11' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-16' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-23' AS date), 1048, 3144, 13671, 13672, 13672, 13672, 13672, 13672, 13672, 2457040, 57039, N'2015-01-17', 201503, 3, 6, N'2015-W03', N'2015-W03-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95710, CAST(N'2015-01-18' AS date), CAST(N'2015-01-19' AS date), 2015, 20151, 201501, 2015018, 1, 1, 18, 18, 1, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-12' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-16' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-23' AS date), 1048, 3144, 13672, 13672, 13672, 13672, 13672, 13672, 13672, 2457041, 57040, N'2015-01-18', 201503, 3, 7, N'2015-W03', N'2015-W03-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95711, CAST(N'2015-01-19' AS date), CAST(N'2015-01-20' AS date), 2015, 20151, 201501, 2015019, 1, 1, 19, 19, 2, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-13' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-16' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-23' AS date), 1048, 3144, 13672, 13673, 13672, 13672, 13672, 13672, 13672, 2457042, 57041, N'2015-01-19', 201504, 4, 1, N'2015-W04', N'2015-W04-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95712, CAST(N'2015-01-20' AS date), CAST(N'2015-01-21' AS date), 2015, 20151, 201501, 2015020, 1, 1, 20, 20, 3, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-01-14' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-16' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-23' AS date), 1048, 3144, 13672, 13673, 13673, 13672, 13672, 13672, 13672, 2457043, 57042, N'2015-01-20', 201504, 4, 2, N'2015-W04', N'2015-W04-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95713, CAST(N'2015-01-21' AS date), CAST(N'2015-01-22' AS date), 2015, 20151, 201501, 2015021, 1, 1, 21, 21, 4, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-01-15' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-16' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-23' AS date), 1048, 3144, 13672, 13673, 13673, 13673, 13672, 13672, 13672, 2457044, 57043, N'2015-01-21', 201504, 4, 3, N'2015-W04', N'2015-W04-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95714, CAST(N'2015-01-22' AS date), CAST(N'2015-01-23' AS date), 2015, 20151, 201501, 2015022, 1, 1, 22, 22, 5, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-01-16' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-23' AS date), 1048, 3144, 13672, 13673, 13673, 13673, 13673, 13672, 13672, 2457045, 57044, N'2015-01-22', 201504, 4, 4, N'2015-W04', N'2015-W04-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95715, CAST(N'2015-01-23' AS date), CAST(N'2015-01-24' AS date), 2015, 20151, 201501, 2015023, 1, 1, 23, 23, 6, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-01-23' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-01-17' AS date), CAST(N'2015-01-23' AS date), 1048, 3144, 13672, 13673, 13673, 13673, 13673, 13673, 13672, 2457046, 57045, N'2015-01-23', 201504, 4, 5, N'2015-W04', N'2015-W04-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95716, CAST(N'2015-01-24' AS date), CAST(N'2015-01-25' AS date), 2015, 20151, 201501, 2015024, 1, 1, 24, 24, 7, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-18' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-01-23' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-30' AS date), 1048, 3144, 13672, 13673, 13673, 13673, 13673, 13673, 13673, 2457047, 57046, N'2015-01-24', 201504, 4, 6, N'2015-W04', N'2015-W04-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95717, CAST(N'2015-01-25' AS date), CAST(N'2015-01-26' AS date), 2015, 20151, 201501, 2015025, 1, 1, 25, 25, 1, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-19' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-01-23' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-30' AS date), 1048, 3144, 13673, 13673, 13673, 13673, 13673, 13673, 13673, 2457048, 57047, N'2015-01-25', 201504, 4, 7, N'2015-W04', N'2015-W04-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95718, CAST(N'2015-01-26' AS date), CAST(N'2015-01-27' AS date), 2015, 20151, 201501, 2015026, 1, 1, 26, 26, 2, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-01-20' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-01-23' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-30' AS date), 1048, 3144, 13673, 13674, 13673, 13673, 13673, 13673, 13673, 2457049, 57048, N'2015-01-26', 201505, 5, 1, N'2015-W05', N'2015-W05-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95719, CAST(N'2015-01-27' AS date), CAST(N'2015-01-28' AS date), 2015, 20151, 201501, 2015027, 1, 1, 27, 27, 3, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-01-21' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-01-23' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-30' AS date), 1048, 3144, 13673, 13674, 13674, 13673, 13673, 13673, 13673, 2457050, 57049, N'2015-01-27', 201505, 5, 2, N'2015-W05', N'2015-W05-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95720, CAST(N'2015-01-28' AS date), CAST(N'2015-01-29' AS date), 2015, 20151, 201501, 2015028, 1, 1, 28, 28, 4, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-01-22' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-01-23' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-30' AS date), 1048, 3144, 13673, 13674, 13674, 13674, 13673, 13673, 13673, 2457051, 57050, N'2015-01-28', 201505, 5, 3, N'2015-W05', N'2015-W05-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95721, CAST(N'2015-01-29' AS date), CAST(N'2015-01-30' AS date), 2015, 20151, 201501, 2015029, 1, 1, 29, 29, 5, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-01-23' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-30' AS date), 1048, 3144, 13673, 13674, 13674, 13674, 13674, 13673, 13673, 2457052, 57051, N'2015-01-29', 201505, 5, 4, N'2015-W05', N'2015-W05-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95722, CAST(N'2015-01-30' AS date), CAST(N'2015-01-31' AS date), 2015, 20151, 201501, 2015030, 1, 1, 30, 30, 6, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-01-30' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-01-24' AS date), CAST(N'2015-01-30' AS date), 1048, 3144, 13673, 13674, 13674, 13674, 13674, 13674, 13673, 2457053, 57052, N'2015-01-30', 201505, 5, 5, N'2015-W05', N'2015-W05-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95723, CAST(N'2015-01-31' AS date), CAST(N'2015-02-01' AS date), 2015, 20151, 201501, 2015031, 1, 1, 31, 31, 7, N'2015', N'2015 Q1', N'2015 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-25' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-01-30' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-02-06' AS date), 1048, 3144, 13673, 13674, 13674, 13674, 13674, 13674, 13674, 2457054, 57053, N'2015-01-31', 201505, 5, 6, N'2015-W05', N'2015-W05-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95724, CAST(N'2015-02-01' AS date), CAST(N'2015-02-02' AS date), 2015, 20151, 201502, 2015032, 1, 2, 32, 1, 1, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-01-26' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-01-30' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-02-06' AS date), 1048, 3145, 13674, 13674, 13674, 13674, 13674, 13674, 13674, 2457055, 57054, N'2015-02-01', 201505, 5, 7, N'2015-W05', N'2015-W05-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95725, CAST(N'2015-02-02' AS date), CAST(N'2015-02-03' AS date), 2015, 20151, 201502, 2015033, 1, 2, 33, 2, 2, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-01-27' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-01-30' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-02-06' AS date), 1048, 3145, 13674, 13675, 13674, 13674, 13674, 13674, 13674, 2457056, 57055, N'2015-02-02', 201506, 6, 1, N'2015-W06', N'2015-W06-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95726, CAST(N'2015-02-03' AS date), CAST(N'2015-02-04' AS date), 2015, 20151, 201502, 2015034, 1, 2, 34, 3, 3, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-01-28' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-01-30' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-02-06' AS date), 1048, 3145, 13674, 13675, 13675, 13674, 13674, 13674, 13674, 2457057, 57056, N'2015-02-03', 201506, 6, 2, N'2015-W06', N'2015-W06-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95727, CAST(N'2015-02-04' AS date), CAST(N'2015-02-05' AS date), 2015, 20151, 201502, 2015035, 1, 2, 35, 4, 4, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-01-29' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-01-30' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-02-06' AS date), 1048, 3145, 13674, 13675, 13675, 13675, 13674, 13674, 13674, 2457058, 57057, N'2015-02-04', 201506, 6, 3, N'2015-W06', N'2015-W06-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95728, CAST(N'2015-02-05' AS date), CAST(N'2015-02-06' AS date), 2015, 20151, 201502, 2015036, 1, 2, 36, 5, 5, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-01-30' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-02-06' AS date), 1048, 3145, 13674, 13675, 13675, 13675, 13675, 13674, 13674, 2457059, 57058, N'2015-02-05', 201506, 6, 4, N'2015-W06', N'2015-W06-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95729, CAST(N'2015-02-06' AS date), CAST(N'2015-02-07' AS date), 2015, 20151, 201502, 2015037, 1, 2, 37, 6, 6, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-06' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-01-31' AS date), CAST(N'2015-02-06' AS date), 1048, 3145, 13674, 13675, 13675, 13675, 13675, 13675, 13674, 2457060, 57059, N'2015-02-06', 201506, 6, 5, N'2015-W06', N'2015-W06-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95730, CAST(N'2015-02-07' AS date), CAST(N'2015-02-08' AS date), 2015, 20151, 201502, 2015038, 1, 2, 38, 7, 7, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-06' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-13' AS date), 1048, 3145, 13674, 13675, 13675, 13675, 13675, 13675, 13675, 2457061, 57060, N'2015-02-07', 201506, 6, 6, N'2015-W06', N'2015-W06-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95731, CAST(N'2015-02-08' AS date), CAST(N'2015-02-09' AS date), 2015, 20151, 201502, 2015039, 1, 2, 39, 8, 1, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-02' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-06' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-13' AS date), 1048, 3145, 13675, 13675, 13675, 13675, 13675, 13675, 13675, 2457062, 57061, N'2015-02-08', 201506, 6, 7, N'2015-W06', N'2015-W06-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95732, CAST(N'2015-02-09' AS date), CAST(N'2015-02-10' AS date), 2015, 20151, 201502, 2015040, 1, 2, 40, 9, 2, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-03' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-06' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-13' AS date), 1048, 3145, 13675, 13676, 13675, 13675, 13675, 13675, 13675, 2457063, 57062, N'2015-02-09', 201507, 7, 1, N'2015-W07', N'2015-W07-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95733, CAST(N'2015-02-10' AS date), CAST(N'2015-02-11' AS date), 2015, 20151, 201502, 2015041, 1, 2, 41, 10, 3, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-04' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-06' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-13' AS date), 1048, 3145, 13675, 13676, 13676, 13675, 13675, 13675, 13675, 2457064, 57063, N'2015-02-10', 201507, 7, 2, N'2015-W07', N'2015-W07-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95734, CAST(N'2015-02-11' AS date), CAST(N'2015-02-12' AS date), 2015, 20151, 201502, 2015042, 1, 2, 42, 11, 4, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-05' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-06' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-13' AS date), 1048, 3145, 13675, 13676, 13676, 13676, 13675, 13675, 13675, 2457065, 57064, N'2015-02-11', 201507, 7, 3, N'2015-W07', N'2015-W07-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95735, CAST(N'2015-02-12' AS date), CAST(N'2015-02-13' AS date), 2015, 20151, 201502, 2015043, 1, 2, 43, 12, 5, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-06' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-13' AS date), 1048, 3145, 13675, 13676, 13676, 13676, 13676, 13675, 13675, 2457066, 57065, N'2015-02-12', 201507, 7, 4, N'2015-W07', N'2015-W07-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95736, CAST(N'2015-02-13' AS date), CAST(N'2015-02-14' AS date), 2015, 20151, 201502, 2015044, 1, 2, 44, 13, 6, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-13' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-07' AS date), CAST(N'2015-02-13' AS date), 1048, 3145, 13675, 13676, 13676, 13676, 13676, 13676, 13675, 2457067, 57066, N'2015-02-13', 201507, 7, 5, N'2015-W07', N'2015-W07-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95737, CAST(N'2015-02-14' AS date), CAST(N'2015-02-15' AS date), 2015, 20151, 201502, 2015045, 1, 2, 45, 14, 7, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-08' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-13' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-20' AS date), 1048, 3145, 13675, 13676, 13676, 13676, 13676, 13676, 13676, 2457068, 57067, N'2015-02-14', 201507, 7, 6, N'2015-W07', N'2015-W07-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95738, CAST(N'2015-02-15' AS date), CAST(N'2015-02-16' AS date), 2015, 20151, 201502, 2015046, 1, 2, 46, 15, 1, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-09' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-13' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-20' AS date), 1048, 3145, 13676, 13676, 13676, 13676, 13676, 13676, 13676, 2457069, 57068, N'2015-02-15', 201507, 7, 7, N'2015-W07', N'2015-W07-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95739, CAST(N'2015-02-16' AS date), CAST(N'2015-02-17' AS date), 2015, 20151, 201502, 2015047, 1, 2, 47, 16, 2, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-10' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-13' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-20' AS date), 1048, 3145, 13676, 13677, 13676, 13676, 13676, 13676, 13676, 2457070, 57069, N'2015-02-16', 201508, 8, 1, N'2015-W08', N'2015-W08-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95740, CAST(N'2015-02-17' AS date), CAST(N'2015-02-18' AS date), 2015, 20151, 201502, 2015048, 1, 2, 48, 17, 3, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-02-11' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-13' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-20' AS date), 1048, 3145, 13676, 13677, 13677, 13676, 13676, 13676, 13676, 2457071, 57070, N'2015-02-17', 201508, 8, 2, N'2015-W08', N'2015-W08-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95741, CAST(N'2015-02-18' AS date), CAST(N'2015-02-19' AS date), 2015, 20151, 201502, 2015049, 1, 2, 49, 18, 4, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-02-12' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-13' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-20' AS date), 1048, 3145, 13676, 13677, 13677, 13677, 13676, 13676, 13676, 2457072, 57071, N'2015-02-18', 201508, 8, 3, N'2015-W08', N'2015-W08-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95742, CAST(N'2015-02-19' AS date), CAST(N'2015-02-20' AS date), 2015, 20151, 201502, 2015050, 1, 2, 50, 19, 5, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-02-13' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-20' AS date), 1048, 3145, 13676, 13677, 13677, 13677, 13677, 13676, 13676, 2457073, 57072, N'2015-02-19', 201508, 8, 4, N'2015-W08', N'2015-W08-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95743, CAST(N'2015-02-20' AS date), CAST(N'2015-02-21' AS date), 2015, 20151, 201502, 2015051, 1, 2, 51, 20, 6, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-02-20' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-02-14' AS date), CAST(N'2015-02-20' AS date), 1048, 3145, 13676, 13677, 13677, 13677, 13677, 13677, 13676, 2457074, 57073, N'2015-02-20', 201508, 8, 5, N'2015-W08', N'2015-W08-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95744, CAST(N'2015-02-21' AS date), CAST(N'2015-02-22' AS date), 2015, 20151, 201502, 2015052, 1, 2, 52, 21, 7, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-15' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-02-20' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-27' AS date), 1048, 3145, 13676, 13677, 13677, 13677, 13677, 13677, 13677, 2457075, 57074, N'2015-02-21', 201508, 8, 6, N'2015-W08', N'2015-W08-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95745, CAST(N'2015-02-22' AS date), CAST(N'2015-02-23' AS date), 2015, 20151, 201502, 2015053, 1, 2, 53, 22, 1, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-16' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-02-20' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-27' AS date), 1048, 3145, 13677, 13677, 13677, 13677, 13677, 13677, 13677, 2457076, 57075, N'2015-02-22', 201508, 8, 7, N'2015-W08', N'2015-W08-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95746, CAST(N'2015-02-23' AS date), CAST(N'2015-02-24' AS date), 2015, 20151, 201502, 2015054, 1, 2, 54, 23, 2, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-02-17' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-02-20' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-27' AS date), 1048, 3145, 13677, 13678, 13677, 13677, 13677, 13677, 13677, 2457077, 57076, N'2015-02-23', 201509, 9, 1, N'2015-W09', N'2015-W09-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95747, CAST(N'2015-02-24' AS date), CAST(N'2015-02-25' AS date), 2015, 20151, 201502, 2015055, 1, 2, 55, 24, 3, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-02-18' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-02-20' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-27' AS date), 1048, 3145, 13677, 13678, 13678, 13677, 13677, 13677, 13677, 2457078, 57077, N'2015-02-24', 201509, 9, 2, N'2015-W09', N'2015-W09-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95748, CAST(N'2015-02-25' AS date), CAST(N'2015-02-26' AS date), 2015, 20151, 201502, 2015056, 1, 2, 56, 25, 4, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-02-19' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-02-20' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-27' AS date), 1048, 3145, 13677, 13678, 13678, 13678, 13677, 13677, 13677, 2457079, 57078, N'2015-02-25', 201509, 9, 3, N'2015-W09', N'2015-W09-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95749, CAST(N'2015-02-26' AS date), CAST(N'2015-02-27' AS date), 2015, 20151, 201502, 2015057, 1, 2, 57, 26, 5, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-02-20' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-27' AS date), 1048, 3145, 13677, 13678, 13678, 13678, 13678, 13677, 13677, 2457080, 57079, N'2015-02-26', 201509, 9, 4, N'2015-W09', N'2015-W09-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95750, CAST(N'2015-02-27' AS date), CAST(N'2015-02-28' AS date), 2015, 20151, 201502, 2015058, 1, 2, 58, 27, 6, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-02-27' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-02-21' AS date), CAST(N'2015-02-27' AS date), 1048, 3145, 13677, 13678, 13678, 13678, 13678, 13678, 13677, 2457081, 57080, N'2015-02-27', 201509, 9, 5, N'2015-W09', N'2015-W09-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95751, CAST(N'2015-02-28' AS date), CAST(N'2015-03-01' AS date), 2015, 20151, 201502, 2015059, 1, 2, 59, 28, 7, N'2015', N'2015 Q1', N'2015 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-02-01' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-22' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-02-27' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-03-06' AS date), 1048, 3145, 13677, 13678, 13678, 13678, 13678, 13678, 13678, 2457082, 57081, N'2015-02-28', 201509, 9, 6, N'2015-W09', N'2015-W09-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95752, CAST(N'2015-03-01' AS date), CAST(N'2015-03-02' AS date), 2015, 20151, 201503, 2015060, 1, 3, 60, 1, 1, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-02-23' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-02-27' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-03-06' AS date), 1048, 3146, 13678, 13678, 13678, 13678, 13678, 13678, 13678, 2457083, 57082, N'2015-03-01', 201509, 9, 7, N'2015-W09', N'2015-W09-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95753, CAST(N'2015-03-02' AS date), CAST(N'2015-03-03' AS date), 2015, 20151, 201503, 2015061, 1, 3, 61, 2, 2, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-02-24' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-02-27' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-03-06' AS date), 1048, 3146, 13678, 13679, 13678, 13678, 13678, 13678, 13678, 2457084, 57083, N'2015-03-02', 201510, 10, 1, N'2015-W10', N'2015-W10-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95754, CAST(N'2015-03-03' AS date), CAST(N'2015-03-04' AS date), 2015, 20151, 201503, 2015062, 1, 3, 62, 3, 3, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-02-25' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-02-27' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-03-06' AS date), 1048, 3146, 13678, 13679, 13679, 13678, 13678, 13678, 13678, 2457085, 57084, N'2015-03-03', 201510, 10, 2, N'2015-W10', N'2015-W10-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95755, CAST(N'2015-03-04' AS date), CAST(N'2015-03-05' AS date), 2015, 20151, 201503, 2015063, 1, 3, 63, 4, 4, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-02-26' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-02-27' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-03-06' AS date), 1048, 3146, 13678, 13679, 13679, 13679, 13678, 13678, 13678, 2457086, 57085, N'2015-03-04', 201510, 10, 3, N'2015-W10', N'2015-W10-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95756, CAST(N'2015-03-05' AS date), CAST(N'2015-03-06' AS date), 2015, 20151, 201503, 2015064, 1, 3, 64, 5, 5, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-02-27' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-03-06' AS date), 1048, 3146, 13678, 13679, 13679, 13679, 13679, 13678, 13678, 2457087, 57086, N'2015-03-05', 201510, 10, 4, N'2015-W10', N'2015-W10-4');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95757, CAST(N'2015-03-06' AS date), CAST(N'2015-03-07' AS date), 2015, 20151, 201503, 2015065, 1, 3, 65, 6, 6, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-06' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-02-28' AS date), CAST(N'2015-03-06' AS date), 1048, 3146, 13678, 13679, 13679, 13679, 13679, 13679, 13678, 2457088, 57087, N'2015-03-06', 201510, 10, 5, N'2015-W10', N'2015-W10-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95758, CAST(N'2015-03-07' AS date), CAST(N'2015-03-08' AS date), 2015, 20151, 201503, 2015066, 1, 3, 66, 7, 7, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-06' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-13' AS date), 1048, 3146, 13678, 13679, 13679, 13679, 13679, 13679, 13679, 2457089, 57088, N'2015-03-07', 201510, 10, 6, N'2015-W10', N'2015-W10-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95759, CAST(N'2015-03-08' AS date), CAST(N'2015-03-09' AS date), 2015, 20151, 201503, 2015067, 1, 3, 67, 8, 1, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-02' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-06' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-13' AS date), 1048, 3146, 13679, 13679, 13679, 13679, 13679, 13679, 13679, 2457090, 57089, N'2015-03-08', 201510, 10, 7, N'2015-W10', N'2015-W10-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95760, CAST(N'2015-03-09' AS date), CAST(N'2015-03-10' AS date), 2015, 20151, 201503, 2015068, 1, 3, 68, 9, 2, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-03' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-06' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-13' AS date), 1048, 3146, 13679, 13680, 13679, 13679, 13679, 13679, 13679, 2457091, 57090, N'2015-03-09', 201511, 11, 1, N'2015-W11', N'2015-W11-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95761, CAST(N'2015-03-10' AS date), CAST(N'2015-03-11' AS date), 2015, 20151, 201503, 2015069, 1, 3, 69, 10, 3, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-04' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-06' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-13' AS date), 1048, 3146, 13679, 13680, 13680, 13679, 13679, 13679, 13679, 2457092, 57091, N'2015-03-10', 201511, 11, 2, N'2015-W11', N'2015-W11-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95762, CAST(N'2015-03-11' AS date), CAST(N'2015-03-12' AS date), 2015, 20151, 201503, 2015070, 1, 3, 70, 11, 4, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-05' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-06' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-13' AS date), 1048, 3146, 13679, 13680, 13680, 13680, 13679, 13679, 13679, 2457093, 57092, N'2015-03-11', 201511, 11, 3, N'2015-W11', N'2015-W11-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95763, CAST(N'2015-03-12' AS date), CAST(N'2015-03-13' AS date), 2015, 20151, 201503, 2015071, 1, 3, 71, 12, 5, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-06' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-13' AS date), 1048, 3146, 13679, 13680, 13680, 13680, 13680, 13679, 13679, 2457094, 57093, N'2015-03-12', 201511, 11, 4, N'2015-W11', N'2015-W11-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95764, CAST(N'2015-03-13' AS date), CAST(N'2015-03-14' AS date), 2015, 20151, 201503, 2015072, 1, 3, 72, 13, 6, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-13' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-07' AS date), CAST(N'2015-03-13' AS date), 1048, 3146, 13679, 13680, 13680, 13680, 13680, 13680, 13679, 2457095, 57094, N'2015-03-13', 201511, 11, 5, N'2015-W11', N'2015-W11-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95765, CAST(N'2015-03-14' AS date), CAST(N'2015-03-15' AS date), 2015, 20151, 201503, 2015073, 1, 3, 73, 14, 7, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-08' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-13' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-20' AS date), 1048, 3146, 13679, 13680, 13680, 13680, 13680, 13680, 13680, 2457096, 57095, N'2015-03-14', 201511, 11, 6, N'2015-W11', N'2015-W11-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95766, CAST(N'2015-03-15' AS date), CAST(N'2015-03-16' AS date), 2015, 20151, 201503, 2015074, 1, 3, 74, 15, 1, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-09' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-13' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-20' AS date), 1048, 3146, 13680, 13680, 13680, 13680, 13680, 13680, 13680, 2457097, 57096, N'2015-03-15', 201511, 11, 7, N'2015-W11', N'2015-W11-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95767, CAST(N'2015-03-16' AS date), CAST(N'2015-03-17' AS date), 2015, 20151, 201503, 2015075, 1, 3, 75, 16, 2, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-10' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-13' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-20' AS date), 1048, 3146, 13680, 13681, 13680, 13680, 13680, 13680, 13680, 2457098, 57097, N'2015-03-16', 201512, 12, 1, N'2015-W12', N'2015-W12-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95768, CAST(N'2015-03-17' AS date), CAST(N'2015-03-18' AS date), 2015, 20151, 201503, 2015076, 1, 3, 76, 17, 3, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-11' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-13' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-20' AS date), 1048, 3146, 13680, 13681, 13681, 13680, 13680, 13680, 13680, 2457099, 57098, N'2015-03-17', 201512, 12, 2, N'2015-W12', N'2015-W12-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95769, CAST(N'2015-03-18' AS date), CAST(N'2015-03-19' AS date), 2015, 20151, 201503, 2015077, 1, 3, 77, 18, 4, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-12' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-13' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-20' AS date), 1048, 3146, 13680, 13681, 13681, 13681, 13680, 13680, 13680, 2457100, 57099, N'2015-03-18', 201512, 12, 3, N'2015-W12', N'2015-W12-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95770, CAST(N'2015-03-19' AS date), CAST(N'2015-03-20' AS date), 2015, 20151, 201503, 2015078, 1, 3, 78, 19, 5, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-13' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-20' AS date), 1048, 3146, 13680, 13681, 13681, 13681, 13681, 13680, 13680, 2457101, 57100, N'2015-03-19', 201512, 12, 4, N'2015-W12', N'2015-W12-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95771, CAST(N'2015-03-20' AS date), CAST(N'2015-03-21' AS date), 2015, 20151, 201503, 2015079, 1, 3, 79, 20, 6, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-20' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-03-14' AS date), CAST(N'2015-03-20' AS date), 1048, 3146, 13680, 13681, 13681, 13681, 13681, 13681, 13680, 2457102, 57101, N'2015-03-20', 201512, 12, 5, N'2015-W12', N'2015-W12-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95772, CAST(N'2015-03-21' AS date), CAST(N'2015-03-22' AS date), 2015, 20151, 201503, 2015080, 1, 3, 80, 21, 7, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-15' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-20' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-27' AS date), 1048, 3146, 13680, 13681, 13681, 13681, 13681, 13681, 13681, 2457103, 57102, N'2015-03-21', 201512, 12, 6, N'2015-W12', N'2015-W12-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95773, CAST(N'2015-03-22' AS date), CAST(N'2015-03-23' AS date), 2015, 20151, 201503, 2015081, 1, 3, 81, 22, 1, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-03-16' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-20' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-27' AS date), 1048, 3146, 13681, 13681, 13681, 13681, 13681, 13681, 13681, 2457104, 57103, N'2015-03-22', 201512, 12, 7, N'2015-W12', N'2015-W12-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95774, CAST(N'2015-03-23' AS date), CAST(N'2015-03-24' AS date), 2015, 20151, 201503, 2015082, 1, 3, 82, 23, 2, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-03-17' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-20' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-27' AS date), 1048, 3146, 13681, 13682, 13681, 13681, 13681, 13681, 13681, 2457105, 57104, N'2015-03-23', 201513, 13, 1, N'2015-W13', N'2015-W13-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95775, CAST(N'2015-03-24' AS date), CAST(N'2015-03-25' AS date), 2015, 20151, 201503, 2015083, 1, 3, 83, 24, 3, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-03-18' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-20' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-27' AS date), 1048, 3146, 13681, 13682, 13682, 13681, 13681, 13681, 13681, 2457106, 57105, N'2015-03-24', 201513, 13, 2, N'2015-W13', N'2015-W13-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95776, CAST(N'2015-03-25' AS date), CAST(N'2015-03-26' AS date), 2015, 20151, 201503, 2015084, 1, 3, 84, 25, 4, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-19' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-20' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-27' AS date), 1048, 3146, 13681, 13682, 13682, 13682, 13681, 13681, 13681, 2457107, 57106, N'2015-03-25', 201513, 13, 3, N'2015-W13', N'2015-W13-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95777, CAST(N'2015-03-26' AS date), CAST(N'2015-03-27' AS date), 2015, 20151, 201503, 2015085, 1, 3, 85, 26, 5, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-03-20' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-27' AS date), 1048, 3146, 13681, 13682, 13682, 13682, 13682, 13681, 13681, 2457108, 57107, N'2015-03-26', 201513, 13, 4, N'2015-W13', N'2015-W13-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95778, CAST(N'2015-03-27' AS date), CAST(N'2015-03-28' AS date), 2015, 20151, 201503, 2015086, 1, 3, 86, 27, 6, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-03-27' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-03-21' AS date), CAST(N'2015-03-27' AS date), 1048, 3146, 13681, 13682, 13682, 13682, 13682, 13682, 13681, 2457109, 57108, N'2015-03-27', 201513, 13, 5, N'2015-W13', N'2015-W13-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95779, CAST(N'2015-03-28' AS date), CAST(N'2015-03-29' AS date), 2015, 20151, 201503, 2015087, 1, 3, 87, 28, 7, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-22' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-03-27' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-04-03' AS date), 1048, 3146, 13681, 13682, 13682, 13682, 13682, 13682, 13682, 2457110, 57109, N'2015-03-28', 201513, 13, 6, N'2015-W13', N'2015-W13-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95780, CAST(N'2015-03-29' AS date), CAST(N'2015-03-30' AS date), 2015, 20151, 201503, 2015088, 1, 3, 88, 29, 1, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-03-23' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-03-27' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-04-03' AS date), 1048, 3146, 13682, 13682, 13682, 13682, 13682, 13682, 13682, 2457111, 57110, N'2015-03-29', 201513, 13, 7, N'2015-W13', N'2015-W13-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95781, CAST(N'2015-03-30' AS date), CAST(N'2015-03-31' AS date), 2015, 20151, 201503, 2015089, 1, 3, 89, 30, 2, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-03-24' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-03-27' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-04-03' AS date), 1048, 3146, 13682, 13683, 13682, 13682, 13682, 13682, 13682, 2457112, 57111, N'2015-03-30', 201514, 14, 1, N'2015-W14', N'2015-W14-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95782, CAST(N'2015-03-31' AS date), CAST(N'2015-04-01' AS date), 2015, 20151, 201503, 2015090, 1, 3, 90, 31, 3, N'2015', N'2015 Q1', N'2015 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-01-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-01' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-03-25' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-03-27' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-04-03' AS date), 1048, 3146, 13682, 13683, 13683, 13682, 13682, 13682, 13682, 2457113, 57112, N'2015-03-31', 201514, 14, 2, N'2015-W14', N'2015-W14-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95783, CAST(N'2015-04-01' AS date), CAST(N'2015-04-02' AS date), 2015, 20152, 201504, 2015091, 2, 4, 91, 1, 4, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-03-26' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-03-27' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-04-03' AS date), 1049, 3147, 13682, 13683, 13683, 13683, 13682, 13682, 13682, 2457114, 57113, N'2015-04-01', 201514, 14, 3, N'2015-W14', N'2015-W14-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95784, CAST(N'2015-04-02' AS date), CAST(N'2015-04-03' AS date), 2015, 20152, 201504, 2015092, 2, 4, 92, 2, 5, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-03-27' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-04-03' AS date), 1049, 3147, 13682, 13683, 13683, 13683, 13683, 13682, 13682, 2457115, 57114, N'2015-04-02', 201514, 14, 4, N'2015-W14', N'2015-W14-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95785, CAST(N'2015-04-03' AS date), CAST(N'2015-04-04' AS date), 2015, 20152, 201504, 2015093, 2, 4, 93, 3, 6, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-03' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-03-28' AS date), CAST(N'2015-04-03' AS date), 1049, 3147, 13682, 13683, 13683, 13683, 13683, 13683, 13682, 2457116, 57115, N'2015-04-03', 201514, 14, 5, N'2015-W14', N'2015-W14-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95786, CAST(N'2015-04-04' AS date), CAST(N'2015-04-05' AS date), 2015, 20152, 201504, 2015094, 2, 4, 94, 4, 7, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-03-29' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-03' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-04-10' AS date), 1049, 3147, 13682, 13683, 13683, 13683, 13683, 13683, 13683, 2457117, 57116, N'2015-04-04', 201514, 14, 6, N'2015-W14', N'2015-W14-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95787, CAST(N'2015-04-05' AS date), CAST(N'2015-04-06' AS date), 2015, 20152, 201504, 2015095, 2, 4, 95, 5, 1, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-03-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-03' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-04-10' AS date), 1049, 3147, 13683, 13683, 13683, 13683, 13683, 13683, 13683, 2457118, 57117, N'2015-04-05', 201514, 14, 7, N'2015-W14', N'2015-W14-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95788, CAST(N'2015-04-06' AS date), CAST(N'2015-04-07' AS date), 2015, 20152, 201504, 2015096, 2, 4, 96, 6, 2, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-03-31' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-03' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-04-10' AS date), 1049, 3147, 13683, 13684, 13683, 13683, 13683, 13683, 13683, 2457119, 57118, N'2015-04-06', 201515, 15, 1, N'2015-W15', N'2015-W15-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95789, CAST(N'2015-04-07' AS date), CAST(N'2015-04-08' AS date), 2015, 20152, 201504, 2015097, 2, 4, 97, 7, 3, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-03' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-04-10' AS date), 1049, 3147, 13683, 13684, 13684, 13683, 13683, 13683, 13683, 2457120, 57119, N'2015-04-07', 201515, 15, 2, N'2015-W15', N'2015-W15-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95790, CAST(N'2015-04-08' AS date), CAST(N'2015-04-09' AS date), 2015, 20152, 201504, 2015098, 2, 4, 98, 8, 4, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-02' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-03' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-04-10' AS date), 1049, 3147, 13683, 13684, 13684, 13684, 13683, 13683, 13683, 2457121, 57120, N'2015-04-08', 201515, 15, 3, N'2015-W15', N'2015-W15-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95791, CAST(N'2015-04-09' AS date), CAST(N'2015-04-10' AS date), 2015, 20152, 201504, 2015099, 2, 4, 99, 9, 5, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-03' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-04-10' AS date), 1049, 3147, 13683, 13684, 13684, 13684, 13684, 13683, 13683, 2457122, 57121, N'2015-04-09', 201515, 15, 4, N'2015-W15', N'2015-W15-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95792, CAST(N'2015-04-10' AS date), CAST(N'2015-04-11' AS date), 2015, 20152, 201504, 2015100, 2, 4, 100, 10, 6, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-10' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-04' AS date), CAST(N'2015-04-10' AS date), 1049, 3147, 13683, 13684, 13684, 13684, 13684, 13684, 13683, 2457123, 57122, N'2015-04-10', 201515, 15, 5, N'2015-W15', N'2015-W15-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95793, CAST(N'2015-04-11' AS date), CAST(N'2015-04-12' AS date), 2015, 20152, 201504, 2015101, 2, 4, 101, 11, 7, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-05' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-10' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-17' AS date), 1049, 3147, 13683, 13684, 13684, 13684, 13684, 13684, 13684, 2457124, 57123, N'2015-04-11', 201515, 15, 6, N'2015-W15', N'2015-W15-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95794, CAST(N'2015-04-12' AS date), CAST(N'2015-04-13' AS date), 2015, 20152, 201504, 2015102, 2, 4, 102, 12, 1, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-06' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-10' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-17' AS date), 1049, 3147, 13684, 13684, 13684, 13684, 13684, 13684, 13684, 2457125, 57124, N'2015-04-12', 201515, 15, 7, N'2015-W15', N'2015-W15-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95795, CAST(N'2015-04-13' AS date), CAST(N'2015-04-14' AS date), 2015, 20152, 201504, 2015103, 2, 4, 103, 13, 2, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-07' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-10' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-17' AS date), 1049, 3147, 13684, 13685, 13684, 13684, 13684, 13684, 13684, 2457126, 57125, N'2015-04-13', 201516, 16, 1, N'2015-W16', N'2015-W16-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95796, CAST(N'2015-04-14' AS date), CAST(N'2015-04-15' AS date), 2015, 20152, 201504, 2015104, 2, 4, 104, 14, 3, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-08' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-10' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-17' AS date), 1049, 3147, 13684, 13685, 13685, 13684, 13684, 13684, 13684, 2457127, 57126, N'2015-04-14', 201516, 16, 2, N'2015-W16', N'2015-W16-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95797, CAST(N'2015-04-15' AS date), CAST(N'2015-04-16' AS date), 2015, 20152, 201504, 2015105, 2, 4, 105, 15, 4, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-09' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-10' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-17' AS date), 1049, 3147, 13684, 13685, 13685, 13685, 13684, 13684, 13684, 2457128, 57127, N'2015-04-15', 201516, 16, 3, N'2015-W16', N'2015-W16-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95798, CAST(N'2015-04-16' AS date), CAST(N'2015-04-17' AS date), 2015, 20152, 201504, 2015106, 2, 4, 106, 16, 5, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-10' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-17' AS date), 1049, 3147, 13684, 13685, 13685, 13685, 13685, 13684, 13684, 2457129, 57128, N'2015-04-16', 201516, 16, 4, N'2015-W16', N'2015-W16-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95799, CAST(N'2015-04-17' AS date), CAST(N'2015-04-18' AS date), 2015, 20152, 201504, 2015107, 2, 4, 107, 17, 6, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-17' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-11' AS date), CAST(N'2015-04-17' AS date), 1049, 3147, 13684, 13685, 13685, 13685, 13685, 13685, 13684, 2457130, 57129, N'2015-04-17', 201516, 16, 5, N'2015-W16', N'2015-W16-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95800, CAST(N'2015-04-18' AS date), CAST(N'2015-04-19' AS date), 2015, 20152, 201504, 2015108, 2, 4, 108, 18, 7, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-12' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-17' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-24' AS date), 1049, 3147, 13684, 13685, 13685, 13685, 13685, 13685, 13685, 2457131, 57130, N'2015-04-18', 201516, 16, 6, N'2015-W16', N'2015-W16-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95801, CAST(N'2015-04-19' AS date), CAST(N'2015-04-20' AS date), 2015, 20152, 201504, 2015109, 2, 4, 109, 19, 1, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-04-13' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-17' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-24' AS date), 1049, 3147, 13685, 13685, 13685, 13685, 13685, 13685, 13685, 2457132, 57131, N'2015-04-19', 201516, 16, 7, N'2015-W16', N'2015-W16-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95802, CAST(N'2015-04-20' AS date), CAST(N'2015-04-21' AS date), 2015, 20152, 201504, 2015110, 2, 4, 110, 20, 2, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-04-14' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-17' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-24' AS date), 1049, 3147, 13685, 13686, 13685, 13685, 13685, 13685, 13685, 2457133, 57132, N'2015-04-20', 201517, 17, 1, N'2015-W17', N'2015-W17-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95803, CAST(N'2015-04-21' AS date), CAST(N'2015-04-22' AS date), 2015, 20152, 201504, 2015111, 2, 4, 111, 21, 3, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-04-15' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-17' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-24' AS date), 1049, 3147, 13685, 13686, 13686, 13685, 13685, 13685, 13685, 2457134, 57133, N'2015-04-21', 201517, 17, 2, N'2015-W17', N'2015-W17-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95804, CAST(N'2015-04-22' AS date), CAST(N'2015-04-23' AS date), 2015, 20152, 201504, 2015112, 2, 4, 112, 22, 4, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-04-16' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-17' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-24' AS date), 1049, 3147, 13685, 13686, 13686, 13686, 13685, 13685, 13685, 2457135, 57134, N'2015-04-22', 201517, 17, 3, N'2015-W17', N'2015-W17-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95805, CAST(N'2015-04-23' AS date), CAST(N'2015-04-24' AS date), 2015, 20152, 201504, 2015113, 2, 4, 113, 23, 5, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-04-17' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-24' AS date), 1049, 3147, 13685, 13686, 13686, 13686, 13686, 13685, 13685, 2457136, 57135, N'2015-04-23', 201517, 17, 4, N'2015-W17', N'2015-W17-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95806, CAST(N'2015-04-24' AS date), CAST(N'2015-04-25' AS date), 2015, 20152, 201504, 2015114, 2, 4, 114, 24, 6, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-04-24' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-18' AS date), CAST(N'2015-04-24' AS date), 1049, 3147, 13685, 13686, 13686, 13686, 13686, 13686, 13685, 2457137, 57136, N'2015-04-24', 201517, 17, 5, N'2015-W17', N'2015-W17-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95807, CAST(N'2015-04-25' AS date), CAST(N'2015-04-26' AS date), 2015, 20152, 201504, 2015115, 2, 4, 115, 25, 7, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-19' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-04-24' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-05-01' AS date), 1049, 3147, 13685, 13686, 13686, 13686, 13686, 13686, 13686, 2457138, 57137, N'2015-04-25', 201517, 17, 6, N'2015-W17', N'2015-W17-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95808, CAST(N'2015-04-26' AS date), CAST(N'2015-04-27' AS date), 2015, 20152, 201504, 2015116, 2, 4, 116, 26, 1, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-04-20' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-04-24' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-05-01' AS date), 1049, 3147, 13686, 13686, 13686, 13686, 13686, 13686, 13686, 2457139, 57138, N'2015-04-26', 201517, 17, 7, N'2015-W17', N'2015-W17-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95809, CAST(N'2015-04-27' AS date), CAST(N'2015-04-28' AS date), 2015, 20152, 201504, 2015117, 2, 4, 117, 27, 2, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-04-21' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-04-24' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-05-01' AS date), 1049, 3147, 13686, 13687, 13686, 13686, 13686, 13686, 13686, 2457140, 57139, N'2015-04-27', 201518, 18, 1, N'2015-W18', N'2015-W18-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95810, CAST(N'2015-04-28' AS date), CAST(N'2015-04-29' AS date), 2015, 20152, 201504, 2015118, 2, 4, 118, 28, 3, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-04-22' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-04-24' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-05-01' AS date), 1049, 3147, 13686, 13687, 13687, 13686, 13686, 13686, 13686, 2457141, 57140, N'2015-04-28', 201518, 18, 2, N'2015-W18', N'2015-W18-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95811, CAST(N'2015-04-29' AS date), CAST(N'2015-04-30' AS date), 2015, 20152, 201504, 2015119, 2, 4, 119, 29, 4, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-04-23' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-04-24' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-05-01' AS date), 1049, 3147, 13686, 13687, 13687, 13687, 13686, 13686, 13686, 2457142, 57141, N'2015-04-29', 201518, 18, 3, N'2015-W18', N'2015-W18-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95812, CAST(N'2015-04-30' AS date), CAST(N'2015-05-01' AS date), 2015, 20152, 201504, 2015120, 2, 4, 120, 30, 5, N'2015', N'2015 Q2', N'2015 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-04-24' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-05-01' AS date), 1049, 3147, 13686, 13687, 13687, 13687, 13687, 13686, 13686, 2457143, 57142, N'2015-04-30', 201518, 18, 4, N'2015-W18', N'2015-W18-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95813, CAST(N'2015-05-01' AS date), CAST(N'2015-05-02' AS date), 2015, 20152, 201505, 2015121, 2, 5, 121, 1, 6, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-04-25' AS date), CAST(N'2015-05-01' AS date), 1049, 3148, 13686, 13687, 13687, 13687, 13687, 13687, 13686, 2457144, 57143, N'2015-05-01', 201518, 18, 5, N'2015-W18', N'2015-W18-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95814, CAST(N'2015-05-02' AS date), CAST(N'2015-05-03' AS date), 2015, 20152, 201505, 2015122, 2, 5, 122, 2, 7, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-04-26' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-05-08' AS date), 1049, 3148, 13686, 13687, 13687, 13687, 13687, 13687, 13687, 2457145, 57144, N'2015-05-02', 201518, 18, 6, N'2015-W18', N'2015-W18-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95815, CAST(N'2015-05-03' AS date), CAST(N'2015-05-04' AS date), 2015, 20152, 201505, 2015123, 2, 5, 123, 3, 1, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-04-27' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-05-08' AS date), 1049, 3148, 13687, 13687, 13687, 13687, 13687, 13687, 13687, 2457146, 57145, N'2015-05-03', 201518, 18, 7, N'2015-W18', N'2015-W18-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95816, CAST(N'2015-05-04' AS date), CAST(N'2015-05-05' AS date), 2015, 20152, 201505, 2015124, 2, 5, 124, 4, 2, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-04-28' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-05-08' AS date), 1049, 3148, 13687, 13688, 13687, 13687, 13687, 13687, 13687, 2457147, 57146, N'2015-05-04', 201519, 19, 1, N'2015-W19', N'2015-W19-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95817, CAST(N'2015-05-05' AS date), CAST(N'2015-05-06' AS date), 2015, 20152, 201505, 2015125, 2, 5, 125, 5, 3, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-04-29' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-05-08' AS date), 1049, 3148, 13687, 13688, 13688, 13687, 13687, 13687, 13687, 2457148, 57147, N'2015-05-05', 201519, 19, 2, N'2015-W19', N'2015-W19-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95818, CAST(N'2015-05-06' AS date), CAST(N'2015-05-07' AS date), 2015, 20152, 201505, 2015126, 2, 5, 126, 6, 4, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-04-30' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-05-08' AS date), 1049, 3148, 13687, 13688, 13688, 13688, 13687, 13687, 13687, 2457149, 57148, N'2015-05-06', 201519, 19, 3, N'2015-W19', N'2015-W19-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95819, CAST(N'2015-05-07' AS date), CAST(N'2015-05-08' AS date), 2015, 20152, 201505, 2015127, 2, 5, 127, 7, 5, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-05-08' AS date), 1049, 3148, 13687, 13688, 13688, 13688, 13688, 13687, 13687, 2457150, 57149, N'2015-05-07', 201519, 19, 4, N'2015-W19', N'2015-W19-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95820, CAST(N'2015-05-08' AS date), CAST(N'2015-05-09' AS date), 2015, 20152, 201505, 2015128, 2, 5, 128, 8, 6, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-08' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-02' AS date), CAST(N'2015-05-08' AS date), 1049, 3148, 13687, 13688, 13688, 13688, 13688, 13688, 13687, 2457151, 57150, N'2015-05-08', 201519, 19, 5, N'2015-W19', N'2015-W19-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95821, CAST(N'2015-05-09' AS date), CAST(N'2015-05-10' AS date), 2015, 20152, 201505, 2015129, 2, 5, 129, 9, 7, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-03' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-08' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-15' AS date), 1049, 3148, 13687, 13688, 13688, 13688, 13688, 13688, 13688, 2457152, 57151, N'2015-05-09', 201519, 19, 6, N'2015-W19', N'2015-W19-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95822, CAST(N'2015-05-10' AS date), CAST(N'2015-05-11' AS date), 2015, 20152, 201505, 2015130, 2, 5, 130, 10, 1, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-04' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-08' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-15' AS date), 1049, 3148, 13688, 13688, 13688, 13688, 13688, 13688, 13688, 2457153, 57152, N'2015-05-10', 201519, 19, 7, N'2015-W19', N'2015-W19-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95823, CAST(N'2015-05-11' AS date), CAST(N'2015-05-12' AS date), 2015, 20152, 201505, 2015131, 2, 5, 131, 11, 2, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-05' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-08' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-15' AS date), 1049, 3148, 13688, 13689, 13688, 13688, 13688, 13688, 13688, 2457154, 57153, N'2015-05-11', 201520, 20, 1, N'2015-W20', N'2015-W20-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95824, CAST(N'2015-05-12' AS date), CAST(N'2015-05-13' AS date), 2015, 20152, 201505, 2015132, 2, 5, 132, 12, 3, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-06' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-08' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-15' AS date), 1049, 3148, 13688, 13689, 13689, 13688, 13688, 13688, 13688, 2457155, 57154, N'2015-05-12', 201520, 20, 2, N'2015-W20', N'2015-W20-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95825, CAST(N'2015-05-13' AS date), CAST(N'2015-05-14' AS date), 2015, 20152, 201505, 2015133, 2, 5, 133, 13, 4, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-07' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-08' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-15' AS date), 1049, 3148, 13688, 13689, 13689, 13689, 13688, 13688, 13688, 2457156, 57155, N'2015-05-13', 201520, 20, 3, N'2015-W20', N'2015-W20-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95826, CAST(N'2015-05-14' AS date), CAST(N'2015-05-15' AS date), 2015, 20152, 201505, 2015134, 2, 5, 134, 14, 5, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-08' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-15' AS date), 1049, 3148, 13688, 13689, 13689, 13689, 13689, 13688, 13688, 2457157, 57156, N'2015-05-14', 201520, 20, 4, N'2015-W20', N'2015-W20-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95827, CAST(N'2015-05-15' AS date), CAST(N'2015-05-16' AS date), 2015, 20152, 201505, 2015135, 2, 5, 135, 15, 6, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-15' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-09' AS date), CAST(N'2015-05-15' AS date), 1049, 3148, 13688, 13689, 13689, 13689, 13689, 13689, 13688, 2457158, 57157, N'2015-05-15', 201520, 20, 5, N'2015-W20', N'2015-W20-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95828, CAST(N'2015-05-16' AS date), CAST(N'2015-05-17' AS date), 2015, 20152, 201505, 2015136, 2, 5, 136, 16, 7, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-10' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-15' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-22' AS date), 1049, 3148, 13688, 13689, 13689, 13689, 13689, 13689, 13689, 2457159, 57158, N'2015-05-16', 201520, 20, 6, N'2015-W20', N'2015-W20-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95829, CAST(N'2015-05-17' AS date), CAST(N'2015-05-18' AS date), 2015, 20152, 201505, 2015137, 2, 5, 137, 17, 1, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-11' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-15' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-22' AS date), 1049, 3148, 13689, 13689, 13689, 13689, 13689, 13689, 13689, 2457160, 57159, N'2015-05-17', 201520, 20, 7, N'2015-W20', N'2015-W20-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95830, CAST(N'2015-05-18' AS date), CAST(N'2015-05-19' AS date), 2015, 20152, 201505, 2015138, 2, 5, 138, 18, 2, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-12' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-15' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-22' AS date), 1049, 3148, 13689, 13690, 13689, 13689, 13689, 13689, 13689, 2457161, 57160, N'2015-05-18', 201521, 21, 1, N'2015-W21', N'2015-W21-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95831, CAST(N'2015-05-19' AS date), CAST(N'2015-05-20' AS date), 2015, 20152, 201505, 2015139, 2, 5, 139, 19, 3, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-13' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-15' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-22' AS date), 1049, 3148, 13689, 13690, 13690, 13689, 13689, 13689, 13689, 2457162, 57161, N'2015-05-19', 201521, 21, 2, N'2015-W21', N'2015-W21-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95832, CAST(N'2015-05-20' AS date), CAST(N'2015-05-21' AS date), 2015, 20152, 201505, 2015140, 2, 5, 140, 20, 4, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-05-14' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-15' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-22' AS date), 1049, 3148, 13689, 13690, 13690, 13690, 13689, 13689, 13689, 2457163, 57162, N'2015-05-20', 201521, 21, 3, N'2015-W21', N'2015-W21-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95833, CAST(N'2015-05-21' AS date), CAST(N'2015-05-22' AS date), 2015, 20152, 201505, 2015141, 2, 5, 141, 21, 5, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-05-15' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-22' AS date), 1049, 3148, 13689, 13690, 13690, 13690, 13690, 13689, 13689, 2457164, 57163, N'2015-05-21', 201521, 21, 4, N'2015-W21', N'2015-W21-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95834, CAST(N'2015-05-22' AS date), CAST(N'2015-05-23' AS date), 2015, 20152, 201505, 2015142, 2, 5, 142, 22, 6, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-05-22' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-05-16' AS date), CAST(N'2015-05-22' AS date), 1049, 3148, 13689, 13690, 13690, 13690, 13690, 13690, 13689, 2457165, 57164, N'2015-05-22', 201521, 21, 5, N'2015-W21', N'2015-W21-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95835, CAST(N'2015-05-23' AS date), CAST(N'2015-05-24' AS date), 2015, 20152, 201505, 2015143, 2, 5, 143, 23, 7, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-17' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-05-22' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-29' AS date), 1049, 3148, 13689, 13690, 13690, 13690, 13690, 13690, 13690, 2457166, 57165, N'2015-05-23', 201521, 21, 6, N'2015-W21', N'2015-W21-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95836, CAST(N'2015-05-24' AS date), CAST(N'2015-05-25' AS date), 2015, 20152, 201505, 2015144, 2, 5, 144, 24, 1, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-05-18' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-05-22' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-29' AS date), 1049, 3148, 13690, 13690, 13690, 13690, 13690, 13690, 13690, 2457167, 57166, N'2015-05-24', 201521, 21, 7, N'2015-W21', N'2015-W21-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95837, CAST(N'2015-05-25' AS date), CAST(N'2015-05-26' AS date), 2015, 20152, 201505, 2015145, 2, 5, 145, 25, 2, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-19' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-05-22' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-29' AS date), 1049, 3148, 13690, 13691, 13690, 13690, 13690, 13690, 13690, 2457168, 57167, N'2015-05-25', 201522, 22, 1, N'2015-W22', N'2015-W22-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95838, CAST(N'2015-05-26' AS date), CAST(N'2015-05-27' AS date), 2015, 20152, 201505, 2015146, 2, 5, 146, 26, 3, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-05-20' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-05-22' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-29' AS date), 1049, 3148, 13690, 13691, 13691, 13690, 13690, 13690, 13690, 2457169, 57168, N'2015-05-26', 201522, 22, 2, N'2015-W22', N'2015-W22-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95839, CAST(N'2015-05-27' AS date), CAST(N'2015-05-28' AS date), 2015, 20152, 201505, 2015147, 2, 5, 147, 27, 4, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-05-21' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-05-22' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-29' AS date), 1049, 3148, 13690, 13691, 13691, 13691, 13690, 13690, 13690, 2457170, 57169, N'2015-05-27', 201522, 22, 3, N'2015-W22', N'2015-W22-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95840, CAST(N'2015-05-28' AS date), CAST(N'2015-05-29' AS date), 2015, 20152, 201505, 2015148, 2, 5, 148, 28, 5, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-05-22' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-29' AS date), 1049, 3148, 13690, 13691, 13691, 13691, 13691, 13690, 13690, 2457171, 57170, N'2015-05-28', 201522, 22, 4, N'2015-W22', N'2015-W22-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95841, CAST(N'2015-05-29' AS date), CAST(N'2015-05-30' AS date), 2015, 20152, 201505, 2015149, 2, 5, 149, 29, 6, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-05-29' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-05-23' AS date), CAST(N'2015-05-29' AS date), 1049, 3148, 13690, 13691, 13691, 13691, 13691, 13691, 13690, 2457172, 57171, N'2015-05-29', 201522, 22, 5, N'2015-W22', N'2015-W22-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95842, CAST(N'2015-05-30' AS date), CAST(N'2015-05-31' AS date), 2015, 20152, 201505, 2015150, 2, 5, 150, 30, 7, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-24' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-05-29' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-06-05' AS date), 1049, 3148, 13690, 13691, 13691, 13691, 13691, 13691, 13691, 2457173, 57172, N'2015-05-30', 201522, 22, 6, N'2015-W22', N'2015-W22-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95843, CAST(N'2015-05-31' AS date), CAST(N'2015-06-01' AS date), 2015, 20152, 201505, 2015151, 2, 5, 151, 31, 1, N'2015', N'2015 Q2', N'2015 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-01' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-05-25' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-05-29' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-06-05' AS date), 1049, 3148, 13691, 13691, 13691, 13691, 13691, 13691, 13691, 2457174, 57173, N'2015-05-31', 201522, 22, 7, N'2015-W22', N'2015-W22-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95844, CAST(N'2015-06-01' AS date), CAST(N'2015-06-02' AS date), 2015, 20152, 201506, 2015152, 2, 6, 152, 1, 2, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-05-26' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-05-29' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-06-05' AS date), 1049, 3149, 13691, 13692, 13691, 13691, 13691, 13691, 13691, 2457175, 57174, N'2015-06-01', 201523, 23, 1, N'2015-W23', N'2015-W23-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95845, CAST(N'2015-06-02' AS date), CAST(N'2015-06-03' AS date), 2015, 20152, 201506, 2015153, 2, 6, 153, 2, 3, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-05-27' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-05-29' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-06-05' AS date), 1049, 3149, 13691, 13692, 13692, 13691, 13691, 13691, 13691, 2457176, 57175, N'2015-06-02', 201523, 23, 2, N'2015-W23', N'2015-W23-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95846, CAST(N'2015-06-03' AS date), CAST(N'2015-06-04' AS date), 2015, 20152, 201506, 2015154, 2, 6, 154, 3, 4, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-05-28' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-05-29' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-06-05' AS date), 1049, 3149, 13691, 13692, 13692, 13692, 13691, 13691, 13691, 2457177, 57176, N'2015-06-03', 201523, 23, 3, N'2015-W23', N'2015-W23-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95847, CAST(N'2015-06-04' AS date), CAST(N'2015-06-05' AS date), 2015, 20152, 201506, 2015155, 2, 6, 155, 4, 5, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-05-29' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-06-05' AS date), 1049, 3149, 13691, 13692, 13692, 13692, 13692, 13691, 13691, 2457178, 57177, N'2015-06-04', 201523, 23, 4, N'2015-W23', N'2015-W23-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95848, CAST(N'2015-06-05' AS date), CAST(N'2015-06-06' AS date), 2015, 20152, 201506, 2015156, 2, 6, 156, 5, 6, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-05' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-05-30' AS date), CAST(N'2015-06-05' AS date), 1049, 3149, 13691, 13692, 13692, 13692, 13692, 13692, 13691, 2457179, 57178, N'2015-06-05', 201523, 23, 5, N'2015-W23', N'2015-W23-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95849, CAST(N'2015-06-06' AS date), CAST(N'2015-06-07' AS date), 2015, 20152, 201506, 2015157, 2, 6, 157, 6, 7, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-05-31' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-05' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-12' AS date), 1049, 3149, 13691, 13692, 13692, 13692, 13692, 13692, 13692, 2457180, 57179, N'2015-06-06', 201523, 23, 6, N'2015-W23', N'2015-W23-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95850, CAST(N'2015-06-07' AS date), CAST(N'2015-06-08' AS date), 2015, 20152, 201506, 2015158, 2, 6, 158, 7, 1, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-05' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-12' AS date), 1049, 3149, 13692, 13692, 13692, 13692, 13692, 13692, 13692, 2457181, 57180, N'2015-06-07', 201523, 23, 7, N'2015-W23', N'2015-W23-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95851, CAST(N'2015-06-08' AS date), CAST(N'2015-06-09' AS date), 2015, 20152, 201506, 2015159, 2, 6, 159, 8, 2, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-02' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-05' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-12' AS date), 1049, 3149, 13692, 13693, 13692, 13692, 13692, 13692, 13692, 2457182, 57181, N'2015-06-08', 201524, 24, 1, N'2015-W24', N'2015-W24-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95852, CAST(N'2015-06-09' AS date), CAST(N'2015-06-10' AS date), 2015, 20152, 201506, 2015160, 2, 6, 160, 9, 3, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-03' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-05' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-12' AS date), 1049, 3149, 13692, 13693, 13693, 13692, 13692, 13692, 13692, 2457183, 57182, N'2015-06-09', 201524, 24, 2, N'2015-W24', N'2015-W24-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95853, CAST(N'2015-06-10' AS date), CAST(N'2015-06-11' AS date), 2015, 20152, 201506, 2015161, 2, 6, 161, 10, 4, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-04' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-05' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-12' AS date), 1049, 3149, 13692, 13693, 13693, 13693, 13692, 13692, 13692, 2457184, 57183, N'2015-06-10', 201524, 24, 3, N'2015-W24', N'2015-W24-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95854, CAST(N'2015-06-11' AS date), CAST(N'2015-06-12' AS date), 2015, 20152, 201506, 2015162, 2, 6, 162, 11, 5, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-05' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-12' AS date), 1049, 3149, 13692, 13693, 13693, 13693, 13693, 13692, 13692, 2457185, 57184, N'2015-06-11', 201524, 24, 4, N'2015-W24', N'2015-W24-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95855, CAST(N'2015-06-12' AS date), CAST(N'2015-06-13' AS date), 2015, 20152, 201506, 2015163, 2, 6, 163, 12, 6, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-12' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-06' AS date), CAST(N'2015-06-12' AS date), 1049, 3149, 13692, 13693, 13693, 13693, 13693, 13693, 13692, 2457186, 57185, N'2015-06-12', 201524, 24, 5, N'2015-W24', N'2015-W24-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95856, CAST(N'2015-06-13' AS date), CAST(N'2015-06-14' AS date), 2015, 20152, 201506, 2015164, 2, 6, 164, 13, 7, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-07' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-12' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-19' AS date), 1049, 3149, 13692, 13693, 13693, 13693, 13693, 13693, 13693, 2457187, 57186, N'2015-06-13', 201524, 24, 6, N'2015-W24', N'2015-W24-6');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95857, CAST(N'2015-06-14' AS date), CAST(N'2015-06-15' AS date), 2015, 20152, 201506, 2015165, 2, 6, 165, 14, 1, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-08' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-12' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-19' AS date), 1049, 3149, 13693, 13693, 13693, 13693, 13693, 13693, 13693, 2457188, 57187, N'2015-06-14', 201524, 24, 7, N'2015-W24', N'2015-W24-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95858, CAST(N'2015-06-15' AS date), CAST(N'2015-06-16' AS date), 2015, 20152, 201506, 2015166, 2, 6, 166, 15, 2, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-09' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-12' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-19' AS date), 1049, 3149, 13693, 13694, 13693, 13693, 13693, 13693, 13693, 2457189, 57188, N'2015-06-15', 201525, 25, 1, N'2015-W25', N'2015-W25-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95859, CAST(N'2015-06-16' AS date), CAST(N'2015-06-17' AS date), 2015, 20152, 201506, 2015167, 2, 6, 167, 16, 3, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-10' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-12' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-19' AS date), 1049, 3149, 13693, 13694, 13694, 13693, 13693, 13693, 13693, 2457190, 57189, N'2015-06-16', 201525, 25, 2, N'2015-W25', N'2015-W25-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95860, CAST(N'2015-06-17' AS date), CAST(N'2015-06-18' AS date), 2015, 20152, 201506, 2015168, 2, 6, 168, 17, 4, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-11' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-12' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-19' AS date), 1049, 3149, 13693, 13694, 13694, 13694, 13693, 13693, 13693, 2457191, 57190, N'2015-06-17', 201525, 25, 3, N'2015-W25', N'2015-W25-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95861, CAST(N'2015-06-18' AS date), CAST(N'2015-06-19' AS date), 2015, 20152, 201506, 2015169, 2, 6, 169, 18, 5, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-12' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-19' AS date), 1049, 3149, 13693, 13694, 13694, 13694, 13694, 13693, 13693, 2457192, 57191, N'2015-06-18', 201525, 25, 4, N'2015-W25', N'2015-W25-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95862, CAST(N'2015-06-19' AS date), CAST(N'2015-06-20' AS date), 2015, 20152, 201506, 2015170, 2, 6, 170, 19, 6, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-19' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-06-13' AS date), CAST(N'2015-06-19' AS date), 1049, 3149, 13693, 13694, 13694, 13694, 13694, 13694, 13693, 2457193, 57192, N'2015-06-19', 201525, 25, 5, N'2015-W25', N'2015-W25-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95863, CAST(N'2015-06-20' AS date), CAST(N'2015-06-21' AS date), 2015, 20152, 201506, 2015171, 2, 6, 171, 20, 7, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-14' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-19' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-26' AS date), 1049, 3149, 13693, 13694, 13694, 13694, 13694, 13694, 13694, 2457194, 57193, N'2015-06-20', 201525, 25, 6, N'2015-W25', N'2015-W25-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95864, CAST(N'2015-06-21' AS date), CAST(N'2015-06-22' AS date), 2015, 20152, 201506, 2015172, 2, 6, 172, 21, 1, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-06-15' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-19' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-26' AS date), 1049, 3149, 13694, 13694, 13694, 13694, 13694, 13694, 13694, 2457195, 57194, N'2015-06-21', 201525, 25, 7, N'2015-W25', N'2015-W25-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95865, CAST(N'2015-06-22' AS date), CAST(N'2015-06-23' AS date), 2015, 20152, 201506, 2015173, 2, 6, 173, 22, 2, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-06-16' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-19' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-26' AS date), 1049, 3149, 13694, 13695, 13694, 13694, 13694, 13694, 13694, 2457196, 57195, N'2015-06-22', 201526, 26, 1, N'2015-W26', N'2015-W26-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95866, CAST(N'2015-06-23' AS date), CAST(N'2015-06-24' AS date), 2015, 20152, 201506, 2015174, 2, 6, 174, 23, 3, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-06-17' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-19' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-26' AS date), 1049, 3149, 13694, 13695, 13695, 13694, 13694, 13694, 13694, 2457197, 57196, N'2015-06-23', 201526, 26, 2, N'2015-W26', N'2015-W26-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95867, CAST(N'2015-06-24' AS date), CAST(N'2015-06-25' AS date), 2015, 20152, 201506, 2015175, 2, 6, 175, 24, 4, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-18' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-19' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-26' AS date), 1049, 3149, 13694, 13695, 13695, 13695, 13694, 13694, 13694, 2457198, 57197, N'2015-06-24', 201526, 26, 3, N'2015-W26', N'2015-W26-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95868, CAST(N'2015-06-25' AS date), CAST(N'2015-06-26' AS date), 2015, 20152, 201506, 2015176, 2, 6, 176, 25, 5, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-06-19' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-26' AS date), 1049, 3149, 13694, 13695, 13695, 13695, 13695, 13694, 13694, 2457199, 57198, N'2015-06-25', 201526, 26, 4, N'2015-W26', N'2015-W26-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95869, CAST(N'2015-06-26' AS date), CAST(N'2015-06-27' AS date), 2015, 20152, 201506, 2015177, 2, 6, 177, 26, 6, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-06-26' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-06-20' AS date), CAST(N'2015-06-26' AS date), 1049, 3149, 13694, 13695, 13695, 13695, 13695, 13695, 13694, 2457200, 57199, N'2015-06-26', 201526, 26, 5, N'2015-W26', N'2015-W26-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95870, CAST(N'2015-06-27' AS date), CAST(N'2015-06-28' AS date), 2015, 20152, 201506, 2015178, 2, 6, 178, 27, 7, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-21' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-06-26' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-07-03' AS date), 1049, 3149, 13694, 13695, 13695, 13695, 13695, 13695, 13695, 2457201, 57200, N'2015-06-27', 201526, 26, 6, N'2015-W26', N'2015-W26-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95871, CAST(N'2015-06-28' AS date), CAST(N'2015-06-29' AS date), 2015, 20152, 201506, 2015179, 2, 6, 179, 28, 1, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-06-22' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-06-26' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-07-03' AS date), 1049, 3149, 13695, 13695, 13695, 13695, 13695, 13695, 13695, 2457202, 57201, N'2015-06-28', 201526, 26, 7, N'2015-W26', N'2015-W26-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95872, CAST(N'2015-06-29' AS date), CAST(N'2015-06-30' AS date), 2015, 20152, 201506, 2015180, 2, 6, 180, 29, 2, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-06-23' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-06-26' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-07-03' AS date), 1049, 3149, 13695, 13696, 13695, 13695, 13695, 13695, 13695, 2457203, 57202, N'2015-06-29', 201527, 27, 1, N'2015-W27', N'2015-W27-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95873, CAST(N'2015-06-30' AS date), CAST(N'2015-07-01' AS date), 2015, 20152, 201506, 2015181, 2, 6, 181, 30, 3, N'2015', N'2015 Q2', N'2015 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-04-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-01' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-06-24' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-06-26' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-07-03' AS date), 1049, 3149, 13695, 13696, 13696, 13695, 13695, 13695, 13695, 2457204, 57203, N'2015-06-30', 201527, 27, 2, N'2015-W27', N'2015-W27-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95874, CAST(N'2015-07-01' AS date), CAST(N'2015-07-02' AS date), 2015, 20153, 201507, 2015182, 3, 7, 182, 1, 4, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-06-25' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-06-26' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-07-03' AS date), 1050, 3150, 13695, 13696, 13696, 13696, 13695, 13695, 13695, 2457205, 57204, N'2015-07-01', 201527, 27, 3, N'2015-W27', N'2015-W27-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95875, CAST(N'2015-07-02' AS date), CAST(N'2015-07-03' AS date), 2015, 20153, 201507, 2015183, 3, 7, 183, 2, 5, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-06-26' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-07-03' AS date), 1050, 3150, 13695, 13696, 13696, 13696, 13696, 13695, 13695, 2457206, 57205, N'2015-07-02', 201527, 27, 4, N'2015-W27', N'2015-W27-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95876, CAST(N'2015-07-03' AS date), CAST(N'2015-07-04' AS date), 2015, 20153, 201507, 2015184, 3, 7, 184, 3, 6, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-03' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-06-27' AS date), CAST(N'2015-07-03' AS date), 1050, 3150, 13695, 13696, 13696, 13696, 13696, 13696, 13695, 2457207, 57206, N'2015-07-03', 201527, 27, 5, N'2015-W27', N'2015-W27-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95877, CAST(N'2015-07-04' AS date), CAST(N'2015-07-05' AS date), 2015, 20153, 201507, 2015185, 3, 7, 185, 4, 7, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-06-28' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-03' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-07-10' AS date), 1050, 3150, 13695, 13696, 13696, 13696, 13696, 13696, 13696, 2457208, 57207, N'2015-07-04', 201527, 27, 6, N'2015-W27', N'2015-W27-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95878, CAST(N'2015-07-05' AS date), CAST(N'2015-07-06' AS date), 2015, 20153, 201507, 2015186, 3, 7, 186, 5, 1, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-06-29' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-03' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-07-10' AS date), 1050, 3150, 13696, 13696, 13696, 13696, 13696, 13696, 13696, 2457209, 57208, N'2015-07-05', 201527, 27, 7, N'2015-W27', N'2015-W27-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95879, CAST(N'2015-07-06' AS date), CAST(N'2015-07-07' AS date), 2015, 20153, 201507, 2015187, 3, 7, 187, 6, 2, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-06-30' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-03' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-07-10' AS date), 1050, 3150, 13696, 13697, 13696, 13696, 13696, 13696, 13696, 2457210, 57209, N'2015-07-06', 201528, 28, 1, N'2015-W28', N'2015-W28-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95880, CAST(N'2015-07-07' AS date), CAST(N'2015-07-08' AS date), 2015, 20153, 201507, 2015188, 3, 7, 188, 7, 3, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-03' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-07-10' AS date), 1050, 3150, 13696, 13697, 13697, 13696, 13696, 13696, 13696, 2457211, 57210, N'2015-07-07', 201528, 28, 2, N'2015-W28', N'2015-W28-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95881, CAST(N'2015-07-08' AS date), CAST(N'2015-07-09' AS date), 2015, 20153, 201507, 2015189, 3, 7, 189, 8, 4, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-02' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-03' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-07-10' AS date), 1050, 3150, 13696, 13697, 13697, 13697, 13696, 13696, 13696, 2457212, 57211, N'2015-07-08', 201528, 28, 3, N'2015-W28', N'2015-W28-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95882, CAST(N'2015-07-09' AS date), CAST(N'2015-07-10' AS date), 2015, 20153, 201507, 2015190, 3, 7, 190, 9, 5, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-03' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-07-10' AS date), 1050, 3150, 13696, 13697, 13697, 13697, 13697, 13696, 13696, 2457213, 57212, N'2015-07-09', 201528, 28, 4, N'2015-W28', N'2015-W28-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95883, CAST(N'2015-07-10' AS date), CAST(N'2015-07-11' AS date), 2015, 20153, 201507, 2015191, 3, 7, 191, 10, 6, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-10' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-04' AS date), CAST(N'2015-07-10' AS date), 1050, 3150, 13696, 13697, 13697, 13697, 13697, 13697, 13696, 2457214, 57213, N'2015-07-10', 201528, 28, 5, N'2015-W28', N'2015-W28-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95884, CAST(N'2015-07-11' AS date), CAST(N'2015-07-12' AS date), 2015, 20153, 201507, 2015192, 3, 7, 192, 11, 7, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-05' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-10' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-17' AS date), 1050, 3150, 13696, 13697, 13697, 13697, 13697, 13697, 13697, 2457215, 57214, N'2015-07-11', 201528, 28, 6, N'2015-W28', N'2015-W28-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95885, CAST(N'2015-07-12' AS date), CAST(N'2015-07-13' AS date), 2015, 20153, 201507, 2015193, 3, 7, 193, 12, 1, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-06' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-10' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-17' AS date), 1050, 3150, 13697, 13697, 13697, 13697, 13697, 13697, 13697, 2457216, 57215, N'2015-07-12', 201528, 28, 7, N'2015-W28', N'2015-W28-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95886, CAST(N'2015-07-13' AS date), CAST(N'2015-07-14' AS date), 2015, 20153, 201507, 2015194, 3, 7, 194, 13, 2, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-07' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-10' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-17' AS date), 1050, 3150, 13697, 13698, 13697, 13697, 13697, 13697, 13697, 2457217, 57216, N'2015-07-13', 201529, 29, 1, N'2015-W29', N'2015-W29-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95887, CAST(N'2015-07-14' AS date), CAST(N'2015-07-15' AS date), 2015, 20153, 201507, 2015195, 3, 7, 195, 14, 3, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-08' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-10' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-17' AS date), 1050, 3150, 13697, 13698, 13698, 13697, 13697, 13697, 13697, 2457218, 57217, N'2015-07-14', 201529, 29, 2, N'2015-W29', N'2015-W29-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95888, CAST(N'2015-07-15' AS date), CAST(N'2015-07-16' AS date), 2015, 20153, 201507, 2015196, 3, 7, 196, 15, 4, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-09' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-10' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-17' AS date), 1050, 3150, 13697, 13698, 13698, 13698, 13697, 13697, 13697, 2457219, 57218, N'2015-07-15', 201529, 29, 3, N'2015-W29', N'2015-W29-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95889, CAST(N'2015-07-16' AS date), CAST(N'2015-07-17' AS date), 2015, 20153, 201507, 2015197, 3, 7, 197, 16, 5, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-10' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-17' AS date), 1050, 3150, 13697, 13698, 13698, 13698, 13698, 13697, 13697, 2457220, 57219, N'2015-07-16', 201529, 29, 4, N'2015-W29', N'2015-W29-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95890, CAST(N'2015-07-17' AS date), CAST(N'2015-07-18' AS date), 2015, 20153, 201507, 2015198, 3, 7, 198, 17, 6, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-17' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-11' AS date), CAST(N'2015-07-17' AS date), 1050, 3150, 13697, 13698, 13698, 13698, 13698, 13698, 13697, 2457221, 57220, N'2015-07-17', 201529, 29, 5, N'2015-W29', N'2015-W29-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95891, CAST(N'2015-07-18' AS date), CAST(N'2015-07-19' AS date), 2015, 20153, 201507, 2015199, 3, 7, 199, 18, 7, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-12' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-17' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-24' AS date), 1050, 3150, 13697, 13698, 13698, 13698, 13698, 13698, 13698, 2457222, 57221, N'2015-07-18', 201529, 29, 6, N'2015-W29', N'2015-W29-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95892, CAST(N'2015-07-19' AS date), CAST(N'2015-07-20' AS date), 2015, 20153, 201507, 2015200, 3, 7, 200, 19, 1, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-13' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-17' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-24' AS date), 1050, 3150, 13698, 13698, 13698, 13698, 13698, 13698, 13698, 2457223, 57222, N'2015-07-19', 201529, 29, 7, N'2015-W29', N'2015-W29-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95893, CAST(N'2015-07-20' AS date), CAST(N'2015-07-21' AS date), 2015, 20153, 201507, 2015201, 3, 7, 201, 20, 2, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-07-14' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-17' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-24' AS date), 1050, 3150, 13698, 13699, 13698, 13698, 13698, 13698, 13698, 2457224, 57223, N'2015-07-20', 201530, 30, 1, N'2015-W30', N'2015-W30-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95894, CAST(N'2015-07-21' AS date), CAST(N'2015-07-22' AS date), 2015, 20153, 201507, 2015202, 3, 7, 202, 21, 3, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-07-15' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-17' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-24' AS date), 1050, 3150, 13698, 13699, 13699, 13698, 13698, 13698, 13698, 2457225, 57224, N'2015-07-21', 201530, 30, 2, N'2015-W30', N'2015-W30-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95895, CAST(N'2015-07-22' AS date), CAST(N'2015-07-23' AS date), 2015, 20153, 201507, 2015203, 3, 7, 203, 22, 4, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-07-16' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-17' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-24' AS date), 1050, 3150, 13698, 13699, 13699, 13699, 13698, 13698, 13698, 2457226, 57225, N'2015-07-22', 201530, 30, 3, N'2015-W30', N'2015-W30-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95896, CAST(N'2015-07-23' AS date), CAST(N'2015-07-24' AS date), 2015, 20153, 201507, 2015204, 3, 7, 204, 23, 5, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-07-17' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-24' AS date), 1050, 3150, 13698, 13699, 13699, 13699, 13699, 13698, 13698, 2457227, 57226, N'2015-07-23', 201530, 30, 4, N'2015-W30', N'2015-W30-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95897, CAST(N'2015-07-24' AS date), CAST(N'2015-07-25' AS date), 2015, 20153, 201507, 2015205, 3, 7, 205, 24, 6, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-07-24' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-07-18' AS date), CAST(N'2015-07-24' AS date), 1050, 3150, 13698, 13699, 13699, 13699, 13699, 13699, 13698, 2457228, 57227, N'2015-07-24', 201530, 30, 5, N'2015-W30', N'2015-W30-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95898, CAST(N'2015-07-25' AS date), CAST(N'2015-07-26' AS date), 2015, 20153, 201507, 2015206, 3, 7, 206, 25, 7, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-19' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-07-24' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-31' AS date), 1050, 3150, 13698, 13699, 13699, 13699, 13699, 13699, 13699, 2457229, 57228, N'2015-07-25', 201530, 30, 6, N'2015-W30', N'2015-W30-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95899, CAST(N'2015-07-26' AS date), CAST(N'2015-07-27' AS date), 2015, 20153, 201507, 2015207, 3, 7, 207, 26, 1, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-07-20' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-07-24' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-31' AS date), 1050, 3150, 13699, 13699, 13699, 13699, 13699, 13699, 13699, 2457230, 57229, N'2015-07-26', 201530, 30, 7, N'2015-W30', N'2015-W30-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95900, CAST(N'2015-07-27' AS date), CAST(N'2015-07-28' AS date), 2015, 20153, 201507, 2015208, 3, 7, 208, 27, 2, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-07-21' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-07-24' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-31' AS date), 1050, 3150, 13699, 13700, 13699, 13699, 13699, 13699, 13699, 2457231, 57230, N'2015-07-27', 201531, 31, 1, N'2015-W31', N'2015-W31-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95901, CAST(N'2015-07-28' AS date), CAST(N'2015-07-29' AS date), 2015, 20153, 201507, 2015209, 3, 7, 209, 28, 3, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-07-22' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-07-24' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-31' AS date), 1050, 3150, 13699, 13700, 13700, 13699, 13699, 13699, 13699, 2457232, 57231, N'2015-07-28', 201531, 31, 2, N'2015-W31', N'2015-W31-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95902, CAST(N'2015-07-29' AS date), CAST(N'2015-07-30' AS date), 2015, 20153, 201507, 2015210, 3, 7, 210, 29, 4, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-07-23' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-07-24' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-31' AS date), 1050, 3150, 13699, 13700, 13700, 13700, 13699, 13699, 13699, 2457233, 57232, N'2015-07-29', 201531, 31, 3, N'2015-W31', N'2015-W31-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95903, CAST(N'2015-07-30' AS date), CAST(N'2015-07-31' AS date), 2015, 20153, 201507, 2015211, 3, 7, 211, 30, 5, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-07-24' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-31' AS date), 1050, 3150, 13699, 13700, 13700, 13700, 13700, 13699, 13699, 2457234, 57233, N'2015-07-30', 201531, 31, 4, N'2015-W31', N'2015-W31-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95904, CAST(N'2015-07-31' AS date), CAST(N'2015-08-01' AS date), 2015, 20153, 201507, 2015212, 3, 7, 212, 31, 6, N'2015', N'2015 Q3', N'2015 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-07-25' AS date), CAST(N'2015-07-31' AS date), 1050, 3150, 13699, 13700, 13700, 13700, 13700, 13700, 13699, 2457235, 57234, N'2015-07-31', 201531, 31, 5, N'2015-W31', N'2015-W31-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95905, CAST(N'2015-08-01' AS date), CAST(N'2015-08-02' AS date), 2015, 20153, 201508, 2015213, 3, 8, 213, 1, 7, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-07-26' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-07' AS date), 1050, 3151, 13699, 13700, 13700, 13700, 13700, 13700, 13700, 2457236, 57235, N'2015-08-01', 201531, 31, 6, N'2015-W31', N'2015-W31-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95906, CAST(N'2015-08-02' AS date), CAST(N'2015-08-03' AS date), 2015, 20153, 201508, 2015214, 3, 8, 214, 2, 1, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-07-27' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-07' AS date), 1050, 3151, 13700, 13700, 13700, 13700, 13700, 13700, 13700, 2457237, 57236, N'2015-08-02', 201531, 31, 7, N'2015-W31', N'2015-W31-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95907, CAST(N'2015-08-03' AS date), CAST(N'2015-08-04' AS date), 2015, 20153, 201508, 2015215, 3, 8, 215, 3, 2, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-07-28' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-07' AS date), 1050, 3151, 13700, 13701, 13700, 13700, 13700, 13700, 13700, 2457238, 57237, N'2015-08-03', 201532, 32, 1, N'2015-W32', N'2015-W32-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95908, CAST(N'2015-08-04' AS date), CAST(N'2015-08-05' AS date), 2015, 20153, 201508, 2015216, 3, 8, 216, 4, 3, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-07-29' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-07' AS date), 1050, 3151, 13700, 13701, 13701, 13700, 13700, 13700, 13700, 2457239, 57238, N'2015-08-04', 201532, 32, 2, N'2015-W32', N'2015-W32-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95909, CAST(N'2015-08-05' AS date), CAST(N'2015-08-06' AS date), 2015, 20153, 201508, 2015217, 3, 8, 217, 5, 4, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-07-30' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-07' AS date), 1050, 3151, 13700, 13701, 13701, 13701, 13700, 13700, 13700, 2457240, 57239, N'2015-08-05', 201532, 32, 3, N'2015-W32', N'2015-W32-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95910, CAST(N'2015-08-06' AS date), CAST(N'2015-08-07' AS date), 2015, 20153, 201508, 2015218, 3, 8, 218, 6, 5, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-07-31' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-07' AS date), 1050, 3151, 13700, 13701, 13701, 13701, 13701, 13700, 13700, 2457241, 57240, N'2015-08-06', 201532, 32, 4, N'2015-W32', N'2015-W32-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95911, CAST(N'2015-08-07' AS date), CAST(N'2015-08-08' AS date), 2015, 20153, 201508, 2015219, 3, 8, 219, 7, 6, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-07' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-07' AS date), 1050, 3151, 13700, 13701, 13701, 13701, 13701, 13701, 13700, 2457242, 57241, N'2015-08-07', 201532, 32, 5, N'2015-W32', N'2015-W32-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95912, CAST(N'2015-08-08' AS date), CAST(N'2015-08-09' AS date), 2015, 20153, 201508, 2015220, 3, 8, 220, 8, 7, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-02' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-07' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-14' AS date), 1050, 3151, 13700, 13701, 13701, 13701, 13701, 13701, 13701, 2457243, 57242, N'2015-08-08', 201532, 32, 6, N'2015-W32', N'2015-W32-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95913, CAST(N'2015-08-09' AS date), CAST(N'2015-08-10' AS date), 2015, 20153, 201508, 2015221, 3, 8, 221, 9, 1, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-03' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-07' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-14' AS date), 1050, 3151, 13701, 13701, 13701, 13701, 13701, 13701, 13701, 2457244, 57243, N'2015-08-09', 201532, 32, 7, N'2015-W32', N'2015-W32-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95914, CAST(N'2015-08-10' AS date), CAST(N'2015-08-11' AS date), 2015, 20153, 201508, 2015222, 3, 8, 222, 10, 2, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-04' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-07' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-14' AS date), 1050, 3151, 13701, 13702, 13701, 13701, 13701, 13701, 13701, 2457245, 57244, N'2015-08-10', 201533, 33, 1, N'2015-W33', N'2015-W33-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95915, CAST(N'2015-08-11' AS date), CAST(N'2015-08-12' AS date), 2015, 20153, 201508, 2015223, 3, 8, 223, 11, 3, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-05' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-07' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-14' AS date), 1050, 3151, 13701, 13702, 13702, 13701, 13701, 13701, 13701, 2457246, 57245, N'2015-08-11', 201533, 33, 2, N'2015-W33', N'2015-W33-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95916, CAST(N'2015-08-12' AS date), CAST(N'2015-08-13' AS date), 2015, 20153, 201508, 2015224, 3, 8, 224, 12, 4, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-06' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-07' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-14' AS date), 1050, 3151, 13701, 13702, 13702, 13702, 13701, 13701, 13701, 2457247, 57246, N'2015-08-12', 201533, 33, 3, N'2015-W33', N'2015-W33-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95917, CAST(N'2015-08-13' AS date), CAST(N'2015-08-14' AS date), 2015, 20153, 201508, 2015225, 3, 8, 225, 13, 5, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-07' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-14' AS date), 1050, 3151, 13701, 13702, 13702, 13702, 13702, 13701, 13701, 2457248, 57247, N'2015-08-13', 201533, 33, 4, N'2015-W33', N'2015-W33-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95918, CAST(N'2015-08-14' AS date), CAST(N'2015-08-15' AS date), 2015, 20153, 201508, 2015226, 3, 8, 226, 14, 6, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-14' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-08' AS date), CAST(N'2015-08-14' AS date), 1050, 3151, 13701, 13702, 13702, 13702, 13702, 13702, 13701, 2457249, 57248, N'2015-08-14', 201533, 33, 5, N'2015-W33', N'2015-W33-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95919, CAST(N'2015-08-15' AS date), CAST(N'2015-08-16' AS date), 2015, 20153, 201508, 2015227, 3, 8, 227, 15, 7, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-09' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-14' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-21' AS date), 1050, 3151, 13701, 13702, 13702, 13702, 13702, 13702, 13702, 2457250, 57249, N'2015-08-15', 201533, 33, 6, N'2015-W33', N'2015-W33-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95920, CAST(N'2015-08-16' AS date), CAST(N'2015-08-17' AS date), 2015, 20153, 201508, 2015228, 3, 8, 228, 16, 1, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-10' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-14' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-21' AS date), 1050, 3151, 13702, 13702, 13702, 13702, 13702, 13702, 13702, 2457251, 57250, N'2015-08-16', 201533, 33, 7, N'2015-W33', N'2015-W33-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95921, CAST(N'2015-08-17' AS date), CAST(N'2015-08-18' AS date), 2015, 20153, 201508, 2015229, 3, 8, 229, 17, 2, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-11' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-14' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-21' AS date), 1050, 3151, 13702, 13703, 13702, 13702, 13702, 13702, 13702, 2457252, 57251, N'2015-08-17', 201534, 34, 1, N'2015-W34', N'2015-W34-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95922, CAST(N'2015-08-18' AS date), CAST(N'2015-08-19' AS date), 2015, 20153, 201508, 2015230, 3, 8, 230, 18, 3, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-12' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-14' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-21' AS date), 1050, 3151, 13702, 13703, 13703, 13702, 13702, 13702, 13702, 2457253, 57252, N'2015-08-18', 201534, 34, 2, N'2015-W34', N'2015-W34-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95923, CAST(N'2015-08-19' AS date), CAST(N'2015-08-20' AS date), 2015, 20153, 201508, 2015231, 3, 8, 231, 19, 4, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-13' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-14' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-21' AS date), 1050, 3151, 13702, 13703, 13703, 13703, 13702, 13702, 13702, 2457254, 57253, N'2015-08-19', 201534, 34, 3, N'2015-W34', N'2015-W34-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95924, CAST(N'2015-08-20' AS date), CAST(N'2015-08-21' AS date), 2015, 20153, 201508, 2015232, 3, 8, 232, 20, 5, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-08-14' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-21' AS date), 1050, 3151, 13702, 13703, 13703, 13703, 13703, 13702, 13702, 2457255, 57254, N'2015-08-20', 201534, 34, 4, N'2015-W34', N'2015-W34-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95925, CAST(N'2015-08-21' AS date), CAST(N'2015-08-22' AS date), 2015, 20153, 201508, 2015233, 3, 8, 233, 21, 6, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-08-21' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-08-15' AS date), CAST(N'2015-08-21' AS date), 1050, 3151, 13702, 13703, 13703, 13703, 13703, 13703, 13702, 2457256, 57255, N'2015-08-21', 201534, 34, 5, N'2015-W34', N'2015-W34-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95926, CAST(N'2015-08-22' AS date), CAST(N'2015-08-23' AS date), 2015, 20153, 201508, 2015234, 3, 8, 234, 22, 7, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-16' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-08-21' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-28' AS date), 1050, 3151, 13702, 13703, 13703, 13703, 13703, 13703, 13703, 2457257, 57256, N'2015-08-22', 201534, 34, 6, N'2015-W34', N'2015-W34-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95927, CAST(N'2015-08-23' AS date), CAST(N'2015-08-24' AS date), 2015, 20153, 201508, 2015235, 3, 8, 235, 23, 1, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-08-17' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-08-21' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-28' AS date), 1050, 3151, 13703, 13703, 13703, 13703, 13703, 13703, 13703, 2457258, 57257, N'2015-08-23', 201534, 34, 7, N'2015-W34', N'2015-W34-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95928, CAST(N'2015-08-24' AS date), CAST(N'2015-08-25' AS date), 2015, 20153, 201508, 2015236, 3, 8, 236, 24, 2, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-08-18' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-08-21' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-28' AS date), 1050, 3151, 13703, 13704, 13703, 13703, 13703, 13703, 13703, 2457259, 57258, N'2015-08-24', 201535, 35, 1, N'2015-W35', N'2015-W35-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95929, CAST(N'2015-08-25' AS date), CAST(N'2015-08-26' AS date), 2015, 20153, 201508, 2015237, 3, 8, 237, 25, 3, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-19' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-08-21' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-28' AS date), 1050, 3151, 13703, 13704, 13704, 13703, 13703, 13703, 13703, 2457260, 57259, N'2015-08-25', 201535, 35, 2, N'2015-W35', N'2015-W35-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95930, CAST(N'2015-08-26' AS date), CAST(N'2015-08-27' AS date), 2015, 20153, 201508, 2015238, 3, 8, 238, 26, 4, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-08-20' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-08-21' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-28' AS date), 1050, 3151, 13703, 13704, 13704, 13704, 13703, 13703, 13703, 2457261, 57260, N'2015-08-26', 201535, 35, 3, N'2015-W35', N'2015-W35-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95931, CAST(N'2015-08-27' AS date), CAST(N'2015-08-28' AS date), 2015, 20153, 201508, 2015239, 3, 8, 239, 27, 5, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-08-21' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-28' AS date), 1050, 3151, 13703, 13704, 13704, 13704, 13704, 13703, 13703, 2457262, 57261, N'2015-08-27', 201535, 35, 4, N'2015-W35', N'2015-W35-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95932, CAST(N'2015-08-28' AS date), CAST(N'2015-08-29' AS date), 2015, 20153, 201508, 2015240, 3, 8, 240, 28, 6, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-08-28' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-08-22' AS date), CAST(N'2015-08-28' AS date), 1050, 3151, 13703, 13704, 13704, 13704, 13704, 13704, 13703, 2457263, 57262, N'2015-08-28', 201535, 35, 5, N'2015-W35', N'2015-W35-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95933, CAST(N'2015-08-29' AS date), CAST(N'2015-08-30' AS date), 2015, 20153, 201508, 2015241, 3, 8, 241, 29, 7, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-23' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-08-28' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-09-04' AS date), 1050, 3151, 13703, 13704, 13704, 13704, 13704, 13704, 13704, 2457264, 57263, N'2015-08-29', 201535, 35, 6, N'2015-W35', N'2015-W35-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95934, CAST(N'2015-08-30' AS date), CAST(N'2015-08-31' AS date), 2015, 20153, 201508, 2015242, 3, 8, 242, 30, 1, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-08-24' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-08-28' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-09-04' AS date), 1050, 3151, 13704, 13704, 13704, 13704, 13704, 13704, 13704, 2457265, 57264, N'2015-08-30', 201535, 35, 7, N'2015-W35', N'2015-W35-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95935, CAST(N'2015-08-31' AS date), CAST(N'2015-09-01' AS date), 2015, 20153, 201508, 2015243, 3, 8, 243, 31, 2, N'2015', N'2015 Q3', N'2015 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-01' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-08-25' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-08-28' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-09-04' AS date), 1050, 3151, 13704, 13705, 13704, 13704, 13704, 13704, 13704, 2457266, 57265, N'2015-08-31', 201536, 36, 1, N'2015-W36', N'2015-W36-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95936, CAST(N'2015-09-01' AS date), CAST(N'2015-09-02' AS date), 2015, 20153, 201509, 2015244, 3, 9, 244, 1, 3, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-08-26' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-08-28' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-09-04' AS date), 1050, 3152, 13704, 13705, 13705, 13704, 13704, 13704, 13704, 2457267, 57266, N'2015-09-01', 201536, 36, 2, N'2015-W36', N'2015-W36-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95937, CAST(N'2015-09-02' AS date), CAST(N'2015-09-03' AS date), 2015, 20153, 201509, 2015245, 3, 9, 245, 2, 4, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-08-27' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-08-28' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-09-04' AS date), 1050, 3152, 13704, 13705, 13705, 13705, 13704, 13704, 13704, 2457268, 57267, N'2015-09-02', 201536, 36, 3, N'2015-W36', N'2015-W36-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95938, CAST(N'2015-09-03' AS date), CAST(N'2015-09-04' AS date), 2015, 20153, 201509, 2015246, 3, 9, 246, 3, 5, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-08-28' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-09-04' AS date), 1050, 3152, 13704, 13705, 13705, 13705, 13705, 13704, 13704, 2457269, 57268, N'2015-09-03', 201536, 36, 4, N'2015-W36', N'2015-W36-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95939, CAST(N'2015-09-04' AS date), CAST(N'2015-09-05' AS date), 2015, 20153, 201509, 2015247, 3, 9, 247, 4, 6, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-04' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-08-29' AS date), CAST(N'2015-09-04' AS date), 1050, 3152, 13704, 13705, 13705, 13705, 13705, 13705, 13704, 2457270, 57269, N'2015-09-04', 201536, 36, 5, N'2015-W36', N'2015-W36-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95940, CAST(N'2015-09-05' AS date), CAST(N'2015-09-06' AS date), 2015, 20153, 201509, 2015248, 3, 9, 248, 5, 7, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-08-30' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-04' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-09-11' AS date), 1050, 3152, 13704, 13705, 13705, 13705, 13705, 13705, 13705, 2457271, 57270, N'2015-09-05', 201536, 36, 6, N'2015-W36', N'2015-W36-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95941, CAST(N'2015-09-06' AS date), CAST(N'2015-09-07' AS date), 2015, 20153, 201509, 2015249, 3, 9, 249, 6, 1, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-08-31' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-04' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-09-11' AS date), 1050, 3152, 13705, 13705, 13705, 13705, 13705, 13705, 13705, 2457272, 57271, N'2015-09-06', 201536, 36, 7, N'2015-W36', N'2015-W36-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95942, CAST(N'2015-09-07' AS date), CAST(N'2015-09-08' AS date), 2015, 20153, 201509, 2015250, 3, 9, 250, 7, 2, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-04' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-09-11' AS date), 1050, 3152, 13705, 13706, 13705, 13705, 13705, 13705, 13705, 2457273, 57272, N'2015-09-07', 201537, 37, 1, N'2015-W37', N'2015-W37-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95943, CAST(N'2015-09-08' AS date), CAST(N'2015-09-09' AS date), 2015, 20153, 201509, 2015251, 3, 9, 251, 8, 3, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-02' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-04' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-09-11' AS date), 1050, 3152, 13705, 13706, 13706, 13705, 13705, 13705, 13705, 2457274, 57273, N'2015-09-08', 201537, 37, 2, N'2015-W37', N'2015-W37-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95944, CAST(N'2015-09-09' AS date), CAST(N'2015-09-10' AS date), 2015, 20153, 201509, 2015252, 3, 9, 252, 9, 4, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-03' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-04' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-09-11' AS date), 1050, 3152, 13705, 13706, 13706, 13706, 13705, 13705, 13705, 2457275, 57274, N'2015-09-09', 201537, 37, 3, N'2015-W37', N'2015-W37-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95945, CAST(N'2015-09-10' AS date), CAST(N'2015-09-11' AS date), 2015, 20153, 201509, 2015253, 3, 9, 253, 10, 5, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-04' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-09-11' AS date), 1050, 3152, 13705, 13706, 13706, 13706, 13706, 13705, 13705, 2457276, 57275, N'2015-09-10', 201537, 37, 4, N'2015-W37', N'2015-W37-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95946, CAST(N'2015-09-11' AS date), CAST(N'2015-09-12' AS date), 2015, 20153, 201509, 2015254, 3, 9, 254, 11, 6, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-11' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-05' AS date), CAST(N'2015-09-11' AS date), 1050, 3152, 13705, 13706, 13706, 13706, 13706, 13706, 13705, 2457277, 57276, N'2015-09-11', 201537, 37, 5, N'2015-W37', N'2015-W37-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95947, CAST(N'2015-09-12' AS date), CAST(N'2015-09-13' AS date), 2015, 20153, 201509, 2015255, 3, 9, 255, 12, 7, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-06' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-11' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-18' AS date), 1050, 3152, 13705, 13706, 13706, 13706, 13706, 13706, 13706, 2457278, 57277, N'2015-09-12', 201537, 37, 6, N'2015-W37', N'2015-W37-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95948, CAST(N'2015-09-13' AS date), CAST(N'2015-09-14' AS date), 2015, 20153, 201509, 2015256, 3, 9, 256, 13, 1, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-07' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-11' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-18' AS date), 1050, 3152, 13706, 13706, 13706, 13706, 13706, 13706, 13706, 2457279, 57278, N'2015-09-13', 201537, 37, 7, N'2015-W37', N'2015-W37-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95949, CAST(N'2015-09-14' AS date), CAST(N'2015-09-15' AS date), 2015, 20153, 201509, 2015257, 3, 9, 257, 14, 2, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-08' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-11' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-18' AS date), 1050, 3152, 13706, 13707, 13706, 13706, 13706, 13706, 13706, 2457280, 57279, N'2015-09-14', 201538, 38, 1, N'2015-W38', N'2015-W38-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95950, CAST(N'2015-09-15' AS date), CAST(N'2015-09-16' AS date), 2015, 20153, 201509, 2015258, 3, 9, 258, 15, 3, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-09' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-11' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-18' AS date), 1050, 3152, 13706, 13707, 13707, 13706, 13706, 13706, 13706, 2457281, 57280, N'2015-09-15', 201538, 38, 2, N'2015-W38', N'2015-W38-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95951, CAST(N'2015-09-16' AS date), CAST(N'2015-09-17' AS date), 2015, 20153, 201509, 2015259, 3, 9, 259, 16, 4, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-10' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-11' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-18' AS date), 1050, 3152, 13706, 13707, 13707, 13707, 13706, 13706, 13706, 2457282, 57281, N'2015-09-16', 201538, 38, 3, N'2015-W38', N'2015-W38-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95952, CAST(N'2015-09-17' AS date), CAST(N'2015-09-18' AS date), 2015, 20153, 201509, 2015260, 3, 9, 260, 17, 5, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-11' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-18' AS date), 1050, 3152, 13706, 13707, 13707, 13707, 13707, 13706, 13706, 2457283, 57282, N'2015-09-17', 201538, 38, 4, N'2015-W38', N'2015-W38-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95953, CAST(N'2015-09-18' AS date), CAST(N'2015-09-19' AS date), 2015, 20153, 201509, 2015261, 3, 9, 261, 18, 6, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-18' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-12' AS date), CAST(N'2015-09-18' AS date), 1050, 3152, 13706, 13707, 13707, 13707, 13707, 13707, 13706, 2457284, 57283, N'2015-09-18', 201538, 38, 5, N'2015-W38', N'2015-W38-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95954, CAST(N'2015-09-19' AS date), CAST(N'2015-09-20' AS date), 2015, 20153, 201509, 2015262, 3, 9, 262, 19, 7, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-13' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-18' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-25' AS date), 1050, 3152, 13706, 13707, 13707, 13707, 13707, 13707, 13707, 2457285, 57284, N'2015-09-19', 201538, 38, 6, N'2015-W38', N'2015-W38-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95955, CAST(N'2015-09-20' AS date), CAST(N'2015-09-21' AS date), 2015, 20153, 201509, 2015263, 3, 9, 263, 20, 1, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-09-14' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-18' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-25' AS date), 1050, 3152, 13707, 13707, 13707, 13707, 13707, 13707, 13707, 2457286, 57285, N'2015-09-20', 201538, 38, 7, N'2015-W38', N'2015-W38-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95956, CAST(N'2015-09-21' AS date), CAST(N'2015-09-22' AS date), 2015, 20153, 201509, 2015264, 3, 9, 264, 21, 2, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-09-15' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-18' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-25' AS date), 1050, 3152, 13707, 13708, 13707, 13707, 13707, 13707, 13707, 2457287, 57286, N'2015-09-21', 201539, 39, 1, N'2015-W39', N'2015-W39-1');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95957, CAST(N'2015-09-22' AS date), CAST(N'2015-09-23' AS date), 2015, 20153, 201509, 2015265, 3, 9, 265, 22, 3, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-09-16' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-18' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-25' AS date), 1050, 3152, 13707, 13708, 13708, 13707, 13707, 13707, 13707, 2457288, 57287, N'2015-09-22', 201539, 39, 2, N'2015-W39', N'2015-W39-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95958, CAST(N'2015-09-23' AS date), CAST(N'2015-09-24' AS date), 2015, 20153, 201509, 2015266, 3, 9, 266, 23, 4, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-09-17' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-18' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-25' AS date), 1050, 3152, 13707, 13708, 13708, 13708, 13707, 13707, 13707, 2457289, 57288, N'2015-09-23', 201539, 39, 3, N'2015-W39', N'2015-W39-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95959, CAST(N'2015-09-24' AS date), CAST(N'2015-09-25' AS date), 2015, 20153, 201509, 2015267, 3, 9, 267, 24, 5, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-18' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-25' AS date), 1050, 3152, 13707, 13708, 13708, 13708, 13708, 13707, 13707, 2457290, 57289, N'2015-09-24', 201539, 39, 4, N'2015-W39', N'2015-W39-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95960, CAST(N'2015-09-25' AS date), CAST(N'2015-09-26' AS date), 2015, 20153, 201509, 2015268, 3, 9, 268, 25, 6, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-25' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-09-19' AS date), CAST(N'2015-09-25' AS date), 1050, 3152, 13707, 13708, 13708, 13708, 13708, 13708, 13707, 2457291, 57290, N'2015-09-25', 201539, 39, 5, N'2015-W39', N'2015-W39-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95961, CAST(N'2015-09-26' AS date), CAST(N'2015-09-27' AS date), 2015, 20153, 201509, 2015269, 3, 9, 269, 26, 7, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-20' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-25' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-10-02' AS date), 1050, 3152, 13707, 13708, 13708, 13708, 13708, 13708, 13708, 2457292, 57291, N'2015-09-26', 201539, 39, 6, N'2015-W39', N'2015-W39-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95962, CAST(N'2015-09-27' AS date), CAST(N'2015-09-28' AS date), 2015, 20153, 201509, 2015270, 3, 9, 270, 27, 1, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-09-21' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-25' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-10-02' AS date), 1050, 3152, 13708, 13708, 13708, 13708, 13708, 13708, 13708, 2457293, 57292, N'2015-09-27', 201539, 39, 7, N'2015-W39', N'2015-W39-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95963, CAST(N'2015-09-28' AS date), CAST(N'2015-09-29' AS date), 2015, 20153, 201509, 2015271, 3, 9, 271, 28, 2, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-09-22' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-25' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-10-02' AS date), 1050, 3152, 13708, 13709, 13708, 13708, 13708, 13708, 13708, 2457294, 57293, N'2015-09-28', 201540, 40, 1, N'2015-W40', N'2015-W40-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95964, CAST(N'2015-09-29' AS date), CAST(N'2015-09-30' AS date), 2015, 20153, 201509, 2015272, 3, 9, 272, 29, 3, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-09-23' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-25' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-10-02' AS date), 1050, 3152, 13708, 13709, 13709, 13708, 13708, 13708, 13708, 2457295, 57294, N'2015-09-29', 201540, 40, 2, N'2015-W40', N'2015-W40-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95965, CAST(N'2015-09-30' AS date), CAST(N'2015-10-01' AS date), 2015, 20153, 201509, 2015273, 3, 9, 273, 30, 4, N'2015', N'2015 Q3', N'2015 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-07-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-01' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-09-24' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-09-25' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-10-02' AS date), 1050, 3152, 13708, 13709, 13709, 13709, 13708, 13708, 13708, 2457296, 57295, N'2015-09-30', 201540, 40, 3, N'2015-W40', N'2015-W40-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95966, CAST(N'2015-10-01' AS date), CAST(N'2015-10-02' AS date), 2015, 20154, 201510, 2015274, 4, 10, 274, 1, 5, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-09-25' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-10-02' AS date), 1051, 3153, 13708, 13709, 13709, 13709, 13709, 13708, 13708, 2457297, 57296, N'2015-10-01', 201540, 40, 4, N'2015-W40', N'2015-W40-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95967, CAST(N'2015-10-02' AS date), CAST(N'2015-10-03' AS date), 2015, 20154, 201510, 2015275, 4, 10, 275, 2, 6, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-02' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-09-26' AS date), CAST(N'2015-10-02' AS date), 1051, 3153, 13708, 13709, 13709, 13709, 13709, 13709, 13708, 2457298, 57297, N'2015-10-02', 201540, 40, 5, N'2015-W40', N'2015-W40-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95968, CAST(N'2015-10-03' AS date), CAST(N'2015-10-04' AS date), 2015, 20154, 201510, 2015276, 4, 10, 276, 3, 7, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-09-27' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-02' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-10-09' AS date), 1051, 3153, 13708, 13709, 13709, 13709, 13709, 13709, 13709, 2457299, 57298, N'2015-10-03', 201540, 40, 6, N'2015-W40', N'2015-W40-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95969, CAST(N'2015-10-04' AS date), CAST(N'2015-10-05' AS date), 2015, 20154, 201510, 2015277, 4, 10, 277, 4, 1, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-09-28' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-02' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-10-09' AS date), 1051, 3153, 13709, 13709, 13709, 13709, 13709, 13709, 13709, 2457300, 57299, N'2015-10-04', 201540, 40, 7, N'2015-W40', N'2015-W40-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95970, CAST(N'2015-10-05' AS date), CAST(N'2015-10-06' AS date), 2015, 20154, 201510, 2015278, 4, 10, 278, 5, 2, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-09-29' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-02' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-10-09' AS date), 1051, 3153, 13709, 13710, 13709, 13709, 13709, 13709, 13709, 2457301, 57300, N'2015-10-05', 201541, 41, 1, N'2015-W41', N'2015-W41-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95971, CAST(N'2015-10-06' AS date), CAST(N'2015-10-07' AS date), 2015, 20154, 201510, 2015279, 4, 10, 279, 6, 3, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-09-30' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-02' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-10-09' AS date), 1051, 3153, 13709, 13710, 13710, 13709, 13709, 13709, 13709, 2457302, 57301, N'2015-10-06', 201541, 41, 2, N'2015-W41', N'2015-W41-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95972, CAST(N'2015-10-07' AS date), CAST(N'2015-10-08' AS date), 2015, 20154, 201510, 2015280, 4, 10, 280, 7, 4, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-02' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-10-09' AS date), 1051, 3153, 13709, 13710, 13710, 13710, 13709, 13709, 13709, 2457303, 57302, N'2015-10-07', 201541, 41, 3, N'2015-W41', N'2015-W41-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95973, CAST(N'2015-10-08' AS date), CAST(N'2015-10-09' AS date), 2015, 20154, 201510, 2015281, 4, 10, 281, 8, 5, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-02' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-10-09' AS date), 1051, 3153, 13709, 13710, 13710, 13710, 13710, 13709, 13709, 2457304, 57303, N'2015-10-08', 201541, 41, 4, N'2015-W41', N'2015-W41-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95974, CAST(N'2015-10-09' AS date), CAST(N'2015-10-10' AS date), 2015, 20154, 201510, 2015282, 4, 10, 282, 9, 6, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-09' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-03' AS date), CAST(N'2015-10-09' AS date), 1051, 3153, 13709, 13710, 13710, 13710, 13710, 13710, 13709, 2457305, 57304, N'2015-10-09', 201541, 41, 5, N'2015-W41', N'2015-W41-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95975, CAST(N'2015-10-10' AS date), CAST(N'2015-10-11' AS date), 2015, 20154, 201510, 2015283, 4, 10, 283, 10, 7, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-04' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-09' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-16' AS date), 1051, 3153, 13709, 13710, 13710, 13710, 13710, 13710, 13710, 2457306, 57305, N'2015-10-10', 201541, 41, 6, N'2015-W41', N'2015-W41-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95976, CAST(N'2015-10-11' AS date), CAST(N'2015-10-12' AS date), 2015, 20154, 201510, 2015284, 4, 10, 284, 11, 1, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-05' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-09' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-16' AS date), 1051, 3153, 13710, 13710, 13710, 13710, 13710, 13710, 13710, 2457307, 57306, N'2015-10-11', 201541, 41, 7, N'2015-W41', N'2015-W41-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95977, CAST(N'2015-10-12' AS date), CAST(N'2015-10-13' AS date), 2015, 20154, 201510, 2015285, 4, 10, 285, 12, 2, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-06' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-09' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-16' AS date), 1051, 3153, 13710, 13711, 13710, 13710, 13710, 13710, 13710, 2457308, 57307, N'2015-10-12', 201542, 42, 1, N'2015-W42', N'2015-W42-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95978, CAST(N'2015-10-13' AS date), CAST(N'2015-10-14' AS date), 2015, 20154, 201510, 2015286, 4, 10, 286, 13, 3, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-07' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-09' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-16' AS date), 1051, 3153, 13710, 13711, 13711, 13710, 13710, 13710, 13710, 2457309, 57308, N'2015-10-13', 201542, 42, 2, N'2015-W42', N'2015-W42-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95979, CAST(N'2015-10-14' AS date), CAST(N'2015-10-15' AS date), 2015, 20154, 201510, 2015287, 4, 10, 287, 14, 4, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-08' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-09' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-16' AS date), 1051, 3153, 13710, 13711, 13711, 13711, 13710, 13710, 13710, 2457310, 57309, N'2015-10-14', 201542, 42, 3, N'2015-W42', N'2015-W42-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95980, CAST(N'2015-10-15' AS date), CAST(N'2015-10-16' AS date), 2015, 20154, 201510, 2015288, 4, 10, 288, 15, 5, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-09' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-16' AS date), 1051, 3153, 13710, 13711, 13711, 13711, 13711, 13710, 13710, 2457311, 57310, N'2015-10-15', 201542, 42, 4, N'2015-W42', N'2015-W42-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95981, CAST(N'2015-10-16' AS date), CAST(N'2015-10-17' AS date), 2015, 20154, 201510, 2015289, 4, 10, 289, 16, 6, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-16' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-10' AS date), CAST(N'2015-10-16' AS date), 1051, 3153, 13710, 13711, 13711, 13711, 13711, 13711, 13710, 2457312, 57311, N'2015-10-16', 201542, 42, 5, N'2015-W42', N'2015-W42-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95982, CAST(N'2015-10-17' AS date), CAST(N'2015-10-18' AS date), 2015, 20154, 201510, 2015290, 4, 10, 290, 17, 7, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-11' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-16' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-23' AS date), 1051, 3153, 13710, 13711, 13711, 13711, 13711, 13711, 13711, 2457313, 57312, N'2015-10-17', 201542, 42, 6, N'2015-W42', N'2015-W42-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95983, CAST(N'2015-10-18' AS date), CAST(N'2015-10-19' AS date), 2015, 20154, 201510, 2015291, 4, 10, 291, 18, 1, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-12' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-16' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-23' AS date), 1051, 3153, 13711, 13711, 13711, 13711, 13711, 13711, 13711, 2457314, 57313, N'2015-10-18', 201542, 42, 7, N'2015-W42', N'2015-W42-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95984, CAST(N'2015-10-19' AS date), CAST(N'2015-10-20' AS date), 2015, 20154, 201510, 2015292, 4, 10, 292, 19, 2, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-13' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-16' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-23' AS date), 1051, 3153, 13711, 13712, 13711, 13711, 13711, 13711, 13711, 2457315, 57314, N'2015-10-19', 201543, 43, 1, N'2015-W43', N'2015-W43-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95985, CAST(N'2015-10-20' AS date), CAST(N'2015-10-21' AS date), 2015, 20154, 201510, 2015293, 4, 10, 293, 20, 3, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-10-14' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-16' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-23' AS date), 1051, 3153, 13711, 13712, 13712, 13711, 13711, 13711, 13711, 2457316, 57315, N'2015-10-20', 201543, 43, 2, N'2015-W43', N'2015-W43-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95986, CAST(N'2015-10-21' AS date), CAST(N'2015-10-22' AS date), 2015, 20154, 201510, 2015294, 4, 10, 294, 21, 4, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-10-15' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-16' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-23' AS date), 1051, 3153, 13711, 13712, 13712, 13712, 13711, 13711, 13711, 2457317, 57316, N'2015-10-21', 201543, 43, 3, N'2015-W43', N'2015-W43-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95987, CAST(N'2015-10-22' AS date), CAST(N'2015-10-23' AS date), 2015, 20154, 201510, 2015295, 4, 10, 295, 22, 5, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-10-16' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-23' AS date), 1051, 3153, 13711, 13712, 13712, 13712, 13712, 13711, 13711, 2457318, 57317, N'2015-10-22', 201543, 43, 4, N'2015-W43', N'2015-W43-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95988, CAST(N'2015-10-23' AS date), CAST(N'2015-10-24' AS date), 2015, 20154, 201510, 2015296, 4, 10, 296, 23, 6, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-10-23' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-10-17' AS date), CAST(N'2015-10-23' AS date), 1051, 3153, 13711, 13712, 13712, 13712, 13712, 13712, 13711, 2457319, 57318, N'2015-10-23', 201543, 43, 5, N'2015-W43', N'2015-W43-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95989, CAST(N'2015-10-24' AS date), CAST(N'2015-10-25' AS date), 2015, 20154, 201510, 2015297, 4, 10, 297, 24, 7, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-18' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-10-23' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-30' AS date), 1051, 3153, 13711, 13712, 13712, 13712, 13712, 13712, 13712, 2457320, 57319, N'2015-10-24', 201543, 43, 6, N'2015-W43', N'2015-W43-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95990, CAST(N'2015-10-25' AS date), CAST(N'2015-10-26' AS date), 2015, 20154, 201510, 2015298, 4, 10, 298, 25, 1, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-19' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-10-23' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-30' AS date), 1051, 3153, 13712, 13712, 13712, 13712, 13712, 13712, 13712, 2457321, 57320, N'2015-10-25', 201543, 43, 7, N'2015-W43', N'2015-W43-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95991, CAST(N'2015-10-26' AS date), CAST(N'2015-10-27' AS date), 2015, 20154, 201510, 2015299, 4, 10, 299, 26, 2, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-10-20' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-10-23' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-30' AS date), 1051, 3153, 13712, 13713, 13712, 13712, 13712, 13712, 13712, 2457322, 57321, N'2015-10-26', 201544, 44, 1, N'2015-W44', N'2015-W44-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95992, CAST(N'2015-10-27' AS date), CAST(N'2015-10-28' AS date), 2015, 20154, 201510, 2015300, 4, 10, 300, 27, 3, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-10-21' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-10-23' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-30' AS date), 1051, 3153, 13712, 13713, 13713, 13712, 13712, 13712, 13712, 2457323, 57322, N'2015-10-27', 201544, 44, 2, N'2015-W44', N'2015-W44-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95993, CAST(N'2015-10-28' AS date), CAST(N'2015-10-29' AS date), 2015, 20154, 201510, 2015301, 4, 10, 301, 28, 4, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-10-22' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-10-23' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-30' AS date), 1051, 3153, 13712, 13713, 13713, 13713, 13712, 13712, 13712, 2457324, 57323, N'2015-10-28', 201544, 44, 3, N'2015-W44', N'2015-W44-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95994, CAST(N'2015-10-29' AS date), CAST(N'2015-10-30' AS date), 2015, 20154, 201510, 2015302, 4, 10, 302, 29, 5, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-10-23' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-30' AS date), 1051, 3153, 13712, 13713, 13713, 13713, 13713, 13712, 13712, 2457325, 57324, N'2015-10-29', 201544, 44, 4, N'2015-W44', N'2015-W44-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95995, CAST(N'2015-10-30' AS date), CAST(N'2015-10-31' AS date), 2015, 20154, 201510, 2015303, 4, 10, 303, 30, 6, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-10-30' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-10-24' AS date), CAST(N'2015-10-30' AS date), 1051, 3153, 13712, 13713, 13713, 13713, 13713, 13713, 13712, 2457326, 57325, N'2015-10-30', 201544, 44, 5, N'2015-W44', N'2015-W44-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95996, CAST(N'2015-10-31' AS date), CAST(N'2015-11-01' AS date), 2015, 20154, 201510, 2015304, 4, 10, 304, 31, 7, N'2015', N'2015 Q4', N'2015 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-25' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-10-30' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-11-06' AS date), 1051, 3153, 13712, 13713, 13713, 13713, 13713, 13713, 13713, 2457327, 57326, N'2015-10-31', 201544, 44, 6, N'2015-W44', N'2015-W44-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95997, CAST(N'2015-11-01' AS date), CAST(N'2015-11-02' AS date), 2015, 20154, 201511, 2015305, 4, 11, 305, 1, 1, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-10-26' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-10-30' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-11-06' AS date), 1051, 3154, 13713, 13713, 13713, 13713, 13713, 13713, 13713, 2457328, 57327, N'2015-11-01', 201544, 44, 7, N'2015-W44', N'2015-W44-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95998, CAST(N'2015-11-02' AS date), CAST(N'2015-11-03' AS date), 2015, 20154, 201511, 2015306, 4, 11, 306, 2, 2, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-10-27' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-10-30' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-11-06' AS date), 1051, 3154, 13713, 13714, 13713, 13713, 13713, 13713, 13713, 2457329, 57328, N'2015-11-02', 201545, 45, 1, N'2015-W45', N'2015-W45-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (95999, CAST(N'2015-11-03' AS date), CAST(N'2015-11-04' AS date), 2015, 20154, 201511, 2015307, 4, 11, 307, 3, 3, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-10-28' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-10-30' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-11-06' AS date), 1051, 3154, 13713, 13714, 13714, 13713, 13713, 13713, 13713, 2457330, 57329, N'2015-11-03', 201545, 45, 2, N'2015-W45', N'2015-W45-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96000, CAST(N'2015-11-04' AS date), CAST(N'2015-11-05' AS date), 2015, 20154, 201511, 2015308, 4, 11, 308, 4, 4, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-10-29' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-10-30' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-11-06' AS date), 1051, 3154, 13713, 13714, 13714, 13714, 13713, 13713, 13713, 2457331, 57330, N'2015-11-04', 201545, 45, 3, N'2015-W45', N'2015-W45-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96001, CAST(N'2015-11-05' AS date), CAST(N'2015-11-06' AS date), 2015, 20154, 201511, 2015309, 4, 11, 309, 5, 5, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-10-30' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-11-06' AS date), 1051, 3154, 13713, 13714, 13714, 13714, 13714, 13713, 13713, 2457332, 57331, N'2015-11-05', 201545, 45, 4, N'2015-W45', N'2015-W45-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96002, CAST(N'2015-11-06' AS date), CAST(N'2015-11-07' AS date), 2015, 20154, 201511, 2015310, 4, 11, 310, 6, 6, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-06' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-10-31' AS date), CAST(N'2015-11-06' AS date), 1051, 3154, 13713, 13714, 13714, 13714, 13714, 13714, 13713, 2457333, 57332, N'2015-11-06', 201545, 45, 5, N'2015-W45', N'2015-W45-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96003, CAST(N'2015-11-07' AS date), CAST(N'2015-11-08' AS date), 2015, 20154, 201511, 2015311, 4, 11, 311, 7, 7, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-06' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-13' AS date), 1051, 3154, 13713, 13714, 13714, 13714, 13714, 13714, 13714, 2457334, 57333, N'2015-11-07', 201545, 45, 6, N'2015-W45', N'2015-W45-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96004, CAST(N'2015-11-08' AS date), CAST(N'2015-11-09' AS date), 2015, 20154, 201511, 2015312, 4, 11, 312, 8, 1, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-02' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-06' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-13' AS date), 1051, 3154, 13714, 13714, 13714, 13714, 13714, 13714, 13714, 2457335, 57334, N'2015-11-08', 201545, 45, 7, N'2015-W45', N'2015-W45-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96005, CAST(N'2015-11-09' AS date), CAST(N'2015-11-10' AS date), 2015, 20154, 201511, 2015313, 4, 11, 313, 9, 2, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-03' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-06' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-13' AS date), 1051, 3154, 13714, 13715, 13714, 13714, 13714, 13714, 13714, 2457336, 57335, N'2015-11-09', 201546, 46, 1, N'2015-W46', N'2015-W46-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96006, CAST(N'2015-11-10' AS date), CAST(N'2015-11-11' AS date), 2015, 20154, 201511, 2015314, 4, 11, 314, 10, 3, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-04' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-06' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-13' AS date), 1051, 3154, 13714, 13715, 13715, 13714, 13714, 13714, 13714, 2457337, 57336, N'2015-11-10', 201546, 46, 2, N'2015-W46', N'2015-W46-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96007, CAST(N'2015-11-11' AS date), CAST(N'2015-11-12' AS date), 2015, 20154, 201511, 2015315, 4, 11, 315, 11, 4, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-05' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-06' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-13' AS date), 1051, 3154, 13714, 13715, 13715, 13715, 13714, 13714, 13714, 2457338, 57337, N'2015-11-11', 201546, 46, 3, N'2015-W46', N'2015-W46-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96008, CAST(N'2015-11-12' AS date), CAST(N'2015-11-13' AS date), 2015, 20154, 201511, 2015316, 4, 11, 316, 12, 5, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-06' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-13' AS date), 1051, 3154, 13714, 13715, 13715, 13715, 13715, 13714, 13714, 2457339, 57338, N'2015-11-12', 201546, 46, 4, N'2015-W46', N'2015-W46-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96009, CAST(N'2015-11-13' AS date), CAST(N'2015-11-14' AS date), 2015, 20154, 201511, 2015317, 4, 11, 317, 13, 6, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-13' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-07' AS date), CAST(N'2015-11-13' AS date), 1051, 3154, 13714, 13715, 13715, 13715, 13715, 13715, 13714, 2457340, 57339, N'2015-11-13', 201546, 46, 5, N'2015-W46', N'2015-W46-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96010, CAST(N'2015-11-14' AS date), CAST(N'2015-11-15' AS date), 2015, 20154, 201511, 2015318, 4, 11, 318, 14, 7, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-08' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-13' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-20' AS date), 1051, 3154, 13714, 13715, 13715, 13715, 13715, 13715, 13715, 2457341, 57340, N'2015-11-14', 201546, 46, 6, N'2015-W46', N'2015-W46-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96011, CAST(N'2015-11-15' AS date), CAST(N'2015-11-16' AS date), 2015, 20154, 201511, 2015319, 4, 11, 319, 15, 1, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-09' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-13' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-20' AS date), 1051, 3154, 13715, 13715, 13715, 13715, 13715, 13715, 13715, 2457342, 57341, N'2015-11-15', 201546, 46, 7, N'2015-W46', N'2015-W46-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96012, CAST(N'2015-11-16' AS date), CAST(N'2015-11-17' AS date), 2015, 20154, 201511, 2015320, 4, 11, 320, 16, 2, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-10' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-13' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-20' AS date), 1051, 3154, 13715, 13716, 13715, 13715, 13715, 13715, 13715, 2457343, 57342, N'2015-11-16', 201547, 47, 1, N'2015-W47', N'2015-W47-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96013, CAST(N'2015-11-17' AS date), CAST(N'2015-11-18' AS date), 2015, 20154, 201511, 2015321, 4, 11, 321, 17, 3, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-11' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-13' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-20' AS date), 1051, 3154, 13715, 13716, 13716, 13715, 13715, 13715, 13715, 2457344, 57343, N'2015-11-17', 201547, 47, 2, N'2015-W47', N'2015-W47-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96014, CAST(N'2015-11-18' AS date), CAST(N'2015-11-19' AS date), 2015, 20154, 201511, 2015322, 4, 11, 322, 18, 4, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-12' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-13' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-20' AS date), 1051, 3154, 13715, 13716, 13716, 13716, 13715, 13715, 13715, 2457345, 57344, N'2015-11-18', 201547, 47, 3, N'2015-W47', N'2015-W47-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96015, CAST(N'2015-11-19' AS date), CAST(N'2015-11-20' AS date), 2015, 20154, 201511, 2015323, 4, 11, 323, 19, 5, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-11-13' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-20' AS date), 1051, 3154, 13715, 13716, 13716, 13716, 13716, 13715, 13715, 2457346, 57345, N'2015-11-19', 201547, 47, 4, N'2015-W47', N'2015-W47-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96016, CAST(N'2015-11-20' AS date), CAST(N'2015-11-21' AS date), 2015, 20154, 201511, 2015324, 4, 11, 324, 20, 6, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-11-20' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-11-14' AS date), CAST(N'2015-11-20' AS date), 1051, 3154, 13715, 13716, 13716, 13716, 13716, 13716, 13715, 2457347, 57346, N'2015-11-20', 201547, 47, 5, N'2015-W47', N'2015-W47-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96017, CAST(N'2015-11-21' AS date), CAST(N'2015-11-22' AS date), 2015, 20154, 201511, 2015325, 4, 11, 325, 21, 7, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-15' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-11-20' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-27' AS date), 1051, 3154, 13715, 13716, 13716, 13716, 13716, 13716, 13716, 2457348, 57347, N'2015-11-21', 201547, 47, 6, N'2015-W47', N'2015-W47-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96018, CAST(N'2015-11-22' AS date), CAST(N'2015-11-23' AS date), 2015, 20154, 201511, 2015326, 4, 11, 326, 22, 1, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-11-16' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-11-20' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-27' AS date), 1051, 3154, 13716, 13716, 13716, 13716, 13716, 13716, 13716, 2457349, 57348, N'2015-11-22', 201547, 47, 7, N'2015-W47', N'2015-W47-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96019, CAST(N'2015-11-23' AS date), CAST(N'2015-11-24' AS date), 2015, 20154, 201511, 2015327, 4, 11, 327, 23, 2, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-11-17' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-11-20' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-27' AS date), 1051, 3154, 13716, 13717, 13716, 13716, 13716, 13716, 13716, 2457350, 57349, N'2015-11-23', 201548, 48, 1, N'2015-W48', N'2015-W48-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96020, CAST(N'2015-11-24' AS date), CAST(N'2015-11-25' AS date), 2015, 20154, 201511, 2015328, 4, 11, 328, 24, 3, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-18' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-11-20' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-27' AS date), 1051, 3154, 13716, 13717, 13717, 13716, 13716, 13716, 13716, 2457351, 57350, N'2015-11-24', 201548, 48, 2, N'2015-W48', N'2015-W48-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96021, CAST(N'2015-11-25' AS date), CAST(N'2015-11-26' AS date), 2015, 20154, 201511, 2015329, 4, 11, 329, 25, 4, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-11-19' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-11-20' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-27' AS date), 1051, 3154, 13716, 13717, 13717, 13717, 13716, 13716, 13716, 2457352, 57351, N'2015-11-25', 201548, 48, 3, N'2015-W48', N'2015-W48-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96022, CAST(N'2015-11-26' AS date), CAST(N'2015-11-27' AS date), 2015, 20154, 201511, 2015330, 4, 11, 330, 26, 5, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-11-20' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-27' AS date), 1051, 3154, 13716, 13717, 13717, 13717, 13717, 13716, 13716, 2457353, 57352, N'2015-11-26', 201548, 48, 4, N'2015-W48', N'2015-W48-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96023, CAST(N'2015-11-27' AS date), CAST(N'2015-11-28' AS date), 2015, 20154, 201511, 2015331, 4, 11, 331, 27, 6, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-11-27' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-11-21' AS date), CAST(N'2015-11-27' AS date), 1051, 3154, 13716, 13717, 13717, 13717, 13717, 13717, 13716, 2457354, 57353, N'2015-11-27', 201548, 48, 5, N'2015-W48', N'2015-W48-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96024, CAST(N'2015-11-28' AS date), CAST(N'2015-11-29' AS date), 2015, 20154, 201511, 2015332, 4, 11, 332, 28, 7, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-22' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-11-27' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-12-04' AS date), 1051, 3154, 13716, 13717, 13717, 13717, 13717, 13717, 13717, 2457355, 57354, N'2015-11-28', 201548, 48, 6, N'2015-W48', N'2015-W48-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96025, CAST(N'2015-11-29' AS date), CAST(N'2015-11-30' AS date), 2015, 20154, 201511, 2015333, 4, 11, 333, 29, 1, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-11-23' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-11-27' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-12-04' AS date), 1051, 3154, 13717, 13717, 13717, 13717, 13717, 13717, 13717, 2457356, 57355, N'2015-11-29', 201548, 48, 7, N'2015-W48', N'2015-W48-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96026, CAST(N'2015-11-30' AS date), CAST(N'2015-12-01' AS date), 2015, 20154, 201511, 2015334, 4, 11, 334, 30, 2, N'2015', N'2015 Q4', N'2015 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-01' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-11-24' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-11-27' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-12-04' AS date), 1051, 3154, 13717, 13718, 13717, 13717, 13717, 13717, 13717, 2457357, 57356, N'2015-11-30', 201549, 49, 1, N'2015-W49', N'2015-W49-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96027, CAST(N'2015-12-01' AS date), CAST(N'2015-12-02' AS date), 2015, 20154, 201512, 2015335, 4, 12, 335, 1, 3, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-11-25' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-11-27' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-12-04' AS date), 1051, 3155, 13717, 13718, 13718, 13717, 13717, 13717, 13717, 2457358, 57357, N'2015-12-01', 201549, 49, 2, N'2015-W49', N'2015-W49-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96028, CAST(N'2015-12-02' AS date), CAST(N'2015-12-03' AS date), 2015, 20154, 201512, 2015336, 4, 12, 336, 2, 4, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-11-26' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-11-27' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-12-04' AS date), 1051, 3155, 13717, 13718, 13718, 13718, 13717, 13717, 13717, 2457359, 57358, N'2015-12-02', 201549, 49, 3, N'2015-W49', N'2015-W49-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96029, CAST(N'2015-12-03' AS date), CAST(N'2015-12-04' AS date), 2015, 20154, 201512, 2015337, 4, 12, 337, 3, 5, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-11-27' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-12-04' AS date), 1051, 3155, 13717, 13718, 13718, 13718, 13718, 13717, 13717, 2457360, 57359, N'2015-12-03', 201549, 49, 4, N'2015-W49', N'2015-W49-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96030, CAST(N'2015-12-04' AS date), CAST(N'2015-12-05' AS date), 2015, 20154, 201512, 2015338, 4, 12, 338, 4, 6, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-04' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-11-28' AS date), CAST(N'2015-12-04' AS date), 1051, 3155, 13717, 13718, 13718, 13718, 13718, 13718, 13717, 2457361, 57360, N'2015-12-04', 201549, 49, 5, N'2015-W49', N'2015-W49-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96031, CAST(N'2015-12-05' AS date), CAST(N'2015-12-06' AS date), 2015, 20154, 201512, 2015339, 4, 12, 339, 5, 7, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-11-29' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-04' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-12-11' AS date), 1051, 3155, 13717, 13718, 13718, 13718, 13718, 13718, 13718, 2457362, 57361, N'2015-12-05', 201549, 49, 6, N'2015-W49', N'2015-W49-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96032, CAST(N'2015-12-06' AS date), CAST(N'2015-12-07' AS date), 2015, 20154, 201512, 2015340, 4, 12, 340, 6, 1, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-11-30' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-04' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-12-11' AS date), 1051, 3155, 13718, 13718, 13718, 13718, 13718, 13718, 13718, 2457363, 57362, N'2015-12-06', 201549, 49, 7, N'2015-W49', N'2015-W49-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96033, CAST(N'2015-12-07' AS date), CAST(N'2015-12-08' AS date), 2015, 20154, 201512, 2015341, 4, 12, 341, 7, 2, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-04' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-12-11' AS date), 1051, 3155, 13718, 13719, 13718, 13718, 13718, 13718, 13718, 2457364, 57363, N'2015-12-07', 201550, 50, 1, N'2015-W50', N'2015-W50-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96034, CAST(N'2015-12-08' AS date), CAST(N'2015-12-09' AS date), 2015, 20154, 201512, 2015342, 4, 12, 342, 8, 3, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-02' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-04' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-12-11' AS date), 1051, 3155, 13718, 13719, 13719, 13718, 13718, 13718, 13718, 2457365, 57364, N'2015-12-08', 201550, 50, 2, N'2015-W50', N'2015-W50-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96035, CAST(N'2015-12-09' AS date), CAST(N'2015-12-10' AS date), 2015, 20154, 201512, 2015343, 4, 12, 343, 9, 4, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-03' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-04' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-12-11' AS date), 1051, 3155, 13718, 13719, 13719, 13719, 13718, 13718, 13718, 2457366, 57365, N'2015-12-09', 201550, 50, 3, N'2015-W50', N'2015-W50-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96036, CAST(N'2015-12-10' AS date), CAST(N'2015-12-11' AS date), 2015, 20154, 201512, 2015344, 4, 12, 344, 10, 5, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-04' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-12-11' AS date), 1051, 3155, 13718, 13719, 13719, 13719, 13719, 13718, 13718, 2457367, 57366, N'2015-12-10', 201550, 50, 4, N'2015-W50', N'2015-W50-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96037, CAST(N'2015-12-11' AS date), CAST(N'2015-12-12' AS date), 2015, 20154, 201512, 2015345, 4, 12, 345, 11, 6, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-11' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-05' AS date), CAST(N'2015-12-11' AS date), 1051, 3155, 13718, 13719, 13719, 13719, 13719, 13719, 13718, 2457368, 57367, N'2015-12-11', 201550, 50, 5, N'2015-W50', N'2015-W50-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96038, CAST(N'2015-12-12' AS date), CAST(N'2015-12-13' AS date), 2015, 20154, 201512, 2015346, 4, 12, 346, 12, 7, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-06' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-11' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-18' AS date), 1051, 3155, 13718, 13719, 13719, 13719, 13719, 13719, 13719, 2457369, 57368, N'2015-12-12', 201550, 50, 6, N'2015-W50', N'2015-W50-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96039, CAST(N'2015-12-13' AS date), CAST(N'2015-12-14' AS date), 2015, 20154, 201512, 2015347, 4, 12, 347, 13, 1, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-07' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-11' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-18' AS date), 1051, 3155, 13719, 13719, 13719, 13719, 13719, 13719, 13719, 2457370, 57369, N'2015-12-13', 201550, 50, 7, N'2015-W50', N'2015-W50-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96040, CAST(N'2015-12-14' AS date), CAST(N'2015-12-15' AS date), 2015, 20154, 201512, 2015348, 4, 12, 348, 14, 2, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-08' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-11' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-18' AS date), 1051, 3155, 13719, 13720, 13719, 13719, 13719, 13719, 13719, 2457371, 57370, N'2015-12-14', 201551, 51, 1, N'2015-W51', N'2015-W51-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96041, CAST(N'2015-12-15' AS date), CAST(N'2015-12-16' AS date), 2015, 20154, 201512, 2015349, 4, 12, 349, 15, 3, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-09' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-11' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-18' AS date), 1051, 3155, 13719, 13720, 13720, 13719, 13719, 13719, 13719, 2457372, 57371, N'2015-12-15', 201551, 51, 2, N'2015-W51', N'2015-W51-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96042, CAST(N'2015-12-16' AS date), CAST(N'2015-12-17' AS date), 2015, 20154, 201512, 2015350, 4, 12, 350, 16, 4, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-10' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-11' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-18' AS date), 1051, 3155, 13719, 13720, 13720, 13720, 13719, 13719, 13719, 2457373, 57372, N'2015-12-16', 201551, 51, 3, N'2015-W51', N'2015-W51-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96043, CAST(N'2015-12-17' AS date), CAST(N'2015-12-18' AS date), 2015, 20154, 201512, 2015351, 4, 12, 351, 17, 5, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-11' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-18' AS date), 1051, 3155, 13719, 13720, 13720, 13720, 13720, 13719, 13719, 2457374, 57373, N'2015-12-17', 201551, 51, 4, N'2015-W51', N'2015-W51-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96044, CAST(N'2015-12-18' AS date), CAST(N'2015-12-19' AS date), 2015, 20154, 201512, 2015352, 4, 12, 352, 18, 6, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-18' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-12' AS date), CAST(N'2015-12-18' AS date), 1051, 3155, 13719, 13720, 13720, 13720, 13720, 13720, 13719, 2457375, 57374, N'2015-12-18', 201551, 51, 5, N'2015-W51', N'2015-W51-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96045, CAST(N'2015-12-19' AS date), CAST(N'2015-12-20' AS date), 2015, 20154, 201512, 2015353, 4, 12, 353, 19, 7, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-13' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-18' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-25' AS date), 1051, 3155, 13719, 13720, 13720, 13720, 13720, 13720, 13720, 2457376, 57375, N'2015-12-19', 201551, 51, 6, N'2015-W51', N'2015-W51-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96046, CAST(N'2015-12-20' AS date), CAST(N'2015-12-21' AS date), 2015, 20154, 201512, 2015354, 4, 12, 354, 20, 1, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-26' AS date), CAST(N'2015-12-14' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-18' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-25' AS date), 1051, 3155, 13720, 13720, 13720, 13720, 13720, 13720, 13720, 2457377, 57376, N'2015-12-20', 201551, 51, 7, N'2015-W51', N'2015-W51-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96047, CAST(N'2015-12-21' AS date), CAST(N'2015-12-22' AS date), 2015, 20154, 201512, 2015355, 4, 12, 355, 21, 2, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-26' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-27' AS date), CAST(N'2015-12-15' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-18' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-25' AS date), 1051, 3155, 13720, 13721, 13720, 13720, 13720, 13720, 13720, 2457378, 57377, N'2015-12-21', 201552, 52, 1, N'2015-W52', N'2015-W52-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96048, CAST(N'2015-12-22' AS date), CAST(N'2015-12-23' AS date), 2015, 20154, 201512, 2015356, 4, 12, 356, 22, 3, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-26' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-27' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-28' AS date), CAST(N'2015-12-16' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-18' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-25' AS date), 1051, 3155, 13720, 13721, 13721, 13720, 13720, 13720, 13720, 2457379, 57378, N'2015-12-22', 201552, 52, 2, N'2015-W52', N'2015-W52-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96049, CAST(N'2015-12-23' AS date), CAST(N'2015-12-24' AS date), 2015, 20154, 201512, 2015357, 4, 12, 357, 23, 4, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-26' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-27' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-28' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-29' AS date), CAST(N'2015-12-17' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-18' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-25' AS date), 1051, 3155, 13720, 13721, 13721, 13721, 13720, 13720, 13720, 2457380, 57379, N'2015-12-23', 201552, 52, 3, N'2015-W52', N'2015-W52-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96050, CAST(N'2015-12-24' AS date), CAST(N'2015-12-25' AS date), 2015, 20154, 201512, 2015358, 4, 12, 358, 24, 5, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-26' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-27' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-28' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-29' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-30' AS date), CAST(N'2015-12-18' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-25' AS date), 1051, 3155, 13720, 13721, 13721, 13721, 13721, 13720, 13720, 2457381, 57380, N'2015-12-24', 201552, 52, 4, N'2015-W52', N'2015-W52-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96051, CAST(N'2015-12-25' AS date), CAST(N'2015-12-26' AS date), 2015, 20154, 201512, 2015359, 4, 12, 359, 25, 6, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-26' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-27' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-28' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-29' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-30' AS date), CAST(N'2015-12-25' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-19' AS date), CAST(N'2015-12-25' AS date), 1051, 3155, 13720, 13721, 13721, 13721, 13721, 13721, 13720, 2457382, 57381, N'2015-12-25', 201552, 52, 5, N'2015-W52', N'2015-W52-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96052, CAST(N'2015-12-26' AS date), CAST(N'2015-12-27' AS date), 2015, 20154, 201512, 2015360, 4, 12, 360, 26, 7, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-20' AS date), CAST(N'2015-12-26' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-27' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-28' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-29' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-30' AS date), CAST(N'2015-12-25' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-26' AS date), CAST(N'2016-01-01' AS date), 1051, 3155, 13720, 13721, 13721, 13721, 13721, 13721, 13721, 2457383, 57382, N'2015-12-26', 201552, 52, 6, N'2015-W52', N'2015-W52-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96053, CAST(N'2015-12-27' AS date), CAST(N'2015-12-28' AS date), 2015, 20154, 201512, 2015361, 4, 12, 361, 27, 1, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-27' AS date), CAST(N'2016-01-02' AS date), CAST(N'2015-12-21' AS date), CAST(N'2015-12-27' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-28' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-29' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-30' AS date), CAST(N'2015-12-25' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-26' AS date), CAST(N'2016-01-01' AS date), 1051, 3155, 13721, 13721, 13721, 13721, 13721, 13721, 13721, 2457384, 57383, N'2015-12-27', 201552, 52, 7, N'2015-W52', N'2015-W52-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96054, CAST(N'2015-12-28' AS date), CAST(N'2015-12-29' AS date), 2015, 20154, 201512, 2015362, 4, 12, 362, 28, 2, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-27' AS date), CAST(N'2016-01-02' AS date), CAST(N'2015-12-28' AS date), CAST(N'2016-01-03' AS date), CAST(N'2015-12-22' AS date), CAST(N'2015-12-28' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-29' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-30' AS date), CAST(N'2015-12-25' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-26' AS date), CAST(N'2016-01-01' AS date), 1051, 3155, 13721, 13722, 13721, 13721, 13721, 13721, 13721, 2457385, 57384, N'2015-12-28', 201553, 53, 1, N'2015-W53', N'2015-W53-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96055, CAST(N'2015-12-29' AS date), CAST(N'2015-12-30' AS date), 2015, 20154, 201512, 2015363, 4, 12, 363, 29, 3, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-27' AS date), CAST(N'2016-01-02' AS date), CAST(N'2015-12-28' AS date), CAST(N'2016-01-03' AS date), CAST(N'2015-12-29' AS date), CAST(N'2016-01-04' AS date), CAST(N'2015-12-23' AS date), CAST(N'2015-12-29' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-30' AS date), CAST(N'2015-12-25' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-26' AS date), CAST(N'2016-01-01' AS date), 1051, 3155, 13721, 13722, 13722, 13721, 13721, 13721, 13721, 2457386, 57385, N'2015-12-29', 201553, 53, 2, N'2015-W53', N'2015-W53-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96056, CAST(N'2015-12-30' AS date), CAST(N'2015-12-31' AS date), 2015, 20154, 201512, 2015364, 4, 12, 364, 30, 4, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-27' AS date), CAST(N'2016-01-02' AS date), CAST(N'2015-12-28' AS date), CAST(N'2016-01-03' AS date), CAST(N'2015-12-29' AS date), CAST(N'2016-01-04' AS date), CAST(N'2015-12-30' AS date), CAST(N'2016-01-05' AS date), CAST(N'2015-12-24' AS date), CAST(N'2015-12-30' AS date), CAST(N'2015-12-25' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-26' AS date), CAST(N'2016-01-01' AS date), 1051, 3155, 13721, 13722, 13722, 13722, 13721, 13721, 13721, 2457387, 57386, N'2015-12-30', 201553, 53, 3, N'2015-W53', N'2015-W53-3');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96057, CAST(N'2015-12-31' AS date), CAST(N'2016-01-01' AS date), 2015, 20154, 201512, 2015365, 4, 12, 365, 31, 5, N'2015', N'2015 Q4', N'2015 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2015-01-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-10-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-01' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-27' AS date), CAST(N'2016-01-02' AS date), CAST(N'2015-12-28' AS date), CAST(N'2016-01-03' AS date), CAST(N'2015-12-29' AS date), CAST(N'2016-01-04' AS date), CAST(N'2015-12-30' AS date), CAST(N'2016-01-05' AS date), CAST(N'2015-12-31' AS date), CAST(N'2016-01-06' AS date), CAST(N'2015-12-25' AS date), CAST(N'2015-12-31' AS date), CAST(N'2015-12-26' AS date), CAST(N'2016-01-01' AS date), 1051, 3155, 13721, 13722, 13722, 13722, 13722, 13721, 13721, 2457388, 57387, N'2015-12-31', 201553, 53, 4, N'2015-W53', N'2015-W53-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96058, CAST(N'2016-01-01' AS date), CAST(N'2016-01-02' AS date), 2016, 20161, 201601, 2016001, 1, 1, 1, 1, 6, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2015-12-27' AS date), CAST(N'2016-01-02' AS date), CAST(N'2015-12-28' AS date), CAST(N'2016-01-03' AS date), CAST(N'2015-12-29' AS date), CAST(N'2016-01-04' AS date), CAST(N'2015-12-30' AS date), CAST(N'2016-01-05' AS date), CAST(N'2015-12-31' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-07' AS date), CAST(N'2015-12-26' AS date), CAST(N'2016-01-01' AS date), 1052, 3156, 13721, 13722, 13722, 13722, 13722, 13722, 13721, 2457389, 57388, N'2016-01-01', 201553, 53, 5, N'2015-W53', N'2015-W53-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96059, CAST(N'2016-01-02' AS date), CAST(N'2016-01-03' AS date), 2016, 20161, 201601, 2016002, 1, 1, 2, 2, 7, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2015-12-27' AS date), CAST(N'2016-01-02' AS date), CAST(N'2015-12-28' AS date), CAST(N'2016-01-03' AS date), CAST(N'2015-12-29' AS date), CAST(N'2016-01-04' AS date), CAST(N'2015-12-30' AS date), CAST(N'2016-01-05' AS date), CAST(N'2015-12-31' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-02' AS date), CAST(N'2016-01-08' AS date), 1052, 3156, 13721, 13722, 13722, 13722, 13722, 13722, 13722, 2457390, 57389, N'2016-01-02', 201553, 53, 6, N'2015-W53', N'2015-W53-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96060, CAST(N'2016-01-03' AS date), CAST(N'2016-01-04' AS date), 2016, 20161, 201601, 2016003, 1, 1, 3, 3, 1, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-03' AS date), CAST(N'2016-01-09' AS date), CAST(N'2015-12-28' AS date), CAST(N'2016-01-03' AS date), CAST(N'2015-12-29' AS date), CAST(N'2016-01-04' AS date), CAST(N'2015-12-30' AS date), CAST(N'2016-01-05' AS date), CAST(N'2015-12-31' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-02' AS date), CAST(N'2016-01-08' AS date), 1052, 3156, 13722, 13722, 13722, 13722, 13722, 13722, 13722, 2457391, 57390, N'2016-01-03', 201553, 53, 7, N'2015-W53', N'2015-W53-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96061, CAST(N'2016-01-04' AS date), CAST(N'2016-01-05' AS date), 2016, 20161, 201601, 2016004, 1, 1, 4, 4, 2, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-03' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-04' AS date), CAST(N'2016-01-10' AS date), CAST(N'2015-12-29' AS date), CAST(N'2016-01-04' AS date), CAST(N'2015-12-30' AS date), CAST(N'2016-01-05' AS date), CAST(N'2015-12-31' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-02' AS date), CAST(N'2016-01-08' AS date), 1052, 3156, 13722, 13723, 13722, 13722, 13722, 13722, 13722, 2457392, 57391, N'2016-01-04', 201601, 1, 1, N'2016-W01', N'2016-W01-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96062, CAST(N'2016-01-05' AS date), CAST(N'2016-01-06' AS date), 2016, 20161, 201601, 2016005, 1, 1, 5, 5, 3, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-03' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-04' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-05' AS date), CAST(N'2016-01-11' AS date), CAST(N'2015-12-30' AS date), CAST(N'2016-01-05' AS date), CAST(N'2015-12-31' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-02' AS date), CAST(N'2016-01-08' AS date), 1052, 3156, 13722, 13723, 13723, 13722, 13722, 13722, 13722, 2457393, 57392, N'2016-01-05', 201601, 1, 2, N'2016-W01', N'2016-W01-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96063, CAST(N'2016-01-06' AS date), CAST(N'2016-01-07' AS date), 2016, 20161, 201601, 2016006, 1, 1, 6, 6, 4, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-03' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-04' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-05' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-12' AS date), CAST(N'2015-12-31' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-02' AS date), CAST(N'2016-01-08' AS date), 1052, 3156, 13722, 13723, 13723, 13723, 13722, 13722, 13722, 2457394, 57393, N'2016-01-06', 201601, 1, 3, N'2016-W01', N'2016-W01-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96064, CAST(N'2016-01-07' AS date), CAST(N'2016-01-08' AS date), 2016, 20161, 201601, 2016007, 1, 1, 7, 7, 5, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-03' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-04' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-05' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-02' AS date), CAST(N'2016-01-08' AS date), 1052, 3156, 13722, 13723, 13723, 13723, 13723, 13722, 13722, 2457395, 57394, N'2016-01-07', 201601, 1, 4, N'2016-W01', N'2016-W01-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96065, CAST(N'2016-01-08' AS date), CAST(N'2016-01-09' AS date), 2016, 20161, 201601, 2016008, 1, 1, 8, 8, 6, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-03' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-04' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-05' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-08' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-02' AS date), CAST(N'2016-01-08' AS date), 1052, 3156, 13722, 13723, 13723, 13723, 13723, 13723, 13722, 2457396, 57395, N'2016-01-08', 201601, 1, 5, N'2016-W01', N'2016-W01-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96066, CAST(N'2016-01-09' AS date), CAST(N'2016-01-10' AS date), 2016, 20161, 201601, 2016009, 1, 1, 9, 9, 7, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-03' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-04' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-05' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-08' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-15' AS date), 1052, 3156, 13722, 13723, 13723, 13723, 13723, 13723, 13723, 2457397, 57396, N'2016-01-09', 201601, 1, 6, N'2016-W01', N'2016-W01-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96067, CAST(N'2016-01-10' AS date), CAST(N'2016-01-11' AS date), 2016, 20161, 201601, 2016010, 1, 1, 10, 10, 1, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-04' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-05' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-08' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-15' AS date), 1052, 3156, 13723, 13723, 13723, 13723, 13723, 13723, 13723, 2457398, 57397, N'2016-01-10', 201601, 1, 7, N'2016-W01', N'2016-W01-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96068, CAST(N'2016-01-11' AS date), CAST(N'2016-01-12' AS date), 2016, 20161, 201601, 2016011, 1, 1, 11, 11, 2, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-05' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-08' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-15' AS date), 1052, 3156, 13723, 13724, 13723, 13723, 13723, 13723, 13723, 2457399, 57398, N'2016-01-11', 201602, 2, 1, N'2016-W02', N'2016-W02-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96069, CAST(N'2016-01-12' AS date), CAST(N'2016-01-13' AS date), 2016, 20161, 201601, 2016012, 1, 1, 12, 12, 3, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-06' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-08' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-15' AS date), 1052, 3156, 13723, 13724, 13724, 13723, 13723, 13723, 13723, 2457400, 57399, N'2016-01-12', 201602, 2, 2, N'2016-W02', N'2016-W02-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96070, CAST(N'2016-01-13' AS date), CAST(N'2016-01-14' AS date), 2016, 20161, 201601, 2016013, 1, 1, 13, 13, 4, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-07' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-08' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-15' AS date), 1052, 3156, 13723, 13724, 13724, 13724, 13723, 13723, 13723, 2457401, 57400, N'2016-01-13', 201602, 2, 3, N'2016-W02', N'2016-W02-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96071, CAST(N'2016-01-14' AS date), CAST(N'2016-01-15' AS date), 2016, 20161, 201601, 2016014, 1, 1, 14, 14, 5, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-08' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-15' AS date), 1052, 3156, 13723, 13724, 13724, 13724, 13724, 13723, 13723, 2457402, 57401, N'2016-01-14', 201602, 2, 4, N'2016-W02', N'2016-W02-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96072, CAST(N'2016-01-15' AS date), CAST(N'2016-01-16' AS date), 2016, 20161, 201601, 2016015, 1, 1, 15, 15, 6, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-15' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-09' AS date), CAST(N'2016-01-15' AS date), 1052, 3156, 13723, 13724, 13724, 13724, 13724, 13724, 13723, 2457403, 57402, N'2016-01-15', 201602, 2, 5, N'2016-W02', N'2016-W02-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96073, CAST(N'2016-01-16' AS date), CAST(N'2016-01-17' AS date), 2016, 20161, 201601, 2016016, 1, 1, 16, 16, 7, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-10' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-15' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-22' AS date), 1052, 3156, 13723, 13724, 13724, 13724, 13724, 13724, 13724, 2457404, 57403, N'2016-01-16', 201602, 2, 6, N'2016-W02', N'2016-W02-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96074, CAST(N'2016-01-17' AS date), CAST(N'2016-01-18' AS date), 2016, 20161, 201601, 2016017, 1, 1, 17, 17, 1, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-11' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-15' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-22' AS date), 1052, 3156, 13724, 13724, 13724, 13724, 13724, 13724, 13724, 2457405, 57404, N'2016-01-17', 201602, 2, 7, N'2016-W02', N'2016-W02-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96075, CAST(N'2016-01-18' AS date), CAST(N'2016-01-19' AS date), 2016, 20161, 201601, 2016018, 1, 1, 18, 18, 2, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-12' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-15' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-22' AS date), 1052, 3156, 13724, 13725, 13724, 13724, 13724, 13724, 13724, 2457406, 57405, N'2016-01-18', 201603, 3, 1, N'2016-W03', N'2016-W03-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96076, CAST(N'2016-01-19' AS date), CAST(N'2016-01-20' AS date), 2016, 20161, 201601, 2016019, 1, 1, 19, 19, 3, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-13' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-15' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-22' AS date), 1052, 3156, 13724, 13725, 13725, 13724, 13724, 13724, 13724, 2457407, 57406, N'2016-01-19', 201603, 3, 2, N'2016-W03', N'2016-W03-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96077, CAST(N'2016-01-20' AS date), CAST(N'2016-01-21' AS date), 2016, 20161, 201601, 2016020, 1, 1, 20, 20, 4, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-01-14' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-15' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-22' AS date), 1052, 3156, 13724, 13725, 13725, 13725, 13724, 13724, 13724, 2457408, 57407, N'2016-01-20', 201603, 3, 3, N'2016-W03', N'2016-W03-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96078, CAST(N'2016-01-21' AS date), CAST(N'2016-01-22' AS date), 2016, 20161, 201601, 2016021, 1, 1, 21, 21, 5, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-01-15' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-22' AS date), 1052, 3156, 13724, 13725, 13725, 13725, 13725, 13724, 13724, 2457409, 57408, N'2016-01-21', 201603, 3, 4, N'2016-W03', N'2016-W03-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96079, CAST(N'2016-01-22' AS date), CAST(N'2016-01-23' AS date), 2016, 20161, 201601, 2016022, 1, 1, 22, 22, 6, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-01-22' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-01-16' AS date), CAST(N'2016-01-22' AS date), 1052, 3156, 13724, 13725, 13725, 13725, 13725, 13725, 13724, 2457410, 57409, N'2016-01-22', 201603, 3, 5, N'2016-W03', N'2016-W03-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96080, CAST(N'2016-01-23' AS date), CAST(N'2016-01-24' AS date), 2016, 20161, 201601, 2016023, 1, 1, 23, 23, 7, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-17' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-01-22' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-29' AS date), 1052, 3156, 13724, 13725, 13725, 13725, 13725, 13725, 13725, 2457411, 57410, N'2016-01-23', 201603, 3, 6, N'2016-W03', N'2016-W03-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96081, CAST(N'2016-01-24' AS date), CAST(N'2016-01-25' AS date), 2016, 20161, 201601, 2016024, 1, 1, 24, 24, 1, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-01-18' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-01-22' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-29' AS date), 1052, 3156, 13725, 13725, 13725, 13725, 13725, 13725, 13725, 2457412, 57411, N'2016-01-24', 201603, 3, 7, N'2016-W03', N'2016-W03-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96082, CAST(N'2016-01-25' AS date), CAST(N'2016-01-26' AS date), 2016, 20161, 201601, 2016025, 1, 1, 25, 25, 2, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-19' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-01-22' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-29' AS date), 1052, 3156, 13725, 13726, 13725, 13725, 13725, 13725, 13725, 2457413, 57412, N'2016-01-25', 201604, 4, 1, N'2016-W04', N'2016-W04-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96083, CAST(N'2016-01-26' AS date), CAST(N'2016-01-27' AS date), 2016, 20161, 201601, 2016026, 1, 1, 26, 26, 3, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-01-20' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-01-22' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-29' AS date), 1052, 3156, 13725, 13726, 13726, 13725, 13725, 13725, 13725, 2457414, 57413, N'2016-01-26', 201604, 4, 2, N'2016-W04', N'2016-W04-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96084, CAST(N'2016-01-27' AS date), CAST(N'2016-01-28' AS date), 2016, 20161, 201601, 2016027, 1, 1, 27, 27, 4, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-01-21' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-01-22' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-29' AS date), 1052, 3156, 13725, 13726, 13726, 13726, 13725, 13725, 13725, 2457415, 57414, N'2016-01-27', 201604, 4, 3, N'2016-W04', N'2016-W04-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96085, CAST(N'2016-01-28' AS date), CAST(N'2016-01-29' AS date), 2016, 20161, 201601, 2016028, 1, 1, 28, 28, 5, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-01-22' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-29' AS date), 1052, 3156, 13725, 13726, 13726, 13726, 13726, 13725, 13725, 2457416, 57415, N'2016-01-28', 201604, 4, 4, N'2016-W04', N'2016-W04-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96086, CAST(N'2016-01-29' AS date), CAST(N'2016-01-30' AS date), 2016, 20161, 201601, 2016029, 1, 1, 29, 29, 6, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-01-29' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-01-23' AS date), CAST(N'2016-01-29' AS date), 1052, 3156, 13725, 13726, 13726, 13726, 13726, 13726, 13725, 2457417, 57416, N'2016-01-29', 201604, 4, 5, N'2016-W04', N'2016-W04-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96087, CAST(N'2016-01-30' AS date), CAST(N'2016-01-31' AS date), 2016, 20161, 201601, 2016030, 1, 1, 30, 30, 7, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-24' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-01-29' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-02-05' AS date), 1052, 3156, 13725, 13726, 13726, 13726, 13726, 13726, 13726, 2457418, 57417, N'2016-01-30', 201604, 4, 6, N'2016-W04', N'2016-W04-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96088, CAST(N'2016-01-31' AS date), CAST(N'2016-02-01' AS date), 2016, 20161, 201601, 2016031, 1, 1, 31, 31, 1, N'2016', N'2016 Q1', N'2016 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-01-25' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-01-29' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-02-05' AS date), 1052, 3156, 13726, 13726, 13726, 13726, 13726, 13726, 13726, 2457419, 57418, N'2016-01-31', 201604, 4, 7, N'2016-W04', N'2016-W04-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96089, CAST(N'2016-02-01' AS date), CAST(N'2016-02-02' AS date), 2016, 20161, 201602, 2016032, 1, 2, 32, 1, 2, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-01-26' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-01-29' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-02-05' AS date), 1052, 3157, 13726, 13727, 13726, 13726, 13726, 13726, 13726, 2457420, 57419, N'2016-02-01', 201605, 5, 1, N'2016-W05', N'2016-W05-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96090, CAST(N'2016-02-02' AS date), CAST(N'2016-02-03' AS date), 2016, 20161, 201602, 2016033, 1, 2, 33, 2, 3, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-01-27' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-01-29' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-02-05' AS date), 1052, 3157, 13726, 13727, 13727, 13726, 13726, 13726, 13726, 2457421, 57420, N'2016-02-02', 201605, 5, 2, N'2016-W05', N'2016-W05-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96091, CAST(N'2016-02-03' AS date), CAST(N'2016-02-04' AS date), 2016, 20161, 201602, 2016034, 1, 2, 34, 3, 4, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-01-28' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-01-29' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-02-05' AS date), 1052, 3157, 13726, 13727, 13727, 13727, 13726, 13726, 13726, 2457422, 57421, N'2016-02-03', 201605, 5, 3, N'2016-W05', N'2016-W05-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96092, CAST(N'2016-02-04' AS date), CAST(N'2016-02-05' AS date), 2016, 20161, 201602, 2016035, 1, 2, 35, 4, 5, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-01-29' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-02-05' AS date), 1052, 3157, 13726, 13727, 13727, 13727, 13727, 13726, 13726, 2457423, 57422, N'2016-02-04', 201605, 5, 4, N'2016-W05', N'2016-W05-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96093, CAST(N'2016-02-05' AS date), CAST(N'2016-02-06' AS date), 2016, 20161, 201602, 2016036, 1, 2, 36, 5, 6, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-05' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-01-30' AS date), CAST(N'2016-02-05' AS date), 1052, 3157, 13726, 13727, 13727, 13727, 13727, 13727, 13726, 2457424, 57423, N'2016-02-05', 201605, 5, 5, N'2016-W05', N'2016-W05-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96094, CAST(N'2016-02-06' AS date), CAST(N'2016-02-07' AS date), 2016, 20161, 201602, 2016037, 1, 2, 37, 6, 7, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-01-31' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-05' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-12' AS date), 1052, 3157, 13726, 13727, 13727, 13727, 13727, 13727, 13727, 2457425, 57424, N'2016-02-06', 201605, 5, 6, N'2016-W05', N'2016-W05-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96095, CAST(N'2016-02-07' AS date), CAST(N'2016-02-08' AS date), 2016, 20161, 201602, 2016038, 1, 2, 38, 7, 1, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-05' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-12' AS date), 1052, 3157, 13727, 13727, 13727, 13727, 13727, 13727, 13727, 2457426, 57425, N'2016-02-07', 201605, 5, 7, N'2016-W05', N'2016-W05-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96096, CAST(N'2016-02-08' AS date), CAST(N'2016-02-09' AS date), 2016, 20161, 201602, 2016039, 1, 2, 39, 8, 2, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-02' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-05' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-12' AS date), 1052, 3157, 13727, 13728, 13727, 13727, 13727, 13727, 13727, 2457427, 57426, N'2016-02-08', 201606, 6, 1, N'2016-W06', N'2016-W06-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96097, CAST(N'2016-02-09' AS date), CAST(N'2016-02-10' AS date), 2016, 20161, 201602, 2016040, 1, 2, 40, 9, 3, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-03' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-05' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-12' AS date), 1052, 3157, 13727, 13728, 13728, 13727, 13727, 13727, 13727, 2457428, 57427, N'2016-02-09', 201606, 6, 2, N'2016-W06', N'2016-W06-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96098, CAST(N'2016-02-10' AS date), CAST(N'2016-02-11' AS date), 2016, 20161, 201602, 2016041, 1, 2, 41, 10, 4, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-04' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-05' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-12' AS date), 1052, 3157, 13727, 13728, 13728, 13728, 13727, 13727, 13727, 2457429, 57428, N'2016-02-10', 201606, 6, 3, N'2016-W06', N'2016-W06-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96099, CAST(N'2016-02-11' AS date), CAST(N'2016-02-12' AS date), 2016, 20161, 201602, 2016042, 1, 2, 42, 11, 5, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-05' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-12' AS date), 1052, 3157, 13727, 13728, 13728, 13728, 13728, 13727, 13727, 2457430, 57429, N'2016-02-11', 201606, 6, 4, N'2016-W06', N'2016-W06-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96100, CAST(N'2016-02-12' AS date), CAST(N'2016-02-13' AS date), 2016, 20161, 201602, 2016043, 1, 2, 43, 12, 6, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-12' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-06' AS date), CAST(N'2016-02-12' AS date), 1052, 3157, 13727, 13728, 13728, 13728, 13728, 13728, 13727, 2457431, 57430, N'2016-02-12', 201606, 6, 5, N'2016-W06', N'2016-W06-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96101, CAST(N'2016-02-13' AS date), CAST(N'2016-02-14' AS date), 2016, 20161, 201602, 2016044, 1, 2, 44, 13, 7, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-07' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-12' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-19' AS date), 1052, 3157, 13727, 13728, 13728, 13728, 13728, 13728, 13728, 2457432, 57431, N'2016-02-13', 201606, 6, 6, N'2016-W06', N'2016-W06-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96102, CAST(N'2016-02-14' AS date), CAST(N'2016-02-15' AS date), 2016, 20161, 201602, 2016045, 1, 2, 45, 14, 1, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-08' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-12' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-19' AS date), 1052, 3157, 13728, 13728, 13728, 13728, 13728, 13728, 13728, 2457433, 57432, N'2016-02-14', 201606, 6, 7, N'2016-W06', N'2016-W06-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96103, CAST(N'2016-02-15' AS date), CAST(N'2016-02-16' AS date), 2016, 20161, 201602, 2016046, 1, 2, 46, 15, 2, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-09' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-12' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-19' AS date), 1052, 3157, 13728, 13729, 13728, 13728, 13728, 13728, 13728, 2457434, 57433, N'2016-02-15', 201607, 7, 1, N'2016-W07', N'2016-W07-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96104, CAST(N'2016-02-16' AS date), CAST(N'2016-02-17' AS date), 2016, 20161, 201602, 2016047, 1, 2, 47, 16, 3, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-10' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-12' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-19' AS date), 1052, 3157, 13728, 13729, 13729, 13728, 13728, 13728, 13728, 2457435, 57434, N'2016-02-16', 201607, 7, 2, N'2016-W07', N'2016-W07-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96105, CAST(N'2016-02-17' AS date), CAST(N'2016-02-18' AS date), 2016, 20161, 201602, 2016048, 1, 2, 48, 17, 4, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-11' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-12' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-19' AS date), 1052, 3157, 13728, 13729, 13729, 13729, 13728, 13728, 13728, 2457436, 57435, N'2016-02-17', 201607, 7, 3, N'2016-W07', N'2016-W07-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96106, CAST(N'2016-02-18' AS date), CAST(N'2016-02-19' AS date), 2016, 20161, 201602, 2016049, 1, 2, 49, 18, 5, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-02-12' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-19' AS date), 1052, 3157, 13728, 13729, 13729, 13729, 13729, 13728, 13728, 2457437, 57436, N'2016-02-18', 201607, 7, 4, N'2016-W07', N'2016-W07-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96107, CAST(N'2016-02-19' AS date), CAST(N'2016-02-20' AS date), 2016, 20161, 201602, 2016050, 1, 2, 50, 19, 6, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-02-19' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-02-13' AS date), CAST(N'2016-02-19' AS date), 1052, 3157, 13728, 13729, 13729, 13729, 13729, 13729, 13728, 2457438, 57437, N'2016-02-19', 201607, 7, 5, N'2016-W07', N'2016-W07-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96108, CAST(N'2016-02-20' AS date), CAST(N'2016-02-21' AS date), 2016, 20161, 201602, 2016051, 1, 2, 51, 20, 7, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-14' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-02-19' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-26' AS date), 1052, 3157, 13728, 13729, 13729, 13729, 13729, 13729, 13729, 2457439, 57438, N'2016-02-20', 201607, 7, 6, N'2016-W07', N'2016-W07-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96109, CAST(N'2016-02-21' AS date), CAST(N'2016-02-22' AS date), 2016, 20161, 201602, 2016052, 1, 2, 52, 21, 1, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-02-15' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-02-19' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-26' AS date), 1052, 3157, 13729, 13729, 13729, 13729, 13729, 13729, 13729, 2457440, 57439, N'2016-02-21', 201607, 7, 7, N'2016-W07', N'2016-W07-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96110, CAST(N'2016-02-22' AS date), CAST(N'2016-02-23' AS date), 2016, 20161, 201602, 2016053, 1, 2, 53, 22, 2, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-02-16' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-02-19' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-26' AS date), 1052, 3157, 13729, 13730, 13729, 13729, 13729, 13729, 13729, 2457441, 57440, N'2016-02-22', 201608, 8, 1, N'2016-W08', N'2016-W08-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96111, CAST(N'2016-02-23' AS date), CAST(N'2016-02-24' AS date), 2016, 20161, 201602, 2016054, 1, 2, 54, 23, 3, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-17' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-02-19' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-26' AS date), 1052, 3157, 13729, 13730, 13730, 13729, 13729, 13729, 13729, 2457442, 57441, N'2016-02-23', 201608, 8, 2, N'2016-W08', N'2016-W08-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96112, CAST(N'2016-02-24' AS date), CAST(N'2016-02-25' AS date), 2016, 20161, 201602, 2016055, 1, 2, 55, 24, 4, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-02-18' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-02-19' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-26' AS date), 1052, 3157, 13729, 13730, 13730, 13730, 13729, 13729, 13729, 2457443, 57442, N'2016-02-24', 201608, 8, 3, N'2016-W08', N'2016-W08-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96113, CAST(N'2016-02-25' AS date), CAST(N'2016-02-26' AS date), 2016, 20161, 201602, 2016056, 1, 2, 56, 25, 5, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-02-19' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-26' AS date), 1052, 3157, 13729, 13730, 13730, 13730, 13730, 13729, 13729, 2457444, 57443, N'2016-02-25', 201608, 8, 4, N'2016-W08', N'2016-W08-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96114, CAST(N'2016-02-26' AS date), CAST(N'2016-02-27' AS date), 2016, 20161, 201602, 2016057, 1, 2, 57, 26, 6, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-02-26' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-02-20' AS date), CAST(N'2016-02-26' AS date), 1052, 3157, 13729, 13730, 13730, 13730, 13730, 13730, 13729, 2457445, 57444, N'2016-02-26', 201608, 8, 5, N'2016-W08', N'2016-W08-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96115, CAST(N'2016-02-27' AS date), CAST(N'2016-02-28' AS date), 2016, 20161, 201602, 2016058, 1, 2, 58, 27, 7, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-21' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-02-26' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-03-04' AS date), 1052, 3157, 13729, 13730, 13730, 13730, 13730, 13730, 13730, 2457446, 57445, N'2016-02-27', 201608, 8, 6, N'2016-W08', N'2016-W08-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96116, CAST(N'2016-02-28' AS date), CAST(N'2016-02-29' AS date), 2016, 20161, 201602, 2016059, 1, 2, 59, 28, 1, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-02-22' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-02-26' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-03-04' AS date), 1052, 3157, 13730, 13730, 13730, 13730, 13730, 13730, 13730, 2457447, 57446, N'2016-02-28', 201608, 8, 7, N'2016-W08', N'2016-W08-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96117, CAST(N'2016-02-29' AS date), CAST(N'2016-03-01' AS date), 2016, 20161, 201602, 2016060, 1, 2, 60, 29, 2, N'2016', N'2016 Q1', N'2016 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-01' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-02-23' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-02-26' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-03-04' AS date), 1052, 3157, 13730, 13731, 13730, 13730, 13730, 13730, 13730, 2457448, 57447, N'2016-02-29', 201609, 9, 1, N'2016-W09', N'2016-W09-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96118, CAST(N'2016-03-01' AS date), CAST(N'2016-03-02' AS date), 2016, 20161, 201603, 2016061, 1, 3, 61, 1, 3, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-02-24' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-02-26' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-03-04' AS date), 1052, 3158, 13730, 13731, 13731, 13730, 13730, 13730, 13730, 2457449, 57448, N'2016-03-01', 201609, 9, 2, N'2016-W09', N'2016-W09-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96119, CAST(N'2016-03-02' AS date), CAST(N'2016-03-03' AS date), 2016, 20161, 201603, 2016062, 1, 3, 62, 2, 4, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-02-25' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-02-26' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-03-04' AS date), 1052, 3158, 13730, 13731, 13731, 13731, 13730, 13730, 13730, 2457450, 57449, N'2016-03-02', 201609, 9, 3, N'2016-W09', N'2016-W09-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96120, CAST(N'2016-03-03' AS date), CAST(N'2016-03-04' AS date), 2016, 20161, 201603, 2016063, 1, 3, 63, 3, 5, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-02-26' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-03-04' AS date), 1052, 3158, 13730, 13731, 13731, 13731, 13731, 13730, 13730, 2457451, 57450, N'2016-03-03', 201609, 9, 4, N'2016-W09', N'2016-W09-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96121, CAST(N'2016-03-04' AS date), CAST(N'2016-03-05' AS date), 2016, 20161, 201603, 2016064, 1, 3, 64, 4, 6, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-04' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-02-27' AS date), CAST(N'2016-03-04' AS date), 1052, 3158, 13730, 13731, 13731, 13731, 13731, 13731, 13730, 2457452, 57451, N'2016-03-04', 201609, 9, 5, N'2016-W09', N'2016-W09-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96122, CAST(N'2016-03-05' AS date), CAST(N'2016-03-06' AS date), 2016, 20161, 201603, 2016065, 1, 3, 65, 5, 7, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-02-28' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-04' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-03-11' AS date), 1052, 3158, 13730, 13731, 13731, 13731, 13731, 13731, 13731, 2457453, 57452, N'2016-03-05', 201609, 9, 6, N'2016-W09', N'2016-W09-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96123, CAST(N'2016-03-06' AS date), CAST(N'2016-03-07' AS date), 2016, 20161, 201603, 2016066, 1, 3, 66, 6, 1, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-02-29' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-04' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-03-11' AS date), 1052, 3158, 13731, 13731, 13731, 13731, 13731, 13731, 13731, 2457454, 57453, N'2016-03-06', 201609, 9, 7, N'2016-W09', N'2016-W09-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96124, CAST(N'2016-03-07' AS date), CAST(N'2016-03-08' AS date), 2016, 20161, 201603, 2016067, 1, 3, 67, 7, 2, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-04' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-03-11' AS date), 1052, 3158, 13731, 13732, 13731, 13731, 13731, 13731, 13731, 2457455, 57454, N'2016-03-07', 201610, 10, 1, N'2016-W10', N'2016-W10-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96125, CAST(N'2016-03-08' AS date), CAST(N'2016-03-09' AS date), 2016, 20161, 201603, 2016068, 1, 3, 68, 8, 3, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-02' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-04' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-03-11' AS date), 1052, 3158, 13731, 13732, 13732, 13731, 13731, 13731, 13731, 2457456, 57455, N'2016-03-08', 201610, 10, 2, N'2016-W10', N'2016-W10-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96126, CAST(N'2016-03-09' AS date), CAST(N'2016-03-10' AS date), 2016, 20161, 201603, 2016069, 1, 3, 69, 9, 4, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-03' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-04' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-03-11' AS date), 1052, 3158, 13731, 13732, 13732, 13732, 13731, 13731, 13731, 2457457, 57456, N'2016-03-09', 201610, 10, 3, N'2016-W10', N'2016-W10-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96127, CAST(N'2016-03-10' AS date), CAST(N'2016-03-11' AS date), 2016, 20161, 201603, 2016070, 1, 3, 70, 10, 5, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-04' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-03-11' AS date), 1052, 3158, 13731, 13732, 13732, 13732, 13732, 13731, 13731, 2457458, 57457, N'2016-03-10', 201610, 10, 4, N'2016-W10', N'2016-W10-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96128, CAST(N'2016-03-11' AS date), CAST(N'2016-03-12' AS date), 2016, 20161, 201603, 2016071, 1, 3, 71, 11, 6, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-11' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-05' AS date), CAST(N'2016-03-11' AS date), 1052, 3158, 13731, 13732, 13732, 13732, 13732, 13732, 13731, 2457459, 57458, N'2016-03-11', 201610, 10, 5, N'2016-W10', N'2016-W10-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96129, CAST(N'2016-03-12' AS date), CAST(N'2016-03-13' AS date), 2016, 20161, 201603, 2016072, 1, 3, 72, 12, 7, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-06' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-11' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-18' AS date), 1052, 3158, 13731, 13732, 13732, 13732, 13732, 13732, 13732, 2457460, 57459, N'2016-03-12', 201610, 10, 6, N'2016-W10', N'2016-W10-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96130, CAST(N'2016-03-13' AS date), CAST(N'2016-03-14' AS date), 2016, 20161, 201603, 2016073, 1, 3, 73, 13, 1, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-07' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-11' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-18' AS date), 1052, 3158, 13732, 13732, 13732, 13732, 13732, 13732, 13732, 2457461, 57460, N'2016-03-13', 201610, 10, 7, N'2016-W10', N'2016-W10-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96131, CAST(N'2016-03-14' AS date), CAST(N'2016-03-15' AS date), 2016, 20161, 201603, 2016074, 1, 3, 74, 14, 2, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-08' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-11' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-18' AS date), 1052, 3158, 13732, 13733, 13732, 13732, 13732, 13732, 13732, 2457462, 57461, N'2016-03-14', 201611, 11, 1, N'2016-W11', N'2016-W11-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96132, CAST(N'2016-03-15' AS date), CAST(N'2016-03-16' AS date), 2016, 20161, 201603, 2016075, 1, 3, 75, 15, 3, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-09' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-11' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-18' AS date), 1052, 3158, 13732, 13733, 13733, 13732, 13732, 13732, 13732, 2457463, 57462, N'2016-03-15', 201611, 11, 2, N'2016-W11', N'2016-W11-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96133, CAST(N'2016-03-16' AS date), CAST(N'2016-03-17' AS date), 2016, 20161, 201603, 2016076, 1, 3, 76, 16, 4, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-10' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-11' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-18' AS date), 1052, 3158, 13732, 13733, 13733, 13733, 13732, 13732, 13732, 2457464, 57463, N'2016-03-16', 201611, 11, 3, N'2016-W11', N'2016-W11-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96134, CAST(N'2016-03-17' AS date), CAST(N'2016-03-18' AS date), 2016, 20161, 201603, 2016077, 1, 3, 77, 17, 5, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-11' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-18' AS date), 1052, 3158, 13732, 13733, 13733, 13733, 13733, 13732, 13732, 2457465, 57464, N'2016-03-17', 201611, 11, 4, N'2016-W11', N'2016-W11-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96135, CAST(N'2016-03-18' AS date), CAST(N'2016-03-19' AS date), 2016, 20161, 201603, 2016078, 1, 3, 78, 18, 6, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-18' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-12' AS date), CAST(N'2016-03-18' AS date), 1052, 3158, 13732, 13733, 13733, 13733, 13733, 13733, 13732, 2457466, 57465, N'2016-03-18', 201611, 11, 5, N'2016-W11', N'2016-W11-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96136, CAST(N'2016-03-19' AS date), CAST(N'2016-03-20' AS date), 2016, 20161, 201603, 2016079, 1, 3, 79, 19, 7, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-13' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-18' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-25' AS date), 1052, 3158, 13732, 13733, 13733, 13733, 13733, 13733, 13733, 2457467, 57466, N'2016-03-19', 201611, 11, 6, N'2016-W11', N'2016-W11-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96137, CAST(N'2016-03-20' AS date), CAST(N'2016-03-21' AS date), 2016, 20161, 201603, 2016080, 1, 3, 80, 20, 1, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-03-14' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-18' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-25' AS date), 1052, 3158, 13733, 13733, 13733, 13733, 13733, 13733, 13733, 2457468, 57467, N'2016-03-20', 201611, 11, 7, N'2016-W11', N'2016-W11-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96138, CAST(N'2016-03-21' AS date), CAST(N'2016-03-22' AS date), 2016, 20161, 201603, 2016081, 1, 3, 81, 21, 2, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-03-15' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-18' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-25' AS date), 1052, 3158, 13733, 13734, 13733, 13733, 13733, 13733, 13733, 2457469, 57468, N'2016-03-21', 201612, 12, 1, N'2016-W12', N'2016-W12-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96139, CAST(N'2016-03-22' AS date), CAST(N'2016-03-23' AS date), 2016, 20161, 201603, 2016082, 1, 3, 82, 22, 3, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-03-16' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-18' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-25' AS date), 1052, 3158, 13733, 13734, 13734, 13733, 13733, 13733, 13733, 2457470, 57469, N'2016-03-22', 201612, 12, 2, N'2016-W12', N'2016-W12-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96140, CAST(N'2016-03-23' AS date), CAST(N'2016-03-24' AS date), 2016, 20161, 201603, 2016083, 1, 3, 83, 23, 4, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-03-17' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-18' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-25' AS date), 1052, 3158, 13733, 13734, 13734, 13734, 13733, 13733, 13733, 2457471, 57470, N'2016-03-23', 201612, 12, 3, N'2016-W12', N'2016-W12-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96141, CAST(N'2016-03-24' AS date), CAST(N'2016-03-25' AS date), 2016, 20161, 201603, 2016084, 1, 3, 84, 24, 5, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-03-18' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-25' AS date), 1052, 3158, 13733, 13734, 13734, 13734, 13734, 13733, 13733, 2457472, 57471, N'2016-03-24', 201612, 12, 4, N'2016-W12', N'2016-W12-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96142, CAST(N'2016-03-25' AS date), CAST(N'2016-03-26' AS date), 2016, 20161, 201603, 2016085, 1, 3, 85, 25, 6, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-03-25' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-19' AS date), CAST(N'2016-03-25' AS date), 1052, 3158, 13733, 13734, 13734, 13734, 13734, 13734, 13733, 2457473, 57472, N'2016-03-25', 201612, 12, 5, N'2016-W12', N'2016-W12-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96143, CAST(N'2016-03-26' AS date), CAST(N'2016-03-27' AS date), 2016, 20161, 201603, 2016086, 1, 3, 86, 26, 7, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-20' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-03-25' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-04-01' AS date), 1052, 3158, 13733, 13734, 13734, 13734, 13734, 13734, 13734, 2457474, 57473, N'2016-03-26', 201612, 12, 6, N'2016-W12', N'2016-W12-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96144, CAST(N'2016-03-27' AS date), CAST(N'2016-03-28' AS date), 2016, 20161, 201603, 2016087, 1, 3, 87, 27, 1, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-03-21' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-03-25' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-04-01' AS date), 1052, 3158, 13734, 13734, 13734, 13734, 13734, 13734, 13734, 2457475, 57474, N'2016-03-27', 201612, 12, 7, N'2016-W12', N'2016-W12-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96145, CAST(N'2016-03-28' AS date), CAST(N'2016-03-29' AS date), 2016, 20161, 201603, 2016088, 1, 3, 88, 28, 2, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-03-22' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-03-25' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-04-01' AS date), 1052, 3158, 13734, 13735, 13734, 13734, 13734, 13734, 13734, 2457476, 57475, N'2016-03-28', 201613, 13, 1, N'2016-W13', N'2016-W13-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96146, CAST(N'2016-03-29' AS date), CAST(N'2016-03-30' AS date), 2016, 20161, 201603, 2016089, 1, 3, 89, 29, 3, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-03-23' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-03-25' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-04-01' AS date), 1052, 3158, 13734, 13735, 13735, 13734, 13734, 13734, 13734, 2457477, 57476, N'2016-03-29', 201613, 13, 2, N'2016-W13', N'2016-W13-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96147, CAST(N'2016-03-30' AS date), CAST(N'2016-03-31' AS date), 2016, 20161, 201603, 2016090, 1, 3, 90, 30, 4, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-03-24' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-03-25' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-04-01' AS date), 1052, 3158, 13734, 13735, 13735, 13735, 13734, 13734, 13734, 2457478, 57477, N'2016-03-30', 201613, 13, 3, N'2016-W13', N'2016-W13-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96148, CAST(N'2016-03-31' AS date), CAST(N'2016-04-01' AS date), 2016, 20161, 201603, 2016091, 1, 3, 91, 31, 5, N'2016', N'2016 Q1', N'2016 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-01-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-01' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-03-25' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-04-01' AS date), 1052, 3158, 13734, 13735, 13735, 13735, 13735, 13734, 13734, 2457479, 57478, N'2016-03-31', 201613, 13, 4, N'2016-W13', N'2016-W13-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96149, CAST(N'2016-04-01' AS date), CAST(N'2016-04-02' AS date), 2016, 20162, 201604, 2016092, 2, 4, 92, 1, 6, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-03-26' AS date), CAST(N'2016-04-01' AS date), 1053, 3159, 13734, 13735, 13735, 13735, 13735, 13735, 13734, 2457480, 57479, N'2016-04-01', 201613, 13, 5, N'2016-W13', N'2016-W13-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96150, CAST(N'2016-04-02' AS date), CAST(N'2016-04-03' AS date), 2016, 20162, 201604, 2016093, 2, 4, 93, 2, 7, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-03-27' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-04-08' AS date), 1053, 3159, 13734, 13735, 13735, 13735, 13735, 13735, 13735, 2457481, 57480, N'2016-04-02', 201613, 13, 6, N'2016-W13', N'2016-W13-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96151, CAST(N'2016-04-03' AS date), CAST(N'2016-04-04' AS date), 2016, 20162, 201604, 2016094, 2, 4, 94, 3, 1, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-03-28' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-04-08' AS date), 1053, 3159, 13735, 13735, 13735, 13735, 13735, 13735, 13735, 2457482, 57481, N'2016-04-03', 201613, 13, 7, N'2016-W13', N'2016-W13-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96152, CAST(N'2016-04-04' AS date), CAST(N'2016-04-05' AS date), 2016, 20162, 201604, 2016095, 2, 4, 95, 4, 2, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-03-29' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-04-08' AS date), 1053, 3159, 13735, 13736, 13735, 13735, 13735, 13735, 13735, 2457483, 57482, N'2016-04-04', 201614, 14, 1, N'2016-W14', N'2016-W14-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96153, CAST(N'2016-04-05' AS date), CAST(N'2016-04-06' AS date), 2016, 20162, 201604, 2016096, 2, 4, 96, 5, 3, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-03-30' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-04-08' AS date), 1053, 3159, 13735, 13736, 13736, 13735, 13735, 13735, 13735, 2457484, 57483, N'2016-04-05', 201614, 14, 2, N'2016-W14', N'2016-W14-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96154, CAST(N'2016-04-06' AS date), CAST(N'2016-04-07' AS date), 2016, 20162, 201604, 2016097, 2, 4, 97, 6, 4, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-03-31' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-04-08' AS date), 1053, 3159, 13735, 13736, 13736, 13736, 13735, 13735, 13735, 2457485, 57484, N'2016-04-06', 201614, 14, 3, N'2016-W14', N'2016-W14-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96155, CAST(N'2016-04-07' AS date), CAST(N'2016-04-08' AS date), 2016, 20162, 201604, 2016098, 2, 4, 98, 7, 5, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-04-08' AS date), 1053, 3159, 13735, 13736, 13736, 13736, 13736, 13735, 13735, 2457486, 57485, N'2016-04-07', 201614, 14, 4, N'2016-W14', N'2016-W14-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96156, CAST(N'2016-04-08' AS date), CAST(N'2016-04-09' AS date), 2016, 20162, 201604, 2016099, 2, 4, 99, 8, 6, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-08' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-02' AS date), CAST(N'2016-04-08' AS date), 1053, 3159, 13735, 13736, 13736, 13736, 13736, 13736, 13735, 2457487, 57486, N'2016-04-08', 201614, 14, 5, N'2016-W14', N'2016-W14-5');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96157, CAST(N'2016-04-09' AS date), CAST(N'2016-04-10' AS date), 2016, 20162, 201604, 2016100, 2, 4, 100, 9, 7, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-03' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-08' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-15' AS date), 1053, 3159, 13735, 13736, 13736, 13736, 13736, 13736, 13736, 2457488, 57487, N'2016-04-09', 201614, 14, 6, N'2016-W14', N'2016-W14-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96158, CAST(N'2016-04-10' AS date), CAST(N'2016-04-11' AS date), 2016, 20162, 201604, 2016101, 2, 4, 101, 10, 1, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-04' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-08' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-15' AS date), 1053, 3159, 13736, 13736, 13736, 13736, 13736, 13736, 13736, 2457489, 57488, N'2016-04-10', 201614, 14, 7, N'2016-W14', N'2016-W14-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96159, CAST(N'2016-04-11' AS date), CAST(N'2016-04-12' AS date), 2016, 20162, 201604, 2016102, 2, 4, 102, 11, 2, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-05' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-08' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-15' AS date), 1053, 3159, 13736, 13737, 13736, 13736, 13736, 13736, 13736, 2457490, 57489, N'2016-04-11', 201615, 15, 1, N'2016-W15', N'2016-W15-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96160, CAST(N'2016-04-12' AS date), CAST(N'2016-04-13' AS date), 2016, 20162, 201604, 2016103, 2, 4, 103, 12, 3, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-06' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-08' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-15' AS date), 1053, 3159, 13736, 13737, 13737, 13736, 13736, 13736, 13736, 2457491, 57490, N'2016-04-12', 201615, 15, 2, N'2016-W15', N'2016-W15-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96161, CAST(N'2016-04-13' AS date), CAST(N'2016-04-14' AS date), 2016, 20162, 201604, 2016104, 2, 4, 104, 13, 4, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-07' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-08' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-15' AS date), 1053, 3159, 13736, 13737, 13737, 13737, 13736, 13736, 13736, 2457492, 57491, N'2016-04-13', 201615, 15, 3, N'2016-W15', N'2016-W15-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96162, CAST(N'2016-04-14' AS date), CAST(N'2016-04-15' AS date), 2016, 20162, 201604, 2016105, 2, 4, 105, 14, 5, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-08' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-15' AS date), 1053, 3159, 13736, 13737, 13737, 13737, 13737, 13736, 13736, 2457493, 57492, N'2016-04-14', 201615, 15, 4, N'2016-W15', N'2016-W15-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96163, CAST(N'2016-04-15' AS date), CAST(N'2016-04-16' AS date), 2016, 20162, 201604, 2016106, 2, 4, 106, 15, 6, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-15' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-09' AS date), CAST(N'2016-04-15' AS date), 1053, 3159, 13736, 13737, 13737, 13737, 13737, 13737, 13736, 2457494, 57493, N'2016-04-15', 201615, 15, 5, N'2016-W15', N'2016-W15-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96164, CAST(N'2016-04-16' AS date), CAST(N'2016-04-17' AS date), 2016, 20162, 201604, 2016107, 2, 4, 107, 16, 7, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-10' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-15' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-22' AS date), 1053, 3159, 13736, 13737, 13737, 13737, 13737, 13737, 13737, 2457495, 57494, N'2016-04-16', 201615, 15, 6, N'2016-W15', N'2016-W15-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96165, CAST(N'2016-04-17' AS date), CAST(N'2016-04-18' AS date), 2016, 20162, 201604, 2016108, 2, 4, 108, 17, 1, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-11' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-15' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-22' AS date), 1053, 3159, 13737, 13737, 13737, 13737, 13737, 13737, 13737, 2457496, 57495, N'2016-04-17', 201615, 15, 7, N'2016-W15', N'2016-W15-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96166, CAST(N'2016-04-18' AS date), CAST(N'2016-04-19' AS date), 2016, 20162, 201604, 2016109, 2, 4, 109, 18, 2, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-12' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-15' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-22' AS date), 1053, 3159, 13737, 13738, 13737, 13737, 13737, 13737, 13737, 2457497, 57496, N'2016-04-18', 201616, 16, 1, N'2016-W16', N'2016-W16-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96167, CAST(N'2016-04-19' AS date), CAST(N'2016-04-20' AS date), 2016, 20162, 201604, 2016110, 2, 4, 110, 19, 3, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-04-13' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-15' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-22' AS date), 1053, 3159, 13737, 13738, 13738, 13737, 13737, 13737, 13737, 2457498, 57497, N'2016-04-19', 201616, 16, 2, N'2016-W16', N'2016-W16-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96168, CAST(N'2016-04-20' AS date), CAST(N'2016-04-21' AS date), 2016, 20162, 201604, 2016111, 2, 4, 111, 20, 4, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-04-14' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-15' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-22' AS date), 1053, 3159, 13737, 13738, 13738, 13738, 13737, 13737, 13737, 2457499, 57498, N'2016-04-20', 201616, 16, 3, N'2016-W16', N'2016-W16-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96169, CAST(N'2016-04-21' AS date), CAST(N'2016-04-22' AS date), 2016, 20162, 201604, 2016112, 2, 4, 112, 21, 5, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-04-15' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-22' AS date), 1053, 3159, 13737, 13738, 13738, 13738, 13738, 13737, 13737, 2457500, 57499, N'2016-04-21', 201616, 16, 4, N'2016-W16', N'2016-W16-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96170, CAST(N'2016-04-22' AS date), CAST(N'2016-04-23' AS date), 2016, 20162, 201604, 2016113, 2, 4, 113, 22, 6, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-04-22' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-04-16' AS date), CAST(N'2016-04-22' AS date), 1053, 3159, 13737, 13738, 13738, 13738, 13738, 13738, 13737, 2457501, 57500, N'2016-04-22', 201616, 16, 5, N'2016-W16', N'2016-W16-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96171, CAST(N'2016-04-23' AS date), CAST(N'2016-04-24' AS date), 2016, 20162, 201604, 2016114, 2, 4, 114, 23, 7, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-17' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-04-22' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-29' AS date), 1053, 3159, 13737, 13738, 13738, 13738, 13738, 13738, 13738, 2457502, 57501, N'2016-04-23', 201616, 16, 6, N'2016-W16', N'2016-W16-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96172, CAST(N'2016-04-24' AS date), CAST(N'2016-04-25' AS date), 2016, 20162, 201604, 2016115, 2, 4, 115, 24, 1, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-18' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-04-22' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-29' AS date), 1053, 3159, 13738, 13738, 13738, 13738, 13738, 13738, 13738, 2457503, 57502, N'2016-04-24', 201616, 16, 7, N'2016-W16', N'2016-W16-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96173, CAST(N'2016-04-25' AS date), CAST(N'2016-04-26' AS date), 2016, 20162, 201604, 2016116, 2, 4, 116, 25, 2, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-04-19' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-04-22' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-29' AS date), 1053, 3159, 13738, 13739, 13738, 13738, 13738, 13738, 13738, 2457504, 57503, N'2016-04-25', 201617, 17, 1, N'2016-W17', N'2016-W17-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96174, CAST(N'2016-04-26' AS date), CAST(N'2016-04-27' AS date), 2016, 20162, 201604, 2016117, 2, 4, 117, 26, 3, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-04-20' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-04-22' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-29' AS date), 1053, 3159, 13738, 13739, 13739, 13738, 13738, 13738, 13738, 2457505, 57504, N'2016-04-26', 201617, 17, 2, N'2016-W17', N'2016-W17-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96175, CAST(N'2016-04-27' AS date), CAST(N'2016-04-28' AS date), 2016, 20162, 201604, 2016118, 2, 4, 118, 27, 4, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-04-21' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-04-22' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-29' AS date), 1053, 3159, 13738, 13739, 13739, 13739, 13738, 13738, 13738, 2457506, 57505, N'2016-04-27', 201617, 17, 3, N'2016-W17', N'2016-W17-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96176, CAST(N'2016-04-28' AS date), CAST(N'2016-04-29' AS date), 2016, 20162, 201604, 2016119, 2, 4, 119, 28, 5, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-04-22' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-29' AS date), 1053, 3159, 13738, 13739, 13739, 13739, 13739, 13738, 13738, 2457507, 57506, N'2016-04-28', 201617, 17, 4, N'2016-W17', N'2016-W17-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96177, CAST(N'2016-04-29' AS date), CAST(N'2016-04-30' AS date), 2016, 20162, 201604, 2016120, 2, 4, 120, 29, 6, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-04-29' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-04-23' AS date), CAST(N'2016-04-29' AS date), 1053, 3159, 13738, 13739, 13739, 13739, 13739, 13739, 13738, 2457508, 57507, N'2016-04-29', 201617, 17, 5, N'2016-W17', N'2016-W17-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96178, CAST(N'2016-04-30' AS date), CAST(N'2016-05-01' AS date), 2016, 20162, 201604, 2016121, 2, 4, 121, 30, 7, N'2016', N'2016 Q2', N'2016 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-24' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-04-29' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-05-06' AS date), 1053, 3159, 13738, 13739, 13739, 13739, 13739, 13739, 13739, 2457509, 57508, N'2016-04-30', 201617, 17, 6, N'2016-W17', N'2016-W17-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96179, CAST(N'2016-05-01' AS date), CAST(N'2016-05-02' AS date), 2016, 20162, 201605, 2016122, 2, 5, 122, 1, 1, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-04-25' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-04-29' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-05-06' AS date), 1053, 3160, 13739, 13739, 13739, 13739, 13739, 13739, 13739, 2457510, 57509, N'2016-05-01', 201617, 17, 7, N'2016-W17', N'2016-W17-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96180, CAST(N'2016-05-02' AS date), CAST(N'2016-05-03' AS date), 2016, 20162, 201605, 2016123, 2, 5, 123, 2, 2, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-04-26' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-04-29' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-05-06' AS date), 1053, 3160, 13739, 13740, 13739, 13739, 13739, 13739, 13739, 2457511, 57510, N'2016-05-02', 201618, 18, 1, N'2016-W18', N'2016-W18-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96181, CAST(N'2016-05-03' AS date), CAST(N'2016-05-04' AS date), 2016, 20162, 201605, 2016124, 2, 5, 124, 3, 3, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-04-27' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-04-29' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-05-06' AS date), 1053, 3160, 13739, 13740, 13740, 13739, 13739, 13739, 13739, 2457512, 57511, N'2016-05-03', 201618, 18, 2, N'2016-W18', N'2016-W18-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96182, CAST(N'2016-05-04' AS date), CAST(N'2016-05-05' AS date), 2016, 20162, 201605, 2016125, 2, 5, 125, 4, 4, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-04-28' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-04-29' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-05-06' AS date), 1053, 3160, 13739, 13740, 13740, 13740, 13739, 13739, 13739, 2457513, 57512, N'2016-05-04', 201618, 18, 3, N'2016-W18', N'2016-W18-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96183, CAST(N'2016-05-05' AS date), CAST(N'2016-05-06' AS date), 2016, 20162, 201605, 2016126, 2, 5, 126, 5, 5, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-04-29' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-05-06' AS date), 1053, 3160, 13739, 13740, 13740, 13740, 13740, 13739, 13739, 2457514, 57513, N'2016-05-05', 201618, 18, 4, N'2016-W18', N'2016-W18-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96184, CAST(N'2016-05-06' AS date), CAST(N'2016-05-07' AS date), 2016, 20162, 201605, 2016127, 2, 5, 127, 6, 6, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-06' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-04-30' AS date), CAST(N'2016-05-06' AS date), 1053, 3160, 13739, 13740, 13740, 13740, 13740, 13740, 13739, 2457515, 57514, N'2016-05-06', 201618, 18, 5, N'2016-W18', N'2016-W18-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96185, CAST(N'2016-05-07' AS date), CAST(N'2016-05-08' AS date), 2016, 20162, 201605, 2016128, 2, 5, 128, 7, 7, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-06' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-13' AS date), 1053, 3160, 13739, 13740, 13740, 13740, 13740, 13740, 13740, 2457516, 57515, N'2016-05-07', 201618, 18, 6, N'2016-W18', N'2016-W18-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96186, CAST(N'2016-05-08' AS date), CAST(N'2016-05-09' AS date), 2016, 20162, 201605, 2016129, 2, 5, 129, 8, 1, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-02' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-06' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-13' AS date), 1053, 3160, 13740, 13740, 13740, 13740, 13740, 13740, 13740, 2457517, 57516, N'2016-05-08', 201618, 18, 7, N'2016-W18', N'2016-W18-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96187, CAST(N'2016-05-09' AS date), CAST(N'2016-05-10' AS date), 2016, 20162, 201605, 2016130, 2, 5, 130, 9, 2, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-03' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-06' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-13' AS date), 1053, 3160, 13740, 13741, 13740, 13740, 13740, 13740, 13740, 2457518, 57517, N'2016-05-09', 201619, 19, 1, N'2016-W19', N'2016-W19-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96188, CAST(N'2016-05-10' AS date), CAST(N'2016-05-11' AS date), 2016, 20162, 201605, 2016131, 2, 5, 131, 10, 3, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-04' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-06' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-13' AS date), 1053, 3160, 13740, 13741, 13741, 13740, 13740, 13740, 13740, 2457519, 57518, N'2016-05-10', 201619, 19, 2, N'2016-W19', N'2016-W19-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96189, CAST(N'2016-05-11' AS date), CAST(N'2016-05-12' AS date), 2016, 20162, 201605, 2016132, 2, 5, 132, 11, 4, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-05' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-06' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-13' AS date), 1053, 3160, 13740, 13741, 13741, 13741, 13740, 13740, 13740, 2457520, 57519, N'2016-05-11', 201619, 19, 3, N'2016-W19', N'2016-W19-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96190, CAST(N'2016-05-12' AS date), CAST(N'2016-05-13' AS date), 2016, 20162, 201605, 2016133, 2, 5, 133, 12, 5, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-06' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-13' AS date), 1053, 3160, 13740, 13741, 13741, 13741, 13741, 13740, 13740, 2457521, 57520, N'2016-05-12', 201619, 19, 4, N'2016-W19', N'2016-W19-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96191, CAST(N'2016-05-13' AS date), CAST(N'2016-05-14' AS date), 2016, 20162, 201605, 2016134, 2, 5, 134, 13, 6, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-13' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-07' AS date), CAST(N'2016-05-13' AS date), 1053, 3160, 13740, 13741, 13741, 13741, 13741, 13741, 13740, 2457522, 57521, N'2016-05-13', 201619, 19, 5, N'2016-W19', N'2016-W19-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96192, CAST(N'2016-05-14' AS date), CAST(N'2016-05-15' AS date), 2016, 20162, 201605, 2016135, 2, 5, 135, 14, 7, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-08' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-13' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-20' AS date), 1053, 3160, 13740, 13741, 13741, 13741, 13741, 13741, 13741, 2457523, 57522, N'2016-05-14', 201619, 19, 6, N'2016-W19', N'2016-W19-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96193, CAST(N'2016-05-15' AS date), CAST(N'2016-05-16' AS date), 2016, 20162, 201605, 2016136, 2, 5, 136, 15, 1, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-09' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-13' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-20' AS date), 1053, 3160, 13741, 13741, 13741, 13741, 13741, 13741, 13741, 2457524, 57523, N'2016-05-15', 201619, 19, 7, N'2016-W19', N'2016-W19-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96194, CAST(N'2016-05-16' AS date), CAST(N'2016-05-17' AS date), 2016, 20162, 201605, 2016137, 2, 5, 137, 16, 2, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-10' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-13' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-20' AS date), 1053, 3160, 13741, 13742, 13741, 13741, 13741, 13741, 13741, 2457525, 57524, N'2016-05-16', 201620, 20, 1, N'2016-W20', N'2016-W20-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96195, CAST(N'2016-05-17' AS date), CAST(N'2016-05-18' AS date), 2016, 20162, 201605, 2016138, 2, 5, 138, 17, 3, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-11' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-13' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-20' AS date), 1053, 3160, 13741, 13742, 13742, 13741, 13741, 13741, 13741, 2457526, 57525, N'2016-05-17', 201620, 20, 2, N'2016-W20', N'2016-W20-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96196, CAST(N'2016-05-18' AS date), CAST(N'2016-05-19' AS date), 2016, 20162, 201605, 2016139, 2, 5, 139, 18, 4, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-12' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-13' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-20' AS date), 1053, 3160, 13741, 13742, 13742, 13742, 13741, 13741, 13741, 2457527, 57526, N'2016-05-18', 201620, 20, 3, N'2016-W20', N'2016-W20-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96197, CAST(N'2016-05-19' AS date), CAST(N'2016-05-20' AS date), 2016, 20162, 201605, 2016140, 2, 5, 140, 19, 5, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-13' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-20' AS date), 1053, 3160, 13741, 13742, 13742, 13742, 13742, 13741, 13741, 2457528, 57527, N'2016-05-19', 201620, 20, 4, N'2016-W20', N'2016-W20-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96198, CAST(N'2016-05-20' AS date), CAST(N'2016-05-21' AS date), 2016, 20162, 201605, 2016141, 2, 5, 141, 20, 6, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-20' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-05-14' AS date), CAST(N'2016-05-20' AS date), 1053, 3160, 13741, 13742, 13742, 13742, 13742, 13742, 13741, 2457529, 57528, N'2016-05-20', 201620, 20, 5, N'2016-W20', N'2016-W20-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96199, CAST(N'2016-05-21' AS date), CAST(N'2016-05-22' AS date), 2016, 20162, 201605, 2016142, 2, 5, 142, 21, 7, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-15' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-20' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-27' AS date), 1053, 3160, 13741, 13742, 13742, 13742, 13742, 13742, 13742, 2457530, 57529, N'2016-05-21', 201620, 20, 6, N'2016-W20', N'2016-W20-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96200, CAST(N'2016-05-22' AS date), CAST(N'2016-05-23' AS date), 2016, 20162, 201605, 2016143, 2, 5, 143, 22, 1, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-05-16' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-20' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-27' AS date), 1053, 3160, 13742, 13742, 13742, 13742, 13742, 13742, 13742, 2457531, 57530, N'2016-05-22', 201620, 20, 7, N'2016-W20', N'2016-W20-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96201, CAST(N'2016-05-23' AS date), CAST(N'2016-05-24' AS date), 2016, 20162, 201605, 2016144, 2, 5, 144, 23, 2, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-05-17' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-20' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-27' AS date), 1053, 3160, 13742, 13743, 13742, 13742, 13742, 13742, 13742, 2457532, 57531, N'2016-05-23', 201621, 21, 1, N'2016-W21', N'2016-W21-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96202, CAST(N'2016-05-24' AS date), CAST(N'2016-05-25' AS date), 2016, 20162, 201605, 2016145, 2, 5, 145, 24, 3, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-05-18' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-20' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-27' AS date), 1053, 3160, 13742, 13743, 13743, 13742, 13742, 13742, 13742, 2457533, 57532, N'2016-05-24', 201621, 21, 2, N'2016-W21', N'2016-W21-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96203, CAST(N'2016-05-25' AS date), CAST(N'2016-05-26' AS date), 2016, 20162, 201605, 2016146, 2, 5, 146, 25, 4, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-19' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-20' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-27' AS date), 1053, 3160, 13742, 13743, 13743, 13743, 13742, 13742, 13742, 2457534, 57533, N'2016-05-25', 201621, 21, 3, N'2016-W21', N'2016-W21-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96204, CAST(N'2016-05-26' AS date), CAST(N'2016-05-27' AS date), 2016, 20162, 201605, 2016147, 2, 5, 147, 26, 5, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-05-20' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-27' AS date), 1053, 3160, 13742, 13743, 13743, 13743, 13743, 13742, 13742, 2457535, 57534, N'2016-05-26', 201621, 21, 4, N'2016-W21', N'2016-W21-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96205, CAST(N'2016-05-27' AS date), CAST(N'2016-05-28' AS date), 2016, 20162, 201605, 2016148, 2, 5, 148, 27, 6, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-05-27' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-05-21' AS date), CAST(N'2016-05-27' AS date), 1053, 3160, 13742, 13743, 13743, 13743, 13743, 13743, 13742, 2457536, 57535, N'2016-05-27', 201621, 21, 5, N'2016-W21', N'2016-W21-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96206, CAST(N'2016-05-28' AS date), CAST(N'2016-05-29' AS date), 2016, 20162, 201605, 2016149, 2, 5, 149, 28, 7, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-22' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-05-27' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-06-03' AS date), 1053, 3160, 13742, 13743, 13743, 13743, 13743, 13743, 13743, 2457537, 57536, N'2016-05-28', 201621, 21, 6, N'2016-W21', N'2016-W21-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96207, CAST(N'2016-05-29' AS date), CAST(N'2016-05-30' AS date), 2016, 20162, 201605, 2016150, 2, 5, 150, 29, 1, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-05-23' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-05-27' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-06-03' AS date), 1053, 3160, 13743, 13743, 13743, 13743, 13743, 13743, 13743, 2457538, 57537, N'2016-05-29', 201621, 21, 7, N'2016-W21', N'2016-W21-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96208, CAST(N'2016-05-30' AS date), CAST(N'2016-05-31' AS date), 2016, 20162, 201605, 2016151, 2, 5, 151, 30, 2, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-05-24' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-05-27' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-06-03' AS date), 1053, 3160, 13743, 13744, 13743, 13743, 13743, 13743, 13743, 2457539, 57538, N'2016-05-30', 201622, 22, 1, N'2016-W22', N'2016-W22-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96209, CAST(N'2016-05-31' AS date), CAST(N'2016-06-01' AS date), 2016, 20162, 201605, 2016152, 2, 5, 152, 31, 3, N'2016', N'2016 Q2', N'2016 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-01' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-05-25' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-05-27' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-06-03' AS date), 1053, 3160, 13743, 13744, 13744, 13743, 13743, 13743, 13743, 2457540, 57539, N'2016-05-31', 201622, 22, 2, N'2016-W22', N'2016-W22-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96210, CAST(N'2016-06-01' AS date), CAST(N'2016-06-02' AS date), 2016, 20162, 201606, 2016153, 2, 6, 153, 1, 4, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-05-26' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-05-27' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-06-03' AS date), 1053, 3161, 13743, 13744, 13744, 13744, 13743, 13743, 13743, 2457541, 57540, N'2016-06-01', 201622, 22, 3, N'2016-W22', N'2016-W22-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96211, CAST(N'2016-06-02' AS date), CAST(N'2016-06-03' AS date), 2016, 20162, 201606, 2016154, 2, 6, 154, 2, 5, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-05-27' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-06-03' AS date), 1053, 3161, 13743, 13744, 13744, 13744, 13744, 13743, 13743, 2457542, 57541, N'2016-06-02', 201622, 22, 4, N'2016-W22', N'2016-W22-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96212, CAST(N'2016-06-03' AS date), CAST(N'2016-06-04' AS date), 2016, 20162, 201606, 2016155, 2, 6, 155, 3, 6, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-03' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-05-28' AS date), CAST(N'2016-06-03' AS date), 1053, 3161, 13743, 13744, 13744, 13744, 13744, 13744, 13743, 2457543, 57542, N'2016-06-03', 201622, 22, 5, N'2016-W22', N'2016-W22-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96213, CAST(N'2016-06-04' AS date), CAST(N'2016-06-05' AS date), 2016, 20162, 201606, 2016156, 2, 6, 156, 4, 7, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-05-29' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-03' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-06-10' AS date), 1053, 3161, 13743, 13744, 13744, 13744, 13744, 13744, 13744, 2457544, 57543, N'2016-06-04', 201622, 22, 6, N'2016-W22', N'2016-W22-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96214, CAST(N'2016-06-05' AS date), CAST(N'2016-06-06' AS date), 2016, 20162, 201606, 2016157, 2, 6, 157, 5, 1, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-05-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-03' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-06-10' AS date), 1053, 3161, 13744, 13744, 13744, 13744, 13744, 13744, 13744, 2457545, 57544, N'2016-06-05', 201622, 22, 7, N'2016-W22', N'2016-W22-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96215, CAST(N'2016-06-06' AS date), CAST(N'2016-06-07' AS date), 2016, 20162, 201606, 2016158, 2, 6, 158, 6, 2, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-05-31' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-03' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-06-10' AS date), 1053, 3161, 13744, 13745, 13744, 13744, 13744, 13744, 13744, 2457546, 57545, N'2016-06-06', 201623, 23, 1, N'2016-W23', N'2016-W23-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96216, CAST(N'2016-06-07' AS date), CAST(N'2016-06-08' AS date), 2016, 20162, 201606, 2016159, 2, 6, 159, 7, 3, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-03' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-06-10' AS date), 1053, 3161, 13744, 13745, 13745, 13744, 13744, 13744, 13744, 2457547, 57546, N'2016-06-07', 201623, 23, 2, N'2016-W23', N'2016-W23-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96217, CAST(N'2016-06-08' AS date), CAST(N'2016-06-09' AS date), 2016, 20162, 201606, 2016160, 2, 6, 160, 8, 4, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-02' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-03' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-06-10' AS date), 1053, 3161, 13744, 13745, 13745, 13745, 13744, 13744, 13744, 2457548, 57547, N'2016-06-08', 201623, 23, 3, N'2016-W23', N'2016-W23-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96218, CAST(N'2016-06-09' AS date), CAST(N'2016-06-10' AS date), 2016, 20162, 201606, 2016161, 2, 6, 161, 9, 5, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-03' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-06-10' AS date), 1053, 3161, 13744, 13745, 13745, 13745, 13745, 13744, 13744, 2457549, 57548, N'2016-06-09', 201623, 23, 4, N'2016-W23', N'2016-W23-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96219, CAST(N'2016-06-10' AS date), CAST(N'2016-06-11' AS date), 2016, 20162, 201606, 2016162, 2, 6, 162, 10, 6, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-10' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-04' AS date), CAST(N'2016-06-10' AS date), 1053, 3161, 13744, 13745, 13745, 13745, 13745, 13745, 13744, 2457550, 57549, N'2016-06-10', 201623, 23, 5, N'2016-W23', N'2016-W23-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96220, CAST(N'2016-06-11' AS date), CAST(N'2016-06-12' AS date), 2016, 20162, 201606, 2016163, 2, 6, 163, 11, 7, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-05' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-10' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-17' AS date), 1053, 3161, 13744, 13745, 13745, 13745, 13745, 13745, 13745, 2457551, 57550, N'2016-06-11', 201623, 23, 6, N'2016-W23', N'2016-W23-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96221, CAST(N'2016-06-12' AS date), CAST(N'2016-06-13' AS date), 2016, 20162, 201606, 2016164, 2, 6, 164, 12, 1, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-06' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-10' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-17' AS date), 1053, 3161, 13745, 13745, 13745, 13745, 13745, 13745, 13745, 2457552, 57551, N'2016-06-12', 201623, 23, 7, N'2016-W23', N'2016-W23-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96222, CAST(N'2016-06-13' AS date), CAST(N'2016-06-14' AS date), 2016, 20162, 201606, 2016165, 2, 6, 165, 13, 2, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-07' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-10' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-17' AS date), 1053, 3161, 13745, 13746, 13745, 13745, 13745, 13745, 13745, 2457553, 57552, N'2016-06-13', 201624, 24, 1, N'2016-W24', N'2016-W24-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96223, CAST(N'2016-06-14' AS date), CAST(N'2016-06-15' AS date), 2016, 20162, 201606, 2016166, 2, 6, 166, 14, 3, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-08' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-10' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-17' AS date), 1053, 3161, 13745, 13746, 13746, 13745, 13745, 13745, 13745, 2457554, 57553, N'2016-06-14', 201624, 24, 2, N'2016-W24', N'2016-W24-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96224, CAST(N'2016-06-15' AS date), CAST(N'2016-06-16' AS date), 2016, 20162, 201606, 2016167, 2, 6, 167, 15, 4, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-09' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-10' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-17' AS date), 1053, 3161, 13745, 13746, 13746, 13746, 13745, 13745, 13745, 2457555, 57554, N'2016-06-15', 201624, 24, 3, N'2016-W24', N'2016-W24-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96225, CAST(N'2016-06-16' AS date), CAST(N'2016-06-17' AS date), 2016, 20162, 201606, 2016168, 2, 6, 168, 16, 5, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-10' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-17' AS date), 1053, 3161, 13745, 13746, 13746, 13746, 13746, 13745, 13745, 2457556, 57555, N'2016-06-16', 201624, 24, 4, N'2016-W24', N'2016-W24-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96226, CAST(N'2016-06-17' AS date), CAST(N'2016-06-18' AS date), 2016, 20162, 201606, 2016169, 2, 6, 169, 17, 6, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-17' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-11' AS date), CAST(N'2016-06-17' AS date), 1053, 3161, 13745, 13746, 13746, 13746, 13746, 13746, 13745, 2457557, 57556, N'2016-06-17', 201624, 24, 5, N'2016-W24', N'2016-W24-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96227, CAST(N'2016-06-18' AS date), CAST(N'2016-06-19' AS date), 2016, 20162, 201606, 2016170, 2, 6, 170, 18, 7, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-12' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-17' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-24' AS date), 1053, 3161, 13745, 13746, 13746, 13746, 13746, 13746, 13746, 2457558, 57557, N'2016-06-18', 201624, 24, 6, N'2016-W24', N'2016-W24-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96228, CAST(N'2016-06-19' AS date), CAST(N'2016-06-20' AS date), 2016, 20162, 201606, 2016171, 2, 6, 171, 19, 1, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-06-13' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-17' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-24' AS date), 1053, 3161, 13746, 13746, 13746, 13746, 13746, 13746, 13746, 2457559, 57558, N'2016-06-19', 201624, 24, 7, N'2016-W24', N'2016-W24-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96229, CAST(N'2016-06-20' AS date), CAST(N'2016-06-21' AS date), 2016, 20162, 201606, 2016172, 2, 6, 172, 20, 2, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-06-14' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-17' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-24' AS date), 1053, 3161, 13746, 13747, 13746, 13746, 13746, 13746, 13746, 2457560, 57559, N'2016-06-20', 201625, 25, 1, N'2016-W25', N'2016-W25-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96230, CAST(N'2016-06-21' AS date), CAST(N'2016-06-22' AS date), 2016, 20162, 201606, 2016173, 2, 6, 173, 21, 3, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-06-15' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-17' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-24' AS date), 1053, 3161, 13746, 13747, 13747, 13746, 13746, 13746, 13746, 2457561, 57560, N'2016-06-21', 201625, 25, 2, N'2016-W25', N'2016-W25-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96231, CAST(N'2016-06-22' AS date), CAST(N'2016-06-23' AS date), 2016, 20162, 201606, 2016174, 2, 6, 174, 22, 4, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-06-16' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-17' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-24' AS date), 1053, 3161, 13746, 13747, 13747, 13747, 13746, 13746, 13746, 2457562, 57561, N'2016-06-22', 201625, 25, 3, N'2016-W25', N'2016-W25-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96232, CAST(N'2016-06-23' AS date), CAST(N'2016-06-24' AS date), 2016, 20162, 201606, 2016175, 2, 6, 175, 23, 5, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-06-17' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-24' AS date), 1053, 3161, 13746, 13747, 13747, 13747, 13747, 13746, 13746, 2457563, 57562, N'2016-06-23', 201625, 25, 4, N'2016-W25', N'2016-W25-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96233, CAST(N'2016-06-24' AS date), CAST(N'2016-06-25' AS date), 2016, 20162, 201606, 2016176, 2, 6, 176, 24, 6, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-06-24' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-18' AS date), CAST(N'2016-06-24' AS date), 1053, 3161, 13746, 13747, 13747, 13747, 13747, 13747, 13746, 2457564, 57563, N'2016-06-24', 201625, 25, 5, N'2016-W25', N'2016-W25-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96234, CAST(N'2016-06-25' AS date), CAST(N'2016-06-26' AS date), 2016, 20162, 201606, 2016177, 2, 6, 177, 25, 7, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-19' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-06-24' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-07-01' AS date), 1053, 3161, 13746, 13747, 13747, 13747, 13747, 13747, 13747, 2457565, 57564, N'2016-06-25', 201625, 25, 6, N'2016-W25', N'2016-W25-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96235, CAST(N'2016-06-26' AS date), CAST(N'2016-06-27' AS date), 2016, 20162, 201606, 2016178, 2, 6, 178, 26, 1, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-06-20' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-06-24' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-07-01' AS date), 1053, 3161, 13747, 13747, 13747, 13747, 13747, 13747, 13747, 2457566, 57565, N'2016-06-26', 201625, 25, 7, N'2016-W25', N'2016-W25-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96236, CAST(N'2016-06-27' AS date), CAST(N'2016-06-28' AS date), 2016, 20162, 201606, 2016179, 2, 6, 179, 27, 2, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-06-21' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-06-24' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-07-01' AS date), 1053, 3161, 13747, 13748, 13747, 13747, 13747, 13747, 13747, 2457567, 57566, N'2016-06-27', 201626, 26, 1, N'2016-W26', N'2016-W26-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96237, CAST(N'2016-06-28' AS date), CAST(N'2016-06-29' AS date), 2016, 20162, 201606, 2016180, 2, 6, 180, 28, 3, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-06-22' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-06-24' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-07-01' AS date), 1053, 3161, 13747, 13748, 13748, 13747, 13747, 13747, 13747, 2457568, 57567, N'2016-06-28', 201626, 26, 2, N'2016-W26', N'2016-W26-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96238, CAST(N'2016-06-29' AS date), CAST(N'2016-06-30' AS date), 2016, 20162, 201606, 2016181, 2, 6, 181, 29, 4, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-06-23' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-06-24' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-07-01' AS date), 1053, 3161, 13747, 13748, 13748, 13748, 13747, 13747, 13747, 2457569, 57568, N'2016-06-29', 201626, 26, 3, N'2016-W26', N'2016-W26-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96239, CAST(N'2016-06-30' AS date), CAST(N'2016-07-01' AS date), 2016, 20162, 201606, 2016182, 2, 6, 182, 30, 5, N'2016', N'2016 Q2', N'2016 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-04-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-01' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-06-24' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-07-01' AS date), 1053, 3161, 13747, 13748, 13748, 13748, 13748, 13747, 13747, 2457570, 57569, N'2016-06-30', 201626, 26, 4, N'2016-W26', N'2016-W26-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96240, CAST(N'2016-07-01' AS date), CAST(N'2016-07-02' AS date), 2016, 20163, 201607, 2016183, 3, 7, 183, 1, 6, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-06-25' AS date), CAST(N'2016-07-01' AS date), 1054, 3162, 13747, 13748, 13748, 13748, 13748, 13748, 13747, 2457571, 57570, N'2016-07-01', 201626, 26, 5, N'2016-W26', N'2016-W26-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96241, CAST(N'2016-07-02' AS date), CAST(N'2016-07-03' AS date), 2016, 20163, 201607, 2016184, 3, 7, 184, 2, 7, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-06-26' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-07-08' AS date), 1054, 3162, 13747, 13748, 13748, 13748, 13748, 13748, 13748, 2457572, 57571, N'2016-07-02', 201626, 26, 6, N'2016-W26', N'2016-W26-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96242, CAST(N'2016-07-03' AS date), CAST(N'2016-07-04' AS date), 2016, 20163, 201607, 2016185, 3, 7, 185, 3, 1, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-06-27' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-07-08' AS date), 1054, 3162, 13748, 13748, 13748, 13748, 13748, 13748, 13748, 2457573, 57572, N'2016-07-03', 201626, 26, 7, N'2016-W26', N'2016-W26-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96243, CAST(N'2016-07-04' AS date), CAST(N'2016-07-05' AS date), 2016, 20163, 201607, 2016186, 3, 7, 186, 4, 2, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-06-28' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-07-08' AS date), 1054, 3162, 13748, 13749, 13748, 13748, 13748, 13748, 13748, 2457574, 57573, N'2016-07-04', 201627, 27, 1, N'2016-W27', N'2016-W27-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96244, CAST(N'2016-07-05' AS date), CAST(N'2016-07-06' AS date), 2016, 20163, 201607, 2016187, 3, 7, 187, 5, 3, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-06-29' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-07-08' AS date), 1054, 3162, 13748, 13749, 13749, 13748, 13748, 13748, 13748, 2457575, 57574, N'2016-07-05', 201627, 27, 2, N'2016-W27', N'2016-W27-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96245, CAST(N'2016-07-06' AS date), CAST(N'2016-07-07' AS date), 2016, 20163, 201607, 2016188, 3, 7, 188, 6, 4, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-06-30' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-07-08' AS date), 1054, 3162, 13748, 13749, 13749, 13749, 13748, 13748, 13748, 2457576, 57575, N'2016-07-06', 201627, 27, 3, N'2016-W27', N'2016-W27-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96246, CAST(N'2016-07-07' AS date), CAST(N'2016-07-08' AS date), 2016, 20163, 201607, 2016189, 3, 7, 189, 7, 5, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-07-08' AS date), 1054, 3162, 13748, 13749, 13749, 13749, 13749, 13748, 13748, 2457577, 57576, N'2016-07-07', 201627, 27, 4, N'2016-W27', N'2016-W27-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96247, CAST(N'2016-07-08' AS date), CAST(N'2016-07-09' AS date), 2016, 20163, 201607, 2016190, 3, 7, 190, 8, 6, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-08' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-02' AS date), CAST(N'2016-07-08' AS date), 1054, 3162, 13748, 13749, 13749, 13749, 13749, 13749, 13748, 2457578, 57577, N'2016-07-08', 201627, 27, 5, N'2016-W27', N'2016-W27-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96248, CAST(N'2016-07-09' AS date), CAST(N'2016-07-10' AS date), 2016, 20163, 201607, 2016191, 3, 7, 191, 9, 7, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-03' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-08' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-15' AS date), 1054, 3162, 13748, 13749, 13749, 13749, 13749, 13749, 13749, 2457579, 57578, N'2016-07-09', 201627, 27, 6, N'2016-W27', N'2016-W27-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96249, CAST(N'2016-07-10' AS date), CAST(N'2016-07-11' AS date), 2016, 20163, 201607, 2016192, 3, 7, 192, 10, 1, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-04' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-08' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-15' AS date), 1054, 3162, 13749, 13749, 13749, 13749, 13749, 13749, 13749, 2457580, 57579, N'2016-07-10', 201627, 27, 7, N'2016-W27', N'2016-W27-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96250, CAST(N'2016-07-11' AS date), CAST(N'2016-07-12' AS date), 2016, 20163, 201607, 2016193, 3, 7, 193, 11, 2, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-05' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-08' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-15' AS date), 1054, 3162, 13749, 13750, 13749, 13749, 13749, 13749, 13749, 2457581, 57580, N'2016-07-11', 201628, 28, 1, N'2016-W28', N'2016-W28-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96251, CAST(N'2016-07-12' AS date), CAST(N'2016-07-13' AS date), 2016, 20163, 201607, 2016194, 3, 7, 194, 12, 3, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-06' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-08' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-15' AS date), 1054, 3162, 13749, 13750, 13750, 13749, 13749, 13749, 13749, 2457582, 57581, N'2016-07-12', 201628, 28, 2, N'2016-W28', N'2016-W28-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96252, CAST(N'2016-07-13' AS date), CAST(N'2016-07-14' AS date), 2016, 20163, 201607, 2016195, 3, 7, 195, 13, 4, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-07' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-08' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-15' AS date), 1054, 3162, 13749, 13750, 13750, 13750, 13749, 13749, 13749, 2457583, 57582, N'2016-07-13', 201628, 28, 3, N'2016-W28', N'2016-W28-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96253, CAST(N'2016-07-14' AS date), CAST(N'2016-07-15' AS date), 2016, 20163, 201607, 2016196, 3, 7, 196, 14, 5, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-08' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-15' AS date), 1054, 3162, 13749, 13750, 13750, 13750, 13750, 13749, 13749, 2457584, 57583, N'2016-07-14', 201628, 28, 4, N'2016-W28', N'2016-W28-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96254, CAST(N'2016-07-15' AS date), CAST(N'2016-07-16' AS date), 2016, 20163, 201607, 2016197, 3, 7, 197, 15, 6, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-15' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-09' AS date), CAST(N'2016-07-15' AS date), 1054, 3162, 13749, 13750, 13750, 13750, 13750, 13750, 13749, 2457585, 57584, N'2016-07-15', 201628, 28, 5, N'2016-W28', N'2016-W28-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96255, CAST(N'2016-07-16' AS date), CAST(N'2016-07-17' AS date), 2016, 20163, 201607, 2016198, 3, 7, 198, 16, 7, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-10' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-15' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-22' AS date), 1054, 3162, 13749, 13750, 13750, 13750, 13750, 13750, 13750, 2457586, 57585, N'2016-07-16', 201628, 28, 6, N'2016-W28', N'2016-W28-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96256, CAST(N'2016-07-17' AS date), CAST(N'2016-07-18' AS date), 2016, 20163, 201607, 2016199, 3, 7, 199, 17, 1, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-11' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-15' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-22' AS date), 1054, 3162, 13750, 13750, 13750, 13750, 13750, 13750, 13750, 2457587, 57586, N'2016-07-17', 201628, 28, 7, N'2016-W28', N'2016-W28-7');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96257, CAST(N'2016-07-18' AS date), CAST(N'2016-07-19' AS date), 2016, 20163, 201607, 2016200, 3, 7, 200, 18, 2, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-12' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-15' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-22' AS date), 1054, 3162, 13750, 13751, 13750, 13750, 13750, 13750, 13750, 2457588, 57587, N'2016-07-18', 201629, 29, 1, N'2016-W29', N'2016-W29-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96258, CAST(N'2016-07-19' AS date), CAST(N'2016-07-20' AS date), 2016, 20163, 201607, 2016201, 3, 7, 201, 19, 3, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-13' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-15' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-22' AS date), 1054, 3162, 13750, 13751, 13751, 13750, 13750, 13750, 13750, 2457589, 57588, N'2016-07-19', 201629, 29, 2, N'2016-W29', N'2016-W29-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96259, CAST(N'2016-07-20' AS date), CAST(N'2016-07-21' AS date), 2016, 20163, 201607, 2016202, 3, 7, 202, 20, 4, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-07-14' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-15' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-22' AS date), 1054, 3162, 13750, 13751, 13751, 13751, 13750, 13750, 13750, 2457590, 57589, N'2016-07-20', 201629, 29, 3, N'2016-W29', N'2016-W29-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96260, CAST(N'2016-07-21' AS date), CAST(N'2016-07-22' AS date), 2016, 20163, 201607, 2016203, 3, 7, 203, 21, 5, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-07-15' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-22' AS date), 1054, 3162, 13750, 13751, 13751, 13751, 13751, 13750, 13750, 2457591, 57590, N'2016-07-21', 201629, 29, 4, N'2016-W29', N'2016-W29-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96261, CAST(N'2016-07-22' AS date), CAST(N'2016-07-23' AS date), 2016, 20163, 201607, 2016204, 3, 7, 204, 22, 6, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-07-22' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-07-16' AS date), CAST(N'2016-07-22' AS date), 1054, 3162, 13750, 13751, 13751, 13751, 13751, 13751, 13750, 2457592, 57591, N'2016-07-22', 201629, 29, 5, N'2016-W29', N'2016-W29-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96262, CAST(N'2016-07-23' AS date), CAST(N'2016-07-24' AS date), 2016, 20163, 201607, 2016205, 3, 7, 205, 23, 7, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-17' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-07-22' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-29' AS date), 1054, 3162, 13750, 13751, 13751, 13751, 13751, 13751, 13751, 2457593, 57592, N'2016-07-23', 201629, 29, 6, N'2016-W29', N'2016-W29-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96263, CAST(N'2016-07-24' AS date), CAST(N'2016-07-25' AS date), 2016, 20163, 201607, 2016206, 3, 7, 206, 24, 1, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-07-18' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-07-22' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-29' AS date), 1054, 3162, 13751, 13751, 13751, 13751, 13751, 13751, 13751, 2457594, 57593, N'2016-07-24', 201629, 29, 7, N'2016-W29', N'2016-W29-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96264, CAST(N'2016-07-25' AS date), CAST(N'2016-07-26' AS date), 2016, 20163, 201607, 2016207, 3, 7, 207, 25, 2, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-19' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-07-22' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-29' AS date), 1054, 3162, 13751, 13752, 13751, 13751, 13751, 13751, 13751, 2457595, 57594, N'2016-07-25', 201630, 30, 1, N'2016-W30', N'2016-W30-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96265, CAST(N'2016-07-26' AS date), CAST(N'2016-07-27' AS date), 2016, 20163, 201607, 2016208, 3, 7, 208, 26, 3, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-07-20' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-07-22' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-29' AS date), 1054, 3162, 13751, 13752, 13752, 13751, 13751, 13751, 13751, 2457596, 57595, N'2016-07-26', 201630, 30, 2, N'2016-W30', N'2016-W30-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96266, CAST(N'2016-07-27' AS date), CAST(N'2016-07-28' AS date), 2016, 20163, 201607, 2016209, 3, 7, 209, 27, 4, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-07-21' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-07-22' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-29' AS date), 1054, 3162, 13751, 13752, 13752, 13752, 13751, 13751, 13751, 2457597, 57596, N'2016-07-27', 201630, 30, 3, N'2016-W30', N'2016-W30-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96267, CAST(N'2016-07-28' AS date), CAST(N'2016-07-29' AS date), 2016, 20163, 201607, 2016210, 3, 7, 210, 28, 5, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-07-22' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-29' AS date), 1054, 3162, 13751, 13752, 13752, 13752, 13752, 13751, 13751, 2457598, 57597, N'2016-07-28', 201630, 30, 4, N'2016-W30', N'2016-W30-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96268, CAST(N'2016-07-29' AS date), CAST(N'2016-07-30' AS date), 2016, 20163, 201607, 2016211, 3, 7, 211, 29, 6, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-07-29' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-07-23' AS date), CAST(N'2016-07-29' AS date), 1054, 3162, 13751, 13752, 13752, 13752, 13752, 13752, 13751, 2457599, 57598, N'2016-07-29', 201630, 30, 5, N'2016-W30', N'2016-W30-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96269, CAST(N'2016-07-30' AS date), CAST(N'2016-07-31' AS date), 2016, 20163, 201607, 2016212, 3, 7, 212, 30, 7, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-24' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-07-29' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-08-05' AS date), 1054, 3162, 13751, 13752, 13752, 13752, 13752, 13752, 13752, 2457600, 57599, N'2016-07-30', 201630, 30, 6, N'2016-W30', N'2016-W30-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96270, CAST(N'2016-07-31' AS date), CAST(N'2016-08-01' AS date), 2016, 20163, 201607, 2016213, 3, 7, 213, 31, 1, N'2016', N'2016 Q3', N'2016 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-07-25' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-07-29' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-08-05' AS date), 1054, 3162, 13752, 13752, 13752, 13752, 13752, 13752, 13752, 2457601, 57600, N'2016-07-31', 201630, 30, 7, N'2016-W30', N'2016-W30-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96271, CAST(N'2016-08-01' AS date), CAST(N'2016-08-02' AS date), 2016, 20163, 201608, 2016214, 3, 8, 214, 1, 2, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-07-26' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-07-29' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-08-05' AS date), 1054, 3163, 13752, 13753, 13752, 13752, 13752, 13752, 13752, 2457602, 57601, N'2016-08-01', 201631, 31, 1, N'2016-W31', N'2016-W31-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96272, CAST(N'2016-08-02' AS date), CAST(N'2016-08-03' AS date), 2016, 20163, 201608, 2016215, 3, 8, 215, 2, 3, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-07-27' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-07-29' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-08-05' AS date), 1054, 3163, 13752, 13753, 13753, 13752, 13752, 13752, 13752, 2457603, 57602, N'2016-08-02', 201631, 31, 2, N'2016-W31', N'2016-W31-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96273, CAST(N'2016-08-03' AS date), CAST(N'2016-08-04' AS date), 2016, 20163, 201608, 2016216, 3, 8, 216, 3, 4, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-07-28' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-07-29' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-08-05' AS date), 1054, 3163, 13752, 13753, 13753, 13753, 13752, 13752, 13752, 2457604, 57603, N'2016-08-03', 201631, 31, 3, N'2016-W31', N'2016-W31-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96274, CAST(N'2016-08-04' AS date), CAST(N'2016-08-05' AS date), 2016, 20163, 201608, 2016217, 3, 8, 217, 4, 5, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-07-29' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-08-05' AS date), 1054, 3163, 13752, 13753, 13753, 13753, 13753, 13752, 13752, 2457605, 57604, N'2016-08-04', 201631, 31, 4, N'2016-W31', N'2016-W31-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96275, CAST(N'2016-08-05' AS date), CAST(N'2016-08-06' AS date), 2016, 20163, 201608, 2016218, 3, 8, 218, 5, 6, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-05' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-07-30' AS date), CAST(N'2016-08-05' AS date), 1054, 3163, 13752, 13753, 13753, 13753, 13753, 13753, 13752, 2457606, 57605, N'2016-08-05', 201631, 31, 5, N'2016-W31', N'2016-W31-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96276, CAST(N'2016-08-06' AS date), CAST(N'2016-08-07' AS date), 2016, 20163, 201608, 2016219, 3, 8, 219, 6, 7, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-07-31' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-05' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-12' AS date), 1054, 3163, 13752, 13753, 13753, 13753, 13753, 13753, 13753, 2457607, 57606, N'2016-08-06', 201631, 31, 6, N'2016-W31', N'2016-W31-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96277, CAST(N'2016-08-07' AS date), CAST(N'2016-08-08' AS date), 2016, 20163, 201608, 2016220, 3, 8, 220, 7, 1, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-05' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-12' AS date), 1054, 3163, 13753, 13753, 13753, 13753, 13753, 13753, 13753, 2457608, 57607, N'2016-08-07', 201631, 31, 7, N'2016-W31', N'2016-W31-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96278, CAST(N'2016-08-08' AS date), CAST(N'2016-08-09' AS date), 2016, 20163, 201608, 2016221, 3, 8, 221, 8, 2, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-02' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-05' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-12' AS date), 1054, 3163, 13753, 13754, 13753, 13753, 13753, 13753, 13753, 2457609, 57608, N'2016-08-08', 201632, 32, 1, N'2016-W32', N'2016-W32-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96279, CAST(N'2016-08-09' AS date), CAST(N'2016-08-10' AS date), 2016, 20163, 201608, 2016222, 3, 8, 222, 9, 3, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-03' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-05' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-12' AS date), 1054, 3163, 13753, 13754, 13754, 13753, 13753, 13753, 13753, 2457610, 57609, N'2016-08-09', 201632, 32, 2, N'2016-W32', N'2016-W32-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96280, CAST(N'2016-08-10' AS date), CAST(N'2016-08-11' AS date), 2016, 20163, 201608, 2016223, 3, 8, 223, 10, 4, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-04' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-05' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-12' AS date), 1054, 3163, 13753, 13754, 13754, 13754, 13753, 13753, 13753, 2457611, 57610, N'2016-08-10', 201632, 32, 3, N'2016-W32', N'2016-W32-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96281, CAST(N'2016-08-11' AS date), CAST(N'2016-08-12' AS date), 2016, 20163, 201608, 2016224, 3, 8, 224, 11, 5, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-05' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-12' AS date), 1054, 3163, 13753, 13754, 13754, 13754, 13754, 13753, 13753, 2457612, 57611, N'2016-08-11', 201632, 32, 4, N'2016-W32', N'2016-W32-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96282, CAST(N'2016-08-12' AS date), CAST(N'2016-08-13' AS date), 2016, 20163, 201608, 2016225, 3, 8, 225, 12, 6, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-12' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-06' AS date), CAST(N'2016-08-12' AS date), 1054, 3163, 13753, 13754, 13754, 13754, 13754, 13754, 13753, 2457613, 57612, N'2016-08-12', 201632, 32, 5, N'2016-W32', N'2016-W32-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96283, CAST(N'2016-08-13' AS date), CAST(N'2016-08-14' AS date), 2016, 20163, 201608, 2016226, 3, 8, 226, 13, 7, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-07' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-12' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-19' AS date), 1054, 3163, 13753, 13754, 13754, 13754, 13754, 13754, 13754, 2457614, 57613, N'2016-08-13', 201632, 32, 6, N'2016-W32', N'2016-W32-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96284, CAST(N'2016-08-14' AS date), CAST(N'2016-08-15' AS date), 2016, 20163, 201608, 2016227, 3, 8, 227, 14, 1, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-08' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-12' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-19' AS date), 1054, 3163, 13754, 13754, 13754, 13754, 13754, 13754, 13754, 2457615, 57614, N'2016-08-14', 201632, 32, 7, N'2016-W32', N'2016-W32-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96285, CAST(N'2016-08-15' AS date), CAST(N'2016-08-16' AS date), 2016, 20163, 201608, 2016228, 3, 8, 228, 15, 2, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-09' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-12' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-19' AS date), 1054, 3163, 13754, 13755, 13754, 13754, 13754, 13754, 13754, 2457616, 57615, N'2016-08-15', 201633, 33, 1, N'2016-W33', N'2016-W33-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96286, CAST(N'2016-08-16' AS date), CAST(N'2016-08-17' AS date), 2016, 20163, 201608, 2016229, 3, 8, 229, 16, 3, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-10' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-12' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-19' AS date), 1054, 3163, 13754, 13755, 13755, 13754, 13754, 13754, 13754, 2457617, 57616, N'2016-08-16', 201633, 33, 2, N'2016-W33', N'2016-W33-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96287, CAST(N'2016-08-17' AS date), CAST(N'2016-08-18' AS date), 2016, 20163, 201608, 2016230, 3, 8, 230, 17, 4, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-11' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-12' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-19' AS date), 1054, 3163, 13754, 13755, 13755, 13755, 13754, 13754, 13754, 2457618, 57617, N'2016-08-17', 201633, 33, 3, N'2016-W33', N'2016-W33-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96288, CAST(N'2016-08-18' AS date), CAST(N'2016-08-19' AS date), 2016, 20163, 201608, 2016231, 3, 8, 231, 18, 5, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-12' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-19' AS date), 1054, 3163, 13754, 13755, 13755, 13755, 13755, 13754, 13754, 2457619, 57618, N'2016-08-18', 201633, 33, 4, N'2016-W33', N'2016-W33-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96289, CAST(N'2016-08-19' AS date), CAST(N'2016-08-20' AS date), 2016, 20163, 201608, 2016232, 3, 8, 232, 19, 6, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-19' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-13' AS date), CAST(N'2016-08-19' AS date), 1054, 3163, 13754, 13755, 13755, 13755, 13755, 13755, 13754, 2457620, 57619, N'2016-08-19', 201633, 33, 5, N'2016-W33', N'2016-W33-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96290, CAST(N'2016-08-20' AS date), CAST(N'2016-08-21' AS date), 2016, 20163, 201608, 2016233, 3, 8, 233, 20, 7, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-14' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-19' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-26' AS date), 1054, 3163, 13754, 13755, 13755, 13755, 13755, 13755, 13755, 2457621, 57620, N'2016-08-20', 201633, 33, 6, N'2016-W33', N'2016-W33-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96291, CAST(N'2016-08-21' AS date), CAST(N'2016-08-22' AS date), 2016, 20163, 201608, 2016234, 3, 8, 234, 21, 1, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-08-15' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-19' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-26' AS date), 1054, 3163, 13755, 13755, 13755, 13755, 13755, 13755, 13755, 2457622, 57621, N'2016-08-21', 201633, 33, 7, N'2016-W33', N'2016-W33-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96292, CAST(N'2016-08-22' AS date), CAST(N'2016-08-23' AS date), 2016, 20163, 201608, 2016235, 3, 8, 235, 22, 2, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-08-16' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-19' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-26' AS date), 1054, 3163, 13755, 13756, 13755, 13755, 13755, 13755, 13755, 2457623, 57622, N'2016-08-22', 201634, 34, 1, N'2016-W34', N'2016-W34-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96293, CAST(N'2016-08-23' AS date), CAST(N'2016-08-24' AS date), 2016, 20163, 201608, 2016236, 3, 8, 236, 23, 3, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-08-17' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-19' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-26' AS date), 1054, 3163, 13755, 13756, 13756, 13755, 13755, 13755, 13755, 2457624, 57623, N'2016-08-23', 201634, 34, 2, N'2016-W34', N'2016-W34-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96294, CAST(N'2016-08-24' AS date), CAST(N'2016-08-25' AS date), 2016, 20163, 201608, 2016237, 3, 8, 237, 24, 4, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-08-18' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-19' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-26' AS date), 1054, 3163, 13755, 13756, 13756, 13756, 13755, 13755, 13755, 2457625, 57624, N'2016-08-24', 201634, 34, 3, N'2016-W34', N'2016-W34-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96295, CAST(N'2016-08-25' AS date), CAST(N'2016-08-26' AS date), 2016, 20163, 201608, 2016238, 3, 8, 238, 25, 5, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-19' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-26' AS date), 1054, 3163, 13755, 13756, 13756, 13756, 13756, 13755, 13755, 2457626, 57625, N'2016-08-25', 201634, 34, 4, N'2016-W34', N'2016-W34-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96296, CAST(N'2016-08-26' AS date), CAST(N'2016-08-27' AS date), 2016, 20163, 201608, 2016239, 3, 8, 239, 26, 6, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-26' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-08-20' AS date), CAST(N'2016-08-26' AS date), 1054, 3163, 13755, 13756, 13756, 13756, 13756, 13756, 13755, 2457627, 57626, N'2016-08-26', 201634, 34, 5, N'2016-W34', N'2016-W34-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96297, CAST(N'2016-08-27' AS date), CAST(N'2016-08-28' AS date), 2016, 20163, 201608, 2016240, 3, 8, 240, 27, 7, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-21' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-26' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-09-02' AS date), 1054, 3163, 13755, 13756, 13756, 13756, 13756, 13756, 13756, 2457628, 57627, N'2016-08-27', 201634, 34, 6, N'2016-W34', N'2016-W34-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96298, CAST(N'2016-08-28' AS date), CAST(N'2016-08-29' AS date), 2016, 20163, 201608, 2016241, 3, 8, 241, 28, 1, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-08-22' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-26' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-09-02' AS date), 1054, 3163, 13756, 13756, 13756, 13756, 13756, 13756, 13756, 2457629, 57628, N'2016-08-28', 201634, 34, 7, N'2016-W34', N'2016-W34-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96299, CAST(N'2016-08-29' AS date), CAST(N'2016-08-30' AS date), 2016, 20163, 201608, 2016242, 3, 8, 242, 29, 2, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-08-23' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-26' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-09-02' AS date), 1054, 3163, 13756, 13757, 13756, 13756, 13756, 13756, 13756, 2457630, 57629, N'2016-08-29', 201635, 35, 1, N'2016-W35', N'2016-W35-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96300, CAST(N'2016-08-30' AS date), CAST(N'2016-08-31' AS date), 2016, 20163, 201608, 2016243, 3, 8, 243, 30, 3, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-08-24' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-26' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-09-02' AS date), 1054, 3163, 13756, 13757, 13757, 13756, 13756, 13756, 13756, 2457631, 57630, N'2016-08-30', 201635, 35, 2, N'2016-W35', N'2016-W35-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96301, CAST(N'2016-08-31' AS date), CAST(N'2016-09-01' AS date), 2016, 20163, 201608, 2016244, 3, 8, 244, 31, 4, N'2016', N'2016 Q3', N'2016 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-01' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-08-25' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-08-26' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-09-02' AS date), 1054, 3163, 13756, 13757, 13757, 13757, 13756, 13756, 13756, 2457632, 57631, N'2016-08-31', 201635, 35, 3, N'2016-W35', N'2016-W35-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96302, CAST(N'2016-09-01' AS date), CAST(N'2016-09-02' AS date), 2016, 20163, 201609, 2016245, 3, 9, 245, 1, 5, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-08-26' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-09-02' AS date), 1054, 3164, 13756, 13757, 13757, 13757, 13757, 13756, 13756, 2457633, 57632, N'2016-09-01', 201635, 35, 4, N'2016-W35', N'2016-W35-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96303, CAST(N'2016-09-02' AS date), CAST(N'2016-09-03' AS date), 2016, 20163, 201609, 2016246, 3, 9, 246, 2, 6, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-02' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-08-27' AS date), CAST(N'2016-09-02' AS date), 1054, 3164, 13756, 13757, 13757, 13757, 13757, 13757, 13756, 2457634, 57633, N'2016-09-02', 201635, 35, 5, N'2016-W35', N'2016-W35-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96304, CAST(N'2016-09-03' AS date), CAST(N'2016-09-04' AS date), 2016, 20163, 201609, 2016247, 3, 9, 247, 3, 7, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-08-28' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-02' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-09-09' AS date), 1054, 3164, 13756, 13757, 13757, 13757, 13757, 13757, 13757, 2457635, 57634, N'2016-09-03', 201635, 35, 6, N'2016-W35', N'2016-W35-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96305, CAST(N'2016-09-04' AS date), CAST(N'2016-09-05' AS date), 2016, 20163, 201609, 2016248, 3, 9, 248, 4, 1, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-08-29' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-02' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-09-09' AS date), 1054, 3164, 13757, 13757, 13757, 13757, 13757, 13757, 13757, 2457636, 57635, N'2016-09-04', 201635, 35, 7, N'2016-W35', N'2016-W35-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96306, CAST(N'2016-09-05' AS date), CAST(N'2016-09-06' AS date), 2016, 20163, 201609, 2016249, 3, 9, 249, 5, 2, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-08-30' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-02' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-09-09' AS date), 1054, 3164, 13757, 13758, 13757, 13757, 13757, 13757, 13757, 2457637, 57636, N'2016-09-05', 201636, 36, 1, N'2016-W36', N'2016-W36-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96307, CAST(N'2016-09-06' AS date), CAST(N'2016-09-07' AS date), 2016, 20163, 201609, 2016250, 3, 9, 250, 6, 3, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-08-31' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-02' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-09-09' AS date), 1054, 3164, 13757, 13758, 13758, 13757, 13757, 13757, 13757, 2457638, 57637, N'2016-09-06', 201636, 36, 2, N'2016-W36', N'2016-W36-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96308, CAST(N'2016-09-07' AS date), CAST(N'2016-09-08' AS date), 2016, 20163, 201609, 2016251, 3, 9, 251, 7, 4, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-02' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-09-09' AS date), 1054, 3164, 13757, 13758, 13758, 13758, 13757, 13757, 13757, 2457639, 57638, N'2016-09-07', 201636, 36, 3, N'2016-W36', N'2016-W36-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96309, CAST(N'2016-09-08' AS date), CAST(N'2016-09-09' AS date), 2016, 20163, 201609, 2016252, 3, 9, 252, 8, 5, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-02' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-09-09' AS date), 1054, 3164, 13757, 13758, 13758, 13758, 13758, 13757, 13757, 2457640, 57639, N'2016-09-08', 201636, 36, 4, N'2016-W36', N'2016-W36-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96310, CAST(N'2016-09-09' AS date), CAST(N'2016-09-10' AS date), 2016, 20163, 201609, 2016253, 3, 9, 253, 9, 6, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-09' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-03' AS date), CAST(N'2016-09-09' AS date), 1054, 3164, 13757, 13758, 13758, 13758, 13758, 13758, 13757, 2457641, 57640, N'2016-09-09', 201636, 36, 5, N'2016-W36', N'2016-W36-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96311, CAST(N'2016-09-10' AS date), CAST(N'2016-09-11' AS date), 2016, 20163, 201609, 2016254, 3, 9, 254, 10, 7, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-04' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-09' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-16' AS date), 1054, 3164, 13757, 13758, 13758, 13758, 13758, 13758, 13758, 2457642, 57641, N'2016-09-10', 201636, 36, 6, N'2016-W36', N'2016-W36-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96312, CAST(N'2016-09-11' AS date), CAST(N'2016-09-12' AS date), 2016, 20163, 201609, 2016255, 3, 9, 255, 11, 1, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-05' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-09' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-16' AS date), 1054, 3164, 13758, 13758, 13758, 13758, 13758, 13758, 13758, 2457643, 57642, N'2016-09-11', 201636, 36, 7, N'2016-W36', N'2016-W36-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96313, CAST(N'2016-09-12' AS date), CAST(N'2016-09-13' AS date), 2016, 20163, 201609, 2016256, 3, 9, 256, 12, 2, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-06' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-09' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-16' AS date), 1054, 3164, 13758, 13759, 13758, 13758, 13758, 13758, 13758, 2457644, 57643, N'2016-09-12', 201637, 37, 1, N'2016-W37', N'2016-W37-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96314, CAST(N'2016-09-13' AS date), CAST(N'2016-09-14' AS date), 2016, 20163, 201609, 2016257, 3, 9, 257, 13, 3, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-07' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-09' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-16' AS date), 1054, 3164, 13758, 13759, 13759, 13758, 13758, 13758, 13758, 2457645, 57644, N'2016-09-13', 201637, 37, 2, N'2016-W37', N'2016-W37-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96315, CAST(N'2016-09-14' AS date), CAST(N'2016-09-15' AS date), 2016, 20163, 201609, 2016258, 3, 9, 258, 14, 4, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-08' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-09' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-16' AS date), 1054, 3164, 13758, 13759, 13759, 13759, 13758, 13758, 13758, 2457646, 57645, N'2016-09-14', 201637, 37, 3, N'2016-W37', N'2016-W37-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96316, CAST(N'2016-09-15' AS date), CAST(N'2016-09-16' AS date), 2016, 20163, 201609, 2016259, 3, 9, 259, 15, 5, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-09' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-16' AS date), 1054, 3164, 13758, 13759, 13759, 13759, 13759, 13758, 13758, 2457647, 57646, N'2016-09-15', 201637, 37, 4, N'2016-W37', N'2016-W37-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96317, CAST(N'2016-09-16' AS date), CAST(N'2016-09-17' AS date), 2016, 20163, 201609, 2016260, 3, 9, 260, 16, 6, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-16' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-10' AS date), CAST(N'2016-09-16' AS date), 1054, 3164, 13758, 13759, 13759, 13759, 13759, 13759, 13758, 2457648, 57647, N'2016-09-16', 201637, 37, 5, N'2016-W37', N'2016-W37-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96318, CAST(N'2016-09-17' AS date), CAST(N'2016-09-18' AS date), 2016, 20163, 201609, 2016261, 3, 9, 261, 17, 7, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-11' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-16' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-23' AS date), 1054, 3164, 13758, 13759, 13759, 13759, 13759, 13759, 13759, 2457649, 57648, N'2016-09-17', 201637, 37, 6, N'2016-W37', N'2016-W37-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96319, CAST(N'2016-09-18' AS date), CAST(N'2016-09-19' AS date), 2016, 20163, 201609, 2016262, 3, 9, 262, 18, 1, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-12' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-16' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-23' AS date), 1054, 3164, 13759, 13759, 13759, 13759, 13759, 13759, 13759, 2457650, 57649, N'2016-09-18', 201637, 37, 7, N'2016-W37', N'2016-W37-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96320, CAST(N'2016-09-19' AS date), CAST(N'2016-09-20' AS date), 2016, 20163, 201609, 2016263, 3, 9, 263, 19, 2, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-09-13' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-16' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-23' AS date), 1054, 3164, 13759, 13760, 13759, 13759, 13759, 13759, 13759, 2457651, 57650, N'2016-09-19', 201638, 38, 1, N'2016-W38', N'2016-W38-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96321, CAST(N'2016-09-20' AS date), CAST(N'2016-09-21' AS date), 2016, 20163, 201609, 2016264, 3, 9, 264, 20, 3, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-09-14' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-16' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-23' AS date), 1054, 3164, 13759, 13760, 13760, 13759, 13759, 13759, 13759, 2457652, 57651, N'2016-09-20', 201638, 38, 2, N'2016-W38', N'2016-W38-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96322, CAST(N'2016-09-21' AS date), CAST(N'2016-09-22' AS date), 2016, 20163, 201609, 2016265, 3, 9, 265, 21, 4, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-09-15' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-16' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-23' AS date), 1054, 3164, 13759, 13760, 13760, 13760, 13759, 13759, 13759, 2457653, 57652, N'2016-09-21', 201638, 38, 3, N'2016-W38', N'2016-W38-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96323, CAST(N'2016-09-22' AS date), CAST(N'2016-09-23' AS date), 2016, 20163, 201609, 2016266, 3, 9, 266, 22, 5, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-09-16' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-23' AS date), 1054, 3164, 13759, 13760, 13760, 13760, 13760, 13759, 13759, 2457654, 57653, N'2016-09-22', 201638, 38, 4, N'2016-W38', N'2016-W38-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96324, CAST(N'2016-09-23' AS date), CAST(N'2016-09-24' AS date), 2016, 20163, 201609, 2016267, 3, 9, 267, 23, 6, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-09-23' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-09-17' AS date), CAST(N'2016-09-23' AS date), 1054, 3164, 13759, 13760, 13760, 13760, 13760, 13760, 13759, 2457655, 57654, N'2016-09-23', 201638, 38, 5, N'2016-W38', N'2016-W38-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96325, CAST(N'2016-09-24' AS date), CAST(N'2016-09-25' AS date), 2016, 20163, 201609, 2016268, 3, 9, 268, 24, 7, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-18' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-09-23' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-30' AS date), 1054, 3164, 13759, 13760, 13760, 13760, 13760, 13760, 13760, 2457656, 57655, N'2016-09-24', 201638, 38, 6, N'2016-W38', N'2016-W38-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96326, CAST(N'2016-09-25' AS date), CAST(N'2016-09-26' AS date), 2016, 20163, 201609, 2016269, 3, 9, 269, 25, 1, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-09-19' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-09-23' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-30' AS date), 1054, 3164, 13760, 13760, 13760, 13760, 13760, 13760, 13760, 2457657, 57656, N'2016-09-25', 201638, 38, 7, N'2016-W38', N'2016-W38-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96327, CAST(N'2016-09-26' AS date), CAST(N'2016-09-27' AS date), 2016, 20163, 201609, 2016270, 3, 9, 270, 26, 2, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-09-20' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-09-23' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-30' AS date), 1054, 3164, 13760, 13761, 13760, 13760, 13760, 13760, 13760, 2457658, 57657, N'2016-09-26', 201639, 39, 1, N'2016-W39', N'2016-W39-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96328, CAST(N'2016-09-27' AS date), CAST(N'2016-09-28' AS date), 2016, 20163, 201609, 2016271, 3, 9, 271, 27, 3, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-09-21' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-09-23' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-30' AS date), 1054, 3164, 13760, 13761, 13761, 13760, 13760, 13760, 13760, 2457659, 57658, N'2016-09-27', 201639, 39, 2, N'2016-W39', N'2016-W39-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96329, CAST(N'2016-09-28' AS date), CAST(N'2016-09-29' AS date), 2016, 20163, 201609, 2016272, 3, 9, 272, 28, 4, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-09-22' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-09-23' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-30' AS date), 1054, 3164, 13760, 13761, 13761, 13761, 13760, 13760, 13760, 2457660, 57659, N'2016-09-28', 201639, 39, 3, N'2016-W39', N'2016-W39-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96330, CAST(N'2016-09-29' AS date), CAST(N'2016-09-30' AS date), 2016, 20163, 201609, 2016273, 3, 9, 273, 29, 5, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-09-23' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-30' AS date), 1054, 3164, 13760, 13761, 13761, 13761, 13761, 13760, 13760, 2457661, 57660, N'2016-09-29', 201639, 39, 4, N'2016-W39', N'2016-W39-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96331, CAST(N'2016-09-30' AS date), CAST(N'2016-10-01' AS date), 2016, 20163, 201609, 2016274, 3, 9, 274, 30, 6, N'2016', N'2016 Q3', N'2016 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-07-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-01' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-09-24' AS date), CAST(N'2016-09-30' AS date), 1054, 3164, 13760, 13761, 13761, 13761, 13761, 13761, 13760, 2457662, 57661, N'2016-09-30', 201639, 39, 5, N'2016-W39', N'2016-W39-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96332, CAST(N'2016-10-01' AS date), CAST(N'2016-10-02' AS date), 2016, 20164, 201610, 2016275, 4, 10, 275, 1, 7, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-09-25' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-07' AS date), 1055, 3165, 13760, 13761, 13761, 13761, 13761, 13761, 13761, 2457663, 57662, N'2016-10-01', 201639, 39, 6, N'2016-W39', N'2016-W39-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96333, CAST(N'2016-10-02' AS date), CAST(N'2016-10-03' AS date), 2016, 20164, 201610, 2016276, 4, 10, 276, 2, 1, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-09-26' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-07' AS date), 1055, 3165, 13761, 13761, 13761, 13761, 13761, 13761, 13761, 2457664, 57663, N'2016-10-02', 201639, 39, 7, N'2016-W39', N'2016-W39-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96334, CAST(N'2016-10-03' AS date), CAST(N'2016-10-04' AS date), 2016, 20164, 201610, 2016277, 4, 10, 277, 3, 2, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-09-27' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-07' AS date), 1055, 3165, 13761, 13762, 13761, 13761, 13761, 13761, 13761, 2457665, 57664, N'2016-10-03', 201640, 40, 1, N'2016-W40', N'2016-W40-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96335, CAST(N'2016-10-04' AS date), CAST(N'2016-10-05' AS date), 2016, 20164, 201610, 2016278, 4, 10, 278, 4, 3, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-09-28' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-07' AS date), 1055, 3165, 13761, 13762, 13762, 13761, 13761, 13761, 13761, 2457666, 57665, N'2016-10-04', 201640, 40, 2, N'2016-W40', N'2016-W40-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96336, CAST(N'2016-10-05' AS date), CAST(N'2016-10-06' AS date), 2016, 20164, 201610, 2016279, 4, 10, 279, 5, 4, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-09-29' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-07' AS date), 1055, 3165, 13761, 13762, 13762, 13762, 13761, 13761, 13761, 2457667, 57666, N'2016-10-05', 201640, 40, 3, N'2016-W40', N'2016-W40-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96337, CAST(N'2016-10-06' AS date), CAST(N'2016-10-07' AS date), 2016, 20164, 201610, 2016280, 4, 10, 280, 6, 5, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-09-30' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-07' AS date), 1055, 3165, 13761, 13762, 13762, 13762, 13762, 13761, 13761, 2457668, 57667, N'2016-10-06', 201640, 40, 4, N'2016-W40', N'2016-W40-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96338, CAST(N'2016-10-07' AS date), CAST(N'2016-10-08' AS date), 2016, 20164, 201610, 2016281, 4, 10, 281, 7, 6, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-07' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-07' AS date), 1055, 3165, 13761, 13762, 13762, 13762, 13762, 13762, 13761, 2457669, 57668, N'2016-10-07', 201640, 40, 5, N'2016-W40', N'2016-W40-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96339, CAST(N'2016-10-08' AS date), CAST(N'2016-10-09' AS date), 2016, 20164, 201610, 2016282, 4, 10, 282, 8, 7, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-02' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-07' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-14' AS date), 1055, 3165, 13761, 13762, 13762, 13762, 13762, 13762, 13762, 2457670, 57669, N'2016-10-08', 201640, 40, 6, N'2016-W40', N'2016-W40-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96340, CAST(N'2016-10-09' AS date), CAST(N'2016-10-10' AS date), 2016, 20164, 201610, 2016283, 4, 10, 283, 9, 1, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-03' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-07' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-14' AS date), 1055, 3165, 13762, 13762, 13762, 13762, 13762, 13762, 13762, 2457671, 57670, N'2016-10-09', 201640, 40, 7, N'2016-W40', N'2016-W40-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96341, CAST(N'2016-10-10' AS date), CAST(N'2016-10-11' AS date), 2016, 20164, 201610, 2016284, 4, 10, 284, 10, 2, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-04' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-07' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-14' AS date), 1055, 3165, 13762, 13763, 13762, 13762, 13762, 13762, 13762, 2457672, 57671, N'2016-10-10', 201641, 41, 1, N'2016-W41', N'2016-W41-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96342, CAST(N'2016-10-11' AS date), CAST(N'2016-10-12' AS date), 2016, 20164, 201610, 2016285, 4, 10, 285, 11, 3, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-05' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-07' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-14' AS date), 1055, 3165, 13762, 13763, 13763, 13762, 13762, 13762, 13762, 2457673, 57672, N'2016-10-11', 201641, 41, 2, N'2016-W41', N'2016-W41-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96343, CAST(N'2016-10-12' AS date), CAST(N'2016-10-13' AS date), 2016, 20164, 201610, 2016286, 4, 10, 286, 12, 4, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-06' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-07' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-14' AS date), 1055, 3165, 13762, 13763, 13763, 13763, 13762, 13762, 13762, 2457674, 57673, N'2016-10-12', 201641, 41, 3, N'2016-W41', N'2016-W41-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96344, CAST(N'2016-10-13' AS date), CAST(N'2016-10-14' AS date), 2016, 20164, 201610, 2016287, 4, 10, 287, 13, 5, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-07' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-14' AS date), 1055, 3165, 13762, 13763, 13763, 13763, 13763, 13762, 13762, 2457675, 57674, N'2016-10-13', 201641, 41, 4, N'2016-W41', N'2016-W41-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96345, CAST(N'2016-10-14' AS date), CAST(N'2016-10-15' AS date), 2016, 20164, 201610, 2016288, 4, 10, 288, 14, 6, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-14' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-08' AS date), CAST(N'2016-10-14' AS date), 1055, 3165, 13762, 13763, 13763, 13763, 13763, 13763, 13762, 2457676, 57675, N'2016-10-14', 201641, 41, 5, N'2016-W41', N'2016-W41-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96346, CAST(N'2016-10-15' AS date), CAST(N'2016-10-16' AS date), 2016, 20164, 201610, 2016289, 4, 10, 289, 15, 7, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-09' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-14' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-21' AS date), 1055, 3165, 13762, 13763, 13763, 13763, 13763, 13763, 13763, 2457677, 57676, N'2016-10-15', 201641, 41, 6, N'2016-W41', N'2016-W41-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96347, CAST(N'2016-10-16' AS date), CAST(N'2016-10-17' AS date), 2016, 20164, 201610, 2016290, 4, 10, 290, 16, 1, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-10' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-14' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-21' AS date), 1055, 3165, 13763, 13763, 13763, 13763, 13763, 13763, 13763, 2457678, 57677, N'2016-10-16', 201641, 41, 7, N'2016-W41', N'2016-W41-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96348, CAST(N'2016-10-17' AS date), CAST(N'2016-10-18' AS date), 2016, 20164, 201610, 2016291, 4, 10, 291, 17, 2, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-11' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-14' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-21' AS date), 1055, 3165, 13763, 13764, 13763, 13763, 13763, 13763, 13763, 2457679, 57678, N'2016-10-17', 201642, 42, 1, N'2016-W42', N'2016-W42-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96349, CAST(N'2016-10-18' AS date), CAST(N'2016-10-19' AS date), 2016, 20164, 201610, 2016292, 4, 10, 292, 18, 3, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-12' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-14' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-21' AS date), 1055, 3165, 13763, 13764, 13764, 13763, 13763, 13763, 13763, 2457680, 57679, N'2016-10-18', 201642, 42, 2, N'2016-W42', N'2016-W42-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96350, CAST(N'2016-10-19' AS date), CAST(N'2016-10-20' AS date), 2016, 20164, 201610, 2016293, 4, 10, 293, 19, 4, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-13' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-14' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-21' AS date), 1055, 3165, 13763, 13764, 13764, 13764, 13763, 13763, 13763, 2457681, 57680, N'2016-10-19', 201642, 42, 3, N'2016-W42', N'2016-W42-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96351, CAST(N'2016-10-20' AS date), CAST(N'2016-10-21' AS date), 2016, 20164, 201610, 2016294, 4, 10, 294, 20, 5, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-10-14' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-21' AS date), 1055, 3165, 13763, 13764, 13764, 13764, 13764, 13763, 13763, 2457682, 57681, N'2016-10-20', 201642, 42, 4, N'2016-W42', N'2016-W42-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96352, CAST(N'2016-10-21' AS date), CAST(N'2016-10-22' AS date), 2016, 20164, 201610, 2016295, 4, 10, 295, 21, 6, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-10-21' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-10-15' AS date), CAST(N'2016-10-21' AS date), 1055, 3165, 13763, 13764, 13764, 13764, 13764, 13764, 13763, 2457683, 57682, N'2016-10-21', 201642, 42, 5, N'2016-W42', N'2016-W42-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96353, CAST(N'2016-10-22' AS date), CAST(N'2016-10-23' AS date), 2016, 20164, 201610, 2016296, 4, 10, 296, 22, 7, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-16' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-10-21' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-28' AS date), 1055, 3165, 13763, 13764, 13764, 13764, 13764, 13764, 13764, 2457684, 57683, N'2016-10-22', 201642, 42, 6, N'2016-W42', N'2016-W42-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96354, CAST(N'2016-10-23' AS date), CAST(N'2016-10-24' AS date), 2016, 20164, 201610, 2016297, 4, 10, 297, 23, 1, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-10-17' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-10-21' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-28' AS date), 1055, 3165, 13764, 13764, 13764, 13764, 13764, 13764, 13764, 2457685, 57684, N'2016-10-23', 201642, 42, 7, N'2016-W42', N'2016-W42-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96355, CAST(N'2016-10-24' AS date), CAST(N'2016-10-25' AS date), 2016, 20164, 201610, 2016298, 4, 10, 298, 24, 2, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-10-18' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-10-21' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-28' AS date), 1055, 3165, 13764, 13765, 13764, 13764, 13764, 13764, 13764, 2457686, 57685, N'2016-10-24', 201643, 43, 1, N'2016-W43', N'2016-W43-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96356, CAST(N'2016-10-25' AS date), CAST(N'2016-10-26' AS date), 2016, 20164, 201610, 2016299, 4, 10, 299, 25, 3, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-19' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-10-21' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-28' AS date), 1055, 3165, 13764, 13765, 13765, 13764, 13764, 13764, 13764, 2457687, 57686, N'2016-10-25', 201643, 43, 2, N'2016-W43', N'2016-W43-2');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96357, CAST(N'2016-10-26' AS date), CAST(N'2016-10-27' AS date), 2016, 20164, 201610, 2016300, 4, 10, 300, 26, 4, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-10-20' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-10-21' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-28' AS date), 1055, 3165, 13764, 13765, 13765, 13765, 13764, 13764, 13764, 2457688, 57687, N'2016-10-26', 201643, 43, 3, N'2016-W43', N'2016-W43-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96358, CAST(N'2016-10-27' AS date), CAST(N'2016-10-28' AS date), 2016, 20164, 201610, 2016301, 4, 10, 301, 27, 5, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-10-21' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-28' AS date), 1055, 3165, 13764, 13765, 13765, 13765, 13765, 13764, 13764, 2457689, 57688, N'2016-10-27', 201643, 43, 4, N'2016-W43', N'2016-W43-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96359, CAST(N'2016-10-28' AS date), CAST(N'2016-10-29' AS date), 2016, 20164, 201610, 2016302, 4, 10, 302, 28, 6, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-10-28' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-10-22' AS date), CAST(N'2016-10-28' AS date), 1055, 3165, 13764, 13765, 13765, 13765, 13765, 13765, 13764, 2457690, 57689, N'2016-10-28', 201643, 43, 5, N'2016-W43', N'2016-W43-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96360, CAST(N'2016-10-29' AS date), CAST(N'2016-10-30' AS date), 2016, 20164, 201610, 2016303, 4, 10, 303, 29, 7, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-23' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-10-28' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-11-04' AS date), 1055, 3165, 13764, 13765, 13765, 13765, 13765, 13765, 13765, 2457691, 57690, N'2016-10-29', 201643, 43, 6, N'2016-W43', N'2016-W43-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96361, CAST(N'2016-10-30' AS date), CAST(N'2016-10-31' AS date), 2016, 20164, 201610, 2016304, 4, 10, 304, 30, 1, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-10-24' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-10-28' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-11-04' AS date), 1055, 3165, 13765, 13765, 13765, 13765, 13765, 13765, 13765, 2457692, 57691, N'2016-10-30', 201643, 43, 7, N'2016-W43', N'2016-W43-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96362, CAST(N'2016-10-31' AS date), CAST(N'2016-11-01' AS date), 2016, 20164, 201610, 2016305, 4, 10, 305, 31, 2, N'2016', N'2016 Q4', N'2016 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-10-25' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-10-28' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-11-04' AS date), 1055, 3165, 13765, 13766, 13765, 13765, 13765, 13765, 13765, 2457693, 57692, N'2016-10-31', 201644, 44, 1, N'2016-W44', N'2016-W44-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96363, CAST(N'2016-11-01' AS date), CAST(N'2016-11-02' AS date), 2016, 20164, 201611, 2016306, 4, 11, 306, 1, 3, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-10-26' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-10-28' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-11-04' AS date), 1055, 3166, 13765, 13766, 13766, 13765, 13765, 13765, 13765, 2457694, 57693, N'2016-11-01', 201644, 44, 2, N'2016-W44', N'2016-W44-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96364, CAST(N'2016-11-02' AS date), CAST(N'2016-11-03' AS date), 2016, 20164, 201611, 2016307, 4, 11, 307, 2, 4, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-10-27' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-10-28' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-11-04' AS date), 1055, 3166, 13765, 13766, 13766, 13766, 13765, 13765, 13765, 2457695, 57694, N'2016-11-02', 201644, 44, 3, N'2016-W44', N'2016-W44-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96365, CAST(N'2016-11-03' AS date), CAST(N'2016-11-04' AS date), 2016, 20164, 201611, 2016308, 4, 11, 308, 3, 5, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-10-28' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-11-04' AS date), 1055, 3166, 13765, 13766, 13766, 13766, 13766, 13765, 13765, 2457696, 57695, N'2016-11-03', 201644, 44, 4, N'2016-W44', N'2016-W44-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96366, CAST(N'2016-11-04' AS date), CAST(N'2016-11-05' AS date), 2016, 20164, 201611, 2016309, 4, 11, 309, 4, 6, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-04' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-10-29' AS date), CAST(N'2016-11-04' AS date), 1055, 3166, 13765, 13766, 13766, 13766, 13766, 13766, 13765, 2457697, 57696, N'2016-11-04', 201644, 44, 5, N'2016-W44', N'2016-W44-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96367, CAST(N'2016-11-05' AS date), CAST(N'2016-11-06' AS date), 2016, 20164, 201611, 2016310, 4, 11, 310, 5, 7, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-10-30' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-04' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-11-11' AS date), 1055, 3166, 13765, 13766, 13766, 13766, 13766, 13766, 13766, 2457698, 57697, N'2016-11-05', 201644, 44, 6, N'2016-W44', N'2016-W44-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96368, CAST(N'2016-11-06' AS date), CAST(N'2016-11-07' AS date), 2016, 20164, 201611, 2016311, 4, 11, 311, 6, 1, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-10-31' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-04' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-11-11' AS date), 1055, 3166, 13766, 13766, 13766, 13766, 13766, 13766, 13766, 2457699, 57698, N'2016-11-06', 201644, 44, 7, N'2016-W44', N'2016-W44-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96369, CAST(N'2016-11-07' AS date), CAST(N'2016-11-08' AS date), 2016, 20164, 201611, 2016312, 4, 11, 312, 7, 2, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-04' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-11-11' AS date), 1055, 3166, 13766, 13767, 13766, 13766, 13766, 13766, 13766, 2457700, 57699, N'2016-11-07', 201645, 45, 1, N'2016-W45', N'2016-W45-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96370, CAST(N'2016-11-08' AS date), CAST(N'2016-11-09' AS date), 2016, 20164, 201611, 2016313, 4, 11, 313, 8, 3, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-02' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-04' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-11-11' AS date), 1055, 3166, 13766, 13767, 13767, 13766, 13766, 13766, 13766, 2457701, 57700, N'2016-11-08', 201645, 45, 2, N'2016-W45', N'2016-W45-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96371, CAST(N'2016-11-09' AS date), CAST(N'2016-11-10' AS date), 2016, 20164, 201611, 2016314, 4, 11, 314, 9, 4, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-03' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-04' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-11-11' AS date), 1055, 3166, 13766, 13767, 13767, 13767, 13766, 13766, 13766, 2457702, 57701, N'2016-11-09', 201645, 45, 3, N'2016-W45', N'2016-W45-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96372, CAST(N'2016-11-10' AS date), CAST(N'2016-11-11' AS date), 2016, 20164, 201611, 2016315, 4, 11, 315, 10, 5, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-04' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-11-11' AS date), 1055, 3166, 13766, 13767, 13767, 13767, 13767, 13766, 13766, 2457703, 57702, N'2016-11-10', 201645, 45, 4, N'2016-W45', N'2016-W45-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96373, CAST(N'2016-11-11' AS date), CAST(N'2016-11-12' AS date), 2016, 20164, 201611, 2016316, 4, 11, 316, 11, 6, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-11' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-05' AS date), CAST(N'2016-11-11' AS date), 1055, 3166, 13766, 13767, 13767, 13767, 13767, 13767, 13766, 2457704, 57703, N'2016-11-11', 201645, 45, 5, N'2016-W45', N'2016-W45-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96374, CAST(N'2016-11-12' AS date), CAST(N'2016-11-13' AS date), 2016, 20164, 201611, 2016317, 4, 11, 317, 12, 7, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-06' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-11' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-18' AS date), 1055, 3166, 13766, 13767, 13767, 13767, 13767, 13767, 13767, 2457705, 57704, N'2016-11-12', 201645, 45, 6, N'2016-W45', N'2016-W45-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96375, CAST(N'2016-11-13' AS date), CAST(N'2016-11-14' AS date), 2016, 20164, 201611, 2016318, 4, 11, 318, 13, 1, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-07' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-11' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-18' AS date), 1055, 3166, 13767, 13767, 13767, 13767, 13767, 13767, 13767, 2457706, 57705, N'2016-11-13', 201645, 45, 7, N'2016-W45', N'2016-W45-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96376, CAST(N'2016-11-14' AS date), CAST(N'2016-11-15' AS date), 2016, 20164, 201611, 2016319, 4, 11, 319, 14, 2, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-08' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-11' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-18' AS date), 1055, 3166, 13767, 13768, 13767, 13767, 13767, 13767, 13767, 2457707, 57706, N'2016-11-14', 201646, 46, 1, N'2016-W46', N'2016-W46-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96377, CAST(N'2016-11-15' AS date), CAST(N'2016-11-16' AS date), 2016, 20164, 201611, 2016320, 4, 11, 320, 15, 3, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-09' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-11' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-18' AS date), 1055, 3166, 13767, 13768, 13768, 13767, 13767, 13767, 13767, 2457708, 57707, N'2016-11-15', 201646, 46, 2, N'2016-W46', N'2016-W46-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96378, CAST(N'2016-11-16' AS date), CAST(N'2016-11-17' AS date), 2016, 20164, 201611, 2016321, 4, 11, 321, 16, 4, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-10' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-11' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-18' AS date), 1055, 3166, 13767, 13768, 13768, 13768, 13767, 13767, 13767, 2457709, 57708, N'2016-11-16', 201646, 46, 3, N'2016-W46', N'2016-W46-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96379, CAST(N'2016-11-17' AS date), CAST(N'2016-11-18' AS date), 2016, 20164, 201611, 2016322, 4, 11, 322, 17, 5, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-11' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-18' AS date), 1055, 3166, 13767, 13768, 13768, 13768, 13768, 13767, 13767, 2457710, 57709, N'2016-11-17', 201646, 46, 4, N'2016-W46', N'2016-W46-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96380, CAST(N'2016-11-18' AS date), CAST(N'2016-11-19' AS date), 2016, 20164, 201611, 2016323, 4, 11, 323, 18, 6, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-18' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-12' AS date), CAST(N'2016-11-18' AS date), 1055, 3166, 13767, 13768, 13768, 13768, 13768, 13768, 13767, 2457711, 57710, N'2016-11-18', 201646, 46, 5, N'2016-W46', N'2016-W46-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96381, CAST(N'2016-11-19' AS date), CAST(N'2016-11-20' AS date), 2016, 20164, 201611, 2016324, 4, 11, 324, 19, 7, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-13' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-18' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-25' AS date), 1055, 3166, 13767, 13768, 13768, 13768, 13768, 13768, 13768, 2457712, 57711, N'2016-11-19', 201646, 46, 6, N'2016-W46', N'2016-W46-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96382, CAST(N'2016-11-20' AS date), CAST(N'2016-11-21' AS date), 2016, 20164, 201611, 2016325, 4, 11, 325, 20, 1, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-11-14' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-18' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-25' AS date), 1055, 3166, 13768, 13768, 13768, 13768, 13768, 13768, 13768, 2457713, 57712, N'2016-11-20', 201646, 46, 7, N'2016-W46', N'2016-W46-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96383, CAST(N'2016-11-21' AS date), CAST(N'2016-11-22' AS date), 2016, 20164, 201611, 2016326, 4, 11, 326, 21, 2, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-11-15' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-18' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-25' AS date), 1055, 3166, 13768, 13769, 13768, 13768, 13768, 13768, 13768, 2457714, 57713, N'2016-11-21', 201647, 47, 1, N'2016-W47', N'2016-W47-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96384, CAST(N'2016-11-22' AS date), CAST(N'2016-11-23' AS date), 2016, 20164, 201611, 2016327, 4, 11, 327, 22, 3, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-11-16' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-18' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-25' AS date), 1055, 3166, 13768, 13769, 13769, 13768, 13768, 13768, 13768, 2457715, 57714, N'2016-11-22', 201647, 47, 2, N'2016-W47', N'2016-W47-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96385, CAST(N'2016-11-23' AS date), CAST(N'2016-11-24' AS date), 2016, 20164, 201611, 2016328, 4, 11, 328, 23, 4, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-11-17' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-18' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-25' AS date), 1055, 3166, 13768, 13769, 13769, 13769, 13768, 13768, 13768, 2457716, 57715, N'2016-11-23', 201647, 47, 3, N'2016-W47', N'2016-W47-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96386, CAST(N'2016-11-24' AS date), CAST(N'2016-11-25' AS date), 2016, 20164, 201611, 2016329, 4, 11, 329, 24, 5, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-18' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-25' AS date), 1055, 3166, 13768, 13769, 13769, 13769, 13769, 13768, 13768, 2457717, 57716, N'2016-11-24', 201647, 47, 4, N'2016-W47', N'2016-W47-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96387, CAST(N'2016-11-25' AS date), CAST(N'2016-11-26' AS date), 2016, 20164, 201611, 2016330, 4, 11, 330, 25, 6, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-25' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-11-19' AS date), CAST(N'2016-11-25' AS date), 1055, 3166, 13768, 13769, 13769, 13769, 13769, 13769, 13768, 2457718, 57717, N'2016-11-25', 201647, 47, 5, N'2016-W47', N'2016-W47-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96388, CAST(N'2016-11-26' AS date), CAST(N'2016-11-27' AS date), 2016, 20164, 201611, 2016331, 4, 11, 331, 26, 7, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-20' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-25' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-12-02' AS date), 1055, 3166, 13768, 13769, 13769, 13769, 13769, 13769, 13769, 2457719, 57718, N'2016-11-26', 201647, 47, 6, N'2016-W47', N'2016-W47-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96389, CAST(N'2016-11-27' AS date), CAST(N'2016-11-28' AS date), 2016, 20164, 201611, 2016332, 4, 11, 332, 27, 1, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-11-21' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-25' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-12-02' AS date), 1055, 3166, 13769, 13769, 13769, 13769, 13769, 13769, 13769, 2457720, 57719, N'2016-11-27', 201647, 47, 7, N'2016-W47', N'2016-W47-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96390, CAST(N'2016-11-28' AS date), CAST(N'2016-11-29' AS date), 2016, 20164, 201611, 2016333, 4, 11, 333, 28, 2, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-11-22' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-25' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-12-02' AS date), 1055, 3166, 13769, 13770, 13769, 13769, 13769, 13769, 13769, 2457721, 57720, N'2016-11-28', 201648, 48, 1, N'2016-W48', N'2016-W48-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96391, CAST(N'2016-11-29' AS date), CAST(N'2016-11-30' AS date), 2016, 20164, 201611, 2016334, 4, 11, 334, 29, 3, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-11-23' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-25' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-12-02' AS date), 1055, 3166, 13769, 13770, 13770, 13769, 13769, 13769, 13769, 2457722, 57721, N'2016-11-29', 201648, 48, 2, N'2016-W48', N'2016-W48-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96392, CAST(N'2016-11-30' AS date), CAST(N'2016-12-01' AS date), 2016, 20164, 201611, 2016335, 4, 11, 335, 30, 4, N'2016', N'2016 Q4', N'2016 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-01' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-11-24' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-11-25' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-12-02' AS date), 1055, 3166, 13769, 13770, 13770, 13770, 13769, 13769, 13769, 2457723, 57722, N'2016-11-30', 201648, 48, 3, N'2016-W48', N'2016-W48-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96393, CAST(N'2016-12-01' AS date), CAST(N'2016-12-02' AS date), 2016, 20164, 201612, 2016336, 4, 12, 336, 1, 5, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-11-25' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-12-02' AS date), 1055, 3167, 13769, 13770, 13770, 13770, 13770, 13769, 13769, 2457724, 57723, N'2016-12-01', 201648, 48, 4, N'2016-W48', N'2016-W48-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96394, CAST(N'2016-12-02' AS date), CAST(N'2016-12-03' AS date), 2016, 20164, 201612, 2016337, 4, 12, 337, 2, 6, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-02' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-11-26' AS date), CAST(N'2016-12-02' AS date), 1055, 3167, 13769, 13770, 13770, 13770, 13770, 13770, 13769, 2457725, 57724, N'2016-12-02', 201648, 48, 5, N'2016-W48', N'2016-W48-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96395, CAST(N'2016-12-03' AS date), CAST(N'2016-12-04' AS date), 2016, 20164, 201612, 2016338, 4, 12, 338, 3, 7, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-11-27' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-02' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-12-09' AS date), 1055, 3167, 13769, 13770, 13770, 13770, 13770, 13770, 13770, 2457726, 57725, N'2016-12-03', 201648, 48, 6, N'2016-W48', N'2016-W48-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96396, CAST(N'2016-12-04' AS date), CAST(N'2016-12-05' AS date), 2016, 20164, 201612, 2016339, 4, 12, 339, 4, 1, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-11-28' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-02' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-12-09' AS date), 1055, 3167, 13770, 13770, 13770, 13770, 13770, 13770, 13770, 2457727, 57726, N'2016-12-04', 201648, 48, 7, N'2016-W48', N'2016-W48-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96397, CAST(N'2016-12-05' AS date), CAST(N'2016-12-06' AS date), 2016, 20164, 201612, 2016340, 4, 12, 340, 5, 2, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-11-29' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-02' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-12-09' AS date), 1055, 3167, 13770, 13771, 13770, 13770, 13770, 13770, 13770, 2457728, 57727, N'2016-12-05', 201649, 49, 1, N'2016-W49', N'2016-W49-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96398, CAST(N'2016-12-06' AS date), CAST(N'2016-12-07' AS date), 2016, 20164, 201612, 2016341, 4, 12, 341, 6, 3, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-11-30' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-02' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-12-09' AS date), 1055, 3167, 13770, 13771, 13771, 13770, 13770, 13770, 13770, 2457729, 57728, N'2016-12-06', 201649, 49, 2, N'2016-W49', N'2016-W49-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96399, CAST(N'2016-12-07' AS date), CAST(N'2016-12-08' AS date), 2016, 20164, 201612, 2016342, 4, 12, 342, 7, 4, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-02' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-12-09' AS date), 1055, 3167, 13770, 13771, 13771, 13771, 13770, 13770, 13770, 2457730, 57729, N'2016-12-07', 201649, 49, 3, N'2016-W49', N'2016-W49-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96400, CAST(N'2016-12-08' AS date), CAST(N'2016-12-09' AS date), 2016, 20164, 201612, 2016343, 4, 12, 343, 8, 5, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-02' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-12-09' AS date), 1055, 3167, 13770, 13771, 13771, 13771, 13771, 13770, 13770, 2457731, 57730, N'2016-12-08', 201649, 49, 4, N'2016-W49', N'2016-W49-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96401, CAST(N'2016-12-09' AS date), CAST(N'2016-12-10' AS date), 2016, 20164, 201612, 2016344, 4, 12, 344, 9, 6, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-09' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-03' AS date), CAST(N'2016-12-09' AS date), 1055, 3167, 13770, 13771, 13771, 13771, 13771, 13771, 13770, 2457732, 57731, N'2016-12-09', 201649, 49, 5, N'2016-W49', N'2016-W49-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96402, CAST(N'2016-12-10' AS date), CAST(N'2016-12-11' AS date), 2016, 20164, 201612, 2016345, 4, 12, 345, 10, 7, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-04' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-09' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-16' AS date), 1055, 3167, 13770, 13771, 13771, 13771, 13771, 13771, 13771, 2457733, 57732, N'2016-12-10', 201649, 49, 6, N'2016-W49', N'2016-W49-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96403, CAST(N'2016-12-11' AS date), CAST(N'2016-12-12' AS date), 2016, 20164, 201612, 2016346, 4, 12, 346, 11, 1, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-05' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-09' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-16' AS date), 1055, 3167, 13771, 13771, 13771, 13771, 13771, 13771, 13771, 2457734, 57733, N'2016-12-11', 201649, 49, 7, N'2016-W49', N'2016-W49-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96404, CAST(N'2016-12-12' AS date), CAST(N'2016-12-13' AS date), 2016, 20164, 201612, 2016347, 4, 12, 347, 12, 2, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-06' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-09' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-16' AS date), 1055, 3167, 13771, 13772, 13771, 13771, 13771, 13771, 13771, 2457735, 57734, N'2016-12-12', 201650, 50, 1, N'2016-W50', N'2016-W50-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96405, CAST(N'2016-12-13' AS date), CAST(N'2016-12-14' AS date), 2016, 20164, 201612, 2016348, 4, 12, 348, 13, 3, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-07' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-09' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-16' AS date), 1055, 3167, 13771, 13772, 13772, 13771, 13771, 13771, 13771, 2457736, 57735, N'2016-12-13', 201650, 50, 2, N'2016-W50', N'2016-W50-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96406, CAST(N'2016-12-14' AS date), CAST(N'2016-12-15' AS date), 2016, 20164, 201612, 2016349, 4, 12, 349, 14, 4, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-08' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-09' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-16' AS date), 1055, 3167, 13771, 13772, 13772, 13772, 13771, 13771, 13771, 2457737, 57736, N'2016-12-14', 201650, 50, 3, N'2016-W50', N'2016-W50-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96407, CAST(N'2016-12-15' AS date), CAST(N'2016-12-16' AS date), 2016, 20164, 201612, 2016350, 4, 12, 350, 15, 5, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-09' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-16' AS date), 1055, 3167, 13771, 13772, 13772, 13772, 13772, 13771, 13771, 2457738, 57737, N'2016-12-15', 201650, 50, 4, N'2016-W50', N'2016-W50-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96408, CAST(N'2016-12-16' AS date), CAST(N'2016-12-17' AS date), 2016, 20164, 201612, 2016351, 4, 12, 351, 16, 6, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-16' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-10' AS date), CAST(N'2016-12-16' AS date), 1055, 3167, 13771, 13772, 13772, 13772, 13772, 13772, 13771, 2457739, 57738, N'2016-12-16', 201650, 50, 5, N'2016-W50', N'2016-W50-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96409, CAST(N'2016-12-17' AS date), CAST(N'2016-12-18' AS date), 2016, 20164, 201612, 2016352, 4, 12, 352, 17, 7, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-11' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-16' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-23' AS date), 1055, 3167, 13771, 13772, 13772, 13772, 13772, 13772, 13772, 2457740, 57739, N'2016-12-17', 201650, 50, 6, N'2016-W50', N'2016-W50-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96410, CAST(N'2016-12-18' AS date), CAST(N'2016-12-19' AS date), 2016, 20164, 201612, 2016353, 4, 12, 353, 18, 1, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-12' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-16' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-23' AS date), 1055, 3167, 13772, 13772, 13772, 13772, 13772, 13772, 13772, 2457741, 57740, N'2016-12-18', 201650, 50, 7, N'2016-W50', N'2016-W50-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96411, CAST(N'2016-12-19' AS date), CAST(N'2016-12-20' AS date), 2016, 20164, 201612, 2016354, 4, 12, 354, 19, 2, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-13' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-16' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-23' AS date), 1055, 3167, 13772, 13773, 13772, 13772, 13772, 13772, 13772, 2457742, 57741, N'2016-12-19', 201651, 51, 1, N'2016-W51', N'2016-W51-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96412, CAST(N'2016-12-20' AS date), CAST(N'2016-12-21' AS date), 2016, 20164, 201612, 2016355, 4, 12, 355, 20, 3, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-26' AS date), CAST(N'2016-12-14' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-16' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-23' AS date), 1055, 3167, 13772, 13773, 13773, 13772, 13772, 13772, 13772, 2457743, 57742, N'2016-12-20', 201651, 51, 2, N'2016-W51', N'2016-W51-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96413, CAST(N'2016-12-21' AS date), CAST(N'2016-12-22' AS date), 2016, 20164, 201612, 2016356, 4, 12, 356, 21, 4, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-26' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-27' AS date), CAST(N'2016-12-15' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-16' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-23' AS date), 1055, 3167, 13772, 13773, 13773, 13773, 13772, 13772, 13772, 2457744, 57743, N'2016-12-21', 201651, 51, 3, N'2016-W51', N'2016-W51-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96414, CAST(N'2016-12-22' AS date), CAST(N'2016-12-23' AS date), 2016, 20164, 201612, 2016357, 4, 12, 357, 22, 5, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-26' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-27' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-28' AS date), CAST(N'2016-12-16' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-23' AS date), 1055, 3167, 13772, 13773, 13773, 13773, 13773, 13772, 13772, 2457745, 57744, N'2016-12-22', 201651, 51, 4, N'2016-W51', N'2016-W51-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96415, CAST(N'2016-12-23' AS date), CAST(N'2016-12-24' AS date), 2016, 20164, 201612, 2016358, 4, 12, 358, 23, 6, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-26' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-27' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-28' AS date), CAST(N'2016-12-23' AS date), CAST(N'2016-12-29' AS date), CAST(N'2016-12-17' AS date), CAST(N'2016-12-23' AS date), 1055, 3167, 13772, 13773, 13773, 13773, 13773, 13773, 13772, 2457746, 57745, N'2016-12-23', 201651, 51, 5, N'2016-W51', N'2016-W51-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96416, CAST(N'2016-12-24' AS date), CAST(N'2016-12-25' AS date), 2016, 20164, 201612, 2016359, 4, 12, 359, 24, 7, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-18' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-26' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-27' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-28' AS date), CAST(N'2016-12-23' AS date), CAST(N'2016-12-29' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-30' AS date), 1055, 3167, 13772, 13773, 13773, 13773, 13773, 13773, 13773, 2457747, 57746, N'2016-12-24', 201651, 51, 6, N'2016-W51', N'2016-W51-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96417, CAST(N'2016-12-25' AS date), CAST(N'2016-12-26' AS date), 2016, 20164, 201612, 2016360, 4, 12, 360, 25, 1, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-19' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-26' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-27' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-28' AS date), CAST(N'2016-12-23' AS date), CAST(N'2016-12-29' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-30' AS date), 1055, 3167, 13773, 13773, 13773, 13773, 13773, 13773, 13773, 2457748, 57747, N'2016-12-25', 201651, 51, 7, N'2016-W51', N'2016-W51-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96418, CAST(N'2016-12-26' AS date), CAST(N'2016-12-27' AS date), 2016, 20164, 201612, 2016361, 4, 12, 361, 26, 2, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-26' AS date), CAST(N'2017-01-01' AS date), CAST(N'2016-12-20' AS date), CAST(N'2016-12-26' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-27' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-28' AS date), CAST(N'2016-12-23' AS date), CAST(N'2016-12-29' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-30' AS date), 1055, 3167, 13773, 13774, 13773, 13773, 13773, 13773, 13773, 2457749, 57748, N'2016-12-26', 201652, 52, 1, N'2016-W52', N'2016-W52-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96419, CAST(N'2016-12-27' AS date), CAST(N'2016-12-28' AS date), 2016, 20164, 201612, 2016362, 4, 12, 362, 27, 3, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-26' AS date), CAST(N'2017-01-01' AS date), CAST(N'2016-12-27' AS date), CAST(N'2017-01-02' AS date), CAST(N'2016-12-21' AS date), CAST(N'2016-12-27' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-28' AS date), CAST(N'2016-12-23' AS date), CAST(N'2016-12-29' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-30' AS date), 1055, 3167, 13773, 13774, 13774, 13773, 13773, 13773, 13773, 2457750, 57749, N'2016-12-27', 201652, 52, 2, N'2016-W52', N'2016-W52-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96420, CAST(N'2016-12-28' AS date), CAST(N'2016-12-29' AS date), 2016, 20164, 201612, 2016363, 4, 12, 363, 28, 4, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-26' AS date), CAST(N'2017-01-01' AS date), CAST(N'2016-12-27' AS date), CAST(N'2017-01-02' AS date), CAST(N'2016-12-28' AS date), CAST(N'2017-01-03' AS date), CAST(N'2016-12-22' AS date), CAST(N'2016-12-28' AS date), CAST(N'2016-12-23' AS date), CAST(N'2016-12-29' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-30' AS date), 1055, 3167, 13773, 13774, 13774, 13774, 13773, 13773, 13773, 2457751, 57750, N'2016-12-28', 201652, 52, 3, N'2016-W52', N'2016-W52-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96421, CAST(N'2016-12-29' AS date), CAST(N'2016-12-30' AS date), 2016, 20164, 201612, 2016364, 4, 12, 364, 29, 5, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-26' AS date), CAST(N'2017-01-01' AS date), CAST(N'2016-12-27' AS date), CAST(N'2017-01-02' AS date), CAST(N'2016-12-28' AS date), CAST(N'2017-01-03' AS date), CAST(N'2016-12-29' AS date), CAST(N'2017-01-04' AS date), CAST(N'2016-12-23' AS date), CAST(N'2016-12-29' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-30' AS date), 1055, 3167, 13773, 13774, 13774, 13774, 13774, 13773, 13773, 2457752, 57751, N'2016-12-29', 201652, 52, 4, N'2016-W52', N'2016-W52-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96422, CAST(N'2016-12-30' AS date), CAST(N'2016-12-31' AS date), 2016, 20164, 201612, 2016365, 4, 12, 365, 30, 6, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-26' AS date), CAST(N'2017-01-01' AS date), CAST(N'2016-12-27' AS date), CAST(N'2017-01-02' AS date), CAST(N'2016-12-28' AS date), CAST(N'2017-01-03' AS date), CAST(N'2016-12-29' AS date), CAST(N'2017-01-04' AS date), CAST(N'2016-12-30' AS date), CAST(N'2017-01-05' AS date), CAST(N'2016-12-24' AS date), CAST(N'2016-12-30' AS date), 1055, 3167, 13773, 13774, 13774, 13774, 13774, 13774, 13773, 2457753, 57752, N'2016-12-30', 201652, 52, 5, N'2016-W52', N'2016-W52-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96423, CAST(N'2016-12-31' AS date), CAST(N'2017-01-01' AS date), 2016, 20164, 201612, 2016366, 4, 12, 366, 31, 7, N'2016', N'2016 Q4', N'2016 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2016-01-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-10-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-01' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-25' AS date), CAST(N'2016-12-31' AS date), CAST(N'2016-12-26' AS date), CAST(N'2017-01-01' AS date), CAST(N'2016-12-27' AS date), CAST(N'2017-01-02' AS date), CAST(N'2016-12-28' AS date), CAST(N'2017-01-03' AS date), CAST(N'2016-12-29' AS date), CAST(N'2017-01-04' AS date), CAST(N'2016-12-30' AS date), CAST(N'2017-01-05' AS date), CAST(N'2016-12-31' AS date), CAST(N'2017-01-06' AS date), 1055, 3167, 13773, 13774, 13774, 13774, 13774, 13774, 13774, 2457754, 57753, N'2016-12-31', 201652, 52, 6, N'2016-W52', N'2016-W52-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96424, CAST(N'2017-01-01' AS date), CAST(N'2017-01-02' AS date), 2017, 20171, 201701, 2017001, 1, 1, 1, 1, 1, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-07' AS date), CAST(N'2016-12-26' AS date), CAST(N'2017-01-01' AS date), CAST(N'2016-12-27' AS date), CAST(N'2017-01-02' AS date), CAST(N'2016-12-28' AS date), CAST(N'2017-01-03' AS date), CAST(N'2016-12-29' AS date), CAST(N'2017-01-04' AS date), CAST(N'2016-12-30' AS date), CAST(N'2017-01-05' AS date), CAST(N'2016-12-31' AS date), CAST(N'2017-01-06' AS date), 1056, 3168, 13774, 13774, 13774, 13774, 13774, 13774, 13774, 2457755, 57754, N'2017-01-01', 201652, 52, 7, N'2016-W52', N'2016-W52-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96425, CAST(N'2017-01-02' AS date), CAST(N'2017-01-03' AS date), 2017, 20171, 201701, 2017002, 1, 1, 2, 2, 2, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-02' AS date), CAST(N'2017-01-08' AS date), CAST(N'2016-12-27' AS date), CAST(N'2017-01-02' AS date), CAST(N'2016-12-28' AS date), CAST(N'2017-01-03' AS date), CAST(N'2016-12-29' AS date), CAST(N'2017-01-04' AS date), CAST(N'2016-12-30' AS date), CAST(N'2017-01-05' AS date), CAST(N'2016-12-31' AS date), CAST(N'2017-01-06' AS date), 1056, 3168, 13774, 13775, 13774, 13774, 13774, 13774, 13774, 2457756, 57755, N'2017-01-02', 201701, 1, 1, N'2017-W01', N'2017-W01-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96426, CAST(N'2017-01-03' AS date), CAST(N'2017-01-04' AS date), 2017, 20171, 201701, 2017003, 1, 1, 3, 3, 3, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-02' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-03' AS date), CAST(N'2017-01-09' AS date), CAST(N'2016-12-28' AS date), CAST(N'2017-01-03' AS date), CAST(N'2016-12-29' AS date), CAST(N'2017-01-04' AS date), CAST(N'2016-12-30' AS date), CAST(N'2017-01-05' AS date), CAST(N'2016-12-31' AS date), CAST(N'2017-01-06' AS date), 1056, 3168, 13774, 13775, 13775, 13774, 13774, 13774, 13774, 2457757, 57756, N'2017-01-03', 201701, 1, 2, N'2017-W01', N'2017-W01-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96427, CAST(N'2017-01-04' AS date), CAST(N'2017-01-05' AS date), 2017, 20171, 201701, 2017004, 1, 1, 4, 4, 4, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-02' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-03' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-04' AS date), CAST(N'2017-01-10' AS date), CAST(N'2016-12-29' AS date), CAST(N'2017-01-04' AS date), CAST(N'2016-12-30' AS date), CAST(N'2017-01-05' AS date), CAST(N'2016-12-31' AS date), CAST(N'2017-01-06' AS date), 1056, 3168, 13774, 13775, 13775, 13775, 13774, 13774, 13774, 2457758, 57757, N'2017-01-04', 201701, 1, 3, N'2017-W01', N'2017-W01-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96428, CAST(N'2017-01-05' AS date), CAST(N'2017-01-06' AS date), 2017, 20171, 201701, 2017005, 1, 1, 5, 5, 5, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-02' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-03' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-04' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-05' AS date), CAST(N'2017-01-11' AS date), CAST(N'2016-12-30' AS date), CAST(N'2017-01-05' AS date), CAST(N'2016-12-31' AS date), CAST(N'2017-01-06' AS date), 1056, 3168, 13774, 13775, 13775, 13775, 13775, 13774, 13774, 2457759, 57758, N'2017-01-05', 201701, 1, 4, N'2017-W01', N'2017-W01-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96429, CAST(N'2017-01-06' AS date), CAST(N'2017-01-07' AS date), 2017, 20171, 201701, 2017006, 1, 1, 6, 6, 6, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-02' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-03' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-04' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-05' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-06' AS date), CAST(N'2017-01-12' AS date), CAST(N'2016-12-31' AS date), CAST(N'2017-01-06' AS date), 1056, 3168, 13774, 13775, 13775, 13775, 13775, 13775, 13774, 2457760, 57759, N'2017-01-06', 201701, 1, 5, N'2017-W01', N'2017-W01-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96430, CAST(N'2017-01-07' AS date), CAST(N'2017-01-08' AS date), 2017, 20171, 201701, 2017007, 1, 1, 7, 7, 7, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-02' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-03' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-04' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-05' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-06' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-13' AS date), 1056, 3168, 13774, 13775, 13775, 13775, 13775, 13775, 13775, 2457761, 57760, N'2017-01-07', 201701, 1, 6, N'2017-W01', N'2017-W01-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96431, CAST(N'2017-01-08' AS date), CAST(N'2017-01-09' AS date), 2017, 20171, 201701, 2017008, 1, 1, 8, 8, 1, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-02' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-03' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-04' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-05' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-06' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-13' AS date), 1056, 3168, 13775, 13775, 13775, 13775, 13775, 13775, 13775, 2457762, 57761, N'2017-01-08', 201701, 1, 7, N'2017-W01', N'2017-W01-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96432, CAST(N'2017-01-09' AS date), CAST(N'2017-01-10' AS date), 2017, 20171, 201701, 2017009, 1, 1, 9, 9, 2, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-03' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-04' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-05' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-06' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-13' AS date), 1056, 3168, 13775, 13776, 13775, 13775, 13775, 13775, 13775, 2457763, 57762, N'2017-01-09', 201702, 2, 1, N'2017-W02', N'2017-W02-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96433, CAST(N'2017-01-10' AS date), CAST(N'2017-01-11' AS date), 2017, 20171, 201701, 2017010, 1, 1, 10, 10, 3, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-04' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-05' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-06' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-13' AS date), 1056, 3168, 13775, 13776, 13776, 13775, 13775, 13775, 13775, 2457764, 57763, N'2017-01-10', 201702, 2, 2, N'2017-W02', N'2017-W02-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96434, CAST(N'2017-01-11' AS date), CAST(N'2017-01-12' AS date), 2017, 20171, 201701, 2017011, 1, 1, 11, 11, 4, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-05' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-06' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-13' AS date), 1056, 3168, 13775, 13776, 13776, 13776, 13775, 13775, 13775, 2457765, 57764, N'2017-01-11', 201702, 2, 3, N'2017-W02', N'2017-W02-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96435, CAST(N'2017-01-12' AS date), CAST(N'2017-01-13' AS date), 2017, 20171, 201701, 2017012, 1, 1, 12, 12, 5, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-06' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-13' AS date), 1056, 3168, 13775, 13776, 13776, 13776, 13776, 13775, 13775, 2457766, 57765, N'2017-01-12', 201702, 2, 4, N'2017-W02', N'2017-W02-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96436, CAST(N'2017-01-13' AS date), CAST(N'2017-01-14' AS date), 2017, 20171, 201701, 2017013, 1, 1, 13, 13, 6, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-13' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-07' AS date), CAST(N'2017-01-13' AS date), 1056, 3168, 13775, 13776, 13776, 13776, 13776, 13776, 13775, 2457767, 57766, N'2017-01-13', 201702, 2, 5, N'2017-W02', N'2017-W02-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96437, CAST(N'2017-01-14' AS date), CAST(N'2017-01-15' AS date), 2017, 20171, 201701, 2017014, 1, 1, 14, 14, 7, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-08' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-13' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-20' AS date), 1056, 3168, 13775, 13776, 13776, 13776, 13776, 13776, 13776, 2457768, 57767, N'2017-01-14', 201702, 2, 6, N'2017-W02', N'2017-W02-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96438, CAST(N'2017-01-15' AS date), CAST(N'2017-01-16' AS date), 2017, 20171, 201701, 2017015, 1, 1, 15, 15, 1, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-09' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-13' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-20' AS date), 1056, 3168, 13776, 13776, 13776, 13776, 13776, 13776, 13776, 2457769, 57768, N'2017-01-15', 201702, 2, 7, N'2017-W02', N'2017-W02-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96439, CAST(N'2017-01-16' AS date), CAST(N'2017-01-17' AS date), 2017, 20171, 201701, 2017016, 1, 1, 16, 16, 2, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-10' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-13' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-20' AS date), 1056, 3168, 13776, 13777, 13776, 13776, 13776, 13776, 13776, 2457770, 57769, N'2017-01-16', 201703, 3, 1, N'2017-W03', N'2017-W03-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96440, CAST(N'2017-01-17' AS date), CAST(N'2017-01-18' AS date), 2017, 20171, 201701, 2017017, 1, 1, 17, 17, 3, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-11' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-13' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-20' AS date), 1056, 3168, 13776, 13777, 13777, 13776, 13776, 13776, 13776, 2457771, 57770, N'2017-01-17', 201703, 3, 2, N'2017-W03', N'2017-W03-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96441, CAST(N'2017-01-18' AS date), CAST(N'2017-01-19' AS date), 2017, 20171, 201701, 2017018, 1, 1, 18, 18, 4, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-12' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-13' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-20' AS date), 1056, 3168, 13776, 13777, 13777, 13777, 13776, 13776, 13776, 2457772, 57771, N'2017-01-18', 201703, 3, 3, N'2017-W03', N'2017-W03-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96442, CAST(N'2017-01-19' AS date), CAST(N'2017-01-20' AS date), 2017, 20171, 201701, 2017019, 1, 1, 19, 19, 5, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-13' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-20' AS date), 1056, 3168, 13776, 13777, 13777, 13777, 13777, 13776, 13776, 2457773, 57772, N'2017-01-19', 201703, 3, 4, N'2017-W03', N'2017-W03-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96443, CAST(N'2017-01-20' AS date), CAST(N'2017-01-21' AS date), 2017, 20171, 201701, 2017020, 1, 1, 20, 20, 6, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-20' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-01-14' AS date), CAST(N'2017-01-20' AS date), 1056, 3168, 13776, 13777, 13777, 13777, 13777, 13777, 13776, 2457774, 57773, N'2017-01-20', 201703, 3, 5, N'2017-W03', N'2017-W03-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96444, CAST(N'2017-01-21' AS date), CAST(N'2017-01-22' AS date), 2017, 20171, 201701, 2017021, 1, 1, 21, 21, 7, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-15' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-20' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-27' AS date), 1056, 3168, 13776, 13777, 13777, 13777, 13777, 13777, 13777, 2457775, 57774, N'2017-01-21', 201703, 3, 6, N'2017-W03', N'2017-W03-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96445, CAST(N'2017-01-22' AS date), CAST(N'2017-01-23' AS date), 2017, 20171, 201701, 2017022, 1, 1, 22, 22, 1, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-01-16' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-20' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-27' AS date), 1056, 3168, 13777, 13777, 13777, 13777, 13777, 13777, 13777, 2457776, 57775, N'2017-01-22', 201703, 3, 7, N'2017-W03', N'2017-W03-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96446, CAST(N'2017-01-23' AS date), CAST(N'2017-01-24' AS date), 2017, 20171, 201701, 2017023, 1, 1, 23, 23, 2, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-01-17' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-20' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-27' AS date), 1056, 3168, 13777, 13778, 13777, 13777, 13777, 13777, 13777, 2457777, 57776, N'2017-01-23', 201704, 4, 1, N'2017-W04', N'2017-W04-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96447, CAST(N'2017-01-24' AS date), CAST(N'2017-01-25' AS date), 2017, 20171, 201701, 2017024, 1, 1, 24, 24, 3, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-01-18' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-20' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-27' AS date), 1056, 3168, 13777, 13778, 13778, 13777, 13777, 13777, 13777, 2457778, 57777, N'2017-01-24', 201704, 4, 2, N'2017-W04', N'2017-W04-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96448, CAST(N'2017-01-25' AS date), CAST(N'2017-01-26' AS date), 2017, 20171, 201701, 2017025, 1, 1, 25, 25, 4, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-19' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-20' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-27' AS date), 1056, 3168, 13777, 13778, 13778, 13778, 13777, 13777, 13777, 2457779, 57778, N'2017-01-25', 201704, 4, 3, N'2017-W04', N'2017-W04-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96449, CAST(N'2017-01-26' AS date), CAST(N'2017-01-27' AS date), 2017, 20171, 201701, 2017026, 1, 1, 26, 26, 5, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-01-20' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-27' AS date), 1056, 3168, 13777, 13778, 13778, 13778, 13778, 13777, 13777, 2457780, 57779, N'2017-01-26', 201704, 4, 4, N'2017-W04', N'2017-W04-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96450, CAST(N'2017-01-27' AS date), CAST(N'2017-01-28' AS date), 2017, 20171, 201701, 2017027, 1, 1, 27, 27, 6, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-01-27' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-01-21' AS date), CAST(N'2017-01-27' AS date), 1056, 3168, 13777, 13778, 13778, 13778, 13778, 13778, 13777, 2457781, 57780, N'2017-01-27', 201704, 4, 5, N'2017-W04', N'2017-W04-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96451, CAST(N'2017-01-28' AS date), CAST(N'2017-01-29' AS date), 2017, 20171, 201701, 2017028, 1, 1, 28, 28, 7, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-22' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-01-27' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-02-03' AS date), 1056, 3168, 13777, 13778, 13778, 13778, 13778, 13778, 13778, 2457782, 57781, N'2017-01-28', 201704, 4, 6, N'2017-W04', N'2017-W04-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96452, CAST(N'2017-01-29' AS date), CAST(N'2017-01-30' AS date), 2017, 20171, 201701, 2017029, 1, 1, 29, 29, 1, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-01-23' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-01-27' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-02-03' AS date), 1056, 3168, 13778, 13778, 13778, 13778, 13778, 13778, 13778, 2457783, 57782, N'2017-01-29', 201704, 4, 7, N'2017-W04', N'2017-W04-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96453, CAST(N'2017-01-30' AS date), CAST(N'2017-01-31' AS date), 2017, 20171, 201701, 2017030, 1, 1, 30, 30, 2, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-01-24' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-01-27' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-02-03' AS date), 1056, 3168, 13778, 13779, 13778, 13778, 13778, 13778, 13778, 2457784, 57783, N'2017-01-30', 201705, 5, 1, N'2017-W05', N'2017-W05-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96454, CAST(N'2017-01-31' AS date), CAST(N'2017-02-01' AS date), 2017, 20171, 201701, 2017031, 1, 1, 31, 31, 3, N'2017', N'2017 Q1', N'2017 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-01-25' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-01-27' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-02-03' AS date), 1056, 3168, 13778, 13779, 13779, 13778, 13778, 13778, 13778, 2457785, 57784, N'2017-01-31', 201705, 5, 2, N'2017-W05', N'2017-W05-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96455, CAST(N'2017-02-01' AS date), CAST(N'2017-02-02' AS date), 2017, 20171, 201702, 2017032, 1, 2, 32, 1, 4, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-01-26' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-01-27' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-02-03' AS date), 1056, 3169, 13778, 13779, 13779, 13779, 13778, 13778, 13778, 2457786, 57785, N'2017-02-01', 201705, 5, 3, N'2017-W05', N'2017-W05-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96456, CAST(N'2017-02-02' AS date), CAST(N'2017-02-03' AS date), 2017, 20171, 201702, 2017033, 1, 2, 33, 2, 5, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-01-27' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-02-03' AS date), 1056, 3169, 13778, 13779, 13779, 13779, 13779, 13778, 13778, 2457787, 57786, N'2017-02-02', 201705, 5, 4, N'2017-W05', N'2017-W05-4');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96457, CAST(N'2017-02-03' AS date), CAST(N'2017-02-04' AS date), 2017, 20171, 201702, 2017034, 1, 2, 34, 3, 6, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-03' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-01-28' AS date), CAST(N'2017-02-03' AS date), 1056, 3169, 13778, 13779, 13779, 13779, 13779, 13779, 13778, 2457788, 57787, N'2017-02-03', 201705, 5, 5, N'2017-W05', N'2017-W05-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96458, CAST(N'2017-02-04' AS date), CAST(N'2017-02-05' AS date), 2017, 20171, 201702, 2017035, 1, 2, 35, 4, 7, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-01-29' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-03' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-02-10' AS date), 1056, 3169, 13778, 13779, 13779, 13779, 13779, 13779, 13779, 2457789, 57788, N'2017-02-04', 201705, 5, 6, N'2017-W05', N'2017-W05-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96459, CAST(N'2017-02-05' AS date), CAST(N'2017-02-06' AS date), 2017, 20171, 201702, 2017036, 1, 2, 36, 5, 1, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-01-30' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-03' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-02-10' AS date), 1056, 3169, 13779, 13779, 13779, 13779, 13779, 13779, 13779, 2457790, 57789, N'2017-02-05', 201705, 5, 7, N'2017-W05', N'2017-W05-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96460, CAST(N'2017-02-06' AS date), CAST(N'2017-02-07' AS date), 2017, 20171, 201702, 2017037, 1, 2, 37, 6, 2, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-01-31' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-03' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-02-10' AS date), 1056, 3169, 13779, 13780, 13779, 13779, 13779, 13779, 13779, 2457791, 57790, N'2017-02-06', 201706, 6, 1, N'2017-W06', N'2017-W06-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96461, CAST(N'2017-02-07' AS date), CAST(N'2017-02-08' AS date), 2017, 20171, 201702, 2017038, 1, 2, 38, 7, 3, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-03' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-02-10' AS date), 1056, 3169, 13779, 13780, 13780, 13779, 13779, 13779, 13779, 2457792, 57791, N'2017-02-07', 201706, 6, 2, N'2017-W06', N'2017-W06-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96462, CAST(N'2017-02-08' AS date), CAST(N'2017-02-09' AS date), 2017, 20171, 201702, 2017039, 1, 2, 39, 8, 4, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-02' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-03' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-02-10' AS date), 1056, 3169, 13779, 13780, 13780, 13780, 13779, 13779, 13779, 2457793, 57792, N'2017-02-08', 201706, 6, 3, N'2017-W06', N'2017-W06-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96463, CAST(N'2017-02-09' AS date), CAST(N'2017-02-10' AS date), 2017, 20171, 201702, 2017040, 1, 2, 40, 9, 5, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-03' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-02-10' AS date), 1056, 3169, 13779, 13780, 13780, 13780, 13780, 13779, 13779, 2457794, 57793, N'2017-02-09', 201706, 6, 4, N'2017-W06', N'2017-W06-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96464, CAST(N'2017-02-10' AS date), CAST(N'2017-02-11' AS date), 2017, 20171, 201702, 2017041, 1, 2, 41, 10, 6, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-10' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-04' AS date), CAST(N'2017-02-10' AS date), 1056, 3169, 13779, 13780, 13780, 13780, 13780, 13780, 13779, 2457795, 57794, N'2017-02-10', 201706, 6, 5, N'2017-W06', N'2017-W06-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96465, CAST(N'2017-02-11' AS date), CAST(N'2017-02-12' AS date), 2017, 20171, 201702, 2017042, 1, 2, 42, 11, 7, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-05' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-10' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-17' AS date), 1056, 3169, 13779, 13780, 13780, 13780, 13780, 13780, 13780, 2457796, 57795, N'2017-02-11', 201706, 6, 6, N'2017-W06', N'2017-W06-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96466, CAST(N'2017-02-12' AS date), CAST(N'2017-02-13' AS date), 2017, 20171, 201702, 2017043, 1, 2, 43, 12, 1, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-06' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-10' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-17' AS date), 1056, 3169, 13780, 13780, 13780, 13780, 13780, 13780, 13780, 2457797, 57796, N'2017-02-12', 201706, 6, 7, N'2017-W06', N'2017-W06-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96467, CAST(N'2017-02-13' AS date), CAST(N'2017-02-14' AS date), 2017, 20171, 201702, 2017044, 1, 2, 44, 13, 2, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-07' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-10' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-17' AS date), 1056, 3169, 13780, 13781, 13780, 13780, 13780, 13780, 13780, 2457798, 57797, N'2017-02-13', 201707, 7, 1, N'2017-W07', N'2017-W07-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96468, CAST(N'2017-02-14' AS date), CAST(N'2017-02-15' AS date), 2017, 20171, 201702, 2017045, 1, 2, 45, 14, 3, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-08' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-10' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-17' AS date), 1056, 3169, 13780, 13781, 13781, 13780, 13780, 13780, 13780, 2457799, 57798, N'2017-02-14', 201707, 7, 2, N'2017-W07', N'2017-W07-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96469, CAST(N'2017-02-15' AS date), CAST(N'2017-02-16' AS date), 2017, 20171, 201702, 2017046, 1, 2, 46, 15, 4, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-09' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-10' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-17' AS date), 1056, 3169, 13780, 13781, 13781, 13781, 13780, 13780, 13780, 2457800, 57799, N'2017-02-15', 201707, 7, 3, N'2017-W07', N'2017-W07-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96470, CAST(N'2017-02-16' AS date), CAST(N'2017-02-17' AS date), 2017, 20171, 201702, 2017047, 1, 2, 47, 16, 5, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-10' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-17' AS date), 1056, 3169, 13780, 13781, 13781, 13781, 13781, 13780, 13780, 2457801, 57800, N'2017-02-16', 201707, 7, 4, N'2017-W07', N'2017-W07-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96471, CAST(N'2017-02-17' AS date), CAST(N'2017-02-18' AS date), 2017, 20171, 201702, 2017048, 1, 2, 48, 17, 6, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-17' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-02-11' AS date), CAST(N'2017-02-17' AS date), 1056, 3169, 13780, 13781, 13781, 13781, 13781, 13781, 13780, 2457802, 57801, N'2017-02-17', 201707, 7, 5, N'2017-W07', N'2017-W07-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96472, CAST(N'2017-02-18' AS date), CAST(N'2017-02-19' AS date), 2017, 20171, 201702, 2017049, 1, 2, 49, 18, 7, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-12' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-17' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-24' AS date), 1056, 3169, 13780, 13781, 13781, 13781, 13781, 13781, 13781, 2457803, 57802, N'2017-02-18', 201707, 7, 6, N'2017-W07', N'2017-W07-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96473, CAST(N'2017-02-19' AS date), CAST(N'2017-02-20' AS date), 2017, 20171, 201702, 2017050, 1, 2, 50, 19, 1, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-02-13' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-17' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-24' AS date), 1056, 3169, 13781, 13781, 13781, 13781, 13781, 13781, 13781, 2457804, 57803, N'2017-02-19', 201707, 7, 7, N'2017-W07', N'2017-W07-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96474, CAST(N'2017-02-20' AS date), CAST(N'2017-02-21' AS date), 2017, 20171, 201702, 2017051, 1, 2, 51, 20, 2, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-02-14' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-17' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-24' AS date), 1056, 3169, 13781, 13782, 13781, 13781, 13781, 13781, 13781, 2457805, 57804, N'2017-02-20', 201708, 8, 1, N'2017-W08', N'2017-W08-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96475, CAST(N'2017-02-21' AS date), CAST(N'2017-02-22' AS date), 2017, 20171, 201702, 2017052, 1, 2, 52, 21, 3, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-02-15' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-17' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-24' AS date), 1056, 3169, 13781, 13782, 13782, 13781, 13781, 13781, 13781, 2457806, 57805, N'2017-02-21', 201708, 8, 2, N'2017-W08', N'2017-W08-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96476, CAST(N'2017-02-22' AS date), CAST(N'2017-02-23' AS date), 2017, 20171, 201702, 2017053, 1, 2, 53, 22, 4, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-16' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-17' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-24' AS date), 1056, 3169, 13781, 13782, 13782, 13782, 13781, 13781, 13781, 2457807, 57806, N'2017-02-22', 201708, 8, 3, N'2017-W08', N'2017-W08-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96477, CAST(N'2017-02-23' AS date), CAST(N'2017-02-24' AS date), 2017, 20171, 201702, 2017054, 1, 2, 54, 23, 5, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-02-17' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-24' AS date), 1056, 3169, 13781, 13782, 13782, 13782, 13782, 13781, 13781, 2457808, 57807, N'2017-02-23', 201708, 8, 4, N'2017-W08', N'2017-W08-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96478, CAST(N'2017-02-24' AS date), CAST(N'2017-02-25' AS date), 2017, 20171, 201702, 2017055, 1, 2, 55, 24, 6, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-02-24' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-02-18' AS date), CAST(N'2017-02-24' AS date), 1056, 3169, 13781, 13782, 13782, 13782, 13782, 13782, 13781, 2457809, 57808, N'2017-02-24', 201708, 8, 5, N'2017-W08', N'2017-W08-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96479, CAST(N'2017-02-25' AS date), CAST(N'2017-02-26' AS date), 2017, 20171, 201702, 2017056, 1, 2, 56, 25, 7, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-19' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-02-24' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-03-03' AS date), 1056, 3169, 13781, 13782, 13782, 13782, 13782, 13782, 13782, 2457810, 57809, N'2017-02-25', 201708, 8, 6, N'2017-W08', N'2017-W08-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96480, CAST(N'2017-02-26' AS date), CAST(N'2017-02-27' AS date), 2017, 20171, 201702, 2017057, 1, 2, 57, 26, 1, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-02-20' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-02-24' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-03-03' AS date), 1056, 3169, 13782, 13782, 13782, 13782, 13782, 13782, 13782, 2457811, 57810, N'2017-02-26', 201708, 8, 7, N'2017-W08', N'2017-W08-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96481, CAST(N'2017-02-27' AS date), CAST(N'2017-02-28' AS date), 2017, 20171, 201702, 2017058, 1, 2, 58, 27, 2, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-02-21' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-02-24' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-03-03' AS date), 1056, 3169, 13782, 13783, 13782, 13782, 13782, 13782, 13782, 2457812, 57811, N'2017-02-27', 201709, 9, 1, N'2017-W09', N'2017-W09-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96482, CAST(N'2017-02-28' AS date), CAST(N'2017-03-01' AS date), 2017, 20171, 201702, 2017059, 1, 2, 59, 28, 3, N'2017', N'2017 Q1', N'2017 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-01' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-02-22' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-02-24' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-03-03' AS date), 1056, 3169, 13782, 13783, 13783, 13782, 13782, 13782, 13782, 2457813, 57812, N'2017-02-28', 201709, 9, 2, N'2017-W09', N'2017-W09-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96483, CAST(N'2017-03-01' AS date), CAST(N'2017-03-02' AS date), 2017, 20171, 201703, 2017060, 1, 3, 60, 1, 4, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-02-23' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-02-24' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-03-03' AS date), 1056, 3170, 13782, 13783, 13783, 13783, 13782, 13782, 13782, 2457814, 57813, N'2017-03-01', 201709, 9, 3, N'2017-W09', N'2017-W09-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96484, CAST(N'2017-03-02' AS date), CAST(N'2017-03-03' AS date), 2017, 20171, 201703, 2017061, 1, 3, 61, 2, 5, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-02-24' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-03-03' AS date), 1056, 3170, 13782, 13783, 13783, 13783, 13783, 13782, 13782, 2457815, 57814, N'2017-03-02', 201709, 9, 4, N'2017-W09', N'2017-W09-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96485, CAST(N'2017-03-03' AS date), CAST(N'2017-03-04' AS date), 2017, 20171, 201703, 2017062, 1, 3, 62, 3, 6, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-03' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-02-25' AS date), CAST(N'2017-03-03' AS date), 1056, 3170, 13782, 13783, 13783, 13783, 13783, 13783, 13782, 2457816, 57815, N'2017-03-03', 201709, 9, 5, N'2017-W09', N'2017-W09-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96486, CAST(N'2017-03-04' AS date), CAST(N'2017-03-05' AS date), 2017, 20171, 201703, 2017063, 1, 3, 63, 4, 7, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-02-26' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-03' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-03-10' AS date), 1056, 3170, 13782, 13783, 13783, 13783, 13783, 13783, 13783, 2457817, 57816, N'2017-03-04', 201709, 9, 6, N'2017-W09', N'2017-W09-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96487, CAST(N'2017-03-05' AS date), CAST(N'2017-03-06' AS date), 2017, 20171, 201703, 2017064, 1, 3, 64, 5, 1, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-02-27' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-03' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-03-10' AS date), 1056, 3170, 13783, 13783, 13783, 13783, 13783, 13783, 13783, 2457818, 57817, N'2017-03-05', 201709, 9, 7, N'2017-W09', N'2017-W09-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96488, CAST(N'2017-03-06' AS date), CAST(N'2017-03-07' AS date), 2017, 20171, 201703, 2017065, 1, 3, 65, 6, 2, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-02-28' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-03' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-03-10' AS date), 1056, 3170, 13783, 13784, 13783, 13783, 13783, 13783, 13783, 2457819, 57818, N'2017-03-06', 201710, 10, 1, N'2017-W10', N'2017-W10-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96489, CAST(N'2017-03-07' AS date), CAST(N'2017-03-08' AS date), 2017, 20171, 201703, 2017066, 1, 3, 66, 7, 3, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-03' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-03-10' AS date), 1056, 3170, 13783, 13784, 13784, 13783, 13783, 13783, 13783, 2457820, 57819, N'2017-03-07', 201710, 10, 2, N'2017-W10', N'2017-W10-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96490, CAST(N'2017-03-08' AS date), CAST(N'2017-03-09' AS date), 2017, 20171, 201703, 2017067, 1, 3, 67, 8, 4, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-02' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-03' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-03-10' AS date), 1056, 3170, 13783, 13784, 13784, 13784, 13783, 13783, 13783, 2457821, 57820, N'2017-03-08', 201710, 10, 3, N'2017-W10', N'2017-W10-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96491, CAST(N'2017-03-09' AS date), CAST(N'2017-03-10' AS date), 2017, 20171, 201703, 2017068, 1, 3, 68, 9, 5, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-03' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-03-10' AS date), 1056, 3170, 13783, 13784, 13784, 13784, 13784, 13783, 13783, 2457822, 57821, N'2017-03-09', 201710, 10, 4, N'2017-W10', N'2017-W10-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96492, CAST(N'2017-03-10' AS date), CAST(N'2017-03-11' AS date), 2017, 20171, 201703, 2017069, 1, 3, 69, 10, 6, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-10' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-04' AS date), CAST(N'2017-03-10' AS date), 1056, 3170, 13783, 13784, 13784, 13784, 13784, 13784, 13783, 2457823, 57822, N'2017-03-10', 201710, 10, 5, N'2017-W10', N'2017-W10-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96493, CAST(N'2017-03-11' AS date), CAST(N'2017-03-12' AS date), 2017, 20171, 201703, 2017070, 1, 3, 70, 11, 7, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-05' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-10' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-17' AS date), 1056, 3170, 13783, 13784, 13784, 13784, 13784, 13784, 13784, 2457824, 57823, N'2017-03-11', 201710, 10, 6, N'2017-W10', N'2017-W10-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96494, CAST(N'2017-03-12' AS date), CAST(N'2017-03-13' AS date), 2017, 20171, 201703, 2017071, 1, 3, 71, 12, 1, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-06' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-10' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-17' AS date), 1056, 3170, 13784, 13784, 13784, 13784, 13784, 13784, 13784, 2457825, 57824, N'2017-03-12', 201710, 10, 7, N'2017-W10', N'2017-W10-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96495, CAST(N'2017-03-13' AS date), CAST(N'2017-03-14' AS date), 2017, 20171, 201703, 2017072, 1, 3, 72, 13, 2, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-07' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-10' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-17' AS date), 1056, 3170, 13784, 13785, 13784, 13784, 13784, 13784, 13784, 2457826, 57825, N'2017-03-13', 201711, 11, 1, N'2017-W11', N'2017-W11-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96496, CAST(N'2017-03-14' AS date), CAST(N'2017-03-15' AS date), 2017, 20171, 201703, 2017073, 1, 3, 73, 14, 3, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-08' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-10' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-17' AS date), 1056, 3170, 13784, 13785, 13785, 13784, 13784, 13784, 13784, 2457827, 57826, N'2017-03-14', 201711, 11, 2, N'2017-W11', N'2017-W11-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96497, CAST(N'2017-03-15' AS date), CAST(N'2017-03-16' AS date), 2017, 20171, 201703, 2017074, 1, 3, 74, 15, 4, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-09' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-10' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-17' AS date), 1056, 3170, 13784, 13785, 13785, 13785, 13784, 13784, 13784, 2457828, 57827, N'2017-03-15', 201711, 11, 3, N'2017-W11', N'2017-W11-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96498, CAST(N'2017-03-16' AS date), CAST(N'2017-03-17' AS date), 2017, 20171, 201703, 2017075, 1, 3, 75, 16, 5, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-10' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-17' AS date), 1056, 3170, 13784, 13785, 13785, 13785, 13785, 13784, 13784, 2457829, 57828, N'2017-03-16', 201711, 11, 4, N'2017-W11', N'2017-W11-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96499, CAST(N'2017-03-17' AS date), CAST(N'2017-03-18' AS date), 2017, 20171, 201703, 2017076, 1, 3, 76, 17, 6, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-17' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-11' AS date), CAST(N'2017-03-17' AS date), 1056, 3170, 13784, 13785, 13785, 13785, 13785, 13785, 13784, 2457830, 57829, N'2017-03-17', 201711, 11, 5, N'2017-W11', N'2017-W11-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96500, CAST(N'2017-03-18' AS date), CAST(N'2017-03-19' AS date), 2017, 20171, 201703, 2017077, 1, 3, 77, 18, 7, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-12' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-17' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-24' AS date), 1056, 3170, 13784, 13785, 13785, 13785, 13785, 13785, 13785, 2457831, 57830, N'2017-03-18', 201711, 11, 6, N'2017-W11', N'2017-W11-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96501, CAST(N'2017-03-19' AS date), CAST(N'2017-03-20' AS date), 2017, 20171, 201703, 2017078, 1, 3, 78, 19, 1, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-13' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-17' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-24' AS date), 1056, 3170, 13785, 13785, 13785, 13785, 13785, 13785, 13785, 2457832, 57831, N'2017-03-19', 201711, 11, 7, N'2017-W11', N'2017-W11-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96502, CAST(N'2017-03-20' AS date), CAST(N'2017-03-21' AS date), 2017, 20171, 201703, 2017079, 1, 3, 79, 20, 2, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-03-14' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-17' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-24' AS date), 1056, 3170, 13785, 13786, 13785, 13785, 13785, 13785, 13785, 2457833, 57832, N'2017-03-20', 201712, 12, 1, N'2017-W12', N'2017-W12-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96503, CAST(N'2017-03-21' AS date), CAST(N'2017-03-22' AS date), 2017, 20171, 201703, 2017080, 1, 3, 80, 21, 3, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-03-15' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-17' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-24' AS date), 1056, 3170, 13785, 13786, 13786, 13785, 13785, 13785, 13785, 2457834, 57833, N'2017-03-21', 201712, 12, 2, N'2017-W12', N'2017-W12-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96504, CAST(N'2017-03-22' AS date), CAST(N'2017-03-23' AS date), 2017, 20171, 201703, 2017081, 1, 3, 81, 22, 4, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-03-16' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-17' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-24' AS date), 1056, 3170, 13785, 13786, 13786, 13786, 13785, 13785, 13785, 2457835, 57834, N'2017-03-22', 201712, 12, 3, N'2017-W12', N'2017-W12-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96505, CAST(N'2017-03-23' AS date), CAST(N'2017-03-24' AS date), 2017, 20171, 201703, 2017082, 1, 3, 82, 23, 5, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-03-17' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-24' AS date), 1056, 3170, 13785, 13786, 13786, 13786, 13786, 13785, 13785, 2457836, 57835, N'2017-03-23', 201712, 12, 4, N'2017-W12', N'2017-W12-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96506, CAST(N'2017-03-24' AS date), CAST(N'2017-03-25' AS date), 2017, 20171, 201703, 2017083, 1, 3, 83, 24, 6, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-03-24' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-03-18' AS date), CAST(N'2017-03-24' AS date), 1056, 3170, 13785, 13786, 13786, 13786, 13786, 13786, 13785, 2457837, 57836, N'2017-03-24', 201712, 12, 5, N'2017-W12', N'2017-W12-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96507, CAST(N'2017-03-25' AS date), CAST(N'2017-03-26' AS date), 2017, 20171, 201703, 2017084, 1, 3, 84, 25, 7, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-19' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-03-24' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-31' AS date), 1056, 3170, 13785, 13786, 13786, 13786, 13786, 13786, 13786, 2457838, 57837, N'2017-03-25', 201712, 12, 6, N'2017-W12', N'2017-W12-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96508, CAST(N'2017-03-26' AS date), CAST(N'2017-03-27' AS date), 2017, 20171, 201703, 2017085, 1, 3, 85, 26, 1, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-03-20' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-03-24' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-31' AS date), 1056, 3170, 13786, 13786, 13786, 13786, 13786, 13786, 13786, 2457839, 57838, N'2017-03-26', 201712, 12, 7, N'2017-W12', N'2017-W12-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96509, CAST(N'2017-03-27' AS date), CAST(N'2017-03-28' AS date), 2017, 20171, 201703, 2017086, 1, 3, 86, 27, 2, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-03-21' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-03-24' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-31' AS date), 1056, 3170, 13786, 13787, 13786, 13786, 13786, 13786, 13786, 2457840, 57839, N'2017-03-27', 201713, 13, 1, N'2017-W13', N'2017-W13-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96510, CAST(N'2017-03-28' AS date), CAST(N'2017-03-29' AS date), 2017, 20171, 201703, 2017087, 1, 3, 87, 28, 3, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-03-22' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-03-24' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-31' AS date), 1056, 3170, 13786, 13787, 13787, 13786, 13786, 13786, 13786, 2457841, 57840, N'2017-03-28', 201713, 13, 2, N'2017-W13', N'2017-W13-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96511, CAST(N'2017-03-29' AS date), CAST(N'2017-03-30' AS date), 2017, 20171, 201703, 2017088, 1, 3, 88, 29, 4, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-03-23' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-03-24' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-31' AS date), 1056, 3170, 13786, 13787, 13787, 13787, 13786, 13786, 13786, 2457842, 57841, N'2017-03-29', 201713, 13, 3, N'2017-W13', N'2017-W13-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96512, CAST(N'2017-03-30' AS date), CAST(N'2017-03-31' AS date), 2017, 20171, 201703, 2017089, 1, 3, 89, 30, 5, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-03-24' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-31' AS date), 1056, 3170, 13786, 13787, 13787, 13787, 13787, 13786, 13786, 2457843, 57842, N'2017-03-30', 201713, 13, 4, N'2017-W13', N'2017-W13-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96513, CAST(N'2017-03-31' AS date), CAST(N'2017-04-01' AS date), 2017, 20171, 201703, 2017090, 1, 3, 90, 31, 6, N'2017', N'2017 Q1', N'2017 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-01-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-01' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-03-25' AS date), CAST(N'2017-03-31' AS date), 1056, 3170, 13786, 13787, 13787, 13787, 13787, 13787, 13786, 2457844, 57843, N'2017-03-31', 201713, 13, 5, N'2017-W13', N'2017-W13-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96514, CAST(N'2017-04-01' AS date), CAST(N'2017-04-02' AS date), 2017, 20172, 201704, 2017091, 2, 4, 91, 1, 7, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-03-26' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-07' AS date), 1057, 3171, 13786, 13787, 13787, 13787, 13787, 13787, 13787, 2457845, 57844, N'2017-04-01', 201713, 13, 6, N'2017-W13', N'2017-W13-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96515, CAST(N'2017-04-02' AS date), CAST(N'2017-04-03' AS date), 2017, 20172, 201704, 2017092, 2, 4, 92, 2, 1, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-03-27' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-07' AS date), 1057, 3171, 13787, 13787, 13787, 13787, 13787, 13787, 13787, 2457846, 57845, N'2017-04-02', 201713, 13, 7, N'2017-W13', N'2017-W13-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96516, CAST(N'2017-04-03' AS date), CAST(N'2017-04-04' AS date), 2017, 20172, 201704, 2017093, 2, 4, 93, 3, 2, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-03-28' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-07' AS date), 1057, 3171, 13787, 13788, 13787, 13787, 13787, 13787, 13787, 2457847, 57846, N'2017-04-03', 201714, 14, 1, N'2017-W14', N'2017-W14-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96517, CAST(N'2017-04-04' AS date), CAST(N'2017-04-05' AS date), 2017, 20172, 201704, 2017094, 2, 4, 94, 4, 3, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-03-29' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-07' AS date), 1057, 3171, 13787, 13788, 13788, 13787, 13787, 13787, 13787, 2457848, 57847, N'2017-04-04', 201714, 14, 2, N'2017-W14', N'2017-W14-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96518, CAST(N'2017-04-05' AS date), CAST(N'2017-04-06' AS date), 2017, 20172, 201704, 2017095, 2, 4, 95, 5, 4, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-03-30' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-07' AS date), 1057, 3171, 13787, 13788, 13788, 13788, 13787, 13787, 13787, 2457849, 57848, N'2017-04-05', 201714, 14, 3, N'2017-W14', N'2017-W14-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96519, CAST(N'2017-04-06' AS date), CAST(N'2017-04-07' AS date), 2017, 20172, 201704, 2017096, 2, 4, 96, 6, 5, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-03-31' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-07' AS date), 1057, 3171, 13787, 13788, 13788, 13788, 13788, 13787, 13787, 2457850, 57849, N'2017-04-06', 201714, 14, 4, N'2017-W14', N'2017-W14-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96520, CAST(N'2017-04-07' AS date), CAST(N'2017-04-08' AS date), 2017, 20172, 201704, 2017097, 2, 4, 97, 7, 6, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-07' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-07' AS date), 1057, 3171, 13787, 13788, 13788, 13788, 13788, 13788, 13787, 2457851, 57850, N'2017-04-07', 201714, 14, 5, N'2017-W14', N'2017-W14-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96521, CAST(N'2017-04-08' AS date), CAST(N'2017-04-09' AS date), 2017, 20172, 201704, 2017098, 2, 4, 98, 8, 7, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-02' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-07' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-14' AS date), 1057, 3171, 13787, 13788, 13788, 13788, 13788, 13788, 13788, 2457852, 57851, N'2017-04-08', 201714, 14, 6, N'2017-W14', N'2017-W14-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96522, CAST(N'2017-04-09' AS date), CAST(N'2017-04-10' AS date), 2017, 20172, 201704, 2017099, 2, 4, 99, 9, 1, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-03' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-07' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-14' AS date), 1057, 3171, 13788, 13788, 13788, 13788, 13788, 13788, 13788, 2457853, 57852, N'2017-04-09', 201714, 14, 7, N'2017-W14', N'2017-W14-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96523, CAST(N'2017-04-10' AS date), CAST(N'2017-04-11' AS date), 2017, 20172, 201704, 2017100, 2, 4, 100, 10, 2, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-04' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-07' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-14' AS date), 1057, 3171, 13788, 13789, 13788, 13788, 13788, 13788, 13788, 2457854, 57853, N'2017-04-10', 201715, 15, 1, N'2017-W15', N'2017-W15-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96524, CAST(N'2017-04-11' AS date), CAST(N'2017-04-12' AS date), 2017, 20172, 201704, 2017101, 2, 4, 101, 11, 3, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-05' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-07' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-14' AS date), 1057, 3171, 13788, 13789, 13789, 13788, 13788, 13788, 13788, 2457855, 57854, N'2017-04-11', 201715, 15, 2, N'2017-W15', N'2017-W15-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96525, CAST(N'2017-04-12' AS date), CAST(N'2017-04-13' AS date), 2017, 20172, 201704, 2017102, 2, 4, 102, 12, 4, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-06' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-07' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-14' AS date), 1057, 3171, 13788, 13789, 13789, 13789, 13788, 13788, 13788, 2457856, 57855, N'2017-04-12', 201715, 15, 3, N'2017-W15', N'2017-W15-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96526, CAST(N'2017-04-13' AS date), CAST(N'2017-04-14' AS date), 2017, 20172, 201704, 2017103, 2, 4, 103, 13, 5, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-07' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-14' AS date), 1057, 3171, 13788, 13789, 13789, 13789, 13789, 13788, 13788, 2457857, 57856, N'2017-04-13', 201715, 15, 4, N'2017-W15', N'2017-W15-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96527, CAST(N'2017-04-14' AS date), CAST(N'2017-04-15' AS date), 2017, 20172, 201704, 2017104, 2, 4, 104, 14, 6, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-14' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-08' AS date), CAST(N'2017-04-14' AS date), 1057, 3171, 13788, 13789, 13789, 13789, 13789, 13789, 13788, 2457858, 57857, N'2017-04-14', 201715, 15, 5, N'2017-W15', N'2017-W15-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96528, CAST(N'2017-04-15' AS date), CAST(N'2017-04-16' AS date), 2017, 20172, 201704, 2017105, 2, 4, 105, 15, 7, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-09' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-14' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-21' AS date), 1057, 3171, 13788, 13789, 13789, 13789, 13789, 13789, 13789, 2457859, 57858, N'2017-04-15', 201715, 15, 6, N'2017-W15', N'2017-W15-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96529, CAST(N'2017-04-16' AS date), CAST(N'2017-04-17' AS date), 2017, 20172, 201704, 2017106, 2, 4, 106, 16, 1, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-10' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-14' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-21' AS date), 1057, 3171, 13789, 13789, 13789, 13789, 13789, 13789, 13789, 2457860, 57859, N'2017-04-16', 201715, 15, 7, N'2017-W15', N'2017-W15-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96530, CAST(N'2017-04-17' AS date), CAST(N'2017-04-18' AS date), 2017, 20172, 201704, 2017107, 2, 4, 107, 17, 2, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-11' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-14' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-21' AS date), 1057, 3171, 13789, 13790, 13789, 13789, 13789, 13789, 13789, 2457861, 57860, N'2017-04-17', 201716, 16, 1, N'2017-W16', N'2017-W16-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96531, CAST(N'2017-04-18' AS date), CAST(N'2017-04-19' AS date), 2017, 20172, 201704, 2017108, 2, 4, 108, 18, 3, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-12' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-14' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-21' AS date), 1057, 3171, 13789, 13790, 13790, 13789, 13789, 13789, 13789, 2457862, 57861, N'2017-04-18', 201716, 16, 2, N'2017-W16', N'2017-W16-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96532, CAST(N'2017-04-19' AS date), CAST(N'2017-04-20' AS date), 2017, 20172, 201704, 2017109, 2, 4, 109, 19, 4, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-04-13' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-14' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-21' AS date), 1057, 3171, 13789, 13790, 13790, 13790, 13789, 13789, 13789, 2457863, 57862, N'2017-04-19', 201716, 16, 3, N'2017-W16', N'2017-W16-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96533, CAST(N'2017-04-20' AS date), CAST(N'2017-04-21' AS date), 2017, 20172, 201704, 2017110, 2, 4, 110, 20, 5, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-04-14' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-21' AS date), 1057, 3171, 13789, 13790, 13790, 13790, 13790, 13789, 13789, 2457864, 57863, N'2017-04-20', 201716, 16, 4, N'2017-W16', N'2017-W16-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96534, CAST(N'2017-04-21' AS date), CAST(N'2017-04-22' AS date), 2017, 20172, 201704, 2017111, 2, 4, 111, 21, 6, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-04-21' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-04-15' AS date), CAST(N'2017-04-21' AS date), 1057, 3171, 13789, 13790, 13790, 13790, 13790, 13790, 13789, 2457865, 57864, N'2017-04-21', 201716, 16, 5, N'2017-W16', N'2017-W16-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96535, CAST(N'2017-04-22' AS date), CAST(N'2017-04-23' AS date), 2017, 20172, 201704, 2017112, 2, 4, 112, 22, 7, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-16' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-04-21' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-28' AS date), 1057, 3171, 13789, 13790, 13790, 13790, 13790, 13790, 13790, 2457866, 57865, N'2017-04-22', 201716, 16, 6, N'2017-W16', N'2017-W16-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96536, CAST(N'2017-04-23' AS date), CAST(N'2017-04-24' AS date), 2017, 20172, 201704, 2017113, 2, 4, 113, 23, 1, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-04-17' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-04-21' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-28' AS date), 1057, 3171, 13790, 13790, 13790, 13790, 13790, 13790, 13790, 2457867, 57866, N'2017-04-23', 201716, 16, 7, N'2017-W16', N'2017-W16-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96537, CAST(N'2017-04-24' AS date), CAST(N'2017-04-25' AS date), 2017, 20172, 201704, 2017114, 2, 4, 114, 24, 2, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-18' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-04-21' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-28' AS date), 1057, 3171, 13790, 13791, 13790, 13790, 13790, 13790, 13790, 2457868, 57867, N'2017-04-24', 201717, 17, 1, N'2017-W17', N'2017-W17-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96538, CAST(N'2017-04-25' AS date), CAST(N'2017-04-26' AS date), 2017, 20172, 201704, 2017115, 2, 4, 115, 25, 3, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-04-19' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-04-21' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-28' AS date), 1057, 3171, 13790, 13791, 13791, 13790, 13790, 13790, 13790, 2457869, 57868, N'2017-04-25', 201717, 17, 2, N'2017-W17', N'2017-W17-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96539, CAST(N'2017-04-26' AS date), CAST(N'2017-04-27' AS date), 2017, 20172, 201704, 2017116, 2, 4, 116, 26, 4, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-04-20' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-04-21' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-28' AS date), 1057, 3171, 13790, 13791, 13791, 13791, 13790, 13790, 13790, 2457870, 57869, N'2017-04-26', 201717, 17, 3, N'2017-W17', N'2017-W17-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96540, CAST(N'2017-04-27' AS date), CAST(N'2017-04-28' AS date), 2017, 20172, 201704, 2017117, 2, 4, 117, 27, 5, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-04-21' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-28' AS date), 1057, 3171, 13790, 13791, 13791, 13791, 13791, 13790, 13790, 2457871, 57870, N'2017-04-27', 201717, 17, 4, N'2017-W17', N'2017-W17-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96541, CAST(N'2017-04-28' AS date), CAST(N'2017-04-29' AS date), 2017, 20172, 201704, 2017118, 2, 4, 118, 28, 6, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-04-28' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-04-22' AS date), CAST(N'2017-04-28' AS date), 1057, 3171, 13790, 13791, 13791, 13791, 13791, 13791, 13790, 2457872, 57871, N'2017-04-28', 201717, 17, 5, N'2017-W17', N'2017-W17-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96542, CAST(N'2017-04-29' AS date), CAST(N'2017-04-30' AS date), 2017, 20172, 201704, 2017119, 2, 4, 119, 29, 7, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-23' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-04-28' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-05-05' AS date), 1057, 3171, 13790, 13791, 13791, 13791, 13791, 13791, 13791, 2457873, 57872, N'2017-04-29', 201717, 17, 6, N'2017-W17', N'2017-W17-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96543, CAST(N'2017-04-30' AS date), CAST(N'2017-05-01' AS date), 2017, 20172, 201704, 2017120, 2, 4, 120, 30, 1, N'2017', N'2017 Q2', N'2017 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-04-24' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-04-28' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-05-05' AS date), 1057, 3171, 13791, 13791, 13791, 13791, 13791, 13791, 13791, 2457874, 57873, N'2017-04-30', 201717, 17, 7, N'2017-W17', N'2017-W17-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96544, CAST(N'2017-05-01' AS date), CAST(N'2017-05-02' AS date), 2017, 20172, 201705, 2017121, 2, 5, 121, 1, 2, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-04-25' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-04-28' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-05-05' AS date), 1057, 3172, 13791, 13792, 13791, 13791, 13791, 13791, 13791, 2457875, 57874, N'2017-05-01', 201718, 18, 1, N'2017-W18', N'2017-W18-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96545, CAST(N'2017-05-02' AS date), CAST(N'2017-05-03' AS date), 2017, 20172, 201705, 2017122, 2, 5, 122, 2, 3, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-04-26' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-04-28' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-05-05' AS date), 1057, 3172, 13791, 13792, 13792, 13791, 13791, 13791, 13791, 2457876, 57875, N'2017-05-02', 201718, 18, 2, N'2017-W18', N'2017-W18-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96546, CAST(N'2017-05-03' AS date), CAST(N'2017-05-04' AS date), 2017, 20172, 201705, 2017123, 2, 5, 123, 3, 4, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-04-27' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-04-28' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-05-05' AS date), 1057, 3172, 13791, 13792, 13792, 13792, 13791, 13791, 13791, 2457877, 57876, N'2017-05-03', 201718, 18, 3, N'2017-W18', N'2017-W18-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96547, CAST(N'2017-05-04' AS date), CAST(N'2017-05-05' AS date), 2017, 20172, 201705, 2017124, 2, 5, 124, 4, 5, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-04-28' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-05-05' AS date), 1057, 3172, 13791, 13792, 13792, 13792, 13792, 13791, 13791, 2457878, 57877, N'2017-05-04', 201718, 18, 4, N'2017-W18', N'2017-W18-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96548, CAST(N'2017-05-05' AS date), CAST(N'2017-05-06' AS date), 2017, 20172, 201705, 2017125, 2, 5, 125, 5, 6, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-05' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-04-29' AS date), CAST(N'2017-05-05' AS date), 1057, 3172, 13791, 13792, 13792, 13792, 13792, 13792, 13791, 2457879, 57878, N'2017-05-05', 201718, 18, 5, N'2017-W18', N'2017-W18-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96549, CAST(N'2017-05-06' AS date), CAST(N'2017-05-07' AS date), 2017, 20172, 201705, 2017126, 2, 5, 126, 6, 7, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-04-30' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-05' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-12' AS date), 1057, 3172, 13791, 13792, 13792, 13792, 13792, 13792, 13792, 2457880, 57879, N'2017-05-06', 201718, 18, 6, N'2017-W18', N'2017-W18-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96550, CAST(N'2017-05-07' AS date), CAST(N'2017-05-08' AS date), 2017, 20172, 201705, 2017127, 2, 5, 127, 7, 1, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-05' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-12' AS date), 1057, 3172, 13792, 13792, 13792, 13792, 13792, 13792, 13792, 2457881, 57880, N'2017-05-07', 201718, 18, 7, N'2017-W18', N'2017-W18-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96551, CAST(N'2017-05-08' AS date), CAST(N'2017-05-09' AS date), 2017, 20172, 201705, 2017128, 2, 5, 128, 8, 2, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-02' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-05' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-12' AS date), 1057, 3172, 13792, 13793, 13792, 13792, 13792, 13792, 13792, 2457882, 57881, N'2017-05-08', 201719, 19, 1, N'2017-W19', N'2017-W19-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96552, CAST(N'2017-05-09' AS date), CAST(N'2017-05-10' AS date), 2017, 20172, 201705, 2017129, 2, 5, 129, 9, 3, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-03' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-05' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-12' AS date), 1057, 3172, 13792, 13793, 13793, 13792, 13792, 13792, 13792, 2457883, 57882, N'2017-05-09', 201719, 19, 2, N'2017-W19', N'2017-W19-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96553, CAST(N'2017-05-10' AS date), CAST(N'2017-05-11' AS date), 2017, 20172, 201705, 2017130, 2, 5, 130, 10, 4, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-04' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-05' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-12' AS date), 1057, 3172, 13792, 13793, 13793, 13793, 13792, 13792, 13792, 2457884, 57883, N'2017-05-10', 201719, 19, 3, N'2017-W19', N'2017-W19-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96554, CAST(N'2017-05-11' AS date), CAST(N'2017-05-12' AS date), 2017, 20172, 201705, 2017131, 2, 5, 131, 11, 5, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-05' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-12' AS date), 1057, 3172, 13792, 13793, 13793, 13793, 13793, 13792, 13792, 2457885, 57884, N'2017-05-11', 201719, 19, 4, N'2017-W19', N'2017-W19-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96555, CAST(N'2017-05-12' AS date), CAST(N'2017-05-13' AS date), 2017, 20172, 201705, 2017132, 2, 5, 132, 12, 6, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-12' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-06' AS date), CAST(N'2017-05-12' AS date), 1057, 3172, 13792, 13793, 13793, 13793, 13793, 13793, 13792, 2457886, 57885, N'2017-05-12', 201719, 19, 5, N'2017-W19', N'2017-W19-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96556, CAST(N'2017-05-13' AS date), CAST(N'2017-05-14' AS date), 2017, 20172, 201705, 2017133, 2, 5, 133, 13, 7, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-07' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-12' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-19' AS date), 1057, 3172, 13792, 13793, 13793, 13793, 13793, 13793, 13793, 2457887, 57886, N'2017-05-13', 201719, 19, 6, N'2017-W19', N'2017-W19-6');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96557, CAST(N'2017-05-14' AS date), CAST(N'2017-05-15' AS date), 2017, 20172, 201705, 2017134, 2, 5, 134, 14, 1, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-08' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-12' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-19' AS date), 1057, 3172, 13793, 13793, 13793, 13793, 13793, 13793, 13793, 2457888, 57887, N'2017-05-14', 201719, 19, 7, N'2017-W19', N'2017-W19-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96558, CAST(N'2017-05-15' AS date), CAST(N'2017-05-16' AS date), 2017, 20172, 201705, 2017135, 2, 5, 135, 15, 2, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-09' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-12' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-19' AS date), 1057, 3172, 13793, 13794, 13793, 13793, 13793, 13793, 13793, 2457889, 57888, N'2017-05-15', 201720, 20, 1, N'2017-W20', N'2017-W20-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96559, CAST(N'2017-05-16' AS date), CAST(N'2017-05-17' AS date), 2017, 20172, 201705, 2017136, 2, 5, 136, 16, 3, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-10' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-12' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-19' AS date), 1057, 3172, 13793, 13794, 13794, 13793, 13793, 13793, 13793, 2457890, 57889, N'2017-05-16', 201720, 20, 2, N'2017-W20', N'2017-W20-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96560, CAST(N'2017-05-17' AS date), CAST(N'2017-05-18' AS date), 2017, 20172, 201705, 2017137, 2, 5, 137, 17, 4, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-11' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-12' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-19' AS date), 1057, 3172, 13793, 13794, 13794, 13794, 13793, 13793, 13793, 2457891, 57890, N'2017-05-17', 201720, 20, 3, N'2017-W20', N'2017-W20-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96561, CAST(N'2017-05-18' AS date), CAST(N'2017-05-19' AS date), 2017, 20172, 201705, 2017138, 2, 5, 138, 18, 5, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-12' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-19' AS date), 1057, 3172, 13793, 13794, 13794, 13794, 13794, 13793, 13793, 2457892, 57891, N'2017-05-18', 201720, 20, 4, N'2017-W20', N'2017-W20-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96562, CAST(N'2017-05-19' AS date), CAST(N'2017-05-20' AS date), 2017, 20172, 201705, 2017139, 2, 5, 139, 19, 6, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-19' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-13' AS date), CAST(N'2017-05-19' AS date), 1057, 3172, 13793, 13794, 13794, 13794, 13794, 13794, 13793, 2457893, 57892, N'2017-05-19', 201720, 20, 5, N'2017-W20', N'2017-W20-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96563, CAST(N'2017-05-20' AS date), CAST(N'2017-05-21' AS date), 2017, 20172, 201705, 2017140, 2, 5, 140, 20, 7, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-14' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-19' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-26' AS date), 1057, 3172, 13793, 13794, 13794, 13794, 13794, 13794, 13794, 2457894, 57893, N'2017-05-20', 201720, 20, 6, N'2017-W20', N'2017-W20-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96564, CAST(N'2017-05-21' AS date), CAST(N'2017-05-22' AS date), 2017, 20172, 201705, 2017141, 2, 5, 141, 21, 1, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-05-15' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-19' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-26' AS date), 1057, 3172, 13794, 13794, 13794, 13794, 13794, 13794, 13794, 2457895, 57894, N'2017-05-21', 201720, 20, 7, N'2017-W20', N'2017-W20-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96565, CAST(N'2017-05-22' AS date), CAST(N'2017-05-23' AS date), 2017, 20172, 201705, 2017142, 2, 5, 142, 22, 2, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-05-16' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-19' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-26' AS date), 1057, 3172, 13794, 13795, 13794, 13794, 13794, 13794, 13794, 2457896, 57895, N'2017-05-22', 201721, 21, 1, N'2017-W21', N'2017-W21-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96566, CAST(N'2017-05-23' AS date), CAST(N'2017-05-24' AS date), 2017, 20172, 201705, 2017143, 2, 5, 143, 23, 3, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-05-17' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-19' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-26' AS date), 1057, 3172, 13794, 13795, 13795, 13794, 13794, 13794, 13794, 2457897, 57896, N'2017-05-23', 201721, 21, 2, N'2017-W21', N'2017-W21-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96567, CAST(N'2017-05-24' AS date), CAST(N'2017-05-25' AS date), 2017, 20172, 201705, 2017144, 2, 5, 144, 24, 4, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-05-18' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-19' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-26' AS date), 1057, 3172, 13794, 13795, 13795, 13795, 13794, 13794, 13794, 2457898, 57897, N'2017-05-24', 201721, 21, 3, N'2017-W21', N'2017-W21-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96568, CAST(N'2017-05-25' AS date), CAST(N'2017-05-26' AS date), 2017, 20172, 201705, 2017145, 2, 5, 145, 25, 5, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-19' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-26' AS date), 1057, 3172, 13794, 13795, 13795, 13795, 13795, 13794, 13794, 2457899, 57898, N'2017-05-25', 201721, 21, 4, N'2017-W21', N'2017-W21-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96569, CAST(N'2017-05-26' AS date), CAST(N'2017-05-27' AS date), 2017, 20172, 201705, 2017146, 2, 5, 146, 26, 6, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-26' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-05-20' AS date), CAST(N'2017-05-26' AS date), 1057, 3172, 13794, 13795, 13795, 13795, 13795, 13795, 13794, 2457900, 57899, N'2017-05-26', 201721, 21, 5, N'2017-W21', N'2017-W21-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96570, CAST(N'2017-05-27' AS date), CAST(N'2017-05-28' AS date), 2017, 20172, 201705, 2017147, 2, 5, 147, 27, 7, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-21' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-26' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-06-02' AS date), 1057, 3172, 13794, 13795, 13795, 13795, 13795, 13795, 13795, 2457901, 57900, N'2017-05-27', 201721, 21, 6, N'2017-W21', N'2017-W21-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96571, CAST(N'2017-05-28' AS date), CAST(N'2017-05-29' AS date), 2017, 20172, 201705, 2017148, 2, 5, 148, 28, 1, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-05-22' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-26' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-06-02' AS date), 1057, 3172, 13795, 13795, 13795, 13795, 13795, 13795, 13795, 2457902, 57901, N'2017-05-28', 201721, 21, 7, N'2017-W21', N'2017-W21-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96572, CAST(N'2017-05-29' AS date), CAST(N'2017-05-30' AS date), 2017, 20172, 201705, 2017149, 2, 5, 149, 29, 2, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-05-23' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-26' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-06-02' AS date), 1057, 3172, 13795, 13796, 13795, 13795, 13795, 13795, 13795, 2457903, 57902, N'2017-05-29', 201722, 22, 1, N'2017-W22', N'2017-W22-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96573, CAST(N'2017-05-30' AS date), CAST(N'2017-05-31' AS date), 2017, 20172, 201705, 2017150, 2, 5, 150, 30, 3, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-05-24' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-26' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-06-02' AS date), 1057, 3172, 13795, 13796, 13796, 13795, 13795, 13795, 13795, 2457904, 57903, N'2017-05-30', 201722, 22, 2, N'2017-W22', N'2017-W22-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96574, CAST(N'2017-05-31' AS date), CAST(N'2017-06-01' AS date), 2017, 20172, 201705, 2017151, 2, 5, 151, 31, 4, N'2017', N'2017 Q2', N'2017 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-01' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-05-25' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-05-26' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-06-02' AS date), 1057, 3172, 13795, 13796, 13796, 13796, 13795, 13795, 13795, 2457905, 57904, N'2017-05-31', 201722, 22, 3, N'2017-W22', N'2017-W22-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96575, CAST(N'2017-06-01' AS date), CAST(N'2017-06-02' AS date), 2017, 20172, 201706, 2017152, 2, 6, 152, 1, 5, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-05-26' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-06-02' AS date), 1057, 3173, 13795, 13796, 13796, 13796, 13796, 13795, 13795, 2457906, 57905, N'2017-06-01', 201722, 22, 4, N'2017-W22', N'2017-W22-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96576, CAST(N'2017-06-02' AS date), CAST(N'2017-06-03' AS date), 2017, 20172, 201706, 2017153, 2, 6, 153, 2, 6, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-02' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-05-27' AS date), CAST(N'2017-06-02' AS date), 1057, 3173, 13795, 13796, 13796, 13796, 13796, 13796, 13795, 2457907, 57906, N'2017-06-02', 201722, 22, 5, N'2017-W22', N'2017-W22-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96577, CAST(N'2017-06-03' AS date), CAST(N'2017-06-04' AS date), 2017, 20172, 201706, 2017154, 2, 6, 154, 3, 7, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-05-28' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-02' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-06-09' AS date), 1057, 3173, 13795, 13796, 13796, 13796, 13796, 13796, 13796, 2457908, 57907, N'2017-06-03', 201722, 22, 6, N'2017-W22', N'2017-W22-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96578, CAST(N'2017-06-04' AS date), CAST(N'2017-06-05' AS date), 2017, 20172, 201706, 2017155, 2, 6, 155, 4, 1, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-05-29' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-02' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-06-09' AS date), 1057, 3173, 13796, 13796, 13796, 13796, 13796, 13796, 13796, 2457909, 57908, N'2017-06-04', 201722, 22, 7, N'2017-W22', N'2017-W22-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96579, CAST(N'2017-06-05' AS date), CAST(N'2017-06-06' AS date), 2017, 20172, 201706, 2017156, 2, 6, 156, 5, 2, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-05-30' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-02' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-06-09' AS date), 1057, 3173, 13796, 13797, 13796, 13796, 13796, 13796, 13796, 2457910, 57909, N'2017-06-05', 201723, 23, 1, N'2017-W23', N'2017-W23-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96580, CAST(N'2017-06-06' AS date), CAST(N'2017-06-07' AS date), 2017, 20172, 201706, 2017157, 2, 6, 157, 6, 3, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-05-31' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-02' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-06-09' AS date), 1057, 3173, 13796, 13797, 13797, 13796, 13796, 13796, 13796, 2457911, 57910, N'2017-06-06', 201723, 23, 2, N'2017-W23', N'2017-W23-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96581, CAST(N'2017-06-07' AS date), CAST(N'2017-06-08' AS date), 2017, 20172, 201706, 2017158, 2, 6, 158, 7, 4, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-02' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-06-09' AS date), 1057, 3173, 13796, 13797, 13797, 13797, 13796, 13796, 13796, 2457912, 57911, N'2017-06-07', 201723, 23, 3, N'2017-W23', N'2017-W23-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96582, CAST(N'2017-06-08' AS date), CAST(N'2017-06-09' AS date), 2017, 20172, 201706, 2017159, 2, 6, 159, 8, 5, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-02' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-06-09' AS date), 1057, 3173, 13796, 13797, 13797, 13797, 13797, 13796, 13796, 2457913, 57912, N'2017-06-08', 201723, 23, 4, N'2017-W23', N'2017-W23-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96583, CAST(N'2017-06-09' AS date), CAST(N'2017-06-10' AS date), 2017, 20172, 201706, 2017160, 2, 6, 160, 9, 6, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-09' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-03' AS date), CAST(N'2017-06-09' AS date), 1057, 3173, 13796, 13797, 13797, 13797, 13797, 13797, 13796, 2457914, 57913, N'2017-06-09', 201723, 23, 5, N'2017-W23', N'2017-W23-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96584, CAST(N'2017-06-10' AS date), CAST(N'2017-06-11' AS date), 2017, 20172, 201706, 2017161, 2, 6, 161, 10, 7, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-04' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-09' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-16' AS date), 1057, 3173, 13796, 13797, 13797, 13797, 13797, 13797, 13797, 2457915, 57914, N'2017-06-10', 201723, 23, 6, N'2017-W23', N'2017-W23-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96585, CAST(N'2017-06-11' AS date), CAST(N'2017-06-12' AS date), 2017, 20172, 201706, 2017162, 2, 6, 162, 11, 1, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-05' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-09' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-16' AS date), 1057, 3173, 13797, 13797, 13797, 13797, 13797, 13797, 13797, 2457916, 57915, N'2017-06-11', 201723, 23, 7, N'2017-W23', N'2017-W23-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96586, CAST(N'2017-06-12' AS date), CAST(N'2017-06-13' AS date), 2017, 20172, 201706, 2017163, 2, 6, 163, 12, 2, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-06' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-09' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-16' AS date), 1057, 3173, 13797, 13798, 13797, 13797, 13797, 13797, 13797, 2457917, 57916, N'2017-06-12', 201724, 24, 1, N'2017-W24', N'2017-W24-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96587, CAST(N'2017-06-13' AS date), CAST(N'2017-06-14' AS date), 2017, 20172, 201706, 2017164, 2, 6, 164, 13, 3, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-07' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-09' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-16' AS date), 1057, 3173, 13797, 13798, 13798, 13797, 13797, 13797, 13797, 2457918, 57917, N'2017-06-13', 201724, 24, 2, N'2017-W24', N'2017-W24-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96588, CAST(N'2017-06-14' AS date), CAST(N'2017-06-15' AS date), 2017, 20172, 201706, 2017165, 2, 6, 165, 14, 4, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-08' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-09' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-16' AS date), 1057, 3173, 13797, 13798, 13798, 13798, 13797, 13797, 13797, 2457919, 57918, N'2017-06-14', 201724, 24, 3, N'2017-W24', N'2017-W24-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96589, CAST(N'2017-06-15' AS date), CAST(N'2017-06-16' AS date), 2017, 20172, 201706, 2017166, 2, 6, 166, 15, 5, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-09' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-16' AS date), 1057, 3173, 13797, 13798, 13798, 13798, 13798, 13797, 13797, 2457920, 57919, N'2017-06-15', 201724, 24, 4, N'2017-W24', N'2017-W24-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96590, CAST(N'2017-06-16' AS date), CAST(N'2017-06-17' AS date), 2017, 20172, 201706, 2017167, 2, 6, 167, 16, 6, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-16' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-10' AS date), CAST(N'2017-06-16' AS date), 1057, 3173, 13797, 13798, 13798, 13798, 13798, 13798, 13797, 2457921, 57920, N'2017-06-16', 201724, 24, 5, N'2017-W24', N'2017-W24-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96591, CAST(N'2017-06-17' AS date), CAST(N'2017-06-18' AS date), 2017, 20172, 201706, 2017168, 2, 6, 168, 17, 7, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-11' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-16' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-23' AS date), 1057, 3173, 13797, 13798, 13798, 13798, 13798, 13798, 13798, 2457922, 57921, N'2017-06-17', 201724, 24, 6, N'2017-W24', N'2017-W24-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96592, CAST(N'2017-06-18' AS date), CAST(N'2017-06-19' AS date), 2017, 20172, 201706, 2017169, 2, 6, 169, 18, 1, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-12' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-16' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-23' AS date), 1057, 3173, 13798, 13798, 13798, 13798, 13798, 13798, 13798, 2457923, 57922, N'2017-06-18', 201724, 24, 7, N'2017-W24', N'2017-W24-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96593, CAST(N'2017-06-19' AS date), CAST(N'2017-06-20' AS date), 2017, 20172, 201706, 2017170, 2, 6, 170, 19, 2, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-06-13' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-16' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-23' AS date), 1057, 3173, 13798, 13799, 13798, 13798, 13798, 13798, 13798, 2457924, 57923, N'2017-06-19', 201725, 25, 1, N'2017-W25', N'2017-W25-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96594, CAST(N'2017-06-20' AS date), CAST(N'2017-06-21' AS date), 2017, 20172, 201706, 2017171, 2, 6, 171, 20, 3, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-06-14' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-16' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-23' AS date), 1057, 3173, 13798, 13799, 13799, 13798, 13798, 13798, 13798, 2457925, 57924, N'2017-06-20', 201725, 25, 2, N'2017-W25', N'2017-W25-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96595, CAST(N'2017-06-21' AS date), CAST(N'2017-06-22' AS date), 2017, 20172, 201706, 2017172, 2, 6, 172, 21, 4, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-06-15' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-16' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-23' AS date), 1057, 3173, 13798, 13799, 13799, 13799, 13798, 13798, 13798, 2457926, 57925, N'2017-06-21', 201725, 25, 3, N'2017-W25', N'2017-W25-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96596, CAST(N'2017-06-22' AS date), CAST(N'2017-06-23' AS date), 2017, 20172, 201706, 2017173, 2, 6, 173, 22, 5, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-06-16' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-23' AS date), 1057, 3173, 13798, 13799, 13799, 13799, 13799, 13798, 13798, 2457927, 57926, N'2017-06-22', 201725, 25, 4, N'2017-W25', N'2017-W25-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96597, CAST(N'2017-06-23' AS date), CAST(N'2017-06-24' AS date), 2017, 20172, 201706, 2017174, 2, 6, 174, 23, 6, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-06-23' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-06-17' AS date), CAST(N'2017-06-23' AS date), 1057, 3173, 13798, 13799, 13799, 13799, 13799, 13799, 13798, 2457928, 57927, N'2017-06-23', 201725, 25, 5, N'2017-W25', N'2017-W25-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96598, CAST(N'2017-06-24' AS date), CAST(N'2017-06-25' AS date), 2017, 20172, 201706, 2017175, 2, 6, 175, 24, 7, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-18' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-06-23' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-30' AS date), 1057, 3173, 13798, 13799, 13799, 13799, 13799, 13799, 13799, 2457929, 57928, N'2017-06-24', 201725, 25, 6, N'2017-W25', N'2017-W25-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96599, CAST(N'2017-06-25' AS date), CAST(N'2017-06-26' AS date), 2017, 20172, 201706, 2017176, 2, 6, 176, 25, 1, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-06-19' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-06-23' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-30' AS date), 1057, 3173, 13799, 13799, 13799, 13799, 13799, 13799, 13799, 2457930, 57929, N'2017-06-25', 201725, 25, 7, N'2017-W25', N'2017-W25-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96600, CAST(N'2017-06-26' AS date), CAST(N'2017-06-27' AS date), 2017, 20172, 201706, 2017177, 2, 6, 177, 26, 2, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-06-20' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-06-23' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-30' AS date), 1057, 3173, 13799, 13800, 13799, 13799, 13799, 13799, 13799, 2457931, 57930, N'2017-06-26', 201726, 26, 1, N'2017-W26', N'2017-W26-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96601, CAST(N'2017-06-27' AS date), CAST(N'2017-06-28' AS date), 2017, 20172, 201706, 2017178, 2, 6, 178, 27, 3, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-06-21' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-06-23' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-30' AS date), 1057, 3173, 13799, 13800, 13800, 13799, 13799, 13799, 13799, 2457932, 57931, N'2017-06-27', 201726, 26, 2, N'2017-W26', N'2017-W26-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96602, CAST(N'2017-06-28' AS date), CAST(N'2017-06-29' AS date), 2017, 20172, 201706, 2017179, 2, 6, 179, 28, 4, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-06-22' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-06-23' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-30' AS date), 1057, 3173, 13799, 13800, 13800, 13800, 13799, 13799, 13799, 2457933, 57932, N'2017-06-28', 201726, 26, 3, N'2017-W26', N'2017-W26-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96603, CAST(N'2017-06-29' AS date), CAST(N'2017-06-30' AS date), 2017, 20172, 201706, 2017180, 2, 6, 180, 29, 5, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-06-23' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-30' AS date), 1057, 3173, 13799, 13800, 13800, 13800, 13800, 13799, 13799, 2457934, 57933, N'2017-06-29', 201726, 26, 4, N'2017-W26', N'2017-W26-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96604, CAST(N'2017-06-30' AS date), CAST(N'2017-07-01' AS date), 2017, 20172, 201706, 2017181, 2, 6, 181, 30, 6, N'2017', N'2017 Q2', N'2017 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-04-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-01' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-06-24' AS date), CAST(N'2017-06-30' AS date), 1057, 3173, 13799, 13800, 13800, 13800, 13800, 13800, 13799, 2457935, 57934, N'2017-06-30', 201726, 26, 5, N'2017-W26', N'2017-W26-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96605, CAST(N'2017-07-01' AS date), CAST(N'2017-07-02' AS date), 2017, 20173, 201707, 2017182, 3, 7, 182, 1, 7, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-06-25' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-07' AS date), 1058, 3174, 13799, 13800, 13800, 13800, 13800, 13800, 13800, 2457936, 57935, N'2017-07-01', 201726, 26, 6, N'2017-W26', N'2017-W26-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96606, CAST(N'2017-07-02' AS date), CAST(N'2017-07-03' AS date), 2017, 20173, 201707, 2017183, 3, 7, 183, 2, 1, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-06-26' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-07' AS date), 1058, 3174, 13800, 13800, 13800, 13800, 13800, 13800, 13800, 2457937, 57936, N'2017-07-02', 201726, 26, 7, N'2017-W26', N'2017-W26-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96607, CAST(N'2017-07-03' AS date), CAST(N'2017-07-04' AS date), 2017, 20173, 201707, 2017184, 3, 7, 184, 3, 2, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-06-27' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-07' AS date), 1058, 3174, 13800, 13801, 13800, 13800, 13800, 13800, 13800, 2457938, 57937, N'2017-07-03', 201727, 27, 1, N'2017-W27', N'2017-W27-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96608, CAST(N'2017-07-04' AS date), CAST(N'2017-07-05' AS date), 2017, 20173, 201707, 2017185, 3, 7, 185, 4, 3, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-06-28' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-07' AS date), 1058, 3174, 13800, 13801, 13801, 13800, 13800, 13800, 13800, 2457939, 57938, N'2017-07-04', 201727, 27, 2, N'2017-W27', N'2017-W27-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96609, CAST(N'2017-07-05' AS date), CAST(N'2017-07-06' AS date), 2017, 20173, 201707, 2017186, 3, 7, 186, 5, 4, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-06-29' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-07' AS date), 1058, 3174, 13800, 13801, 13801, 13801, 13800, 13800, 13800, 2457940, 57939, N'2017-07-05', 201727, 27, 3, N'2017-W27', N'2017-W27-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96610, CAST(N'2017-07-06' AS date), CAST(N'2017-07-07' AS date), 2017, 20173, 201707, 2017187, 3, 7, 187, 6, 5, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-06-30' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-07' AS date), 1058, 3174, 13800, 13801, 13801, 13801, 13801, 13800, 13800, 2457941, 57940, N'2017-07-06', 201727, 27, 4, N'2017-W27', N'2017-W27-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96611, CAST(N'2017-07-07' AS date), CAST(N'2017-07-08' AS date), 2017, 20173, 201707, 2017188, 3, 7, 188, 7, 6, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-07' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-07' AS date), 1058, 3174, 13800, 13801, 13801, 13801, 13801, 13801, 13800, 2457942, 57941, N'2017-07-07', 201727, 27, 5, N'2017-W27', N'2017-W27-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96612, CAST(N'2017-07-08' AS date), CAST(N'2017-07-09' AS date), 2017, 20173, 201707, 2017189, 3, 7, 189, 8, 7, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-02' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-07' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-14' AS date), 1058, 3174, 13800, 13801, 13801, 13801, 13801, 13801, 13801, 2457943, 57942, N'2017-07-08', 201727, 27, 6, N'2017-W27', N'2017-W27-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96613, CAST(N'2017-07-09' AS date), CAST(N'2017-07-10' AS date), 2017, 20173, 201707, 2017190, 3, 7, 190, 9, 1, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-03' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-07' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-14' AS date), 1058, 3174, 13801, 13801, 13801, 13801, 13801, 13801, 13801, 2457944, 57943, N'2017-07-09', 201727, 27, 7, N'2017-W27', N'2017-W27-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96614, CAST(N'2017-07-10' AS date), CAST(N'2017-07-11' AS date), 2017, 20173, 201707, 2017191, 3, 7, 191, 10, 2, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-04' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-07' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-14' AS date), 1058, 3174, 13801, 13802, 13801, 13801, 13801, 13801, 13801, 2457945, 57944, N'2017-07-10', 201728, 28, 1, N'2017-W28', N'2017-W28-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96615, CAST(N'2017-07-11' AS date), CAST(N'2017-07-12' AS date), 2017, 20173, 201707, 2017192, 3, 7, 192, 11, 3, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-05' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-07' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-14' AS date), 1058, 3174, 13801, 13802, 13802, 13801, 13801, 13801, 13801, 2457946, 57945, N'2017-07-11', 201728, 28, 2, N'2017-W28', N'2017-W28-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96616, CAST(N'2017-07-12' AS date), CAST(N'2017-07-13' AS date), 2017, 20173, 201707, 2017193, 3, 7, 193, 12, 4, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-06' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-07' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-14' AS date), 1058, 3174, 13801, 13802, 13802, 13802, 13801, 13801, 13801, 2457947, 57946, N'2017-07-12', 201728, 28, 3, N'2017-W28', N'2017-W28-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96617, CAST(N'2017-07-13' AS date), CAST(N'2017-07-14' AS date), 2017, 20173, 201707, 2017194, 3, 7, 194, 13, 5, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-07' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-14' AS date), 1058, 3174, 13801, 13802, 13802, 13802, 13802, 13801, 13801, 2457948, 57947, N'2017-07-13', 201728, 28, 4, N'2017-W28', N'2017-W28-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96618, CAST(N'2017-07-14' AS date), CAST(N'2017-07-15' AS date), 2017, 20173, 201707, 2017195, 3, 7, 195, 14, 6, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-14' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-08' AS date), CAST(N'2017-07-14' AS date), 1058, 3174, 13801, 13802, 13802, 13802, 13802, 13802, 13801, 2457949, 57948, N'2017-07-14', 201728, 28, 5, N'2017-W28', N'2017-W28-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96619, CAST(N'2017-07-15' AS date), CAST(N'2017-07-16' AS date), 2017, 20173, 201707, 2017196, 3, 7, 196, 15, 7, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-09' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-14' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-21' AS date), 1058, 3174, 13801, 13802, 13802, 13802, 13802, 13802, 13802, 2457950, 57949, N'2017-07-15', 201728, 28, 6, N'2017-W28', N'2017-W28-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96620, CAST(N'2017-07-16' AS date), CAST(N'2017-07-17' AS date), 2017, 20173, 201707, 2017197, 3, 7, 197, 16, 1, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-10' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-14' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-21' AS date), 1058, 3174, 13802, 13802, 13802, 13802, 13802, 13802, 13802, 2457951, 57950, N'2017-07-16', 201728, 28, 7, N'2017-W28', N'2017-W28-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96621, CAST(N'2017-07-17' AS date), CAST(N'2017-07-18' AS date), 2017, 20173, 201707, 2017198, 3, 7, 198, 17, 2, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-11' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-14' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-21' AS date), 1058, 3174, 13802, 13803, 13802, 13802, 13802, 13802, 13802, 2457952, 57951, N'2017-07-17', 201729, 29, 1, N'2017-W29', N'2017-W29-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96622, CAST(N'2017-07-18' AS date), CAST(N'2017-07-19' AS date), 2017, 20173, 201707, 2017199, 3, 7, 199, 18, 3, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-12' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-14' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-21' AS date), 1058, 3174, 13802, 13803, 13803, 13802, 13802, 13802, 13802, 2457953, 57952, N'2017-07-18', 201729, 29, 2, N'2017-W29', N'2017-W29-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96623, CAST(N'2017-07-19' AS date), CAST(N'2017-07-20' AS date), 2017, 20173, 201707, 2017200, 3, 7, 200, 19, 4, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-13' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-14' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-21' AS date), 1058, 3174, 13802, 13803, 13803, 13803, 13802, 13802, 13802, 2457954, 57953, N'2017-07-19', 201729, 29, 3, N'2017-W29', N'2017-W29-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96624, CAST(N'2017-07-20' AS date), CAST(N'2017-07-21' AS date), 2017, 20173, 201707, 2017201, 3, 7, 201, 20, 5, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-07-14' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-21' AS date), 1058, 3174, 13802, 13803, 13803, 13803, 13803, 13802, 13802, 2457955, 57954, N'2017-07-20', 201729, 29, 4, N'2017-W29', N'2017-W29-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96625, CAST(N'2017-07-21' AS date), CAST(N'2017-07-22' AS date), 2017, 20173, 201707, 2017202, 3, 7, 202, 21, 6, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-07-21' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-07-15' AS date), CAST(N'2017-07-21' AS date), 1058, 3174, 13802, 13803, 13803, 13803, 13803, 13803, 13802, 2457956, 57955, N'2017-07-21', 201729, 29, 5, N'2017-W29', N'2017-W29-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96626, CAST(N'2017-07-22' AS date), CAST(N'2017-07-23' AS date), 2017, 20173, 201707, 2017203, 3, 7, 203, 22, 7, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-16' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-07-21' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-28' AS date), 1058, 3174, 13802, 13803, 13803, 13803, 13803, 13803, 13803, 2457957, 57956, N'2017-07-22', 201729, 29, 6, N'2017-W29', N'2017-W29-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96627, CAST(N'2017-07-23' AS date), CAST(N'2017-07-24' AS date), 2017, 20173, 201707, 2017204, 3, 7, 204, 23, 1, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-07-17' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-07-21' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-28' AS date), 1058, 3174, 13803, 13803, 13803, 13803, 13803, 13803, 13803, 2457958, 57957, N'2017-07-23', 201729, 29, 7, N'2017-W29', N'2017-W29-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96628, CAST(N'2017-07-24' AS date), CAST(N'2017-07-25' AS date), 2017, 20173, 201707, 2017205, 3, 7, 205, 24, 2, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-07-18' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-07-21' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-28' AS date), 1058, 3174, 13803, 13804, 13803, 13803, 13803, 13803, 13803, 2457959, 57958, N'2017-07-24', 201730, 30, 1, N'2017-W30', N'2017-W30-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96629, CAST(N'2017-07-25' AS date), CAST(N'2017-07-26' AS date), 2017, 20173, 201707, 2017206, 3, 7, 206, 25, 3, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-19' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-07-21' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-28' AS date), 1058, 3174, 13803, 13804, 13804, 13803, 13803, 13803, 13803, 2457960, 57959, N'2017-07-25', 201730, 30, 2, N'2017-W30', N'2017-W30-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96630, CAST(N'2017-07-26' AS date), CAST(N'2017-07-27' AS date), 2017, 20173, 201707, 2017207, 3, 7, 207, 26, 4, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-07-20' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-07-21' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-28' AS date), 1058, 3174, 13803, 13804, 13804, 13804, 13803, 13803, 13803, 2457961, 57960, N'2017-07-26', 201730, 30, 3, N'2017-W30', N'2017-W30-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96631, CAST(N'2017-07-27' AS date), CAST(N'2017-07-28' AS date), 2017, 20173, 201707, 2017208, 3, 7, 208, 27, 5, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-07-21' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-28' AS date), 1058, 3174, 13803, 13804, 13804, 13804, 13804, 13803, 13803, 2457962, 57961, N'2017-07-27', 201730, 30, 4, N'2017-W30', N'2017-W30-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96632, CAST(N'2017-07-28' AS date), CAST(N'2017-07-29' AS date), 2017, 20173, 201707, 2017209, 3, 7, 209, 28, 6, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-07-28' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-07-22' AS date), CAST(N'2017-07-28' AS date), 1058, 3174, 13803, 13804, 13804, 13804, 13804, 13804, 13803, 2457963, 57962, N'2017-07-28', 201730, 30, 5, N'2017-W30', N'2017-W30-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96633, CAST(N'2017-07-29' AS date), CAST(N'2017-07-30' AS date), 2017, 20173, 201707, 2017210, 3, 7, 210, 29, 7, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-23' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-07-28' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-08-04' AS date), 1058, 3174, 13803, 13804, 13804, 13804, 13804, 13804, 13804, 2457964, 57963, N'2017-07-29', 201730, 30, 6, N'2017-W30', N'2017-W30-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96634, CAST(N'2017-07-30' AS date), CAST(N'2017-07-31' AS date), 2017, 20173, 201707, 2017211, 3, 7, 211, 30, 1, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-07-24' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-07-28' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-08-04' AS date), 1058, 3174, 13804, 13804, 13804, 13804, 13804, 13804, 13804, 2457965, 57964, N'2017-07-30', 201730, 30, 7, N'2017-W30', N'2017-W30-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96635, CAST(N'2017-07-31' AS date), CAST(N'2017-08-01' AS date), 2017, 20173, 201707, 2017212, 3, 7, 212, 31, 2, N'2017', N'2017 Q3', N'2017 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-07-25' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-07-28' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-08-04' AS date), 1058, 3174, 13804, 13805, 13804, 13804, 13804, 13804, 13804, 2457966, 57965, N'2017-07-31', 201731, 31, 1, N'2017-W31', N'2017-W31-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96636, CAST(N'2017-08-01' AS date), CAST(N'2017-08-02' AS date), 2017, 20173, 201708, 2017213, 3, 8, 213, 1, 3, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-07-26' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-07-28' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-08-04' AS date), 1058, 3175, 13804, 13805, 13805, 13804, 13804, 13804, 13804, 2457967, 57966, N'2017-08-01', 201731, 31, 2, N'2017-W31', N'2017-W31-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96637, CAST(N'2017-08-02' AS date), CAST(N'2017-08-03' AS date), 2017, 20173, 201708, 2017214, 3, 8, 214, 2, 4, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-07-27' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-07-28' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-08-04' AS date), 1058, 3175, 13804, 13805, 13805, 13805, 13804, 13804, 13804, 2457968, 57967, N'2017-08-02', 201731, 31, 3, N'2017-W31', N'2017-W31-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96638, CAST(N'2017-08-03' AS date), CAST(N'2017-08-04' AS date), 2017, 20173, 201708, 2017215, 3, 8, 215, 3, 5, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-07-28' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-08-04' AS date), 1058, 3175, 13804, 13805, 13805, 13805, 13805, 13804, 13804, 2457969, 57968, N'2017-08-03', 201731, 31, 4, N'2017-W31', N'2017-W31-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96639, CAST(N'2017-08-04' AS date), CAST(N'2017-08-05' AS date), 2017, 20173, 201708, 2017216, 3, 8, 216, 4, 6, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-04' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-07-29' AS date), CAST(N'2017-08-04' AS date), 1058, 3175, 13804, 13805, 13805, 13805, 13805, 13805, 13804, 2457970, 57969, N'2017-08-04', 201731, 31, 5, N'2017-W31', N'2017-W31-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96640, CAST(N'2017-08-05' AS date), CAST(N'2017-08-06' AS date), 2017, 20173, 201708, 2017217, 3, 8, 217, 5, 7, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-07-30' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-04' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-08-11' AS date), 1058, 3175, 13804, 13805, 13805, 13805, 13805, 13805, 13805, 2457971, 57970, N'2017-08-05', 201731, 31, 6, N'2017-W31', N'2017-W31-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96641, CAST(N'2017-08-06' AS date), CAST(N'2017-08-07' AS date), 2017, 20173, 201708, 2017218, 3, 8, 218, 6, 1, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-07-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-04' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-08-11' AS date), 1058, 3175, 13805, 13805, 13805, 13805, 13805, 13805, 13805, 2457972, 57971, N'2017-08-06', 201731, 31, 7, N'2017-W31', N'2017-W31-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96642, CAST(N'2017-08-07' AS date), CAST(N'2017-08-08' AS date), 2017, 20173, 201708, 2017219, 3, 8, 219, 7, 2, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-04' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-08-11' AS date), 1058, 3175, 13805, 13806, 13805, 13805, 13805, 13805, 13805, 2457973, 57972, N'2017-08-07', 201732, 32, 1, N'2017-W32', N'2017-W32-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96643, CAST(N'2017-08-08' AS date), CAST(N'2017-08-09' AS date), 2017, 20173, 201708, 2017220, 3, 8, 220, 8, 3, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-02' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-04' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-08-11' AS date), 1058, 3175, 13805, 13806, 13806, 13805, 13805, 13805, 13805, 2457974, 57973, N'2017-08-08', 201732, 32, 2, N'2017-W32', N'2017-W32-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96644, CAST(N'2017-08-09' AS date), CAST(N'2017-08-10' AS date), 2017, 20173, 201708, 2017221, 3, 8, 221, 9, 4, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-03' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-04' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-08-11' AS date), 1058, 3175, 13805, 13806, 13806, 13806, 13805, 13805, 13805, 2457975, 57974, N'2017-08-09', 201732, 32, 3, N'2017-W32', N'2017-W32-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96645, CAST(N'2017-08-10' AS date), CAST(N'2017-08-11' AS date), 2017, 20173, 201708, 2017222, 3, 8, 222, 10, 5, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-04' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-08-11' AS date), 1058, 3175, 13805, 13806, 13806, 13806, 13806, 13805, 13805, 2457976, 57975, N'2017-08-10', 201732, 32, 4, N'2017-W32', N'2017-W32-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96646, CAST(N'2017-08-11' AS date), CAST(N'2017-08-12' AS date), 2017, 20173, 201708, 2017223, 3, 8, 223, 11, 6, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-11' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-05' AS date), CAST(N'2017-08-11' AS date), 1058, 3175, 13805, 13806, 13806, 13806, 13806, 13806, 13805, 2457977, 57976, N'2017-08-11', 201732, 32, 5, N'2017-W32', N'2017-W32-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96647, CAST(N'2017-08-12' AS date), CAST(N'2017-08-13' AS date), 2017, 20173, 201708, 2017224, 3, 8, 224, 12, 7, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-06' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-11' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-18' AS date), 1058, 3175, 13805, 13806, 13806, 13806, 13806, 13806, 13806, 2457978, 57977, N'2017-08-12', 201732, 32, 6, N'2017-W32', N'2017-W32-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96648, CAST(N'2017-08-13' AS date), CAST(N'2017-08-14' AS date), 2017, 20173, 201708, 2017225, 3, 8, 225, 13, 1, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-07' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-11' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-18' AS date), 1058, 3175, 13806, 13806, 13806, 13806, 13806, 13806, 13806, 2457979, 57978, N'2017-08-13', 201732, 32, 7, N'2017-W32', N'2017-W32-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96649, CAST(N'2017-08-14' AS date), CAST(N'2017-08-15' AS date), 2017, 20173, 201708, 2017226, 3, 8, 226, 14, 2, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-08' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-11' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-18' AS date), 1058, 3175, 13806, 13807, 13806, 13806, 13806, 13806, 13806, 2457980, 57979, N'2017-08-14', 201733, 33, 1, N'2017-W33', N'2017-W33-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96650, CAST(N'2017-08-15' AS date), CAST(N'2017-08-16' AS date), 2017, 20173, 201708, 2017227, 3, 8, 227, 15, 3, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-09' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-11' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-18' AS date), 1058, 3175, 13806, 13807, 13807, 13806, 13806, 13806, 13806, 2457981, 57980, N'2017-08-15', 201733, 33, 2, N'2017-W33', N'2017-W33-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96651, CAST(N'2017-08-16' AS date), CAST(N'2017-08-17' AS date), 2017, 20173, 201708, 2017228, 3, 8, 228, 16, 4, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-10' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-11' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-18' AS date), 1058, 3175, 13806, 13807, 13807, 13807, 13806, 13806, 13806, 2457982, 57981, N'2017-08-16', 201733, 33, 3, N'2017-W33', N'2017-W33-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96652, CAST(N'2017-08-17' AS date), CAST(N'2017-08-18' AS date), 2017, 20173, 201708, 2017229, 3, 8, 229, 17, 5, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-11' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-18' AS date), 1058, 3175, 13806, 13807, 13807, 13807, 13807, 13806, 13806, 2457983, 57982, N'2017-08-17', 201733, 33, 4, N'2017-W33', N'2017-W33-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96653, CAST(N'2017-08-18' AS date), CAST(N'2017-08-19' AS date), 2017, 20173, 201708, 2017230, 3, 8, 230, 18, 6, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-18' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-12' AS date), CAST(N'2017-08-18' AS date), 1058, 3175, 13806, 13807, 13807, 13807, 13807, 13807, 13806, 2457984, 57983, N'2017-08-18', 201733, 33, 5, N'2017-W33', N'2017-W33-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96654, CAST(N'2017-08-19' AS date), CAST(N'2017-08-20' AS date), 2017, 20173, 201708, 2017231, 3, 8, 231, 19, 7, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-13' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-18' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-25' AS date), 1058, 3175, 13806, 13807, 13807, 13807, 13807, 13807, 13807, 2457985, 57984, N'2017-08-19', 201733, 33, 6, N'2017-W33', N'2017-W33-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96655, CAST(N'2017-08-20' AS date), CAST(N'2017-08-21' AS date), 2017, 20173, 201708, 2017232, 3, 8, 232, 20, 1, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-08-14' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-18' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-25' AS date), 1058, 3175, 13807, 13807, 13807, 13807, 13807, 13807, 13807, 2457986, 57985, N'2017-08-20', 201733, 33, 7, N'2017-W33', N'2017-W33-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96656, CAST(N'2017-08-21' AS date), CAST(N'2017-08-22' AS date), 2017, 20173, 201708, 2017233, 3, 8, 233, 21, 2, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-08-15' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-18' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-25' AS date), 1058, 3175, 13807, 13808, 13807, 13807, 13807, 13807, 13807, 2457987, 57986, N'2017-08-21', 201734, 34, 1, N'2017-W34', N'2017-W34-1');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96657, CAST(N'2017-08-22' AS date), CAST(N'2017-08-23' AS date), 2017, 20173, 201708, 2017234, 3, 8, 234, 22, 3, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-08-16' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-18' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-25' AS date), 1058, 3175, 13807, 13808, 13808, 13807, 13807, 13807, 13807, 2457988, 57987, N'2017-08-22', 201734, 34, 2, N'2017-W34', N'2017-W34-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96658, CAST(N'2017-08-23' AS date), CAST(N'2017-08-24' AS date), 2017, 20173, 201708, 2017235, 3, 8, 235, 23, 4, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-08-17' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-18' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-25' AS date), 1058, 3175, 13807, 13808, 13808, 13808, 13807, 13807, 13807, 2457989, 57988, N'2017-08-23', 201734, 34, 3, N'2017-W34', N'2017-W34-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96659, CAST(N'2017-08-24' AS date), CAST(N'2017-08-25' AS date), 2017, 20173, 201708, 2017236, 3, 8, 236, 24, 5, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-08-18' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-25' AS date), 1058, 3175, 13807, 13808, 13808, 13808, 13808, 13807, 13807, 2457990, 57989, N'2017-08-24', 201734, 34, 4, N'2017-W34', N'2017-W34-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96660, CAST(N'2017-08-25' AS date), CAST(N'2017-08-26' AS date), 2017, 20173, 201708, 2017237, 3, 8, 237, 25, 6, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-08-25' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-19' AS date), CAST(N'2017-08-25' AS date), 1058, 3175, 13807, 13808, 13808, 13808, 13808, 13808, 13807, 2457991, 57990, N'2017-08-25', 201734, 34, 5, N'2017-W34', N'2017-W34-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96661, CAST(N'2017-08-26' AS date), CAST(N'2017-08-27' AS date), 2017, 20173, 201708, 2017238, 3, 8, 238, 26, 7, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-20' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-08-25' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-09-01' AS date), 1058, 3175, 13807, 13808, 13808, 13808, 13808, 13808, 13808, 2457992, 57991, N'2017-08-26', 201734, 34, 6, N'2017-W34', N'2017-W34-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96662, CAST(N'2017-08-27' AS date), CAST(N'2017-08-28' AS date), 2017, 20173, 201708, 2017239, 3, 8, 239, 27, 1, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-08-21' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-08-25' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-09-01' AS date), 1058, 3175, 13808, 13808, 13808, 13808, 13808, 13808, 13808, 2457993, 57992, N'2017-08-27', 201734, 34, 7, N'2017-W34', N'2017-W34-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96663, CAST(N'2017-08-28' AS date), CAST(N'2017-08-29' AS date), 2017, 20173, 201708, 2017240, 3, 8, 240, 28, 2, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-08-22' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-08-25' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-09-01' AS date), 1058, 3175, 13808, 13809, 13808, 13808, 13808, 13808, 13808, 2457994, 57993, N'2017-08-28', 201735, 35, 1, N'2017-W35', N'2017-W35-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96664, CAST(N'2017-08-29' AS date), CAST(N'2017-08-30' AS date), 2017, 20173, 201708, 2017241, 3, 8, 241, 29, 3, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-08-23' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-08-25' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-09-01' AS date), 1058, 3175, 13808, 13809, 13809, 13808, 13808, 13808, 13808, 2457995, 57994, N'2017-08-29', 201735, 35, 2, N'2017-W35', N'2017-W35-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96665, CAST(N'2017-08-30' AS date), CAST(N'2017-08-31' AS date), 2017, 20173, 201708, 2017242, 3, 8, 242, 30, 4, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-08-24' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-08-25' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-09-01' AS date), 1058, 3175, 13808, 13809, 13809, 13809, 13808, 13808, 13808, 2457996, 57995, N'2017-08-30', 201735, 35, 3, N'2017-W35', N'2017-W35-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96666, CAST(N'2017-08-31' AS date), CAST(N'2017-09-01' AS date), 2017, 20173, 201708, 2017243, 3, 8, 243, 31, 5, N'2017', N'2017 Q3', N'2017 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-01' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-08-25' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-09-01' AS date), 1058, 3175, 13808, 13809, 13809, 13809, 13809, 13808, 13808, 2457997, 57996, N'2017-08-31', 201735, 35, 4, N'2017-W35', N'2017-W35-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96667, CAST(N'2017-09-01' AS date), CAST(N'2017-09-02' AS date), 2017, 20173, 201709, 2017244, 3, 9, 244, 1, 6, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-08-26' AS date), CAST(N'2017-09-01' AS date), 1058, 3176, 13808, 13809, 13809, 13809, 13809, 13809, 13808, 2457998, 57997, N'2017-09-01', 201735, 35, 5, N'2017-W35', N'2017-W35-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96668, CAST(N'2017-09-02' AS date), CAST(N'2017-09-03' AS date), 2017, 20173, 201709, 2017245, 3, 9, 245, 2, 7, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-08-27' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-09-08' AS date), 1058, 3176, 13808, 13809, 13809, 13809, 13809, 13809, 13809, 2457999, 57998, N'2017-09-02', 201735, 35, 6, N'2017-W35', N'2017-W35-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96669, CAST(N'2017-09-03' AS date), CAST(N'2017-09-04' AS date), 2017, 20173, 201709, 2017246, 3, 9, 246, 3, 1, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-08-28' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-09-08' AS date), 1058, 3176, 13809, 13809, 13809, 13809, 13809, 13809, 13809, 2458000, 57999, N'2017-09-03', 201735, 35, 7, N'2017-W35', N'2017-W35-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96670, CAST(N'2017-09-04' AS date), CAST(N'2017-09-05' AS date), 2017, 20173, 201709, 2017247, 3, 9, 247, 4, 2, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-08-29' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-09-08' AS date), 1058, 3176, 13809, 13810, 13809, 13809, 13809, 13809, 13809, 2458001, 58000, N'2017-09-04', 201736, 36, 1, N'2017-W36', N'2017-W36-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96671, CAST(N'2017-09-05' AS date), CAST(N'2017-09-06' AS date), 2017, 20173, 201709, 2017248, 3, 9, 248, 5, 3, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-08-30' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-09-08' AS date), 1058, 3176, 13809, 13810, 13810, 13809, 13809, 13809, 13809, 2458002, 58001, N'2017-09-05', 201736, 36, 2, N'2017-W36', N'2017-W36-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96672, CAST(N'2017-09-06' AS date), CAST(N'2017-09-07' AS date), 2017, 20173, 201709, 2017249, 3, 9, 249, 6, 4, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-08-31' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-09-08' AS date), 1058, 3176, 13809, 13810, 13810, 13810, 13809, 13809, 13809, 2458003, 58002, N'2017-09-06', 201736, 36, 3, N'2017-W36', N'2017-W36-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96673, CAST(N'2017-09-07' AS date), CAST(N'2017-09-08' AS date), 2017, 20173, 201709, 2017250, 3, 9, 250, 7, 5, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-09-08' AS date), 1058, 3176, 13809, 13810, 13810, 13810, 13810, 13809, 13809, 2458004, 58003, N'2017-09-07', 201736, 36, 4, N'2017-W36', N'2017-W36-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96674, CAST(N'2017-09-08' AS date), CAST(N'2017-09-09' AS date), 2017, 20173, 201709, 2017251, 3, 9, 251, 8, 6, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-08' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-02' AS date), CAST(N'2017-09-08' AS date), 1058, 3176, 13809, 13810, 13810, 13810, 13810, 13810, 13809, 2458005, 58004, N'2017-09-08', 201736, 36, 5, N'2017-W36', N'2017-W36-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96675, CAST(N'2017-09-09' AS date), CAST(N'2017-09-10' AS date), 2017, 20173, 201709, 2017252, 3, 9, 252, 9, 7, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-03' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-08' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-15' AS date), 1058, 3176, 13809, 13810, 13810, 13810, 13810, 13810, 13810, 2458006, 58005, N'2017-09-09', 201736, 36, 6, N'2017-W36', N'2017-W36-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96676, CAST(N'2017-09-10' AS date), CAST(N'2017-09-11' AS date), 2017, 20173, 201709, 2017253, 3, 9, 253, 10, 1, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-04' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-08' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-15' AS date), 1058, 3176, 13810, 13810, 13810, 13810, 13810, 13810, 13810, 2458007, 58006, N'2017-09-10', 201736, 36, 7, N'2017-W36', N'2017-W36-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96677, CAST(N'2017-09-11' AS date), CAST(N'2017-09-12' AS date), 2017, 20173, 201709, 2017254, 3, 9, 254, 11, 2, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-05' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-08' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-15' AS date), 1058, 3176, 13810, 13811, 13810, 13810, 13810, 13810, 13810, 2458008, 58007, N'2017-09-11', 201737, 37, 1, N'2017-W37', N'2017-W37-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96678, CAST(N'2017-09-12' AS date), CAST(N'2017-09-13' AS date), 2017, 20173, 201709, 2017255, 3, 9, 255, 12, 3, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-06' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-08' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-15' AS date), 1058, 3176, 13810, 13811, 13811, 13810, 13810, 13810, 13810, 2458009, 58008, N'2017-09-12', 201737, 37, 2, N'2017-W37', N'2017-W37-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96679, CAST(N'2017-09-13' AS date), CAST(N'2017-09-14' AS date), 2017, 20173, 201709, 2017256, 3, 9, 256, 13, 4, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-07' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-08' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-15' AS date), 1058, 3176, 13810, 13811, 13811, 13811, 13810, 13810, 13810, 2458010, 58009, N'2017-09-13', 201737, 37, 3, N'2017-W37', N'2017-W37-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96680, CAST(N'2017-09-14' AS date), CAST(N'2017-09-15' AS date), 2017, 20173, 201709, 2017257, 3, 9, 257, 14, 5, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-08' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-15' AS date), 1058, 3176, 13810, 13811, 13811, 13811, 13811, 13810, 13810, 2458011, 58010, N'2017-09-14', 201737, 37, 4, N'2017-W37', N'2017-W37-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96681, CAST(N'2017-09-15' AS date), CAST(N'2017-09-16' AS date), 2017, 20173, 201709, 2017258, 3, 9, 258, 15, 6, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-15' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-09' AS date), CAST(N'2017-09-15' AS date), 1058, 3176, 13810, 13811, 13811, 13811, 13811, 13811, 13810, 2458012, 58011, N'2017-09-15', 201737, 37, 5, N'2017-W37', N'2017-W37-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96682, CAST(N'2017-09-16' AS date), CAST(N'2017-09-17' AS date), 2017, 20173, 201709, 2017259, 3, 9, 259, 16, 7, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-10' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-15' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-22' AS date), 1058, 3176, 13810, 13811, 13811, 13811, 13811, 13811, 13811, 2458013, 58012, N'2017-09-16', 201737, 37, 6, N'2017-W37', N'2017-W37-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96683, CAST(N'2017-09-17' AS date), CAST(N'2017-09-18' AS date), 2017, 20173, 201709, 2017260, 3, 9, 260, 17, 1, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-11' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-15' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-22' AS date), 1058, 3176, 13811, 13811, 13811, 13811, 13811, 13811, 13811, 2458014, 58013, N'2017-09-17', 201737, 37, 7, N'2017-W37', N'2017-W37-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96684, CAST(N'2017-09-18' AS date), CAST(N'2017-09-19' AS date), 2017, 20173, 201709, 2017261, 3, 9, 261, 18, 2, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-12' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-15' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-22' AS date), 1058, 3176, 13811, 13812, 13811, 13811, 13811, 13811, 13811, 2458015, 58014, N'2017-09-18', 201738, 38, 1, N'2017-W38', N'2017-W38-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96685, CAST(N'2017-09-19' AS date), CAST(N'2017-09-20' AS date), 2017, 20173, 201709, 2017262, 3, 9, 262, 19, 3, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-09-13' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-15' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-22' AS date), 1058, 3176, 13811, 13812, 13812, 13811, 13811, 13811, 13811, 2458016, 58015, N'2017-09-19', 201738, 38, 2, N'2017-W38', N'2017-W38-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96686, CAST(N'2017-09-20' AS date), CAST(N'2017-09-21' AS date), 2017, 20173, 201709, 2017263, 3, 9, 263, 20, 4, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-09-14' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-15' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-22' AS date), 1058, 3176, 13811, 13812, 13812, 13812, 13811, 13811, 13811, 2458017, 58016, N'2017-09-20', 201738, 38, 3, N'2017-W38', N'2017-W38-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96687, CAST(N'2017-09-21' AS date), CAST(N'2017-09-22' AS date), 2017, 20173, 201709, 2017264, 3, 9, 264, 21, 5, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-09-15' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-22' AS date), 1058, 3176, 13811, 13812, 13812, 13812, 13812, 13811, 13811, 2458018, 58017, N'2017-09-21', 201738, 38, 4, N'2017-W38', N'2017-W38-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96688, CAST(N'2017-09-22' AS date), CAST(N'2017-09-23' AS date), 2017, 20173, 201709, 2017265, 3, 9, 265, 22, 6, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-09-22' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-09-16' AS date), CAST(N'2017-09-22' AS date), 1058, 3176, 13811, 13812, 13812, 13812, 13812, 13812, 13811, 2458019, 58018, N'2017-09-22', 201738, 38, 5, N'2017-W38', N'2017-W38-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96689, CAST(N'2017-09-23' AS date), CAST(N'2017-09-24' AS date), 2017, 20173, 201709, 2017266, 3, 9, 266, 23, 7, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-17' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-09-22' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-29' AS date), 1058, 3176, 13811, 13812, 13812, 13812, 13812, 13812, 13812, 2458020, 58019, N'2017-09-23', 201738, 38, 6, N'2017-W38', N'2017-W38-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96690, CAST(N'2017-09-24' AS date), CAST(N'2017-09-25' AS date), 2017, 20173, 201709, 2017267, 3, 9, 267, 24, 1, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-18' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-09-22' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-29' AS date), 1058, 3176, 13812, 13812, 13812, 13812, 13812, 13812, 13812, 2458021, 58020, N'2017-09-24', 201738, 38, 7, N'2017-W38', N'2017-W38-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96691, CAST(N'2017-09-25' AS date), CAST(N'2017-09-26' AS date), 2017, 20173, 201709, 2017268, 3, 9, 268, 25, 2, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-09-19' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-09-22' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-29' AS date), 1058, 3176, 13812, 13813, 13812, 13812, 13812, 13812, 13812, 2458022, 58021, N'2017-09-25', 201739, 39, 1, N'2017-W39', N'2017-W39-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96692, CAST(N'2017-09-26' AS date), CAST(N'2017-09-27' AS date), 2017, 20173, 201709, 2017269, 3, 9, 269, 26, 3, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-09-20' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-09-22' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-29' AS date), 1058, 3176, 13812, 13813, 13813, 13812, 13812, 13812, 13812, 2458023, 58022, N'2017-09-26', 201739, 39, 2, N'2017-W39', N'2017-W39-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96693, CAST(N'2017-09-27' AS date), CAST(N'2017-09-28' AS date), 2017, 20173, 201709, 2017270, 3, 9, 270, 27, 4, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-09-21' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-09-22' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-29' AS date), 1058, 3176, 13812, 13813, 13813, 13813, 13812, 13812, 13812, 2458024, 58023, N'2017-09-27', 201739, 39, 3, N'2017-W39', N'2017-W39-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96694, CAST(N'2017-09-28' AS date), CAST(N'2017-09-29' AS date), 2017, 20173, 201709, 2017271, 3, 9, 271, 28, 5, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-09-22' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-29' AS date), 1058, 3176, 13812, 13813, 13813, 13813, 13813, 13812, 13812, 2458025, 58024, N'2017-09-28', 201739, 39, 4, N'2017-W39', N'2017-W39-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96695, CAST(N'2017-09-29' AS date), CAST(N'2017-09-30' AS date), 2017, 20173, 201709, 2017272, 3, 9, 272, 29, 6, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-09-29' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-09-23' AS date), CAST(N'2017-09-29' AS date), 1058, 3176, 13812, 13813, 13813, 13813, 13813, 13813, 13812, 2458026, 58025, N'2017-09-29', 201739, 39, 5, N'2017-W39', N'2017-W39-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96696, CAST(N'2017-09-30' AS date), CAST(N'2017-10-01' AS date), 2017, 20173, 201709, 2017273, 3, 9, 273, 30, 7, N'2017', N'2017 Q3', N'2017 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-07-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-01' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-24' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-09-29' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-10-06' AS date), 1058, 3176, 13812, 13813, 13813, 13813, 13813, 13813, 13813, 2458027, 58026, N'2017-09-30', 201739, 39, 6, N'2017-W39', N'2017-W39-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96697, CAST(N'2017-10-01' AS date), CAST(N'2017-10-02' AS date), 2017, 20174, 201710, 2017274, 4, 10, 274, 1, 1, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-09-25' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-09-29' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-10-06' AS date), 1059, 3177, 13813, 13813, 13813, 13813, 13813, 13813, 13813, 2458028, 58027, N'2017-10-01', 201739, 39, 7, N'2017-W39', N'2017-W39-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96698, CAST(N'2017-10-02' AS date), CAST(N'2017-10-03' AS date), 2017, 20174, 201710, 2017275, 4, 10, 275, 2, 2, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-09-26' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-09-29' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-10-06' AS date), 1059, 3177, 13813, 13814, 13813, 13813, 13813, 13813, 13813, 2458029, 58028, N'2017-10-02', 201740, 40, 1, N'2017-W40', N'2017-W40-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96699, CAST(N'2017-10-03' AS date), CAST(N'2017-10-04' AS date), 2017, 20174, 201710, 2017276, 4, 10, 276, 3, 3, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-09-27' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-09-29' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-10-06' AS date), 1059, 3177, 13813, 13814, 13814, 13813, 13813, 13813, 13813, 2458030, 58029, N'2017-10-03', 201740, 40, 2, N'2017-W40', N'2017-W40-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96700, CAST(N'2017-10-04' AS date), CAST(N'2017-10-05' AS date), 2017, 20174, 201710, 2017277, 4, 10, 277, 4, 4, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-09-28' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-09-29' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-10-06' AS date), 1059, 3177, 13813, 13814, 13814, 13814, 13813, 13813, 13813, 2458031, 58030, N'2017-10-04', 201740, 40, 3, N'2017-W40', N'2017-W40-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96701, CAST(N'2017-10-05' AS date), CAST(N'2017-10-06' AS date), 2017, 20174, 201710, 2017278, 4, 10, 278, 5, 5, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-09-29' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-10-06' AS date), 1059, 3177, 13813, 13814, 13814, 13814, 13814, 13813, 13813, 2458032, 58031, N'2017-10-05', 201740, 40, 4, N'2017-W40', N'2017-W40-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96702, CAST(N'2017-10-06' AS date), CAST(N'2017-10-07' AS date), 2017, 20174, 201710, 2017279, 4, 10, 279, 6, 6, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-06' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-09-30' AS date), CAST(N'2017-10-06' AS date), 1059, 3177, 13813, 13814, 13814, 13814, 13814, 13814, 13813, 2458033, 58032, N'2017-10-06', 201740, 40, 5, N'2017-W40', N'2017-W40-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96703, CAST(N'2017-10-07' AS date), CAST(N'2017-10-08' AS date), 2017, 20174, 201710, 2017280, 4, 10, 280, 7, 7, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-06' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-13' AS date), 1059, 3177, 13813, 13814, 13814, 13814, 13814, 13814, 13814, 2458034, 58033, N'2017-10-07', 201740, 40, 6, N'2017-W40', N'2017-W40-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96704, CAST(N'2017-10-08' AS date), CAST(N'2017-10-09' AS date), 2017, 20174, 201710, 2017281, 4, 10, 281, 8, 1, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-02' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-06' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-13' AS date), 1059, 3177, 13814, 13814, 13814, 13814, 13814, 13814, 13814, 2458035, 58034, N'2017-10-08', 201740, 40, 7, N'2017-W40', N'2017-W40-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96705, CAST(N'2017-10-09' AS date), CAST(N'2017-10-10' AS date), 2017, 20174, 201710, 2017282, 4, 10, 282, 9, 2, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-03' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-06' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-13' AS date), 1059, 3177, 13814, 13815, 13814, 13814, 13814, 13814, 13814, 2458036, 58035, N'2017-10-09', 201741, 41, 1, N'2017-W41', N'2017-W41-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96706, CAST(N'2017-10-10' AS date), CAST(N'2017-10-11' AS date), 2017, 20174, 201710, 2017283, 4, 10, 283, 10, 3, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-04' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-06' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-13' AS date), 1059, 3177, 13814, 13815, 13815, 13814, 13814, 13814, 13814, 2458037, 58036, N'2017-10-10', 201741, 41, 2, N'2017-W41', N'2017-W41-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96707, CAST(N'2017-10-11' AS date), CAST(N'2017-10-12' AS date), 2017, 20174, 201710, 2017284, 4, 10, 284, 11, 4, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-05' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-06' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-13' AS date), 1059, 3177, 13814, 13815, 13815, 13815, 13814, 13814, 13814, 2458038, 58037, N'2017-10-11', 201741, 41, 3, N'2017-W41', N'2017-W41-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96708, CAST(N'2017-10-12' AS date), CAST(N'2017-10-13' AS date), 2017, 20174, 201710, 2017285, 4, 10, 285, 12, 5, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-06' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-13' AS date), 1059, 3177, 13814, 13815, 13815, 13815, 13815, 13814, 13814, 2458039, 58038, N'2017-10-12', 201741, 41, 4, N'2017-W41', N'2017-W41-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96709, CAST(N'2017-10-13' AS date), CAST(N'2017-10-14' AS date), 2017, 20174, 201710, 2017286, 4, 10, 286, 13, 6, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-13' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-07' AS date), CAST(N'2017-10-13' AS date), 1059, 3177, 13814, 13815, 13815, 13815, 13815, 13815, 13814, 2458040, 58039, N'2017-10-13', 201741, 41, 5, N'2017-W41', N'2017-W41-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96710, CAST(N'2017-10-14' AS date), CAST(N'2017-10-15' AS date), 2017, 20174, 201710, 2017287, 4, 10, 287, 14, 7, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-08' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-13' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-20' AS date), 1059, 3177, 13814, 13815, 13815, 13815, 13815, 13815, 13815, 2458041, 58040, N'2017-10-14', 201741, 41, 6, N'2017-W41', N'2017-W41-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96711, CAST(N'2017-10-15' AS date), CAST(N'2017-10-16' AS date), 2017, 20174, 201710, 2017288, 4, 10, 288, 15, 1, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-09' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-13' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-20' AS date), 1059, 3177, 13815, 13815, 13815, 13815, 13815, 13815, 13815, 2458042, 58041, N'2017-10-15', 201741, 41, 7, N'2017-W41', N'2017-W41-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96712, CAST(N'2017-10-16' AS date), CAST(N'2017-10-17' AS date), 2017, 20174, 201710, 2017289, 4, 10, 289, 16, 2, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-10' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-13' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-20' AS date), 1059, 3177, 13815, 13816, 13815, 13815, 13815, 13815, 13815, 2458043, 58042, N'2017-10-16', 201742, 42, 1, N'2017-W42', N'2017-W42-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96713, CAST(N'2017-10-17' AS date), CAST(N'2017-10-18' AS date), 2017, 20174, 201710, 2017290, 4, 10, 290, 17, 3, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-11' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-13' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-20' AS date), 1059, 3177, 13815, 13816, 13816, 13815, 13815, 13815, 13815, 2458044, 58043, N'2017-10-17', 201742, 42, 2, N'2017-W42', N'2017-W42-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96714, CAST(N'2017-10-18' AS date), CAST(N'2017-10-19' AS date), 2017, 20174, 201710, 2017291, 4, 10, 291, 18, 4, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-12' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-13' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-20' AS date), 1059, 3177, 13815, 13816, 13816, 13816, 13815, 13815, 13815, 2458045, 58044, N'2017-10-18', 201742, 42, 3, N'2017-W42', N'2017-W42-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96715, CAST(N'2017-10-19' AS date), CAST(N'2017-10-20' AS date), 2017, 20174, 201710, 2017292, 4, 10, 292, 19, 5, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-13' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-20' AS date), 1059, 3177, 13815, 13816, 13816, 13816, 13816, 13815, 13815, 2458046, 58045, N'2017-10-19', 201742, 42, 4, N'2017-W42', N'2017-W42-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96716, CAST(N'2017-10-20' AS date), CAST(N'2017-10-21' AS date), 2017, 20174, 201710, 2017293, 4, 10, 293, 20, 6, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-20' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-10-14' AS date), CAST(N'2017-10-20' AS date), 1059, 3177, 13815, 13816, 13816, 13816, 13816, 13816, 13815, 2458047, 58046, N'2017-10-20', 201742, 42, 5, N'2017-W42', N'2017-W42-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96717, CAST(N'2017-10-21' AS date), CAST(N'2017-10-22' AS date), 2017, 20174, 201710, 2017294, 4, 10, 294, 21, 7, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-15' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-20' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-27' AS date), 1059, 3177, 13815, 13816, 13816, 13816, 13816, 13816, 13816, 2458048, 58047, N'2017-10-21', 201742, 42, 6, N'2017-W42', N'2017-W42-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96718, CAST(N'2017-10-22' AS date), CAST(N'2017-10-23' AS date), 2017, 20174, 201710, 2017295, 4, 10, 295, 22, 1, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-10-16' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-20' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-27' AS date), 1059, 3177, 13816, 13816, 13816, 13816, 13816, 13816, 13816, 2458049, 58048, N'2017-10-22', 201742, 42, 7, N'2017-W42', N'2017-W42-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96719, CAST(N'2017-10-23' AS date), CAST(N'2017-10-24' AS date), 2017, 20174, 201710, 2017296, 4, 10, 296, 23, 2, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-10-17' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-20' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-27' AS date), 1059, 3177, 13816, 13817, 13816, 13816, 13816, 13816, 13816, 2458050, 58049, N'2017-10-23', 201743, 43, 1, N'2017-W43', N'2017-W43-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96720, CAST(N'2017-10-24' AS date), CAST(N'2017-10-25' AS date), 2017, 20174, 201710, 2017297, 4, 10, 297, 24, 3, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-10-18' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-20' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-27' AS date), 1059, 3177, 13816, 13817, 13817, 13816, 13816, 13816, 13816, 2458051, 58050, N'2017-10-24', 201743, 43, 2, N'2017-W43', N'2017-W43-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96721, CAST(N'2017-10-25' AS date), CAST(N'2017-10-26' AS date), 2017, 20174, 201710, 2017298, 4, 10, 298, 25, 4, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-19' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-20' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-27' AS date), 1059, 3177, 13816, 13817, 13817, 13817, 13816, 13816, 13816, 2458052, 58051, N'2017-10-25', 201743, 43, 3, N'2017-W43', N'2017-W43-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96722, CAST(N'2017-10-26' AS date), CAST(N'2017-10-27' AS date), 2017, 20174, 201710, 2017299, 4, 10, 299, 26, 5, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-10-20' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-27' AS date), 1059, 3177, 13816, 13817, 13817, 13817, 13817, 13816, 13816, 2458053, 58052, N'2017-10-26', 201743, 43, 4, N'2017-W43', N'2017-W43-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96723, CAST(N'2017-10-27' AS date), CAST(N'2017-10-28' AS date), 2017, 20174, 201710, 2017300, 4, 10, 300, 27, 6, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-10-27' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-10-21' AS date), CAST(N'2017-10-27' AS date), 1059, 3177, 13816, 13817, 13817, 13817, 13817, 13817, 13816, 2458054, 58053, N'2017-10-27', 201743, 43, 5, N'2017-W43', N'2017-W43-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96724, CAST(N'2017-10-28' AS date), CAST(N'2017-10-29' AS date), 2017, 20174, 201710, 2017301, 4, 10, 301, 28, 7, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-22' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-10-27' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-11-03' AS date), 1059, 3177, 13816, 13817, 13817, 13817, 13817, 13817, 13817, 2458055, 58054, N'2017-10-28', 201743, 43, 6, N'2017-W43', N'2017-W43-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96725, CAST(N'2017-10-29' AS date), CAST(N'2017-10-30' AS date), 2017, 20174, 201710, 2017302, 4, 10, 302, 29, 1, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-10-23' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-10-27' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-11-03' AS date), 1059, 3177, 13817, 13817, 13817, 13817, 13817, 13817, 13817, 2458056, 58055, N'2017-10-29', 201743, 43, 7, N'2017-W43', N'2017-W43-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96726, CAST(N'2017-10-30' AS date), CAST(N'2017-10-31' AS date), 2017, 20174, 201710, 2017303, 4, 10, 303, 30, 2, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-10-24' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-10-27' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-11-03' AS date), 1059, 3177, 13817, 13818, 13817, 13817, 13817, 13817, 13817, 2458057, 58056, N'2017-10-30', 201744, 44, 1, N'2017-W44', N'2017-W44-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96727, CAST(N'2017-10-31' AS date), CAST(N'2017-11-01' AS date), 2017, 20174, 201710, 2017304, 4, 10, 304, 31, 3, N'2017', N'2017 Q4', N'2017 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-10-25' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-10-27' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-11-03' AS date), 1059, 3177, 13817, 13818, 13818, 13817, 13817, 13817, 13817, 2458058, 58057, N'2017-10-31', 201744, 44, 2, N'2017-W44', N'2017-W44-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96728, CAST(N'2017-11-01' AS date), CAST(N'2017-11-02' AS date), 2017, 20174, 201711, 2017305, 4, 11, 305, 1, 4, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-10-26' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-10-27' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-11-03' AS date), 1059, 3178, 13817, 13818, 13818, 13818, 13817, 13817, 13817, 2458059, 58058, N'2017-11-01', 201744, 44, 3, N'2017-W44', N'2017-W44-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96729, CAST(N'2017-11-02' AS date), CAST(N'2017-11-03' AS date), 2017, 20174, 201711, 2017306, 4, 11, 306, 2, 5, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-10-27' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-11-03' AS date), 1059, 3178, 13817, 13818, 13818, 13818, 13818, 13817, 13817, 2458060, 58059, N'2017-11-02', 201744, 44, 4, N'2017-W44', N'2017-W44-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96730, CAST(N'2017-11-03' AS date), CAST(N'2017-11-04' AS date), 2017, 20174, 201711, 2017307, 4, 11, 307, 3, 6, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-03' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-10-28' AS date), CAST(N'2017-11-03' AS date), 1059, 3178, 13817, 13818, 13818, 13818, 13818, 13818, 13817, 2458061, 58060, N'2017-11-03', 201744, 44, 5, N'2017-W44', N'2017-W44-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96731, CAST(N'2017-11-04' AS date), CAST(N'2017-11-05' AS date), 2017, 20174, 201711, 2017308, 4, 11, 308, 4, 7, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-10-29' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-03' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-11-10' AS date), 1059, 3178, 13817, 13818, 13818, 13818, 13818, 13818, 13818, 2458062, 58061, N'2017-11-04', 201744, 44, 6, N'2017-W44', N'2017-W44-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96732, CAST(N'2017-11-05' AS date), CAST(N'2017-11-06' AS date), 2017, 20174, 201711, 2017309, 4, 11, 309, 5, 1, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-10-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-03' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-11-10' AS date), 1059, 3178, 13818, 13818, 13818, 13818, 13818, 13818, 13818, 2458063, 58062, N'2017-11-05', 201744, 44, 7, N'2017-W44', N'2017-W44-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96733, CAST(N'2017-11-06' AS date), CAST(N'2017-11-07' AS date), 2017, 20174, 201711, 2017310, 4, 11, 310, 6, 2, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-10-31' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-03' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-11-10' AS date), 1059, 3178, 13818, 13819, 13818, 13818, 13818, 13818, 13818, 2458064, 58063, N'2017-11-06', 201745, 45, 1, N'2017-W45', N'2017-W45-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96734, CAST(N'2017-11-07' AS date), CAST(N'2017-11-08' AS date), 2017, 20174, 201711, 2017311, 4, 11, 311, 7, 3, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-03' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-11-10' AS date), 1059, 3178, 13818, 13819, 13819, 13818, 13818, 13818, 13818, 2458065, 58064, N'2017-11-07', 201745, 45, 2, N'2017-W45', N'2017-W45-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96735, CAST(N'2017-11-08' AS date), CAST(N'2017-11-09' AS date), 2017, 20174, 201711, 2017312, 4, 11, 312, 8, 4, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-02' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-03' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-11-10' AS date), 1059, 3178, 13818, 13819, 13819, 13819, 13818, 13818, 13818, 2458066, 58065, N'2017-11-08', 201745, 45, 3, N'2017-W45', N'2017-W45-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96736, CAST(N'2017-11-09' AS date), CAST(N'2017-11-10' AS date), 2017, 20174, 201711, 2017313, 4, 11, 313, 9, 5, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-03' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-11-10' AS date), 1059, 3178, 13818, 13819, 13819, 13819, 13819, 13818, 13818, 2458067, 58066, N'2017-11-09', 201745, 45, 4, N'2017-W45', N'2017-W45-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96737, CAST(N'2017-11-10' AS date), CAST(N'2017-11-11' AS date), 2017, 20174, 201711, 2017314, 4, 11, 314, 10, 6, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-10' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-04' AS date), CAST(N'2017-11-10' AS date), 1059, 3178, 13818, 13819, 13819, 13819, 13819, 13819, 13818, 2458068, 58067, N'2017-11-10', 201745, 45, 5, N'2017-W45', N'2017-W45-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96738, CAST(N'2017-11-11' AS date), CAST(N'2017-11-12' AS date), 2017, 20174, 201711, 2017315, 4, 11, 315, 11, 7, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-05' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-10' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-17' AS date), 1059, 3178, 13818, 13819, 13819, 13819, 13819, 13819, 13819, 2458069, 58068, N'2017-11-11', 201745, 45, 6, N'2017-W45', N'2017-W45-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96739, CAST(N'2017-11-12' AS date), CAST(N'2017-11-13' AS date), 2017, 20174, 201711, 2017316, 4, 11, 316, 12, 1, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-06' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-10' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-17' AS date), 1059, 3178, 13819, 13819, 13819, 13819, 13819, 13819, 13819, 2458070, 58069, N'2017-11-12', 201745, 45, 7, N'2017-W45', N'2017-W45-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96740, CAST(N'2017-11-13' AS date), CAST(N'2017-11-14' AS date), 2017, 20174, 201711, 2017317, 4, 11, 317, 13, 2, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-07' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-10' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-17' AS date), 1059, 3178, 13819, 13820, 13819, 13819, 13819, 13819, 13819, 2458071, 58070, N'2017-11-13', 201746, 46, 1, N'2017-W46', N'2017-W46-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96741, CAST(N'2017-11-14' AS date), CAST(N'2017-11-15' AS date), 2017, 20174, 201711, 2017318, 4, 11, 318, 14, 3, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-08' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-10' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-17' AS date), 1059, 3178, 13819, 13820, 13820, 13819, 13819, 13819, 13819, 2458072, 58071, N'2017-11-14', 201746, 46, 2, N'2017-W46', N'2017-W46-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96742, CAST(N'2017-11-15' AS date), CAST(N'2017-11-16' AS date), 2017, 20174, 201711, 2017319, 4, 11, 319, 15, 4, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-09' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-10' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-17' AS date), 1059, 3178, 13819, 13820, 13820, 13820, 13819, 13819, 13819, 2458073, 58072, N'2017-11-15', 201746, 46, 3, N'2017-W46', N'2017-W46-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96743, CAST(N'2017-11-16' AS date), CAST(N'2017-11-17' AS date), 2017, 20174, 201711, 2017320, 4, 11, 320, 16, 5, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-10' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-17' AS date), 1059, 3178, 13819, 13820, 13820, 13820, 13820, 13819, 13819, 2458074, 58073, N'2017-11-16', 201746, 46, 4, N'2017-W46', N'2017-W46-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96744, CAST(N'2017-11-17' AS date), CAST(N'2017-11-18' AS date), 2017, 20174, 201711, 2017321, 4, 11, 321, 17, 6, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-17' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-11' AS date), CAST(N'2017-11-17' AS date), 1059, 3178, 13819, 13820, 13820, 13820, 13820, 13820, 13819, 2458075, 58074, N'2017-11-17', 201746, 46, 5, N'2017-W46', N'2017-W46-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96745, CAST(N'2017-11-18' AS date), CAST(N'2017-11-19' AS date), 2017, 20174, 201711, 2017322, 4, 11, 322, 18, 7, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-12' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-17' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-24' AS date), 1059, 3178, 13819, 13820, 13820, 13820, 13820, 13820, 13820, 2458076, 58075, N'2017-11-18', 201746, 46, 6, N'2017-W46', N'2017-W46-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96746, CAST(N'2017-11-19' AS date), CAST(N'2017-11-20' AS date), 2017, 20174, 201711, 2017323, 4, 11, 323, 19, 1, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-11-13' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-17' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-24' AS date), 1059, 3178, 13820, 13820, 13820, 13820, 13820, 13820, 13820, 2458077, 58076, N'2017-11-19', 201746, 46, 7, N'2017-W46', N'2017-W46-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96747, CAST(N'2017-11-20' AS date), CAST(N'2017-11-21' AS date), 2017, 20174, 201711, 2017324, 4, 11, 324, 20, 2, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-11-14' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-17' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-24' AS date), 1059, 3178, 13820, 13821, 13820, 13820, 13820, 13820, 13820, 2458078, 58077, N'2017-11-20', 201747, 47, 1, N'2017-W47', N'2017-W47-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96748, CAST(N'2017-11-21' AS date), CAST(N'2017-11-22' AS date), 2017, 20174, 201711, 2017325, 4, 11, 325, 21, 3, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-11-15' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-17' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-24' AS date), 1059, 3178, 13820, 13821, 13821, 13820, 13820, 13820, 13820, 2458079, 58078, N'2017-11-21', 201747, 47, 2, N'2017-W47', N'2017-W47-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96749, CAST(N'2017-11-22' AS date), CAST(N'2017-11-23' AS date), 2017, 20174, 201711, 2017326, 4, 11, 326, 22, 4, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-11-16' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-17' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-24' AS date), 1059, 3178, 13820, 13821, 13821, 13821, 13820, 13820, 13820, 2458080, 58079, N'2017-11-22', 201747, 47, 3, N'2017-W47', N'2017-W47-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96750, CAST(N'2017-11-23' AS date), CAST(N'2017-11-24' AS date), 2017, 20174, 201711, 2017327, 4, 11, 327, 23, 5, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-11-17' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-24' AS date), 1059, 3178, 13820, 13821, 13821, 13821, 13821, 13820, 13820, 2458081, 58080, N'2017-11-23', 201747, 47, 4, N'2017-W47', N'2017-W47-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96751, CAST(N'2017-11-24' AS date), CAST(N'2017-11-25' AS date), 2017, 20174, 201711, 2017328, 4, 11, 328, 24, 6, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-11-24' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-18' AS date), CAST(N'2017-11-24' AS date), 1059, 3178, 13820, 13821, 13821, 13821, 13821, 13821, 13820, 2458082, 58081, N'2017-11-24', 201747, 47, 5, N'2017-W47', N'2017-W47-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96752, CAST(N'2017-11-25' AS date), CAST(N'2017-11-26' AS date), 2017, 20174, 201711, 2017329, 4, 11, 329, 25, 7, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-19' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-11-24' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-12-01' AS date), 1059, 3178, 13820, 13821, 13821, 13821, 13821, 13821, 13821, 2458083, 58082, N'2017-11-25', 201747, 47, 6, N'2017-W47', N'2017-W47-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96753, CAST(N'2017-11-26' AS date), CAST(N'2017-11-27' AS date), 2017, 20174, 201711, 2017330, 4, 11, 330, 26, 1, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-11-20' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-11-24' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-12-01' AS date), 1059, 3178, 13821, 13821, 13821, 13821, 13821, 13821, 13821, 2458084, 58083, N'2017-11-26', 201747, 47, 7, N'2017-W47', N'2017-W47-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96754, CAST(N'2017-11-27' AS date), CAST(N'2017-11-28' AS date), 2017, 20174, 201711, 2017331, 4, 11, 331, 27, 2, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-11-21' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-11-24' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-12-01' AS date), 1059, 3178, 13821, 13822, 13821, 13821, 13821, 13821, 13821, 2458085, 58084, N'2017-11-27', 201748, 48, 1, N'2017-W48', N'2017-W48-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96755, CAST(N'2017-11-28' AS date), CAST(N'2017-11-29' AS date), 2017, 20174, 201711, 2017332, 4, 11, 332, 28, 3, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-11-22' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-11-24' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-12-01' AS date), 1059, 3178, 13821, 13822, 13822, 13821, 13821, 13821, 13821, 2458086, 58085, N'2017-11-28', 201748, 48, 2, N'2017-W48', N'2017-W48-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96756, CAST(N'2017-11-29' AS date), CAST(N'2017-11-30' AS date), 2017, 20174, 201711, 2017333, 4, 11, 333, 29, 4, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-11-23' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-11-24' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-12-01' AS date), 1059, 3178, 13821, 13822, 13822, 13822, 13821, 13821, 13821, 2458087, 58086, N'2017-11-29', 201748, 48, 3, N'2017-W48', N'2017-W48-3');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96757, CAST(N'2017-11-30' AS date), CAST(N'2017-12-01' AS date), 2017, 20174, 201711, 2017334, 4, 11, 334, 30, 5, N'2017', N'2017 Q4', N'2017 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-01' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-11-24' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-12-01' AS date), 1059, 3178, 13821, 13822, 13822, 13822, 13822, 13821, 13821, 2458088, 58087, N'2017-11-30', 201748, 48, 4, N'2017-W48', N'2017-W48-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96758, CAST(N'2017-12-01' AS date), CAST(N'2017-12-02' AS date), 2017, 20174, 201712, 2017335, 4, 12, 335, 1, 6, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-11-25' AS date), CAST(N'2017-12-01' AS date), 1059, 3179, 13821, 13822, 13822, 13822, 13822, 13822, 13821, 2458089, 58088, N'2017-12-01', 201748, 48, 5, N'2017-W48', N'2017-W48-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96759, CAST(N'2017-12-02' AS date), CAST(N'2017-12-03' AS date), 2017, 20174, 201712, 2017336, 4, 12, 336, 2, 7, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-11-26' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-12-08' AS date), 1059, 3179, 13821, 13822, 13822, 13822, 13822, 13822, 13822, 2458090, 58089, N'2017-12-02', 201748, 48, 6, N'2017-W48', N'2017-W48-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96760, CAST(N'2017-12-03' AS date), CAST(N'2017-12-04' AS date), 2017, 20174, 201712, 2017337, 4, 12, 337, 3, 1, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-11-27' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-12-08' AS date), 1059, 3179, 13822, 13822, 13822, 13822, 13822, 13822, 13822, 2458091, 58090, N'2017-12-03', 201748, 48, 7, N'2017-W48', N'2017-W48-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96761, CAST(N'2017-12-04' AS date), CAST(N'2017-12-05' AS date), 2017, 20174, 201712, 2017338, 4, 12, 338, 4, 2, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-11-28' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-12-08' AS date), 1059, 3179, 13822, 13823, 13822, 13822, 13822, 13822, 13822, 2458092, 58091, N'2017-12-04', 201749, 49, 1, N'2017-W49', N'2017-W49-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96762, CAST(N'2017-12-05' AS date), CAST(N'2017-12-06' AS date), 2017, 20174, 201712, 2017339, 4, 12, 339, 5, 3, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-11-29' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-12-08' AS date), 1059, 3179, 13822, 13823, 13823, 13822, 13822, 13822, 13822, 2458093, 58092, N'2017-12-05', 201749, 49, 2, N'2017-W49', N'2017-W49-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96763, CAST(N'2017-12-06' AS date), CAST(N'2017-12-07' AS date), 2017, 20174, 201712, 2017340, 4, 12, 340, 6, 4, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-11-30' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-12-08' AS date), 1059, 3179, 13822, 13823, 13823, 13823, 13822, 13822, 13822, 2458094, 58093, N'2017-12-06', 201749, 49, 3, N'2017-W49', N'2017-W49-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96764, CAST(N'2017-12-07' AS date), CAST(N'2017-12-08' AS date), 2017, 20174, 201712, 2017341, 4, 12, 341, 7, 5, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-12-08' AS date), 1059, 3179, 13822, 13823, 13823, 13823, 13823, 13822, 13822, 2458095, 58094, N'2017-12-07', 201749, 49, 4, N'2017-W49', N'2017-W49-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96765, CAST(N'2017-12-08' AS date), CAST(N'2017-12-09' AS date), 2017, 20174, 201712, 2017342, 4, 12, 342, 8, 6, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-08' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-02' AS date), CAST(N'2017-12-08' AS date), 1059, 3179, 13822, 13823, 13823, 13823, 13823, 13823, 13822, 2458096, 58095, N'2017-12-08', 201749, 49, 5, N'2017-W49', N'2017-W49-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96766, CAST(N'2017-12-09' AS date), CAST(N'2017-12-10' AS date), 2017, 20174, 201712, 2017343, 4, 12, 343, 9, 7, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-03' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-08' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-15' AS date), 1059, 3179, 13822, 13823, 13823, 13823, 13823, 13823, 13823, 2458097, 58096, N'2017-12-09', 201749, 49, 6, N'2017-W49', N'2017-W49-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96767, CAST(N'2017-12-10' AS date), CAST(N'2017-12-11' AS date), 2017, 20174, 201712, 2017344, 4, 12, 344, 10, 1, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-04' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-08' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-15' AS date), 1059, 3179, 13823, 13823, 13823, 13823, 13823, 13823, 13823, 2458098, 58097, N'2017-12-10', 201749, 49, 7, N'2017-W49', N'2017-W49-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96768, CAST(N'2017-12-11' AS date), CAST(N'2017-12-12' AS date), 2017, 20174, 201712, 2017345, 4, 12, 345, 11, 2, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-05' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-08' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-15' AS date), 1059, 3179, 13823, 13824, 13823, 13823, 13823, 13823, 13823, 2458099, 58098, N'2017-12-11', 201750, 50, 1, N'2017-W50', N'2017-W50-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96769, CAST(N'2017-12-12' AS date), CAST(N'2017-12-13' AS date), 2017, 20174, 201712, 2017346, 4, 12, 346, 12, 3, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-06' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-08' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-15' AS date), 1059, 3179, 13823, 13824, 13824, 13823, 13823, 13823, 13823, 2458100, 58099, N'2017-12-12', 201750, 50, 2, N'2017-W50', N'2017-W50-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96770, CAST(N'2017-12-13' AS date), CAST(N'2017-12-14' AS date), 2017, 20174, 201712, 2017347, 4, 12, 347, 13, 4, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-07' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-08' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-15' AS date), 1059, 3179, 13823, 13824, 13824, 13824, 13823, 13823, 13823, 2458101, 58100, N'2017-12-13', 201750, 50, 3, N'2017-W50', N'2017-W50-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96771, CAST(N'2017-12-14' AS date), CAST(N'2017-12-15' AS date), 2017, 20174, 201712, 2017348, 4, 12, 348, 14, 5, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-08' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-15' AS date), 1059, 3179, 13823, 13824, 13824, 13824, 13824, 13823, 13823, 2458102, 58101, N'2017-12-14', 201750, 50, 4, N'2017-W50', N'2017-W50-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96772, CAST(N'2017-12-15' AS date), CAST(N'2017-12-16' AS date), 2017, 20174, 201712, 2017349, 4, 12, 349, 15, 6, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-15' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-09' AS date), CAST(N'2017-12-15' AS date), 1059, 3179, 13823, 13824, 13824, 13824, 13824, 13824, 13823, 2458103, 58102, N'2017-12-15', 201750, 50, 5, N'2017-W50', N'2017-W50-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96773, CAST(N'2017-12-16' AS date), CAST(N'2017-12-17' AS date), 2017, 20174, 201712, 2017350, 4, 12, 350, 16, 7, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-10' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-15' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-22' AS date), 1059, 3179, 13823, 13824, 13824, 13824, 13824, 13824, 13824, 2458104, 58103, N'2017-12-16', 201750, 50, 6, N'2017-W50', N'2017-W50-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96774, CAST(N'2017-12-17' AS date), CAST(N'2017-12-18' AS date), 2017, 20174, 201712, 2017351, 4, 12, 351, 17, 1, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-11' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-15' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-22' AS date), 1059, 3179, 13824, 13824, 13824, 13824, 13824, 13824, 13824, 2458105, 58104, N'2017-12-17', 201750, 50, 7, N'2017-W50', N'2017-W50-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96775, CAST(N'2017-12-18' AS date), CAST(N'2017-12-19' AS date), 2017, 20174, 201712, 2017352, 4, 12, 352, 18, 2, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-12' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-15' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-22' AS date), 1059, 3179, 13824, 13825, 13824, 13824, 13824, 13824, 13824, 2458106, 58105, N'2017-12-18', 201751, 51, 1, N'2017-W51', N'2017-W51-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96776, CAST(N'2017-12-19' AS date), CAST(N'2017-12-20' AS date), 2017, 20174, 201712, 2017353, 4, 12, 353, 19, 3, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-13' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-15' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-22' AS date), 1059, 3179, 13824, 13825, 13825, 13824, 13824, 13824, 13824, 2458107, 58106, N'2017-12-19', 201751, 51, 2, N'2017-W51', N'2017-W51-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96777, CAST(N'2017-12-20' AS date), CAST(N'2017-12-21' AS date), 2017, 20174, 201712, 2017354, 4, 12, 354, 20, 4, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-26' AS date), CAST(N'2017-12-14' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-15' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-22' AS date), 1059, 3179, 13824, 13825, 13825, 13825, 13824, 13824, 13824, 2458108, 58107, N'2017-12-20', 201751, 51, 3, N'2017-W51', N'2017-W51-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96778, CAST(N'2017-12-21' AS date), CAST(N'2017-12-22' AS date), 2017, 20174, 201712, 2017355, 4, 12, 355, 21, 5, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-26' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-27' AS date), CAST(N'2017-12-15' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-22' AS date), 1059, 3179, 13824, 13825, 13825, 13825, 13825, 13824, 13824, 2458109, 58108, N'2017-12-21', 201751, 51, 4, N'2017-W51', N'2017-W51-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96779, CAST(N'2017-12-22' AS date), CAST(N'2017-12-23' AS date), 2017, 20174, 201712, 2017356, 4, 12, 356, 22, 6, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-26' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-27' AS date), CAST(N'2017-12-22' AS date), CAST(N'2017-12-28' AS date), CAST(N'2017-12-16' AS date), CAST(N'2017-12-22' AS date), 1059, 3179, 13824, 13825, 13825, 13825, 13825, 13825, 13824, 2458110, 58109, N'2017-12-22', 201751, 51, 5, N'2017-W51', N'2017-W51-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96780, CAST(N'2017-12-23' AS date), CAST(N'2017-12-24' AS date), 2017, 20174, 201712, 2017357, 4, 12, 357, 23, 7, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-17' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-26' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-27' AS date), CAST(N'2017-12-22' AS date), CAST(N'2017-12-28' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-29' AS date), 1059, 3179, 13824, 13825, 13825, 13825, 13825, 13825, 13825, 2458111, 58110, N'2017-12-23', 201751, 51, 6, N'2017-W51', N'2017-W51-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96781, CAST(N'2017-12-24' AS date), CAST(N'2017-12-25' AS date), 2017, 20174, 201712, 2017358, 4, 12, 358, 24, 1, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-30' AS date), CAST(N'2017-12-18' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-26' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-27' AS date), CAST(N'2017-12-22' AS date), CAST(N'2017-12-28' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-29' AS date), 1059, 3179, 13825, 13825, 13825, 13825, 13825, 13825, 13825, 2458112, 58111, N'2017-12-24', 201751, 51, 7, N'2017-W51', N'2017-W51-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96782, CAST(N'2017-12-25' AS date), CAST(N'2017-12-26' AS date), 2017, 20174, 201712, 2017359, 4, 12, 359, 25, 2, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-30' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-19' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-26' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-27' AS date), CAST(N'2017-12-22' AS date), CAST(N'2017-12-28' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-29' AS date), 1059, 3179, 13825, 13826, 13825, 13825, 13825, 13825, 13825, 2458113, 58112, N'2017-12-25', 201752, 52, 1, N'2017-W52', N'2017-W52-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96783, CAST(N'2017-12-26' AS date), CAST(N'2017-12-27' AS date), 2017, 20174, 201712, 2017360, 4, 12, 360, 26, 3, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-30' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-26' AS date), CAST(N'2018-01-01' AS date), CAST(N'2017-12-20' AS date), CAST(N'2017-12-26' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-27' AS date), CAST(N'2017-12-22' AS date), CAST(N'2017-12-28' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-29' AS date), 1059, 3179, 13825, 13826, 13826, 13825, 13825, 13825, 13825, 2458114, 58113, N'2017-12-26', 201752, 52, 2, N'2017-W52', N'2017-W52-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96784, CAST(N'2017-12-27' AS date), CAST(N'2017-12-28' AS date), 2017, 20174, 201712, 2017361, 4, 12, 361, 27, 4, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-30' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-26' AS date), CAST(N'2018-01-01' AS date), CAST(N'2017-12-27' AS date), CAST(N'2018-01-02' AS date), CAST(N'2017-12-21' AS date), CAST(N'2017-12-27' AS date), CAST(N'2017-12-22' AS date), CAST(N'2017-12-28' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-29' AS date), 1059, 3179, 13825, 13826, 13826, 13826, 13825, 13825, 13825, 2458115, 58114, N'2017-12-27', 201752, 52, 3, N'2017-W52', N'2017-W52-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96785, CAST(N'2017-12-28' AS date), CAST(N'2017-12-29' AS date), 2017, 20174, 201712, 2017362, 4, 12, 362, 28, 5, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-30' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-26' AS date), CAST(N'2018-01-01' AS date), CAST(N'2017-12-27' AS date), CAST(N'2018-01-02' AS date), CAST(N'2017-12-28' AS date), CAST(N'2018-01-03' AS date), CAST(N'2017-12-22' AS date), CAST(N'2017-12-28' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-29' AS date), 1059, 3179, 13825, 13826, 13826, 13826, 13826, 13825, 13825, 2458116, 58115, N'2017-12-28', 201752, 52, 4, N'2017-W52', N'2017-W52-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96786, CAST(N'2017-12-29' AS date), CAST(N'2017-12-30' AS date), 2017, 20174, 201712, 2017363, 4, 12, 363, 29, 6, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-30' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-26' AS date), CAST(N'2018-01-01' AS date), CAST(N'2017-12-27' AS date), CAST(N'2018-01-02' AS date), CAST(N'2017-12-28' AS date), CAST(N'2018-01-03' AS date), CAST(N'2017-12-29' AS date), CAST(N'2018-01-04' AS date), CAST(N'2017-12-23' AS date), CAST(N'2017-12-29' AS date), 1059, 3179, 13825, 13826, 13826, 13826, 13826, 13826, 13825, 2458117, 58116, N'2017-12-29', 201752, 52, 5, N'2017-W52', N'2017-W52-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96787, CAST(N'2017-12-30' AS date), CAST(N'2017-12-31' AS date), 2017, 20174, 201712, 2017364, 4, 12, 364, 30, 7, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-24' AS date), CAST(N'2017-12-30' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-26' AS date), CAST(N'2018-01-01' AS date), CAST(N'2017-12-27' AS date), CAST(N'2018-01-02' AS date), CAST(N'2017-12-28' AS date), CAST(N'2018-01-03' AS date), CAST(N'2017-12-29' AS date), CAST(N'2018-01-04' AS date), CAST(N'2017-12-30' AS date), CAST(N'2018-01-05' AS date), 1059, 3179, 13825, 13826, 13826, 13826, 13826, 13826, 13826, 2458118, 58117, N'2017-12-30', 201752, 52, 6, N'2017-W52', N'2017-W52-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96788, CAST(N'2017-12-31' AS date), CAST(N'2018-01-01' AS date), 2017, 20174, 201712, 2017365, 4, 12, 365, 31, 1, N'2017', N'2017 Q4', N'2017 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2017-01-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-10-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-01' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-31' AS date), CAST(N'2018-01-06' AS date), CAST(N'2017-12-25' AS date), CAST(N'2017-12-31' AS date), CAST(N'2017-12-26' AS date), CAST(N'2018-01-01' AS date), CAST(N'2017-12-27' AS date), CAST(N'2018-01-02' AS date), CAST(N'2017-12-28' AS date), CAST(N'2018-01-03' AS date), CAST(N'2017-12-29' AS date), CAST(N'2018-01-04' AS date), CAST(N'2017-12-30' AS date), CAST(N'2018-01-05' AS date), 1059, 3179, 13826, 13826, 13826, 13826, 13826, 13826, 13826, 2458119, 58118, N'2017-12-31', 201752, 52, 7, N'2017-W52', N'2017-W52-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96789, CAST(N'2018-01-01' AS date), CAST(N'2018-01-02' AS date), 2018, 20181, 201801, 2018001, 1, 1, 1, 1, 2, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2017-12-31' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-07' AS date), CAST(N'2017-12-26' AS date), CAST(N'2018-01-01' AS date), CAST(N'2017-12-27' AS date), CAST(N'2018-01-02' AS date), CAST(N'2017-12-28' AS date), CAST(N'2018-01-03' AS date), CAST(N'2017-12-29' AS date), CAST(N'2018-01-04' AS date), CAST(N'2017-12-30' AS date), CAST(N'2018-01-05' AS date), 1060, 3180, 13826, 13827, 13826, 13826, 13826, 13826, 13826, 2458120, 58119, N'2018-01-01', 201801, 1, 1, N'2018-W01', N'2018-W01-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96790, CAST(N'2018-01-02' AS date), CAST(N'2018-01-03' AS date), 2018, 20181, 201801, 2018002, 1, 1, 2, 2, 3, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2017-12-31' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-02' AS date), CAST(N'2018-01-08' AS date), CAST(N'2017-12-27' AS date), CAST(N'2018-01-02' AS date), CAST(N'2017-12-28' AS date), CAST(N'2018-01-03' AS date), CAST(N'2017-12-29' AS date), CAST(N'2018-01-04' AS date), CAST(N'2017-12-30' AS date), CAST(N'2018-01-05' AS date), 1060, 3180, 13826, 13827, 13827, 13826, 13826, 13826, 13826, 2458121, 58120, N'2018-01-02', 201801, 1, 2, N'2018-W01', N'2018-W01-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96791, CAST(N'2018-01-03' AS date), CAST(N'2018-01-04' AS date), 2018, 20181, 201801, 2018003, 1, 1, 3, 3, 4, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2017-12-31' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-02' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-03' AS date), CAST(N'2018-01-09' AS date), CAST(N'2017-12-28' AS date), CAST(N'2018-01-03' AS date), CAST(N'2017-12-29' AS date), CAST(N'2018-01-04' AS date), CAST(N'2017-12-30' AS date), CAST(N'2018-01-05' AS date), 1060, 3180, 13826, 13827, 13827, 13827, 13826, 13826, 13826, 2458122, 58121, N'2018-01-03', 201801, 1, 3, N'2018-W01', N'2018-W01-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96792, CAST(N'2018-01-04' AS date), CAST(N'2018-01-05' AS date), 2018, 20181, 201801, 2018004, 1, 1, 4, 4, 5, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2017-12-31' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-02' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-03' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-04' AS date), CAST(N'2018-01-10' AS date), CAST(N'2017-12-29' AS date), CAST(N'2018-01-04' AS date), CAST(N'2017-12-30' AS date), CAST(N'2018-01-05' AS date), 1060, 3180, 13826, 13827, 13827, 13827, 13827, 13826, 13826, 2458123, 58122, N'2018-01-04', 201801, 1, 4, N'2018-W01', N'2018-W01-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96793, CAST(N'2018-01-05' AS date), CAST(N'2018-01-06' AS date), 2018, 20181, 201801, 2018005, 1, 1, 5, 5, 6, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2017-12-31' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-02' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-03' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-04' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-05' AS date), CAST(N'2018-01-11' AS date), CAST(N'2017-12-30' AS date), CAST(N'2018-01-05' AS date), 1060, 3180, 13826, 13827, 13827, 13827, 13827, 13827, 13826, 2458124, 58123, N'2018-01-05', 201801, 1, 5, N'2018-W01', N'2018-W01-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96794, CAST(N'2018-01-06' AS date), CAST(N'2018-01-07' AS date), 2018, 20181, 201801, 2018006, 1, 1, 6, 6, 7, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2017-12-31' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-02' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-03' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-04' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-05' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-12' AS date), 1060, 3180, 13826, 13827, 13827, 13827, 13827, 13827, 13827, 2458125, 58124, N'2018-01-06', 201801, 1, 6, N'2018-W01', N'2018-W01-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96795, CAST(N'2018-01-07' AS date), CAST(N'2018-01-08' AS date), 2018, 20181, 201801, 2018007, 1, 1, 7, 7, 1, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-02' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-03' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-04' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-05' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-12' AS date), 1060, 3180, 13827, 13827, 13827, 13827, 13827, 13827, 13827, 2458126, 58125, N'2018-01-07', 201801, 1, 7, N'2018-W01', N'2018-W01-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96796, CAST(N'2018-01-08' AS date), CAST(N'2018-01-09' AS date), 2018, 20181, 201801, 2018008, 1, 1, 8, 8, 2, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-02' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-03' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-04' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-05' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-12' AS date), 1060, 3180, 13827, 13828, 13827, 13827, 13827, 13827, 13827, 2458127, 58126, N'2018-01-08', 201802, 2, 1, N'2018-W02', N'2018-W02-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96797, CAST(N'2018-01-09' AS date), CAST(N'2018-01-10' AS date), 2018, 20181, 201801, 2018009, 1, 1, 9, 9, 3, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-03' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-04' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-05' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-12' AS date), 1060, 3180, 13827, 13828, 13828, 13827, 13827, 13827, 13827, 2458128, 58127, N'2018-01-09', 201802, 2, 2, N'2018-W02', N'2018-W02-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96798, CAST(N'2018-01-10' AS date), CAST(N'2018-01-11' AS date), 2018, 20181, 201801, 2018010, 1, 1, 10, 10, 4, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-04' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-05' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-12' AS date), 1060, 3180, 13827, 13828, 13828, 13828, 13827, 13827, 13827, 2458129, 58128, N'2018-01-10', 201802, 2, 3, N'2018-W02', N'2018-W02-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96799, CAST(N'2018-01-11' AS date), CAST(N'2018-01-12' AS date), 2018, 20181, 201801, 2018011, 1, 1, 11, 11, 5, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-05' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-12' AS date), 1060, 3180, 13827, 13828, 13828, 13828, 13828, 13827, 13827, 2458130, 58129, N'2018-01-11', 201802, 2, 4, N'2018-W02', N'2018-W02-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96800, CAST(N'2018-01-12' AS date), CAST(N'2018-01-13' AS date), 2018, 20181, 201801, 2018012, 1, 1, 12, 12, 6, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-12' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-06' AS date), CAST(N'2018-01-12' AS date), 1060, 3180, 13827, 13828, 13828, 13828, 13828, 13828, 13827, 2458131, 58130, N'2018-01-12', 201802, 2, 5, N'2018-W02', N'2018-W02-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96801, CAST(N'2018-01-13' AS date), CAST(N'2018-01-14' AS date), 2018, 20181, 201801, 2018013, 1, 1, 13, 13, 7, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-07' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-12' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-19' AS date), 1060, 3180, 13827, 13828, 13828, 13828, 13828, 13828, 13828, 2458132, 58131, N'2018-01-13', 201802, 2, 6, N'2018-W02', N'2018-W02-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96802, CAST(N'2018-01-14' AS date), CAST(N'2018-01-15' AS date), 2018, 20181, 201801, 2018014, 1, 1, 14, 14, 1, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-08' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-12' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-19' AS date), 1060, 3180, 13828, 13828, 13828, 13828, 13828, 13828, 13828, 2458133, 58132, N'2018-01-14', 201802, 2, 7, N'2018-W02', N'2018-W02-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96803, CAST(N'2018-01-15' AS date), CAST(N'2018-01-16' AS date), 2018, 20181, 201801, 2018015, 1, 1, 15, 15, 2, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-09' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-12' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-19' AS date), 1060, 3180, 13828, 13829, 13828, 13828, 13828, 13828, 13828, 2458134, 58133, N'2018-01-15', 201803, 3, 1, N'2018-W03', N'2018-W03-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96804, CAST(N'2018-01-16' AS date), CAST(N'2018-01-17' AS date), 2018, 20181, 201801, 2018016, 1, 1, 16, 16, 3, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-10' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-12' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-19' AS date), 1060, 3180, 13828, 13829, 13829, 13828, 13828, 13828, 13828, 2458135, 58134, N'2018-01-16', 201803, 3, 2, N'2018-W03', N'2018-W03-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96805, CAST(N'2018-01-17' AS date), CAST(N'2018-01-18' AS date), 2018, 20181, 201801, 2018017, 1, 1, 17, 17, 4, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-11' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-12' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-19' AS date), 1060, 3180, 13828, 13829, 13829, 13829, 13828, 13828, 13828, 2458136, 58135, N'2018-01-17', 201803, 3, 3, N'2018-W03', N'2018-W03-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96806, CAST(N'2018-01-18' AS date), CAST(N'2018-01-19' AS date), 2018, 20181, 201801, 2018018, 1, 1, 18, 18, 5, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-12' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-19' AS date), 1060, 3180, 13828, 13829, 13829, 13829, 13829, 13828, 13828, 2458137, 58136, N'2018-01-18', 201803, 3, 4, N'2018-W03', N'2018-W03-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96807, CAST(N'2018-01-19' AS date), CAST(N'2018-01-20' AS date), 2018, 20181, 201801, 2018019, 1, 1, 19, 19, 6, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-19' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-13' AS date), CAST(N'2018-01-19' AS date), 1060, 3180, 13828, 13829, 13829, 13829, 13829, 13829, 13828, 2458138, 58137, N'2018-01-19', 201803, 3, 5, N'2018-W03', N'2018-W03-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96808, CAST(N'2018-01-20' AS date), CAST(N'2018-01-21' AS date), 2018, 20181, 201801, 2018020, 1, 1, 20, 20, 7, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-14' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-19' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-26' AS date), 1060, 3180, 13828, 13829, 13829, 13829, 13829, 13829, 13829, 2458139, 58138, N'2018-01-20', 201803, 3, 6, N'2018-W03', N'2018-W03-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96809, CAST(N'2018-01-21' AS date), CAST(N'2018-01-22' AS date), 2018, 20181, 201801, 2018021, 1, 1, 21, 21, 1, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-01-15' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-19' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-26' AS date), 1060, 3180, 13829, 13829, 13829, 13829, 13829, 13829, 13829, 2458140, 58139, N'2018-01-21', 201803, 3, 7, N'2018-W03', N'2018-W03-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96810, CAST(N'2018-01-22' AS date), CAST(N'2018-01-23' AS date), 2018, 20181, 201801, 2018022, 1, 1, 22, 22, 2, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-01-16' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-19' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-26' AS date), 1060, 3180, 13829, 13830, 13829, 13829, 13829, 13829, 13829, 2458141, 58140, N'2018-01-22', 201804, 4, 1, N'2018-W04', N'2018-W04-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96811, CAST(N'2018-01-23' AS date), CAST(N'2018-01-24' AS date), 2018, 20181, 201801, 2018023, 1, 1, 23, 23, 3, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-01-17' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-19' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-26' AS date), 1060, 3180, 13829, 13830, 13830, 13829, 13829, 13829, 13829, 2458142, 58141, N'2018-01-23', 201804, 4, 2, N'2018-W04', N'2018-W04-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96812, CAST(N'2018-01-24' AS date), CAST(N'2018-01-25' AS date), 2018, 20181, 201801, 2018024, 1, 1, 24, 24, 4, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-01-18' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-19' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-26' AS date), 1060, 3180, 13829, 13830, 13830, 13830, 13829, 13829, 13829, 2458143, 58142, N'2018-01-24', 201804, 4, 3, N'2018-W04', N'2018-W04-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96813, CAST(N'2018-01-25' AS date), CAST(N'2018-01-26' AS date), 2018, 20181, 201801, 2018025, 1, 1, 25, 25, 5, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-19' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-26' AS date), 1060, 3180, 13829, 13830, 13830, 13830, 13830, 13829, 13829, 2458144, 58143, N'2018-01-25', 201804, 4, 4, N'2018-W04', N'2018-W04-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96814, CAST(N'2018-01-26' AS date), CAST(N'2018-01-27' AS date), 2018, 20181, 201801, 2018026, 1, 1, 26, 26, 6, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-26' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-01-20' AS date), CAST(N'2018-01-26' AS date), 1060, 3180, 13829, 13830, 13830, 13830, 13830, 13830, 13829, 2458145, 58144, N'2018-01-26', 201804, 4, 5, N'2018-W04', N'2018-W04-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96815, CAST(N'2018-01-27' AS date), CAST(N'2018-01-28' AS date), 2018, 20181, 201801, 2018027, 1, 1, 27, 27, 7, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-21' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-26' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-02-02' AS date), 1060, 3180, 13829, 13830, 13830, 13830, 13830, 13830, 13830, 2458146, 58145, N'2018-01-27', 201804, 4, 6, N'2018-W04', N'2018-W04-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96816, CAST(N'2018-01-28' AS date), CAST(N'2018-01-29' AS date), 2018, 20181, 201801, 2018028, 1, 1, 28, 28, 1, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-01-22' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-26' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-02-02' AS date), 1060, 3180, 13830, 13830, 13830, 13830, 13830, 13830, 13830, 2458147, 58146, N'2018-01-28', 201804, 4, 7, N'2018-W04', N'2018-W04-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96817, CAST(N'2018-01-29' AS date), CAST(N'2018-01-30' AS date), 2018, 20181, 201801, 2018029, 1, 1, 29, 29, 2, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-01-23' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-26' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-02-02' AS date), 1060, 3180, 13830, 13831, 13830, 13830, 13830, 13830, 13830, 2458148, 58147, N'2018-01-29', 201805, 5, 1, N'2018-W05', N'2018-W05-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96818, CAST(N'2018-01-30' AS date), CAST(N'2018-01-31' AS date), 2018, 20181, 201801, 2018030, 1, 1, 30, 30, 3, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-01-24' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-26' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-02-02' AS date), 1060, 3180, 13830, 13831, 13831, 13830, 13830, 13830, 13830, 2458149, 58148, N'2018-01-30', 201805, 5, 2, N'2018-W05', N'2018-W05-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96819, CAST(N'2018-01-31' AS date), CAST(N'2018-02-01' AS date), 2018, 20181, 201801, 2018031, 1, 1, 31, 31, 4, N'2018', N'2018 Q1', N'2018 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-01-25' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-01-26' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-02-02' AS date), 1060, 3180, 13830, 13831, 13831, 13831, 13830, 13830, 13830, 2458150, 58149, N'2018-01-31', 201805, 5, 3, N'2018-W05', N'2018-W05-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96820, CAST(N'2018-02-01' AS date), CAST(N'2018-02-02' AS date), 2018, 20181, 201802, 2018032, 1, 2, 32, 1, 5, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-01-26' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-02-02' AS date), 1060, 3181, 13830, 13831, 13831, 13831, 13831, 13830, 13830, 2458151, 58150, N'2018-02-01', 201805, 5, 4, N'2018-W05', N'2018-W05-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96821, CAST(N'2018-02-02' AS date), CAST(N'2018-02-03' AS date), 2018, 20181, 201802, 2018033, 1, 2, 33, 2, 6, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-02' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-01-27' AS date), CAST(N'2018-02-02' AS date), 1060, 3181, 13830, 13831, 13831, 13831, 13831, 13831, 13830, 2458152, 58151, N'2018-02-02', 201805, 5, 5, N'2018-W05', N'2018-W05-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96822, CAST(N'2018-02-03' AS date), CAST(N'2018-02-04' AS date), 2018, 20181, 201802, 2018034, 1, 2, 34, 3, 7, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-01-28' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-02' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-02-09' AS date), 1060, 3181, 13830, 13831, 13831, 13831, 13831, 13831, 13831, 2458153, 58152, N'2018-02-03', 201805, 5, 6, N'2018-W05', N'2018-W05-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96823, CAST(N'2018-02-04' AS date), CAST(N'2018-02-05' AS date), 2018, 20181, 201802, 2018035, 1, 2, 35, 4, 1, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-01-29' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-02' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-02-09' AS date), 1060, 3181, 13831, 13831, 13831, 13831, 13831, 13831, 13831, 2458154, 58153, N'2018-02-04', 201805, 5, 7, N'2018-W05', N'2018-W05-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96824, CAST(N'2018-02-05' AS date), CAST(N'2018-02-06' AS date), 2018, 20181, 201802, 2018036, 1, 2, 36, 5, 2, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-01-30' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-02' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-02-09' AS date), 1060, 3181, 13831, 13832, 13831, 13831, 13831, 13831, 13831, 2458155, 58154, N'2018-02-05', 201806, 6, 1, N'2018-W06', N'2018-W06-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96825, CAST(N'2018-02-06' AS date), CAST(N'2018-02-07' AS date), 2018, 20181, 201802, 2018037, 1, 2, 37, 6, 3, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-01-31' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-02' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-02-09' AS date), 1060, 3181, 13831, 13832, 13832, 13831, 13831, 13831, 13831, 2458156, 58155, N'2018-02-06', 201806, 6, 2, N'2018-W06', N'2018-W06-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96826, CAST(N'2018-02-07' AS date), CAST(N'2018-02-08' AS date), 2018, 20181, 201802, 2018038, 1, 2, 38, 7, 4, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-02' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-02-09' AS date), 1060, 3181, 13831, 13832, 13832, 13832, 13831, 13831, 13831, 2458157, 58156, N'2018-02-07', 201806, 6, 3, N'2018-W06', N'2018-W06-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96827, CAST(N'2018-02-08' AS date), CAST(N'2018-02-09' AS date), 2018, 20181, 201802, 2018039, 1, 2, 39, 8, 5, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-02' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-02-09' AS date), 1060, 3181, 13831, 13832, 13832, 13832, 13832, 13831, 13831, 2458158, 58157, N'2018-02-08', 201806, 6, 4, N'2018-W06', N'2018-W06-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96828, CAST(N'2018-02-09' AS date), CAST(N'2018-02-10' AS date), 2018, 20181, 201802, 2018040, 1, 2, 40, 9, 6, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-09' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-03' AS date), CAST(N'2018-02-09' AS date), 1060, 3181, 13831, 13832, 13832, 13832, 13832, 13832, 13831, 2458159, 58158, N'2018-02-09', 201806, 6, 5, N'2018-W06', N'2018-W06-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96829, CAST(N'2018-02-10' AS date), CAST(N'2018-02-11' AS date), 2018, 20181, 201802, 2018041, 1, 2, 41, 10, 7, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-04' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-09' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-16' AS date), 1060, 3181, 13831, 13832, 13832, 13832, 13832, 13832, 13832, 2458160, 58159, N'2018-02-10', 201806, 6, 6, N'2018-W06', N'2018-W06-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96830, CAST(N'2018-02-11' AS date), CAST(N'2018-02-12' AS date), 2018, 20181, 201802, 2018042, 1, 2, 42, 11, 1, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-05' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-09' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-16' AS date), 1060, 3181, 13832, 13832, 13832, 13832, 13832, 13832, 13832, 2458161, 58160, N'2018-02-11', 201806, 6, 7, N'2018-W06', N'2018-W06-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96831, CAST(N'2018-02-12' AS date), CAST(N'2018-02-13' AS date), 2018, 20181, 201802, 2018043, 1, 2, 43, 12, 2, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-06' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-09' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-16' AS date), 1060, 3181, 13832, 13833, 13832, 13832, 13832, 13832, 13832, 2458162, 58161, N'2018-02-12', 201807, 7, 1, N'2018-W07', N'2018-W07-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96832, CAST(N'2018-02-13' AS date), CAST(N'2018-02-14' AS date), 2018, 20181, 201802, 2018044, 1, 2, 44, 13, 3, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-07' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-09' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-16' AS date), 1060, 3181, 13832, 13833, 13833, 13832, 13832, 13832, 13832, 2458163, 58162, N'2018-02-13', 201807, 7, 2, N'2018-W07', N'2018-W07-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96833, CAST(N'2018-02-14' AS date), CAST(N'2018-02-15' AS date), 2018, 20181, 201802, 2018045, 1, 2, 45, 14, 4, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-08' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-09' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-16' AS date), 1060, 3181, 13832, 13833, 13833, 13833, 13832, 13832, 13832, 2458164, 58163, N'2018-02-14', 201807, 7, 3, N'2018-W07', N'2018-W07-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96834, CAST(N'2018-02-15' AS date), CAST(N'2018-02-16' AS date), 2018, 20181, 201802, 2018046, 1, 2, 46, 15, 5, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-09' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-16' AS date), 1060, 3181, 13832, 13833, 13833, 13833, 13833, 13832, 13832, 2458165, 58164, N'2018-02-15', 201807, 7, 4, N'2018-W07', N'2018-W07-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96835, CAST(N'2018-02-16' AS date), CAST(N'2018-02-17' AS date), 2018, 20181, 201802, 2018047, 1, 2, 47, 16, 6, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-16' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-10' AS date), CAST(N'2018-02-16' AS date), 1060, 3181, 13832, 13833, 13833, 13833, 13833, 13833, 13832, 2458166, 58165, N'2018-02-16', 201807, 7, 5, N'2018-W07', N'2018-W07-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96836, CAST(N'2018-02-17' AS date), CAST(N'2018-02-18' AS date), 2018, 20181, 201802, 2018048, 1, 2, 48, 17, 7, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-11' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-16' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-23' AS date), 1060, 3181, 13832, 13833, 13833, 13833, 13833, 13833, 13833, 2458167, 58166, N'2018-02-17', 201807, 7, 6, N'2018-W07', N'2018-W07-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96837, CAST(N'2018-02-18' AS date), CAST(N'2018-02-19' AS date), 2018, 20181, 201802, 2018049, 1, 2, 49, 18, 1, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-02-12' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-16' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-23' AS date), 1060, 3181, 13833, 13833, 13833, 13833, 13833, 13833, 13833, 2458168, 58167, N'2018-02-18', 201807, 7, 7, N'2018-W07', N'2018-W07-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96838, CAST(N'2018-02-19' AS date), CAST(N'2018-02-20' AS date), 2018, 20181, 201802, 2018050, 1, 2, 50, 19, 2, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-02-13' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-16' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-23' AS date), 1060, 3181, 13833, 13834, 13833, 13833, 13833, 13833, 13833, 2458169, 58168, N'2018-02-19', 201808, 8, 1, N'2018-W08', N'2018-W08-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96839, CAST(N'2018-02-20' AS date), CAST(N'2018-02-21' AS date), 2018, 20181, 201802, 2018051, 1, 2, 51, 20, 3, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-02-14' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-16' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-23' AS date), 1060, 3181, 13833, 13834, 13834, 13833, 13833, 13833, 13833, 2458170, 58169, N'2018-02-20', 201808, 8, 2, N'2018-W08', N'2018-W08-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96840, CAST(N'2018-02-21' AS date), CAST(N'2018-02-22' AS date), 2018, 20181, 201802, 2018052, 1, 2, 52, 21, 4, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-02-15' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-16' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-23' AS date), 1060, 3181, 13833, 13834, 13834, 13834, 13833, 13833, 13833, 2458171, 58170, N'2018-02-21', 201808, 8, 3, N'2018-W08', N'2018-W08-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96841, CAST(N'2018-02-22' AS date), CAST(N'2018-02-23' AS date), 2018, 20181, 201802, 2018053, 1, 2, 53, 22, 5, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-16' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-23' AS date), 1060, 3181, 13833, 13834, 13834, 13834, 13834, 13833, 13833, 2458172, 58171, N'2018-02-22', 201808, 8, 4, N'2018-W08', N'2018-W08-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96842, CAST(N'2018-02-23' AS date), CAST(N'2018-02-24' AS date), 2018, 20181, 201802, 2018054, 1, 2, 54, 23, 6, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-23' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-02-17' AS date), CAST(N'2018-02-23' AS date), 1060, 3181, 13833, 13834, 13834, 13834, 13834, 13834, 13833, 2458173, 58172, N'2018-02-23', 201808, 8, 5, N'2018-W08', N'2018-W08-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96843, CAST(N'2018-02-24' AS date), CAST(N'2018-02-25' AS date), 2018, 20181, 201802, 2018055, 1, 2, 55, 24, 7, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-18' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-23' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-03-02' AS date), 1060, 3181, 13833, 13834, 13834, 13834, 13834, 13834, 13834, 2458174, 58173, N'2018-02-24', 201808, 8, 6, N'2018-W08', N'2018-W08-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96844, CAST(N'2018-02-25' AS date), CAST(N'2018-02-26' AS date), 2018, 20181, 201802, 2018056, 1, 2, 56, 25, 1, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-02-19' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-23' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-03-02' AS date), 1060, 3181, 13834, 13834, 13834, 13834, 13834, 13834, 13834, 2458175, 58174, N'2018-02-25', 201808, 8, 7, N'2018-W08', N'2018-W08-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96845, CAST(N'2018-02-26' AS date), CAST(N'2018-02-27' AS date), 2018, 20181, 201802, 2018057, 1, 2, 57, 26, 2, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-02-20' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-23' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-03-02' AS date), 1060, 3181, 13834, 13835, 13834, 13834, 13834, 13834, 13834, 2458176, 58175, N'2018-02-26', 201809, 9, 1, N'2018-W09', N'2018-W09-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96846, CAST(N'2018-02-27' AS date), CAST(N'2018-02-28' AS date), 2018, 20181, 201802, 2018058, 1, 2, 58, 27, 3, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-02-21' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-23' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-03-02' AS date), 1060, 3181, 13834, 13835, 13835, 13834, 13834, 13834, 13834, 2458177, 58176, N'2018-02-27', 201809, 9, 2, N'2018-W09', N'2018-W09-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96847, CAST(N'2018-02-28' AS date), CAST(N'2018-03-01' AS date), 2018, 20181, 201802, 2018059, 1, 2, 59, 28, 4, N'2018', N'2018 Q1', N'2018 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-01' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-02-22' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-02-23' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-03-02' AS date), 1060, 3181, 13834, 13835, 13835, 13835, 13834, 13834, 13834, 2458178, 58177, N'2018-02-28', 201809, 9, 3, N'2018-W09', N'2018-W09-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96848, CAST(N'2018-03-01' AS date), CAST(N'2018-03-02' AS date), 2018, 20181, 201803, 2018060, 1, 3, 60, 1, 5, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-02-23' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-03-02' AS date), 1060, 3182, 13834, 13835, 13835, 13835, 13835, 13834, 13834, 2458179, 58178, N'2018-03-01', 201809, 9, 4, N'2018-W09', N'2018-W09-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96849, CAST(N'2018-03-02' AS date), CAST(N'2018-03-03' AS date), 2018, 20181, 201803, 2018061, 1, 3, 61, 2, 6, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-02' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-02-24' AS date), CAST(N'2018-03-02' AS date), 1060, 3182, 13834, 13835, 13835, 13835, 13835, 13835, 13834, 2458180, 58179, N'2018-03-02', 201809, 9, 5, N'2018-W09', N'2018-W09-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96850, CAST(N'2018-03-03' AS date), CAST(N'2018-03-04' AS date), 2018, 20181, 201803, 2018062, 1, 3, 62, 3, 7, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-02-25' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-02' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-03-09' AS date), 1060, 3182, 13834, 13835, 13835, 13835, 13835, 13835, 13835, 2458181, 58180, N'2018-03-03', 201809, 9, 6, N'2018-W09', N'2018-W09-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96851, CAST(N'2018-03-04' AS date), CAST(N'2018-03-05' AS date), 2018, 20181, 201803, 2018063, 1, 3, 63, 4, 1, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-02-26' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-02' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-03-09' AS date), 1060, 3182, 13835, 13835, 13835, 13835, 13835, 13835, 13835, 2458182, 58181, N'2018-03-04', 201809, 9, 7, N'2018-W09', N'2018-W09-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96852, CAST(N'2018-03-05' AS date), CAST(N'2018-03-06' AS date), 2018, 20181, 201803, 2018064, 1, 3, 64, 5, 2, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-02-27' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-02' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-03-09' AS date), 1060, 3182, 13835, 13836, 13835, 13835, 13835, 13835, 13835, 2458183, 58182, N'2018-03-05', 201810, 10, 1, N'2018-W10', N'2018-W10-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96853, CAST(N'2018-03-06' AS date), CAST(N'2018-03-07' AS date), 2018, 20181, 201803, 2018065, 1, 3, 65, 6, 3, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-02-28' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-02' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-03-09' AS date), 1060, 3182, 13835, 13836, 13836, 13835, 13835, 13835, 13835, 2458184, 58183, N'2018-03-06', 201810, 10, 2, N'2018-W10', N'2018-W10-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96854, CAST(N'2018-03-07' AS date), CAST(N'2018-03-08' AS date), 2018, 20181, 201803, 2018066, 1, 3, 66, 7, 4, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-02' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-03-09' AS date), 1060, 3182, 13835, 13836, 13836, 13836, 13835, 13835, 13835, 2458185, 58184, N'2018-03-07', 201810, 10, 3, N'2018-W10', N'2018-W10-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96855, CAST(N'2018-03-08' AS date), CAST(N'2018-03-09' AS date), 2018, 20181, 201803, 2018067, 1, 3, 67, 8, 5, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-02' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-03-09' AS date), 1060, 3182, 13835, 13836, 13836, 13836, 13836, 13835, 13835, 2458186, 58185, N'2018-03-08', 201810, 10, 4, N'2018-W10', N'2018-W10-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96856, CAST(N'2018-03-09' AS date), CAST(N'2018-03-10' AS date), 2018, 20181, 201803, 2018068, 1, 3, 68, 9, 6, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-09' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-03' AS date), CAST(N'2018-03-09' AS date), 1060, 3182, 13835, 13836, 13836, 13836, 13836, 13836, 13835, 2458187, 58186, N'2018-03-09', 201810, 10, 5, N'2018-W10', N'2018-W10-5');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96857, CAST(N'2018-03-10' AS date), CAST(N'2018-03-11' AS date), 2018, 20181, 201803, 2018069, 1, 3, 69, 10, 7, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-04' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-09' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-16' AS date), 1060, 3182, 13835, 13836, 13836, 13836, 13836, 13836, 13836, 2458188, 58187, N'2018-03-10', 201810, 10, 6, N'2018-W10', N'2018-W10-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96858, CAST(N'2018-03-11' AS date), CAST(N'2018-03-12' AS date), 2018, 20181, 201803, 2018070, 1, 3, 70, 11, 1, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-05' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-09' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-16' AS date), 1060, 3182, 13836, 13836, 13836, 13836, 13836, 13836, 13836, 2458189, 58188, N'2018-03-11', 201810, 10, 7, N'2018-W10', N'2018-W10-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96859, CAST(N'2018-03-12' AS date), CAST(N'2018-03-13' AS date), 2018, 20181, 201803, 2018071, 1, 3, 71, 12, 2, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-06' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-09' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-16' AS date), 1060, 3182, 13836, 13837, 13836, 13836, 13836, 13836, 13836, 2458190, 58189, N'2018-03-12', 201811, 11, 1, N'2018-W11', N'2018-W11-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96860, CAST(N'2018-03-13' AS date), CAST(N'2018-03-14' AS date), 2018, 20181, 201803, 2018072, 1, 3, 72, 13, 3, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-07' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-09' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-16' AS date), 1060, 3182, 13836, 13837, 13837, 13836, 13836, 13836, 13836, 2458191, 58190, N'2018-03-13', 201811, 11, 2, N'2018-W11', N'2018-W11-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96861, CAST(N'2018-03-14' AS date), CAST(N'2018-03-15' AS date), 2018, 20181, 201803, 2018073, 1, 3, 73, 14, 4, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-08' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-09' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-16' AS date), 1060, 3182, 13836, 13837, 13837, 13837, 13836, 13836, 13836, 2458192, 58191, N'2018-03-14', 201811, 11, 3, N'2018-W11', N'2018-W11-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96862, CAST(N'2018-03-15' AS date), CAST(N'2018-03-16' AS date), 2018, 20181, 201803, 2018074, 1, 3, 74, 15, 5, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-09' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-16' AS date), 1060, 3182, 13836, 13837, 13837, 13837, 13837, 13836, 13836, 2458193, 58192, N'2018-03-15', 201811, 11, 4, N'2018-W11', N'2018-W11-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96863, CAST(N'2018-03-16' AS date), CAST(N'2018-03-17' AS date), 2018, 20181, 201803, 2018075, 1, 3, 75, 16, 6, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-16' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-10' AS date), CAST(N'2018-03-16' AS date), 1060, 3182, 13836, 13837, 13837, 13837, 13837, 13837, 13836, 2458194, 58193, N'2018-03-16', 201811, 11, 5, N'2018-W11', N'2018-W11-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96864, CAST(N'2018-03-17' AS date), CAST(N'2018-03-18' AS date), 2018, 20181, 201803, 2018076, 1, 3, 76, 17, 7, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-11' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-16' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-23' AS date), 1060, 3182, 13836, 13837, 13837, 13837, 13837, 13837, 13837, 2458195, 58194, N'2018-03-17', 201811, 11, 6, N'2018-W11', N'2018-W11-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96865, CAST(N'2018-03-18' AS date), CAST(N'2018-03-19' AS date), 2018, 20181, 201803, 2018077, 1, 3, 77, 18, 1, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-12' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-16' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-23' AS date), 1060, 3182, 13837, 13837, 13837, 13837, 13837, 13837, 13837, 2458196, 58195, N'2018-03-18', 201811, 11, 7, N'2018-W11', N'2018-W11-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96866, CAST(N'2018-03-19' AS date), CAST(N'2018-03-20' AS date), 2018, 20181, 201803, 2018078, 1, 3, 78, 19, 2, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-13' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-16' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-23' AS date), 1060, 3182, 13837, 13838, 13837, 13837, 13837, 13837, 13837, 2458197, 58196, N'2018-03-19', 201812, 12, 1, N'2018-W12', N'2018-W12-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96867, CAST(N'2018-03-20' AS date), CAST(N'2018-03-21' AS date), 2018, 20181, 201803, 2018079, 1, 3, 79, 20, 3, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-03-14' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-16' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-23' AS date), 1060, 3182, 13837, 13838, 13838, 13837, 13837, 13837, 13837, 2458198, 58197, N'2018-03-20', 201812, 12, 2, N'2018-W12', N'2018-W12-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96868, CAST(N'2018-03-21' AS date), CAST(N'2018-03-22' AS date), 2018, 20181, 201803, 2018080, 1, 3, 80, 21, 4, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-03-15' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-16' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-23' AS date), 1060, 3182, 13837, 13838, 13838, 13838, 13837, 13837, 13837, 2458199, 58198, N'2018-03-21', 201812, 12, 3, N'2018-W12', N'2018-W12-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96869, CAST(N'2018-03-22' AS date), CAST(N'2018-03-23' AS date), 2018, 20181, 201803, 2018081, 1, 3, 81, 22, 5, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-03-16' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-23' AS date), 1060, 3182, 13837, 13838, 13838, 13838, 13838, 13837, 13837, 2458200, 58199, N'2018-03-22', 201812, 12, 4, N'2018-W12', N'2018-W12-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96870, CAST(N'2018-03-23' AS date), CAST(N'2018-03-24' AS date), 2018, 20181, 201803, 2018082, 1, 3, 82, 23, 6, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-03-23' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-03-17' AS date), CAST(N'2018-03-23' AS date), 1060, 3182, 13837, 13838, 13838, 13838, 13838, 13838, 13837, 2458201, 58200, N'2018-03-23', 201812, 12, 5, N'2018-W12', N'2018-W12-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96871, CAST(N'2018-03-24' AS date), CAST(N'2018-03-25' AS date), 2018, 20181, 201803, 2018083, 1, 3, 83, 24, 7, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-18' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-03-23' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-30' AS date), 1060, 3182, 13837, 13838, 13838, 13838, 13838, 13838, 13838, 2458202, 58201, N'2018-03-24', 201812, 12, 6, N'2018-W12', N'2018-W12-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96872, CAST(N'2018-03-25' AS date), CAST(N'2018-03-26' AS date), 2018, 20181, 201803, 2018084, 1, 3, 84, 25, 1, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-19' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-03-23' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-30' AS date), 1060, 3182, 13838, 13838, 13838, 13838, 13838, 13838, 13838, 2458203, 58202, N'2018-03-25', 201812, 12, 7, N'2018-W12', N'2018-W12-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96873, CAST(N'2018-03-26' AS date), CAST(N'2018-03-27' AS date), 2018, 20181, 201803, 2018085, 1, 3, 85, 26, 2, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-03-20' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-03-23' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-30' AS date), 1060, 3182, 13838, 13839, 13838, 13838, 13838, 13838, 13838, 2458204, 58203, N'2018-03-26', 201813, 13, 1, N'2018-W13', N'2018-W13-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96874, CAST(N'2018-03-27' AS date), CAST(N'2018-03-28' AS date), 2018, 20181, 201803, 2018086, 1, 3, 86, 27, 3, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-03-21' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-03-23' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-30' AS date), 1060, 3182, 13838, 13839, 13839, 13838, 13838, 13838, 13838, 2458205, 58204, N'2018-03-27', 201813, 13, 2, N'2018-W13', N'2018-W13-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96875, CAST(N'2018-03-28' AS date), CAST(N'2018-03-29' AS date), 2018, 20181, 201803, 2018087, 1, 3, 87, 28, 4, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-03-22' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-03-23' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-30' AS date), 1060, 3182, 13838, 13839, 13839, 13839, 13838, 13838, 13838, 2458206, 58205, N'2018-03-28', 201813, 13, 3, N'2018-W13', N'2018-W13-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96876, CAST(N'2018-03-29' AS date), CAST(N'2018-03-30' AS date), 2018, 20181, 201803, 2018088, 1, 3, 88, 29, 5, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-03-23' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-30' AS date), 1060, 3182, 13838, 13839, 13839, 13839, 13839, 13838, 13838, 2458207, 58206, N'2018-03-29', 201813, 13, 4, N'2018-W13', N'2018-W13-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96877, CAST(N'2018-03-30' AS date), CAST(N'2018-03-31' AS date), 2018, 20181, 201803, 2018089, 1, 3, 89, 30, 6, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-03-30' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-03-24' AS date), CAST(N'2018-03-30' AS date), 1060, 3182, 13838, 13839, 13839, 13839, 13839, 13839, 13838, 2458208, 58207, N'2018-03-30', 201813, 13, 5, N'2018-W13', N'2018-W13-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96878, CAST(N'2018-03-31' AS date), CAST(N'2018-04-01' AS date), 2018, 20181, 201803, 2018090, 1, 3, 90, 31, 7, N'2018', N'2018 Q1', N'2018 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-01-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-01' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-25' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-03-30' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-04-06' AS date), 1060, 3182, 13838, 13839, 13839, 13839, 13839, 13839, 13839, 2458209, 58208, N'2018-03-31', 201813, 13, 6, N'2018-W13', N'2018-W13-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96879, CAST(N'2018-04-01' AS date), CAST(N'2018-04-02' AS date), 2018, 20182, 201804, 2018091, 2, 4, 91, 1, 1, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-03-26' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-03-30' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-04-06' AS date), 1061, 3183, 13839, 13839, 13839, 13839, 13839, 13839, 13839, 2458210, 58209, N'2018-04-01', 201813, 13, 7, N'2018-W13', N'2018-W13-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96880, CAST(N'2018-04-02' AS date), CAST(N'2018-04-03' AS date), 2018, 20182, 201804, 2018092, 2, 4, 92, 2, 2, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-03-27' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-03-30' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-04-06' AS date), 1061, 3183, 13839, 13840, 13839, 13839, 13839, 13839, 13839, 2458211, 58210, N'2018-04-02', 201814, 14, 1, N'2018-W14', N'2018-W14-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96881, CAST(N'2018-04-03' AS date), CAST(N'2018-04-04' AS date), 2018, 20182, 201804, 2018093, 2, 4, 93, 3, 3, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-03-28' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-03-30' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-04-06' AS date), 1061, 3183, 13839, 13840, 13840, 13839, 13839, 13839, 13839, 2458212, 58211, N'2018-04-03', 201814, 14, 2, N'2018-W14', N'2018-W14-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96882, CAST(N'2018-04-04' AS date), CAST(N'2018-04-05' AS date), 2018, 20182, 201804, 2018094, 2, 4, 94, 4, 4, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-03-29' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-03-30' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-04-06' AS date), 1061, 3183, 13839, 13840, 13840, 13840, 13839, 13839, 13839, 2458213, 58212, N'2018-04-04', 201814, 14, 3, N'2018-W14', N'2018-W14-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96883, CAST(N'2018-04-05' AS date), CAST(N'2018-04-06' AS date), 2018, 20182, 201804, 2018095, 2, 4, 95, 5, 5, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-03-30' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-04-06' AS date), 1061, 3183, 13839, 13840, 13840, 13840, 13840, 13839, 13839, 2458214, 58213, N'2018-04-05', 201814, 14, 4, N'2018-W14', N'2018-W14-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96884, CAST(N'2018-04-06' AS date), CAST(N'2018-04-07' AS date), 2018, 20182, 201804, 2018096, 2, 4, 96, 6, 6, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-06' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-03-31' AS date), CAST(N'2018-04-06' AS date), 1061, 3183, 13839, 13840, 13840, 13840, 13840, 13840, 13839, 2458215, 58214, N'2018-04-06', 201814, 14, 5, N'2018-W14', N'2018-W14-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96885, CAST(N'2018-04-07' AS date), CAST(N'2018-04-08' AS date), 2018, 20182, 201804, 2018097, 2, 4, 97, 7, 7, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-06' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-13' AS date), 1061, 3183, 13839, 13840, 13840, 13840, 13840, 13840, 13840, 2458216, 58215, N'2018-04-07', 201814, 14, 6, N'2018-W14', N'2018-W14-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96886, CAST(N'2018-04-08' AS date), CAST(N'2018-04-09' AS date), 2018, 20182, 201804, 2018098, 2, 4, 98, 8, 1, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-02' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-06' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-13' AS date), 1061, 3183, 13840, 13840, 13840, 13840, 13840, 13840, 13840, 2458217, 58216, N'2018-04-08', 201814, 14, 7, N'2018-W14', N'2018-W14-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96887, CAST(N'2018-04-09' AS date), CAST(N'2018-04-10' AS date), 2018, 20182, 201804, 2018099, 2, 4, 99, 9, 2, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-03' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-06' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-13' AS date), 1061, 3183, 13840, 13841, 13840, 13840, 13840, 13840, 13840, 2458218, 58217, N'2018-04-09', 201815, 15, 1, N'2018-W15', N'2018-W15-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96888, CAST(N'2018-04-10' AS date), CAST(N'2018-04-11' AS date), 2018, 20182, 201804, 2018100, 2, 4, 100, 10, 3, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-04' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-06' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-13' AS date), 1061, 3183, 13840, 13841, 13841, 13840, 13840, 13840, 13840, 2458219, 58218, N'2018-04-10', 201815, 15, 2, N'2018-W15', N'2018-W15-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96889, CAST(N'2018-04-11' AS date), CAST(N'2018-04-12' AS date), 2018, 20182, 201804, 2018101, 2, 4, 101, 11, 4, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-05' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-06' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-13' AS date), 1061, 3183, 13840, 13841, 13841, 13841, 13840, 13840, 13840, 2458220, 58219, N'2018-04-11', 201815, 15, 3, N'2018-W15', N'2018-W15-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96890, CAST(N'2018-04-12' AS date), CAST(N'2018-04-13' AS date), 2018, 20182, 201804, 2018102, 2, 4, 102, 12, 5, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-06' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-13' AS date), 1061, 3183, 13840, 13841, 13841, 13841, 13841, 13840, 13840, 2458221, 58220, N'2018-04-12', 201815, 15, 4, N'2018-W15', N'2018-W15-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96891, CAST(N'2018-04-13' AS date), CAST(N'2018-04-14' AS date), 2018, 20182, 201804, 2018103, 2, 4, 103, 13, 6, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-13' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-07' AS date), CAST(N'2018-04-13' AS date), 1061, 3183, 13840, 13841, 13841, 13841, 13841, 13841, 13840, 2458222, 58221, N'2018-04-13', 201815, 15, 5, N'2018-W15', N'2018-W15-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96892, CAST(N'2018-04-14' AS date), CAST(N'2018-04-15' AS date), 2018, 20182, 201804, 2018104, 2, 4, 104, 14, 7, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-08' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-13' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-20' AS date), 1061, 3183, 13840, 13841, 13841, 13841, 13841, 13841, 13841, 2458223, 58222, N'2018-04-14', 201815, 15, 6, N'2018-W15', N'2018-W15-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96893, CAST(N'2018-04-15' AS date), CAST(N'2018-04-16' AS date), 2018, 20182, 201804, 2018105, 2, 4, 105, 15, 1, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-09' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-13' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-20' AS date), 1061, 3183, 13841, 13841, 13841, 13841, 13841, 13841, 13841, 2458224, 58223, N'2018-04-15', 201815, 15, 7, N'2018-W15', N'2018-W15-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96894, CAST(N'2018-04-16' AS date), CAST(N'2018-04-17' AS date), 2018, 20182, 201804, 2018106, 2, 4, 106, 16, 2, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-10' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-13' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-20' AS date), 1061, 3183, 13841, 13842, 13841, 13841, 13841, 13841, 13841, 2458225, 58224, N'2018-04-16', 201816, 16, 1, N'2018-W16', N'2018-W16-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96895, CAST(N'2018-04-17' AS date), CAST(N'2018-04-18' AS date), 2018, 20182, 201804, 2018107, 2, 4, 107, 17, 3, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-11' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-13' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-20' AS date), 1061, 3183, 13841, 13842, 13842, 13841, 13841, 13841, 13841, 2458226, 58225, N'2018-04-17', 201816, 16, 2, N'2018-W16', N'2018-W16-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96896, CAST(N'2018-04-18' AS date), CAST(N'2018-04-19' AS date), 2018, 20182, 201804, 2018108, 2, 4, 108, 18, 4, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-12' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-13' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-20' AS date), 1061, 3183, 13841, 13842, 13842, 13842, 13841, 13841, 13841, 2458227, 58226, N'2018-04-18', 201816, 16, 3, N'2018-W16', N'2018-W16-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96897, CAST(N'2018-04-19' AS date), CAST(N'2018-04-20' AS date), 2018, 20182, 201804, 2018109, 2, 4, 109, 19, 5, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-04-13' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-20' AS date), 1061, 3183, 13841, 13842, 13842, 13842, 13842, 13841, 13841, 2458228, 58227, N'2018-04-19', 201816, 16, 4, N'2018-W16', N'2018-W16-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96898, CAST(N'2018-04-20' AS date), CAST(N'2018-04-21' AS date), 2018, 20182, 201804, 2018110, 2, 4, 110, 20, 6, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-04-20' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-04-14' AS date), CAST(N'2018-04-20' AS date), 1061, 3183, 13841, 13842, 13842, 13842, 13842, 13842, 13841, 2458229, 58228, N'2018-04-20', 201816, 16, 5, N'2018-W16', N'2018-W16-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96899, CAST(N'2018-04-21' AS date), CAST(N'2018-04-22' AS date), 2018, 20182, 201804, 2018111, 2, 4, 111, 21, 7, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-15' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-04-20' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-27' AS date), 1061, 3183, 13841, 13842, 13842, 13842, 13842, 13842, 13842, 2458230, 58229, N'2018-04-21', 201816, 16, 6, N'2018-W16', N'2018-W16-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96900, CAST(N'2018-04-22' AS date), CAST(N'2018-04-23' AS date), 2018, 20182, 201804, 2018112, 2, 4, 112, 22, 1, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-04-16' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-04-20' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-27' AS date), 1061, 3183, 13842, 13842, 13842, 13842, 13842, 13842, 13842, 2458231, 58230, N'2018-04-22', 201816, 16, 7, N'2018-W16', N'2018-W16-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96901, CAST(N'2018-04-23' AS date), CAST(N'2018-04-24' AS date), 2018, 20182, 201804, 2018113, 2, 4, 113, 23, 2, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-04-17' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-04-20' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-27' AS date), 1061, 3183, 13842, 13843, 13842, 13842, 13842, 13842, 13842, 2458232, 58231, N'2018-04-23', 201817, 17, 1, N'2018-W17', N'2018-W17-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96902, CAST(N'2018-04-24' AS date), CAST(N'2018-04-25' AS date), 2018, 20182, 201804, 2018114, 2, 4, 114, 24, 3, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-18' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-04-20' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-27' AS date), 1061, 3183, 13842, 13843, 13843, 13842, 13842, 13842, 13842, 2458233, 58232, N'2018-04-24', 201817, 17, 2, N'2018-W17', N'2018-W17-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96903, CAST(N'2018-04-25' AS date), CAST(N'2018-04-26' AS date), 2018, 20182, 201804, 2018115, 2, 4, 115, 25, 4, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-04-19' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-04-20' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-27' AS date), 1061, 3183, 13842, 13843, 13843, 13843, 13842, 13842, 13842, 2458234, 58233, N'2018-04-25', 201817, 17, 3, N'2018-W17', N'2018-W17-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96904, CAST(N'2018-04-26' AS date), CAST(N'2018-04-27' AS date), 2018, 20182, 201804, 2018116, 2, 4, 116, 26, 5, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-04-20' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-27' AS date), 1061, 3183, 13842, 13843, 13843, 13843, 13843, 13842, 13842, 2458235, 58234, N'2018-04-26', 201817, 17, 4, N'2018-W17', N'2018-W17-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96905, CAST(N'2018-04-27' AS date), CAST(N'2018-04-28' AS date), 2018, 20182, 201804, 2018117, 2, 4, 117, 27, 6, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-04-27' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-04-21' AS date), CAST(N'2018-04-27' AS date), 1061, 3183, 13842, 13843, 13843, 13843, 13843, 13843, 13842, 2458236, 58235, N'2018-04-27', 201817, 17, 5, N'2018-W17', N'2018-W17-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96906, CAST(N'2018-04-28' AS date), CAST(N'2018-04-29' AS date), 2018, 20182, 201804, 2018118, 2, 4, 118, 28, 7, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-22' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-04-27' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-05-04' AS date), 1061, 3183, 13842, 13843, 13843, 13843, 13843, 13843, 13843, 2458237, 58236, N'2018-04-28', 201817, 17, 6, N'2018-W17', N'2018-W17-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96907, CAST(N'2018-04-29' AS date), CAST(N'2018-04-30' AS date), 2018, 20182, 201804, 2018119, 2, 4, 119, 29, 1, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-04-23' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-04-27' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-05-04' AS date), 1061, 3183, 13843, 13843, 13843, 13843, 13843, 13843, 13843, 2458238, 58237, N'2018-04-29', 201817, 17, 7, N'2018-W17', N'2018-W17-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96908, CAST(N'2018-04-30' AS date), CAST(N'2018-05-01' AS date), 2018, 20182, 201804, 2018120, 2, 4, 120, 30, 2, N'2018', N'2018 Q2', N'2018 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-04-24' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-04-27' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-05-04' AS date), 1061, 3183, 13843, 13844, 13843, 13843, 13843, 13843, 13843, 2458239, 58238, N'2018-04-30', 201818, 18, 1, N'2018-W18', N'2018-W18-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96909, CAST(N'2018-05-01' AS date), CAST(N'2018-05-02' AS date), 2018, 20182, 201805, 2018121, 2, 5, 121, 1, 3, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-04-25' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-04-27' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-05-04' AS date), 1061, 3184, 13843, 13844, 13844, 13843, 13843, 13843, 13843, 2458240, 58239, N'2018-05-01', 201818, 18, 2, N'2018-W18', N'2018-W18-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96910, CAST(N'2018-05-02' AS date), CAST(N'2018-05-03' AS date), 2018, 20182, 201805, 2018122, 2, 5, 122, 2, 4, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-04-26' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-04-27' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-05-04' AS date), 1061, 3184, 13843, 13844, 13844, 13844, 13843, 13843, 13843, 2458241, 58240, N'2018-05-02', 201818, 18, 3, N'2018-W18', N'2018-W18-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96911, CAST(N'2018-05-03' AS date), CAST(N'2018-05-04' AS date), 2018, 20182, 201805, 2018123, 2, 5, 123, 3, 5, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-04-27' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-05-04' AS date), 1061, 3184, 13843, 13844, 13844, 13844, 13844, 13843, 13843, 2458242, 58241, N'2018-05-03', 201818, 18, 4, N'2018-W18', N'2018-W18-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96912, CAST(N'2018-05-04' AS date), CAST(N'2018-05-05' AS date), 2018, 20182, 201805, 2018124, 2, 5, 124, 4, 6, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-04' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-04-28' AS date), CAST(N'2018-05-04' AS date), 1061, 3184, 13843, 13844, 13844, 13844, 13844, 13844, 13843, 2458243, 58242, N'2018-05-04', 201818, 18, 5, N'2018-W18', N'2018-W18-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96913, CAST(N'2018-05-05' AS date), CAST(N'2018-05-06' AS date), 2018, 20182, 201805, 2018125, 2, 5, 125, 5, 7, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-04-29' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-04' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-05-11' AS date), 1061, 3184, 13843, 13844, 13844, 13844, 13844, 13844, 13844, 2458244, 58243, N'2018-05-05', 201818, 18, 6, N'2018-W18', N'2018-W18-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96914, CAST(N'2018-05-06' AS date), CAST(N'2018-05-07' AS date), 2018, 20182, 201805, 2018126, 2, 5, 126, 6, 1, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-04-30' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-04' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-05-11' AS date), 1061, 3184, 13844, 13844, 13844, 13844, 13844, 13844, 13844, 2458245, 58244, N'2018-05-06', 201818, 18, 7, N'2018-W18', N'2018-W18-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96915, CAST(N'2018-05-07' AS date), CAST(N'2018-05-08' AS date), 2018, 20182, 201805, 2018127, 2, 5, 127, 7, 2, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-04' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-05-11' AS date), 1061, 3184, 13844, 13845, 13844, 13844, 13844, 13844, 13844, 2458246, 58245, N'2018-05-07', 201819, 19, 1, N'2018-W19', N'2018-W19-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96916, CAST(N'2018-05-08' AS date), CAST(N'2018-05-09' AS date), 2018, 20182, 201805, 2018128, 2, 5, 128, 8, 3, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-02' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-04' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-05-11' AS date), 1061, 3184, 13844, 13845, 13845, 13844, 13844, 13844, 13844, 2458247, 58246, N'2018-05-08', 201819, 19, 2, N'2018-W19', N'2018-W19-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96917, CAST(N'2018-05-09' AS date), CAST(N'2018-05-10' AS date), 2018, 20182, 201805, 2018129, 2, 5, 129, 9, 4, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-03' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-04' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-05-11' AS date), 1061, 3184, 13844, 13845, 13845, 13845, 13844, 13844, 13844, 2458248, 58247, N'2018-05-09', 201819, 19, 3, N'2018-W19', N'2018-W19-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96918, CAST(N'2018-05-10' AS date), CAST(N'2018-05-11' AS date), 2018, 20182, 201805, 2018130, 2, 5, 130, 10, 5, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-04' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-05-11' AS date), 1061, 3184, 13844, 13845, 13845, 13845, 13845, 13844, 13844, 2458249, 58248, N'2018-05-10', 201819, 19, 4, N'2018-W19', N'2018-W19-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96919, CAST(N'2018-05-11' AS date), CAST(N'2018-05-12' AS date), 2018, 20182, 201805, 2018131, 2, 5, 131, 11, 6, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-11' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-05' AS date), CAST(N'2018-05-11' AS date), 1061, 3184, 13844, 13845, 13845, 13845, 13845, 13845, 13844, 2458250, 58249, N'2018-05-11', 201819, 19, 5, N'2018-W19', N'2018-W19-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96920, CAST(N'2018-05-12' AS date), CAST(N'2018-05-13' AS date), 2018, 20182, 201805, 2018132, 2, 5, 132, 12, 7, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-06' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-11' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-18' AS date), 1061, 3184, 13844, 13845, 13845, 13845, 13845, 13845, 13845, 2458251, 58250, N'2018-05-12', 201819, 19, 6, N'2018-W19', N'2018-W19-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96921, CAST(N'2018-05-13' AS date), CAST(N'2018-05-14' AS date), 2018, 20182, 201805, 2018133, 2, 5, 133, 13, 1, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-07' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-11' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-18' AS date), 1061, 3184, 13845, 13845, 13845, 13845, 13845, 13845, 13845, 2458252, 58251, N'2018-05-13', 201819, 19, 7, N'2018-W19', N'2018-W19-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96922, CAST(N'2018-05-14' AS date), CAST(N'2018-05-15' AS date), 2018, 20182, 201805, 2018134, 2, 5, 134, 14, 2, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-08' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-11' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-18' AS date), 1061, 3184, 13845, 13846, 13845, 13845, 13845, 13845, 13845, 2458253, 58252, N'2018-05-14', 201820, 20, 1, N'2018-W20', N'2018-W20-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96923, CAST(N'2018-05-15' AS date), CAST(N'2018-05-16' AS date), 2018, 20182, 201805, 2018135, 2, 5, 135, 15, 3, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-09' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-11' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-18' AS date), 1061, 3184, 13845, 13846, 13846, 13845, 13845, 13845, 13845, 2458254, 58253, N'2018-05-15', 201820, 20, 2, N'2018-W20', N'2018-W20-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96924, CAST(N'2018-05-16' AS date), CAST(N'2018-05-17' AS date), 2018, 20182, 201805, 2018136, 2, 5, 136, 16, 4, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-10' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-11' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-18' AS date), 1061, 3184, 13845, 13846, 13846, 13846, 13845, 13845, 13845, 2458255, 58254, N'2018-05-16', 201820, 20, 3, N'2018-W20', N'2018-W20-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96925, CAST(N'2018-05-17' AS date), CAST(N'2018-05-18' AS date), 2018, 20182, 201805, 2018137, 2, 5, 137, 17, 5, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-11' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-18' AS date), 1061, 3184, 13845, 13846, 13846, 13846, 13846, 13845, 13845, 2458256, 58255, N'2018-05-17', 201820, 20, 4, N'2018-W20', N'2018-W20-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96926, CAST(N'2018-05-18' AS date), CAST(N'2018-05-19' AS date), 2018, 20182, 201805, 2018138, 2, 5, 138, 18, 6, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-18' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-12' AS date), CAST(N'2018-05-18' AS date), 1061, 3184, 13845, 13846, 13846, 13846, 13846, 13846, 13845, 2458257, 58256, N'2018-05-18', 201820, 20, 5, N'2018-W20', N'2018-W20-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96927, CAST(N'2018-05-19' AS date), CAST(N'2018-05-20' AS date), 2018, 20182, 201805, 2018139, 2, 5, 139, 19, 7, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-13' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-18' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-25' AS date), 1061, 3184, 13845, 13846, 13846, 13846, 13846, 13846, 13846, 2458258, 58257, N'2018-05-19', 201820, 20, 6, N'2018-W20', N'2018-W20-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96928, CAST(N'2018-05-20' AS date), CAST(N'2018-05-21' AS date), 2018, 20182, 201805, 2018140, 2, 5, 140, 20, 1, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-05-14' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-18' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-25' AS date), 1061, 3184, 13846, 13846, 13846, 13846, 13846, 13846, 13846, 2458259, 58258, N'2018-05-20', 201820, 20, 7, N'2018-W20', N'2018-W20-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96929, CAST(N'2018-05-21' AS date), CAST(N'2018-05-22' AS date), 2018, 20182, 201805, 2018141, 2, 5, 141, 21, 2, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-05-15' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-18' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-25' AS date), 1061, 3184, 13846, 13847, 13846, 13846, 13846, 13846, 13846, 2458260, 58259, N'2018-05-21', 201821, 21, 1, N'2018-W21', N'2018-W21-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96930, CAST(N'2018-05-22' AS date), CAST(N'2018-05-23' AS date), 2018, 20182, 201805, 2018142, 2, 5, 142, 22, 3, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-05-16' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-18' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-25' AS date), 1061, 3184, 13846, 13847, 13847, 13846, 13846, 13846, 13846, 2458261, 58260, N'2018-05-22', 201821, 21, 2, N'2018-W21', N'2018-W21-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96931, CAST(N'2018-05-23' AS date), CAST(N'2018-05-24' AS date), 2018, 20182, 201805, 2018143, 2, 5, 143, 23, 4, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-05-17' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-18' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-25' AS date), 1061, 3184, 13846, 13847, 13847, 13847, 13846, 13846, 13846, 2458262, 58261, N'2018-05-23', 201821, 21, 3, N'2018-W21', N'2018-W21-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96932, CAST(N'2018-05-24' AS date), CAST(N'2018-05-25' AS date), 2018, 20182, 201805, 2018144, 2, 5, 144, 24, 5, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-05-18' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-25' AS date), 1061, 3184, 13846, 13847, 13847, 13847, 13847, 13846, 13846, 2458263, 58262, N'2018-05-24', 201821, 21, 4, N'2018-W21', N'2018-W21-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96933, CAST(N'2018-05-25' AS date), CAST(N'2018-05-26' AS date), 2018, 20182, 201805, 2018145, 2, 5, 145, 25, 6, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-05-25' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-19' AS date), CAST(N'2018-05-25' AS date), 1061, 3184, 13846, 13847, 13847, 13847, 13847, 13847, 13846, 2458264, 58263, N'2018-05-25', 201821, 21, 5, N'2018-W21', N'2018-W21-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96934, CAST(N'2018-05-26' AS date), CAST(N'2018-05-27' AS date), 2018, 20182, 201805, 2018146, 2, 5, 146, 26, 7, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-20' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-05-25' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-06-01' AS date), 1061, 3184, 13846, 13847, 13847, 13847, 13847, 13847, 13847, 2458265, 58264, N'2018-05-26', 201821, 21, 6, N'2018-W21', N'2018-W21-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96935, CAST(N'2018-05-27' AS date), CAST(N'2018-05-28' AS date), 2018, 20182, 201805, 2018147, 2, 5, 147, 27, 1, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-05-21' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-05-25' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-06-01' AS date), 1061, 3184, 13847, 13847, 13847, 13847, 13847, 13847, 13847, 2458266, 58265, N'2018-05-27', 201821, 21, 7, N'2018-W21', N'2018-W21-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96936, CAST(N'2018-05-28' AS date), CAST(N'2018-05-29' AS date), 2018, 20182, 201805, 2018148, 2, 5, 148, 28, 2, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-05-22' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-05-25' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-06-01' AS date), 1061, 3184, 13847, 13848, 13847, 13847, 13847, 13847, 13847, 2458267, 58266, N'2018-05-28', 201822, 22, 1, N'2018-W22', N'2018-W22-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96937, CAST(N'2018-05-29' AS date), CAST(N'2018-05-30' AS date), 2018, 20182, 201805, 2018149, 2, 5, 149, 29, 3, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-05-23' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-05-25' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-06-01' AS date), 1061, 3184, 13847, 13848, 13848, 13847, 13847, 13847, 13847, 2458268, 58267, N'2018-05-29', 201822, 22, 2, N'2018-W22', N'2018-W22-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96938, CAST(N'2018-05-30' AS date), CAST(N'2018-05-31' AS date), 2018, 20182, 201805, 2018150, 2, 5, 150, 30, 4, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-05-24' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-05-25' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-06-01' AS date), 1061, 3184, 13847, 13848, 13848, 13848, 13847, 13847, 13847, 2458269, 58268, N'2018-05-30', 201822, 22, 3, N'2018-W22', N'2018-W22-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96939, CAST(N'2018-05-31' AS date), CAST(N'2018-06-01' AS date), 2018, 20182, 201805, 2018151, 2, 5, 151, 31, 5, N'2018', N'2018 Q2', N'2018 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-01' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-05-25' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-06-01' AS date), 1061, 3184, 13847, 13848, 13848, 13848, 13848, 13847, 13847, 2458270, 58269, N'2018-05-31', 201822, 22, 4, N'2018-W22', N'2018-W22-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96940, CAST(N'2018-06-01' AS date), CAST(N'2018-06-02' AS date), 2018, 20182, 201806, 2018152, 2, 6, 152, 1, 6, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-05-26' AS date), CAST(N'2018-06-01' AS date), 1061, 3185, 13847, 13848, 13848, 13848, 13848, 13848, 13847, 2458271, 58270, N'2018-06-01', 201822, 22, 5, N'2018-W22', N'2018-W22-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96941, CAST(N'2018-06-02' AS date), CAST(N'2018-06-03' AS date), 2018, 20182, 201806, 2018153, 2, 6, 153, 2, 7, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-05-27' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-06-08' AS date), 1061, 3185, 13847, 13848, 13848, 13848, 13848, 13848, 13848, 2458272, 58271, N'2018-06-02', 201822, 22, 6, N'2018-W22', N'2018-W22-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96942, CAST(N'2018-06-03' AS date), CAST(N'2018-06-04' AS date), 2018, 20182, 201806, 2018154, 2, 6, 154, 3, 1, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-05-28' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-06-08' AS date), 1061, 3185, 13848, 13848, 13848, 13848, 13848, 13848, 13848, 2458273, 58272, N'2018-06-03', 201822, 22, 7, N'2018-W22', N'2018-W22-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96943, CAST(N'2018-06-04' AS date), CAST(N'2018-06-05' AS date), 2018, 20182, 201806, 2018155, 2, 6, 155, 4, 2, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-05-29' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-06-08' AS date), 1061, 3185, 13848, 13849, 13848, 13848, 13848, 13848, 13848, 2458274, 58273, N'2018-06-04', 201823, 23, 1, N'2018-W23', N'2018-W23-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96944, CAST(N'2018-06-05' AS date), CAST(N'2018-06-06' AS date), 2018, 20182, 201806, 2018156, 2, 6, 156, 5, 3, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-05-30' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-06-08' AS date), 1061, 3185, 13848, 13849, 13849, 13848, 13848, 13848, 13848, 2458275, 58274, N'2018-06-05', 201823, 23, 2, N'2018-W23', N'2018-W23-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96945, CAST(N'2018-06-06' AS date), CAST(N'2018-06-07' AS date), 2018, 20182, 201806, 2018157, 2, 6, 157, 6, 4, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-05-31' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-06-08' AS date), 1061, 3185, 13848, 13849, 13849, 13849, 13848, 13848, 13848, 2458276, 58275, N'2018-06-06', 201823, 23, 3, N'2018-W23', N'2018-W23-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96946, CAST(N'2018-06-07' AS date), CAST(N'2018-06-08' AS date), 2018, 20182, 201806, 2018158, 2, 6, 158, 7, 5, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-06-08' AS date), 1061, 3185, 13848, 13849, 13849, 13849, 13849, 13848, 13848, 2458277, 58276, N'2018-06-07', 201823, 23, 4, N'2018-W23', N'2018-W23-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96947, CAST(N'2018-06-08' AS date), CAST(N'2018-06-09' AS date), 2018, 20182, 201806, 2018159, 2, 6, 159, 8, 6, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-08' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-02' AS date), CAST(N'2018-06-08' AS date), 1061, 3185, 13848, 13849, 13849, 13849, 13849, 13849, 13848, 2458278, 58277, N'2018-06-08', 201823, 23, 5, N'2018-W23', N'2018-W23-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96948, CAST(N'2018-06-09' AS date), CAST(N'2018-06-10' AS date), 2018, 20182, 201806, 2018160, 2, 6, 160, 9, 7, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-03' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-08' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-15' AS date), 1061, 3185, 13848, 13849, 13849, 13849, 13849, 13849, 13849, 2458279, 58278, N'2018-06-09', 201823, 23, 6, N'2018-W23', N'2018-W23-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96949, CAST(N'2018-06-10' AS date), CAST(N'2018-06-11' AS date), 2018, 20182, 201806, 2018161, 2, 6, 161, 10, 1, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-04' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-08' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-15' AS date), 1061, 3185, 13849, 13849, 13849, 13849, 13849, 13849, 13849, 2458280, 58279, N'2018-06-10', 201823, 23, 7, N'2018-W23', N'2018-W23-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96950, CAST(N'2018-06-11' AS date), CAST(N'2018-06-12' AS date), 2018, 20182, 201806, 2018162, 2, 6, 162, 11, 2, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-05' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-08' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-15' AS date), 1061, 3185, 13849, 13850, 13849, 13849, 13849, 13849, 13849, 2458281, 58280, N'2018-06-11', 201824, 24, 1, N'2018-W24', N'2018-W24-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96951, CAST(N'2018-06-12' AS date), CAST(N'2018-06-13' AS date), 2018, 20182, 201806, 2018163, 2, 6, 163, 12, 3, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-06' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-08' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-15' AS date), 1061, 3185, 13849, 13850, 13850, 13849, 13849, 13849, 13849, 2458282, 58281, N'2018-06-12', 201824, 24, 2, N'2018-W24', N'2018-W24-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96952, CAST(N'2018-06-13' AS date), CAST(N'2018-06-14' AS date), 2018, 20182, 201806, 2018164, 2, 6, 164, 13, 4, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-07' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-08' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-15' AS date), 1061, 3185, 13849, 13850, 13850, 13850, 13849, 13849, 13849, 2458283, 58282, N'2018-06-13', 201824, 24, 3, N'2018-W24', N'2018-W24-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96953, CAST(N'2018-06-14' AS date), CAST(N'2018-06-15' AS date), 2018, 20182, 201806, 2018165, 2, 6, 165, 14, 5, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-08' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-15' AS date), 1061, 3185, 13849, 13850, 13850, 13850, 13850, 13849, 13849, 2458284, 58283, N'2018-06-14', 201824, 24, 4, N'2018-W24', N'2018-W24-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96954, CAST(N'2018-06-15' AS date), CAST(N'2018-06-16' AS date), 2018, 20182, 201806, 2018166, 2, 6, 166, 15, 6, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-15' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-09' AS date), CAST(N'2018-06-15' AS date), 1061, 3185, 13849, 13850, 13850, 13850, 13850, 13850, 13849, 2458285, 58284, N'2018-06-15', 201824, 24, 5, N'2018-W24', N'2018-W24-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96955, CAST(N'2018-06-16' AS date), CAST(N'2018-06-17' AS date), 2018, 20182, 201806, 2018167, 2, 6, 167, 16, 7, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-10' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-15' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-22' AS date), 1061, 3185, 13849, 13850, 13850, 13850, 13850, 13850, 13850, 2458286, 58285, N'2018-06-16', 201824, 24, 6, N'2018-W24', N'2018-W24-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96956, CAST(N'2018-06-17' AS date), CAST(N'2018-06-18' AS date), 2018, 20182, 201806, 2018168, 2, 6, 168, 17, 1, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-11' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-15' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-22' AS date), 1061, 3185, 13850, 13850, 13850, 13850, 13850, 13850, 13850, 2458287, 58286, N'2018-06-17', 201824, 24, 7, N'2018-W24', N'2018-W24-7');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96957, CAST(N'2018-06-18' AS date), CAST(N'2018-06-19' AS date), 2018, 20182, 201806, 2018169, 2, 6, 169, 18, 2, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-12' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-15' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-22' AS date), 1061, 3185, 13850, 13851, 13850, 13850, 13850, 13850, 13850, 2458288, 58287, N'2018-06-18', 201825, 25, 1, N'2018-W25', N'2018-W25-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96958, CAST(N'2018-06-19' AS date), CAST(N'2018-06-20' AS date), 2018, 20182, 201806, 2018170, 2, 6, 170, 19, 3, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-06-13' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-15' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-22' AS date), 1061, 3185, 13850, 13851, 13851, 13850, 13850, 13850, 13850, 2458289, 58288, N'2018-06-19', 201825, 25, 2, N'2018-W25', N'2018-W25-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96959, CAST(N'2018-06-20' AS date), CAST(N'2018-06-21' AS date), 2018, 20182, 201806, 2018171, 2, 6, 171, 20, 4, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-06-14' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-15' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-22' AS date), 1061, 3185, 13850, 13851, 13851, 13851, 13850, 13850, 13850, 2458290, 58289, N'2018-06-20', 201825, 25, 3, N'2018-W25', N'2018-W25-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96960, CAST(N'2018-06-21' AS date), CAST(N'2018-06-22' AS date), 2018, 20182, 201806, 2018172, 2, 6, 172, 21, 5, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-06-15' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-22' AS date), 1061, 3185, 13850, 13851, 13851, 13851, 13851, 13850, 13850, 2458291, 58290, N'2018-06-21', 201825, 25, 4, N'2018-W25', N'2018-W25-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96961, CAST(N'2018-06-22' AS date), CAST(N'2018-06-23' AS date), 2018, 20182, 201806, 2018173, 2, 6, 173, 22, 6, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-06-22' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-06-16' AS date), CAST(N'2018-06-22' AS date), 1061, 3185, 13850, 13851, 13851, 13851, 13851, 13851, 13850, 2458292, 58291, N'2018-06-22', 201825, 25, 5, N'2018-W25', N'2018-W25-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96962, CAST(N'2018-06-23' AS date), CAST(N'2018-06-24' AS date), 2018, 20182, 201806, 2018174, 2, 6, 174, 23, 7, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-17' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-06-22' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-29' AS date), 1061, 3185, 13850, 13851, 13851, 13851, 13851, 13851, 13851, 2458293, 58292, N'2018-06-23', 201825, 25, 6, N'2018-W25', N'2018-W25-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96963, CAST(N'2018-06-24' AS date), CAST(N'2018-06-25' AS date), 2018, 20182, 201806, 2018175, 2, 6, 175, 24, 1, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-18' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-06-22' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-29' AS date), 1061, 3185, 13851, 13851, 13851, 13851, 13851, 13851, 13851, 2458294, 58293, N'2018-06-24', 201825, 25, 7, N'2018-W25', N'2018-W25-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96964, CAST(N'2018-06-25' AS date), CAST(N'2018-06-26' AS date), 2018, 20182, 201806, 2018176, 2, 6, 176, 25, 2, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-06-19' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-06-22' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-29' AS date), 1061, 3185, 13851, 13852, 13851, 13851, 13851, 13851, 13851, 2458295, 58294, N'2018-06-25', 201826, 26, 1, N'2018-W26', N'2018-W26-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96965, CAST(N'2018-06-26' AS date), CAST(N'2018-06-27' AS date), 2018, 20182, 201806, 2018177, 2, 6, 177, 26, 3, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-06-20' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-06-22' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-29' AS date), 1061, 3185, 13851, 13852, 13852, 13851, 13851, 13851, 13851, 2458296, 58295, N'2018-06-26', 201826, 26, 2, N'2018-W26', N'2018-W26-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96966, CAST(N'2018-06-27' AS date), CAST(N'2018-06-28' AS date), 2018, 20182, 201806, 2018178, 2, 6, 178, 27, 4, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-06-21' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-06-22' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-29' AS date), 1061, 3185, 13851, 13852, 13852, 13852, 13851, 13851, 13851, 2458297, 58296, N'2018-06-27', 201826, 26, 3, N'2018-W26', N'2018-W26-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96967, CAST(N'2018-06-28' AS date), CAST(N'2018-06-29' AS date), 2018, 20182, 201806, 2018179, 2, 6, 179, 28, 5, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-06-22' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-29' AS date), 1061, 3185, 13851, 13852, 13852, 13852, 13852, 13851, 13851, 2458298, 58297, N'2018-06-28', 201826, 26, 4, N'2018-W26', N'2018-W26-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96968, CAST(N'2018-06-29' AS date), CAST(N'2018-06-30' AS date), 2018, 20182, 201806, 2018180, 2, 6, 180, 29, 6, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-06-29' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-06-23' AS date), CAST(N'2018-06-29' AS date), 1061, 3185, 13851, 13852, 13852, 13852, 13852, 13852, 13851, 2458299, 58298, N'2018-06-29', 201826, 26, 5, N'2018-W26', N'2018-W26-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96969, CAST(N'2018-06-30' AS date), CAST(N'2018-07-01' AS date), 2018, 20182, 201806, 2018181, 2, 6, 181, 30, 7, N'2018', N'2018 Q2', N'2018 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-04-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-01' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-24' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-06-29' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-07-06' AS date), 1061, 3185, 13851, 13852, 13852, 13852, 13852, 13852, 13852, 2458300, 58299, N'2018-06-30', 201826, 26, 6, N'2018-W26', N'2018-W26-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96970, CAST(N'2018-07-01' AS date), CAST(N'2018-07-02' AS date), 2018, 20183, 201807, 2018182, 3, 7, 182, 1, 1, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-06-25' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-06-29' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-07-06' AS date), 1062, 3186, 13852, 13852, 13852, 13852, 13852, 13852, 13852, 2458301, 58300, N'2018-07-01', 201826, 26, 7, N'2018-W26', N'2018-W26-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96971, CAST(N'2018-07-02' AS date), CAST(N'2018-07-03' AS date), 2018, 20183, 201807, 2018183, 3, 7, 183, 2, 2, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-06-26' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-06-29' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-07-06' AS date), 1062, 3186, 13852, 13853, 13852, 13852, 13852, 13852, 13852, 2458302, 58301, N'2018-07-02', 201827, 27, 1, N'2018-W27', N'2018-W27-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96972, CAST(N'2018-07-03' AS date), CAST(N'2018-07-04' AS date), 2018, 20183, 201807, 2018184, 3, 7, 184, 3, 3, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-06-27' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-06-29' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-07-06' AS date), 1062, 3186, 13852, 13853, 13853, 13852, 13852, 13852, 13852, 2458303, 58302, N'2018-07-03', 201827, 27, 2, N'2018-W27', N'2018-W27-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96973, CAST(N'2018-07-04' AS date), CAST(N'2018-07-05' AS date), 2018, 20183, 201807, 2018185, 3, 7, 185, 4, 4, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-06-28' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-06-29' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-07-06' AS date), 1062, 3186, 13852, 13853, 13853, 13853, 13852, 13852, 13852, 2458304, 58303, N'2018-07-04', 201827, 27, 3, N'2018-W27', N'2018-W27-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96974, CAST(N'2018-07-05' AS date), CAST(N'2018-07-06' AS date), 2018, 20183, 201807, 2018186, 3, 7, 186, 5, 5, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-06-29' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-07-06' AS date), 1062, 3186, 13852, 13853, 13853, 13853, 13853, 13852, 13852, 2458305, 58304, N'2018-07-05', 201827, 27, 4, N'2018-W27', N'2018-W27-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96975, CAST(N'2018-07-06' AS date), CAST(N'2018-07-07' AS date), 2018, 20183, 201807, 2018187, 3, 7, 187, 6, 6, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-06' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-06-30' AS date), CAST(N'2018-07-06' AS date), 1062, 3186, 13852, 13853, 13853, 13853, 13853, 13853, 13852, 2458306, 58305, N'2018-07-06', 201827, 27, 5, N'2018-W27', N'2018-W27-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96976, CAST(N'2018-07-07' AS date), CAST(N'2018-07-08' AS date), 2018, 20183, 201807, 2018188, 3, 7, 188, 7, 7, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-06' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-13' AS date), 1062, 3186, 13852, 13853, 13853, 13853, 13853, 13853, 13853, 2458307, 58306, N'2018-07-07', 201827, 27, 6, N'2018-W27', N'2018-W27-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96977, CAST(N'2018-07-08' AS date), CAST(N'2018-07-09' AS date), 2018, 20183, 201807, 2018189, 3, 7, 189, 8, 1, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-02' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-06' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-13' AS date), 1062, 3186, 13853, 13853, 13853, 13853, 13853, 13853, 13853, 2458308, 58307, N'2018-07-08', 201827, 27, 7, N'2018-W27', N'2018-W27-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96978, CAST(N'2018-07-09' AS date), CAST(N'2018-07-10' AS date), 2018, 20183, 201807, 2018190, 3, 7, 190, 9, 2, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-03' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-06' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-13' AS date), 1062, 3186, 13853, 13854, 13853, 13853, 13853, 13853, 13853, 2458309, 58308, N'2018-07-09', 201828, 28, 1, N'2018-W28', N'2018-W28-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96979, CAST(N'2018-07-10' AS date), CAST(N'2018-07-11' AS date), 2018, 20183, 201807, 2018191, 3, 7, 191, 10, 3, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-04' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-06' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-13' AS date), 1062, 3186, 13853, 13854, 13854, 13853, 13853, 13853, 13853, 2458310, 58309, N'2018-07-10', 201828, 28, 2, N'2018-W28', N'2018-W28-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96980, CAST(N'2018-07-11' AS date), CAST(N'2018-07-12' AS date), 2018, 20183, 201807, 2018192, 3, 7, 192, 11, 4, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-05' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-06' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-13' AS date), 1062, 3186, 13853, 13854, 13854, 13854, 13853, 13853, 13853, 2458311, 58310, N'2018-07-11', 201828, 28, 3, N'2018-W28', N'2018-W28-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96981, CAST(N'2018-07-12' AS date), CAST(N'2018-07-13' AS date), 2018, 20183, 201807, 2018193, 3, 7, 193, 12, 5, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-06' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-13' AS date), 1062, 3186, 13853, 13854, 13854, 13854, 13854, 13853, 13853, 2458312, 58311, N'2018-07-12', 201828, 28, 4, N'2018-W28', N'2018-W28-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96982, CAST(N'2018-07-13' AS date), CAST(N'2018-07-14' AS date), 2018, 20183, 201807, 2018194, 3, 7, 194, 13, 6, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-13' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-07' AS date), CAST(N'2018-07-13' AS date), 1062, 3186, 13853, 13854, 13854, 13854, 13854, 13854, 13853, 2458313, 58312, N'2018-07-13', 201828, 28, 5, N'2018-W28', N'2018-W28-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96983, CAST(N'2018-07-14' AS date), CAST(N'2018-07-15' AS date), 2018, 20183, 201807, 2018195, 3, 7, 195, 14, 7, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-08' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-13' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-20' AS date), 1062, 3186, 13853, 13854, 13854, 13854, 13854, 13854, 13854, 2458314, 58313, N'2018-07-14', 201828, 28, 6, N'2018-W28', N'2018-W28-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96984, CAST(N'2018-07-15' AS date), CAST(N'2018-07-16' AS date), 2018, 20183, 201807, 2018196, 3, 7, 196, 15, 1, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-09' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-13' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-20' AS date), 1062, 3186, 13854, 13854, 13854, 13854, 13854, 13854, 13854, 2458315, 58314, N'2018-07-15', 201828, 28, 7, N'2018-W28', N'2018-W28-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96985, CAST(N'2018-07-16' AS date), CAST(N'2018-07-17' AS date), 2018, 20183, 201807, 2018197, 3, 7, 197, 16, 2, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-10' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-13' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-20' AS date), 1062, 3186, 13854, 13855, 13854, 13854, 13854, 13854, 13854, 2458316, 58315, N'2018-07-16', 201829, 29, 1, N'2018-W29', N'2018-W29-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96986, CAST(N'2018-07-17' AS date), CAST(N'2018-07-18' AS date), 2018, 20183, 201807, 2018198, 3, 7, 198, 17, 3, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-11' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-13' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-20' AS date), 1062, 3186, 13854, 13855, 13855, 13854, 13854, 13854, 13854, 2458317, 58316, N'2018-07-17', 201829, 29, 2, N'2018-W29', N'2018-W29-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96987, CAST(N'2018-07-18' AS date), CAST(N'2018-07-19' AS date), 2018, 20183, 201807, 2018199, 3, 7, 199, 18, 4, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-12' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-13' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-20' AS date), 1062, 3186, 13854, 13855, 13855, 13855, 13854, 13854, 13854, 2458318, 58317, N'2018-07-18', 201829, 29, 3, N'2018-W29', N'2018-W29-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96988, CAST(N'2018-07-19' AS date), CAST(N'2018-07-20' AS date), 2018, 20183, 201807, 2018200, 3, 7, 200, 19, 5, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-13' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-20' AS date), 1062, 3186, 13854, 13855, 13855, 13855, 13855, 13854, 13854, 2458319, 58318, N'2018-07-19', 201829, 29, 4, N'2018-W29', N'2018-W29-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96989, CAST(N'2018-07-20' AS date), CAST(N'2018-07-21' AS date), 2018, 20183, 201807, 2018201, 3, 7, 201, 20, 6, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-20' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-07-14' AS date), CAST(N'2018-07-20' AS date), 1062, 3186, 13854, 13855, 13855, 13855, 13855, 13855, 13854, 2458320, 58319, N'2018-07-20', 201829, 29, 5, N'2018-W29', N'2018-W29-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96990, CAST(N'2018-07-21' AS date), CAST(N'2018-07-22' AS date), 2018, 20183, 201807, 2018202, 3, 7, 202, 21, 7, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-15' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-20' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-27' AS date), 1062, 3186, 13854, 13855, 13855, 13855, 13855, 13855, 13855, 2458321, 58320, N'2018-07-21', 201829, 29, 6, N'2018-W29', N'2018-W29-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96991, CAST(N'2018-07-22' AS date), CAST(N'2018-07-23' AS date), 2018, 20183, 201807, 2018203, 3, 7, 203, 22, 1, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-07-16' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-20' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-27' AS date), 1062, 3186, 13855, 13855, 13855, 13855, 13855, 13855, 13855, 2458322, 58321, N'2018-07-22', 201829, 29, 7, N'2018-W29', N'2018-W29-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96992, CAST(N'2018-07-23' AS date), CAST(N'2018-07-24' AS date), 2018, 20183, 201807, 2018204, 3, 7, 204, 23, 2, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-07-17' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-20' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-27' AS date), 1062, 3186, 13855, 13856, 13855, 13855, 13855, 13855, 13855, 2458323, 58322, N'2018-07-23', 201830, 30, 1, N'2018-W30', N'2018-W30-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96993, CAST(N'2018-07-24' AS date), CAST(N'2018-07-25' AS date), 2018, 20183, 201807, 2018205, 3, 7, 205, 24, 3, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-07-18' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-20' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-27' AS date), 1062, 3186, 13855, 13856, 13856, 13855, 13855, 13855, 13855, 2458324, 58323, N'2018-07-24', 201830, 30, 2, N'2018-W30', N'2018-W30-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96994, CAST(N'2018-07-25' AS date), CAST(N'2018-07-26' AS date), 2018, 20183, 201807, 2018206, 3, 7, 206, 25, 4, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-19' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-20' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-27' AS date), 1062, 3186, 13855, 13856, 13856, 13856, 13855, 13855, 13855, 2458325, 58324, N'2018-07-25', 201830, 30, 3, N'2018-W30', N'2018-W30-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96995, CAST(N'2018-07-26' AS date), CAST(N'2018-07-27' AS date), 2018, 20183, 201807, 2018207, 3, 7, 207, 26, 5, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-07-20' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-27' AS date), 1062, 3186, 13855, 13856, 13856, 13856, 13856, 13855, 13855, 2458326, 58325, N'2018-07-26', 201830, 30, 4, N'2018-W30', N'2018-W30-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96996, CAST(N'2018-07-27' AS date), CAST(N'2018-07-28' AS date), 2018, 20183, 201807, 2018208, 3, 7, 208, 27, 6, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-07-27' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-07-21' AS date), CAST(N'2018-07-27' AS date), 1062, 3186, 13855, 13856, 13856, 13856, 13856, 13856, 13855, 2458327, 58326, N'2018-07-27', 201830, 30, 5, N'2018-W30', N'2018-W30-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96997, CAST(N'2018-07-28' AS date), CAST(N'2018-07-29' AS date), 2018, 20183, 201807, 2018209, 3, 7, 209, 28, 7, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-22' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-07-27' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-08-03' AS date), 1062, 3186, 13855, 13856, 13856, 13856, 13856, 13856, 13856, 2458328, 58327, N'2018-07-28', 201830, 30, 6, N'2018-W30', N'2018-W30-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96998, CAST(N'2018-07-29' AS date), CAST(N'2018-07-30' AS date), 2018, 20183, 201807, 2018210, 3, 7, 210, 29, 1, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-07-23' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-07-27' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-08-03' AS date), 1062, 3186, 13856, 13856, 13856, 13856, 13856, 13856, 13856, 2458329, 58328, N'2018-07-29', 201830, 30, 7, N'2018-W30', N'2018-W30-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (96999, CAST(N'2018-07-30' AS date), CAST(N'2018-07-31' AS date), 2018, 20183, 201807, 2018211, 3, 7, 211, 30, 2, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-07-24' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-07-27' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-08-03' AS date), 1062, 3186, 13856, 13857, 13856, 13856, 13856, 13856, 13856, 2458330, 58329, N'2018-07-30', 201831, 31, 1, N'2018-W31', N'2018-W31-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97000, CAST(N'2018-07-31' AS date), CAST(N'2018-08-01' AS date), 2018, 20183, 201807, 2018212, 3, 7, 212, 31, 3, N'2018', N'2018 Q3', N'2018 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-07-25' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-07-27' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-08-03' AS date), 1062, 3186, 13856, 13857, 13857, 13856, 13856, 13856, 13856, 2458331, 58330, N'2018-07-31', 201831, 31, 2, N'2018-W31', N'2018-W31-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97001, CAST(N'2018-08-01' AS date), CAST(N'2018-08-02' AS date), 2018, 20183, 201808, 2018213, 3, 8, 213, 1, 4, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-07-26' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-07-27' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-08-03' AS date), 1062, 3187, 13856, 13857, 13857, 13857, 13856, 13856, 13856, 2458332, 58331, N'2018-08-01', 201831, 31, 3, N'2018-W31', N'2018-W31-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97002, CAST(N'2018-08-02' AS date), CAST(N'2018-08-03' AS date), 2018, 20183, 201808, 2018214, 3, 8, 214, 2, 5, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-07-27' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-08-03' AS date), 1062, 3187, 13856, 13857, 13857, 13857, 13857, 13856, 13856, 2458333, 58332, N'2018-08-02', 201831, 31, 4, N'2018-W31', N'2018-W31-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97003, CAST(N'2018-08-03' AS date), CAST(N'2018-08-04' AS date), 2018, 20183, 201808, 2018215, 3, 8, 215, 3, 6, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-03' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-07-28' AS date), CAST(N'2018-08-03' AS date), 1062, 3187, 13856, 13857, 13857, 13857, 13857, 13857, 13856, 2458334, 58333, N'2018-08-03', 201831, 31, 5, N'2018-W31', N'2018-W31-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97004, CAST(N'2018-08-04' AS date), CAST(N'2018-08-05' AS date), 2018, 20183, 201808, 2018216, 3, 8, 216, 4, 7, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-07-29' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-03' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-08-10' AS date), 1062, 3187, 13856, 13857, 13857, 13857, 13857, 13857, 13857, 2458335, 58334, N'2018-08-04', 201831, 31, 6, N'2018-W31', N'2018-W31-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97005, CAST(N'2018-08-05' AS date), CAST(N'2018-08-06' AS date), 2018, 20183, 201808, 2018217, 3, 8, 217, 5, 1, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-07-30' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-03' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-08-10' AS date), 1062, 3187, 13857, 13857, 13857, 13857, 13857, 13857, 13857, 2458336, 58335, N'2018-08-05', 201831, 31, 7, N'2018-W31', N'2018-W31-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97006, CAST(N'2018-08-06' AS date), CAST(N'2018-08-07' AS date), 2018, 20183, 201808, 2018218, 3, 8, 218, 6, 2, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-07-31' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-03' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-08-10' AS date), 1062, 3187, 13857, 13858, 13857, 13857, 13857, 13857, 13857, 2458337, 58336, N'2018-08-06', 201832, 32, 1, N'2018-W32', N'2018-W32-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97007, CAST(N'2018-08-07' AS date), CAST(N'2018-08-08' AS date), 2018, 20183, 201808, 2018219, 3, 8, 219, 7, 3, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-03' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-08-10' AS date), 1062, 3187, 13857, 13858, 13858, 13857, 13857, 13857, 13857, 2458338, 58337, N'2018-08-07', 201832, 32, 2, N'2018-W32', N'2018-W32-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97008, CAST(N'2018-08-08' AS date), CAST(N'2018-08-09' AS date), 2018, 20183, 201808, 2018220, 3, 8, 220, 8, 4, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-02' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-03' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-08-10' AS date), 1062, 3187, 13857, 13858, 13858, 13858, 13857, 13857, 13857, 2458339, 58338, N'2018-08-08', 201832, 32, 3, N'2018-W32', N'2018-W32-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97009, CAST(N'2018-08-09' AS date), CAST(N'2018-08-10' AS date), 2018, 20183, 201808, 2018221, 3, 8, 221, 9, 5, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-03' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-08-10' AS date), 1062, 3187, 13857, 13858, 13858, 13858, 13858, 13857, 13857, 2458340, 58339, N'2018-08-09', 201832, 32, 4, N'2018-W32', N'2018-W32-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97010, CAST(N'2018-08-10' AS date), CAST(N'2018-08-11' AS date), 2018, 20183, 201808, 2018222, 3, 8, 222, 10, 6, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-10' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-04' AS date), CAST(N'2018-08-10' AS date), 1062, 3187, 13857, 13858, 13858, 13858, 13858, 13858, 13857, 2458341, 58340, N'2018-08-10', 201832, 32, 5, N'2018-W32', N'2018-W32-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97011, CAST(N'2018-08-11' AS date), CAST(N'2018-08-12' AS date), 2018, 20183, 201808, 2018223, 3, 8, 223, 11, 7, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-05' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-10' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-17' AS date), 1062, 3187, 13857, 13858, 13858, 13858, 13858, 13858, 13858, 2458342, 58341, N'2018-08-11', 201832, 32, 6, N'2018-W32', N'2018-W32-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97012, CAST(N'2018-08-12' AS date), CAST(N'2018-08-13' AS date), 2018, 20183, 201808, 2018224, 3, 8, 224, 12, 1, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-06' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-10' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-17' AS date), 1062, 3187, 13858, 13858, 13858, 13858, 13858, 13858, 13858, 2458343, 58342, N'2018-08-12', 201832, 32, 7, N'2018-W32', N'2018-W32-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97013, CAST(N'2018-08-13' AS date), CAST(N'2018-08-14' AS date), 2018, 20183, 201808, 2018225, 3, 8, 225, 13, 2, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-07' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-10' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-17' AS date), 1062, 3187, 13858, 13859, 13858, 13858, 13858, 13858, 13858, 2458344, 58343, N'2018-08-13', 201833, 33, 1, N'2018-W33', N'2018-W33-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97014, CAST(N'2018-08-14' AS date), CAST(N'2018-08-15' AS date), 2018, 20183, 201808, 2018226, 3, 8, 226, 14, 3, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-08' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-10' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-17' AS date), 1062, 3187, 13858, 13859, 13859, 13858, 13858, 13858, 13858, 2458345, 58344, N'2018-08-14', 201833, 33, 2, N'2018-W33', N'2018-W33-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97015, CAST(N'2018-08-15' AS date), CAST(N'2018-08-16' AS date), 2018, 20183, 201808, 2018227, 3, 8, 227, 15, 4, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-09' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-10' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-17' AS date), 1062, 3187, 13858, 13859, 13859, 13859, 13858, 13858, 13858, 2458346, 58345, N'2018-08-15', 201833, 33, 3, N'2018-W33', N'2018-W33-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97016, CAST(N'2018-08-16' AS date), CAST(N'2018-08-17' AS date), 2018, 20183, 201808, 2018228, 3, 8, 228, 16, 5, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-10' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-17' AS date), 1062, 3187, 13858, 13859, 13859, 13859, 13859, 13858, 13858, 2458347, 58346, N'2018-08-16', 201833, 33, 4, N'2018-W33', N'2018-W33-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97017, CAST(N'2018-08-17' AS date), CAST(N'2018-08-18' AS date), 2018, 20183, 201808, 2018229, 3, 8, 229, 17, 6, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-17' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-11' AS date), CAST(N'2018-08-17' AS date), 1062, 3187, 13858, 13859, 13859, 13859, 13859, 13859, 13858, 2458348, 58347, N'2018-08-17', 201833, 33, 5, N'2018-W33', N'2018-W33-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97018, CAST(N'2018-08-18' AS date), CAST(N'2018-08-19' AS date), 2018, 20183, 201808, 2018230, 3, 8, 230, 18, 7, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-12' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-17' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-24' AS date), 1062, 3187, 13858, 13859, 13859, 13859, 13859, 13859, 13859, 2458349, 58348, N'2018-08-18', 201833, 33, 6, N'2018-W33', N'2018-W33-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97019, CAST(N'2018-08-19' AS date), CAST(N'2018-08-20' AS date), 2018, 20183, 201808, 2018231, 3, 8, 231, 19, 1, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-13' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-17' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-24' AS date), 1062, 3187, 13859, 13859, 13859, 13859, 13859, 13859, 13859, 2458350, 58349, N'2018-08-19', 201833, 33, 7, N'2018-W33', N'2018-W33-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97020, CAST(N'2018-08-20' AS date), CAST(N'2018-08-21' AS date), 2018, 20183, 201808, 2018232, 3, 8, 232, 20, 2, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-08-14' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-17' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-24' AS date), 1062, 3187, 13859, 13860, 13859, 13859, 13859, 13859, 13859, 2458351, 58350, N'2018-08-20', 201834, 34, 1, N'2018-W34', N'2018-W34-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97021, CAST(N'2018-08-21' AS date), CAST(N'2018-08-22' AS date), 2018, 20183, 201808, 2018233, 3, 8, 233, 21, 3, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-08-15' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-17' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-24' AS date), 1062, 3187, 13859, 13860, 13860, 13859, 13859, 13859, 13859, 2458352, 58351, N'2018-08-21', 201834, 34, 2, N'2018-W34', N'2018-W34-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97022, CAST(N'2018-08-22' AS date), CAST(N'2018-08-23' AS date), 2018, 20183, 201808, 2018234, 3, 8, 234, 22, 4, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-08-16' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-17' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-24' AS date), 1062, 3187, 13859, 13860, 13860, 13860, 13859, 13859, 13859, 2458353, 58352, N'2018-08-22', 201834, 34, 3, N'2018-W34', N'2018-W34-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97023, CAST(N'2018-08-23' AS date), CAST(N'2018-08-24' AS date), 2018, 20183, 201808, 2018235, 3, 8, 235, 23, 5, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-08-17' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-24' AS date), 1062, 3187, 13859, 13860, 13860, 13860, 13860, 13859, 13859, 2458354, 58353, N'2018-08-23', 201834, 34, 4, N'2018-W34', N'2018-W34-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97024, CAST(N'2018-08-24' AS date), CAST(N'2018-08-25' AS date), 2018, 20183, 201808, 2018236, 3, 8, 236, 24, 6, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-08-24' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-08-18' AS date), CAST(N'2018-08-24' AS date), 1062, 3187, 13859, 13860, 13860, 13860, 13860, 13860, 13859, 2458355, 58354, N'2018-08-24', 201834, 34, 5, N'2018-W34', N'2018-W34-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97025, CAST(N'2018-08-25' AS date), CAST(N'2018-08-26' AS date), 2018, 20183, 201808, 2018237, 3, 8, 237, 25, 7, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-19' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-08-24' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-31' AS date), 1062, 3187, 13859, 13860, 13860, 13860, 13860, 13860, 13860, 2458356, 58355, N'2018-08-25', 201834, 34, 6, N'2018-W34', N'2018-W34-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97026, CAST(N'2018-08-26' AS date), CAST(N'2018-08-27' AS date), 2018, 20183, 201808, 2018238, 3, 8, 238, 26, 1, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-08-20' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-08-24' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-31' AS date), 1062, 3187, 13860, 13860, 13860, 13860, 13860, 13860, 13860, 2458357, 58356, N'2018-08-26', 201834, 34, 7, N'2018-W34', N'2018-W34-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97027, CAST(N'2018-08-27' AS date), CAST(N'2018-08-28' AS date), 2018, 20183, 201808, 2018239, 3, 8, 239, 27, 2, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-08-21' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-08-24' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-31' AS date), 1062, 3187, 13860, 13861, 13860, 13860, 13860, 13860, 13860, 2458358, 58357, N'2018-08-27', 201835, 35, 1, N'2018-W35', N'2018-W35-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97028, CAST(N'2018-08-28' AS date), CAST(N'2018-08-29' AS date), 2018, 20183, 201808, 2018240, 3, 8, 240, 28, 3, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-08-22' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-08-24' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-31' AS date), 1062, 3187, 13860, 13861, 13861, 13860, 13860, 13860, 13860, 2458359, 58358, N'2018-08-28', 201835, 35, 2, N'2018-W35', N'2018-W35-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97029, CAST(N'2018-08-29' AS date), CAST(N'2018-08-30' AS date), 2018, 20183, 201808, 2018241, 3, 8, 241, 29, 4, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-08-23' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-08-24' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-31' AS date), 1062, 3187, 13860, 13861, 13861, 13861, 13860, 13860, 13860, 2458360, 58359, N'2018-08-29', 201835, 35, 3, N'2018-W35', N'2018-W35-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97030, CAST(N'2018-08-30' AS date), CAST(N'2018-08-31' AS date), 2018, 20183, 201808, 2018242, 3, 8, 242, 30, 5, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-08-24' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-31' AS date), 1062, 3187, 13860, 13861, 13861, 13861, 13861, 13860, 13860, 2458361, 58360, N'2018-08-30', 201835, 35, 4, N'2018-W35', N'2018-W35-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97031, CAST(N'2018-08-31' AS date), CAST(N'2018-09-01' AS date), 2018, 20183, 201808, 2018243, 3, 8, 243, 31, 6, N'2018', N'2018 Q3', N'2018 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-01' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-08-25' AS date), CAST(N'2018-08-31' AS date), 1062, 3187, 13860, 13861, 13861, 13861, 13861, 13861, 13860, 2458362, 58361, N'2018-08-31', 201835, 35, 5, N'2018-W35', N'2018-W35-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97032, CAST(N'2018-09-01' AS date), CAST(N'2018-09-02' AS date), 2018, 20183, 201809, 2018244, 3, 9, 244, 1, 7, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-08-26' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-07' AS date), 1062, 3188, 13860, 13861, 13861, 13861, 13861, 13861, 13861, 2458363, 58362, N'2018-09-01', 201835, 35, 6, N'2018-W35', N'2018-W35-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97033, CAST(N'2018-09-02' AS date), CAST(N'2018-09-03' AS date), 2018, 20183, 201809, 2018245, 3, 9, 245, 2, 1, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-08-27' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-07' AS date), 1062, 3188, 13861, 13861, 13861, 13861, 13861, 13861, 13861, 2458364, 58363, N'2018-09-02', 201835, 35, 7, N'2018-W35', N'2018-W35-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97034, CAST(N'2018-09-03' AS date), CAST(N'2018-09-04' AS date), 2018, 20183, 201809, 2018246, 3, 9, 246, 3, 2, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-08-28' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-07' AS date), 1062, 3188, 13861, 13862, 13861, 13861, 13861, 13861, 13861, 2458365, 58364, N'2018-09-03', 201836, 36, 1, N'2018-W36', N'2018-W36-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97035, CAST(N'2018-09-04' AS date), CAST(N'2018-09-05' AS date), 2018, 20183, 201809, 2018247, 3, 9, 247, 4, 3, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-08-29' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-07' AS date), 1062, 3188, 13861, 13862, 13862, 13861, 13861, 13861, 13861, 2458366, 58365, N'2018-09-04', 201836, 36, 2, N'2018-W36', N'2018-W36-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97036, CAST(N'2018-09-05' AS date), CAST(N'2018-09-06' AS date), 2018, 20183, 201809, 2018248, 3, 9, 248, 5, 4, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-08-30' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-07' AS date), 1062, 3188, 13861, 13862, 13862, 13862, 13861, 13861, 13861, 2458367, 58366, N'2018-09-05', 201836, 36, 3, N'2018-W36', N'2018-W36-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97037, CAST(N'2018-09-06' AS date), CAST(N'2018-09-07' AS date), 2018, 20183, 201809, 2018249, 3, 9, 249, 6, 5, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-08-31' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-07' AS date), 1062, 3188, 13861, 13862, 13862, 13862, 13862, 13861, 13861, 2458368, 58367, N'2018-09-06', 201836, 36, 4, N'2018-W36', N'2018-W36-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97038, CAST(N'2018-09-07' AS date), CAST(N'2018-09-08' AS date), 2018, 20183, 201809, 2018250, 3, 9, 250, 7, 6, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-07' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-07' AS date), 1062, 3188, 13861, 13862, 13862, 13862, 13862, 13862, 13861, 2458369, 58368, N'2018-09-07', 201836, 36, 5, N'2018-W36', N'2018-W36-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97039, CAST(N'2018-09-08' AS date), CAST(N'2018-09-09' AS date), 2018, 20183, 201809, 2018251, 3, 9, 251, 8, 7, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-02' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-07' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-14' AS date), 1062, 3188, 13861, 13862, 13862, 13862, 13862, 13862, 13862, 2458370, 58369, N'2018-09-08', 201836, 36, 6, N'2018-W36', N'2018-W36-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97040, CAST(N'2018-09-09' AS date), CAST(N'2018-09-10' AS date), 2018, 20183, 201809, 2018252, 3, 9, 252, 9, 1, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-03' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-07' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-14' AS date), 1062, 3188, 13862, 13862, 13862, 13862, 13862, 13862, 13862, 2458371, 58370, N'2018-09-09', 201836, 36, 7, N'2018-W36', N'2018-W36-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97041, CAST(N'2018-09-10' AS date), CAST(N'2018-09-11' AS date), 2018, 20183, 201809, 2018253, 3, 9, 253, 10, 2, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-04' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-07' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-14' AS date), 1062, 3188, 13862, 13863, 13862, 13862, 13862, 13862, 13862, 2458372, 58371, N'2018-09-10', 201837, 37, 1, N'2018-W37', N'2018-W37-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97042, CAST(N'2018-09-11' AS date), CAST(N'2018-09-12' AS date), 2018, 20183, 201809, 2018254, 3, 9, 254, 11, 3, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-05' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-07' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-14' AS date), 1062, 3188, 13862, 13863, 13863, 13862, 13862, 13862, 13862, 2458373, 58372, N'2018-09-11', 201837, 37, 2, N'2018-W37', N'2018-W37-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97043, CAST(N'2018-09-12' AS date), CAST(N'2018-09-13' AS date), 2018, 20183, 201809, 2018255, 3, 9, 255, 12, 4, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-06' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-07' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-14' AS date), 1062, 3188, 13862, 13863, 13863, 13863, 13862, 13862, 13862, 2458374, 58373, N'2018-09-12', 201837, 37, 3, N'2018-W37', N'2018-W37-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97044, CAST(N'2018-09-13' AS date), CAST(N'2018-09-14' AS date), 2018, 20183, 201809, 2018256, 3, 9, 256, 13, 5, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-07' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-14' AS date), 1062, 3188, 13862, 13863, 13863, 13863, 13863, 13862, 13862, 2458375, 58374, N'2018-09-13', 201837, 37, 4, N'2018-W37', N'2018-W37-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97045, CAST(N'2018-09-14' AS date), CAST(N'2018-09-15' AS date), 2018, 20183, 201809, 2018257, 3, 9, 257, 14, 6, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-14' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-08' AS date), CAST(N'2018-09-14' AS date), 1062, 3188, 13862, 13863, 13863, 13863, 13863, 13863, 13862, 2458376, 58375, N'2018-09-14', 201837, 37, 5, N'2018-W37', N'2018-W37-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97046, CAST(N'2018-09-15' AS date), CAST(N'2018-09-16' AS date), 2018, 20183, 201809, 2018258, 3, 9, 258, 15, 7, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-09' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-14' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-21' AS date), 1062, 3188, 13862, 13863, 13863, 13863, 13863, 13863, 13863, 2458377, 58376, N'2018-09-15', 201837, 37, 6, N'2018-W37', N'2018-W37-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97047, CAST(N'2018-09-16' AS date), CAST(N'2018-09-17' AS date), 2018, 20183, 201809, 2018259, 3, 9, 259, 16, 1, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-10' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-14' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-21' AS date), 1062, 3188, 13863, 13863, 13863, 13863, 13863, 13863, 13863, 2458378, 58377, N'2018-09-16', 201837, 37, 7, N'2018-W37', N'2018-W37-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97048, CAST(N'2018-09-17' AS date), CAST(N'2018-09-18' AS date), 2018, 20183, 201809, 2018260, 3, 9, 260, 17, 2, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-11' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-14' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-21' AS date), 1062, 3188, 13863, 13864, 13863, 13863, 13863, 13863, 13863, 2458379, 58378, N'2018-09-17', 201838, 38, 1, N'2018-W38', N'2018-W38-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97049, CAST(N'2018-09-18' AS date), CAST(N'2018-09-19' AS date), 2018, 20183, 201809, 2018261, 3, 9, 261, 18, 3, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-12' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-14' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-21' AS date), 1062, 3188, 13863, 13864, 13864, 13863, 13863, 13863, 13863, 2458380, 58379, N'2018-09-18', 201838, 38, 2, N'2018-W38', N'2018-W38-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97050, CAST(N'2018-09-19' AS date), CAST(N'2018-09-20' AS date), 2018, 20183, 201809, 2018262, 3, 9, 262, 19, 4, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-09-13' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-14' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-21' AS date), 1062, 3188, 13863, 13864, 13864, 13864, 13863, 13863, 13863, 2458381, 58380, N'2018-09-19', 201838, 38, 3, N'2018-W38', N'2018-W38-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97051, CAST(N'2018-09-20' AS date), CAST(N'2018-09-21' AS date), 2018, 20183, 201809, 2018263, 3, 9, 263, 20, 5, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-09-14' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-21' AS date), 1062, 3188, 13863, 13864, 13864, 13864, 13864, 13863, 13863, 2458382, 58381, N'2018-09-20', 201838, 38, 4, N'2018-W38', N'2018-W38-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97052, CAST(N'2018-09-21' AS date), CAST(N'2018-09-22' AS date), 2018, 20183, 201809, 2018264, 3, 9, 264, 21, 6, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-09-21' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-09-15' AS date), CAST(N'2018-09-21' AS date), 1062, 3188, 13863, 13864, 13864, 13864, 13864, 13864, 13863, 2458383, 58382, N'2018-09-21', 201838, 38, 5, N'2018-W38', N'2018-W38-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97053, CAST(N'2018-09-22' AS date), CAST(N'2018-09-23' AS date), 2018, 20183, 201809, 2018265, 3, 9, 265, 22, 7, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-16' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-09-21' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-28' AS date), 1062, 3188, 13863, 13864, 13864, 13864, 13864, 13864, 13864, 2458384, 58383, N'2018-09-22', 201838, 38, 6, N'2018-W38', N'2018-W38-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97054, CAST(N'2018-09-23' AS date), CAST(N'2018-09-24' AS date), 2018, 20183, 201809, 2018266, 3, 9, 266, 23, 1, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-09-17' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-09-21' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-28' AS date), 1062, 3188, 13864, 13864, 13864, 13864, 13864, 13864, 13864, 2458385, 58384, N'2018-09-23', 201838, 38, 7, N'2018-W38', N'2018-W38-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97055, CAST(N'2018-09-24' AS date), CAST(N'2018-09-25' AS date), 2018, 20183, 201809, 2018267, 3, 9, 267, 24, 2, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-18' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-09-21' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-28' AS date), 1062, 3188, 13864, 13865, 13864, 13864, 13864, 13864, 13864, 2458386, 58385, N'2018-09-24', 201839, 39, 1, N'2018-W39', N'2018-W39-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97056, CAST(N'2018-09-25' AS date), CAST(N'2018-09-26' AS date), 2018, 20183, 201809, 2018268, 3, 9, 268, 25, 3, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-09-19' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-09-21' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-28' AS date), 1062, 3188, 13864, 13865, 13865, 13864, 13864, 13864, 13864, 2458387, 58386, N'2018-09-25', 201839, 39, 2, N'2018-W39', N'2018-W39-2');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97057, CAST(N'2018-09-26' AS date), CAST(N'2018-09-27' AS date), 2018, 20183, 201809, 2018269, 3, 9, 269, 26, 4, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-09-20' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-09-21' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-28' AS date), 1062, 3188, 13864, 13865, 13865, 13865, 13864, 13864, 13864, 2458388, 58387, N'2018-09-26', 201839, 39, 3, N'2018-W39', N'2018-W39-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97058, CAST(N'2018-09-27' AS date), CAST(N'2018-09-28' AS date), 2018, 20183, 201809, 2018270, 3, 9, 270, 27, 5, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-09-21' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-28' AS date), 1062, 3188, 13864, 13865, 13865, 13865, 13865, 13864, 13864, 2458389, 58388, N'2018-09-27', 201839, 39, 4, N'2018-W39', N'2018-W39-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97059, CAST(N'2018-09-28' AS date), CAST(N'2018-09-29' AS date), 2018, 20183, 201809, 2018271, 3, 9, 271, 28, 6, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-09-28' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-09-22' AS date), CAST(N'2018-09-28' AS date), 1062, 3188, 13864, 13865, 13865, 13865, 13865, 13865, 13864, 2458390, 58389, N'2018-09-28', 201839, 39, 5, N'2018-W39', N'2018-W39-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97060, CAST(N'2018-09-29' AS date), CAST(N'2018-09-30' AS date), 2018, 20183, 201809, 2018272, 3, 9, 272, 29, 7, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-23' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-09-28' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-10-05' AS date), 1062, 3188, 13864, 13865, 13865, 13865, 13865, 13865, 13865, 2458391, 58390, N'2018-09-29', 201839, 39, 6, N'2018-W39', N'2018-W39-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97061, CAST(N'2018-09-30' AS date), CAST(N'2018-10-01' AS date), 2018, 20183, 201809, 2018273, 3, 9, 273, 30, 1, N'2018', N'2018 Q3', N'2018 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-07-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-01' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-09-24' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-09-28' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-10-05' AS date), 1062, 3188, 13865, 13865, 13865, 13865, 13865, 13865, 13865, 2458392, 58391, N'2018-09-30', 201839, 39, 7, N'2018-W39', N'2018-W39-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97062, CAST(N'2018-10-01' AS date), CAST(N'2018-10-02' AS date), 2018, 20184, 201810, 2018274, 4, 10, 274, 1, 2, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-09-25' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-09-28' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-10-05' AS date), 1063, 3189, 13865, 13866, 13865, 13865, 13865, 13865, 13865, 2458393, 58392, N'2018-10-01', 201840, 40, 1, N'2018-W40', N'2018-W40-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97063, CAST(N'2018-10-02' AS date), CAST(N'2018-10-03' AS date), 2018, 20184, 201810, 2018275, 4, 10, 275, 2, 3, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-09-26' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-09-28' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-10-05' AS date), 1063, 3189, 13865, 13866, 13866, 13865, 13865, 13865, 13865, 2458394, 58393, N'2018-10-02', 201840, 40, 2, N'2018-W40', N'2018-W40-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97064, CAST(N'2018-10-03' AS date), CAST(N'2018-10-04' AS date), 2018, 20184, 201810, 2018276, 4, 10, 276, 3, 4, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-09-27' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-09-28' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-10-05' AS date), 1063, 3189, 13865, 13866, 13866, 13866, 13865, 13865, 13865, 2458395, 58394, N'2018-10-03', 201840, 40, 3, N'2018-W40', N'2018-W40-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97065, CAST(N'2018-10-04' AS date), CAST(N'2018-10-05' AS date), 2018, 20184, 201810, 2018277, 4, 10, 277, 4, 5, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-09-28' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-10-05' AS date), 1063, 3189, 13865, 13866, 13866, 13866, 13866, 13865, 13865, 2458396, 58395, N'2018-10-04', 201840, 40, 4, N'2018-W40', N'2018-W40-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97066, CAST(N'2018-10-05' AS date), CAST(N'2018-10-06' AS date), 2018, 20184, 201810, 2018278, 4, 10, 278, 5, 6, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-05' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-09-29' AS date), CAST(N'2018-10-05' AS date), 1063, 3189, 13865, 13866, 13866, 13866, 13866, 13866, 13865, 2458397, 58396, N'2018-10-05', 201840, 40, 5, N'2018-W40', N'2018-W40-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97067, CAST(N'2018-10-06' AS date), CAST(N'2018-10-07' AS date), 2018, 20184, 201810, 2018279, 4, 10, 279, 6, 7, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-09-30' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-05' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-12' AS date), 1063, 3189, 13865, 13866, 13866, 13866, 13866, 13866, 13866, 2458398, 58397, N'2018-10-06', 201840, 40, 6, N'2018-W40', N'2018-W40-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97068, CAST(N'2018-10-07' AS date), CAST(N'2018-10-08' AS date), 2018, 20184, 201810, 2018280, 4, 10, 280, 7, 1, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-05' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-12' AS date), 1063, 3189, 13866, 13866, 13866, 13866, 13866, 13866, 13866, 2458399, 58398, N'2018-10-07', 201840, 40, 7, N'2018-W40', N'2018-W40-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97069, CAST(N'2018-10-08' AS date), CAST(N'2018-10-09' AS date), 2018, 20184, 201810, 2018281, 4, 10, 281, 8, 2, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-02' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-05' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-12' AS date), 1063, 3189, 13866, 13867, 13866, 13866, 13866, 13866, 13866, 2458400, 58399, N'2018-10-08', 201841, 41, 1, N'2018-W41', N'2018-W41-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97070, CAST(N'2018-10-09' AS date), CAST(N'2018-10-10' AS date), 2018, 20184, 201810, 2018282, 4, 10, 282, 9, 3, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-03' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-05' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-12' AS date), 1063, 3189, 13866, 13867, 13867, 13866, 13866, 13866, 13866, 2458401, 58400, N'2018-10-09', 201841, 41, 2, N'2018-W41', N'2018-W41-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97071, CAST(N'2018-10-10' AS date), CAST(N'2018-10-11' AS date), 2018, 20184, 201810, 2018283, 4, 10, 283, 10, 4, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-04' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-05' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-12' AS date), 1063, 3189, 13866, 13867, 13867, 13867, 13866, 13866, 13866, 2458402, 58401, N'2018-10-10', 201841, 41, 3, N'2018-W41', N'2018-W41-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97072, CAST(N'2018-10-11' AS date), CAST(N'2018-10-12' AS date), 2018, 20184, 201810, 2018284, 4, 10, 284, 11, 5, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-05' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-12' AS date), 1063, 3189, 13866, 13867, 13867, 13867, 13867, 13866, 13866, 2458403, 58402, N'2018-10-11', 201841, 41, 4, N'2018-W41', N'2018-W41-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97073, CAST(N'2018-10-12' AS date), CAST(N'2018-10-13' AS date), 2018, 20184, 201810, 2018285, 4, 10, 285, 12, 6, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-12' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-06' AS date), CAST(N'2018-10-12' AS date), 1063, 3189, 13866, 13867, 13867, 13867, 13867, 13867, 13866, 2458404, 58403, N'2018-10-12', 201841, 41, 5, N'2018-W41', N'2018-W41-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97074, CAST(N'2018-10-13' AS date), CAST(N'2018-10-14' AS date), 2018, 20184, 201810, 2018286, 4, 10, 286, 13, 7, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-07' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-12' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-19' AS date), 1063, 3189, 13866, 13867, 13867, 13867, 13867, 13867, 13867, 2458405, 58404, N'2018-10-13', 201841, 41, 6, N'2018-W41', N'2018-W41-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97075, CAST(N'2018-10-14' AS date), CAST(N'2018-10-15' AS date), 2018, 20184, 201810, 2018287, 4, 10, 287, 14, 1, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-08' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-12' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-19' AS date), 1063, 3189, 13867, 13867, 13867, 13867, 13867, 13867, 13867, 2458406, 58405, N'2018-10-14', 201841, 41, 7, N'2018-W41', N'2018-W41-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97076, CAST(N'2018-10-15' AS date), CAST(N'2018-10-16' AS date), 2018, 20184, 201810, 2018288, 4, 10, 288, 15, 2, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-09' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-12' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-19' AS date), 1063, 3189, 13867, 13868, 13867, 13867, 13867, 13867, 13867, 2458407, 58406, N'2018-10-15', 201842, 42, 1, N'2018-W42', N'2018-W42-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97077, CAST(N'2018-10-16' AS date), CAST(N'2018-10-17' AS date), 2018, 20184, 201810, 2018289, 4, 10, 289, 16, 3, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-10' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-12' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-19' AS date), 1063, 3189, 13867, 13868, 13868, 13867, 13867, 13867, 13867, 2458408, 58407, N'2018-10-16', 201842, 42, 2, N'2018-W42', N'2018-W42-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97078, CAST(N'2018-10-17' AS date), CAST(N'2018-10-18' AS date), 2018, 20184, 201810, 2018290, 4, 10, 290, 17, 4, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-11' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-12' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-19' AS date), 1063, 3189, 13867, 13868, 13868, 13868, 13867, 13867, 13867, 2458409, 58408, N'2018-10-17', 201842, 42, 3, N'2018-W42', N'2018-W42-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97079, CAST(N'2018-10-18' AS date), CAST(N'2018-10-19' AS date), 2018, 20184, 201810, 2018291, 4, 10, 291, 18, 5, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-12' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-19' AS date), 1063, 3189, 13867, 13868, 13868, 13868, 13868, 13867, 13867, 2458410, 58409, N'2018-10-18', 201842, 42, 4, N'2018-W42', N'2018-W42-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97080, CAST(N'2018-10-19' AS date), CAST(N'2018-10-20' AS date), 2018, 20184, 201810, 2018292, 4, 10, 292, 19, 6, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-19' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-13' AS date), CAST(N'2018-10-19' AS date), 1063, 3189, 13867, 13868, 13868, 13868, 13868, 13868, 13867, 2458411, 58410, N'2018-10-19', 201842, 42, 5, N'2018-W42', N'2018-W42-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97081, CAST(N'2018-10-20' AS date), CAST(N'2018-10-21' AS date), 2018, 20184, 201810, 2018293, 4, 10, 293, 20, 7, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-14' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-19' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-26' AS date), 1063, 3189, 13867, 13868, 13868, 13868, 13868, 13868, 13868, 2458412, 58411, N'2018-10-20', 201842, 42, 6, N'2018-W42', N'2018-W42-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97082, CAST(N'2018-10-21' AS date), CAST(N'2018-10-22' AS date), 2018, 20184, 201810, 2018294, 4, 10, 294, 21, 1, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-10-15' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-19' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-26' AS date), 1063, 3189, 13868, 13868, 13868, 13868, 13868, 13868, 13868, 2458413, 58412, N'2018-10-21', 201842, 42, 7, N'2018-W42', N'2018-W42-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97083, CAST(N'2018-10-22' AS date), CAST(N'2018-10-23' AS date), 2018, 20184, 201810, 2018295, 4, 10, 295, 22, 2, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-10-16' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-19' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-26' AS date), 1063, 3189, 13868, 13869, 13868, 13868, 13868, 13868, 13868, 2458414, 58413, N'2018-10-22', 201843, 43, 1, N'2018-W43', N'2018-W43-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97084, CAST(N'2018-10-23' AS date), CAST(N'2018-10-24' AS date), 2018, 20184, 201810, 2018296, 4, 10, 296, 23, 3, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-10-17' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-19' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-26' AS date), 1063, 3189, 13868, 13869, 13869, 13868, 13868, 13868, 13868, 2458415, 58414, N'2018-10-23', 201843, 43, 2, N'2018-W43', N'2018-W43-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97085, CAST(N'2018-10-24' AS date), CAST(N'2018-10-25' AS date), 2018, 20184, 201810, 2018297, 4, 10, 297, 24, 4, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-10-18' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-19' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-26' AS date), 1063, 3189, 13868, 13869, 13869, 13869, 13868, 13868, 13868, 2458416, 58415, N'2018-10-24', 201843, 43, 3, N'2018-W43', N'2018-W43-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97086, CAST(N'2018-10-25' AS date), CAST(N'2018-10-26' AS date), 2018, 20184, 201810, 2018298, 4, 10, 298, 25, 5, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-19' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-26' AS date), 1063, 3189, 13868, 13869, 13869, 13869, 13869, 13868, 13868, 2458417, 58416, N'2018-10-25', 201843, 43, 4, N'2018-W43', N'2018-W43-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97087, CAST(N'2018-10-26' AS date), CAST(N'2018-10-27' AS date), 2018, 20184, 201810, 2018299, 4, 10, 299, 26, 6, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-26' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-10-20' AS date), CAST(N'2018-10-26' AS date), 1063, 3189, 13868, 13869, 13869, 13869, 13869, 13869, 13868, 2458418, 58417, N'2018-10-26', 201843, 43, 5, N'2018-W43', N'2018-W43-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97088, CAST(N'2018-10-27' AS date), CAST(N'2018-10-28' AS date), 2018, 20184, 201810, 2018300, 4, 10, 300, 27, 7, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-21' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-26' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-11-02' AS date), 1063, 3189, 13868, 13869, 13869, 13869, 13869, 13869, 13869, 2458419, 58418, N'2018-10-27', 201843, 43, 6, N'2018-W43', N'2018-W43-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97089, CAST(N'2018-10-28' AS date), CAST(N'2018-10-29' AS date), 2018, 20184, 201810, 2018301, 4, 10, 301, 28, 1, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-10-22' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-26' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-11-02' AS date), 1063, 3189, 13869, 13869, 13869, 13869, 13869, 13869, 13869, 2458420, 58419, N'2018-10-28', 201843, 43, 7, N'2018-W43', N'2018-W43-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97090, CAST(N'2018-10-29' AS date), CAST(N'2018-10-30' AS date), 2018, 20184, 201810, 2018302, 4, 10, 302, 29, 2, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-10-23' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-26' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-11-02' AS date), 1063, 3189, 13869, 13870, 13869, 13869, 13869, 13869, 13869, 2458421, 58420, N'2018-10-29', 201844, 44, 1, N'2018-W44', N'2018-W44-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97091, CAST(N'2018-10-30' AS date), CAST(N'2018-10-31' AS date), 2018, 20184, 201810, 2018303, 4, 10, 303, 30, 3, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-10-24' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-26' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-11-02' AS date), 1063, 3189, 13869, 13870, 13870, 13869, 13869, 13869, 13869, 2458422, 58421, N'2018-10-30', 201844, 44, 2, N'2018-W44', N'2018-W44-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97092, CAST(N'2018-10-31' AS date), CAST(N'2018-11-01' AS date), 2018, 20184, 201810, 2018304, 4, 10, 304, 31, 4, N'2018', N'2018 Q4', N'2018 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-10-25' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-10-26' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-11-02' AS date), 1063, 3189, 13869, 13870, 13870, 13870, 13869, 13869, 13869, 2458423, 58422, N'2018-10-31', 201844, 44, 3, N'2018-W44', N'2018-W44-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97093, CAST(N'2018-11-01' AS date), CAST(N'2018-11-02' AS date), 2018, 20184, 201811, 2018305, 4, 11, 305, 1, 5, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-10-26' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-11-02' AS date), 1063, 3190, 13869, 13870, 13870, 13870, 13870, 13869, 13869, 2458424, 58423, N'2018-11-01', 201844, 44, 4, N'2018-W44', N'2018-W44-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97094, CAST(N'2018-11-02' AS date), CAST(N'2018-11-03' AS date), 2018, 20184, 201811, 2018306, 4, 11, 306, 2, 6, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-02' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-10-27' AS date), CAST(N'2018-11-02' AS date), 1063, 3190, 13869, 13870, 13870, 13870, 13870, 13870, 13869, 2458425, 58424, N'2018-11-02', 201844, 44, 5, N'2018-W44', N'2018-W44-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97095, CAST(N'2018-11-03' AS date), CAST(N'2018-11-04' AS date), 2018, 20184, 201811, 2018307, 4, 11, 307, 3, 7, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-10-28' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-02' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-11-09' AS date), 1063, 3190, 13869, 13870, 13870, 13870, 13870, 13870, 13870, 2458426, 58425, N'2018-11-03', 201844, 44, 6, N'2018-W44', N'2018-W44-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97096, CAST(N'2018-11-04' AS date), CAST(N'2018-11-05' AS date), 2018, 20184, 201811, 2018308, 4, 11, 308, 4, 1, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-10-29' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-02' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-11-09' AS date), 1063, 3190, 13870, 13870, 13870, 13870, 13870, 13870, 13870, 2458427, 58426, N'2018-11-04', 201844, 44, 7, N'2018-W44', N'2018-W44-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97097, CAST(N'2018-11-05' AS date), CAST(N'2018-11-06' AS date), 2018, 20184, 201811, 2018309, 4, 11, 309, 5, 2, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-10-30' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-02' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-11-09' AS date), 1063, 3190, 13870, 13871, 13870, 13870, 13870, 13870, 13870, 2458428, 58427, N'2018-11-05', 201845, 45, 1, N'2018-W45', N'2018-W45-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97098, CAST(N'2018-11-06' AS date), CAST(N'2018-11-07' AS date), 2018, 20184, 201811, 2018310, 4, 11, 310, 6, 3, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-10-31' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-02' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-11-09' AS date), 1063, 3190, 13870, 13871, 13871, 13870, 13870, 13870, 13870, 2458429, 58428, N'2018-11-06', 201845, 45, 2, N'2018-W45', N'2018-W45-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97099, CAST(N'2018-11-07' AS date), CAST(N'2018-11-08' AS date), 2018, 20184, 201811, 2018311, 4, 11, 311, 7, 4, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-02' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-11-09' AS date), 1063, 3190, 13870, 13871, 13871, 13871, 13870, 13870, 13870, 2458430, 58429, N'2018-11-07', 201845, 45, 3, N'2018-W45', N'2018-W45-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97100, CAST(N'2018-11-08' AS date), CAST(N'2018-11-09' AS date), 2018, 20184, 201811, 2018312, 4, 11, 312, 8, 5, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-02' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-11-09' AS date), 1063, 3190, 13870, 13871, 13871, 13871, 13871, 13870, 13870, 2458431, 58430, N'2018-11-08', 201845, 45, 4, N'2018-W45', N'2018-W45-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97101, CAST(N'2018-11-09' AS date), CAST(N'2018-11-10' AS date), 2018, 20184, 201811, 2018313, 4, 11, 313, 9, 6, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-09' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-03' AS date), CAST(N'2018-11-09' AS date), 1063, 3190, 13870, 13871, 13871, 13871, 13871, 13871, 13870, 2458432, 58431, N'2018-11-09', 201845, 45, 5, N'2018-W45', N'2018-W45-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97102, CAST(N'2018-11-10' AS date), CAST(N'2018-11-11' AS date), 2018, 20184, 201811, 2018314, 4, 11, 314, 10, 7, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-04' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-09' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-16' AS date), 1063, 3190, 13870, 13871, 13871, 13871, 13871, 13871, 13871, 2458433, 58432, N'2018-11-10', 201845, 45, 6, N'2018-W45', N'2018-W45-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97103, CAST(N'2018-11-11' AS date), CAST(N'2018-11-12' AS date), 2018, 20184, 201811, 2018315, 4, 11, 315, 11, 1, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-05' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-09' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-16' AS date), 1063, 3190, 13871, 13871, 13871, 13871, 13871, 13871, 13871, 2458434, 58433, N'2018-11-11', 201845, 45, 7, N'2018-W45', N'2018-W45-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97104, CAST(N'2018-11-12' AS date), CAST(N'2018-11-13' AS date), 2018, 20184, 201811, 2018316, 4, 11, 316, 12, 2, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-06' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-09' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-16' AS date), 1063, 3190, 13871, 13872, 13871, 13871, 13871, 13871, 13871, 2458435, 58434, N'2018-11-12', 201846, 46, 1, N'2018-W46', N'2018-W46-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97105, CAST(N'2018-11-13' AS date), CAST(N'2018-11-14' AS date), 2018, 20184, 201811, 2018317, 4, 11, 317, 13, 3, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-07' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-09' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-16' AS date), 1063, 3190, 13871, 13872, 13872, 13871, 13871, 13871, 13871, 2458436, 58435, N'2018-11-13', 201846, 46, 2, N'2018-W46', N'2018-W46-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97106, CAST(N'2018-11-14' AS date), CAST(N'2018-11-15' AS date), 2018, 20184, 201811, 2018318, 4, 11, 318, 14, 4, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-08' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-09' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-16' AS date), 1063, 3190, 13871, 13872, 13872, 13872, 13871, 13871, 13871, 2458437, 58436, N'2018-11-14', 201846, 46, 3, N'2018-W46', N'2018-W46-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97107, CAST(N'2018-11-15' AS date), CAST(N'2018-11-16' AS date), 2018, 20184, 201811, 2018319, 4, 11, 319, 15, 5, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-09' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-16' AS date), 1063, 3190, 13871, 13872, 13872, 13872, 13872, 13871, 13871, 2458438, 58437, N'2018-11-15', 201846, 46, 4, N'2018-W46', N'2018-W46-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97108, CAST(N'2018-11-16' AS date), CAST(N'2018-11-17' AS date), 2018, 20184, 201811, 2018320, 4, 11, 320, 16, 6, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-16' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-10' AS date), CAST(N'2018-11-16' AS date), 1063, 3190, 13871, 13872, 13872, 13872, 13872, 13872, 13871, 2458439, 58438, N'2018-11-16', 201846, 46, 5, N'2018-W46', N'2018-W46-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97109, CAST(N'2018-11-17' AS date), CAST(N'2018-11-18' AS date), 2018, 20184, 201811, 2018321, 4, 11, 321, 17, 7, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-11' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-16' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-23' AS date), 1063, 3190, 13871, 13872, 13872, 13872, 13872, 13872, 13872, 2458440, 58439, N'2018-11-17', 201846, 46, 6, N'2018-W46', N'2018-W46-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97110, CAST(N'2018-11-18' AS date), CAST(N'2018-11-19' AS date), 2018, 20184, 201811, 2018322, 4, 11, 322, 18, 1, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-12' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-16' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-23' AS date), 1063, 3190, 13872, 13872, 13872, 13872, 13872, 13872, 13872, 2458441, 58440, N'2018-11-18', 201846, 46, 7, N'2018-W46', N'2018-W46-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97111, CAST(N'2018-11-19' AS date), CAST(N'2018-11-20' AS date), 2018, 20184, 201811, 2018323, 4, 11, 323, 19, 2, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-11-13' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-16' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-23' AS date), 1063, 3190, 13872, 13873, 13872, 13872, 13872, 13872, 13872, 2458442, 58441, N'2018-11-19', 201847, 47, 1, N'2018-W47', N'2018-W47-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97112, CAST(N'2018-11-20' AS date), CAST(N'2018-11-21' AS date), 2018, 20184, 201811, 2018324, 4, 11, 324, 20, 3, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-11-14' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-16' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-23' AS date), 1063, 3190, 13872, 13873, 13873, 13872, 13872, 13872, 13872, 2458443, 58442, N'2018-11-20', 201847, 47, 2, N'2018-W47', N'2018-W47-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97113, CAST(N'2018-11-21' AS date), CAST(N'2018-11-22' AS date), 2018, 20184, 201811, 2018325, 4, 11, 325, 21, 4, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-11-15' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-16' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-23' AS date), 1063, 3190, 13872, 13873, 13873, 13873, 13872, 13872, 13872, 2458444, 58443, N'2018-11-21', 201847, 47, 3, N'2018-W47', N'2018-W47-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97114, CAST(N'2018-11-22' AS date), CAST(N'2018-11-23' AS date), 2018, 20184, 201811, 2018326, 4, 11, 326, 22, 5, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-11-16' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-23' AS date), 1063, 3190, 13872, 13873, 13873, 13873, 13873, 13872, 13872, 2458445, 58444, N'2018-11-22', 201847, 47, 4, N'2018-W47', N'2018-W47-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97115, CAST(N'2018-11-23' AS date), CAST(N'2018-11-24' AS date), 2018, 20184, 201811, 2018327, 4, 11, 327, 23, 6, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-11-23' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-11-17' AS date), CAST(N'2018-11-23' AS date), 1063, 3190, 13872, 13873, 13873, 13873, 13873, 13873, 13872, 2458446, 58445, N'2018-11-23', 201847, 47, 5, N'2018-W47', N'2018-W47-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97116, CAST(N'2018-11-24' AS date), CAST(N'2018-11-25' AS date), 2018, 20184, 201811, 2018328, 4, 11, 328, 24, 7, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-18' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-11-23' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-30' AS date), 1063, 3190, 13872, 13873, 13873, 13873, 13873, 13873, 13873, 2458447, 58446, N'2018-11-24', 201847, 47, 6, N'2018-W47', N'2018-W47-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97117, CAST(N'2018-11-25' AS date), CAST(N'2018-11-26' AS date), 2018, 20184, 201811, 2018329, 4, 11, 329, 25, 1, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-11-19' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-11-23' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-30' AS date), 1063, 3190, 13873, 13873, 13873, 13873, 13873, 13873, 13873, 2458448, 58447, N'2018-11-25', 201847, 47, 7, N'2018-W47', N'2018-W47-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97118, CAST(N'2018-11-26' AS date), CAST(N'2018-11-27' AS date), 2018, 20184, 201811, 2018330, 4, 11, 330, 26, 2, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-11-20' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-11-23' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-30' AS date), 1063, 3190, 13873, 13874, 13873, 13873, 13873, 13873, 13873, 2458449, 58448, N'2018-11-26', 201848, 48, 1, N'2018-W48', N'2018-W48-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97119, CAST(N'2018-11-27' AS date), CAST(N'2018-11-28' AS date), 2018, 20184, 201811, 2018331, 4, 11, 331, 27, 3, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-11-21' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-11-23' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-30' AS date), 1063, 3190, 13873, 13874, 13874, 13873, 13873, 13873, 13873, 2458450, 58449, N'2018-11-27', 201848, 48, 2, N'2018-W48', N'2018-W48-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97120, CAST(N'2018-11-28' AS date), CAST(N'2018-11-29' AS date), 2018, 20184, 201811, 2018332, 4, 11, 332, 28, 4, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-11-22' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-11-23' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-30' AS date), 1063, 3190, 13873, 13874, 13874, 13874, 13873, 13873, 13873, 2458451, 58450, N'2018-11-28', 201848, 48, 3, N'2018-W48', N'2018-W48-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97121, CAST(N'2018-11-29' AS date), CAST(N'2018-11-30' AS date), 2018, 20184, 201811, 2018333, 4, 11, 333, 29, 5, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-11-23' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-30' AS date), 1063, 3190, 13873, 13874, 13874, 13874, 13874, 13873, 13873, 2458452, 58451, N'2018-11-29', 201848, 48, 4, N'2018-W48', N'2018-W48-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97122, CAST(N'2018-11-30' AS date), CAST(N'2018-12-01' AS date), 2018, 20184, 201811, 2018334, 4, 11, 334, 30, 6, N'2018', N'2018 Q4', N'2018 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-01' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-11-24' AS date), CAST(N'2018-11-30' AS date), 1063, 3190, 13873, 13874, 13874, 13874, 13874, 13874, 13873, 2458453, 58452, N'2018-11-30', 201848, 48, 5, N'2018-W48', N'2018-W48-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97123, CAST(N'2018-12-01' AS date), CAST(N'2018-12-02' AS date), 2018, 20184, 201812, 2018335, 4, 12, 335, 1, 7, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-11-25' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-07' AS date), 1063, 3191, 13873, 13874, 13874, 13874, 13874, 13874, 13874, 2458454, 58453, N'2018-12-01', 201848, 48, 6, N'2018-W48', N'2018-W48-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97124, CAST(N'2018-12-02' AS date), CAST(N'2018-12-03' AS date), 2018, 20184, 201812, 2018336, 4, 12, 336, 2, 1, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-11-26' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-07' AS date), 1063, 3191, 13874, 13874, 13874, 13874, 13874, 13874, 13874, 2458455, 58454, N'2018-12-02', 201848, 48, 7, N'2018-W48', N'2018-W48-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97125, CAST(N'2018-12-03' AS date), CAST(N'2018-12-04' AS date), 2018, 20184, 201812, 2018337, 4, 12, 337, 3, 2, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-11-27' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-07' AS date), 1063, 3191, 13874, 13875, 13874, 13874, 13874, 13874, 13874, 2458456, 58455, N'2018-12-03', 201849, 49, 1, N'2018-W49', N'2018-W49-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97126, CAST(N'2018-12-04' AS date), CAST(N'2018-12-05' AS date), 2018, 20184, 201812, 2018338, 4, 12, 338, 4, 3, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-11-28' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-07' AS date), 1063, 3191, 13874, 13875, 13875, 13874, 13874, 13874, 13874, 2458457, 58456, N'2018-12-04', 201849, 49, 2, N'2018-W49', N'2018-W49-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97127, CAST(N'2018-12-05' AS date), CAST(N'2018-12-06' AS date), 2018, 20184, 201812, 2018339, 4, 12, 339, 5, 4, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-11-29' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-07' AS date), 1063, 3191, 13874, 13875, 13875, 13875, 13874, 13874, 13874, 2458458, 58457, N'2018-12-05', 201849, 49, 3, N'2018-W49', N'2018-W49-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97128, CAST(N'2018-12-06' AS date), CAST(N'2018-12-07' AS date), 2018, 20184, 201812, 2018340, 4, 12, 340, 6, 5, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-11-30' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-07' AS date), 1063, 3191, 13874, 13875, 13875, 13875, 13875, 13874, 13874, 2458459, 58458, N'2018-12-06', 201849, 49, 4, N'2018-W49', N'2018-W49-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97129, CAST(N'2018-12-07' AS date), CAST(N'2018-12-08' AS date), 2018, 20184, 201812, 2018341, 4, 12, 341, 7, 6, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-07' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-07' AS date), 1063, 3191, 13874, 13875, 13875, 13875, 13875, 13875, 13874, 2458460, 58459, N'2018-12-07', 201849, 49, 5, N'2018-W49', N'2018-W49-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97130, CAST(N'2018-12-08' AS date), CAST(N'2018-12-09' AS date), 2018, 20184, 201812, 2018342, 4, 12, 342, 8, 7, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-02' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-07' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-14' AS date), 1063, 3191, 13874, 13875, 13875, 13875, 13875, 13875, 13875, 2458461, 58460, N'2018-12-08', 201849, 49, 6, N'2018-W49', N'2018-W49-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97131, CAST(N'2018-12-09' AS date), CAST(N'2018-12-10' AS date), 2018, 20184, 201812, 2018343, 4, 12, 343, 9, 1, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-03' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-07' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-14' AS date), 1063, 3191, 13875, 13875, 13875, 13875, 13875, 13875, 13875, 2458462, 58461, N'2018-12-09', 201849, 49, 7, N'2018-W49', N'2018-W49-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97132, CAST(N'2018-12-10' AS date), CAST(N'2018-12-11' AS date), 2018, 20184, 201812, 2018344, 4, 12, 344, 10, 2, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-04' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-07' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-14' AS date), 1063, 3191, 13875, 13876, 13875, 13875, 13875, 13875, 13875, 2458463, 58462, N'2018-12-10', 201850, 50, 1, N'2018-W50', N'2018-W50-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97133, CAST(N'2018-12-11' AS date), CAST(N'2018-12-12' AS date), 2018, 20184, 201812, 2018345, 4, 12, 345, 11, 3, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-05' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-07' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-14' AS date), 1063, 3191, 13875, 13876, 13876, 13875, 13875, 13875, 13875, 2458464, 58463, N'2018-12-11', 201850, 50, 2, N'2018-W50', N'2018-W50-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97134, CAST(N'2018-12-12' AS date), CAST(N'2018-12-13' AS date), 2018, 20184, 201812, 2018346, 4, 12, 346, 12, 4, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-06' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-07' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-14' AS date), 1063, 3191, 13875, 13876, 13876, 13876, 13875, 13875, 13875, 2458465, 58464, N'2018-12-12', 201850, 50, 3, N'2018-W50', N'2018-W50-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97135, CAST(N'2018-12-13' AS date), CAST(N'2018-12-14' AS date), 2018, 20184, 201812, 2018347, 4, 12, 347, 13, 5, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-07' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-14' AS date), 1063, 3191, 13875, 13876, 13876, 13876, 13876, 13875, 13875, 2458466, 58465, N'2018-12-13', 201850, 50, 4, N'2018-W50', N'2018-W50-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97136, CAST(N'2018-12-14' AS date), CAST(N'2018-12-15' AS date), 2018, 20184, 201812, 2018348, 4, 12, 348, 14, 6, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-14' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-08' AS date), CAST(N'2018-12-14' AS date), 1063, 3191, 13875, 13876, 13876, 13876, 13876, 13876, 13875, 2458467, 58466, N'2018-12-14', 201850, 50, 5, N'2018-W50', N'2018-W50-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97137, CAST(N'2018-12-15' AS date), CAST(N'2018-12-16' AS date), 2018, 20184, 201812, 2018349, 4, 12, 349, 15, 7, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-09' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-14' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-21' AS date), 1063, 3191, 13875, 13876, 13876, 13876, 13876, 13876, 13876, 2458468, 58467, N'2018-12-15', 201850, 50, 6, N'2018-W50', N'2018-W50-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97138, CAST(N'2018-12-16' AS date), CAST(N'2018-12-17' AS date), 2018, 20184, 201812, 2018350, 4, 12, 350, 16, 1, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-10' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-14' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-21' AS date), 1063, 3191, 13876, 13876, 13876, 13876, 13876, 13876, 13876, 2458469, 58468, N'2018-12-16', 201850, 50, 7, N'2018-W50', N'2018-W50-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97139, CAST(N'2018-12-17' AS date), CAST(N'2018-12-18' AS date), 2018, 20184, 201812, 2018351, 4, 12, 351, 17, 2, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-11' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-14' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-21' AS date), 1063, 3191, 13876, 13877, 13876, 13876, 13876, 13876, 13876, 2458470, 58469, N'2018-12-17', 201851, 51, 1, N'2018-W51', N'2018-W51-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97140, CAST(N'2018-12-18' AS date), CAST(N'2018-12-19' AS date), 2018, 20184, 201812, 2018352, 4, 12, 352, 18, 3, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-12' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-14' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-21' AS date), 1063, 3191, 13876, 13877, 13877, 13876, 13876, 13876, 13876, 2458471, 58470, N'2018-12-18', 201851, 51, 2, N'2018-W51', N'2018-W51-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97141, CAST(N'2018-12-19' AS date), CAST(N'2018-12-20' AS date), 2018, 20184, 201812, 2018353, 4, 12, 353, 19, 4, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-13' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-14' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-21' AS date), 1063, 3191, 13876, 13877, 13877, 13877, 13876, 13876, 13876, 2458472, 58471, N'2018-12-19', 201851, 51, 3, N'2018-W51', N'2018-W51-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97142, CAST(N'2018-12-20' AS date), CAST(N'2018-12-21' AS date), 2018, 20184, 201812, 2018354, 4, 12, 354, 20, 5, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-26' AS date), CAST(N'2018-12-14' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-21' AS date), 1063, 3191, 13876, 13877, 13877, 13877, 13877, 13876, 13876, 2458473, 58472, N'2018-12-20', 201851, 51, 4, N'2018-W51', N'2018-W51-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97143, CAST(N'2018-12-21' AS date), CAST(N'2018-12-22' AS date), 2018, 20184, 201812, 2018355, 4, 12, 355, 21, 6, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-26' AS date), CAST(N'2018-12-21' AS date), CAST(N'2018-12-27' AS date), CAST(N'2018-12-15' AS date), CAST(N'2018-12-21' AS date), 1063, 3191, 13876, 13877, 13877, 13877, 13877, 13877, 13876, 2458474, 58473, N'2018-12-21', 201851, 51, 5, N'2018-W51', N'2018-W51-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97144, CAST(N'2018-12-22' AS date), CAST(N'2018-12-23' AS date), 2018, 20184, 201812, 2018356, 4, 12, 356, 22, 7, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-16' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-26' AS date), CAST(N'2018-12-21' AS date), CAST(N'2018-12-27' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-28' AS date), 1063, 3191, 13876, 13877, 13877, 13877, 13877, 13877, 13877, 2458475, 58474, N'2018-12-22', 201851, 51, 6, N'2018-W51', N'2018-W51-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97145, CAST(N'2018-12-23' AS date), CAST(N'2018-12-24' AS date), 2018, 20184, 201812, 2018357, 4, 12, 357, 23, 1, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-29' AS date), CAST(N'2018-12-17' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-26' AS date), CAST(N'2018-12-21' AS date), CAST(N'2018-12-27' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-28' AS date), 1063, 3191, 13877, 13877, 13877, 13877, 13877, 13877, 13877, 2458476, 58475, N'2018-12-23', 201851, 51, 7, N'2018-W51', N'2018-W51-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97146, CAST(N'2018-12-24' AS date), CAST(N'2018-12-25' AS date), 2018, 20184, 201812, 2018358, 4, 12, 358, 24, 2, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-29' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-30' AS date), CAST(N'2018-12-18' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-26' AS date), CAST(N'2018-12-21' AS date), CAST(N'2018-12-27' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-28' AS date), 1063, 3191, 13877, 13878, 13877, 13877, 13877, 13877, 13877, 2458477, 58476, N'2018-12-24', 201852, 52, 1, N'2018-W52', N'2018-W52-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97147, CAST(N'2018-12-25' AS date), CAST(N'2018-12-26' AS date), 2018, 20184, 201812, 2018359, 4, 12, 359, 25, 3, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-29' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-30' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-19' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-26' AS date), CAST(N'2018-12-21' AS date), CAST(N'2018-12-27' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-28' AS date), 1063, 3191, 13877, 13878, 13878, 13877, 13877, 13877, 13877, 2458478, 58477, N'2018-12-25', 201852, 52, 2, N'2018-W52', N'2018-W52-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97148, CAST(N'2018-12-26' AS date), CAST(N'2018-12-27' AS date), 2018, 20184, 201812, 2018360, 4, 12, 360, 26, 4, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-29' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-30' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-26' AS date), CAST(N'2019-01-01' AS date), CAST(N'2018-12-20' AS date), CAST(N'2018-12-26' AS date), CAST(N'2018-12-21' AS date), CAST(N'2018-12-27' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-28' AS date), 1063, 3191, 13877, 13878, 13878, 13878, 13877, 13877, 13877, 2458479, 58478, N'2018-12-26', 201852, 52, 3, N'2018-W52', N'2018-W52-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97149, CAST(N'2018-12-27' AS date), CAST(N'2018-12-28' AS date), 2018, 20184, 201812, 2018361, 4, 12, 361, 27, 5, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-29' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-30' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-26' AS date), CAST(N'2019-01-01' AS date), CAST(N'2018-12-27' AS date), CAST(N'2019-01-02' AS date), CAST(N'2018-12-21' AS date), CAST(N'2018-12-27' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-28' AS date), 1063, 3191, 13877, 13878, 13878, 13878, 13878, 13877, 13877, 2458480, 58479, N'2018-12-27', 201852, 52, 4, N'2018-W52', N'2018-W52-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97150, CAST(N'2018-12-28' AS date), CAST(N'2018-12-29' AS date), 2018, 20184, 201812, 2018362, 4, 12, 362, 28, 6, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-29' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-30' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-26' AS date), CAST(N'2019-01-01' AS date), CAST(N'2018-12-27' AS date), CAST(N'2019-01-02' AS date), CAST(N'2018-12-28' AS date), CAST(N'2019-01-03' AS date), CAST(N'2018-12-22' AS date), CAST(N'2018-12-28' AS date), 1063, 3191, 13877, 13878, 13878, 13878, 13878, 13878, 13877, 2458481, 58480, N'2018-12-28', 201852, 52, 5, N'2018-W52', N'2018-W52-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97151, CAST(N'2018-12-29' AS date), CAST(N'2018-12-30' AS date), 2018, 20184, 201812, 2018363, 4, 12, 363, 29, 7, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-23' AS date), CAST(N'2018-12-29' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-30' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-26' AS date), CAST(N'2019-01-01' AS date), CAST(N'2018-12-27' AS date), CAST(N'2019-01-02' AS date), CAST(N'2018-12-28' AS date), CAST(N'2019-01-03' AS date), CAST(N'2018-12-29' AS date), CAST(N'2019-01-04' AS date), 1063, 3191, 13877, 13878, 13878, 13878, 13878, 13878, 13878, 2458482, 58481, N'2018-12-29', 201852, 52, 6, N'2018-W52', N'2018-W52-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97152, CAST(N'2018-12-30' AS date), CAST(N'2018-12-31' AS date), 2018, 20184, 201812, 2018364, 4, 12, 364, 30, 1, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-30' AS date), CAST(N'2019-01-05' AS date), CAST(N'2018-12-24' AS date), CAST(N'2018-12-30' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-26' AS date), CAST(N'2019-01-01' AS date), CAST(N'2018-12-27' AS date), CAST(N'2019-01-02' AS date), CAST(N'2018-12-28' AS date), CAST(N'2019-01-03' AS date), CAST(N'2018-12-29' AS date), CAST(N'2019-01-04' AS date), 1063, 3191, 13878, 13878, 13878, 13878, 13878, 13878, 13878, 2458483, 58482, N'2018-12-30', 201852, 52, 7, N'2018-W52', N'2018-W52-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97153, CAST(N'2018-12-31' AS date), CAST(N'2019-01-01' AS date), 2018, 20184, 201812, 2018365, 4, 12, 365, 31, 2, N'2018', N'2018 Q4', N'2018 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2018-01-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-10-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-01' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-30' AS date), CAST(N'2019-01-05' AS date), CAST(N'2018-12-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2018-12-25' AS date), CAST(N'2018-12-31' AS date), CAST(N'2018-12-26' AS date), CAST(N'2019-01-01' AS date), CAST(N'2018-12-27' AS date), CAST(N'2019-01-02' AS date), CAST(N'2018-12-28' AS date), CAST(N'2019-01-03' AS date), CAST(N'2018-12-29' AS date), CAST(N'2019-01-04' AS date), 1063, 3191, 13878, 13879, 13878, 13878, 13878, 13878, 13878, 2458484, 58483, N'2018-12-31', 201901, 1, 1, N'2019-W01', N'2019-W01-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97154, CAST(N'2019-01-01' AS date), CAST(N'2019-01-02' AS date), 2019, 20191, 201901, 2019001, 1, 1, 1, 1, 3, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2018-12-30' AS date), CAST(N'2019-01-05' AS date), CAST(N'2018-12-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-07' AS date), CAST(N'2018-12-26' AS date), CAST(N'2019-01-01' AS date), CAST(N'2018-12-27' AS date), CAST(N'2019-01-02' AS date), CAST(N'2018-12-28' AS date), CAST(N'2019-01-03' AS date), CAST(N'2018-12-29' AS date), CAST(N'2019-01-04' AS date), 1064, 3192, 13878, 13879, 13879, 13878, 13878, 13878, 13878, 2458485, 58484, N'2019-01-01', 201901, 1, 2, N'2019-W01', N'2019-W01-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97155, CAST(N'2019-01-02' AS date), CAST(N'2019-01-03' AS date), 2019, 20191, 201901, 2019002, 1, 1, 2, 2, 4, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2018-12-30' AS date), CAST(N'2019-01-05' AS date), CAST(N'2018-12-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-02' AS date), CAST(N'2019-01-08' AS date), CAST(N'2018-12-27' AS date), CAST(N'2019-01-02' AS date), CAST(N'2018-12-28' AS date), CAST(N'2019-01-03' AS date), CAST(N'2018-12-29' AS date), CAST(N'2019-01-04' AS date), 1064, 3192, 13878, 13879, 13879, 13879, 13878, 13878, 13878, 2458486, 58485, N'2019-01-02', 201901, 1, 3, N'2019-W01', N'2019-W01-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97156, CAST(N'2019-01-03' AS date), CAST(N'2019-01-04' AS date), 2019, 20191, 201901, 2019003, 1, 1, 3, 3, 5, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2018-12-30' AS date), CAST(N'2019-01-05' AS date), CAST(N'2018-12-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-02' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-03' AS date), CAST(N'2019-01-09' AS date), CAST(N'2018-12-28' AS date), CAST(N'2019-01-03' AS date), CAST(N'2018-12-29' AS date), CAST(N'2019-01-04' AS date), 1064, 3192, 13878, 13879, 13879, 13879, 13879, 13878, 13878, 2458487, 58486, N'2019-01-03', 201901, 1, 4, N'2019-W01', N'2019-W01-4');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97157, CAST(N'2019-01-04' AS date), CAST(N'2019-01-05' AS date), 2019, 20191, 201901, 2019004, 1, 1, 4, 4, 6, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2018-12-30' AS date), CAST(N'2019-01-05' AS date), CAST(N'2018-12-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-02' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-03' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-04' AS date), CAST(N'2019-01-10' AS date), CAST(N'2018-12-29' AS date), CAST(N'2019-01-04' AS date), 1064, 3192, 13878, 13879, 13879, 13879, 13879, 13879, 13878, 2458488, 58487, N'2019-01-04', 201901, 1, 5, N'2019-W01', N'2019-W01-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97158, CAST(N'2019-01-05' AS date), CAST(N'2019-01-06' AS date), 2019, 20191, 201901, 2019005, 1, 1, 5, 5, 7, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2018-12-30' AS date), CAST(N'2019-01-05' AS date), CAST(N'2018-12-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-02' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-03' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-04' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-05' AS date), CAST(N'2019-01-11' AS date), 1064, 3192, 13878, 13879, 13879, 13879, 13879, 13879, 13879, 2458489, 58488, N'2019-01-05', 201901, 1, 6, N'2019-W01', N'2019-W01-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97159, CAST(N'2019-01-06' AS date), CAST(N'2019-01-07' AS date), 2019, 20191, 201901, 2019006, 1, 1, 6, 6, 1, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-12' AS date), CAST(N'2018-12-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-02' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-03' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-04' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-05' AS date), CAST(N'2019-01-11' AS date), 1064, 3192, 13879, 13879, 13879, 13879, 13879, 13879, 13879, 2458490, 58489, N'2019-01-06', 201901, 1, 7, N'2019-W01', N'2019-W01-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97160, CAST(N'2019-01-07' AS date), CAST(N'2019-01-08' AS date), 2019, 20191, 201901, 2019007, 1, 1, 7, 7, 2, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-02' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-03' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-04' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-05' AS date), CAST(N'2019-01-11' AS date), 1064, 3192, 13879, 13880, 13879, 13879, 13879, 13879, 13879, 2458491, 58490, N'2019-01-07', 201902, 2, 1, N'2019-W02', N'2019-W02-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97161, CAST(N'2019-01-08' AS date), CAST(N'2019-01-09' AS date), 2019, 20191, 201901, 2019008, 1, 1, 8, 8, 3, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-02' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-03' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-04' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-05' AS date), CAST(N'2019-01-11' AS date), 1064, 3192, 13879, 13880, 13880, 13879, 13879, 13879, 13879, 2458492, 58491, N'2019-01-08', 201902, 2, 2, N'2019-W02', N'2019-W02-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97162, CAST(N'2019-01-09' AS date), CAST(N'2019-01-10' AS date), 2019, 20191, 201901, 2019009, 1, 1, 9, 9, 4, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-03' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-04' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-05' AS date), CAST(N'2019-01-11' AS date), 1064, 3192, 13879, 13880, 13880, 13880, 13879, 13879, 13879, 2458493, 58492, N'2019-01-09', 201902, 2, 3, N'2019-W02', N'2019-W02-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97163, CAST(N'2019-01-10' AS date), CAST(N'2019-01-11' AS date), 2019, 20191, 201901, 2019010, 1, 1, 10, 10, 5, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-04' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-05' AS date), CAST(N'2019-01-11' AS date), 1064, 3192, 13879, 13880, 13880, 13880, 13880, 13879, 13879, 2458494, 58493, N'2019-01-10', 201902, 2, 4, N'2019-W02', N'2019-W02-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97164, CAST(N'2019-01-11' AS date), CAST(N'2019-01-12' AS date), 2019, 20191, 201901, 2019011, 1, 1, 11, 11, 6, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-11' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-05' AS date), CAST(N'2019-01-11' AS date), 1064, 3192, 13879, 13880, 13880, 13880, 13880, 13880, 13879, 2458495, 58494, N'2019-01-11', 201902, 2, 5, N'2019-W02', N'2019-W02-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97165, CAST(N'2019-01-12' AS date), CAST(N'2019-01-13' AS date), 2019, 20191, 201901, 2019012, 1, 1, 12, 12, 7, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-06' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-11' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-18' AS date), 1064, 3192, 13879, 13880, 13880, 13880, 13880, 13880, 13880, 2458496, 58495, N'2019-01-12', 201902, 2, 6, N'2019-W02', N'2019-W02-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97166, CAST(N'2019-01-13' AS date), CAST(N'2019-01-14' AS date), 2019, 20191, 201901, 2019013, 1, 1, 13, 13, 1, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-07' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-11' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-18' AS date), 1064, 3192, 13880, 13880, 13880, 13880, 13880, 13880, 13880, 2458497, 58496, N'2019-01-13', 201902, 2, 7, N'2019-W02', N'2019-W02-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97167, CAST(N'2019-01-14' AS date), CAST(N'2019-01-15' AS date), 2019, 20191, 201901, 2019014, 1, 1, 14, 14, 2, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-08' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-11' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-18' AS date), 1064, 3192, 13880, 13881, 13880, 13880, 13880, 13880, 13880, 2458498, 58497, N'2019-01-14', 201903, 3, 1, N'2019-W03', N'2019-W03-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97168, CAST(N'2019-01-15' AS date), CAST(N'2019-01-16' AS date), 2019, 20191, 201901, 2019015, 1, 1, 15, 15, 3, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-09' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-11' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-18' AS date), 1064, 3192, 13880, 13881, 13881, 13880, 13880, 13880, 13880, 2458499, 58498, N'2019-01-15', 201903, 3, 2, N'2019-W03', N'2019-W03-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97169, CAST(N'2019-01-16' AS date), CAST(N'2019-01-17' AS date), 2019, 20191, 201901, 2019016, 1, 1, 16, 16, 4, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-10' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-11' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-18' AS date), 1064, 3192, 13880, 13881, 13881, 13881, 13880, 13880, 13880, 2458500, 58499, N'2019-01-16', 201903, 3, 3, N'2019-W03', N'2019-W03-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97170, CAST(N'2019-01-17' AS date), CAST(N'2019-01-18' AS date), 2019, 20191, 201901, 2019017, 1, 1, 17, 17, 5, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-11' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-18' AS date), 1064, 3192, 13880, 13881, 13881, 13881, 13881, 13880, 13880, 2458501, 58500, N'2019-01-17', 201903, 3, 4, N'2019-W03', N'2019-W03-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97171, CAST(N'2019-01-18' AS date), CAST(N'2019-01-19' AS date), 2019, 20191, 201901, 2019018, 1, 1, 18, 18, 6, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-18' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-12' AS date), CAST(N'2019-01-18' AS date), 1064, 3192, 13880, 13881, 13881, 13881, 13881, 13881, 13880, 2458502, 58501, N'2019-01-18', 201903, 3, 5, N'2019-W03', N'2019-W03-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97172, CAST(N'2019-01-19' AS date), CAST(N'2019-01-20' AS date), 2019, 20191, 201901, 2019019, 1, 1, 19, 19, 7, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-13' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-18' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-25' AS date), 1064, 3192, 13880, 13881, 13881, 13881, 13881, 13881, 13881, 2458503, 58502, N'2019-01-19', 201903, 3, 6, N'2019-W03', N'2019-W03-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97173, CAST(N'2019-01-20' AS date), CAST(N'2019-01-21' AS date), 2019, 20191, 201901, 2019020, 1, 1, 20, 20, 1, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-01-14' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-18' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-25' AS date), 1064, 3192, 13881, 13881, 13881, 13881, 13881, 13881, 13881, 2458504, 58503, N'2019-01-20', 201903, 3, 7, N'2019-W03', N'2019-W03-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97174, CAST(N'2019-01-21' AS date), CAST(N'2019-01-22' AS date), 2019, 20191, 201901, 2019021, 1, 1, 21, 21, 2, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-01-15' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-18' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-25' AS date), 1064, 3192, 13881, 13882, 13881, 13881, 13881, 13881, 13881, 2458505, 58504, N'2019-01-21', 201904, 4, 1, N'2019-W04', N'2019-W04-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97175, CAST(N'2019-01-22' AS date), CAST(N'2019-01-23' AS date), 2019, 20191, 201901, 2019022, 1, 1, 22, 22, 3, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-01-16' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-18' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-25' AS date), 1064, 3192, 13881, 13882, 13882, 13881, 13881, 13881, 13881, 2458506, 58505, N'2019-01-22', 201904, 4, 2, N'2019-W04', N'2019-W04-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97176, CAST(N'2019-01-23' AS date), CAST(N'2019-01-24' AS date), 2019, 20191, 201901, 2019023, 1, 1, 23, 23, 4, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-01-17' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-18' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-25' AS date), 1064, 3192, 13881, 13882, 13882, 13882, 13881, 13881, 13881, 2458507, 58506, N'2019-01-23', 201904, 4, 3, N'2019-W04', N'2019-W04-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97177, CAST(N'2019-01-24' AS date), CAST(N'2019-01-25' AS date), 2019, 20191, 201901, 2019024, 1, 1, 24, 24, 5, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-01-18' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-25' AS date), 1064, 3192, 13881, 13882, 13882, 13882, 13882, 13881, 13881, 2458508, 58507, N'2019-01-24', 201904, 4, 4, N'2019-W04', N'2019-W04-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97178, CAST(N'2019-01-25' AS date), CAST(N'2019-01-26' AS date), 2019, 20191, 201901, 2019025, 1, 1, 25, 25, 6, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-01-25' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-19' AS date), CAST(N'2019-01-25' AS date), 1064, 3192, 13881, 13882, 13882, 13882, 13882, 13882, 13881, 2458509, 58508, N'2019-01-25', 201904, 4, 5, N'2019-W04', N'2019-W04-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97179, CAST(N'2019-01-26' AS date), CAST(N'2019-01-27' AS date), 2019, 20191, 201901, 2019026, 1, 1, 26, 26, 7, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-20' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-01-25' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-02-01' AS date), 1064, 3192, 13881, 13882, 13882, 13882, 13882, 13882, 13882, 2458510, 58509, N'2019-01-26', 201904, 4, 6, N'2019-W04', N'2019-W04-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97180, CAST(N'2019-01-27' AS date), CAST(N'2019-01-28' AS date), 2019, 20191, 201901, 2019027, 1, 1, 27, 27, 1, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-01-21' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-01-25' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-02-01' AS date), 1064, 3192, 13882, 13882, 13882, 13882, 13882, 13882, 13882, 2458511, 58510, N'2019-01-27', 201904, 4, 7, N'2019-W04', N'2019-W04-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97181, CAST(N'2019-01-28' AS date), CAST(N'2019-01-29' AS date), 2019, 20191, 201901, 2019028, 1, 1, 28, 28, 2, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-01-22' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-01-25' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-02-01' AS date), 1064, 3192, 13882, 13883, 13882, 13882, 13882, 13882, 13882, 2458512, 58511, N'2019-01-28', 201905, 5, 1, N'2019-W05', N'2019-W05-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97182, CAST(N'2019-01-29' AS date), CAST(N'2019-01-30' AS date), 2019, 20191, 201901, 2019029, 1, 1, 29, 29, 3, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-01-23' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-01-25' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-02-01' AS date), 1064, 3192, 13882, 13883, 13883, 13882, 13882, 13882, 13882, 2458513, 58512, N'2019-01-29', 201905, 5, 2, N'2019-W05', N'2019-W05-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97183, CAST(N'2019-01-30' AS date), CAST(N'2019-01-31' AS date), 2019, 20191, 201901, 2019030, 1, 1, 30, 30, 4, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-01-24' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-01-25' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-02-01' AS date), 1064, 3192, 13882, 13883, 13883, 13883, 13882, 13882, 13882, 2458514, 58513, N'2019-01-30', 201905, 5, 3, N'2019-W05', N'2019-W05-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97184, CAST(N'2019-01-31' AS date), CAST(N'2019-02-01' AS date), 2019, 20191, 201901, 2019031, 1, 1, 31, 31, 5, N'2019', N'2019 Q1', N'2019 Jan', N'Jan', N'January', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-01-25' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-02-01' AS date), 1064, 3192, 13882, 13883, 13883, 13883, 13883, 13882, 13882, 2458515, 58514, N'2019-01-31', 201905, 5, 4, N'2019-W05', N'2019-W05-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97185, CAST(N'2019-02-01' AS date), CAST(N'2019-02-02' AS date), 2019, 20191, 201902, 2019032, 1, 2, 32, 1, 6, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-01-26' AS date), CAST(N'2019-02-01' AS date), 1064, 3193, 13882, 13883, 13883, 13883, 13883, 13883, 13882, 2458516, 58515, N'2019-02-01', 201905, 5, 5, N'2019-W05', N'2019-W05-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97186, CAST(N'2019-02-02' AS date), CAST(N'2019-02-03' AS date), 2019, 20191, 201902, 2019033, 1, 2, 33, 2, 7, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-01-27' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-02-08' AS date), 1064, 3193, 13882, 13883, 13883, 13883, 13883, 13883, 13883, 2458517, 58516, N'2019-02-02', 201905, 5, 6, N'2019-W05', N'2019-W05-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97187, CAST(N'2019-02-03' AS date), CAST(N'2019-02-04' AS date), 2019, 20191, 201902, 2019034, 1, 2, 34, 3, 1, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-01-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-02-08' AS date), 1064, 3193, 13883, 13883, 13883, 13883, 13883, 13883, 13883, 2458518, 58517, N'2019-02-03', 201905, 5, 7, N'2019-W05', N'2019-W05-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97188, CAST(N'2019-02-04' AS date), CAST(N'2019-02-05' AS date), 2019, 20191, 201902, 2019035, 1, 2, 35, 4, 2, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-01-29' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-02-08' AS date), 1064, 3193, 13883, 13884, 13883, 13883, 13883, 13883, 13883, 2458519, 58518, N'2019-02-04', 201906, 6, 1, N'2019-W06', N'2019-W06-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97189, CAST(N'2019-02-05' AS date), CAST(N'2019-02-06' AS date), 2019, 20191, 201902, 2019036, 1, 2, 36, 5, 3, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-01-30' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-02-08' AS date), 1064, 3193, 13883, 13884, 13884, 13883, 13883, 13883, 13883, 2458520, 58519, N'2019-02-05', 201906, 6, 2, N'2019-W06', N'2019-W06-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97190, CAST(N'2019-02-06' AS date), CAST(N'2019-02-07' AS date), 2019, 20191, 201902, 2019037, 1, 2, 37, 6, 4, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-01-31' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-02-08' AS date), 1064, 3193, 13883, 13884, 13884, 13884, 13883, 13883, 13883, 2458521, 58520, N'2019-02-06', 201906, 6, 3, N'2019-W06', N'2019-W06-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97191, CAST(N'2019-02-07' AS date), CAST(N'2019-02-08' AS date), 2019, 20191, 201902, 2019038, 1, 2, 38, 7, 5, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-02-08' AS date), 1064, 3193, 13883, 13884, 13884, 13884, 13884, 13883, 13883, 2458522, 58521, N'2019-02-07', 201906, 6, 4, N'2019-W06', N'2019-W06-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97192, CAST(N'2019-02-08' AS date), CAST(N'2019-02-09' AS date), 2019, 20191, 201902, 2019039, 1, 2, 39, 8, 6, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-08' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-02' AS date), CAST(N'2019-02-08' AS date), 1064, 3193, 13883, 13884, 13884, 13884, 13884, 13884, 13883, 2458523, 58522, N'2019-02-08', 201906, 6, 5, N'2019-W06', N'2019-W06-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97193, CAST(N'2019-02-09' AS date), CAST(N'2019-02-10' AS date), 2019, 20191, 201902, 2019040, 1, 2, 40, 9, 7, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-03' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-08' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-15' AS date), 1064, 3193, 13883, 13884, 13884, 13884, 13884, 13884, 13884, 2458524, 58523, N'2019-02-09', 201906, 6, 6, N'2019-W06', N'2019-W06-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97194, CAST(N'2019-02-10' AS date), CAST(N'2019-02-11' AS date), 2019, 20191, 201902, 2019041, 1, 2, 41, 10, 1, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-04' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-08' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-15' AS date), 1064, 3193, 13884, 13884, 13884, 13884, 13884, 13884, 13884, 2458525, 58524, N'2019-02-10', 201906, 6, 7, N'2019-W06', N'2019-W06-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97195, CAST(N'2019-02-11' AS date), CAST(N'2019-02-12' AS date), 2019, 20191, 201902, 2019042, 1, 2, 42, 11, 2, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-05' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-08' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-15' AS date), 1064, 3193, 13884, 13885, 13884, 13884, 13884, 13884, 13884, 2458526, 58525, N'2019-02-11', 201907, 7, 1, N'2019-W07', N'2019-W07-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97196, CAST(N'2019-02-12' AS date), CAST(N'2019-02-13' AS date), 2019, 20191, 201902, 2019043, 1, 2, 43, 12, 3, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-06' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-08' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-15' AS date), 1064, 3193, 13884, 13885, 13885, 13884, 13884, 13884, 13884, 2458527, 58526, N'2019-02-12', 201907, 7, 2, N'2019-W07', N'2019-W07-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97197, CAST(N'2019-02-13' AS date), CAST(N'2019-02-14' AS date), 2019, 20191, 201902, 2019044, 1, 2, 44, 13, 4, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-07' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-08' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-15' AS date), 1064, 3193, 13884, 13885, 13885, 13885, 13884, 13884, 13884, 2458528, 58527, N'2019-02-13', 201907, 7, 3, N'2019-W07', N'2019-W07-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97198, CAST(N'2019-02-14' AS date), CAST(N'2019-02-15' AS date), 2019, 20191, 201902, 2019045, 1, 2, 45, 14, 5, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-08' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-15' AS date), 1064, 3193, 13884, 13885, 13885, 13885, 13885, 13884, 13884, 2458529, 58528, N'2019-02-14', 201907, 7, 4, N'2019-W07', N'2019-W07-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97199, CAST(N'2019-02-15' AS date), CAST(N'2019-02-16' AS date), 2019, 20191, 201902, 2019046, 1, 2, 46, 15, 6, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-15' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-09' AS date), CAST(N'2019-02-15' AS date), 1064, 3193, 13884, 13885, 13885, 13885, 13885, 13885, 13884, 2458530, 58529, N'2019-02-15', 201907, 7, 5, N'2019-W07', N'2019-W07-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97200, CAST(N'2019-02-16' AS date), CAST(N'2019-02-17' AS date), 2019, 20191, 201902, 2019047, 1, 2, 47, 16, 7, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-10' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-15' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-22' AS date), 1064, 3193, 13884, 13885, 13885, 13885, 13885, 13885, 13885, 2458531, 58530, N'2019-02-16', 201907, 7, 6, N'2019-W07', N'2019-W07-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97201, CAST(N'2019-02-17' AS date), CAST(N'2019-02-18' AS date), 2019, 20191, 201902, 2019048, 1, 2, 48, 17, 1, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-02-11' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-15' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-22' AS date), 1064, 3193, 13885, 13885, 13885, 13885, 13885, 13885, 13885, 2458532, 58531, N'2019-02-17', 201907, 7, 7, N'2019-W07', N'2019-W07-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97202, CAST(N'2019-02-18' AS date), CAST(N'2019-02-19' AS date), 2019, 20191, 201902, 2019049, 1, 2, 49, 18, 2, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-02-12' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-15' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-22' AS date), 1064, 3193, 13885, 13886, 13885, 13885, 13885, 13885, 13885, 2458533, 58532, N'2019-02-18', 201908, 8, 1, N'2019-W08', N'2019-W08-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97203, CAST(N'2019-02-19' AS date), CAST(N'2019-02-20' AS date), 2019, 20191, 201902, 2019050, 1, 2, 50, 19, 3, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-02-13' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-15' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-22' AS date), 1064, 3193, 13885, 13886, 13886, 13885, 13885, 13885, 13885, 2458534, 58533, N'2019-02-19', 201908, 8, 2, N'2019-W08', N'2019-W08-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97204, CAST(N'2019-02-20' AS date), CAST(N'2019-02-21' AS date), 2019, 20191, 201902, 2019051, 1, 2, 51, 20, 4, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-02-14' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-15' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-22' AS date), 1064, 3193, 13885, 13886, 13886, 13886, 13885, 13885, 13885, 2458535, 58534, N'2019-02-20', 201908, 8, 3, N'2019-W08', N'2019-W08-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97205, CAST(N'2019-02-21' AS date), CAST(N'2019-02-22' AS date), 2019, 20191, 201902, 2019052, 1, 2, 52, 21, 5, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-02-15' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-22' AS date), 1064, 3193, 13885, 13886, 13886, 13886, 13886, 13885, 13885, 2458536, 58535, N'2019-02-21', 201908, 8, 4, N'2019-W08', N'2019-W08-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97206, CAST(N'2019-02-22' AS date), CAST(N'2019-02-23' AS date), 2019, 20191, 201902, 2019053, 1, 2, 53, 22, 6, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-02-22' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-16' AS date), CAST(N'2019-02-22' AS date), 1064, 3193, 13885, 13886, 13886, 13886, 13886, 13886, 13885, 2458537, 58536, N'2019-02-22', 201908, 8, 5, N'2019-W08', N'2019-W08-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97207, CAST(N'2019-02-23' AS date), CAST(N'2019-02-24' AS date), 2019, 20191, 201902, 2019054, 1, 2, 54, 23, 7, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-17' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-02-22' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-03-01' AS date), 1064, 3193, 13885, 13886, 13886, 13886, 13886, 13886, 13886, 2458538, 58537, N'2019-02-23', 201908, 8, 6, N'2019-W08', N'2019-W08-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97208, CAST(N'2019-02-24' AS date), CAST(N'2019-02-25' AS date), 2019, 20191, 201902, 2019055, 1, 2, 55, 24, 1, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-02-18' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-02-22' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-03-01' AS date), 1064, 3193, 13886, 13886, 13886, 13886, 13886, 13886, 13886, 2458539, 58538, N'2019-02-24', 201908, 8, 7, N'2019-W08', N'2019-W08-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97209, CAST(N'2019-02-25' AS date), CAST(N'2019-02-26' AS date), 2019, 20191, 201902, 2019056, 1, 2, 56, 25, 2, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-02-19' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-02-22' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-03-01' AS date), 1064, 3193, 13886, 13887, 13886, 13886, 13886, 13886, 13886, 2458540, 58539, N'2019-02-25', 201909, 9, 1, N'2019-W09', N'2019-W09-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97210, CAST(N'2019-02-26' AS date), CAST(N'2019-02-27' AS date), 2019, 20191, 201902, 2019057, 1, 2, 57, 26, 3, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-02-20' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-02-22' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-03-01' AS date), 1064, 3193, 13886, 13887, 13887, 13886, 13886, 13886, 13886, 2458541, 58540, N'2019-02-26', 201909, 9, 2, N'2019-W09', N'2019-W09-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97211, CAST(N'2019-02-27' AS date), CAST(N'2019-02-28' AS date), 2019, 20191, 201902, 2019058, 1, 2, 58, 27, 4, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-02-21' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-02-22' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-03-01' AS date), 1064, 3193, 13886, 13887, 13887, 13887, 13886, 13886, 13886, 2458542, 58541, N'2019-02-27', 201909, 9, 3, N'2019-W09', N'2019-W09-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97212, CAST(N'2019-02-28' AS date), CAST(N'2019-03-01' AS date), 2019, 20191, 201902, 2019059, 1, 2, 59, 28, 5, N'2019', N'2019 Q1', N'2019 Feb', N'Feb', N'February', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-01' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-02-22' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-03-01' AS date), 1064, 3193, 13886, 13887, 13887, 13887, 13887, 13886, 13886, 2458543, 58542, N'2019-02-28', 201909, 9, 4, N'2019-W09', N'2019-W09-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97213, CAST(N'2019-03-01' AS date), CAST(N'2019-03-02' AS date), 2019, 20191, 201903, 2019060, 1, 3, 60, 1, 6, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-02-23' AS date), CAST(N'2019-03-01' AS date), 1064, 3194, 13886, 13887, 13887, 13887, 13887, 13887, 13886, 2458544, 58543, N'2019-03-01', 201909, 9, 5, N'2019-W09', N'2019-W09-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97214, CAST(N'2019-03-02' AS date), CAST(N'2019-03-03' AS date), 2019, 20191, 201903, 2019061, 1, 3, 61, 2, 7, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-02-24' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-03-08' AS date), 1064, 3194, 13886, 13887, 13887, 13887, 13887, 13887, 13887, 2458545, 58544, N'2019-03-02', 201909, 9, 6, N'2019-W09', N'2019-W09-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97215, CAST(N'2019-03-03' AS date), CAST(N'2019-03-04' AS date), 2019, 20191, 201903, 2019062, 1, 3, 62, 3, 1, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-02-25' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-03-08' AS date), 1064, 3194, 13887, 13887, 13887, 13887, 13887, 13887, 13887, 2458546, 58545, N'2019-03-03', 201909, 9, 7, N'2019-W09', N'2019-W09-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97216, CAST(N'2019-03-04' AS date), CAST(N'2019-03-05' AS date), 2019, 20191, 201903, 2019063, 1, 3, 63, 4, 2, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-02-26' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-03-08' AS date), 1064, 3194, 13887, 13888, 13887, 13887, 13887, 13887, 13887, 2458547, 58546, N'2019-03-04', 201910, 10, 1, N'2019-W10', N'2019-W10-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97217, CAST(N'2019-03-05' AS date), CAST(N'2019-03-06' AS date), 2019, 20191, 201903, 2019064, 1, 3, 64, 5, 3, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-02-27' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-03-08' AS date), 1064, 3194, 13887, 13888, 13888, 13887, 13887, 13887, 13887, 2458548, 58547, N'2019-03-05', 201910, 10, 2, N'2019-W10', N'2019-W10-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97218, CAST(N'2019-03-06' AS date), CAST(N'2019-03-07' AS date), 2019, 20191, 201903, 2019065, 1, 3, 65, 6, 4, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-02-28' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-03-08' AS date), 1064, 3194, 13887, 13888, 13888, 13888, 13887, 13887, 13887, 2458549, 58548, N'2019-03-06', 201910, 10, 3, N'2019-W10', N'2019-W10-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97219, CAST(N'2019-03-07' AS date), CAST(N'2019-03-08' AS date), 2019, 20191, 201903, 2019066, 1, 3, 66, 7, 5, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-03-08' AS date), 1064, 3194, 13887, 13888, 13888, 13888, 13888, 13887, 13887, 2458550, 58549, N'2019-03-07', 201910, 10, 4, N'2019-W10', N'2019-W10-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97220, CAST(N'2019-03-08' AS date), CAST(N'2019-03-09' AS date), 2019, 20191, 201903, 2019067, 1, 3, 67, 8, 6, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-08' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-02' AS date), CAST(N'2019-03-08' AS date), 1064, 3194, 13887, 13888, 13888, 13888, 13888, 13888, 13887, 2458551, 58550, N'2019-03-08', 201910, 10, 5, N'2019-W10', N'2019-W10-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97221, CAST(N'2019-03-09' AS date), CAST(N'2019-03-10' AS date), 2019, 20191, 201903, 2019068, 1, 3, 68, 9, 7, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-03' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-08' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-15' AS date), 1064, 3194, 13887, 13888, 13888, 13888, 13888, 13888, 13888, 2458552, 58551, N'2019-03-09', 201910, 10, 6, N'2019-W10', N'2019-W10-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97222, CAST(N'2019-03-10' AS date), CAST(N'2019-03-11' AS date), 2019, 20191, 201903, 2019069, 1, 3, 69, 10, 1, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-04' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-08' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-15' AS date), 1064, 3194, 13888, 13888, 13888, 13888, 13888, 13888, 13888, 2458553, 58552, N'2019-03-10', 201910, 10, 7, N'2019-W10', N'2019-W10-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97223, CAST(N'2019-03-11' AS date), CAST(N'2019-03-12' AS date), 2019, 20191, 201903, 2019070, 1, 3, 70, 11, 2, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-05' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-08' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-15' AS date), 1064, 3194, 13888, 13889, 13888, 13888, 13888, 13888, 13888, 2458554, 58553, N'2019-03-11', 201911, 11, 1, N'2019-W11', N'2019-W11-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97224, CAST(N'2019-03-12' AS date), CAST(N'2019-03-13' AS date), 2019, 20191, 201903, 2019071, 1, 3, 71, 12, 3, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-06' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-08' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-15' AS date), 1064, 3194, 13888, 13889, 13889, 13888, 13888, 13888, 13888, 2458555, 58554, N'2019-03-12', 201911, 11, 2, N'2019-W11', N'2019-W11-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97225, CAST(N'2019-03-13' AS date), CAST(N'2019-03-14' AS date), 2019, 20191, 201903, 2019072, 1, 3, 72, 13, 4, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-07' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-08' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-15' AS date), 1064, 3194, 13888, 13889, 13889, 13889, 13888, 13888, 13888, 2458556, 58555, N'2019-03-13', 201911, 11, 3, N'2019-W11', N'2019-W11-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97226, CAST(N'2019-03-14' AS date), CAST(N'2019-03-15' AS date), 2019, 20191, 201903, 2019073, 1, 3, 73, 14, 5, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-08' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-15' AS date), 1064, 3194, 13888, 13889, 13889, 13889, 13889, 13888, 13888, 2458557, 58556, N'2019-03-14', 201911, 11, 4, N'2019-W11', N'2019-W11-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97227, CAST(N'2019-03-15' AS date), CAST(N'2019-03-16' AS date), 2019, 20191, 201903, 2019074, 1, 3, 74, 15, 6, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-15' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-09' AS date), CAST(N'2019-03-15' AS date), 1064, 3194, 13888, 13889, 13889, 13889, 13889, 13889, 13888, 2458558, 58557, N'2019-03-15', 201911, 11, 5, N'2019-W11', N'2019-W11-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97228, CAST(N'2019-03-16' AS date), CAST(N'2019-03-17' AS date), 2019, 20191, 201903, 2019075, 1, 3, 75, 16, 7, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-10' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-15' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-22' AS date), 1064, 3194, 13888, 13889, 13889, 13889, 13889, 13889, 13889, 2458559, 58558, N'2019-03-16', 201911, 11, 6, N'2019-W11', N'2019-W11-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97229, CAST(N'2019-03-17' AS date), CAST(N'2019-03-18' AS date), 2019, 20191, 201903, 2019076, 1, 3, 76, 17, 1, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-11' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-15' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-22' AS date), 1064, 3194, 13889, 13889, 13889, 13889, 13889, 13889, 13889, 2458560, 58559, N'2019-03-17', 201911, 11, 7, N'2019-W11', N'2019-W11-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97230, CAST(N'2019-03-18' AS date), CAST(N'2019-03-19' AS date), 2019, 20191, 201903, 2019077, 1, 3, 77, 18, 2, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-12' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-15' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-22' AS date), 1064, 3194, 13889, 13890, 13889, 13889, 13889, 13889, 13889, 2458561, 58560, N'2019-03-18', 201912, 12, 1, N'2019-W12', N'2019-W12-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97231, CAST(N'2019-03-19' AS date), CAST(N'2019-03-20' AS date), 2019, 20191, 201903, 2019078, 1, 3, 78, 19, 3, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-13' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-15' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-22' AS date), 1064, 3194, 13889, 13890, 13890, 13889, 13889, 13889, 13889, 2458562, 58561, N'2019-03-19', 201912, 12, 2, N'2019-W12', N'2019-W12-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97232, CAST(N'2019-03-20' AS date), CAST(N'2019-03-21' AS date), 2019, 20191, 201903, 2019079, 1, 3, 79, 20, 4, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-03-14' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-15' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-22' AS date), 1064, 3194, 13889, 13890, 13890, 13890, 13889, 13889, 13889, 2458563, 58562, N'2019-03-20', 201912, 12, 3, N'2019-W12', N'2019-W12-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97233, CAST(N'2019-03-21' AS date), CAST(N'2019-03-22' AS date), 2019, 20191, 201903, 2019080, 1, 3, 80, 21, 5, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-03-15' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-22' AS date), 1064, 3194, 13889, 13890, 13890, 13890, 13890, 13889, 13889, 2458564, 58563, N'2019-03-21', 201912, 12, 4, N'2019-W12', N'2019-W12-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97234, CAST(N'2019-03-22' AS date), CAST(N'2019-03-23' AS date), 2019, 20191, 201903, 2019081, 1, 3, 81, 22, 6, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-03-22' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-03-16' AS date), CAST(N'2019-03-22' AS date), 1064, 3194, 13889, 13890, 13890, 13890, 13890, 13890, 13889, 2458565, 58564, N'2019-03-22', 201912, 12, 5, N'2019-W12', N'2019-W12-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97235, CAST(N'2019-03-23' AS date), CAST(N'2019-03-24' AS date), 2019, 20191, 201903, 2019082, 1, 3, 82, 23, 7, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-17' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-03-22' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-29' AS date), 1064, 3194, 13889, 13890, 13890, 13890, 13890, 13890, 13890, 2458566, 58565, N'2019-03-23', 201912, 12, 6, N'2019-W12', N'2019-W12-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97236, CAST(N'2019-03-24' AS date), CAST(N'2019-03-25' AS date), 2019, 20191, 201903, 2019083, 1, 3, 83, 24, 1, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-03-18' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-03-22' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-29' AS date), 1064, 3194, 13890, 13890, 13890, 13890, 13890, 13890, 13890, 2458567, 58566, N'2019-03-24', 201912, 12, 7, N'2019-W12', N'2019-W12-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97237, CAST(N'2019-03-25' AS date), CAST(N'2019-03-26' AS date), 2019, 20191, 201903, 2019084, 1, 3, 84, 25, 2, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-19' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-03-22' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-29' AS date), 1064, 3194, 13890, 13891, 13890, 13890, 13890, 13890, 13890, 2458568, 58567, N'2019-03-25', 201913, 13, 1, N'2019-W13', N'2019-W13-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97238, CAST(N'2019-03-26' AS date), CAST(N'2019-03-27' AS date), 2019, 20191, 201903, 2019085, 1, 3, 85, 26, 3, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-03-20' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-03-22' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-29' AS date), 1064, 3194, 13890, 13891, 13891, 13890, 13890, 13890, 13890, 2458569, 58568, N'2019-03-26', 201913, 13, 2, N'2019-W13', N'2019-W13-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97239, CAST(N'2019-03-27' AS date), CAST(N'2019-03-28' AS date), 2019, 20191, 201903, 2019086, 1, 3, 86, 27, 4, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-03-21' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-03-22' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-29' AS date), 1064, 3194, 13890, 13891, 13891, 13891, 13890, 13890, 13890, 2458570, 58569, N'2019-03-27', 201913, 13, 3, N'2019-W13', N'2019-W13-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97240, CAST(N'2019-03-28' AS date), CAST(N'2019-03-29' AS date), 2019, 20191, 201903, 2019087, 1, 3, 87, 28, 5, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-03-22' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-29' AS date), 1064, 3194, 13890, 13891, 13891, 13891, 13891, 13890, 13890, 2458571, 58570, N'2019-03-28', 201913, 13, 4, N'2019-W13', N'2019-W13-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97241, CAST(N'2019-03-29' AS date), CAST(N'2019-03-30' AS date), 2019, 20191, 201903, 2019088, 1, 3, 88, 29, 6, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-03-29' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-03-23' AS date), CAST(N'2019-03-29' AS date), 1064, 3194, 13890, 13891, 13891, 13891, 13891, 13891, 13890, 2458572, 58571, N'2019-03-29', 201913, 13, 5, N'2019-W13', N'2019-W13-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97242, CAST(N'2019-03-30' AS date), CAST(N'2019-03-31' AS date), 2019, 20191, 201903, 2019089, 1, 3, 89, 30, 7, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-24' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-03-29' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-04-05' AS date), 1064, 3194, 13890, 13891, 13891, 13891, 13891, 13891, 13891, 2458573, 58572, N'2019-03-30', 201913, 13, 6, N'2019-W13', N'2019-W13-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97243, CAST(N'2019-03-31' AS date), CAST(N'2019-04-01' AS date), 2019, 20191, 201903, 2019090, 1, 3, 90, 31, 1, N'2019', N'2019 Q1', N'2019 Mar', N'Mar', N'March', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-01-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-01' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-03-25' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-03-29' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-04-05' AS date), 1064, 3194, 13891, 13891, 13891, 13891, 13891, 13891, 13891, 2458574, 58573, N'2019-03-31', 201913, 13, 7, N'2019-W13', N'2019-W13-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97244, CAST(N'2019-04-01' AS date), CAST(N'2019-04-02' AS date), 2019, 20192, 201904, 2019091, 2, 4, 91, 1, 2, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-03-26' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-03-29' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-04-05' AS date), 1065, 3195, 13891, 13892, 13891, 13891, 13891, 13891, 13891, 2458575, 58574, N'2019-04-01', 201914, 14, 1, N'2019-W14', N'2019-W14-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97245, CAST(N'2019-04-02' AS date), CAST(N'2019-04-03' AS date), 2019, 20192, 201904, 2019092, 2, 4, 92, 2, 3, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-03-27' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-03-29' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-04-05' AS date), 1065, 3195, 13891, 13892, 13892, 13891, 13891, 13891, 13891, 2458576, 58575, N'2019-04-02', 201914, 14, 2, N'2019-W14', N'2019-W14-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97246, CAST(N'2019-04-03' AS date), CAST(N'2019-04-04' AS date), 2019, 20192, 201904, 2019093, 2, 4, 93, 3, 4, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-03-28' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-03-29' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-04-05' AS date), 1065, 3195, 13891, 13892, 13892, 13892, 13891, 13891, 13891, 2458577, 58576, N'2019-04-03', 201914, 14, 3, N'2019-W14', N'2019-W14-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97247, CAST(N'2019-04-04' AS date), CAST(N'2019-04-05' AS date), 2019, 20192, 201904, 2019094, 2, 4, 94, 4, 5, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-03-29' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-04-05' AS date), 1065, 3195, 13891, 13892, 13892, 13892, 13892, 13891, 13891, 2458578, 58577, N'2019-04-04', 201914, 14, 4, N'2019-W14', N'2019-W14-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97248, CAST(N'2019-04-05' AS date), CAST(N'2019-04-06' AS date), 2019, 20192, 201904, 2019095, 2, 4, 95, 5, 6, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-05' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-03-30' AS date), CAST(N'2019-04-05' AS date), 1065, 3195, 13891, 13892, 13892, 13892, 13892, 13892, 13891, 2458579, 58578, N'2019-04-05', 201914, 14, 5, N'2019-W14', N'2019-W14-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97249, CAST(N'2019-04-06' AS date), CAST(N'2019-04-07' AS date), 2019, 20192, 201904, 2019096, 2, 4, 96, 6, 7, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-03-31' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-05' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-12' AS date), 1065, 3195, 13891, 13892, 13892, 13892, 13892, 13892, 13892, 2458580, 58579, N'2019-04-06', 201914, 14, 6, N'2019-W14', N'2019-W14-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97250, CAST(N'2019-04-07' AS date), CAST(N'2019-04-08' AS date), 2019, 20192, 201904, 2019097, 2, 4, 97, 7, 1, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-05' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-12' AS date), 1065, 3195, 13892, 13892, 13892, 13892, 13892, 13892, 13892, 2458581, 58580, N'2019-04-07', 201914, 14, 7, N'2019-W14', N'2019-W14-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97251, CAST(N'2019-04-08' AS date), CAST(N'2019-04-09' AS date), 2019, 20192, 201904, 2019098, 2, 4, 98, 8, 2, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-02' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-05' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-12' AS date), 1065, 3195, 13892, 13893, 13892, 13892, 13892, 13892, 13892, 2458582, 58581, N'2019-04-08', 201915, 15, 1, N'2019-W15', N'2019-W15-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97252, CAST(N'2019-04-09' AS date), CAST(N'2019-04-10' AS date), 2019, 20192, 201904, 2019099, 2, 4, 99, 9, 3, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-03' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-05' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-12' AS date), 1065, 3195, 13892, 13893, 13893, 13892, 13892, 13892, 13892, 2458583, 58582, N'2019-04-09', 201915, 15, 2, N'2019-W15', N'2019-W15-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97253, CAST(N'2019-04-10' AS date), CAST(N'2019-04-11' AS date), 2019, 20192, 201904, 2019100, 2, 4, 100, 10, 4, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-04' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-05' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-12' AS date), 1065, 3195, 13892, 13893, 13893, 13893, 13892, 13892, 13892, 2458584, 58583, N'2019-04-10', 201915, 15, 3, N'2019-W15', N'2019-W15-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97254, CAST(N'2019-04-11' AS date), CAST(N'2019-04-12' AS date), 2019, 20192, 201904, 2019101, 2, 4, 101, 11, 5, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-05' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-12' AS date), 1065, 3195, 13892, 13893, 13893, 13893, 13893, 13892, 13892, 2458585, 58584, N'2019-04-11', 201915, 15, 4, N'2019-W15', N'2019-W15-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97255, CAST(N'2019-04-12' AS date), CAST(N'2019-04-13' AS date), 2019, 20192, 201904, 2019102, 2, 4, 102, 12, 6, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-12' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-06' AS date), CAST(N'2019-04-12' AS date), 1065, 3195, 13892, 13893, 13893, 13893, 13893, 13893, 13892, 2458586, 58585, N'2019-04-12', 201915, 15, 5, N'2019-W15', N'2019-W15-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97256, CAST(N'2019-04-13' AS date), CAST(N'2019-04-14' AS date), 2019, 20192, 201904, 2019103, 2, 4, 103, 13, 7, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-07' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-12' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-19' AS date), 1065, 3195, 13892, 13893, 13893, 13893, 13893, 13893, 13893, 2458587, 58586, N'2019-04-13', 201915, 15, 6, N'2019-W15', N'2019-W15-6');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97257, CAST(N'2019-04-14' AS date), CAST(N'2019-04-15' AS date), 2019, 20192, 201904, 2019104, 2, 4, 104, 14, 1, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-08' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-12' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-19' AS date), 1065, 3195, 13893, 13893, 13893, 13893, 13893, 13893, 13893, 2458588, 58587, N'2019-04-14', 201915, 15, 7, N'2019-W15', N'2019-W15-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97258, CAST(N'2019-04-15' AS date), CAST(N'2019-04-16' AS date), 2019, 20192, 201904, 2019105, 2, 4, 105, 15, 2, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-09' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-12' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-19' AS date), 1065, 3195, 13893, 13894, 13893, 13893, 13893, 13893, 13893, 2458589, 58588, N'2019-04-15', 201916, 16, 1, N'2019-W16', N'2019-W16-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97259, CAST(N'2019-04-16' AS date), CAST(N'2019-04-17' AS date), 2019, 20192, 201904, 2019106, 2, 4, 106, 16, 3, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-10' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-12' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-19' AS date), 1065, 3195, 13893, 13894, 13894, 13893, 13893, 13893, 13893, 2458590, 58589, N'2019-04-16', 201916, 16, 2, N'2019-W16', N'2019-W16-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97260, CAST(N'2019-04-17' AS date), CAST(N'2019-04-18' AS date), 2019, 20192, 201904, 2019107, 2, 4, 107, 17, 4, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-11' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-12' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-19' AS date), 1065, 3195, 13893, 13894, 13894, 13894, 13893, 13893, 13893, 2458591, 58590, N'2019-04-17', 201916, 16, 3, N'2019-W16', N'2019-W16-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97261, CAST(N'2019-04-18' AS date), CAST(N'2019-04-19' AS date), 2019, 20192, 201904, 2019108, 2, 4, 108, 18, 5, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-12' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-19' AS date), 1065, 3195, 13893, 13894, 13894, 13894, 13894, 13893, 13893, 2458592, 58591, N'2019-04-18', 201916, 16, 4, N'2019-W16', N'2019-W16-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97262, CAST(N'2019-04-19' AS date), CAST(N'2019-04-20' AS date), 2019, 20192, 201904, 2019109, 2, 4, 109, 19, 6, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-19' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-04-13' AS date), CAST(N'2019-04-19' AS date), 1065, 3195, 13893, 13894, 13894, 13894, 13894, 13894, 13893, 2458593, 58592, N'2019-04-19', 201916, 16, 5, N'2019-W16', N'2019-W16-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97263, CAST(N'2019-04-20' AS date), CAST(N'2019-04-21' AS date), 2019, 20192, 201904, 2019110, 2, 4, 110, 20, 7, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-14' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-19' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-26' AS date), 1065, 3195, 13893, 13894, 13894, 13894, 13894, 13894, 13894, 2458594, 58593, N'2019-04-20', 201916, 16, 6, N'2019-W16', N'2019-W16-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97264, CAST(N'2019-04-21' AS date), CAST(N'2019-04-22' AS date), 2019, 20192, 201904, 2019111, 2, 4, 111, 21, 1, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-04-15' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-19' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-26' AS date), 1065, 3195, 13894, 13894, 13894, 13894, 13894, 13894, 13894, 2458595, 58594, N'2019-04-21', 201916, 16, 7, N'2019-W16', N'2019-W16-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97265, CAST(N'2019-04-22' AS date), CAST(N'2019-04-23' AS date), 2019, 20192, 201904, 2019112, 2, 4, 112, 22, 2, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-04-16' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-19' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-26' AS date), 1065, 3195, 13894, 13895, 13894, 13894, 13894, 13894, 13894, 2458596, 58595, N'2019-04-22', 201917, 17, 1, N'2019-W17', N'2019-W17-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97266, CAST(N'2019-04-23' AS date), CAST(N'2019-04-24' AS date), 2019, 20192, 201904, 2019113, 2, 4, 113, 23, 3, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-04-17' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-19' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-26' AS date), 1065, 3195, 13894, 13895, 13895, 13894, 13894, 13894, 13894, 2458597, 58596, N'2019-04-23', 201917, 17, 2, N'2019-W17', N'2019-W17-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97267, CAST(N'2019-04-24' AS date), CAST(N'2019-04-25' AS date), 2019, 20192, 201904, 2019114, 2, 4, 114, 24, 4, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-18' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-19' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-26' AS date), 1065, 3195, 13894, 13895, 13895, 13895, 13894, 13894, 13894, 2458598, 58597, N'2019-04-24', 201917, 17, 3, N'2019-W17', N'2019-W17-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97268, CAST(N'2019-04-25' AS date), CAST(N'2019-04-26' AS date), 2019, 20192, 201904, 2019115, 2, 4, 115, 25, 5, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-04-19' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-26' AS date), 1065, 3195, 13894, 13895, 13895, 13895, 13895, 13894, 13894, 2458599, 58598, N'2019-04-25', 201917, 17, 4, N'2019-W17', N'2019-W17-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97269, CAST(N'2019-04-26' AS date), CAST(N'2019-04-27' AS date), 2019, 20192, 201904, 2019116, 2, 4, 116, 26, 6, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-04-26' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-04-20' AS date), CAST(N'2019-04-26' AS date), 1065, 3195, 13894, 13895, 13895, 13895, 13895, 13895, 13894, 2458600, 58599, N'2019-04-26', 201917, 17, 5, N'2019-W17', N'2019-W17-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97270, CAST(N'2019-04-27' AS date), CAST(N'2019-04-28' AS date), 2019, 20192, 201904, 2019117, 2, 4, 117, 27, 7, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-21' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-04-26' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-05-03' AS date), 1065, 3195, 13894, 13895, 13895, 13895, 13895, 13895, 13895, 2458601, 58600, N'2019-04-27', 201917, 17, 6, N'2019-W17', N'2019-W17-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97271, CAST(N'2019-04-28' AS date), CAST(N'2019-04-29' AS date), 2019, 20192, 201904, 2019118, 2, 4, 118, 28, 1, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-04-22' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-04-26' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-05-03' AS date), 1065, 3195, 13895, 13895, 13895, 13895, 13895, 13895, 13895, 2458602, 58601, N'2019-04-28', 201917, 17, 7, N'2019-W17', N'2019-W17-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97272, CAST(N'2019-04-29' AS date), CAST(N'2019-04-30' AS date), 2019, 20192, 201904, 2019119, 2, 4, 119, 29, 2, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-04-23' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-04-26' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-05-03' AS date), 1065, 3195, 13895, 13896, 13895, 13895, 13895, 13895, 13895, 2458603, 58602, N'2019-04-29', 201918, 18, 1, N'2019-W18', N'2019-W18-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97273, CAST(N'2019-04-30' AS date), CAST(N'2019-05-01' AS date), 2019, 20192, 201904, 2019120, 2, 4, 120, 30, 3, N'2019', N'2019 Q2', N'2019 Apr', N'Apr', N'April', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-04-24' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-04-26' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-05-03' AS date), 1065, 3195, 13895, 13896, 13896, 13895, 13895, 13895, 13895, 2458604, 58603, N'2019-04-30', 201918, 18, 2, N'2019-W18', N'2019-W18-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97274, CAST(N'2019-05-01' AS date), CAST(N'2019-05-02' AS date), 2019, 20192, 201905, 2019121, 2, 5, 121, 1, 4, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-04-25' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-04-26' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-05-03' AS date), 1065, 3196, 13895, 13896, 13896, 13896, 13895, 13895, 13895, 2458605, 58604, N'2019-05-01', 201918, 18, 3, N'2019-W18', N'2019-W18-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97275, CAST(N'2019-05-02' AS date), CAST(N'2019-05-03' AS date), 2019, 20192, 201905, 2019122, 2, 5, 122, 2, 5, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-04-26' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-05-03' AS date), 1065, 3196, 13895, 13896, 13896, 13896, 13896, 13895, 13895, 2458606, 58605, N'2019-05-02', 201918, 18, 4, N'2019-W18', N'2019-W18-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97276, CAST(N'2019-05-03' AS date), CAST(N'2019-05-04' AS date), 2019, 20192, 201905, 2019123, 2, 5, 123, 3, 6, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-03' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-04-27' AS date), CAST(N'2019-05-03' AS date), 1065, 3196, 13895, 13896, 13896, 13896, 13896, 13896, 13895, 2458607, 58606, N'2019-05-03', 201918, 18, 5, N'2019-W18', N'2019-W18-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97277, CAST(N'2019-05-04' AS date), CAST(N'2019-05-05' AS date), 2019, 20192, 201905, 2019124, 2, 5, 124, 4, 7, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-04-28' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-03' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-05-10' AS date), 1065, 3196, 13895, 13896, 13896, 13896, 13896, 13896, 13896, 2458608, 58607, N'2019-05-04', 201918, 18, 6, N'2019-W18', N'2019-W18-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97278, CAST(N'2019-05-05' AS date), CAST(N'2019-05-06' AS date), 2019, 20192, 201905, 2019125, 2, 5, 125, 5, 1, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-04-29' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-03' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-05-10' AS date), 1065, 3196, 13896, 13896, 13896, 13896, 13896, 13896, 13896, 2458609, 58608, N'2019-05-05', 201918, 18, 7, N'2019-W18', N'2019-W18-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97279, CAST(N'2019-05-06' AS date), CAST(N'2019-05-07' AS date), 2019, 20192, 201905, 2019126, 2, 5, 126, 6, 2, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-04-30' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-03' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-05-10' AS date), 1065, 3196, 13896, 13897, 13896, 13896, 13896, 13896, 13896, 2458610, 58609, N'2019-05-06', 201919, 19, 1, N'2019-W19', N'2019-W19-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97280, CAST(N'2019-05-07' AS date), CAST(N'2019-05-08' AS date), 2019, 20192, 201905, 2019127, 2, 5, 127, 7, 3, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-03' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-05-10' AS date), 1065, 3196, 13896, 13897, 13897, 13896, 13896, 13896, 13896, 2458611, 58610, N'2019-05-07', 201919, 19, 2, N'2019-W19', N'2019-W19-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97281, CAST(N'2019-05-08' AS date), CAST(N'2019-05-09' AS date), 2019, 20192, 201905, 2019128, 2, 5, 128, 8, 4, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-02' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-03' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-05-10' AS date), 1065, 3196, 13896, 13897, 13897, 13897, 13896, 13896, 13896, 2458612, 58611, N'2019-05-08', 201919, 19, 3, N'2019-W19', N'2019-W19-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97282, CAST(N'2019-05-09' AS date), CAST(N'2019-05-10' AS date), 2019, 20192, 201905, 2019129, 2, 5, 129, 9, 5, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-03' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-05-10' AS date), 1065, 3196, 13896, 13897, 13897, 13897, 13897, 13896, 13896, 2458613, 58612, N'2019-05-09', 201919, 19, 4, N'2019-W19', N'2019-W19-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97283, CAST(N'2019-05-10' AS date), CAST(N'2019-05-11' AS date), 2019, 20192, 201905, 2019130, 2, 5, 130, 10, 6, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-10' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-04' AS date), CAST(N'2019-05-10' AS date), 1065, 3196, 13896, 13897, 13897, 13897, 13897, 13897, 13896, 2458614, 58613, N'2019-05-10', 201919, 19, 5, N'2019-W19', N'2019-W19-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97284, CAST(N'2019-05-11' AS date), CAST(N'2019-05-12' AS date), 2019, 20192, 201905, 2019131, 2, 5, 131, 11, 7, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-05' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-10' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-17' AS date), 1065, 3196, 13896, 13897, 13897, 13897, 13897, 13897, 13897, 2458615, 58614, N'2019-05-11', 201919, 19, 6, N'2019-W19', N'2019-W19-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97285, CAST(N'2019-05-12' AS date), CAST(N'2019-05-13' AS date), 2019, 20192, 201905, 2019132, 2, 5, 132, 12, 1, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-06' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-10' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-17' AS date), 1065, 3196, 13897, 13897, 13897, 13897, 13897, 13897, 13897, 2458616, 58615, N'2019-05-12', 201919, 19, 7, N'2019-W19', N'2019-W19-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97286, CAST(N'2019-05-13' AS date), CAST(N'2019-05-14' AS date), 2019, 20192, 201905, 2019133, 2, 5, 133, 13, 2, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-07' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-10' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-17' AS date), 1065, 3196, 13897, 13898, 13897, 13897, 13897, 13897, 13897, 2458617, 58616, N'2019-05-13', 201920, 20, 1, N'2019-W20', N'2019-W20-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97287, CAST(N'2019-05-14' AS date), CAST(N'2019-05-15' AS date), 2019, 20192, 201905, 2019134, 2, 5, 134, 14, 3, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-08' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-10' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-17' AS date), 1065, 3196, 13897, 13898, 13898, 13897, 13897, 13897, 13897, 2458618, 58617, N'2019-05-14', 201920, 20, 2, N'2019-W20', N'2019-W20-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97288, CAST(N'2019-05-15' AS date), CAST(N'2019-05-16' AS date), 2019, 20192, 201905, 2019135, 2, 5, 135, 15, 4, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-09' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-10' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-17' AS date), 1065, 3196, 13897, 13898, 13898, 13898, 13897, 13897, 13897, 2458619, 58618, N'2019-05-15', 201920, 20, 3, N'2019-W20', N'2019-W20-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97289, CAST(N'2019-05-16' AS date), CAST(N'2019-05-17' AS date), 2019, 20192, 201905, 2019136, 2, 5, 136, 16, 5, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-10' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-17' AS date), 1065, 3196, 13897, 13898, 13898, 13898, 13898, 13897, 13897, 2458620, 58619, N'2019-05-16', 201920, 20, 4, N'2019-W20', N'2019-W20-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97290, CAST(N'2019-05-17' AS date), CAST(N'2019-05-18' AS date), 2019, 20192, 201905, 2019137, 2, 5, 137, 17, 6, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-17' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-11' AS date), CAST(N'2019-05-17' AS date), 1065, 3196, 13897, 13898, 13898, 13898, 13898, 13898, 13897, 2458621, 58620, N'2019-05-17', 201920, 20, 5, N'2019-W20', N'2019-W20-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97291, CAST(N'2019-05-18' AS date), CAST(N'2019-05-19' AS date), 2019, 20192, 201905, 2019138, 2, 5, 138, 18, 7, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-12' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-17' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-24' AS date), 1065, 3196, 13897, 13898, 13898, 13898, 13898, 13898, 13898, 2458622, 58621, N'2019-05-18', 201920, 20, 6, N'2019-W20', N'2019-W20-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97292, CAST(N'2019-05-19' AS date), CAST(N'2019-05-20' AS date), 2019, 20192, 201905, 2019139, 2, 5, 139, 19, 1, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-13' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-17' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-24' AS date), 1065, 3196, 13898, 13898, 13898, 13898, 13898, 13898, 13898, 2458623, 58622, N'2019-05-19', 201920, 20, 7, N'2019-W20', N'2019-W20-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97293, CAST(N'2019-05-20' AS date), CAST(N'2019-05-21' AS date), 2019, 20192, 201905, 2019140, 2, 5, 140, 20, 2, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-05-14' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-17' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-24' AS date), 1065, 3196, 13898, 13899, 13898, 13898, 13898, 13898, 13898, 2458624, 58623, N'2019-05-20', 201921, 21, 1, N'2019-W21', N'2019-W21-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97294, CAST(N'2019-05-21' AS date), CAST(N'2019-05-22' AS date), 2019, 20192, 201905, 2019141, 2, 5, 141, 21, 3, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-05-15' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-17' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-24' AS date), 1065, 3196, 13898, 13899, 13899, 13898, 13898, 13898, 13898, 2458625, 58624, N'2019-05-21', 201921, 21, 2, N'2019-W21', N'2019-W21-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97295, CAST(N'2019-05-22' AS date), CAST(N'2019-05-23' AS date), 2019, 20192, 201905, 2019142, 2, 5, 142, 22, 4, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-05-16' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-17' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-24' AS date), 1065, 3196, 13898, 13899, 13899, 13899, 13898, 13898, 13898, 2458626, 58625, N'2019-05-22', 201921, 21, 3, N'2019-W21', N'2019-W21-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97296, CAST(N'2019-05-23' AS date), CAST(N'2019-05-24' AS date), 2019, 20192, 201905, 2019143, 2, 5, 143, 23, 5, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-05-17' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-24' AS date), 1065, 3196, 13898, 13899, 13899, 13899, 13899, 13898, 13898, 2458627, 58626, N'2019-05-23', 201921, 21, 4, N'2019-W21', N'2019-W21-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97297, CAST(N'2019-05-24' AS date), CAST(N'2019-05-25' AS date), 2019, 20192, 201905, 2019144, 2, 5, 144, 24, 6, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-05-24' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-05-18' AS date), CAST(N'2019-05-24' AS date), 1065, 3196, 13898, 13899, 13899, 13899, 13899, 13899, 13898, 2458628, 58627, N'2019-05-24', 201921, 21, 5, N'2019-W21', N'2019-W21-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97298, CAST(N'2019-05-25' AS date), CAST(N'2019-05-26' AS date), 2019, 20192, 201905, 2019145, 2, 5, 145, 25, 7, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-19' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-05-24' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-31' AS date), 1065, 3196, 13898, 13899, 13899, 13899, 13899, 13899, 13899, 2458629, 58628, N'2019-05-25', 201921, 21, 6, N'2019-W21', N'2019-W21-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97299, CAST(N'2019-05-26' AS date), CAST(N'2019-05-27' AS date), 2019, 20192, 201905, 2019146, 2, 5, 146, 26, 1, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-05-20' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-05-24' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-31' AS date), 1065, 3196, 13899, 13899, 13899, 13899, 13899, 13899, 13899, 2458630, 58629, N'2019-05-26', 201921, 21, 7, N'2019-W21', N'2019-W21-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97300, CAST(N'2019-05-27' AS date), CAST(N'2019-05-28' AS date), 2019, 20192, 201905, 2019147, 2, 5, 147, 27, 2, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-05-21' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-05-24' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-31' AS date), 1065, 3196, 13899, 13900, 13899, 13899, 13899, 13899, 13899, 2458631, 58630, N'2019-05-27', 201922, 22, 1, N'2019-W22', N'2019-W22-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97301, CAST(N'2019-05-28' AS date), CAST(N'2019-05-29' AS date), 2019, 20192, 201905, 2019148, 2, 5, 148, 28, 3, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-05-22' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-05-24' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-31' AS date), 1065, 3196, 13899, 13900, 13900, 13899, 13899, 13899, 13899, 2458632, 58631, N'2019-05-28', 201922, 22, 2, N'2019-W22', N'2019-W22-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97302, CAST(N'2019-05-29' AS date), CAST(N'2019-05-30' AS date), 2019, 20192, 201905, 2019149, 2, 5, 149, 29, 4, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-05-23' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-05-24' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-31' AS date), 1065, 3196, 13899, 13900, 13900, 13900, 13899, 13899, 13899, 2458633, 58632, N'2019-05-29', 201922, 22, 3, N'2019-W22', N'2019-W22-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97303, CAST(N'2019-05-30' AS date), CAST(N'2019-05-31' AS date), 2019, 20192, 201905, 2019150, 2, 5, 150, 30, 5, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-05-24' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-31' AS date), 1065, 3196, 13899, 13900, 13900, 13900, 13900, 13899, 13899, 2458634, 58633, N'2019-05-30', 201922, 22, 4, N'2019-W22', N'2019-W22-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97304, CAST(N'2019-05-31' AS date), CAST(N'2019-06-01' AS date), 2019, 20192, 201905, 2019151, 2, 5, 151, 31, 6, N'2019', N'2019 Q2', N'2019 May', N'May', N'May', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-01' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-05-25' AS date), CAST(N'2019-05-31' AS date), 1065, 3196, 13899, 13900, 13900, 13900, 13900, 13900, 13899, 2458635, 58634, N'2019-05-31', 201922, 22, 5, N'2019-W22', N'2019-W22-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97305, CAST(N'2019-06-01' AS date), CAST(N'2019-06-02' AS date), 2019, 20192, 201906, 2019152, 2, 6, 152, 1, 7, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-05-26' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-07' AS date), 1065, 3197, 13899, 13900, 13900, 13900, 13900, 13900, 13900, 2458636, 58635, N'2019-06-01', 201922, 22, 6, N'2019-W22', N'2019-W22-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97306, CAST(N'2019-06-02' AS date), CAST(N'2019-06-03' AS date), 2019, 20192, 201906, 2019153, 2, 6, 153, 2, 1, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-05-27' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-07' AS date), 1065, 3197, 13900, 13900, 13900, 13900, 13900, 13900, 13900, 2458637, 58636, N'2019-06-02', 201922, 22, 7, N'2019-W22', N'2019-W22-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97307, CAST(N'2019-06-03' AS date), CAST(N'2019-06-04' AS date), 2019, 20192, 201906, 2019154, 2, 6, 154, 3, 2, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-05-28' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-07' AS date), 1065, 3197, 13900, 13901, 13900, 13900, 13900, 13900, 13900, 2458638, 58637, N'2019-06-03', 201923, 23, 1, N'2019-W23', N'2019-W23-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97308, CAST(N'2019-06-04' AS date), CAST(N'2019-06-05' AS date), 2019, 20192, 201906, 2019155, 2, 6, 155, 4, 3, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-05-29' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-07' AS date), 1065, 3197, 13900, 13901, 13901, 13900, 13900, 13900, 13900, 2458639, 58638, N'2019-06-04', 201923, 23, 2, N'2019-W23', N'2019-W23-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97309, CAST(N'2019-06-05' AS date), CAST(N'2019-06-06' AS date), 2019, 20192, 201906, 2019156, 2, 6, 156, 5, 4, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-05-30' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-07' AS date), 1065, 3197, 13900, 13901, 13901, 13901, 13900, 13900, 13900, 2458640, 58639, N'2019-06-05', 201923, 23, 3, N'2019-W23', N'2019-W23-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97310, CAST(N'2019-06-06' AS date), CAST(N'2019-06-07' AS date), 2019, 20192, 201906, 2019157, 2, 6, 157, 6, 5, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-05-31' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-07' AS date), 1065, 3197, 13900, 13901, 13901, 13901, 13901, 13900, 13900, 2458641, 58640, N'2019-06-06', 201923, 23, 4, N'2019-W23', N'2019-W23-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97311, CAST(N'2019-06-07' AS date), CAST(N'2019-06-08' AS date), 2019, 20192, 201906, 2019158, 2, 6, 158, 7, 6, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-07' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-07' AS date), 1065, 3197, 13900, 13901, 13901, 13901, 13901, 13901, 13900, 2458642, 58641, N'2019-06-07', 201923, 23, 5, N'2019-W23', N'2019-W23-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97312, CAST(N'2019-06-08' AS date), CAST(N'2019-06-09' AS date), 2019, 20192, 201906, 2019159, 2, 6, 159, 8, 7, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-02' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-07' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-14' AS date), 1065, 3197, 13900, 13901, 13901, 13901, 13901, 13901, 13901, 2458643, 58642, N'2019-06-08', 201923, 23, 6, N'2019-W23', N'2019-W23-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97313, CAST(N'2019-06-09' AS date), CAST(N'2019-06-10' AS date), 2019, 20192, 201906, 2019160, 2, 6, 160, 9, 1, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-03' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-07' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-14' AS date), 1065, 3197, 13901, 13901, 13901, 13901, 13901, 13901, 13901, 2458644, 58643, N'2019-06-09', 201923, 23, 7, N'2019-W23', N'2019-W23-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97314, CAST(N'2019-06-10' AS date), CAST(N'2019-06-11' AS date), 2019, 20192, 201906, 2019161, 2, 6, 161, 10, 2, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-04' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-07' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-14' AS date), 1065, 3197, 13901, 13902, 13901, 13901, 13901, 13901, 13901, 2458645, 58644, N'2019-06-10', 201924, 24, 1, N'2019-W24', N'2019-W24-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97315, CAST(N'2019-06-11' AS date), CAST(N'2019-06-12' AS date), 2019, 20192, 201906, 2019162, 2, 6, 162, 11, 3, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-05' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-07' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-14' AS date), 1065, 3197, 13901, 13902, 13902, 13901, 13901, 13901, 13901, 2458646, 58645, N'2019-06-11', 201924, 24, 2, N'2019-W24', N'2019-W24-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97316, CAST(N'2019-06-12' AS date), CAST(N'2019-06-13' AS date), 2019, 20192, 201906, 2019163, 2, 6, 163, 12, 4, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-06' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-07' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-14' AS date), 1065, 3197, 13901, 13902, 13902, 13902, 13901, 13901, 13901, 2458647, 58646, N'2019-06-12', 201924, 24, 3, N'2019-W24', N'2019-W24-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97317, CAST(N'2019-06-13' AS date), CAST(N'2019-06-14' AS date), 2019, 20192, 201906, 2019164, 2, 6, 164, 13, 5, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-07' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-14' AS date), 1065, 3197, 13901, 13902, 13902, 13902, 13902, 13901, 13901, 2458648, 58647, N'2019-06-13', 201924, 24, 4, N'2019-W24', N'2019-W24-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97318, CAST(N'2019-06-14' AS date), CAST(N'2019-06-15' AS date), 2019, 20192, 201906, 2019165, 2, 6, 165, 14, 6, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-14' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-08' AS date), CAST(N'2019-06-14' AS date), 1065, 3197, 13901, 13902, 13902, 13902, 13902, 13902, 13901, 2458649, 58648, N'2019-06-14', 201924, 24, 5, N'2019-W24', N'2019-W24-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97319, CAST(N'2019-06-15' AS date), CAST(N'2019-06-16' AS date), 2019, 20192, 201906, 2019166, 2, 6, 166, 15, 7, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-09' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-14' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-21' AS date), 1065, 3197, 13901, 13902, 13902, 13902, 13902, 13902, 13902, 2458650, 58649, N'2019-06-15', 201924, 24, 6, N'2019-W24', N'2019-W24-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97320, CAST(N'2019-06-16' AS date), CAST(N'2019-06-17' AS date), 2019, 20192, 201906, 2019167, 2, 6, 167, 16, 1, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-10' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-14' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-21' AS date), 1065, 3197, 13902, 13902, 13902, 13902, 13902, 13902, 13902, 2458651, 58650, N'2019-06-16', 201924, 24, 7, N'2019-W24', N'2019-W24-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97321, CAST(N'2019-06-17' AS date), CAST(N'2019-06-18' AS date), 2019, 20192, 201906, 2019168, 2, 6, 168, 17, 2, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-11' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-14' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-21' AS date), 1065, 3197, 13902, 13903, 13902, 13902, 13902, 13902, 13902, 2458652, 58651, N'2019-06-17', 201925, 25, 1, N'2019-W25', N'2019-W25-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97322, CAST(N'2019-06-18' AS date), CAST(N'2019-06-19' AS date), 2019, 20192, 201906, 2019169, 2, 6, 169, 18, 3, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-12' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-14' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-21' AS date), 1065, 3197, 13902, 13903, 13903, 13902, 13902, 13902, 13902, 2458653, 58652, N'2019-06-18', 201925, 25, 2, N'2019-W25', N'2019-W25-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97323, CAST(N'2019-06-19' AS date), CAST(N'2019-06-20' AS date), 2019, 20192, 201906, 2019170, 2, 6, 170, 19, 4, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-06-13' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-14' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-21' AS date), 1065, 3197, 13902, 13903, 13903, 13903, 13902, 13902, 13902, 2458654, 58653, N'2019-06-19', 201925, 25, 3, N'2019-W25', N'2019-W25-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97324, CAST(N'2019-06-20' AS date), CAST(N'2019-06-21' AS date), 2019, 20192, 201906, 2019171, 2, 6, 171, 20, 5, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-06-14' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-21' AS date), 1065, 3197, 13902, 13903, 13903, 13903, 13903, 13902, 13902, 2458655, 58654, N'2019-06-20', 201925, 25, 4, N'2019-W25', N'2019-W25-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97325, CAST(N'2019-06-21' AS date), CAST(N'2019-06-22' AS date), 2019, 20192, 201906, 2019172, 2, 6, 172, 21, 6, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-06-21' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-06-15' AS date), CAST(N'2019-06-21' AS date), 1065, 3197, 13902, 13903, 13903, 13903, 13903, 13903, 13902, 2458656, 58655, N'2019-06-21', 201925, 25, 5, N'2019-W25', N'2019-W25-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97326, CAST(N'2019-06-22' AS date), CAST(N'2019-06-23' AS date), 2019, 20192, 201906, 2019173, 2, 6, 173, 22, 7, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-16' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-06-21' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-28' AS date), 1065, 3197, 13902, 13903, 13903, 13903, 13903, 13903, 13903, 2458657, 58656, N'2019-06-22', 201925, 25, 6, N'2019-W25', N'2019-W25-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97327, CAST(N'2019-06-23' AS date), CAST(N'2019-06-24' AS date), 2019, 20192, 201906, 2019174, 2, 6, 174, 23, 1, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-06-17' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-06-21' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-28' AS date), 1065, 3197, 13903, 13903, 13903, 13903, 13903, 13903, 13903, 2458658, 58657, N'2019-06-23', 201925, 25, 7, N'2019-W25', N'2019-W25-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97328, CAST(N'2019-06-24' AS date), CAST(N'2019-06-25' AS date), 2019, 20192, 201906, 2019175, 2, 6, 175, 24, 2, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-18' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-06-21' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-28' AS date), 1065, 3197, 13903, 13904, 13903, 13903, 13903, 13903, 13903, 2458659, 58658, N'2019-06-24', 201926, 26, 1, N'2019-W26', N'2019-W26-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97329, CAST(N'2019-06-25' AS date), CAST(N'2019-06-26' AS date), 2019, 20192, 201906, 2019176, 2, 6, 176, 25, 3, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-06-19' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-06-21' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-28' AS date), 1065, 3197, 13903, 13904, 13904, 13903, 13903, 13903, 13903, 2458660, 58659, N'2019-06-25', 201926, 26, 2, N'2019-W26', N'2019-W26-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97330, CAST(N'2019-06-26' AS date), CAST(N'2019-06-27' AS date), 2019, 20192, 201906, 2019177, 2, 6, 177, 26, 4, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-06-20' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-06-21' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-28' AS date), 1065, 3197, 13903, 13904, 13904, 13904, 13903, 13903, 13903, 2458661, 58660, N'2019-06-26', 201926, 26, 3, N'2019-W26', N'2019-W26-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97331, CAST(N'2019-06-27' AS date), CAST(N'2019-06-28' AS date), 2019, 20192, 201906, 2019178, 2, 6, 178, 27, 5, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-06-21' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-28' AS date), 1065, 3197, 13903, 13904, 13904, 13904, 13904, 13903, 13903, 2458662, 58661, N'2019-06-27', 201926, 26, 4, N'2019-W26', N'2019-W26-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97332, CAST(N'2019-06-28' AS date), CAST(N'2019-06-29' AS date), 2019, 20192, 201906, 2019179, 2, 6, 179, 28, 6, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-06-28' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-06-22' AS date), CAST(N'2019-06-28' AS date), 1065, 3197, 13903, 13904, 13904, 13904, 13904, 13904, 13903, 2458663, 58662, N'2019-06-28', 201926, 26, 5, N'2019-W26', N'2019-W26-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97333, CAST(N'2019-06-29' AS date), CAST(N'2019-06-30' AS date), 2019, 20192, 201906, 2019180, 2, 6, 180, 29, 7, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-23' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-06-28' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-07-05' AS date), 1065, 3197, 13903, 13904, 13904, 13904, 13904, 13904, 13904, 2458664, 58663, N'2019-06-29', 201926, 26, 6, N'2019-W26', N'2019-W26-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97334, CAST(N'2019-06-30' AS date), CAST(N'2019-07-01' AS date), 2019, 20192, 201906, 2019181, 2, 6, 181, 30, 1, N'2019', N'2019 Q2', N'2019 Jun', N'Jun', N'June', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-04-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-01' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-06-24' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-06-28' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-07-05' AS date), 1065, 3197, 13904, 13904, 13904, 13904, 13904, 13904, 13904, 2458665, 58664, N'2019-06-30', 201926, 26, 7, N'2019-W26', N'2019-W26-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97335, CAST(N'2019-07-01' AS date), CAST(N'2019-07-02' AS date), 2019, 20193, 201907, 2019182, 3, 7, 182, 1, 2, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-06-25' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-06-28' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-07-05' AS date), 1066, 3198, 13904, 13905, 13904, 13904, 13904, 13904, 13904, 2458666, 58665, N'2019-07-01', 201927, 27, 1, N'2019-W27', N'2019-W27-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97336, CAST(N'2019-07-02' AS date), CAST(N'2019-07-03' AS date), 2019, 20193, 201907, 2019183, 3, 7, 183, 2, 3, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-06-26' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-06-28' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-07-05' AS date), 1066, 3198, 13904, 13905, 13905, 13904, 13904, 13904, 13904, 2458667, 58666, N'2019-07-02', 201927, 27, 2, N'2019-W27', N'2019-W27-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97337, CAST(N'2019-07-03' AS date), CAST(N'2019-07-04' AS date), 2019, 20193, 201907, 2019184, 3, 7, 184, 3, 4, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-06-27' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-06-28' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-07-05' AS date), 1066, 3198, 13904, 13905, 13905, 13905, 13904, 13904, 13904, 2458668, 58667, N'2019-07-03', 201927, 27, 3, N'2019-W27', N'2019-W27-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97338, CAST(N'2019-07-04' AS date), CAST(N'2019-07-05' AS date), 2019, 20193, 201907, 2019185, 3, 7, 185, 4, 5, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-06-28' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-07-05' AS date), 1066, 3198, 13904, 13905, 13905, 13905, 13905, 13904, 13904, 2458669, 58668, N'2019-07-04', 201927, 27, 4, N'2019-W27', N'2019-W27-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97339, CAST(N'2019-07-05' AS date), CAST(N'2019-07-06' AS date), 2019, 20193, 201907, 2019186, 3, 7, 186, 5, 6, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-05' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-06-29' AS date), CAST(N'2019-07-05' AS date), 1066, 3198, 13904, 13905, 13905, 13905, 13905, 13905, 13904, 2458670, 58669, N'2019-07-05', 201927, 27, 5, N'2019-W27', N'2019-W27-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97340, CAST(N'2019-07-06' AS date), CAST(N'2019-07-07' AS date), 2019, 20193, 201907, 2019187, 3, 7, 187, 6, 7, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-06-30' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-05' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-12' AS date), 1066, 3198, 13904, 13905, 13905, 13905, 13905, 13905, 13905, 2458671, 58670, N'2019-07-06', 201927, 27, 6, N'2019-W27', N'2019-W27-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97341, CAST(N'2019-07-07' AS date), CAST(N'2019-07-08' AS date), 2019, 20193, 201907, 2019188, 3, 7, 188, 7, 1, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-05' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-12' AS date), 1066, 3198, 13905, 13905, 13905, 13905, 13905, 13905, 13905, 2458672, 58671, N'2019-07-07', 201927, 27, 7, N'2019-W27', N'2019-W27-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97342, CAST(N'2019-07-08' AS date), CAST(N'2019-07-09' AS date), 2019, 20193, 201907, 2019189, 3, 7, 189, 8, 2, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-02' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-05' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-12' AS date), 1066, 3198, 13905, 13906, 13905, 13905, 13905, 13905, 13905, 2458673, 58672, N'2019-07-08', 201928, 28, 1, N'2019-W28', N'2019-W28-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97343, CAST(N'2019-07-09' AS date), CAST(N'2019-07-10' AS date), 2019, 20193, 201907, 2019190, 3, 7, 190, 9, 3, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-03' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-05' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-12' AS date), 1066, 3198, 13905, 13906, 13906, 13905, 13905, 13905, 13905, 2458674, 58673, N'2019-07-09', 201928, 28, 2, N'2019-W28', N'2019-W28-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97344, CAST(N'2019-07-10' AS date), CAST(N'2019-07-11' AS date), 2019, 20193, 201907, 2019191, 3, 7, 191, 10, 4, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-04' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-05' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-12' AS date), 1066, 3198, 13905, 13906, 13906, 13906, 13905, 13905, 13905, 2458675, 58674, N'2019-07-10', 201928, 28, 3, N'2019-W28', N'2019-W28-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97345, CAST(N'2019-07-11' AS date), CAST(N'2019-07-12' AS date), 2019, 20193, 201907, 2019192, 3, 7, 192, 11, 5, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-05' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-12' AS date), 1066, 3198, 13905, 13906, 13906, 13906, 13906, 13905, 13905, 2458676, 58675, N'2019-07-11', 201928, 28, 4, N'2019-W28', N'2019-W28-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97346, CAST(N'2019-07-12' AS date), CAST(N'2019-07-13' AS date), 2019, 20193, 201907, 2019193, 3, 7, 193, 12, 6, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-12' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-06' AS date), CAST(N'2019-07-12' AS date), 1066, 3198, 13905, 13906, 13906, 13906, 13906, 13906, 13905, 2458677, 58676, N'2019-07-12', 201928, 28, 5, N'2019-W28', N'2019-W28-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97347, CAST(N'2019-07-13' AS date), CAST(N'2019-07-14' AS date), 2019, 20193, 201907, 2019194, 3, 7, 194, 13, 7, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-07' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-12' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-19' AS date), 1066, 3198, 13905, 13906, 13906, 13906, 13906, 13906, 13906, 2458678, 58677, N'2019-07-13', 201928, 28, 6, N'2019-W28', N'2019-W28-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97348, CAST(N'2019-07-14' AS date), CAST(N'2019-07-15' AS date), 2019, 20193, 201907, 2019195, 3, 7, 195, 14, 1, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-08' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-12' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-19' AS date), 1066, 3198, 13906, 13906, 13906, 13906, 13906, 13906, 13906, 2458679, 58678, N'2019-07-14', 201928, 28, 7, N'2019-W28', N'2019-W28-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97349, CAST(N'2019-07-15' AS date), CAST(N'2019-07-16' AS date), 2019, 20193, 201907, 2019196, 3, 7, 196, 15, 2, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-09' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-12' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-19' AS date), 1066, 3198, 13906, 13907, 13906, 13906, 13906, 13906, 13906, 2458680, 58679, N'2019-07-15', 201929, 29, 1, N'2019-W29', N'2019-W29-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97350, CAST(N'2019-07-16' AS date), CAST(N'2019-07-17' AS date), 2019, 20193, 201907, 2019197, 3, 7, 197, 16, 3, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-10' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-12' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-19' AS date), 1066, 3198, 13906, 13907, 13907, 13906, 13906, 13906, 13906, 2458681, 58680, N'2019-07-16', 201929, 29, 2, N'2019-W29', N'2019-W29-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97351, CAST(N'2019-07-17' AS date), CAST(N'2019-07-18' AS date), 2019, 20193, 201907, 2019198, 3, 7, 198, 17, 4, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-11' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-12' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-19' AS date), 1066, 3198, 13906, 13907, 13907, 13907, 13906, 13906, 13906, 2458682, 58681, N'2019-07-17', 201929, 29, 3, N'2019-W29', N'2019-W29-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97352, CAST(N'2019-07-18' AS date), CAST(N'2019-07-19' AS date), 2019, 20193, 201907, 2019199, 3, 7, 199, 18, 5, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-12' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-19' AS date), 1066, 3198, 13906, 13907, 13907, 13907, 13907, 13906, 13906, 2458683, 58682, N'2019-07-18', 201929, 29, 4, N'2019-W29', N'2019-W29-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97353, CAST(N'2019-07-19' AS date), CAST(N'2019-07-20' AS date), 2019, 20193, 201907, 2019200, 3, 7, 200, 19, 6, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-19' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-13' AS date), CAST(N'2019-07-19' AS date), 1066, 3198, 13906, 13907, 13907, 13907, 13907, 13907, 13906, 2458684, 58683, N'2019-07-19', 201929, 29, 5, N'2019-W29', N'2019-W29-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97354, CAST(N'2019-07-20' AS date), CAST(N'2019-07-21' AS date), 2019, 20193, 201907, 2019201, 3, 7, 201, 20, 7, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-14' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-19' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-26' AS date), 1066, 3198, 13906, 13907, 13907, 13907, 13907, 13907, 13907, 2458685, 58684, N'2019-07-20', 201929, 29, 6, N'2019-W29', N'2019-W29-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97355, CAST(N'2019-07-21' AS date), CAST(N'2019-07-22' AS date), 2019, 20193, 201907, 2019202, 3, 7, 202, 21, 1, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-07-15' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-19' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-26' AS date), 1066, 3198, 13907, 13907, 13907, 13907, 13907, 13907, 13907, 2458686, 58685, N'2019-07-21', 201929, 29, 7, N'2019-W29', N'2019-W29-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97356, CAST(N'2019-07-22' AS date), CAST(N'2019-07-23' AS date), 2019, 20193, 201907, 2019203, 3, 7, 203, 22, 2, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-07-16' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-19' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-26' AS date), 1066, 3198, 13907, 13908, 13907, 13907, 13907, 13907, 13907, 2458687, 58686, N'2019-07-22', 201930, 30, 1, N'2019-W30', N'2019-W30-1');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97357, CAST(N'2019-07-23' AS date), CAST(N'2019-07-24' AS date), 2019, 20193, 201907, 2019204, 3, 7, 204, 23, 3, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-07-17' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-19' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-26' AS date), 1066, 3198, 13907, 13908, 13908, 13907, 13907, 13907, 13907, 2458688, 58687, N'2019-07-23', 201930, 30, 2, N'2019-W30', N'2019-W30-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97358, CAST(N'2019-07-24' AS date), CAST(N'2019-07-25' AS date), 2019, 20193, 201907, 2019205, 3, 7, 205, 24, 4, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-07-18' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-19' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-26' AS date), 1066, 3198, 13907, 13908, 13908, 13908, 13907, 13907, 13907, 2458689, 58688, N'2019-07-24', 201930, 30, 3, N'2019-W30', N'2019-W30-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97359, CAST(N'2019-07-25' AS date), CAST(N'2019-07-26' AS date), 2019, 20193, 201907, 2019206, 3, 7, 206, 25, 5, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-19' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-26' AS date), 1066, 3198, 13907, 13908, 13908, 13908, 13908, 13907, 13907, 2458690, 58689, N'2019-07-25', 201930, 30, 4, N'2019-W30', N'2019-W30-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97360, CAST(N'2019-07-26' AS date), CAST(N'2019-07-27' AS date), 2019, 20193, 201907, 2019207, 3, 7, 207, 26, 6, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-26' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-07-20' AS date), CAST(N'2019-07-26' AS date), 1066, 3198, 13907, 13908, 13908, 13908, 13908, 13908, 13907, 2458691, 58690, N'2019-07-26', 201930, 30, 5, N'2019-W30', N'2019-W30-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97361, CAST(N'2019-07-27' AS date), CAST(N'2019-07-28' AS date), 2019, 20193, 201907, 2019208, 3, 7, 208, 27, 7, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-21' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-26' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-08-02' AS date), 1066, 3198, 13907, 13908, 13908, 13908, 13908, 13908, 13908, 2458692, 58691, N'2019-07-27', 201930, 30, 6, N'2019-W30', N'2019-W30-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97362, CAST(N'2019-07-28' AS date), CAST(N'2019-07-29' AS date), 2019, 20193, 201907, 2019209, 3, 7, 209, 28, 1, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-07-22' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-26' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-08-02' AS date), 1066, 3198, 13908, 13908, 13908, 13908, 13908, 13908, 13908, 2458693, 58692, N'2019-07-28', 201930, 30, 7, N'2019-W30', N'2019-W30-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97363, CAST(N'2019-07-29' AS date), CAST(N'2019-07-30' AS date), 2019, 20193, 201907, 2019210, 3, 7, 210, 29, 2, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-07-23' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-26' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-08-02' AS date), 1066, 3198, 13908, 13909, 13908, 13908, 13908, 13908, 13908, 2458694, 58693, N'2019-07-29', 201931, 31, 1, N'2019-W31', N'2019-W31-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97364, CAST(N'2019-07-30' AS date), CAST(N'2019-07-31' AS date), 2019, 20193, 201907, 2019211, 3, 7, 211, 30, 3, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-07-24' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-26' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-08-02' AS date), 1066, 3198, 13908, 13909, 13909, 13908, 13908, 13908, 13908, 2458695, 58694, N'2019-07-30', 201931, 31, 2, N'2019-W31', N'2019-W31-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97365, CAST(N'2019-07-31' AS date), CAST(N'2019-08-01' AS date), 2019, 20193, 201907, 2019212, 3, 7, 212, 31, 4, N'2019', N'2019 Q3', N'2019 Jul', N'Jul', N'July', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-07-25' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-07-26' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-08-02' AS date), 1066, 3198, 13908, 13909, 13909, 13909, 13908, 13908, 13908, 2458696, 58695, N'2019-07-31', 201931, 31, 3, N'2019-W31', N'2019-W31-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97366, CAST(N'2019-08-01' AS date), CAST(N'2019-08-02' AS date), 2019, 20193, 201908, 2019213, 3, 8, 213, 1, 5, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-07-26' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-08-02' AS date), 1066, 3199, 13908, 13909, 13909, 13909, 13909, 13908, 13908, 2458697, 58696, N'2019-08-01', 201931, 31, 4, N'2019-W31', N'2019-W31-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97367, CAST(N'2019-08-02' AS date), CAST(N'2019-08-03' AS date), 2019, 20193, 201908, 2019214, 3, 8, 214, 2, 6, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-02' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-07-27' AS date), CAST(N'2019-08-02' AS date), 1066, 3199, 13908, 13909, 13909, 13909, 13909, 13909, 13908, 2458698, 58697, N'2019-08-02', 201931, 31, 5, N'2019-W31', N'2019-W31-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97368, CAST(N'2019-08-03' AS date), CAST(N'2019-08-04' AS date), 2019, 20193, 201908, 2019215, 3, 8, 215, 3, 7, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-07-28' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-02' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-08-09' AS date), 1066, 3199, 13908, 13909, 13909, 13909, 13909, 13909, 13909, 2458699, 58698, N'2019-08-03', 201931, 31, 6, N'2019-W31', N'2019-W31-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97369, CAST(N'2019-08-04' AS date), CAST(N'2019-08-05' AS date), 2019, 20193, 201908, 2019216, 3, 8, 216, 4, 1, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-07-29' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-02' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-08-09' AS date), 1066, 3199, 13909, 13909, 13909, 13909, 13909, 13909, 13909, 2458700, 58699, N'2019-08-04', 201931, 31, 7, N'2019-W31', N'2019-W31-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97370, CAST(N'2019-08-05' AS date), CAST(N'2019-08-06' AS date), 2019, 20193, 201908, 2019217, 3, 8, 217, 5, 2, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-07-30' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-02' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-08-09' AS date), 1066, 3199, 13909, 13910, 13909, 13909, 13909, 13909, 13909, 2458701, 58700, N'2019-08-05', 201932, 32, 1, N'2019-W32', N'2019-W32-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97371, CAST(N'2019-08-06' AS date), CAST(N'2019-08-07' AS date), 2019, 20193, 201908, 2019218, 3, 8, 218, 6, 3, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-07-31' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-02' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-08-09' AS date), 1066, 3199, 13909, 13910, 13910, 13909, 13909, 13909, 13909, 2458702, 58701, N'2019-08-06', 201932, 32, 2, N'2019-W32', N'2019-W32-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97372, CAST(N'2019-08-07' AS date), CAST(N'2019-08-08' AS date), 2019, 20193, 201908, 2019219, 3, 8, 219, 7, 4, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-02' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-08-09' AS date), 1066, 3199, 13909, 13910, 13910, 13910, 13909, 13909, 13909, 2458703, 58702, N'2019-08-07', 201932, 32, 3, N'2019-W32', N'2019-W32-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97373, CAST(N'2019-08-08' AS date), CAST(N'2019-08-09' AS date), 2019, 20193, 201908, 2019220, 3, 8, 220, 8, 5, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-02' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-08-09' AS date), 1066, 3199, 13909, 13910, 13910, 13910, 13910, 13909, 13909, 2458704, 58703, N'2019-08-08', 201932, 32, 4, N'2019-W32', N'2019-W32-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97374, CAST(N'2019-08-09' AS date), CAST(N'2019-08-10' AS date), 2019, 20193, 201908, 2019221, 3, 8, 221, 9, 6, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-09' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-03' AS date), CAST(N'2019-08-09' AS date), 1066, 3199, 13909, 13910, 13910, 13910, 13910, 13910, 13909, 2458705, 58704, N'2019-08-09', 201932, 32, 5, N'2019-W32', N'2019-W32-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97375, CAST(N'2019-08-10' AS date), CAST(N'2019-08-11' AS date), 2019, 20193, 201908, 2019222, 3, 8, 222, 10, 7, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-04' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-09' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-16' AS date), 1066, 3199, 13909, 13910, 13910, 13910, 13910, 13910, 13910, 2458706, 58705, N'2019-08-10', 201932, 32, 6, N'2019-W32', N'2019-W32-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97376, CAST(N'2019-08-11' AS date), CAST(N'2019-08-12' AS date), 2019, 20193, 201908, 2019223, 3, 8, 223, 11, 1, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-05' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-09' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-16' AS date), 1066, 3199, 13910, 13910, 13910, 13910, 13910, 13910, 13910, 2458707, 58706, N'2019-08-11', 201932, 32, 7, N'2019-W32', N'2019-W32-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97377, CAST(N'2019-08-12' AS date), CAST(N'2019-08-13' AS date), 2019, 20193, 201908, 2019224, 3, 8, 224, 12, 2, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-06' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-09' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-16' AS date), 1066, 3199, 13910, 13911, 13910, 13910, 13910, 13910, 13910, 2458708, 58707, N'2019-08-12', 201933, 33, 1, N'2019-W33', N'2019-W33-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97378, CAST(N'2019-08-13' AS date), CAST(N'2019-08-14' AS date), 2019, 20193, 201908, 2019225, 3, 8, 225, 13, 3, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-07' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-09' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-16' AS date), 1066, 3199, 13910, 13911, 13911, 13910, 13910, 13910, 13910, 2458709, 58708, N'2019-08-13', 201933, 33, 2, N'2019-W33', N'2019-W33-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97379, CAST(N'2019-08-14' AS date), CAST(N'2019-08-15' AS date), 2019, 20193, 201908, 2019226, 3, 8, 226, 14, 4, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-08' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-09' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-16' AS date), 1066, 3199, 13910, 13911, 13911, 13911, 13910, 13910, 13910, 2458710, 58709, N'2019-08-14', 201933, 33, 3, N'2019-W33', N'2019-W33-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97380, CAST(N'2019-08-15' AS date), CAST(N'2019-08-16' AS date), 2019, 20193, 201908, 2019227, 3, 8, 227, 15, 5, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-09' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-16' AS date), 1066, 3199, 13910, 13911, 13911, 13911, 13911, 13910, 13910, 2458711, 58710, N'2019-08-15', 201933, 33, 4, N'2019-W33', N'2019-W33-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97381, CAST(N'2019-08-16' AS date), CAST(N'2019-08-17' AS date), 2019, 20193, 201908, 2019228, 3, 8, 228, 16, 6, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-16' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-10' AS date), CAST(N'2019-08-16' AS date), 1066, 3199, 13910, 13911, 13911, 13911, 13911, 13911, 13910, 2458712, 58711, N'2019-08-16', 201933, 33, 5, N'2019-W33', N'2019-W33-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97382, CAST(N'2019-08-17' AS date), CAST(N'2019-08-18' AS date), 2019, 20193, 201908, 2019229, 3, 8, 229, 17, 7, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-11' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-16' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-23' AS date), 1066, 3199, 13910, 13911, 13911, 13911, 13911, 13911, 13911, 2458713, 58712, N'2019-08-17', 201933, 33, 6, N'2019-W33', N'2019-W33-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97383, CAST(N'2019-08-18' AS date), CAST(N'2019-08-19' AS date), 2019, 20193, 201908, 2019230, 3, 8, 230, 18, 1, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-12' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-16' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-23' AS date), 1066, 3199, 13911, 13911, 13911, 13911, 13911, 13911, 13911, 2458714, 58713, N'2019-08-18', 201933, 33, 7, N'2019-W33', N'2019-W33-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97384, CAST(N'2019-08-19' AS date), CAST(N'2019-08-20' AS date), 2019, 20193, 201908, 2019231, 3, 8, 231, 19, 2, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-13' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-16' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-23' AS date), 1066, 3199, 13911, 13912, 13911, 13911, 13911, 13911, 13911, 2458715, 58714, N'2019-08-19', 201934, 34, 1, N'2019-W34', N'2019-W34-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97385, CAST(N'2019-08-20' AS date), CAST(N'2019-08-21' AS date), 2019, 20193, 201908, 2019232, 3, 8, 232, 20, 3, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-08-14' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-16' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-23' AS date), 1066, 3199, 13911, 13912, 13912, 13911, 13911, 13911, 13911, 2458716, 58715, N'2019-08-20', 201934, 34, 2, N'2019-W34', N'2019-W34-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97386, CAST(N'2019-08-21' AS date), CAST(N'2019-08-22' AS date), 2019, 20193, 201908, 2019233, 3, 8, 233, 21, 4, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-08-15' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-16' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-23' AS date), 1066, 3199, 13911, 13912, 13912, 13912, 13911, 13911, 13911, 2458717, 58716, N'2019-08-21', 201934, 34, 3, N'2019-W34', N'2019-W34-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97387, CAST(N'2019-08-22' AS date), CAST(N'2019-08-23' AS date), 2019, 20193, 201908, 2019234, 3, 8, 234, 22, 5, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-08-16' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-23' AS date), 1066, 3199, 13911, 13912, 13912, 13912, 13912, 13911, 13911, 2458718, 58717, N'2019-08-22', 201934, 34, 4, N'2019-W34', N'2019-W34-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97388, CAST(N'2019-08-23' AS date), CAST(N'2019-08-24' AS date), 2019, 20193, 201908, 2019235, 3, 8, 235, 23, 6, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-08-23' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-08-17' AS date), CAST(N'2019-08-23' AS date), 1066, 3199, 13911, 13912, 13912, 13912, 13912, 13912, 13911, 2458719, 58718, N'2019-08-23', 201934, 34, 5, N'2019-W34', N'2019-W34-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97389, CAST(N'2019-08-24' AS date), CAST(N'2019-08-25' AS date), 2019, 20193, 201908, 2019236, 3, 8, 236, 24, 7, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-18' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-08-23' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-30' AS date), 1066, 3199, 13911, 13912, 13912, 13912, 13912, 13912, 13912, 2458720, 58719, N'2019-08-24', 201934, 34, 6, N'2019-W34', N'2019-W34-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97390, CAST(N'2019-08-25' AS date), CAST(N'2019-08-26' AS date), 2019, 20193, 201908, 2019237, 3, 8, 237, 25, 1, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-19' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-08-23' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-30' AS date), 1066, 3199, 13912, 13912, 13912, 13912, 13912, 13912, 13912, 2458721, 58720, N'2019-08-25', 201934, 34, 7, N'2019-W34', N'2019-W34-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97391, CAST(N'2019-08-26' AS date), CAST(N'2019-08-27' AS date), 2019, 20193, 201908, 2019238, 3, 8, 238, 26, 2, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-08-20' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-08-23' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-30' AS date), 1066, 3199, 13912, 13913, 13912, 13912, 13912, 13912, 13912, 2458722, 58721, N'2019-08-26', 201935, 35, 1, N'2019-W35', N'2019-W35-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97392, CAST(N'2019-08-27' AS date), CAST(N'2019-08-28' AS date), 2019, 20193, 201908, 2019239, 3, 8, 239, 27, 3, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-08-21' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-08-23' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-30' AS date), 1066, 3199, 13912, 13913, 13913, 13912, 13912, 13912, 13912, 2458723, 58722, N'2019-08-27', 201935, 35, 2, N'2019-W35', N'2019-W35-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97393, CAST(N'2019-08-28' AS date), CAST(N'2019-08-29' AS date), 2019, 20193, 201908, 2019240, 3, 8, 240, 28, 4, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-08-22' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-08-23' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-30' AS date), 1066, 3199, 13912, 13913, 13913, 13913, 13912, 13912, 13912, 2458724, 58723, N'2019-08-28', 201935, 35, 3, N'2019-W35', N'2019-W35-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97394, CAST(N'2019-08-29' AS date), CAST(N'2019-08-30' AS date), 2019, 20193, 201908, 2019241, 3, 8, 241, 29, 5, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-08-23' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-30' AS date), 1066, 3199, 13912, 13913, 13913, 13913, 13913, 13912, 13912, 2458725, 58724, N'2019-08-29', 201935, 35, 4, N'2019-W35', N'2019-W35-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97395, CAST(N'2019-08-30' AS date), CAST(N'2019-08-31' AS date), 2019, 20193, 201908, 2019242, 3, 8, 242, 30, 6, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-08-30' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-08-24' AS date), CAST(N'2019-08-30' AS date), 1066, 3199, 13912, 13913, 13913, 13913, 13913, 13913, 13912, 2458726, 58725, N'2019-08-30', 201935, 35, 5, N'2019-W35', N'2019-W35-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97396, CAST(N'2019-08-31' AS date), CAST(N'2019-09-01' AS date), 2019, 20193, 201908, 2019243, 3, 8, 243, 31, 7, N'2019', N'2019 Q3', N'2019 Aug', N'Aug', N'August', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-08-01' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-25' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-08-30' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-09-06' AS date), 1066, 3199, 13912, 13913, 13913, 13913, 13913, 13913, 13913, 2458727, 58726, N'2019-08-31', 201935, 35, 6, N'2019-W35', N'2019-W35-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97397, CAST(N'2019-09-01' AS date), CAST(N'2019-09-02' AS date), 2019, 20193, 201909, 2019244, 3, 9, 244, 1, 1, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-08-26' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-08-30' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-09-06' AS date), 1066, 3200, 13913, 13913, 13913, 13913, 13913, 13913, 13913, 2458728, 58727, N'2019-09-01', 201935, 35, 7, N'2019-W35', N'2019-W35-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97398, CAST(N'2019-09-02' AS date), CAST(N'2019-09-03' AS date), 2019, 20193, 201909, 2019245, 3, 9, 245, 2, 2, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-08-27' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-08-30' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-09-06' AS date), 1066, 3200, 13913, 13914, 13913, 13913, 13913, 13913, 13913, 2458729, 58728, N'2019-09-02', 201936, 36, 1, N'2019-W36', N'2019-W36-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97399, CAST(N'2019-09-03' AS date), CAST(N'2019-09-04' AS date), 2019, 20193, 201909, 2019246, 3, 9, 246, 3, 3, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-08-28' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-08-30' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-09-06' AS date), 1066, 3200, 13913, 13914, 13914, 13913, 13913, 13913, 13913, 2458730, 58729, N'2019-09-03', 201936, 36, 2, N'2019-W36', N'2019-W36-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97400, CAST(N'2019-09-04' AS date), CAST(N'2019-09-05' AS date), 2019, 20193, 201909, 2019247, 3, 9, 247, 4, 4, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-08-29' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-08-30' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-09-06' AS date), 1066, 3200, 13913, 13914, 13914, 13914, 13913, 13913, 13913, 2458731, 58730, N'2019-09-04', 201936, 36, 3, N'2019-W36', N'2019-W36-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97401, CAST(N'2019-09-05' AS date), CAST(N'2019-09-06' AS date), 2019, 20193, 201909, 2019248, 3, 9, 248, 5, 5, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-08-30' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-09-06' AS date), 1066, 3200, 13913, 13914, 13914, 13914, 13914, 13913, 13913, 2458732, 58731, N'2019-09-05', 201936, 36, 4, N'2019-W36', N'2019-W36-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97402, CAST(N'2019-09-06' AS date), CAST(N'2019-09-07' AS date), 2019, 20193, 201909, 2019249, 3, 9, 249, 6, 6, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-06' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-08-31' AS date), CAST(N'2019-09-06' AS date), 1066, 3200, 13913, 13914, 13914, 13914, 13914, 13914, 13913, 2458733, 58732, N'2019-09-06', 201936, 36, 5, N'2019-W36', N'2019-W36-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97403, CAST(N'2019-09-07' AS date), CAST(N'2019-09-08' AS date), 2019, 20193, 201909, 2019250, 3, 9, 250, 7, 7, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-06' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-13' AS date), 1066, 3200, 13913, 13914, 13914, 13914, 13914, 13914, 13914, 2458734, 58733, N'2019-09-07', 201936, 36, 6, N'2019-W36', N'2019-W36-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97404, CAST(N'2019-09-08' AS date), CAST(N'2019-09-09' AS date), 2019, 20193, 201909, 2019251, 3, 9, 251, 8, 1, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-02' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-06' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-13' AS date), 1066, 3200, 13914, 13914, 13914, 13914, 13914, 13914, 13914, 2458735, 58734, N'2019-09-08', 201936, 36, 7, N'2019-W36', N'2019-W36-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97405, CAST(N'2019-09-09' AS date), CAST(N'2019-09-10' AS date), 2019, 20193, 201909, 2019252, 3, 9, 252, 9, 2, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-03' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-06' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-13' AS date), 1066, 3200, 13914, 13915, 13914, 13914, 13914, 13914, 13914, 2458736, 58735, N'2019-09-09', 201937, 37, 1, N'2019-W37', N'2019-W37-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97406, CAST(N'2019-09-10' AS date), CAST(N'2019-09-11' AS date), 2019, 20193, 201909, 2019253, 3, 9, 253, 10, 3, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-04' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-06' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-13' AS date), 1066, 3200, 13914, 13915, 13915, 13914, 13914, 13914, 13914, 2458737, 58736, N'2019-09-10', 201937, 37, 2, N'2019-W37', N'2019-W37-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97407, CAST(N'2019-09-11' AS date), CAST(N'2019-09-12' AS date), 2019, 20193, 201909, 2019254, 3, 9, 254, 11, 4, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-05' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-06' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-13' AS date), 1066, 3200, 13914, 13915, 13915, 13915, 13914, 13914, 13914, 2458738, 58737, N'2019-09-11', 201937, 37, 3, N'2019-W37', N'2019-W37-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97408, CAST(N'2019-09-12' AS date), CAST(N'2019-09-13' AS date), 2019, 20193, 201909, 2019255, 3, 9, 255, 12, 5, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-06' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-13' AS date), 1066, 3200, 13914, 13915, 13915, 13915, 13915, 13914, 13914, 2458739, 58738, N'2019-09-12', 201937, 37, 4, N'2019-W37', N'2019-W37-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97409, CAST(N'2019-09-13' AS date), CAST(N'2019-09-14' AS date), 2019, 20193, 201909, 2019256, 3, 9, 256, 13, 6, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-13' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-07' AS date), CAST(N'2019-09-13' AS date), 1066, 3200, 13914, 13915, 13915, 13915, 13915, 13915, 13914, 2458740, 58739, N'2019-09-13', 201937, 37, 5, N'2019-W37', N'2019-W37-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97410, CAST(N'2019-09-14' AS date), CAST(N'2019-09-15' AS date), 2019, 20193, 201909, 2019257, 3, 9, 257, 14, 7, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-08' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-13' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-20' AS date), 1066, 3200, 13914, 13915, 13915, 13915, 13915, 13915, 13915, 2458741, 58740, N'2019-09-14', 201937, 37, 6, N'2019-W37', N'2019-W37-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97411, CAST(N'2019-09-15' AS date), CAST(N'2019-09-16' AS date), 2019, 20193, 201909, 2019258, 3, 9, 258, 15, 1, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-09' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-13' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-20' AS date), 1066, 3200, 13915, 13915, 13915, 13915, 13915, 13915, 13915, 2458742, 58741, N'2019-09-15', 201937, 37, 7, N'2019-W37', N'2019-W37-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97412, CAST(N'2019-09-16' AS date), CAST(N'2019-09-17' AS date), 2019, 20193, 201909, 2019259, 3, 9, 259, 16, 2, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-10' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-13' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-20' AS date), 1066, 3200, 13915, 13916, 13915, 13915, 13915, 13915, 13915, 2458743, 58742, N'2019-09-16', 201938, 38, 1, N'2019-W38', N'2019-W38-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97413, CAST(N'2019-09-17' AS date), CAST(N'2019-09-18' AS date), 2019, 20193, 201909, 2019260, 3, 9, 260, 17, 3, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-11' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-13' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-20' AS date), 1066, 3200, 13915, 13916, 13916, 13915, 13915, 13915, 13915, 2458744, 58743, N'2019-09-17', 201938, 38, 2, N'2019-W38', N'2019-W38-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97414, CAST(N'2019-09-18' AS date), CAST(N'2019-09-19' AS date), 2019, 20193, 201909, 2019261, 3, 9, 261, 18, 4, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-12' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-13' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-20' AS date), 1066, 3200, 13915, 13916, 13916, 13916, 13915, 13915, 13915, 2458745, 58744, N'2019-09-18', 201938, 38, 3, N'2019-W38', N'2019-W38-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97415, CAST(N'2019-09-19' AS date), CAST(N'2019-09-20' AS date), 2019, 20193, 201909, 2019262, 3, 9, 262, 19, 5, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-09-13' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-20' AS date), 1066, 3200, 13915, 13916, 13916, 13916, 13916, 13915, 13915, 2458746, 58745, N'2019-09-19', 201938, 38, 4, N'2019-W38', N'2019-W38-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97416, CAST(N'2019-09-20' AS date), CAST(N'2019-09-21' AS date), 2019, 20193, 201909, 2019263, 3, 9, 263, 20, 6, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-09-20' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-09-14' AS date), CAST(N'2019-09-20' AS date), 1066, 3200, 13915, 13916, 13916, 13916, 13916, 13916, 13915, 2458747, 58746, N'2019-09-20', 201938, 38, 5, N'2019-W38', N'2019-W38-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97417, CAST(N'2019-09-21' AS date), CAST(N'2019-09-22' AS date), 2019, 20193, 201909, 2019264, 3, 9, 264, 21, 7, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-15' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-09-20' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-27' AS date), 1066, 3200, 13915, 13916, 13916, 13916, 13916, 13916, 13916, 2458748, 58747, N'2019-09-21', 201938, 38, 6, N'2019-W38', N'2019-W38-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97418, CAST(N'2019-09-22' AS date), CAST(N'2019-09-23' AS date), 2019, 20193, 201909, 2019265, 3, 9, 265, 22, 1, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-09-16' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-09-20' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-27' AS date), 1066, 3200, 13916, 13916, 13916, 13916, 13916, 13916, 13916, 2458749, 58748, N'2019-09-22', 201938, 38, 7, N'2019-W38', N'2019-W38-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97419, CAST(N'2019-09-23' AS date), CAST(N'2019-09-24' AS date), 2019, 20193, 201909, 2019266, 3, 9, 266, 23, 2, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-09-17' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-09-20' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-27' AS date), 1066, 3200, 13916, 13917, 13916, 13916, 13916, 13916, 13916, 2458750, 58749, N'2019-09-23', 201939, 39, 1, N'2019-W39', N'2019-W39-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97420, CAST(N'2019-09-24' AS date), CAST(N'2019-09-25' AS date), 2019, 20193, 201909, 2019267, 3, 9, 267, 24, 3, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-18' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-09-20' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-27' AS date), 1066, 3200, 13916, 13917, 13917, 13916, 13916, 13916, 13916, 2458751, 58750, N'2019-09-24', 201939, 39, 2, N'2019-W39', N'2019-W39-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97421, CAST(N'2019-09-25' AS date), CAST(N'2019-09-26' AS date), 2019, 20193, 201909, 2019268, 3, 9, 268, 25, 4, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-09-19' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-09-20' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-27' AS date), 1066, 3200, 13916, 13917, 13917, 13917, 13916, 13916, 13916, 2458752, 58751, N'2019-09-25', 201939, 39, 3, N'2019-W39', N'2019-W39-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97422, CAST(N'2019-09-26' AS date), CAST(N'2019-09-27' AS date), 2019, 20193, 201909, 2019269, 3, 9, 269, 26, 5, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-09-20' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-27' AS date), 1066, 3200, 13916, 13917, 13917, 13917, 13917, 13916, 13916, 2458753, 58752, N'2019-09-26', 201939, 39, 4, N'2019-W39', N'2019-W39-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97423, CAST(N'2019-09-27' AS date), CAST(N'2019-09-28' AS date), 2019, 20193, 201909, 2019270, 3, 9, 270, 27, 6, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-09-27' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-09-21' AS date), CAST(N'2019-09-27' AS date), 1066, 3200, 13916, 13917, 13917, 13917, 13917, 13917, 13916, 2458754, 58753, N'2019-09-27', 201939, 39, 5, N'2019-W39', N'2019-W39-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97424, CAST(N'2019-09-28' AS date), CAST(N'2019-09-29' AS date), 2019, 20193, 201909, 2019271, 3, 9, 271, 28, 7, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-22' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-09-27' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-10-04' AS date), 1066, 3200, 13916, 13917, 13917, 13917, 13917, 13917, 13917, 2458755, 58754, N'2019-09-28', 201939, 39, 6, N'2019-W39', N'2019-W39-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97425, CAST(N'2019-09-29' AS date), CAST(N'2019-09-30' AS date), 2019, 20193, 201909, 2019272, 3, 9, 272, 29, 1, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-09-23' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-09-27' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-10-04' AS date), 1066, 3200, 13917, 13917, 13917, 13917, 13917, 13917, 13917, 2458756, 58755, N'2019-09-29', 201939, 39, 7, N'2019-W39', N'2019-W39-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97426, CAST(N'2019-09-30' AS date), CAST(N'2019-10-01' AS date), 2019, 20193, 201909, 2019273, 3, 9, 273, 30, 2, N'2019', N'2019 Q3', N'2019 Sep', N'Sep', N'September', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-07-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-01' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-09-24' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-09-27' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-10-04' AS date), 1066, 3200, 13917, 13918, 13917, 13917, 13917, 13917, 13917, 2458757, 58756, N'2019-09-30', 201940, 40, 1, N'2019-W40', N'2019-W40-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97427, CAST(N'2019-10-01' AS date), CAST(N'2019-10-02' AS date), 2019, 20194, 201910, 2019274, 4, 10, 274, 1, 3, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-09-25' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-09-27' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-10-04' AS date), 1067, 3201, 13917, 13918, 13918, 13917, 13917, 13917, 13917, 2458758, 58757, N'2019-10-01', 201940, 40, 2, N'2019-W40', N'2019-W40-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97428, CAST(N'2019-10-02' AS date), CAST(N'2019-10-03' AS date), 2019, 20194, 201910, 2019275, 4, 10, 275, 2, 4, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-09-26' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-09-27' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-10-04' AS date), 1067, 3201, 13917, 13918, 13918, 13918, 13917, 13917, 13917, 2458759, 58758, N'2019-10-02', 201940, 40, 3, N'2019-W40', N'2019-W40-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97429, CAST(N'2019-10-03' AS date), CAST(N'2019-10-04' AS date), 2019, 20194, 201910, 2019276, 4, 10, 276, 3, 5, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-09-27' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-10-04' AS date), 1067, 3201, 13917, 13918, 13918, 13918, 13918, 13917, 13917, 2458760, 58759, N'2019-10-03', 201940, 40, 4, N'2019-W40', N'2019-W40-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97430, CAST(N'2019-10-04' AS date), CAST(N'2019-10-05' AS date), 2019, 20194, 201910, 2019277, 4, 10, 277, 4, 6, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-04' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-09-28' AS date), CAST(N'2019-10-04' AS date), 1067, 3201, 13917, 13918, 13918, 13918, 13918, 13918, 13917, 2458761, 58760, N'2019-10-04', 201940, 40, 5, N'2019-W40', N'2019-W40-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97431, CAST(N'2019-10-05' AS date), CAST(N'2019-10-06' AS date), 2019, 20194, 201910, 2019278, 4, 10, 278, 5, 7, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-09-29' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-04' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-10-11' AS date), 1067, 3201, 13917, 13918, 13918, 13918, 13918, 13918, 13918, 2458762, 58761, N'2019-10-05', 201940, 40, 6, N'2019-W40', N'2019-W40-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97432, CAST(N'2019-10-06' AS date), CAST(N'2019-10-07' AS date), 2019, 20194, 201910, 2019279, 4, 10, 279, 6, 1, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-09-30' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-04' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-10-11' AS date), 1067, 3201, 13918, 13918, 13918, 13918, 13918, 13918, 13918, 2458763, 58762, N'2019-10-06', 201940, 40, 7, N'2019-W40', N'2019-W40-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97433, CAST(N'2019-10-07' AS date), CAST(N'2019-10-08' AS date), 2019, 20194, 201910, 2019280, 4, 10, 280, 7, 2, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-04' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-10-11' AS date), 1067, 3201, 13918, 13919, 13918, 13918, 13918, 13918, 13918, 2458764, 58763, N'2019-10-07', 201941, 41, 1, N'2019-W41', N'2019-W41-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97434, CAST(N'2019-10-08' AS date), CAST(N'2019-10-09' AS date), 2019, 20194, 201910, 2019281, 4, 10, 281, 8, 3, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-02' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-04' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-10-11' AS date), 1067, 3201, 13918, 13919, 13919, 13918, 13918, 13918, 13918, 2458765, 58764, N'2019-10-08', 201941, 41, 2, N'2019-W41', N'2019-W41-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97435, CAST(N'2019-10-09' AS date), CAST(N'2019-10-10' AS date), 2019, 20194, 201910, 2019282, 4, 10, 282, 9, 4, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-03' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-04' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-10-11' AS date), 1067, 3201, 13918, 13919, 13919, 13919, 13918, 13918, 13918, 2458766, 58765, N'2019-10-09', 201941, 41, 3, N'2019-W41', N'2019-W41-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97436, CAST(N'2019-10-10' AS date), CAST(N'2019-10-11' AS date), 2019, 20194, 201910, 2019283, 4, 10, 283, 10, 5, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-04' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-10-11' AS date), 1067, 3201, 13918, 13919, 13919, 13919, 13919, 13918, 13918, 2458767, 58766, N'2019-10-10', 201941, 41, 4, N'2019-W41', N'2019-W41-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97437, CAST(N'2019-10-11' AS date), CAST(N'2019-10-12' AS date), 2019, 20194, 201910, 2019284, 4, 10, 284, 11, 6, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-11' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-05' AS date), CAST(N'2019-10-11' AS date), 1067, 3201, 13918, 13919, 13919, 13919, 13919, 13919, 13918, 2458768, 58767, N'2019-10-11', 201941, 41, 5, N'2019-W41', N'2019-W41-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97438, CAST(N'2019-10-12' AS date), CAST(N'2019-10-13' AS date), 2019, 20194, 201910, 2019285, 4, 10, 285, 12, 7, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-06' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-11' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-18' AS date), 1067, 3201, 13918, 13919, 13919, 13919, 13919, 13919, 13919, 2458769, 58768, N'2019-10-12', 201941, 41, 6, N'2019-W41', N'2019-W41-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97439, CAST(N'2019-10-13' AS date), CAST(N'2019-10-14' AS date), 2019, 20194, 201910, 2019286, 4, 10, 286, 13, 1, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-07' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-11' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-18' AS date), 1067, 3201, 13919, 13919, 13919, 13919, 13919, 13919, 13919, 2458770, 58769, N'2019-10-13', 201941, 41, 7, N'2019-W41', N'2019-W41-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97440, CAST(N'2019-10-14' AS date), CAST(N'2019-10-15' AS date), 2019, 20194, 201910, 2019287, 4, 10, 287, 14, 2, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-08' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-11' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-18' AS date), 1067, 3201, 13919, 13920, 13919, 13919, 13919, 13919, 13919, 2458771, 58770, N'2019-10-14', 201942, 42, 1, N'2019-W42', N'2019-W42-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97441, CAST(N'2019-10-15' AS date), CAST(N'2019-10-16' AS date), 2019, 20194, 201910, 2019288, 4, 10, 288, 15, 3, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-09' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-11' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-18' AS date), 1067, 3201, 13919, 13920, 13920, 13919, 13919, 13919, 13919, 2458772, 58771, N'2019-10-15', 201942, 42, 2, N'2019-W42', N'2019-W42-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97442, CAST(N'2019-10-16' AS date), CAST(N'2019-10-17' AS date), 2019, 20194, 201910, 2019289, 4, 10, 289, 16, 4, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-10' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-11' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-18' AS date), 1067, 3201, 13919, 13920, 13920, 13920, 13919, 13919, 13919, 2458773, 58772, N'2019-10-16', 201942, 42, 3, N'2019-W42', N'2019-W42-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97443, CAST(N'2019-10-17' AS date), CAST(N'2019-10-18' AS date), 2019, 20194, 201910, 2019290, 4, 10, 290, 17, 5, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-11' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-18' AS date), 1067, 3201, 13919, 13920, 13920, 13920, 13920, 13919, 13919, 2458774, 58773, N'2019-10-17', 201942, 42, 4, N'2019-W42', N'2019-W42-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97444, CAST(N'2019-10-18' AS date), CAST(N'2019-10-19' AS date), 2019, 20194, 201910, 2019291, 4, 10, 291, 18, 6, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-18' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-12' AS date), CAST(N'2019-10-18' AS date), 1067, 3201, 13919, 13920, 13920, 13920, 13920, 13920, 13919, 2458775, 58774, N'2019-10-18', 201942, 42, 5, N'2019-W42', N'2019-W42-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97445, CAST(N'2019-10-19' AS date), CAST(N'2019-10-20' AS date), 2019, 20194, 201910, 2019292, 4, 10, 292, 19, 7, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-13' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-18' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-25' AS date), 1067, 3201, 13919, 13920, 13920, 13920, 13920, 13920, 13920, 2458776, 58775, N'2019-10-19', 201942, 42, 6, N'2019-W42', N'2019-W42-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97446, CAST(N'2019-10-20' AS date), CAST(N'2019-10-21' AS date), 2019, 20194, 201910, 2019293, 4, 10, 293, 20, 1, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-10-14' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-18' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-25' AS date), 1067, 3201, 13920, 13920, 13920, 13920, 13920, 13920, 13920, 2458777, 58776, N'2019-10-20', 201942, 42, 7, N'2019-W42', N'2019-W42-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97447, CAST(N'2019-10-21' AS date), CAST(N'2019-10-22' AS date), 2019, 20194, 201910, 2019294, 4, 10, 294, 21, 2, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-10-15' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-18' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-25' AS date), 1067, 3201, 13920, 13921, 13920, 13920, 13920, 13920, 13920, 2458778, 58777, N'2019-10-21', 201943, 43, 1, N'2019-W43', N'2019-W43-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97448, CAST(N'2019-10-22' AS date), CAST(N'2019-10-23' AS date), 2019, 20194, 201910, 2019295, 4, 10, 295, 22, 3, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-10-16' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-18' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-25' AS date), 1067, 3201, 13920, 13921, 13921, 13920, 13920, 13920, 13920, 2458779, 58778, N'2019-10-22', 201943, 43, 2, N'2019-W43', N'2019-W43-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97449, CAST(N'2019-10-23' AS date), CAST(N'2019-10-24' AS date), 2019, 20194, 201910, 2019296, 4, 10, 296, 23, 4, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-10-17' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-18' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-25' AS date), 1067, 3201, 13920, 13921, 13921, 13921, 13920, 13920, 13920, 2458780, 58779, N'2019-10-23', 201943, 43, 3, N'2019-W43', N'2019-W43-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97450, CAST(N'2019-10-24' AS date), CAST(N'2019-10-25' AS date), 2019, 20194, 201910, 2019297, 4, 10, 297, 24, 5, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-10-18' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-25' AS date), 1067, 3201, 13920, 13921, 13921, 13921, 13921, 13920, 13920, 2458781, 58780, N'2019-10-24', 201943, 43, 4, N'2019-W43', N'2019-W43-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97451, CAST(N'2019-10-25' AS date), CAST(N'2019-10-26' AS date), 2019, 20194, 201910, 2019298, 4, 10, 298, 25, 6, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-10-25' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-19' AS date), CAST(N'2019-10-25' AS date), 1067, 3201, 13920, 13921, 13921, 13921, 13921, 13921, 13920, 2458782, 58781, N'2019-10-25', 201943, 43, 5, N'2019-W43', N'2019-W43-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97452, CAST(N'2019-10-26' AS date), CAST(N'2019-10-27' AS date), 2019, 20194, 201910, 2019299, 4, 10, 299, 26, 7, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-20' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-10-25' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-11-01' AS date), 1067, 3201, 13920, 13921, 13921, 13921, 13921, 13921, 13921, 2458783, 58782, N'2019-10-26', 201943, 43, 6, N'2019-W43', N'2019-W43-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97453, CAST(N'2019-10-27' AS date), CAST(N'2019-10-28' AS date), 2019, 20194, 201910, 2019300, 4, 10, 300, 27, 1, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-10-21' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-10-25' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-11-01' AS date), 1067, 3201, 13921, 13921, 13921, 13921, 13921, 13921, 13921, 2458784, 58783, N'2019-10-27', 201943, 43, 7, N'2019-W43', N'2019-W43-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97454, CAST(N'2019-10-28' AS date), CAST(N'2019-10-29' AS date), 2019, 20194, 201910, 2019301, 4, 10, 301, 28, 2, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-10-22' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-10-25' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-11-01' AS date), 1067, 3201, 13921, 13922, 13921, 13921, 13921, 13921, 13921, 2458785, 58784, N'2019-10-28', 201944, 44, 1, N'2019-W44', N'2019-W44-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97455, CAST(N'2019-10-29' AS date), CAST(N'2019-10-30' AS date), 2019, 20194, 201910, 2019302, 4, 10, 302, 29, 3, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-10-23' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-10-25' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-11-01' AS date), 1067, 3201, 13921, 13922, 13922, 13921, 13921, 13921, 13921, 2458786, 58785, N'2019-10-29', 201944, 44, 2, N'2019-W44', N'2019-W44-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97456, CAST(N'2019-10-30' AS date), CAST(N'2019-10-31' AS date), 2019, 20194, 201910, 2019303, 4, 10, 303, 30, 4, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-10-24' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-10-25' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-11-01' AS date), 1067, 3201, 13921, 13922, 13922, 13922, 13921, 13921, 13921, 2458787, 58786, N'2019-10-30', 201944, 44, 3, N'2019-W44', N'2019-W44-3');

INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97457, CAST(N'2019-10-31' AS date), CAST(N'2019-11-01' AS date), 2019, 20194, 201910, 2019304, 4, 10, 304, 31, 5, N'2019', N'2019 Q4', N'2019 Oct', N'Oct', N'October', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-10-25' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-11-01' AS date), 1067, 3201, 13921, 13922, 13922, 13922, 13922, 13921, 13921, 2458788, 58787, N'2019-10-31', 201944, 44, 4, N'2019-W44', N'2019-W44-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97458, CAST(N'2019-11-01' AS date), CAST(N'2019-11-02' AS date), 2019, 20194, 201911, 2019305, 4, 11, 305, 1, 6, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-10-26' AS date), CAST(N'2019-11-01' AS date), 1067, 3202, 13921, 13922, 13922, 13922, 13922, 13922, 13921, 2458789, 58788, N'2019-11-01', 201944, 44, 5, N'2019-W44', N'2019-W44-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97459, CAST(N'2019-11-02' AS date), CAST(N'2019-11-03' AS date), 2019, 20194, 201911, 2019306, 4, 11, 306, 2, 7, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-10-27' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-11-08' AS date), 1067, 3202, 13921, 13922, 13922, 13922, 13922, 13922, 13922, 2458790, 58789, N'2019-11-02', 201944, 44, 6, N'2019-W44', N'2019-W44-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97460, CAST(N'2019-11-03' AS date), CAST(N'2019-11-04' AS date), 2019, 20194, 201911, 2019307, 4, 11, 307, 3, 1, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-10-28' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-11-08' AS date), 1067, 3202, 13922, 13922, 13922, 13922, 13922, 13922, 13922, 2458791, 58790, N'2019-11-03', 201944, 44, 7, N'2019-W44', N'2019-W44-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97461, CAST(N'2019-11-04' AS date), CAST(N'2019-11-05' AS date), 2019, 20194, 201911, 2019308, 4, 11, 308, 4, 2, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-10-29' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-11-08' AS date), 1067, 3202, 13922, 13923, 13922, 13922, 13922, 13922, 13922, 2458792, 58791, N'2019-11-04', 201945, 45, 1, N'2019-W45', N'2019-W45-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97462, CAST(N'2019-11-05' AS date), CAST(N'2019-11-06' AS date), 2019, 20194, 201911, 2019309, 4, 11, 309, 5, 3, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-10-30' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-11-08' AS date), 1067, 3202, 13922, 13923, 13923, 13922, 13922, 13922, 13922, 2458793, 58792, N'2019-11-05', 201945, 45, 2, N'2019-W45', N'2019-W45-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97463, CAST(N'2019-11-06' AS date), CAST(N'2019-11-07' AS date), 2019, 20194, 201911, 2019310, 4, 11, 310, 6, 4, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-10-31' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-11-08' AS date), 1067, 3202, 13922, 13923, 13923, 13923, 13922, 13922, 13922, 2458794, 58793, N'2019-11-06', 201945, 45, 3, N'2019-W45', N'2019-W45-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97464, CAST(N'2019-11-07' AS date), CAST(N'2019-11-08' AS date), 2019, 20194, 201911, 2019311, 4, 11, 311, 7, 5, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-11-08' AS date), 1067, 3202, 13922, 13923, 13923, 13923, 13923, 13922, 13922, 2458795, 58794, N'2019-11-07', 201945, 45, 4, N'2019-W45', N'2019-W45-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97465, CAST(N'2019-11-08' AS date), CAST(N'2019-11-09' AS date), 2019, 20194, 201911, 2019312, 4, 11, 312, 8, 6, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-08' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-02' AS date), CAST(N'2019-11-08' AS date), 1067, 3202, 13922, 13923, 13923, 13923, 13923, 13923, 13922, 2458796, 58795, N'2019-11-08', 201945, 45, 5, N'2019-W45', N'2019-W45-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97466, CAST(N'2019-11-09' AS date), CAST(N'2019-11-10' AS date), 2019, 20194, 201911, 2019313, 4, 11, 313, 9, 7, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-03' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-08' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-15' AS date), 1067, 3202, 13922, 13923, 13923, 13923, 13923, 13923, 13923, 2458797, 58796, N'2019-11-09', 201945, 45, 6, N'2019-W45', N'2019-W45-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97467, CAST(N'2019-11-10' AS date), CAST(N'2019-11-11' AS date), 2019, 20194, 201911, 2019314, 4, 11, 314, 10, 1, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-04' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-08' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-15' AS date), 1067, 3202, 13923, 13923, 13923, 13923, 13923, 13923, 13923, 2458798, 58797, N'2019-11-10', 201945, 45, 7, N'2019-W45', N'2019-W45-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97468, CAST(N'2019-11-11' AS date), CAST(N'2019-11-12' AS date), 2019, 20194, 201911, 2019315, 4, 11, 315, 11, 2, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-05' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-08' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-15' AS date), 1067, 3202, 13923, 13924, 13923, 13923, 13923, 13923, 13923, 2458799, 58798, N'2019-11-11', 201946, 46, 1, N'2019-W46', N'2019-W46-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97469, CAST(N'2019-11-12' AS date), CAST(N'2019-11-13' AS date), 2019, 20194, 201911, 2019316, 4, 11, 316, 12, 3, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-06' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-08' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-15' AS date), 1067, 3202, 13923, 13924, 13924, 13923, 13923, 13923, 13923, 2458800, 58799, N'2019-11-12', 201946, 46, 2, N'2019-W46', N'2019-W46-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97470, CAST(N'2019-11-13' AS date), CAST(N'2019-11-14' AS date), 2019, 20194, 201911, 2019317, 4, 11, 317, 13, 4, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-07' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-08' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-15' AS date), 1067, 3202, 13923, 13924, 13924, 13924, 13923, 13923, 13923, 2458801, 58800, N'2019-11-13', 201946, 46, 3, N'2019-W46', N'2019-W46-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97471, CAST(N'2019-11-14' AS date), CAST(N'2019-11-15' AS date), 2019, 20194, 201911, 2019318, 4, 11, 318, 14, 5, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-08' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-15' AS date), 1067, 3202, 13923, 13924, 13924, 13924, 13924, 13923, 13923, 2458802, 58801, N'2019-11-14', 201946, 46, 4, N'2019-W46', N'2019-W46-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97472, CAST(N'2019-11-15' AS date), CAST(N'2019-11-16' AS date), 2019, 20194, 201911, 2019319, 4, 11, 319, 15, 6, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-15' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-09' AS date), CAST(N'2019-11-15' AS date), 1067, 3202, 13923, 13924, 13924, 13924, 13924, 13924, 13923, 2458803, 58802, N'2019-11-15', 201946, 46, 5, N'2019-W46', N'2019-W46-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97473, CAST(N'2019-11-16' AS date), CAST(N'2019-11-17' AS date), 2019, 20194, 201911, 2019320, 4, 11, 320, 16, 7, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-10' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-15' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-22' AS date), 1067, 3202, 13923, 13924, 13924, 13924, 13924, 13924, 13924, 2458804, 58803, N'2019-11-16', 201946, 46, 6, N'2019-W46', N'2019-W46-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97474, CAST(N'2019-11-17' AS date), CAST(N'2019-11-18' AS date), 2019, 20194, 201911, 2019321, 4, 11, 321, 17, 1, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-11' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-15' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-22' AS date), 1067, 3202, 13924, 13924, 13924, 13924, 13924, 13924, 13924, 2458805, 58804, N'2019-11-17', 201946, 46, 7, N'2019-W46', N'2019-W46-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97475, CAST(N'2019-11-18' AS date), CAST(N'2019-11-19' AS date), 2019, 20194, 201911, 2019322, 4, 11, 322, 18, 2, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-12' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-15' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-22' AS date), 1067, 3202, 13924, 13925, 13924, 13924, 13924, 13924, 13924, 2458806, 58805, N'2019-11-18', 201947, 47, 1, N'2019-W47', N'2019-W47-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97476, CAST(N'2019-11-19' AS date), CAST(N'2019-11-20' AS date), 2019, 20194, 201911, 2019323, 4, 11, 323, 19, 3, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-11-13' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-15' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-22' AS date), 1067, 3202, 13924, 13925, 13925, 13924, 13924, 13924, 13924, 2458807, 58806, N'2019-11-19', 201947, 47, 2, N'2019-W47', N'2019-W47-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97477, CAST(N'2019-11-20' AS date), CAST(N'2019-11-21' AS date), 2019, 20194, 201911, 2019324, 4, 11, 324, 20, 4, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-11-14' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-15' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-22' AS date), 1067, 3202, 13924, 13925, 13925, 13925, 13924, 13924, 13924, 2458808, 58807, N'2019-11-20', 201947, 47, 3, N'2019-W47', N'2019-W47-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97478, CAST(N'2019-11-21' AS date), CAST(N'2019-11-22' AS date), 2019, 20194, 201911, 2019325, 4, 11, 325, 21, 5, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-11-15' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-22' AS date), 1067, 3202, 13924, 13925, 13925, 13925, 13925, 13924, 13924, 2458809, 58808, N'2019-11-21', 201947, 47, 4, N'2019-W47', N'2019-W47-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97479, CAST(N'2019-11-22' AS date), CAST(N'2019-11-23' AS date), 2019, 20194, 201911, 2019326, 4, 11, 326, 22, 6, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-11-22' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-11-16' AS date), CAST(N'2019-11-22' AS date), 1067, 3202, 13924, 13925, 13925, 13925, 13925, 13925, 13924, 2458810, 58809, N'2019-11-22', 201947, 47, 5, N'2019-W47', N'2019-W47-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97480, CAST(N'2019-11-23' AS date), CAST(N'2019-11-24' AS date), 2019, 20194, 201911, 2019327, 4, 11, 327, 23, 7, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-17' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-11-22' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-29' AS date), 1067, 3202, 13924, 13925, 13925, 13925, 13925, 13925, 13925, 2458811, 58810, N'2019-11-23', 201947, 47, 6, N'2019-W47', N'2019-W47-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97481, CAST(N'2019-11-24' AS date), CAST(N'2019-11-25' AS date), 2019, 20194, 201911, 2019328, 4, 11, 328, 24, 1, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-18' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-11-22' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-29' AS date), 1067, 3202, 13925, 13925, 13925, 13925, 13925, 13925, 13925, 2458812, 58811, N'2019-11-24', 201947, 47, 7, N'2019-W47', N'2019-W47-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97482, CAST(N'2019-11-25' AS date), CAST(N'2019-11-26' AS date), 2019, 20194, 201911, 2019329, 4, 11, 329, 25, 2, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-11-19' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-11-22' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-29' AS date), 1067, 3202, 13925, 13926, 13925, 13925, 13925, 13925, 13925, 2458813, 58812, N'2019-11-25', 201948, 48, 1, N'2019-W48', N'2019-W48-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97483, CAST(N'2019-11-26' AS date), CAST(N'2019-11-27' AS date), 2019, 20194, 201911, 2019330, 4, 11, 330, 26, 3, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-11-20' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-11-22' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-29' AS date), 1067, 3202, 13925, 13926, 13926, 13925, 13925, 13925, 13925, 2458814, 58813, N'2019-11-26', 201948, 48, 2, N'2019-W48', N'2019-W48-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97484, CAST(N'2019-11-27' AS date), CAST(N'2019-11-28' AS date), 2019, 20194, 201911, 2019331, 4, 11, 331, 27, 4, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-11-21' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-11-22' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-29' AS date), 1067, 3202, 13925, 13926, 13926, 13926, 13925, 13925, 13925, 2458815, 58814, N'2019-11-27', 201948, 48, 3, N'2019-W48', N'2019-W48-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97485, CAST(N'2019-11-28' AS date), CAST(N'2019-11-29' AS date), 2019, 20194, 201911, 2019332, 4, 11, 332, 28, 5, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-11-22' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-29' AS date), 1067, 3202, 13925, 13926, 13926, 13926, 13926, 13925, 13925, 2458816, 58815, N'2019-11-28', 201948, 48, 4, N'2019-W48', N'2019-W48-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97486, CAST(N'2019-11-29' AS date), CAST(N'2019-11-30' AS date), 2019, 20194, 201911, 2019333, 4, 11, 333, 29, 6, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-11-29' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-11-23' AS date), CAST(N'2019-11-29' AS date), 1067, 3202, 13925, 13926, 13926, 13926, 13926, 13926, 13925, 2458817, 58816, N'2019-11-29', 201948, 48, 5, N'2019-W48', N'2019-W48-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97487, CAST(N'2019-11-30' AS date), CAST(N'2019-12-01' AS date), 2019, 20194, 201911, 2019334, 4, 11, 334, 30, 7, N'2019', N'2019 Q4', N'2019 Nov', N'Nov', N'November', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-11-01' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-24' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-11-29' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-12-06' AS date), 1067, 3202, 13925, 13926, 13926, 13926, 13926, 13926, 13926, 2458818, 58817, N'2019-11-30', 201948, 48, 6, N'2019-W48', N'2019-W48-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97488, CAST(N'2019-12-01' AS date), CAST(N'2019-12-02' AS date), 2019, 20194, 201912, 2019335, 4, 12, 335, 1, 1, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-11-25' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-11-29' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-12-06' AS date), 1067, 3203, 13926, 13926, 13926, 13926, 13926, 13926, 13926, 2458819, 58818, N'2019-12-01', 201948, 48, 7, N'2019-W48', N'2019-W48-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97489, CAST(N'2019-12-02' AS date), CAST(N'2019-12-03' AS date), 2019, 20194, 201912, 2019336, 4, 12, 336, 2, 2, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-11-26' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-11-29' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-12-06' AS date), 1067, 3203, 13926, 13927, 13926, 13926, 13926, 13926, 13926, 2458820, 58819, N'2019-12-02', 201949, 49, 1, N'2019-W49', N'2019-W49-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97490, CAST(N'2019-12-03' AS date), CAST(N'2019-12-04' AS date), 2019, 20194, 201912, 2019337, 4, 12, 337, 3, 3, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-11-27' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-11-29' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-12-06' AS date), 1067, 3203, 13926, 13927, 13927, 13926, 13926, 13926, 13926, 2458821, 58820, N'2019-12-03', 201949, 49, 2, N'2019-W49', N'2019-W49-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97491, CAST(N'2019-12-04' AS date), CAST(N'2019-12-05' AS date), 2019, 20194, 201912, 2019338, 4, 12, 338, 4, 4, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-11-28' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-11-29' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-12-06' AS date), 1067, 3203, 13926, 13927, 13927, 13927, 13926, 13926, 13926, 2458822, 58821, N'2019-12-04', 201949, 49, 3, N'2019-W49', N'2019-W49-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97492, CAST(N'2019-12-05' AS date), CAST(N'2019-12-06' AS date), 2019, 20194, 201912, 2019339, 4, 12, 339, 5, 5, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-11-29' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-12-06' AS date), 1067, 3203, 13926, 13927, 13927, 13927, 13927, 13926, 13926, 2458823, 58822, N'2019-12-05', 201949, 49, 4, N'2019-W49', N'2019-W49-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97493, CAST(N'2019-12-06' AS date), CAST(N'2019-12-07' AS date), 2019, 20194, 201912, 2019340, 4, 12, 340, 6, 6, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-06' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-11-30' AS date), CAST(N'2019-12-06' AS date), 1067, 3203, 13926, 13927, 13927, 13927, 13927, 13927, 13926, 2458824, 58823, N'2019-12-06', 201949, 49, 5, N'2019-W49', N'2019-W49-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97494, CAST(N'2019-12-07' AS date), CAST(N'2019-12-08' AS date), 2019, 20194, 201912, 2019341, 4, 12, 341, 7, 7, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-06' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-13' AS date), 1067, 3203, 13926, 13927, 13927, 13927, 13927, 13927, 13927, 2458825, 58824, N'2019-12-07', 201949, 49, 6, N'2019-W49', N'2019-W49-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97495, CAST(N'2019-12-08' AS date), CAST(N'2019-12-09' AS date), 2019, 20194, 201912, 2019342, 4, 12, 342, 8, 1, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-02' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-06' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-13' AS date), 1067, 3203, 13927, 13927, 13927, 13927, 13927, 13927, 13927, 2458826, 58825, N'2019-12-08', 201949, 49, 7, N'2019-W49', N'2019-W49-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97496, CAST(N'2019-12-09' AS date), CAST(N'2019-12-10' AS date), 2019, 20194, 201912, 2019343, 4, 12, 343, 9, 2, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-03' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-06' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-13' AS date), 1067, 3203, 13927, 13928, 13927, 13927, 13927, 13927, 13927, 2458827, 58826, N'2019-12-09', 201950, 50, 1, N'2019-W50', N'2019-W50-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97497, CAST(N'2019-12-10' AS date), CAST(N'2019-12-11' AS date), 2019, 20194, 201912, 2019344, 4, 12, 344, 10, 3, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-04' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-06' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-13' AS date), 1067, 3203, 13927, 13928, 13928, 13927, 13927, 13927, 13927, 2458828, 58827, N'2019-12-10', 201950, 50, 2, N'2019-W50', N'2019-W50-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97498, CAST(N'2019-12-11' AS date), CAST(N'2019-12-12' AS date), 2019, 20194, 201912, 2019345, 4, 12, 345, 11, 4, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-05' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-06' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-13' AS date), 1067, 3203, 13927, 13928, 13928, 13928, 13927, 13927, 13927, 2458829, 58828, N'2019-12-11', 201950, 50, 3, N'2019-W50', N'2019-W50-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97499, CAST(N'2019-12-12' AS date), CAST(N'2019-12-13' AS date), 2019, 20194, 201912, 2019346, 4, 12, 346, 12, 5, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-06' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-13' AS date), 1067, 3203, 13927, 13928, 13928, 13928, 13928, 13927, 13927, 2458830, 58829, N'2019-12-12', 201950, 50, 4, N'2019-W50', N'2019-W50-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97500, CAST(N'2019-12-13' AS date), CAST(N'2019-12-14' AS date), 2019, 20194, 201912, 2019347, 4, 12, 347, 13, 6, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-13' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-07' AS date), CAST(N'2019-12-13' AS date), 1067, 3203, 13927, 13928, 13928, 13928, 13928, 13928, 13927, 2458831, 58830, N'2019-12-13', 201950, 50, 5, N'2019-W50', N'2019-W50-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97501, CAST(N'2019-12-14' AS date), CAST(N'2019-12-15' AS date), 2019, 20194, 201912, 2019348, 4, 12, 348, 14, 7, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-08' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-13' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-20' AS date), 1067, 3203, 13927, 13928, 13928, 13928, 13928, 13928, 13928, 2458832, 58831, N'2019-12-14', 201950, 50, 6, N'2019-W50', N'2019-W50-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97502, CAST(N'2019-12-15' AS date), CAST(N'2019-12-16' AS date), 2019, 20194, 201912, 2019349, 4, 12, 349, 15, 1, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-09' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-13' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-20' AS date), 1067, 3203, 13928, 13928, 13928, 13928, 13928, 13928, 13928, 2458833, 58832, N'2019-12-15', 201950, 50, 7, N'2019-W50', N'2019-W50-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97503, CAST(N'2019-12-16' AS date), CAST(N'2019-12-17' AS date), 2019, 20194, 201912, 2019350, 4, 12, 350, 16, 2, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-10' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-13' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-20' AS date), 1067, 3203, 13928, 13929, 13928, 13928, 13928, 13928, 13928, 2458834, 58833, N'2019-12-16', 201951, 51, 1, N'2019-W51', N'2019-W51-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97504, CAST(N'2019-12-17' AS date), CAST(N'2019-12-18' AS date), 2019, 20194, 201912, 2019351, 4, 12, 351, 17, 3, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-11' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-13' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-20' AS date), 1067, 3203, 13928, 13929, 13929, 13928, 13928, 13928, 13928, 2458835, 58834, N'2019-12-17', 201951, 51, 2, N'2019-W51', N'2019-W51-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97505, CAST(N'2019-12-18' AS date), CAST(N'2019-12-19' AS date), 2019, 20194, 201912, 2019352, 4, 12, 352, 18, 4, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-12' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-13' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-20' AS date), 1067, 3203, 13928, 13929, 13929, 13929, 13928, 13928, 13928, 2458836, 58835, N'2019-12-18', 201951, 51, 3, N'2019-W51', N'2019-W51-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97506, CAST(N'2019-12-19' AS date), CAST(N'2019-12-20' AS date), 2019, 20194, 201912, 2019353, 4, 12, 353, 19, 5, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-13' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-20' AS date), 1067, 3203, 13928, 13929, 13929, 13929, 13929, 13928, 13928, 2458837, 58836, N'2019-12-19', 201951, 51, 4, N'2019-W51', N'2019-W51-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97507, CAST(N'2019-12-20' AS date), CAST(N'2019-12-21' AS date), 2019, 20194, 201912, 2019354, 4, 12, 354, 20, 6, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-20' AS date), CAST(N'2019-12-26' AS date), CAST(N'2019-12-14' AS date), CAST(N'2019-12-20' AS date), 1067, 3203, 13928, 13929, 13929, 13929, 13929, 13929, 13928, 2458838, 58837, N'2019-12-20', 201951, 51, 5, N'2019-W51', N'2019-W51-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97508, CAST(N'2019-12-21' AS date), CAST(N'2019-12-22' AS date), 2019, 20194, 201912, 2019355, 4, 12, 355, 21, 7, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-15' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-20' AS date), CAST(N'2019-12-26' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-27' AS date), 1067, 3203, 13928, 13929, 13929, 13929, 13929, 13929, 13929, 2458839, 58838, N'2019-12-21', 201951, 51, 6, N'2019-W51', N'2019-W51-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97509, CAST(N'2019-12-22' AS date), CAST(N'2019-12-23' AS date), 2019, 20194, 201912, 2019356, 4, 12, 356, 22, 1, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-28' AS date), CAST(N'2019-12-16' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-20' AS date), CAST(N'2019-12-26' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-27' AS date), 1067, 3203, 13929, 13929, 13929, 13929, 13929, 13929, 13929, 2458840, 58839, N'2019-12-22', 201951, 51, 7, N'2019-W51', N'2019-W51-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97510, CAST(N'2019-12-23' AS date), CAST(N'2019-12-24' AS date), 2019, 20194, 201912, 2019357, 4, 12, 357, 23, 2, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-28' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-29' AS date), CAST(N'2019-12-17' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-20' AS date), CAST(N'2019-12-26' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-27' AS date), 1067, 3203, 13929, 13930, 13929, 13929, 13929, 13929, 13929, 2458841, 58840, N'2019-12-23', 201952, 52, 1, N'2019-W52', N'2019-W52-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97511, CAST(N'2019-12-24' AS date), CAST(N'2019-12-25' AS date), 2019, 20194, 201912, 2019358, 4, 12, 358, 24, 3, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-28' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-29' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-30' AS date), CAST(N'2019-12-18' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-20' AS date), CAST(N'2019-12-26' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-27' AS date), 1067, 3203, 13929, 13930, 13930, 13929, 13929, 13929, 13929, 2458842, 58841, N'2019-12-24', 201952, 52, 2, N'2019-W52', N'2019-W52-2');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97512, CAST(N'2019-12-25' AS date), CAST(N'2019-12-26' AS date), 2019, 20194, 201912, 2019359, 4, 12, 359, 25, 4, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Wed', N'Wednesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-28' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-29' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-30' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-19' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-20' AS date), CAST(N'2019-12-26' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-27' AS date), 1067, 3203, 13929, 13930, 13930, 13930, 13929, 13929, 13929, 2458843, 58842, N'2019-12-25', 201952, 52, 3, N'2019-W52', N'2019-W52-3');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97513, CAST(N'2019-12-26' AS date), CAST(N'2019-12-27' AS date), 2019, 20194, 201912, 2019360, 4, 12, 360, 26, 5, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Thu', N'Thursday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-28' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-29' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-30' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-26' AS date), CAST(N'2020-01-01' AS date), CAST(N'2019-12-20' AS date), CAST(N'2019-12-26' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-27' AS date), 1067, 3203, 13929, 13930, 13930, 13930, 13930, 13929, 13929, 2458844, 58843, N'2019-12-26', 201952, 52, 4, N'2019-W52', N'2019-W52-4');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97514, CAST(N'2019-12-27' AS date), CAST(N'2019-12-28' AS date), 2019, 20194, 201912, 2019361, 4, 12, 361, 27, 6, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Fri', N'Friday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-28' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-29' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-30' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-26' AS date), CAST(N'2020-01-01' AS date), CAST(N'2019-12-27' AS date), CAST(N'2020-01-02' AS date), CAST(N'2019-12-21' AS date), CAST(N'2019-12-27' AS date), 1067, 3203, 13929, 13930, 13930, 13930, 13930, 13930, 13929, 2458845, 58844, N'2019-12-27', 201952, 52, 5, N'2019-W52', N'2019-W52-5');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97515, CAST(N'2019-12-28' AS date), CAST(N'2019-12-29' AS date), 2019, 20194, 201912, 2019362, 4, 12, 362, 28, 7, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Sat', N'Saturday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-22' AS date), CAST(N'2019-12-28' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-29' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-30' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-26' AS date), CAST(N'2020-01-01' AS date), CAST(N'2019-12-27' AS date), CAST(N'2020-01-02' AS date), CAST(N'2019-12-28' AS date), CAST(N'2020-01-03' AS date), 1067, 3203, 13929, 13930, 13930, 13930, 13930, 13930, 13930, 2458846, 58845, N'2019-12-28', 201952, 52, 6, N'2019-W52', N'2019-W52-6');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97516, CAST(N'2019-12-29' AS date), CAST(N'2019-12-30' AS date), 2019, 20194, 201912, 2019363, 4, 12, 363, 29, 1, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Sun', N'Sunday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-29' AS date), CAST(N'2020-01-04' AS date), CAST(N'2019-12-23' AS date), CAST(N'2019-12-29' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-30' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-26' AS date), CAST(N'2020-01-01' AS date), CAST(N'2019-12-27' AS date), CAST(N'2020-01-02' AS date), CAST(N'2019-12-28' AS date), CAST(N'2020-01-03' AS date), 1067, 3203, 13930, 13930, 13930, 13930, 13930, 13930, 13930, 2458847, 58846, N'2019-12-29', 201952, 52, 7, N'2019-W52', N'2019-W52-7');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97517, CAST(N'2019-12-30' AS date), CAST(N'2019-12-31' AS date), 2019, 20194, 201912, 2019364, 4, 12, 364, 30, 2, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Mon', N'Monday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-29' AS date), CAST(N'2020-01-04' AS date), CAST(N'2019-12-30' AS date), CAST(N'2020-01-05' AS date), CAST(N'2019-12-24' AS date), CAST(N'2019-12-30' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-26' AS date), CAST(N'2020-01-01' AS date), CAST(N'2019-12-27' AS date), CAST(N'2020-01-02' AS date), CAST(N'2019-12-28' AS date), CAST(N'2020-01-03' AS date), 1067, 3203, 13930, 13931, 13930, 13930, 13930, 13930, 13930, 2458848, 58847, N'2019-12-30', 202001, 1, 1, N'2020-W01', N'2020-W01-1');
INSERT DimDate (DateKey, DateValue, NextDayValue, YearValue, YearQuarter, YearMonth, YearDayOfYear, QuarterValue, MonthValue, DayOfYear, DayOfMonth, DayOfWeek, YearName, YearQuarterName, QuarterName, MonthName, MonthNameLong, WeekdayName, WeekdayNameLong, StartOfYearDate, EndOfYearDate, StartOfQuarterDate, EndOfQuarterDate, StartOfMonthDate, EndOfMonthDate, StartOfWeekStartingSunDate, EndOfWeekStartingSunDate, StartOfWeekStartingMonDate, EndOfWeekStartingMonDate, StartOfWeekStartingTueDate, EndOfWeekStartingTueDate, StartOfWeekStartingWedDate, EndOfWeekStartingWedDate, StartOfWeekStartingThuDate, EndOfWeekStartingThuDate, StartOfWeekStartingFriDate, EndOfWeekStartingFriDate, StartOfWeekStartingSatDate, EndOfWeekStartingSatDate, QuarterSeqNo, MonthSeqNo, WeekStartingSunSeq, WeekStartingMonSeq, WeekStartingTueSeq, WeekStartingWedSeq, WeekStartingThuSeq, WeekStartingFriSeq, WeekStartingSatSeq, JulianDate, ModifiedJulianDate, ISODate, ISOYearWeekNo, ISOWeekNo, ISODayOfWeek, ISOYearWeekName, ISOYearWeekDayOfWeekName) VALUES (97518, CAST(N'2019-12-31' AS date), CAST(N'2020-01-01' AS date), 2019, 20194, 201912, 2019365, 4, 12, 365, 31, 3, N'2019', N'2019 Q4', N'2019 Dec', N'Dec', N'December', N'Tue', N'Tuesday', CAST(N'2019-01-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-10-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-01' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-29' AS date), CAST(N'2020-01-04' AS date), CAST(N'2019-12-30' AS date), CAST(N'2020-01-05' AS date), CAST(N'2019-12-31' AS date), CAST(N'2020-01-06' AS date), CAST(N'2019-12-25' AS date), CAST(N'2019-12-31' AS date), CAST(N'2019-12-26' AS date), CAST(N'2020-01-01' AS date), CAST(N'2019-12-27' AS date), CAST(N'2020-01-02' AS date), CAST(N'2019-12-28' AS date), CAST(N'2020-01-03' AS date), 1067, 3203, 13930, 13931, 13931, 13930, 13930, 13930, 13930, 2458849, 58848, N'2019-12-31', 202001, 1, 2, N'2020-W01', N'2020-W01-2');